/*
 *  Copyright (C) 2002 by Glenn McGrath
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include "unarchive.h"

/*
 * Accept names that are in the accept list and not in the reject list
 */
extern char filter_accept_reject_list(archive_handle_t *archive_handle)
{
	const char *key = archive_handle->file_header->name;
	const llist_t *accept_entry = find_list_entry(archive_handle->accept, key);
	const llist_t *reject_entry = find_list_entry(archive_handle->reject, key);

	/* If the key is in a reject list fail */
	if (reject_entry) {
		return(EXIT_FAILURE);
	}

	/* Fail if an accept list was specified and the key wasnt in there */
	if (archive_handle->accept && (accept_entry == NULL)) {
		return(EXIT_FAILURE);
	}

	/* Accepted */
	return EXIT_SUCCESS;
}
