#!/bin/sh
# $1 = build_dir
# $2 = source
# $3 = out

dir=$1
shift
source=$1
shift
out=$1
shift

CFLAGS_CALC_BSS=-DCALC_BSS="static"
CFLAGS_COMMON_BSS=-DCALC_BSS="extern"

basename_source=`basename $source`

if [ "$basename_source" = busybox.c ]; then
	rm -f "$dir"/bss_size.out
	find "$dir" \( -name '*.o.obj' \) -print | \
		xargs size 2> /dev/null | cut -f 3,6 | tail -n +2 | \
		sort -r -n > "$dir"/bss_size.out
	read max_bss filename < "$dir"/bss_size.out
#       echo "$@" -DCALC_BSS="$max_bss" -o $out $source
	"$@" -DCALC_BSS="$max_bss" -o $out $source
else
	if grep -q CALC_BSS $source; then
		"$@" $CFLAGS_CALC_BSS -o "$out".obj $source
		touch "$dir"/bss_size.out
		"$@" $CFLAGS_COMMON_BSS -o $out $source 2> /dev/null
	else
		"$@" $CFLAGS_COMMON_BSS -o $out $source
	fi
fi
