/*
 * Mini chvt implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 */
#ifdef APPLET_USAGE
#define chvt_trivial_usage \
	"N"
#define chvt_full_usage \
	"Changes the foreground virtual terminal to /dev/ttyN"
#else

/* no options */

#include "busybox.h"
#include <stddef.h> /* ptrdiff_t */

/* From <linux/vt.h> */
static const int VT_ACTIVATE = 0x5606;  /* make vt active */
static const int VT_WAITACTIVE = 0x5607;  /* wait for vt active */

int chvt_main(void)
{
	int fd, num;

	bb_xgetopt_ulflags("\0=1");
	fd = get_console_fd_and_die();
	num =  bb_xparse_i_number(10, *Gargv);
	xioctl(fd, VT_ACTIVATE, (void *)(ptrdiff_t)num, "\1ioctl");
	xioctl(fd, VT_WAITACTIVE, (void *)(ptrdiff_t)num, "\1ioctl");
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
