/*
 * Disallocate virtual terminal(s)
 *
 * Copyright (C) 2003 by Tito Ragusa <farmatito@tiscali.it>
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under the GPL v2 or later, see the file LICENSE in this tarball.
 */
#ifdef APPLET_USAGE
#define deallocvt_trivial_usage \
	"[N]"
#define deallocvt_full_usage \
	 "Deallocate unused virtual terminal /dev/ttyN"
#else

/* no options */

#include "busybox.h"
#include <stddef.h> /* ptrdiff_t */

/* From <linux/vt.h> */
static const int VT_DISALLOCATE = 0x5608;  /* free memory associated to vt */

int deallocvt_main(void)
{
	/* num = 0 deallocate all unused consoles */
	int num = 0;

	bb_xgetopt_ulflags("\0?1");
	if(*Gargv)
		num =  bb_xparse_i_number(10, *Gargv);

	xioctl( get_console_fd_and_die(), VT_DISALLOCATE, (void *)(ptrdiff_t)num, "\1VT_DISALLOCATE");
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
