/*
 *  setconsole.c - redirect system console output
 *
 *  Copyright (C) 2004,2005  Enrik Berkhan <Enrik.Berkhan@inka.de>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define setconsole_trivial_usage \
	"[-r|--reset] [DEVICE]"
#define setconsole_full_usage \
	"Redirects system console output to DEVICE (default: /dev/tty).\n\n" \
	"Options:\n" \
	"\t-r\tReset output to /dev/console."
#else

#include "busybox.h"
#include <sys/ioctl.h>
#include "bb_xopen.h"


#ifdef CONFIG_FEATURE_LONG_OPTIONS
static const struct option setconsole_long_options[] = {
	{ "reset", 0, NULL, 'r' },
	{ 0, 0, 0, 0 }
};
#endif

int setconsole_main(void)
{
	char **argv;
	int flags;
	const char *device = bb_dev_tty;
#ifdef CONFIG_FEATURE_LONG_OPTIONS
	bb_applet_long_options = setconsole_long_options;
#endif
	/* max 1 opt */
	flags = bb_xgetopt_ulflags("r\0?1");
	argv = Gargv;
	if (*argv != NULL) {
		if (flags)
			bb_show_usage();
		device = *argv;
	} else {
		if (flags)
			device = CONSOLE_DEV;
	}

	xioctl(bb_xopen(device, O_RDONLY | BB_OPEN_ERR), TIOCCONS, NULL, "\1TIOCCONS");
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
