/*
 * cat implementation for busybox
 *
 * Copyright (C) 2003  Manuel Novoa III  <mjn3@codepoet.org>
 * Licensed under GPL v2, see file LICENSE in this tarball for details.
 */

/* BB_AUDIT SUSv3 compliant */
/* http://www.opengroup.org/onlinepubs/007904975/utilities/cat.html */

#ifdef APPLET_USAGE
#define cat_trivial_usage \
	"[-u] [FILE]..."
#define cat_full_usage \
	"Concatenates FILE(s) and prints them to stdout.\n\n" \
	"Options:\n" \
	"\t-u\tignored since unbuffered i/o is always used"
#else

#include "busybox.h"
#include <unistd.h>

extern int cat_main(void)
{
	char **argv;
	FILE *f;
	int retval = EXIT_SUCCESS;

	/* Convert zero argument usage to one argument "-" */
	bb_xgetopt_ulflags("u\0-0");

	for(argv = Gargv; *argv != NULL; argv++) {
		if ((f = bb_xfopen(*argv, "W-r")) != NULL) {
			int r = bb_copyfd_eof(fileno(f), STDOUT_FILENO);
			bb_fclose_nonstdin(f);
			if (r >= 0) {
				continue;
			}
		}
		retval = EXIT_FAILURE;
	}

	return retval;
}
#endif /* APPLET_USAGE */
