/*
 * Mini chroot implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 * Licensed under GPL v2, see file LICENSE in this tarball for details.
 */

/* BB_AUDIT SUSv3 N/A -- Matches GNU behavior. */
/* Vladimir Oleynik (c) 2008 - GNU coreutils-6.9 compatibility */
#ifdef APPLET_USAGE
#define chroot_trivial_usage \
	"NEWROOT [COMMAND...]"
#define chroot_full_usage \
	"Run COMMAND with root directory set to NEWROOT."
#else

#include "busybox.h"
#include <unistd.h>

#define EXIT_CANNOT_INVOKE 126
#define EXIT_ENOENT 127

int chroot_main(void)
{
	char **argv;

	bb_xgetopt_ulflags("+\0-1");
	argv = Gargv;
	if (chroot(*argv) || chdir("/"))
		bb_perror_msg_and_die("cannot change root directory to %s", *argv);

	++argv;
	if (*argv == NULL) {
		argv -= 2;
		if (!(*argv = getenv("SHELL"))) {
			*argv = (char *) DEFAULT_SHELL;
		}
		argv[1] = (char *) "-i";
	}

	execvp(*argv, argv);
	bb_default_error_retval = (errno == ENOENT ? EXIT_ENOENT : EXIT_CANNOT_INVOKE);
	bb_perror_msg_and_die("cannot execute %s", *argv);
}
#endif /* APPLET_USAGE */
