/*
 * Mini hostid implementation for busybox
 *
 * Copyright (C) 2000  Edward Betts <edward@debian.org>.
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

/* BB_AUDIT SUSv3 N/A -- Matches GNU behavior. */
#ifdef APPLET_USAGE
#define hostid_trivial_usage \
	""
#define hostid_full_usage \
	"Print out a unique 32-bit identifier for the machine."
#else

#include "busybox.h"
#include <unistd.h>

#if defined(__BIONIC__)
#error "BIONIC have not gethostid() function. Reconfigure for disable the 'hostid' applet."
#endif

extern int hostid_main(void)
{
	if (Gargc > 1)
		bb_show_usage();

	bb_printf("%lx\n", gethostid());

	bb_fflush_stdout_and_exit(EXIT_SUCCESS);
}
#endif /* APPLET_USAGE */
