/*
 * coreutils utility routine
 *
 * Copyright (C) 2003  Manuel Novoa III  <mjn3@codepoet.org>
 * Licensed under GPL v2, see file LICENSE in this tarball for details.
 */

#include "busybox.h"
#include <unistd.h>
#include "coreutils.h"

#if ENABLE_FEATURE_LONG_OPTIONS
static const struct option mk_fifo_nod_opt[] =
{
	{"mode", 1, NULL, 'm'},
	{NULL, 0, NULL, 0}
};
#endif

extern mode_t getopt_mk_fifo_nod(int min_arg)
{
	mode_t mode = 0666;
	char *smode = NULL;
	char **argv;

#if ENABLE_FEATURE_LONG_OPTIONS
	bb_applet_long_options = mk_fifo_nod_opt;
#endif
	bb_getopt_ulflags("m:", &smode);
	if(smode) {
		if (bb_parse_mode(smode, &mode))
			umask(0);
	}
	for(argv = Gargv; min_arg > 0; min_arg--, argv++)
		if (*argv == NULL)
			bb_show_usage();
	return mode;
}
