/*
 * mkfifo implementation for busybox
 *
 * Copyright (C) 2003  Manuel Novoa III  <mjn3@codepoet.org>
 * Licensed under GPL v2, see file LICENSE in this tarball for details.
 */

/* BB_AUDIT SUSv3 compliant */
/* http://www.opengroup.org/onlinepubs/007904975/utilities/mkfifo.html */
#ifdef APPLET_USAGE
#define mkfifo_trivial_usage \
	"[OPTIONS] name"
#define mkfifo_full_usage \
	"Creates a named pipe (identical to 'mknod name p')\n\n" \
	"Options:\n" \
	"\t-m" USE_FEATURE_LONG_OPTIONS(", --mode") "\tcreate the pipe using the specified mode (default a=rw)"
#else

#include "busybox.h"
#include <unistd.h>
#include "libcoreutils/coreutils.h"

extern int mkfifo_main(void)
{
	char **argv;
	mode_t mode;
	int retval = EXIT_SUCCESS;

	mode = getopt_mk_fifo_nod(1);

	for(argv = Gargv; *argv; argv++) {
		if (mkfifo(*argv, mode) < 0) {
			bb_perror_msg("%s", *argv);
			retval = EXIT_FAILURE;
		}
	}

	return retval;
}
#endif /* APPLET_USAGE */
