/*
 * printenv implementation for busybox
 *
 * Copyright (C) 2005 by Erik Andersen <andersen@codepoet.org>
 * Copyright (C) 2005 by Mike Frysinger <vapier@gentoo.org>
 *
 */
#ifdef APPLET_USAGE
#define printenv_trivial_usage \
	"[VARIABLES...]"
#define printenv_full_usage \
	"print all or part of environment\n\n" \
	"If no environment VARIABLE specified, print them all."
#else

#include "busybox.h"
#include <string.h>

int printenv_main(void)
{
	char **argv;
	extern char **environ;
	int e = 0;
	int exit_code = EXIT_SUCCESS;

	bb_getopt_ulflags("+");
	argv = Gargv;
	/* no variables specified, show whole env */
	if (argv[0] == NULL)
		while (environ[e] != NULL)
			puts(environ[e++]);

	/* search for specified variables and print them out if found */
	else {
		size_t l;
		char *arg, *env;
		int matches = 0;

		for (; (arg = *argv); argv++) {
			for (; (env = environ[e]); ++e) {
				l = strlen(arg);
				if (!strncmp(env, arg, l) && env[l] == '=') {
					puts(env + l + 1);
					matches++;
				}
			}
		}
		exit_code = matches == Gargc ? EXIT_SUCCESS : EXIT_FAILURE;
	}

	bb_fflush_stdout_and_exit(exit_code);
}
#endif /* APPLET_USAGE */
