/*
 * seq implementation for busybox
 *
 * Copyright (C) 2004, Glenn McGrath
 *
 * Licensed under the GPL v2, see the file LICENSE in this tarball.
 */
#ifdef APPLET_USAGE
#define seq_trivial_usage \
	"[first [increment]] last"
#define seq_full_usage \
	"Print numbers from FIRST to LAST, in steps of INCREMENT.\n" \
	"FIRST, INCREMENT default to 1\n" \
	"Arguments:\n" \
	"\tLAST\n" \
	"\tFIRST\tLAST\n" \
	"\tFIRST\tINCREMENT\tLAST"
#else

#include "busybox.h"

extern int seq_main(void)
{
	int argc = Gargc;
	char **argv = Gargv;
	double last, first, increment, i;

	first = increment = 1;
	switch (argc) {
		case 4:
			increment=atof(argv[2]);
		case 3:
			first=atof(argv[1]);
		case 2:
			last=atof(argv[argc -1]);
			break;
		default:
			bb_show_usage();
	}

	/* You should note that this is pos-5.0.91 semantics, -- FK. */
	if (first < last ? increment > 0 : increment < 0) {
		for (i = first;
			 (first < last) ? (i <= last) : (i >= last);
			 i += increment)
		{
				printf("%g\n", i);
		}
	}

	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
