/*----------------------------------------------------------------------
 * Mini who is used to display user name, login time,
 * idle time and host name.
 *
 * Author: Da Chen  <dchen@ayrnetworks.com>
 *
 * This is a free document; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation:
 *    http://www.gnu.org/copyleft/gpl.html
 *
 * Copyright (c) 2002 AYR Networks, Inc.
 *----------------------------------------------------------------------
 */
#ifdef APPLET_USAGE
#define who_trivial_usage \
	""
#define who_full_usage \
	"Prints the current user names and related information"
#else

#include "busybox.h"
#include <unistd.h>
#include <utmp.h>
#include <string.h>
#include <time.h>

extern int who_main(void)
{
    struct utmp *ut;
    struct stat st;
    int         devlen, len;
    time_t      now, idle;

    bb_xgetopt_ulflags("\0??");

    setutent();
    devlen = sizeof("/dev/") - 1;
    printf("USER       TTY      IDLE      FROM           HOST\n");

    while ((ut = getutent()) != NULL) {
	char name[40];

	if (ut->ut_user[0] && ut->ut_type == USER_PROCESS) {
	    time_t thyme = ut->ut_tv.tv_sec;

	    len = strlen(ut->ut_line);
	    if (ut->ut_line[0] == '/') {
	       safe_strncpy(name, ut->ut_line, len + 1);
	       strcpy(ut->ut_line, ut->ut_line + devlen);
	    } else {
	       strcpy(name, "/dev/");
	       safe_strncpy(name+devlen, ut->ut_line, len + 1);
	    }

	    printf("%-10s %-8s ", ut->ut_user, ut->ut_line);

	    if (stat(name, &st) == 0) {
		now = time(NULL);
		idle = now -  st.st_atime;

		if (idle < 60)
		    printf("00:00m    ");
		else if (idle < (60 * 60))
		    printf("00:%02dm    ", (int)(idle / 60));
		else if (idle < (24 * 60 * 60))
		    printf("%02d:%02dm    ", (int)(idle / (60 * 60)),
			   (int)(idle % (60 * 60)) / 60);
		else if (idle < (24 * 60 * 60 * 365))
		    printf("%03ddays   ", (int)(idle / (24 * 60 * 60)));
		else
		    printf("%02dyears   ", (int) (idle / (24 * 60 * 60 * 365)));
	    } else
		printf("%-8s  ", "?");

	    printf("%-12.12s   %s\n", ctime(&thyme) + 4, ut->ut_host);
	}
    }
    /* no not need before exit */
    /* endutent(); */

    return 0;
}
#endif /* APPLET_USAGE */
