/*
 * Mini readlink implementation for busybox
 *
 * Copyright (C) 2000,2001 Matt Kraai <kraai@alumni.carnegiemellon.edu>
 *
 * Licensed under GPL v2, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define readlink_trivial_usage \
	USE_FEATURE_READLINK_FOLLOW("[-f] ") "FILE"
#define readlink_full_usage \
	"Displays the value of a symbolic link." \
	USE_FEATURE_READLINK_FOLLOW("\n\nOptions:\n" \
	"\t-f\tcanonicalize by following all symlinks")
#else

#include "busybox.h"
#include <unistd.h>

int readlink_main(void)
{
	char *buf;
#if ENABLE_FEATURE_READLINK_FOLLOW
	int opt = (int)bb_xgetopt_ulflags("f\0=1");

	if (opt)
		buf = realpath(*Gargv, NULL);
	else
		buf = xreadlink(*Gargv);

#else
	bb_xgetopt_ulflags("\0=1");

	buf = xreadlink(*Gargv);
#endif
	if (!buf)
		return EXIT_FAILURE;
	puts(buf);

	return EXIT_SUCCESS;
}

#endif /* APPLET_USAGE */
