/*
 * Busybox main internal header file
 *
 * Licensed under the GPL v2 or later, see the file LICENSE in this tarball.
 */
#ifndef _BB_INTERNAL_H_
#define _BB_INTERNAL_H_    1

#include "bb_config.h"

extern const char BB_BANNER[];

/* Pull in the utility routines from libbb */
#include "libbb.h"

struct BB_applet {
	const char *name;
	int (*main) (void);
	int Loc_SUID;
};

/* From busybox.c */
extern const struct BB_applet applets[];

#ifdef CONFIG_FEATURE_SH_STANDALONE_SHELL
void show_applets(void);
#endif

#ifdef CONFIG_ASH_BUILTIN_TEST
extern int bb_test(const char *applet_name, int argc, char **argv);
#endif

/* Automagically pull in all the applet function prototypes and
 * applet usage strings.  These are all of the form:
 *              extern int foo_main(void);
 *              extern const char foo_usage[];
 * These are all autogenerated from the set of currently defined applets.
 */
#define PROTOTYPES
#include "applets.h"
#undef PROTOTYPES

#endif                                                  /* _BB_INTERNAL_H_ */
