/*
 * Copyright (c) 2014 may safely be consumed by a BSD or GPL license.
 * Written by:   Vladimir Oleynik <dzo@simtreas.ru>
 *
 * Documentation in libbb/config_read.c
*/

#define CR_FLAGS_FOUND_SPACE_DELIM 1
#define CR_FLAGS_FOUND_SPEC_DELIM  2
#define CR_FLAGS_FOUND_DOUBLE_SPEC_DELIM  4
#define CR_FLAGS_FOUND_EOL_DELIM   8

typedef struct CONFIG_READ {
	FILE *in;                       /* set fopen/stdin or manually */
	int num_line;                   /* loaded lines */
	int ntokens;                    /* number found tokens in line */
	char **tokens;                  /* null-terminated array interested tokens */
	char *flags;                    /* bitmask CR_FLAGS_FOUND_ */
	int flg_no_close;               /* set manually if need "no close mode" */
	/* private internall config_read library function variables */
	int flg_from_str;
	int max_tokens;
	size_t in_buff_size;
	char *input_buff;
	int readed;
} config_read_t;

config_read_t *config_read_prepare(const char *filename, int flg);
config_read_t *config_read(config_read_t *crt, const char *nc);
void config_close(config_read_t *crt);
