/*
 * Poweroff reboot and halt, oh my.
 *
 * Copyright 2006 by Rob Landley <rob@landley.net>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define halt_trivial_usage \
	"[-d<delay>] [-n<nosync>] [-f<force>]"
#define halt_full_usage \
	"Halt the system.\n" \
	"Options:\n" \
	"\t-d\t\tdelay interval for halting\n" \
	"\t-n\t\tno call to sync()\n" \
	"\t-f\t\tforce halt (don't go through init)"
#else

#include "busybox.h"
#include <signal.h>
#include <unistd.h>
#include "init_shared.h"

int halt_main(void)
{
	long ld;
	int which = 0, flags;
	static const int magic[] = {RB_HALT_SYSTEM, RB_POWER_OFF, RB_AUTOBOOT};
	int rc = 1;

	/* Figure out which applet we're running */
	switch(*bb_applet_name) {
		case 'r':               /* reboot, which = 2; */
			which++;
		case 'p':
			which++;        /* poweroff, which = 1; */
		/* halt, which = 0; */
	}

	/* Parse and handle arguments */
	flags = bb_xgetopt_ulflags("d:nf\0:d", &ld);
	if ((flags & 1)) {
		unsigned int delay = ld;
		sleep(delay);
	}
	if (!(flags & 2))
		sync();

	rc = reboot(magic[which]);
	if (rc)
		bb_error_msg("No.");
	return rc;
}
#endif /* APPLET_USAGE */
