/*
 * Mini poweroff implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 *
 */
#ifdef APPLET_USAGE
#define poweroff_trivial_usage \
	"[-d<delay>] [-n<nosync>] [-f<force>]"
#define poweroff_full_usage \
	"Halt and shut off power.\n" \
	"Options:\n" \
	"\t-d\t\tdelay interval for halting\n" \
	"\t-n\t\tno call to sync()\n" \
	"\t-f\t\tforce power off (don't go through init)"
#else

#include "busybox.h"
#include <unistd.h>
#include <sys/reboot.h>
#include "init_shared.h"
#ifdef CONFIG_INIT
#include <signal.h>
#endif


extern int poweroff_main(void)
{
	int delay;      /* delay in seconds before rebooting */

	if(bb_xgetopt_ulflags("d:\0:-d", &delay)) {
		sleep(delay);
	}

#ifndef CONFIG_INIT
	return(bb_shutdown_system(RB_POWER_OFF));
#else
	return kill(1, SIGUSR2);
#endif
}
#endif /* APPLET_USAGE */
