/*
 * Mini reboot implementation for busybox
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define reboot_trivial_usage \
	"[-d<delay>] [-n<nosync>] [-f<force>]"
#define reboot_full_usage \
	"Reboot the system.\n" \
	"Options:\n" \
	"\t-d\t\tdelay interval for rebooting\n" \
	"\t-n\t\tno call to sync()\n" \
	"\t-f\t\tforce reboot (don't go through init)"
#else

#include "busybox.h"
#ifdef CONFIG_INIT
#include <signal.h>
#endif
#include <unistd.h>
#include "init_shared.h"


extern int reboot_main(void)
{
	int delay; /* delay in seconds before rebooting */

	if(bb_xgetopt_ulflags("d:\0:-d", &delay)) {
		sleep(delay);
	}

#ifndef CONFIG_INIT
	return(bb_shutdown_system(RB_AUTOBOOT));
#else
	return kill(1, SIGTERM);
#endif
}
#endif /* APPLET_USAGE */
