/*
 * Mini shutdown applet for busybox init_sysV
 *
 * Copyright (C) 2009 Vladimir Oleynik <dzo@simtreas.ru>
 *
 */
#ifdef APPLET_USAGE
#define shutdown_trivial_usage \
	"-t delay [-rhfF] now"
#define shutdown_full_usage \
	"shutdown system\n" \
	"\t-t delay\twait before send signals\n" \
	"\t-r\t\treboot after shutdown\n" \
	"\t-h\t\thalt after shutdown\n" \
	"\t-f\t\tfast boot (create /fastboot file)\n" \
	"\t-F\t\tforce fsck (create /forcefsck file)\n" \
	"Time before start support 'now' only. Send Messages unsupported"
#else

#include "busybox.h"
#include <unistd.h>
#include <string.h>
#include "init_shared.h"
#include "bb_xopen.h"

extern int shutdown_main(void)
{
	int delay; /* delay in seconds before */
	int f, fd;
	const char *l;

	f = bb_xgetopt_ulflags("t:rhfF\0:-t:-1", &delay);
	if((f & 1))
		sleep(delay);
	if((f & 8)) {
		/* -f(ast boot) */
		fd = bb_xopen("/fastboot", O_WRONLY | O_CREAT | O_TRUNC | O_NOCTTY | BB_OPEN_WARN, 0644);
		if(fd >= 0)
			close(fd);
	}
	if((f & 16)) {
		/* -F(orce fsck) */
		fd = bb_xopen("/forcefsck", O_WRONLY | O_CREAT | O_TRUNC | O_NOCTTY | BB_OPEN_WARN, 0644);
		if(fd >= 0)
			close(fd);
	}
	if(strcmp(*Gargv, "now")) {
		bb_error_msg_and_die("support only 'now'");
	}
	Gargv++;
	if(*Gargv != NULL)
		bb_error_msg("sending message unsupport");
	if((f & 2))
		l = "6";        /* -r */
	else if((f & 4))
		l = "0";        /* -h */
	else
		l = "1";        /* default: single mode */
	execl("/sbin/init", "init", l, NULL);
	execl("/proc/self/exe", "init", l, NULL);
	bb_perror_msg_and_die("can not exec init");
}
#endif /* APPLET_USAGE */
