/*
	utime interface without the special struct -> utimes
	Vladimir Oleynik <dzo@simtreas.ru> (c) 2014
*/

#include "libbb.h"
#include <sys/time.h>
#include <string.h>

FAST_FUNC int bb_utime(const char *pathname, time_t actime, time_t modtime)
{
	struct timeval times[2];

	memset(times, 0, sizeof(times));
	times[0].tv_sec = actime;
	times[1].tv_sec = modtime;
	return utimes(pathname, times);
}
