#include "libbb.h"
#include <string.h>
#include <unistd.h>
#if defined(CONFIG_FEATURE_UTMP)
# include <utmp.h>
# include <time.h>
# ifdef CONFIG_FEATURE_WTMP
#  include <fcntl.h>
# endif
#endif

extern FAST_FUNC void bb_wutmp_logout(char *line)
{
    char *p;
#if defined(CONFIG_FEATURE_UTMP)
    /* logout */
    struct utmp tmp;
    struct utmp *ut;
#endif

    p = (char *)bb_basename(line);
#if defined(CONFIG_FEATURE_UTMP)
    memset(&tmp, 0, sizeof(tmp));
    setutent ();
    tmp.ut_type = USER_PROCESS;
    strncpy (tmp.ut_line, p, sizeof tmp.ut_line);
    if ((ut = getutline(&tmp)) != NULL) {
	time_t t_tmp;

	/* do not use ut, setutent destroy this */
	memcpy(&tmp, ut, sizeof(tmp));
	memset (tmp.ut_name, 0, sizeof tmp.ut_name);
	memset (tmp.ut_host, 0, sizeof tmp.ut_host);
	time(&t_tmp);
	tmp.ut_time = t_tmp;
	tmp.ut_type = DEAD_PROCESS;
	setutent();
	pututline(&tmp);
    }
    endutent();
#endif
#ifdef CONFIG_FEATURE_WTMP
    if (access(WTMP_FILE, R_OK|W_OK) == -1)
	close(creat(WTMP_FILE, 0664));
    updwtmp(WTMP_FILE, &tmp);
#endif
#ifndef CONFIG_FEATURE_DEVPTS
    /*
     * dholland 16-Aug-96 chmod the tty when not in use
     * This will make it harder to attach unwanted stuff to it
     * (which is a security risk) but will break some programs.
     */
    chmod(line, 0600);
    chown(line, 0, 0);
    *p = 'p';
    chmod(line, 0666);
    chown(line, 0, 0);
#endif
}
