/*
 * perror message may be to sylog if stderr moved to /dev/null
 * for example is from daemon call
 *
 * Copyright (C) 2008 Vladimir N. Oleynik <dzo@simtreas.ru>
 */

#include "libbb.h"
#include <syslog.h>

void xlog_warn(const char* fmt, ...)
{
	va_list args;
	int prev_log_syslog = log_syslog;
	int prev_log_stderr = log_stderr;

	log_syslog = LOG_WARNING;
	log_stderr = 0;
	va_start(args, fmt);
	bb_verror_msg(fmt, args);
	va_end(args);
	log_syslog = prev_log_syslog;
	log_stderr = prev_log_stderr;
}
