/*
	bb_xopen(name, flags, ...) interface
	Vladimir Oleynik <dzo@simtreas.ru> (c) 2007
*/

#include "libbb.h"
#include "bb_xopen.h"

extern int bb_xopen(const char *pathname, int flags, ...)
{
	int ret;
	va_list p;
	mode_t mode = 0;

	va_start(p, flags);
	if((flags & BB_OPEN_CREAT_0777) != 0)
		mode = 0777;
	else if((flags & O_CREAT) != 0)
		mode = va_arg(p, int);
	va_end(p);

	if((flags & BB_OPEN_MINUS_IS_STDIN) != 0 && pathname[0] == '-' && pathname[1] == '\0')
		return 0;

	ret = open(pathname, (flags & ~BB_OPEN_ADD_MASK), mode);
	if (ret == -1) {
		if((flags & (BB_OPEN_WARN | BB_OPEN_ERR)) != 0)
			bb_perror_msg("%s", pathname);
		if((flags & BB_OPEN_ERR) != 0)
			exit(bb_default_error_retval);
	}
	return ret;
}
