/*
 * fclose_nonstdin implementation for busybox
 *
 * Copyright (C) 2003  Manuel Novoa III  <mjn3@codepoet.org>
 * Licensed under the GPL v2 or later, see the file LICENSE in this tarball.
 *
 */

/* A number of standard utilities can accept multiple command line args
 * of '-' for stdin, according to SUSv3.  So we encapsulate the check
 * here to save a little space.
 */

#include "libbb.h"

FAST_FUNC int bb_fclose_nonstdin(FILE *f)
{
	if (f != stdin) {
		return fclose(f);
	}
	return 0;
}
