/*
 * init libbb
 *
 * Copyright (C) 2016 Vladimir Oleynik <dzo@simtreas.ru>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include "busybox.h"

int Gargc;
char **Gargv;
char *f_l_a_proctitle[2];
const char *bb_applet_name;
int log_stderr;
int log_syslog;
int bb_default_error_retval;
#if defined(__GLIBC__) || defined(__BIONIC__) || defined(__UCLIBC_HAS_THREADS__)
int *errnoptr;
#endif
USE_FEATURE_LONG_OPTIONS(const struct option *bb_applet_long_options;)

void libbb_init(int argc, char **argv)
{

	const char *s;

	/* prepare for bb_setproctitle(...) */
	char **e;

	f_l_a_proctitle[0] = argv[0];
	e = argv;
	while (*e)
		e++;
	f_l_a_proctitle[1] = e[-1] + strlen (e[-1]);
	/* end prepare for bb_setproctitle(...) */

	bb_applet_name = argv[0];
	if (*bb_applet_name == '-') bb_applet_name++;
	for (s = bb_applet_name; *s; )
		if (*(s++) == '/') bb_applet_name = s;
#if defined(__GLIBC__) || defined(__UCLIBC_HAS_THREADS__)
	errnoptr = __errno_location();
#endif
#ifdef __BIONIC__
	errnoptr = __errno();
#endif
	log_stderr = 1;
	Gargc = argc;
	Gargv = argv;
	bb_default_error_retval = EXIT_FAILURE;
}
