/*
   Copyright (C) 2003-2016 Vladimir Oleynik <dzo@simtreas.ru>
*/

#include "libbb.h"
#ifdef CONFIG_FEATURE_UTF8_SUPPORT
#include <string.h>
#include <wchar.h>
/* return number width chars */
FAST_FUNC int mbchar_len (const char *s)
{
  size_t tmp = 0;
  int point = 0;
  int count = 0;
  mbstate_t ps;
  wchar_t wc;

  memset(&ps, 0, sizeof (mbstate_t));

  while (s[point]) {
      tmp = mbrtowc (&wc, s+point, strlen(s + point), &ps);
      if ((size_t)(tmp) == (size_t)-1 || (size_t)(tmp) == (size_t)-2) {
	  /* invalid bytes. asume a byte represents a character */
	  point++;
	  count++;
	  /* reset states. */
	  memset(&ps, 0, sizeof(mbstate_t));
      } else if (tmp == (size_t)0) {
	/* found '\0' char */
	break;
      } else {
	  /* valid bytes */
	  point += tmp;
	  count++;
      }
  }

  return count;
}
#endif
