/*
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include "libbb.h"

#ifdef L_full_version
#ifndef BB_EXTRA_VERSION
#define LIBBB_BANNER "BusyBox's library v" BB_VER " (" BB_BT ")"
#else
#define LIBBB_BANNER "BusyBox's library v" BB_VER " (" BB_EXTRA_VERSION ")"
#endif
	const char libbb_msg_full_version[] = LIBBB_BANNER;
#endif
#ifdef L_memory_exhausted
	const char bb_msg_memory_exhausted[] = "Out of memory";
#endif
#ifdef L_invalid_date
	const char bb_msg_invalid_date[] = "invalid date `%s'";
#endif
#ifdef L_write_error
	const char bb_msg_write_error[] = "Write Error";
#endif
#ifdef L_read_error
	const char bb_msg_read_error[] = "Read Error";
#endif
#ifdef L_name_longer_than_foo
	const char bb_msg_name_longer_than_foo[] = "Names longer than %d chars not supported.";
#endif
#ifdef L_unknown
	const char bb_msg_unknown[] = "(unknown)";
#endif
#ifdef L_perm_denied_are_you_root
	const char bb_msg_perm_denied_are_you_root[] = "permission denied. (are you root?)";
#endif
#ifdef L_msg_standard_input
	const char bb_msg_standard_input[] = "standard input";
#endif
#ifdef L_msg_standard_output
	const char bb_msg_standard_output[] = "standard output";
#endif

#ifdef L_passwd_file
#define PASSWD_FILE        "/etc/passwd"
	const char bb_path_passwd_file[] = PASSWD_FILE;
#endif

#ifdef L_shadow_file
#define SHADOW_FILE        "/etc/shadow"
	const char bb_path_shadow_file[] = SHADOW_FILE;
#endif

#ifdef L_group_file
#define GROUP_FILE         "/etc/group"
	const char bb_path_group_file[] = GROUP_FILE;
#endif

#ifdef L_gshadow_file
#define GSHADOW_FILE       "/etc/gshadow"
	const char bb_path_gshadow_file[] = GSHADOW_FILE;
#endif

#ifdef L_nologin_file
#define NOLOGIN_FILE       "/etc/nologin"
	const char bb_path_nologin_file[] = NOLOGIN_FILE;
#endif

#ifdef L_securetty_file
#define SECURETTY_FILE     "/etc/securetty"
	const char bb_path_securetty_file[] = SECURETTY_FILE;
#endif

#ifdef L_motd_file
#define MOTD_FILE          "/etc/motd"
	const char bb_path_motd_file[] = MOTD_FILE;
#endif

#ifdef L_shell_path
	const char bb_default_login_shell[] = LIBBB_DEFAULT_LOGIN_SHELL;
#endif

#ifdef L_bb_dev_null
	const char bb_dev_null[] = "/dev/null";
#endif

#ifdef L_bb_dev_tty
	const char bb_dev_tty[] = "/dev/tty";
#endif

#ifdef L_bb_default
	const char bb_default[] = "default";
#endif

#ifdef L_bb_spacestok
	const char bb_spacestok[] = " \t";
#endif

#ifdef L_login_path
#define BB_LOGIN_PATH   "/bin/login"
	const char bb_login_path[] = BB_LOGIN_PATH;
#endif
