/*
 * Utility routine.
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 *
 */

#include "libbb.h"
#include <string.h>

#ifdef HAVE_CRYPT
#include <crypt.h>
#else
/* do not accept password: return unencrypted */
#define crypt(p, s) (s)
#endif


extern FAST_FUNC char *pw_encrypt(const char *clear, const char *salt,
					char enc[ENCRYPT_BUFFER_SIZE])
{
	char *cp;

#ifdef CONFIG_FEATURE_SHA1_PASSWORDS
	if (strncmp(salt, "$2$", 3) == 0) {
		cp = sha1_crypt(clear);
		goto ret_ok;
	}
#endif
	cp = (char *) crypt(clear, salt);
#ifdef CONFIG_FEATURE_SHA1_PASSWORDS
ret_ok:
#endif
	/* if crypt (a nonstandard crypt) returns a string too large,
	   truncate it so we don't overrun buffers and hope there is
	   enough security in what's left */
	safe_strncpy(enc, cp, ENCRYPT_BUFFER_SIZE);
	return enc;
}
