/*
 * Copyright 1989 - 1994, Julianne Frances Haugh <jockgrrl@austin.rr.com>
 * All rights reserved.
 *
 */

#include "libbb.h"
#ifdef CONFIG_FEATURE_SHADOWPASSWDS
#include <time.h>
#include "bb_shadow.h"

/*
 * pwd_to_spwd - create entries for new spwd structure
 *
 *      pwd_to_spwd() creates a new (struct spwd) containing the
 *      information in the pointed-to (struct passwd).
 */
#define DAY (24L*3600L)
#define WEEK (7*DAY)
#define SCALE DAY
FAST_FUNC struct spwd *pwd_to_spwd(const struct passwd *pw, struct spwd *sp)
{
	/* Nice, easy parts first.  The name and passwd map directly
	 * from the old password structure to the new one. */
	sp->sp_namp = pw->pw_name;
	sp->sp_pwdp = pw->pw_passwd;

	/* Defaults used if there is no pw_age information. */
	sp->sp_min = 0;
	sp->sp_max = (10000L * DAY) / SCALE;
	sp->sp_lstchg = time((time_t *) 0) / SCALE;

	/* These fields have no corresponding information in the password
	 * file.  They are set to uninitialized values. */
	sp->sp_warn = -1;
	sp->sp_expire = -1;
	sp->sp_inact = -1;
	sp->sp_flag = -1;
	return sp;
}
#endif /* CONFIG_FEATURE_SHADOWPASSWDS */
