/*
 * Copyright 1989 - 1991, Julianne Frances Haugh <jockgrrl@austin.rr.com>
 * All rights reserved.
 *
 */

#include "libbb.h"
#include <unistd.h>
#include <string.h>
#include <syslog.h>
#include <ctype.h>


#if HAVE_USERSHELL
/* Return 1 if SHELL is a restricted shell (one not returned by
   getusershell), else 0, meaning it is a standard shell.  */

FAST_FUNC int restricted_shell ( const char *shell )
{
	char *line;

	setusershell ( );
	while (( line = getusershell ( ))) {
		if (( *line != '#' ) && ( strcmp ( line, shell ) == 0 ))
			break;
	}
	endusershell ( );
	return line ? 0 : 1;
}
#else
FAST_FUNC int restricted_shell ( const char *shell )
{
	(void)&shell;
	return 0;
}
#endif
