/*
 * Utility routines.
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include <string.h>
#include "libbb.h"


/* Like strncpy but make sure the resulting string is always 0 terminated. */
extern FAST_FUNC char *
safe_strncpy(char *dst, const char *src, size_t size)
{
	if (size == 0)
		return dst;
	dst[size-1] = '\0';
	return strncpy(dst, src, size-1);
}


