/*
 * Utility routines.
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 */

#include "libbb.h"
#include <assert.h>
#include <math.h>

extern FAST_FUNC
int safe_strtod(char *arg, double* value)
{
	char *endptr;

	assert(arg!=NULL);
	errno = 0;
	*value = strtod(arg, &endptr);
	if (errno != 0 || *endptr!='\0' || endptr==arg || !finite(*value)) {
		return 1;
	}
	return 0;
}
