/*
 * Utility routines.
 *
 * Copyright (C) many different people.
 * If you wrote this, please acknowledge your work.
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include "libbb.h"
#include <string.h>
#include <ctype.h>


FAST_FUNC void trim(char *s)
{
	size_t len = strlen(s);
	size_t lws;

	/* trim trailing whitespace */
	while (len && isspace(s[len-1])) --len;

	/* trim leading whitespace */
	if(len) {
		lws = strspn(s, " \n\r\t\v");
		memmove(s, s + lws, len -= lws);
	}
	s[len] = 0;
}
