/*
 * Utility routines.
 *
 * Copyright (C) 1999-2004 by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

#include "libbb.h"
#include <string.h>
#include <syslog.h>

extern FAST_FUNC void bb_verror_msg(const char *s, va_list p)
{
	if(log_syslog) {
		va_list copy;

		va_copy(copy, p);
		vsyslog(log_syslog, s, p);
		va_end(copy);
	}
	if(log_stderr) {
		if(bb_applet_name != NULL)
			fprintf(stderr, "%s: ", bb_applet_name);
		vfprintf(stderr, s, p);
		putc('\n', stderr);
	}
}
