/*
 * Copyright (C) 2012  Vladimir Oleynik  <dzo@simtreas.ru>
 *
 */

#include "libbb.h"
#include <sys/wait.h>

int waitpid_no_int(pid_t wpid, int *pstatus, int flags, int flg_wpid_only)
{
  /* Reap defunct children until there aren't any more. */
  pid_t pid;
  for (;;) {
	pid = waitpid (wpid, pstatus, flags);
	if ((int) pid == 0 || (flg_wpid_only != 0 && pid == wpid)) {
		/* none left ot wait wpid only */
		break;
	}
	if ((int) pid < 0) {
	  if (errno == EINTR || errno == EAGAIN)  /* because of ptrace */
		continue;
	  /* ECHILD shouldn't happen with the WNOHANG option, but with
	     ** some kernels it does anyway.  Ignore it.
	   */
	  if (errno == ECHILD)
		break;
	}
  }
  return pid;
}
