/*
 * deluser (remove lusers from the system ;) for TinyLogin
 *
 * Copyright (C) 1999 by Lineo, inc. and John Beppu
 * Copyright (C) 1999,2000,2001 by John Beppu <beppu@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define delgroup_trivial_usage \
	"GROUP"
#define delgroup_full_usage \
	 "Deletes group GROUP from the system"
#else

#include "busybox.h"
#include <unistd.h>
#include <string.h>
#include "bb_shadow.h"


#if ! defined CONFIG_DELUSER
#include "delline.c"
#else
extern int del_line_matching(const char *login, const char *filename);
#endif

int delgroup_main(void)
{
	/* int successful; */
	int failure;

	if (Gargc != 2) {
		bb_show_usage();
	} else {
		char *u = Gargv[1];

		failure = del_line_matching(u, bb_path_group_file);
#ifdef CONFIG_FEATURE_SHADOWPASSWDS
		if (access(bb_path_gshadow_file, W_OK) == 0) {
			/* EDR the |= works if the error is not 0, so he had it wrong */
			failure |= del_line_matching(u, bb_path_gshadow_file);
		}
#endif
		if (failure) {
			bb_error_msg_and_die("%s: Group could not be removed\n", u);
		}

	}
	return (EXIT_SUCCESS);
}
#endif /* APPLET_USAGE */
