/*
 * deluser (remove lusers from the system ;) for TinyLogin
 *
 * Copyright (C) 1999 by Lineo, inc. and John Beppu
 * Copyright (C) 1999,2000,2001 by John Beppu <beppu@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define deluser_trivial_usage \
	"USER"
#define deluser_full_usage \
	 "Deletes user USER from the system"
#else

#include "busybox.h"
#include <unistd.h>
#include <string.h>
#include "bb_shadow.h"


#include "delline.c"

static const char deluser_format[]="%s: User could not be removed from %s";

int deluser_main(void)
{
	/* int successful; */
	int failure;

	if (Gargc != 2) {
		bb_show_usage();
	} else {
		char *u = Gargv[1];

		failure = del_line_matching(u, bb_path_passwd_file);
		if (failure) {
			bb_error_msg_and_die(deluser_format, u, bb_path_passwd_file);
		}
#ifdef CONFIG_FEATURE_SHADOWPASSWDS
		failure = del_line_matching(u, bb_path_shadow_file);
		if (failure) {
			bb_error_msg_and_die(deluser_format, u, bb_path_shadow_file);
		}
		failure = del_line_matching(u, bb_path_gshadow_file);
		if (failure) {
			bb_error_msg_and_die(deluser_format, u, bb_path_gshadow_file);
		}
#endif
		failure = del_line_matching(u, bb_path_group_file);
		if (failure) {
			bb_error_msg_and_die(deluser_format, u, bb_path_group_file);
		}

	}
	return (EXIT_SUCCESS);
}
#endif /* APPLET_USAGE */
