/*
 * eject implementation for busybox
 *
 * Copyright (C) 2004  Peter Willis <psyphreak@phreaker.net>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */

/*
 * This is a simple hack of eject based on something Erik posted in #uclibc.
 * Most of the dirty work blatantly ripped off from cat.c =)
 */
#ifdef APPLET_USAGE
#define eject_trivial_usage \
	"[-t] [DEVICE]"
#define eject_full_usage \
	"Eject specified DEVICE (or default /dev/cdrom).\n\n" \
	"Options:\n" \
	"\t-t\tclose tray"
#else

#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/mount.h>
#include <mntent.h>
#include "busybox.h"
#include "bb_xopen.h"

/* various defines swiped from linux/cdrom.h */
#define CDROMCLOSETRAY            0x5319  /* pendant of CDROMEJECT  */
#define CDROMEJECT                0x5309  /* Ejects the cdrom media */
#define DEFAULT_CDROM             "/dev/cdrom"

extern int eject_main(void)
{
	unsigned long flags;
	char *device;
	struct mntent *m;

	flags = bb_getopt_ulflags("t");
	device = *Gargv ? : DEFAULT_CDROM;

	if((m = find_mount_point(device, bb_path_mtab_file))) {
		if(umount(m->mnt_dir))
			bb_perror_msg_and_die("Can't umount");
		else if(ENABLE_FEATURE_MTAB_SUPPORT) erase_mtab(m->mnt_fsname);
	}
	xioctl(bb_xopen(device, (O_RDONLY | O_NONBLOCK | BB_OPEN_ERR)),
		  (flags ? CDROMCLOSETRAY : CDROMEJECT), "\1%s", device);
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
