/*
 * runlevel     Prints out the previous and the current runlevel.
 *
 * Version:     @(#)runlevel  1.20  16-Apr-1997  MvS
 *
 *              This file is part of the sysvinit suite,
 *              Copyright 1991-1997 Miquel van Smoorenburg.
 *
 * Licensed under the GPL v2 or later, see the file LICENSE in this tarball.
 *
 * initially busyboxified by Bernhard Fischer
 */
#ifdef APPLET_USAGE
#define runlevel_trivial_usage \
	"[utmp]"
#define runlevel_full_usage \
	"Find the current and previous system runlevel.\n\n" \
	"If no utmp file exists or if no runlevel record can be found,\n" \
	"runlevel prints \"unknown\""
#else

#include "busybox.h"
#include <utmp.h>
#include <time.h>
#if defined(__BIONIC__) /* bionic suxx */
# ifndef RUN_LVL
#  define RUN_LVL       1
# endif
#endif

int runlevel_main(void)
{
  struct utmp *ut;
  char prev;

  if (Gargc > 1) utmpname(Gargv[1]);

  setutent();
  while ((ut = getutent()) != NULL) {
	if (ut->ut_type == RUN_LVL) {
		prev = ut->ut_pid / 256;
		if (prev == 0) prev = 'N';
		printf("%c %c\n", prev, ut->ut_pid % 256);
		endutent();
		return 0;
	}
  }

  printf("unknown\n");
  endutent();
  return 1;
}

#endif /* APPLET_USAGE */
