/* vi: set sw=4 ts=4: */
/*
 * Mini insmod implementation for busybox
 *
 * Copyright (C) 2008 Timo Teras <timo.teras@iki.fi>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this source tree.
 */
#ifdef APPLET_USAGE
#define insmod_trivial_usage \
	"MODULE [symbol=value]..."
#define insmod_full_usage \
	"Loads the specified kernel modules into the kernel."
#else

#include "busybox.h"
#include "modutils.h"

/* 2.6 style insmod has no options and required filename
 * (not module name - .ko can't be omitted) */

int insmod_main(void)
{
	char **argv = Gargv;
	char *filename;
	int rc;

	filename = *++argv;
	if (filename == NULL)
		bb_show_usage();

	rc = bb_init_module(filename, parse_cmdline_module_options(argv, 0));
	if (rc)
		bb_error_msg("can't insert '%s': %s", filename, moderror(rc));

	return rc;
}
#endif /* APPLET_USAGE */
