/*
 * Common modutils related functions for busybox
 *
 * Copyright (C) 2008 by Timo Teras <timo.teras@iki.fi>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this source tree.
 */

#ifndef MODUTILS_H
#define MODUTILS_H 1

/* linux/include/linux/module.h has 64, but this is also used
 * internally for the maximum alias name length, which can be quite long */
#define MODULE_NAME_LEN 256

char *filename2modname(const char *filename, char *modname);
char *parse_cmdline_module_options(char **argv, int quote_spaces);
void *try_to_mmap_module(const char *filename, size_t *image_size_p);

int bb_init_module(const char *module, const char *options);
/* Return:
 * 0 on success,
 * errno on init_module() error
 */
int bb_delete_module(const char *module, unsigned int flags);
/* Translates error return to a string */
const char *moderror(int err);
/* Remove first element from the list and return it */
void* llist_pop(llist_t **head);

#define CONFIG_DEFAULT_DEPMOD_FILE "modules.dep"
#endif
