#define _XOPEN_SOURCE 500
#include <ftw.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static int
display_info(const char *fpath, const struct stat *sb, int tflag)
{
    printf("%-3s %7jd   %-40s\n",
	(tflag == FTW_D) ?   "d"   : (tflag == FTW_DNR) ? "dnr" :
	(tflag == FTW_DP) ?  "dp"  : (tflag == FTW_F) ?   "f" :
	(tflag == FTW_NS) ?  "ns"  : (tflag == FTW_SL) ?  "sl" :
	(tflag == FTW_SLN) ? "sln" : "???",
	(intmax_t) sb->st_size,
	fpath);
    return 0;           /* To tell nftw() to continue */
}

int
main(int argc, char *argv[])
{
    if (ftw((argc < 2) ? "." : argv[1], display_info, 20)
	    == -1) {
	perror("nftw");
	exit(EXIT_FAILURE);
    }
    exit(EXIT_SUCCESS);
}
