#define _XOPEN_SOURCE
#include <stdlib.h>
#include <stdio.h>
#include <wchar.h>
#include <wctype.h>
#include <ctype.h>
#include <string.h>

static void escape_str_utf8(char *dst, int maxcells)
{
  int my_cells = 0;
  mbstate_t s;
  const char *src = dst;

  memset(&s, 0, sizeof (s));

  for(;;) {
    wchar_t wc;
    int len = 0;

    if(my_cells >= maxcells)
      break;

    if (!(len = mbrtowc (&wc, src, MB_CUR_MAX, &s)))
      /* 'str' contains \0 */
      break;

    if (len < 0) {
      /* invalid multibyte sequence -- zeroize state */
      memset (&s, 0, sizeof (s));
      *dst++ = '?';
      src++;
      my_cells++;

    } else if (len==1) {
      /* non-multibyte */
      *dst++ = isprint(*src) ? *src : '?';
      src++;
      my_cells++;

    } else if (!iswprint(wc)) {
      /* multibyte - no printable */
      *dst++ = '?';
      src += len;
      my_cells++;

    } else {
      /* multibyte - printable */
      int wlen = wcwidth(wc);

      // Got space?
      if (my_cells+wlen > maxcells) break;
      // multibyte
      my_cells += wlen;
      memcpy(dst, src, len);
      dst += len;
      src += len;
    }
  }
  *dst++ = '\0';
}

int main(void)
{
	char hw[16];

	strcpy(hw, "Hello, wordl!!");
	escape_str_utf8(hw, 13);
	return strcmp(hw, "Hello, wordl!");
}
