/*
 * Mini fdflush implementation for busybox
 *
 * Copyright (C) 1995, 1996 by Bruce Perens <bruce@perens.com>.
 * Copyright (C) 2003 by Erik Andersen <andersen@codeoet.org>
 *
 */
#ifdef APPLET_USAGE
#define fdflush_trivial_usage \
	"DEVICE"
#define fdflush_full_usage \
	"Forces floppy disk drive to detect disk change"
#else

#include <sys/ioctl.h>
#include <unistd.h>
#include "busybox.h"
#include "bb_xopen.h"

/* From <linux/fd.h> */
#define FDFLUSH  _IO(2,0x4b)

extern int fdflush_main(void)
{
	if (Gargc != 2)
		bb_show_usage();

	xioctl(bb_xopen(Gargv[1], O_RDONLY | BB_OPEN_ERR), FDFLUSH, 0, "\1ioctl");

	/* Don't bother closing.  Exit does
	 * that, so we can save a few bytes */
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
