/*
 * freeramdisk implementation for busybox
 *
 * Copyright (C) 2000 and written by Emanuele Caratti <wiz@iol.it>
 * Adjusted a bit by Erik Andersen <andersen@codepoet.org>
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define freeramdisk_trivial_usage \
	"DEVICE"
#define freeramdisk_full_usage \
	"Frees all memory used by the specified ramdisk."
#else

#include <string.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <unistd.h>
#include "busybox.h"
#include "bb_xopen.h"

extern int freeramdisk_main(void)
{
	if (Gargc != 2)
		bb_show_usage();

	ioctl(bb_xopen(Gargv[1], O_RDWR | BB_OPEN_ERR), BLKFLSBUF, NULL, "\1failed ioctl on %s", Gargv[1]);

	/* Don't bother closing.  Exit does
	 * that, so we can save a few bytes */
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
