/*
 * Mini losetup implementation for busybox
 *
 * Copyright (C) 2002  Matt Kraai.
 *
 * Licensed under GPLv2 or later, see file LICENSE in this tarball for details.
 */
#ifdef APPLET_USAGE
#define losetup_trivial_usage \
	"[-od] LOOPDEVICE [FILE]"
#define losetup_full_usage \
	"Associate LOOPDEVICE with FILE, or display current association.\n\n" \
	"Options:\n" \
	"\t-d\t\tDisassociate LOOPDEVICE\n" \
	"\t-o OFFSET\tStart OFFSET bytes into FILE"
#else

#include "busybox.h"

int losetup_main (void)
{
  int argc;
  char **argv;
  char *o;
  int  offset = 0;
  int opt;

  /* min 1, max 2 arg */
  opt = bb_xgetopt_ulflags("do:\0:-o:-1?2:?d--o:o--d", &offset);
  argc = Gargc;
  argv = Gargv;
  if(opt & 1) {
      /* detach takes exactly one argument */
      if(argc != 1) bb_show_usage();
      if(!del_loop(*argv)) return EXIT_SUCCESS;
die_failed:
      bb_perror_msg_and_die("%s", *argv);
  }
  if(argc == 2) {
	/* losetup takes two argument:, loop_device and file */
	if(set_loop(&argv[0], argv[1], offset) >= 0)
	  return EXIT_SUCCESS;
	else goto die_failed;
  }
  o = query_loop(*argv);
  if (!o) goto die_failed;
  printf("%s: %s\n", *argv, o);
  return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
