/*
 * pivot_root.c - Change root file system.  Based on util-linux 2.10s
 *
 * busyboxed by Evin Robertson
 * pivot_root syscall stubbed by Erik Andersen, so it will compile
 *     regardless of the kernel being used.
 */
#ifdef APPLET_USAGE
#define pivot_root_trivial_usage \
	"NEW_ROOT PUT_OLD"
#define pivot_root_full_usage \
	"Move the current root file system to PUT_OLD and make NEW_ROOT\n" \
	"the new root file system."
#else

#include "busybox.h"
#if defined(__BIONIC__)
#error "BIONIC have not support pivot_root(). Reconfigure for disable the 'pivot_root' applet."
#endif

extern int pivot_root(const char * new_root,const char * put_old);

int pivot_root_main(void)
{
	int argc = Gargc;
	char **argv = Gargv;

	if (argc != 3)
		bb_show_usage();

	if (pivot_root(argv[1],argv[2]) < 0)
		bb_perror_msg_and_die("pivot_root");

	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
