/*
     A text editor special for rescue and router disk with busybox.
     1992 - 2017 (C) Vladimir Oleynik <dzo@simtreas.ru>

     Sorry, only for russian see source! It my first experience.
*/
#ifdef APPLET_USAGE
#define ocxb_trivial_usage \
	"[-sr] [FILES...]"
#define ocxb_full_usage \
	"A text editor by Vladimir Oleynik\n" \
	"Press <F1> key for see help\n\n" \
	"Options:\n" \
	"\t-s\tUse temp file for noactive windows, reduce memory use\n" \
	"\t-r\tIgnore saved desktop file"
#else

#if defined(__i386__)
# define internal_function __attribute__ ((regparm (3), stdcall))
# define stdcall2 __attribute__ ((stdcall))
#elif defined(__x86_64__)
# define internal_function __attribute__ ((regparm (3)))
# define stdcall2
#else
# define internal_function
# define stdcall2
#endif

#include "busybox.h"
#include <fcntl.h>
#include <time.h>
#include <string.h>
#include <termios.h>
#include <sys/ioctl.h>
#include <math.h>
#include <unistd.h>
#include <sys/wait.h>

#include <glob.h>
#ifndef GLOB_BRACE
#define GLOB_BRACE 0
#endif
#ifndef GLOB_TILDE
#define GLOB_TILDE 0
#endif

#include "bb_sig.h"
#include "bb_xopen.h"

#define NFILES 9

	/*       */

#define AC 6                                    /* rw  */
#define SLASHC '/'


#define MLS 512

	/*  , ,  ,  */
#define NHIS 7
#define buff_history(i) (&shelp[(i)*MLS])
			  /*   */
#define HELP_BUFF    0
#define CALC_BUFF    1
#define FIND_HIS     2
#define FILE_HIS     3
#define CALC_HIS     4
#define REPL_HIS     5
#define SHELL_HIS    6
#define MAN_HIS      7
#define FIRST_HIS    FIND_HIS
#define END_HIS      MAN_HIS
#define NUM_BUFF_HIS 8                  /*     */

#if MLS <= 1024
#define SHELP_BLK 1024
#else
#define SHELP_BLK MLS
#endif

		/*   80x24 */
#define MAX_WY  67      /* SVGA 67x132 mode */
#define MAX_WX  200



#define END_W   (SIZE_W+3)

typedef unsigned short t_swap_lenght;
typedef long t_adr_swap;

union A_S_L
{
  t_adr_swap adr_swap;
  char small_str[sizeof(long)];
};

typedef struct list
{
  /*      */
  struct list *over;            /*  */
  union A_S_L asl;              /*      */
  t_swap_lenght swap_lenght;    /*      */
}
stfkernel;

typedef struct list *stf;

			/*    */
struct BUFF_BLK
{
  long beg_y;                   /*   */
  short beg_x;                  /*   */
  short end_x;                  /*   */
  long end_y;                   /*   */
  short typeb;                  /* =1, =2 */
};

#define N_KQB 10                /*      */
struct kqbs_SPF
{
  long dkqbs[N_KQB];            /*  ,  */
  short dkqbp[N_KQB];           /*    */
};

struct FILES_ST
{                               /*    */
  char filesav[MLS];   /*  */
  struct list stf0f;            /*   
				       */
  /*         : */
  stf top_stf;                  /*  .      */
  short f_pos_cur_y;            /*      y */
  short f_pos_cur_x;            /*      x */
  long f_nstr_pos;              /*     */
  short f_posx_str;             /*     */
  long nstr_file;               /*   */
  int f_column;                 /*    x */
  struct BUFF_BLK blk;          /*    */
  unsigned int mode;            /* stat mode */
  long mtime;                   /* stat modify time */
  struct kqbs_SPF skqbsp;       /*   */
  char flg_s;                   /* , autosave, . ,  */
};

	/*   */
#define SHBIT     10
#define BUFF_SIZE (1<<SHBIT)    /*   1  */
/*    (  !)    */

				/* 32-bit systems */
#define NBUFF_CACHE (1<<9)              /* 512 Kb */

#define SIZEBISIO       (1024<<1)       /*   -stdio */

#define I_P_M 8         /*      */

			/*    */
#define SIZE_MAX_M_WB (34*14+4)

		/*   */
struct ID
{
  char name[8];
  double val;
};

#define MAX_ID (sizeof(shelp)/sizeof(struct ID))

CALC_BSS struct BB_COMMON_BSS
{
	char shelp[NHIS * SHELP_BLK];   /*  help- */
	long seek_io;                    /*   */
	long size_swap;                  /*     */
			/*   mconio */
	int cur_attr;
	int cur_x, cur_y;
	char typ_cursor_save;
	char buff_0screen[MAX_WY * MAX_WX * 2]; /* .  */
	char buf_scr[MAX_WY - 3][MLS];  /*   */
	char *swap_file;        /* swap_file[] = "/tmp/?NPid"; */
		/*  stdio */
	int ochan;
	int oflag;
	unsigned char *optr;
	int ocnt;
	char obuf[SIZEBISIO + MLS];
		/*     */
	char get_str[MLS];      /* temp string */
	char str_rez[MLS];      /* 2 temp string */
	char str_replace[MLS];
	char str_all_tmp[MLS];  /* 3 temp string */
	char gets_text[MLS];    /*     */
	long t0w;                /*     */
	int flg_as_on;           /*    screen saver */
	char psav;       /*    winbox */
	int b_flg_modify;        /*  -   */
	int b_flg_load;          /*  -   */
	int b_flg_vonly;         /*  -    */
	int b_flg_creat;         /*  -   */
	int b_flg_activ;         /*  -   */
	int b_flg_as;            /*  -     */
	int b_u_mdf;     /*  - undo   . . */
	int bpnfiles;
	char flg_synt_highl;
	char flg_repl_all;               /*   */
	char no_ask;                     /*   */
	char wwo;                        /*    */
	char find_f_b;                   /*   / */
	char flg_rcase;          /*       */
	long nstr_pos;           /*     */
	int *wb_miny;
	int wb_maxy;
	int ywb_wf;
	stf ustf0[NFILES];
	long sizeuswap[NFILES];
	long cur_posu[NFILES];
	int flg_link;    /*    */
	struct BUFF_BLK ubblk;
	long *kqbs;                          /*  ,  */
	short *kqbp;                         /*    */
	int pos_val_file;
	int posx_val_file;
	int flg_replace;
	int pnfiles;     /*     */
	long flg_tmp;    /*    */
	int flg_eof;     /*      
			      */
	char str_find[MLS];     /*   */
	int flg_F6;
	unsigned char flg_ex_macro;      /*  macro */
	int flg_p_macro[4];              /*   */
	int nmacro;                      /*    */
	int indsk;                       /*   desktop- */
	char BLKF[MLS];
	int tn_a;                /*   */
	int typebclip;           /*     */
	int lenghbclip;          /*     */
	int flg_avt_form;        /*    */
	int flg_vb;              /* != 0 -   */
	int flg_save_as;
	struct BUFF_BLK *buff_blk;
	struct FILES_ST files_st[NFILES];
	stf bottom_stf;
	char eds[MAX_WY];        /*      eds[y]!=0 */
	stf stf0;                /* root list */
	stf swap_free;
	stf mem_free_root;
	int flg_rus;             /* LAT = 0 */
	int pos_cur_y;           /*      */
	int pos_cur_x;
	int column;              /*    x */
	int posx_str;    /*      */
	int fun_arg;     /* -    */
	long ta;
	char flg_no_sd;  /*  desktop */
	char flg_alarm_initted;
				/*  */
	int fd_swap;
	unsigned int status[NBUFF_CACHE];
				/*  */
	char buff_cache[NBUFF_CACHE][BUFF_SIZE];
	int nblk_w;      /* offset   buff_cache */
	int sav_seek;    /*       */
			/* mconio */
	char *offs_sn;
/*           */
	int re_reset;
	/*       screen saver */
	long timess;
	long tas;        /*    */
	int nfile;       /*      glob(3) */
	glob_t globbuf;
	int flg_blk_form;
/*         */
	struct list *save_stf_cur_list;
	long save_stf_cur_nstr;

	char sav_pos_menu[I_P_M];    /*     */
	int bflg_noasm[I_P_M];   /*      */
	int chU, chD, chL, chR;  /*   */
	/*    */
	char old_scr[MAX_WY * MAX_WX * 2];
	int flg_video;
	/*    */
	struct termios tnew, told;
	int keybrd_inited;
	int cur_rev;
	unsigned short mem_winbox[SIZE_MAX_M_WB];
	const char *ntlfcnv;
	char p_flsrt[32];
	char preset_format;
	int sav_popup;                   /*     */
	int ssav_ywb;
	long u_nstr_pos;
	short u_posx_str;
	char u_flg_vb;
	char u_insert;
	char u_f_modify;
	struct kqbs_SPF u_skqbsp;
	int mem_size_gen;
	stf beg_mem;
	const char *buff_altk;
	char *dp;               /*  .  . . */
	int line_str_a;         /*    */
	int tn_f;               /*    */
	int flg_mperenos;       /*     */
	int flg_view_mod;       /*    */
	int timesasstart;       /*    */
	long bb_nstr_file;      /*     */
	char insert;
	unsigned char user_tab; /* ,   */
	int nswpnaf;            /*      */
#define MACMAX 128                              /*    */
	short macrox[4][MACMAX];
	int flg_sav_macro;      /*   macro */
	struct ID *identf;
	int posid;
	int max_y_wbs;
	int min_y_wbs;
	int nfiles;             /*      */
	stf *p_ustf0;
	long *p_sizeuswap;
	long *p_cur_posu;
#define N_F_A_S 9        /* autosave.X <--      */
	char s_auto_save[N_F_A_S+2];     /*  s_auto_save_st   N_F_A_S */
	int sav_y_form;
	int sav_yfswb;
	int sav_yparm;
	int view_list_sav_ywb;
	int shcom_sav_ywb;
	int calcv_sav_ywb;
	int load_file_sav_ywb;
	int save_file_sav_ywb;
	int save_as_sav_ywb;
	int blk_save_sav_ywb;
	int eparm_sav_ywb;
	int input_buf_sav_ywb;
	int timessstart;        /*   .   screen saver */
	int SIZE_W;
	int WXsize;
} bb_common_bss;
#define shelp bb_common_bss.shelp
#define seek_io bb_common_bss.seek_io
#define size_swap bb_common_bss.size_swap
#define cur_attr bb_common_bss.cur_attr
#define cur_x bb_common_bss.cur_x
#define cur_y bb_common_bss.cur_y
#define typ_cursor_save bb_common_bss.typ_cursor_save
#define buff_0screen bb_common_bss.buff_0screen
#define buf_scr bb_common_bss.buf_scr
#define swap_file bb_common_bss.swap_file
#define ochan bb_common_bss.ochan
#define oflag bb_common_bss.oflag
#define optr bb_common_bss.optr
#define ocnt bb_common_bss.ocnt
#define obuf bb_common_bss.obuf
#define get_str bb_common_bss.get_str
#define str_rez bb_common_bss.str_rez
#define str_replace bb_common_bss.str_replace
#define str_all_tmp bb_common_bss.str_all_tmp
#define gets_text bb_common_bss.gets_text
#define t0w bb_common_bss.t0w
#define flg_as_on bb_common_bss.flg_as_on
#define psav bb_common_bss.psav
#define b_flg_modify bb_common_bss.b_flg_modify
#define b_flg_load bb_common_bss.b_flg_load
#define b_flg_vonly bb_common_bss.b_flg_vonly
#define b_flg_creat bb_common_bss.b_flg_creat
#define b_flg_activ bb_common_bss.b_flg_activ
#define b_flg_as bb_common_bss.b_flg_as
#define b_u_mdf bb_common_bss.b_u_mdf
#define bpnfiles bb_common_bss.bpnfiles
#define flg_synt_highl bb_common_bss.flg_synt_highl
#define flg_repl_all bb_common_bss.flg_repl_all
#define no_ask bb_common_bss.no_ask
#define wwo bb_common_bss.wwo
#define find_f_b bb_common_bss.find_f_b
#define flg_rcase bb_common_bss.flg_rcase
#define nstr_pos bb_common_bss.nstr_pos
#define wb_miny bb_common_bss.wb_miny
#define wb_maxy bb_common_bss.wb_maxy
#define ywb_wf bb_common_bss.ywb_wf
#define ustf0 bb_common_bss.ustf0
#define sizeuswap bb_common_bss.sizeuswap
#define cur_posu bb_common_bss.cur_posu
#define flg_link bb_common_bss.flg_link
#define ubblk bb_common_bss.ubblk
#define kqbs bb_common_bss.kqbs
#define kqbp bb_common_bss.kqbp
#define pos_val_file bb_common_bss.pos_val_file
#define posx_val_file bb_common_bss.posx_val_file
#define flg_replace bb_common_bss.flg_replace
#define pnfiles bb_common_bss.pnfiles
#define flg_tmp bb_common_bss.flg_tmp
#define flg_eof bb_common_bss.flg_eof
#define str_find bb_common_bss.str_find
#define flg_F6 bb_common_bss.flg_F6
#define flg_ex_macro bb_common_bss.flg_ex_macro
#define flg_p_macro bb_common_bss.flg_p_macro
#define nmacro bb_common_bss.nmacro
#define indsk bb_common_bss.indsk
#define BLKF bb_common_bss.BLKF
#define tn_a bb_common_bss.tn_a
#define typebclip bb_common_bss.typebclip
#define lenghbclip bb_common_bss.lenghbclip
#define flg_avt_form bb_common_bss.flg_avt_form
#define flg_vb bb_common_bss.flg_vb
#define flg_save_as bb_common_bss.flg_save_as
#define buff_blk bb_common_bss.buff_blk
#define files_st bb_common_bss.files_st
#define bottom_stf bb_common_bss.bottom_stf
#define eds bb_common_bss.eds
#define stf0 bb_common_bss.stf0
#define swap_free bb_common_bss.swap_free
#define mem_free_root bb_common_bss.mem_free_root
#define flg_rus bb_common_bss.flg_rus
#define pos_cur_y bb_common_bss.pos_cur_y
#define pos_cur_x bb_common_bss.pos_cur_x
#define column bb_common_bss.column
#define posx_str bb_common_bss.posx_str
#define fun_arg bb_common_bss.fun_arg
#define ta bb_common_bss.ta
#define flg_no_sd bb_common_bss.flg_no_sd
#define flg_alarm_initted bb_common_bss.flg_alarm_initted
#define fd_swap bb_common_bss.fd_swap
#define seek_io bb_common_bss.seek_io
#define size_swap bb_common_bss.size_swap
#define status bb_common_bss.status
#define buff_cache bb_common_bss.buff_cache
#define nblk_w bb_common_bss.nblk_w
#define sav_seek bb_common_bss.sav_seek
#define offs_sn bb_common_bss.offs_sn
#define re_reset bb_common_bss.re_reset
#define timess bb_common_bss.timess
#define tas bb_common_bss.tas
#define nfile bb_common_bss.nfile
#define globbuf bb_common_bss.globbuf
#define flg_blk_form bb_common_bss.flg_blk_form
#define save_stf_cur_list bb_common_bss.save_stf_cur_list
#define save_stf_cur_nstr bb_common_bss.save_stf_cur_nstr
#define sav_pos_menu bb_common_bss.sav_pos_menu
#define bflg_noasm bb_common_bss.bflg_noasm
#define chU bb_common_bss.chU
#define chD bb_common_bss.chD
#define chL bb_common_bss.chL
#define chR bb_common_bss.chR
#define old_scr bb_common_bss.old_scr
#define flg_video bb_common_bss.flg_video
#define tnew bb_common_bss.tnew
#define told bb_common_bss.told
#define keybrd_inited bb_common_bss.keybrd_inited
#define cur_rev bb_common_bss.cur_rev
#define mem_winbox bb_common_bss.mem_winbox
#define ntlfcnv bb_common_bss.ntlfcnv
#define p_flsrt bb_common_bss.p_flsrt
#define preset_format bb_common_bss.preset_format
#define sav_popup bb_common_bss.sav_popup
#define ssav_ywb bb_common_bss.ssav_ywb
#define u_nstr_pos bb_common_bss.u_nstr_pos
#define u_posx_str bb_common_bss.u_posx_str
#define u_flg_vb bb_common_bss.u_flg_vb
#define u_insert bb_common_bss.u_insert
#define u_f_modify bb_common_bss.u_f_modify
#define u_skqbsp bb_common_bss.u_skqbsp
#define mem_size_gen bb_common_bss.mem_size_gen
#define beg_mem bb_common_bss.beg_mem
#define buff_altk bb_common_bss.buff_altk
#define dp bb_common_bss.dp
#define line_str_a bb_common_bss.line_str_a
#define tn_f bb_common_bss.tn_f
#define flg_mperenos bb_common_bss.flg_mperenos
#define flg_view_mod bb_common_bss.flg_view_mod
#define timesasstart bb_common_bss.timesasstart
#define bb_nstr_file bb_common_bss.bb_nstr_file
#define insert bb_common_bss.insert
#define user_tab bb_common_bss.user_tab
#define nswpnaf bb_common_bss.nswpnaf
#define macrox bb_common_bss.macrox
#define flg_sav_macro bb_common_bss.flg_sav_macro
#define identf bb_common_bss.identf
#define posid bb_common_bss.posid
#define max_y_wbs bb_common_bss.max_y_wbs
#define min_y_wbs bb_common_bss.min_y_wbs
#define nfiles bb_common_bss.nfiles
#define p_ustf0 bb_common_bss.p_ustf0
#define p_sizeuswap bb_common_bss.p_sizeuswap
#define p_cur_posu bb_common_bss.p_cur_posu
#define s_auto_save bb_common_bss.s_auto_save
#define sav_y_form bb_common_bss.sav_y_form
#define sav_yfswb bb_common_bss.sav_yfswb
#define sav_yparm bb_common_bss.sav_yparm
#define view_list_sav_ywb bb_common_bss.view_list_sav_ywb
#define shcom_sav_ywb bb_common_bss.shcom_sav_ywb
#define calcv_sav_ywb bb_common_bss.calcv_sav_ywb
#define load_file_sav_ywb bb_common_bss.load_file_sav_ywb
#define save_file_sav_ywb bb_common_bss.save_file_sav_ywb
#define save_as_sav_ywb bb_common_bss.save_as_sav_ywb
#define blk_save_sav_ywb bb_common_bss.blk_save_sav_ywb
#define eparm_sav_ywb bb_common_bss.eparm_sav_ywb
#define input_buf_sav_ywb bb_common_bss.input_buf_sav_ywb
#define timessstart bb_common_bss.timessstart
#define SIZE_W bb_common_bss.SIZE_W
#define WXsize bb_common_bss.WXsize

		/*      */

#define OFF_0     ((long)NUM_BUFF_HIS*sizeof(shelp))
#define SIZ_OFF_1 sizeof(buf_scr)
#define SIZ_OFF_2 MAX_WY*WXsize*2
#define SIZ_OFF_3 MAX_WY*WXsize

static void put_scr_buff_swap (void);
static internal_function void put_buff_swap (int);
static internal_function void get_buff_swap (int);
static void get_scr_buff_swap (void);

	/*     */
/*    */
static void str_r_ioc (void);   /*     */
/*     */
static internal_function void write_cb (const void *, int);
static stdcall2 void read_cb (void *, int);     /*     */


	/*    conio */

#define ogotoxy(x,y) { cur_x=(x)-1; cur_y=(y)-1; }

			/*   */
enum CursorType { NORMCURSOR = 0, FULLCURSOR, NOCURSOR };
static stdcall2 void cursor (int);

static void oclrscr (void);
static void beep (void);                /*  \007 */
static void set_offs_sn (void); /*    putch_next */
static stdcall2 void putch_next (char);

static stdcall2 void oputch (char);

static stdcall2 void ocputs (const char *);
static stdcall2 void ocputsn (const char *);
static stdcall2 void ocputsnt (const char *);
static stdcall2 void get2_box (int, int, int, int, void *);
static stdcall2 void restore_box (int, int, int, int, const void *);
static stdcall2 void restore2_box (const void *);
static stdcall2 void cset_atr (int, int);

/*    ,  */
static stdcall2 void old_set (int);
static void old_set_sig (void); /*      */

static stdcall2 void ocputs2n (const char *);
static stdcall2 void ocputs3n (const char *);

		   /*   -  */

#define vtisthis(i) 1
static int getch (void);
static int kbhit (void);
#define TERM_CR    '*'
#define TERM_CR2 TERM_CR
static int get_term_decode_key (void);

static void update_display (void);
static void toclrscr (void);
#ifdef TERMvt52
static stdcall2 void tcursorvisible (int);
#else
#define tcursorvisible(flg_on_off)
#endif
static stdcall2 void togotoxy (int, int);

		/*   */
#define gencolor(colortxt,colorback,ct) (colortxt | colorback<<4)
#define cset_atrD(f,cf,cb,ct) cset_atr(f,cf | cb<<4)
#define textabk(colortxt,colorback,ct) cur_attr = gencolor(colortxt,colorback,ct)

static int test_input (void);   /*      Esc */
static stdcall2 int any (int);  /*    <Enter> <Esc> <Y> <N> <Tab> */


	/*     Unix (kbscancod.c) */
static void vtscanclose (void);
static void vtscaninit (void);

static void t_fflush (void);    /*  ,   . . */

	/*     conio */

			/*  */
static int main_calc (void);    /*  */

		/*  stdio */
#define IOR 0
#define IOW 1


#define EOF     (-1)
#define _IOREAD   1
#define _IOEOF    4
#define _IOWRITE  2
#define _IOOPEN   8
#define form_file swap_file
#define clipboard swap_file

#ifndef __BIONIC__
#define PTMPFILE 5      /* strlen("/tmp/") */
#else
#define PTMPFILE 1      /* Android have not /tmp, use ?NPID */
#endif

static stdcall2 int ofopen (const char *, int);
static void ofclose (void);
static stdcall2 void ofputs (const char *);
static void diskerror (void);
static void qcopen (void);
static int ogetc (void);
static stdcall2 void oputc (int);

#define Qogetc() (ocnt <= 0 ? ogetc() : (ocnt--, *optr++))

		/*  `  stdio */

		/*    */
static const char sESC[] = "(ESC)Cansel";
static const char ERROR[] = "ERROR";
static const char PSAK[] = "Press any key";
static const char NOFOUND[] = "not found";
static const char SWARN[] = "Warning";
static const char sS3n_u[]="$>";
static const char sS3n_m[]="$> ";
static const char sS3n_d[]="$>";
static const char NONAME[] = "NONAME";

static void autosave (void);    /*   */

	/*      */

	/*   - "*[?" ? */
static stdcall2 int ifg (const char *);

static stdcall2 int lline (int);    /*      */
static void g_space_f (void);       /*    */
static void reconv_space (void);    /*    */

static stdcall2 char *str1cat (char *, char);

static stdcall2 void dec_str (long);    /* printf("%ld",long) */

			/*    dsk- */
static stdcall2 int open_raw (const char *, int);
static int write_raw (void *, int);
static int read_raw (void *, int);

			/*   */
/*      screensaver */
static void settss (void);
static stdcall2 void put_time (int);

static stdcall2 void set_alarm (long);
static void unset_alarm (void);


static void scroller (int);
/*    ScrollBar */
static stdcall2 int mathscrollbar (long, int, long);
static stdcall2 void form_d (int);      /* sprintf(str_rez,"%d",arg); */

	/*  <Ok> <Cansel> */
static stdcall2 int button2 (int, const char *, const char *, int);

		/* W I N B O X -    */

			/*   winbox */
#define WB_STD  0
#define WB_SFS2 16      /*     winbox 2   */
#define WB_SFS3 32      /*     winbox 3   */
#define WB_SFS4 64      /*     winbox 4   */
#define W_8     128     /*  8  */
#define W_9     256     /*  9  */

#define W_N_IC  512     /*        */


#define WIN_E_PSAK      1
#define WIN_E_OK        2
#define WIN_E_OK_KEY    4
#define WIN_E_Cancel    8

static stdcall2 int x_centr (const char *);
static stdcall2 void win_0e (const char *, const char *, int);
static stdcall2 void win_err (const char *, const char *, int);
static stdcall2 void win_1e (const char *, const char *, const char *, int);
static stdcall2 void win_e (const char *, const char *, const char *, const char *, int);
static void restore_wb (void);  /* ,    winbox */

#define lj32 j

static void oexit (void);               /*  atexit */

	/*   */


#define FLG_A_S_SYHL 0x80               /*   autosave */
#define FLG_ACTIV    0x40               /*    */
#define FLG_ACTIVB   0x20               /*    */
#define FLG_NONAME   0x10               /*    */

static int get_key (void);
static stdcall2 void save_all (int);    /*      */
static stdcall2 void del_file (int);    /*   */
static stdcall2 void reset (int);

static stdcall2 void up_d (long);
static int comm_down (void);
static void comm_cr (void);

static stdcall2 void view_str (int);
	/*   C++ */
static stdcall2 void view_lstr (const char *, int);
static stdcall2 char *view_flstr (const char *);
static stdcall2 int ascii_w (int, int);
static stdcall2 int recolumn (int);
static stdcall2 int g_lline (stf);
static stdcall2 void g_space (stf);
static stdcall2 void getstext (stf);
static stdcall2 void delupcur (int);    /*     */
	/*    ""    */
static stdcall2 void spec_del (int);
/*  -  */
static stdcall2 void begmacrox (int);


#define NOREVIEW 0
#define REVIEW   1
static stdcall2 void review_scr (int);
static void poscur (void);
static void posrev (void);
static void cr (void);
static stdcall2 void tabx (int);
static stdcall2 void deleten (int);
static stdcall2 void view25 (int);
static stdcall2 void set_nl (long, int);

static int button2ny (void);
static stdcall2 int button3ny (int);
static stdcall2 void but1ysax (int, const char *, int, int);
static stdcall2 void but1ysaxc (int, const char *);
static stdcall2 int button3 (int *, const char *, const char *, const char *, int);

#define RUS 1                                   /* for */
#define ALT 2                                   /* flg_rus */

typedef void (*EF) (void);              /*     */

static void up (void);
static void down (void);
static void left (void);
static void right (void);
static void home (void);
static void end_line (void);
static void pdown (void);
static void pup (void);
static void cr_ask (void);
static void tab (void);
static void bottom (void);
static void delete2 (void);
static void del_line (void);
static void delupcur2 (void);
static void scr_review (void);
static void paste (void);
static void top (void);
static void btab (void);
static void home0 (void);
static void save_file (void);
static void shell (void);
static void save_as (void);
static void input_buf (void);
static void repeat (void);
static void expblk (void);      /*   Shift +  */
static void begmacro (void);    /*      */
static void exemacro (void);    /*   */
static void help_view (void);
static void beg_blk (void);
static void end_blk (void);
static void blk_copy (void);
static void blk_move (void);
static void blk_save (void);
static void save_clip (void);
static void in_clip (void);
static void in_clip_conv (void);
static void blk_del (void);
static void blk_cls (void);
static void load_file (void);
static void man (void);
static void form_set (void);
static void pblk_beg (void);
static void word_plus (void);
static void set_filex (void);
static void left_word (void);
static void delf_fun (void);

static void undo (void);
static void redo (void);
static void main_drp (void);
static void avt_param_form (void);
static void menu (void);

static void paste2 (int);               /*  */
static void u_end_line (void);

static stdcall2 void u_edc (int);
static stdcall2 int blk_to_buff (long, int);
static stdcall2 void blk_to_del (int);

enum codes_keys
{
  UP_KEY = 256, DOWN_KEY, LEFT_KEY, RIGHT_KEY,
  PDOWN_KEY, PUP_KEY, CR_KEY, TAB_KEY, DELETE_KEY, DEL_LINE_KEY,
  DELUPCUR, BTAB_KEY, INPUT_BUF,
  EXPB_UP, EXPB_DOWN, EXPB_LEFT, EXPB_RIGHT, EXPB_PUP, EXPB_PDOWN,
  BLK_COPY, IN_CLIP, FORM_KEY,
  WORD_P_KEY, IN_CLIP2,
  FINDF_KEY, FINDA_KEY, REFIND_KEY,
  EXEMACRO, TXTMAC1_KEY, TXTMAC2_KEY, TXTMAC3_KEY,
  LEFT_WORD,
  FORM_TEXT, CALC1_KEY, CALC2_KEY, CALC3_KEY, CALC4_KEY, CALC5_KEY,
  UNDO_KEY, REDO_KEY, EXPB_WR_KEY, EXPB_WL_KEY,
  /*   -  */
  HOME_KEY, END_KEY,
  SCR_REVIEW, TOP_KEY, SAVE_NO_R, BOTTOM_KEY,
  HOME0_KEY,
  SHELL_KEY,
  SAVE_AS_K, EXPB_END, BEGMACRO,
  HELP_KEY, BEG_BLK, END_BLK, BLK_MOVE,
  BLK_SAVE, BLK_DEL, BLK_CLS, OPEN_KEY, OUT_CLIP,
  BEGTXTM_KEY, ASCII_KEY,
  MAN_KEY,
  CALCV_KEY,
  FORMS_KEY, RIGHT_STR, CENTR_KEY, PBLK_KEY,
  BLK_RUS, BLK_LAT, BLK_UPC, BLK_LOWC,
  CUT_KEY, DELBEG_KEY,
  SET0_KEY, SET1_KEY, SET2_KEY, SET3_KEY, SET4_KEY, SET5_KEY, SET6_KEY,
  SET7_KEY, SET8_KEY, SET9_KEY,
  GOTO0_KEY, GOTO1_KEY, GOTO2_KEY, GOTO3_KEY, GOTO4_KEY, GOTO5_KEY,
  GOTO6_KEY, GOTO7_KEY, GOTO8_KEY, GOTO9_KEY,
  SHCOM_KEY,
  RUS_LAT_FUN, ALT_FUN, INSERT_FUN,
  SET_FILE1, SET_FILE2, SET_FILE3, SET_FILE4, SET_FILE5, SET_FILE6,
  SET_FILE7, SET_FILE8, SET_FILE9,
  VIEW_OLD_S,
  OPEN_FUN, DELF_FUN, FIND_Z, GOTO_LINE, CTRL_UP_KEY, CTRL_DOWN_KEY,
  REPEAT_KEY, NOT_SAVE, MENU_KEY, GLINE_KEY, FORM_BLK_KEY, AVT_FPRM_KEY,
  MOVE_KEY, ERDIC, EXPB_HOME,
  ESC_KEY,
  /*  */
  FORM_FUN, FORM_FUN1,
  OPT_FIND_FUN, OPT_FIND_FUN1,
  BLK_FUN, FIND_FUN,
};

#define RIGHT_S  0x1
#define LEFT_S   0x2
#define ALT_S    0x08
#define CAPS     0x40
#define SHIFT    (RIGHT_S|LEFT_S)

#define S_C(c1,c2) ((((unsigned long)c1)<<16)|c2)
#define U_C(c)     ((unsigned char)c)
#define IS_S(c)    (((unsigned long)c)&0xffff0000)
#define H_C(c)     (c>>16)
#define L_C(c)     ((c)&0xffff)

#define io_seek(ls) seek_io = (ls)
#define ioseekend() seek_io = size_swap
static stdcall2 void set_nfile (int);
static void unload (void);
static void view_pos (void);
static void tmp_blk (void);

static void pasterecalc (void);

static stdcall2 int get_word (char *, int);
static stdcall2 int get_word2 (char *, const char *, int, int);


			/*  savefile */
#define AUTO_SAVE -1
#define SAVE_AS    1
#define SAVENONAME 2
#define SAVECLIP   3
#define SAVEBLOCK  4
#define CUT        5

static stdcall2 int test_blk (int);
static stdcall2 int win_find0 (int);


	/*   */
#define EMACRO1 1                               /*  1 */
#define EMACRO2 2                               /*  2 */
#define EMACRO3 4                               /*  3 */
#define EMACRO4 8                               /*  4 */
#define EMACRO  (EMACRO1|EMACRO2|EMACRO3|EMACRO4)       /*  */
#define EREPEAT 16                              /*  */
#define EFOUND  32              /*   ,   */
#define EFORMT  64              /*   */
#define EOKOP   128             /*     */


		/*    */
#define GEN_BM(i)        (1<<(i))

#define IS_MODIFY()      (b_flg_modify     & bpnfiles)
#define IS_MODIFYI(i)    (b_flg_modify     & GEN_BM(i))
#define IS_ASMODFI(i)    (b_flg_as         & GEN_BM(i))
#define IS_MODIFYI(i)    (b_flg_modify     & GEN_BM(i))
#define IS_LOAD()        (b_flg_load       & bpnfiles)
#define IS_VONLY()       (b_flg_vonly      & bpnfiles)
#define IS_CREAT()       (b_flg_creat      & bpnfiles)
#define IS_ACTIV()       (b_flg_activ      & bpnfiles)
#define IS_OK_MOD()      (IS_MODIFY()      & ~b_flg_vonly)
#define IS_OK_MODI(i)    (IS_MODIFYI(i)    & ~b_flg_vonly)
#define IS_LOADI(i)      (b_flg_load       & GEN_BM(i))
#define IS_ACTIVI(i)     (b_flg_activ      & GEN_BM(i))
#define IS_ACTIVM(i)     (b_flg_activ      & (i))
#define IS_UMDF()        (b_u_mdf          & bpnfiles)

#define SET_MODIFYM(i)   b_flg_modify     |= (i)
#define SET_MODIFYI(i)   SET_MODIFYM(GEN_BM(i))
#define SET_MODIFY()     SET_MODIFYM(bpnfiles),b_flg_as |= bpnfiles
#define SET_VONLYM(i)    b_flg_vonly      |= (i)
#define SET_LOAD()       b_flg_load       |= bpnfiles
#define SET_CREATM(i)    b_flg_creat      |= (i)
#define SET_ACTIV()      b_flg_activ      |= bpnfiles
#define SET_UMDF()       b_u_mdf          |= bpnfiles

#define UNSET_MODIFY()   b_flg_modify &= ~bpnfiles
#define UNSET_ASMODF()   b_flg_as         &= ~bpnfiles
#define UNSET_MODIFYI(i) b_flg_modify     &= ~GEN_BM(i)
#define UNSET_CREAT()    b_flg_creat      &= ~bpnfiles
#define UNSET_LOAD()     b_flg_load       &= ~bpnfiles
#define UNSET_ACTIV()    b_flg_activ       =  0
#define UNSET_UMDF()     b_u_mdf          &= ~bpnfiles
#define UNSET_VONLY()    b_flg_vonly      &= ~bpnfiles

#define IS_DSKM(i)       (indsk & (i))
#define IS_DSK()         IS_DSKM(bpnfiles)
#define UNSET_DSK()      indsk &= ~bpnfiles

static const char brk_win[] = "X";



static const EF fun_edit[];
static const short code[128];

static const unsigned char rus_code[94] = {
  '', '/', '$', ':', '.', '', '?', '%', ';', '+', '', '-', '', '',
  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
  '', '', '', '=', '', '', '"',
  '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '', '', '', '', '', '\\', '',
  ',', '_', ')',
  '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '', '', '', '', '', '|', '', '('
};

static const unsigned char rus_latc[] = {
  '"', '/', '$', ':', '.', '\'', '?', '%', ';', '+', ',', '-', '.', '/',
  '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
  ';', ';', '<', '=', '>', '?', '"',
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
  'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']',
  ',', '_', ')',
  'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
  'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '|', ']'
};

unsigned char alt_code[62]={
'','','','','','','','','','','','','','','','','',
'','','','','','','','','','[','\\',']',',','_','`','','',
'','','','','','','','','','','','','','','','','',
'','','','','','','','{','|','}','~'};

enum Pstr25
{                          /*      */
  MAIN_SS, REPEAT_SS, VSTR_OPT_SS, WAIT_ESC_SS,
  VSTR_SS, VSTR_NH_SS, ESC_SS, K_PREF_SS,
  OPEN_SS, OPTS_SS, FIND_SS, CHG_PARM_SS,
  GLOB_SS, HLP_SS, YES_NO_SS, WAIT_SS,
  HIST_SS, GLINE_SS, MACRO_SS, CHGW_SS,
  LEX_FIND_SS, MENU_SS,
  MOVEWB_SS, ERD_SS, ERD_SS1,
};


static void wbmove (void);              /*   */
static void er_dic (void);              /*   -  */
static void gen_name_bak (void);        /*   bak- */

#define set_max_min_syh(a)
#define set_m2_syh(mi,ma)


/*    color */

#define BLACK  0
#define BLUE  1
#define GREEN  2
#define CYAN  3
#define RED  4
#define MAGENTA  5
#define BROWN  6
#define LIGHTGRAY  7
#define DARKGRAY  8
#define LIGHTBLUE  9
#define LIGHTGREEN 10
#define LIGHTCYAN 11
#define LIGHTRED 12
#define LIGHTMAGENTA 13
#define YELLOW 14
#define WHITE 15

#define COLOR0F  7
#define COLOR0B  0
#define COLOR1F 14
#define COLOR1B  1
#define COLOR2F 12
#define COLOR2B  3
#define COLOR3F 10
#define COLOR3B  1
#define COLOR4F 15
#define COLOR4B  0
#define COLOR5F 15
#define COLOR5B  5
#define COLOR6F 15
#define COLOR6B  1
#define COLOR7F 12
#define COLOR7B  1
#define COLOR8F  1
#define COLOR8B  7
#define COLOR9F 12
#define COLOR9B  7
#define COLOR10F  0
#define COLOR10B  7
#define COLOR11F 10
#define COLOR11B  1
#define COLOR12F 15
#define COLOR12B  3
#define COLOR13F  1
#define COLOR13B  7
#define COLOR14F  0
#define COLOR14B  7
#define COLOR15F 15
#define COLOR15B  7
#define COLOR16F  1
#define COLOR16B  7
#define COLOR17F 15
#define COLOR17B  3
#define COLOR18F  1
#define COLOR18B  2
#define COLOR19F 15
#define COLOR19B  3
#define COLOR20F 14
#define COLOR20B  1
#define COLOR21F  1
#define COLOR21B  7
#define COLOR22F 15
#define COLOR22B  2
#define COLOR23F  0
#define COLOR23B  2
#define COLOR24F  4
#define COLOR24B  7
#define COLOR25F 12
#define COLOR25B  2
#define COLOR26F 12
#define COLOR26B  3
#define COLOR27F  0
#define COLOR27B  3
#define COLOR28F  0
#define COLOR28B  2
#define COLOR29F  1
#define COLOR29B  3
#define COLOR30F 15
#define COLOR30B  2
#define COLOR31F  9
#define COLOR31B  2
#define COLOR32F 12
#define COLOR32B  1
#define COLOR33F 15
#define COLOR33B  7
#define COLOR34F 12
#define COLOR34B  7
#define COLOR35F 10
#define COLOR35B  1
#define COLOR36F  1
#define COLOR36B  3
#define COLOR37F  7
#define COLOR37B  4
#define COLOR38F 14
#define COLOR38B  3
#define COLOR39F 15
#define COLOR39B  5
#define COLOR40F  3
#define COLOR40B  5
#define COLOR41F  4
#define COLOR41B  7
#define COLOR42F 12
#define COLOR42B  0
#define COLOR43F 15
#define COLOR43B  1
#define COLOR44F 10
#define COLOR44B  1
#define COLOR45F 12
#define COLOR45B  7
#define COLOR46F  0
#define COLOR46B  7
#define COLOR47F  0
#define COLOR47B  2
#define COLOR48F  8
#define COLOR48B  0
#define COLOR49F  9
#define COLOR50F  2

static stdcall2 int get_vstr (char *, unsigned int, int);

	/*   get_vstr */
				/*  */
#define FIND_VSTR   1
#define FILE_VSTR   2
#define CALC_VSTR   4
#define REPL_VSTR   8
#define SHELL_VSTR  16
#define MAN_VSTR    32

#define NDES        64                  /*    */
#define RIGH_WORD  128                  /*    -> */

#define TAB_RET     256                 /*   <Tab> */
#define NO_GetKey   512                 /*     */
			/*   inhis */
#define H_VSTR          (FIND_VSTR|FILE_VSTR|SHELL_VSTR|CALC_VSTR|REPL_VSTR|MAN_VSTR)
#define TOHISTORY   0                   /*    */
#define INHISTORY   1024                /*      */

#define VSTR_RWB    2048                /*     */
	/*       buff_altk */
#define DOWN2_VSTR  8192    /*       2  */

static stdcall2 void inhis (char *, int);

struct RESOURSE_BOX
{
  unsigned int flg;
  const char *info;
};

	/*  */
#define RESB_TITLE     256
#define RESB_COLOR     512
#define RESB_SHDWN     1024
#define RESB_DWN_SHDWN 2048
#define RESB_NO_REPOS  4096
#define RESB_REPEAT    8192
#define RESB_COLOR_END 16384
#define RESB_END       32768

static stdcall2 void put_sbox (const struct RESOURSE_BOX *);

/*     */
/*  */
static stdcall2 int main_prenos (const char *, int);
/*     */
static stdcall2 void toup_glb (char *);

static const unsigned char ru_up_code[] = {
  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14,
  15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
  ' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+',
  ',', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':',
  ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
  'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
  'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'A', 'B', 'C', 'D', 'E', 'F', 'G',
  'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V',
  'W', 'X', 'Y', 'Z', '{', '|', '}', '~',
  127, 128, 129, 130, 131, 132, 133,
  134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148,
  149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 128, 129, 130, 131,
  132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 176, 177, 178,
  179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 199, 191, 224, 225,
  226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238, 239, 240,
  241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253, 254, 255,
  224, 225, 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238,
  239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251, 252, 253,
  254, 255
};


static stdcall2 int conv_low_rus (int c);    /*    */

#define conv_up_rus(s) ru_up_code[(int)(unsigned char)(s)]    /*     */

static stdcall2 void all_free (stf);
static stdcall2 stf find_head (long);
static stdcall2 void freemems (stf);
static stf memstf (void);               /*     stf */

static stdcall2 void sfree (stf);       /*     */
static stdcall2 void memstr (const char *, stf);

static stdcall2 void pswapnstr (int);
static void gswapnstr (void);

		/*   UNDO */
#define MASK_USZ     0300
#define UNDO_SZ_B    0100               /*   undo  */
#define UNDO_SZ_SHRT 0200
#define UNDO_SZ_LONG 0
#define UNDO_SZ_0    0300

#define UNDO_LINK    0100               /*   */

enum UNDO_OP
{
  UC_BEG_Y = 1, UC_BEG_X, UC_END_X, UC_END_Y,
  UC_TYPEB,

  UC_NSP, UC_PXS, UC_FVB, UC_INSERT,

  UC_DELLINE, UC_DELLINE0,

  UC_DELUPCUR,

  UC_INS_CR,

  UC_KQBS1, UC_KQBS2, UC_KQBS3, UC_KQBS4, UC_KQBS5, UC_KQBS6,
  UC_KQBS7, UC_KQBS8, UC_KQBS9, UC_KQBS10,

  UC_KQBP1, UC_KQBP2, UC_KQBP3, UC_KQBP4, UC_KQBP5, UC_KQBP6,
  UC_KQBP7, UC_KQBP8, UC_KQBP9, UC_KQBP10,

  UC_CH_CHAR, UC_INS_CHAR, UC_PAST, UC_PAST2,

  UC_FUM
};

#define U_BLK 1024

static stdcall2 void write_b_u (const char *, int);

static void save_u_context (void);
static void put_u_context (void);
static void u_del_file (void);
static stdcall2 void u_comm_dl (char *, int);   /*   */
static void put_all_context (void);
static void save_glob_context (void);

static stdcall2 int utell (int);
static stdcall2 void putdelta (const void *, int);

static const char DSKFILE[] = ".ocx_dsk";

static const char OK[] = " Ok ";
static const char sYes[] = "Yes";
static const char sNo[] = "No";
static const char SNULL[] = "";
static const char MFILE[] = "File";
static const char MfILEl[] = "file";
static const char SAVE[] = "Save ?";
static const char SAVING[] = "Saving";
static const char MODIFYED[] = "modifyed";
static const char baf_on_off[2][10] = { "(N)Off", "(Y)On. " };
static const char af_on_off[2][6] = { "Off.", "On. " };
static const char P3_d[] = "%3d";
static const char sBlk[] = "Block";
static const char cant_create[] = "Can`t create";
static const char can_t_open[] = "Can`t open";

/* s_auto_save[N_F_A_S]++="autosave.0" */
static const char s_auto_save_st[] = "autosave./";

static const char pstr1[] = "0-9 Number Key Repeat\01function Esc Quit";
static const char pstr2[] =
  "Tab Opt v History Ctrl-F5\01^v Move Alt-A Table\01ASCII";
static const char pstr3[] = "\01<Esc> Cansel \01\01\01\01\01\01Wait";
static const char pstr4[] =
  "^v<Enter> Replace Y Insert\01to\01dict N Skip <Esc> Cansel";
static const char * const pstr25[] = {
  "F1 Help F2 Save F3 Open F6 Macros F10 Menu Alt-X Exit",
  pstr1,
  pstr2,
  pstr3,
  &pstr2[8],
  &pstr2[18],
  &pstr1[31],
  "+-*/= Calc B Begin K End C Copy V Move Y Delete",
  "1-9 Switch\01win ^v<Enter> Open Esc Cansel Delete Free\01window",
  "Y On N Off Space Change Tab Choose",
  "F Find A Replace 0-9 Go\01to\01saved\01position",
  "^v<Tab><Space> Change",
  "^v><Symbol Move <Enter> Coose <Tab> Name/mask Esc Cansel",
  "^\01v\01PageUp\01PageDown\01 View\01 Esc\01 Exit",
  "\01Y Yes N No <Esc> Cansel",
  &pstr3[14],
  "^\01v Choose Ctrl-Y Delete <Enter> Use <Esc> Cansel",
  "^v<> Drow. Alt-R Del. Alt-V One. Alt-W Two. Alt-M Move <Esc> Exit",
  " Saving\01macros F6 stop",
  pstr4,
  &pstr4[18],
  "^v<> Choose <Enter> Go <Esc> Cansel",
  "v^ Move <Enter> Fixing",
  "<Enter> Insert",
  "v^ View <Esc> Exit",
};

static void
handler_alarm (int ns)
{
  (void)&ns;
  bb_signal((1 << SIGALRM), handler_alarm);
  ta++;
  alarm (1);
}

static stdcall2 void
set_alarm (long t_start)
{
  if (!flg_alarm_initted) {
	handler_alarm(SIGALRM);
	flg_alarm_initted++;
  }
  ta = t_start;
}

#define get_alarm() ta

static void
unset_alarm (void)
{
  if (flg_alarm_initted) {
	alarm (0);
	bb_signal((1 << SIGALRM), SIG_IGN);
	flg_alarm_initted = 0;
  }
}

/* Cache swaper. 20.11.96 (C) DZO */

/* str_r_ioc     '\0'     */

#define USE_W   0x80000000
#define XNBUFF  0x7fffffff              /* max 2 Gb */


static char *read_cache (void);
static stdcall2 void save_buff (int, int);
static stdcall2 void load_buff (int, int);
static char *write_cache (void);

static char *
write_cache (void)
{
  int Stat, j;
  int nseek;
  nseek = (int) (seek_io >> SHBIT);
  j = nseek & (NBUFF_CACHE - 1);
  Stat = status[j];
  if ((Stat & XNBUFF) != nseek) {
	if ((Stat & USE_W) != 0)
	  save_buff (Stat & XNBUFF, j);
	status[j] = nseek;
	load_buff (nseek, j);
  }
  nblk_w = seek_io & (BUFF_SIZE - 1);
  status[j] |= USE_W;
  return &buff_cache[j][nblk_w];
}

static char *
read_cache (void)
{
  int Stat, j;
  int nseek;

  nseek = (int) (seek_io >> SHBIT);
  j = nseek & (NBUFF_CACHE - 1);
  Stat = status[j];
  if ((Stat & XNBUFF) != nseek) {
	if ((Stat & USE_W) != 0)
	  save_buff (Stat & XNBUFF, j);
	status[j] = nseek;
	load_buff (nseek, j);
  }
  nblk_w = seek_io & (BUFF_SIZE - 1);
  return &buff_cache[j][nblk_w];
}

static stdcall2 void
load_buff (int nblock, int nbuff)
{
  if ((((long) nblock) << SHBIT) > size_swap)
	return;
  if (sav_seek != nblock) {
	lseek (fd_swap, ((long) nblock) << SHBIT, 0);
	sav_seek = nblock;
  }
  while (read (fd_swap, buff_cache[nbuff], BUFF_SIZE) == -1)
	diskerror ();
  sav_seek++;
}

static stdcall2 void
save_buff (int nblock, int nbuff)
{
  if (sav_seek != nblock) {
	lseek (fd_swap, ((long) nblock) << SHBIT, 0);
	sav_seek = nblock;
  }
  while (write (fd_swap, buff_cache[nbuff], BUFF_SIZE) == -1)
	diskerror ();
  sav_seek++;
}

	/* global interface */

static void
str_r_ioc (void)
{
  char *s = gets_text;
  char *n;
  int c;
  do {
	n = read_cache ();
	do {
	  c = *n++;
	  seek_io++;
	  nblk_w++;
	  *s++ = c;
	} while (c != 0 && nblk_w != BUFF_SIZE);
  } while (c != 0);
}

static internal_function void
write_cb (const void *sb, int nb)
{
  char *n;
  const char *s = sb;
  if (nb <= 0)
	return;
  do {
	n = write_cache ();
	do {
	  *n++ = *s++;
	  ++seek_io;
	  nblk_w++;
	  nb--;
	} while (nb > 0 && nblk_w != BUFF_SIZE);
  } while (nb > 0);
}

static stdcall2 void
read_cb (void *sb, int nb)
{
  char *n;
  char *s = sb;
  do {
	n = read_cache ();
	do {
	  seek_io++;
	  nblk_w++;
	  *s++ = *n++;
	  nb--;
	} while (nb > 0 && nblk_w != BUFF_SIZE);
  } while (nb > 0);
}

			/*   */
static void put_xbuff (void *, long, int);


static void init_c_main (void)
{
  int i;

  get_terminal_width_height(&WXsize, &SIZE_W);
  SIZE_W -= 3;
  if(SIZE_W<21 || SIZE_W>(MAX_WY-3) || WXsize<80 || WXsize>MAX_WX) {
	bb_error_msg_and_die("Can`t running witch current TIOCGWINSZ=%dx%d", WXsize, SIZE_W);
  }
  fd_swap = bb_xopen (swap_file, O_RDWR | O_CREAT | O_TRUNC | BB_OPEN_ERR, 0644);
  for (i = 0; i < NBUFF_CACHE; i++)
	status[i] = i;
  for (i = 0; i < NUM_BUFF_HIS; i++) {
	put_buff_swap (i);
	if (i == HELP_BUFF)
	  memset (shelp, 0, sizeof (shelp));
  }
  put_scr_buff_swap ();
  put_xbuff (buf_scr, OFF_0 + SIZ_OFF_1, SIZ_OFF_2);
  put_xbuff (buf_scr, OFF_0 + SIZ_OFF_1 + SIZ_OFF_2, SIZ_OFF_3);
}

static stdcall2 int
ifg (const char *s)
{
  int c, i;

  for (i = 0; (c = *s) != 0; i++, s++)
	if (c == '*' || c == '?' || c == '[')
	  return i;
  return -1;
}

		/*   conio */
/* (C) DZO */


static stdcall2 unsigned int get_ca (int, int);
static stdcall2 void putch_a_coo (int, int, int);

static internal_function void
write_err (const char *s)
{
  write (2, s, strlen (s));
}

#define INFO_VC 4


/* "" */
static stdcall2 void
setoverscan (int colorn)
{
  int save_x = cur_x, save_y = cur_y;
  textabk (COLOR11F, COLOR11B, 1);
  ogotoxy (78, 1);
  oputch (colorn);
  cur_x = save_x;
  cur_y = save_y;
}

static void
beep (void)
{
  if (vtisthis (0))
	write_err ("\007");
}

static void
set_offs_sn (void)
{
  offs_sn = dp + ((cur_y * WXsize + cur_x) << 1);
  if (min_y_wbs > cur_y)
	min_y_wbs = cur_y;
  if (max_y_wbs < cur_y)
	max_y_wbs = cur_y;
}

static stdcall2 void
putch_next (char c)
{
  *offs_sn++ = c;
  *offs_sn++ = cur_attr;
  cur_x++;
}

static stdcall2 void
oputch (char c)
{
  int offs;
  offs = (cur_y * WXsize + cur_x) << 1;
  *(dp + offs) = c;
  *(dp + offs + 1) = cur_attr;
  cur_x++;
  if (min_y_wbs > cur_y)
	min_y_wbs = cur_y;
  if (max_y_wbs < cur_y)
	max_y_wbs = cur_y;
}

static stdcall2 void
ocputs (const char *s)
{
  set_offs_sn ();
  while (*s)
	putch_next (*s++);
}

static stdcall2 unsigned int
get_ca (int posx, int posy)
{
  unsigned offs, ca;
  offs = (posy * WXsize + posx) << 1;
  ca = *(dp + offs);
  ca |= (*(dp + offs + 1)) << 8;
  return (ca);
}

static stdcall2 void
putch_a_coo (int c, int x, int y)
{
  int offs;
  offs = (y * WXsize + x) << 1;
  *(dp + offs) = c;
  *(dp + offs + 1) = c >> 8;
}

static stdcall2 void
cset_atr (int n, int color)
{
  int offs;

  offs = (cur_y * WXsize + cur_x) << 1;
  while (n-- > 0) {
	*(dp + offs + 1) = color;
	offs += 2;
  }
  if (min_y_wbs > cur_y)
	min_y_wbs = cur_y;
  if (max_y_wbs < cur_y)
	max_y_wbs = cur_y;
}

static stdcall2 void
get2_box (int x1, int x2, int Y1, int y2, void *bv)
{
  int j;
  unsigned short *buff = (unsigned short *) bv;

  *buff = x1;
  buff++;
  *buff = x2;
  buff++;
  *buff = Y1;
  buff++;
  *buff = y2;
  buff++;

  Y1--;
  while (--y2 >= 0) {
	for (j = 0; j < x2; j++) {
	  *buff = get_ca (j - 1 + x1, Y1);
	  buff++;
	}
	Y1++;
  }
}

static stdcall2 void
restore_box (int x1, int x2, int Y1, int y2, const void *bv)
{
  int j;
  const unsigned short *buff = (const unsigned short *) bv;

  Y1--;
  if (min_y_wbs > Y1)
	min_y_wbs = Y1;
  if (max_y_wbs < (Y1 + y2))
	max_y_wbs = Y1 + y2;
  while (--y2 >= 0) {
	for (j = 0; j < x2; j++)
	  putch_a_coo (*buff++, j - 1 + x1, Y1);
	Y1++;
  }
}

static stdcall2 void
restore2_box (const void *bv)
{
  const unsigned short *buff = (const unsigned short *) bv;

  restore_box (*buff, *(buff + 1), *(buff + 2), *(buff + 3), buff + 4);
}

static void
oclrscr (void)
{
  int i;
  int ca = ' ' | (cur_attr << 8);

  for (cur_y = 0; cur_y < END_W; cur_y++)
	for (i = WXsize - 1; i >= 0; i--)
	  putch_a_coo (ca, i, cur_y);
  min_y_wbs = 0;
  max_y_wbs = END_W - 1;
  ogotoxy (1, 1);
  toclrscr ();
}

static stdcall2 void
cursor (int typ)
{
  if (typ_cursor_save == typ)
	return;
  {
	int sx, sy, sa;
	sx = cur_x;
	sy = cur_y;
	sa = cur_attr;

	textabk (COLOR11F, COLOR11B, 1);
	ogotoxy (79, 1);
	if (typ == NORMCURSOR)
	  oputch ('I');
	else if (typ == FULLCURSOR)
	  oputch ('C');
	ogotoxy (sx + 1, sy + 1);
	tcursorvisible (typ != NOCURSOR);
	cur_attr = sa;
  }
  typ_cursor_save = typ;
}

static void
settss (void)
{
  t0w = 0;
  time (&timess);
  if (tas == 0)
	tas = timess;
  set_alarm (timess);
}

/*    1  */
static int read1s(void)
{
	struct timeval tv;
	fd_set readfds;

	tv.tv_sec = 1;
	tv.tv_usec = 0;
	FD_ZERO (&readfds);
	FD_SET (0, &readfds);
	return select (1, &readfds, NULL, NULL, &tv);
}

static stdcall2 void
put_time (int flg_delay)
{
  long t0a;
  int sav_x = cur_x;
  int sav_y = cur_y;
  int sav_c = cur_attr;

  if (re_reset == 0)
	return;
  t0a = get_alarm ();
  if (t0a != t0w) {
	struct tm *t;
	char tim_s_buf[16];

	t0w = t0a;
	textabk (COLOR43F, COLOR43B, 0);
	ogotoxy (67, 1);
	t = localtime (&t0w);
	sprintf (tim_s_buf, " %02d:%02d:%02d ", t->tm_hour, t->tm_min, t->tm_sec);
	ocputs (tim_s_buf);
	cur_x = sav_x;
	cur_y = sav_y;
	cur_attr = sav_c;
	t_fflush ();
  }
  if (flg_delay > 0) {
	read1s();
	if (flg_as_on != 0 && (t0a - tas) > timesasstart) {
		tas = t0a;
		sav_c = typ_cursor_save;
		autosave ();
		cur_x = sav_x;
		cur_y = sav_y;
		cursor (sav_c);
	}
  }
}

		/*      Esc */
static int
test_input (void)
{
  int c;
  if (kbhit ()) {
	if (t0w)
	  timess = t0w;
	c = getch ();
	if (c == '\033') {
	  c = read1s();
	  if (c) {
		while (kbhit ())
		  getch ();
		put_time (-1);
		return 1;
	  } else
		return 0;
	} else {
	  if (c == 0)
		getch ();
	  return 2;
	}
  }
  put_time (-1);
  return 1;
}

static stdcall2 void
dec_str (long i)
{
  long int r;
  i++;
  if ((r = i / 10) != 0)
	dec_str (r - 1);
  putch_next ((i % 10) + '0');
}

static void
t_fflush (void)
{
  if (max_y_wbs >= 0 && vtisthis (1)) {
	update_display ();
	min_y_wbs = 1000;
	max_y_wbs = -1;
  }
}

static stdcall2 void
ocputs2n (const char *s)
{
  ocputsn (s);
  cset_atr (2, DARKGRAY);               /* 2  */
}

static stdcall2 void
ocputs3n (const char *s)
{
  int x;
  int xs;

  xs = cur_x;
  ocputs2n (s);
  cur_y++;
  x = cur_x;
  cur_x = xs + 2;
  cset_atr (x - xs, DARKGRAY);  /*  */
}

/* (C) DZO */

static stdcall2 void
toup_glb (char *s)
{

  while (*s) {
	*s = conv_up_rus(*s);
	s++;
  }
}

#define G  1          /*  */
#define S  2          /*  */
#define NO 4          /*        */
#define IDA (NO|8)    /*      */

static const unsigned char ascess_key[] = {
  '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', ''
};

static const unsigned char UP_ascess_key[] = {
  '', '', '', '', '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', ''
};

static stdcall2 int
conv_low_rus (int c)
{
  size_t i;
  unsigned char s = c;

  if (s >= 'A' && s <= 'Z')
	s |= 040;
   else
	for (i = 0; i < (sizeof (ascess_key)); i++)
		if (s == UP_ascess_key[i]) {
		  s = ascess_key[i];
		  break;
		}
  return s;
}

static stdcall2 int up_codep (int c)
{
	static const char rus_glasn[] = "ѣ";
	static const char rus_soglashn[] = "";

	c = conv_low_rus(c);
	if((c >= '0' && c <= '9') || c == '_' || (c >= 'a' && c <= 'z'))
		return IDA;
	if(c == 0)
		return NO;
	if(strchr(rus_glasn, c))
		return G;
	if(strchr(rus_soglashn, c))
		return S;
	return NO;
}

static stdcall2 int
chk_g_s (int s)
{
  return (up_codep(s) & (G | S | NO));
}

/*  / ? */
static stdcall2 int
chk_c_id (int s, int flg_no_rus)
{
  int uc = up_codep(s);

  if (flg_no_rus == 0)
	return (uc & ~NO);
  else
	return ((uc & IDA) == IDA) || (flg_no_rus == '.' && s == '.');
}

static stdcall2 int
chk_gs_ost (unsigned char s)
{
  if (s == ((unsigned char) '') || s == ((unsigned char) '') ||
	  s == ((unsigned char) '') || s == ((unsigned char) '') ||
	  s == ((unsigned char) '') || s == ((unsigned char) ''))
	return NO;
  return chk_g_s (s);
}

static stdcall2 int
perenos (const unsigned char *s)
{
  int n;
  int i = 0;

  while (chk_g_s (*s) == G) {
	i++;
	s++;
  }
  if (chk_g_s (*s) == NO)
	return 0;
  n = i;
no_f1:
  while (chk_g_s (*s) == S) {
	i++;
	s++;
  }
  if (n && chk_gs_ost (*(s - 1)) != NO)
	if ((i - n) > 1)
	  goto fg;
  if (chk_g_s (*s) == NO)
	return 0;
  s++;
  i++;
  if (chk_g_s (*s) == NO)
	return 0;
sgs:
  if (chk_g_s (*s) == G) {
	while (chk_g_s (*(s + 1)) == G) {
	  s++;
	  i++;
	}
	n = 0;
	while (chk_g_s (*s) != NO)
	  n |= chk_gs_ost (*s++);
	if ((n & (G | S)) != (G | S))
	  return 0;
	return i;
  }
  if (chk_gs_ost (*s) == NO && chk_g_s (*s) != NO) {
	i++;
	s++;
	goto sgs;
  }
  while (chk_g_s (*s) == S) {
	i++;
	s++;
  }
fg:
  if (chk_g_s (*s) == NO)
	return 0;
  s--;
  n = 0;
  if (chk_gs_ost (*s) == NO) {
	i--;
	goto no_f1;
  }
  while (chk_g_s (*s) != NO)
	n |= chk_gs_ost (*s++);
  if ((n & (G | S)) != (G | S))
	return 0;
  return i - 1;
}

static stdcall2 int
main_prenos (const char *ss, int space)
{
  int i, si, new_i;
  int save_i, save_si;
  const unsigned char *s = (const unsigned char *)ss;

  i = save_i = si = save_si = 0;

  for (;;) {
	while (chk_g_s (*s) == NO && *s != 0) {
	  si++;
	  s++;
	}
	if (*s == 0)
	  return (save_i + save_si);
	for (;;) {
	  new_i = perenos (s + i);
	  if (new_i != 0) {
		i += new_i;
		if ((i + si + 1) > space)
		  return (save_i + save_si);
		save_i = i;
		save_si = si;
		continue;
	  } else {
		while (chk_g_s (*s) != NO) {
		  s++;
		  si++;
		}
		i = 0;
		break;
	  }
	}
  }
}


 /*
  *   stdio.h
  */

/*      + : dzO.
	    eda  -1.2, (C)  .. */


static void
diskerror (void)
{
  int ab = 0;
  flg_view_mod = 1;
  psav = 0;
  win_0e (ERROR, "Error input/putput", WB_STD | W_N_IC);
  for (;;) {
	switch (button2 (ab, "Retry", "Exit", 30)) {
	case 2:
	  if (ab == 1)
		old_set (1);
	  restore_wb ();
	  return;
	default:
	  ab = !ab;
	  continue;
	}
  }
}

static stdcall2 void
ofputs (const char *str)
{
  while (*str) {
	if (ocnt++ >= (SIZEBISIO + MLS))
	  oputc (*str);
	else
	  *(optr)++ = (unsigned char)*str;
	str++;
  }
}

static stdcall2 int
ofopen (const char *nm, int r)
{
  if (r == IOR) {
	if ((ochan = open (nm, O_RDONLY, 0)) == -1)
	  return 0;
	oflag = _IOREAD | _IOOPEN;
  } else {                                              /* "w" IOW */
	if ((ochan = open (nm, O_WRONLY | O_CREAT | O_TRUNC, 0644)) == -1)
	  return 0;
	oflag = _IOWRITE | _IOOPEN;
	optr = (unsigned char *)obuf;
  }
  ocnt = 0;
  return 1;
}


static stdcall2 int
open_raw (const char *nm, int r)
{
  if (r == IOR) {
	if ((ochan = open (nm, O_RDONLY, 0)) == -1)
	  return 0;
  } else {                                              /* "w" IOW */
	if ((ochan = open (nm, O_WRONLY | O_CREAT | O_TRUNC, 0644)) == -1)
	  return 0;
  }
  return 1;
}

static int
write_raw (void *p, int siz)
{
  if (write (ochan, p, siz) != siz) {
	close (ochan);
	siz = 1;
  } else
	siz = 0;
  return siz;
}

static int
read_raw (void *p, int siz)
{
  if (read (ochan, p, siz) != siz) {
	close (ochan);
	siz = 1;
  } else
	siz = 0;
  return siz;
}

static void
close_raw (void)
{
  close (ochan);
}

static void
ofclose (void)
{
  if (oflag != 0) {
	if ((oflag & _IOWRITE) && ocnt) {
	  while (write (ochan, obuf, ocnt) == -1)
		diskerror ();
	}
	if (oflag & _IOOPEN)
	  close (ochan);
  }
  oflag = 0;
}

static int
ogetc (void)
{
recr:
  if (ocnt <= 0) {
	if (oflag & _IOEOF)
	  return (EOF);
	put_time (-1);
	optr = (unsigned char *)obuf;
	while ((ocnt = read (ochan, obuf, SIZEBISIO)) < 0)
	  diskerror ();
	if (ocnt < SIZEBISIO)
	  oflag |= _IOEOF;
	goto recr;
  }
  ocnt--;
  return (*optr++);
}

static stdcall2 void
oputc (int ch)
{
  if (ocnt++ >= (SIZEBISIO + MLS)) {
	put_time (-1);
	if (oflag == 0)
	  while (ofopen (form_file, IOW) == 0)
		diskerror ();
	while (write (ochan, obuf, (SIZEBISIO + MLS)) == -1)
	  diskerror ();
	optr = (unsigned char *)obuf;
	ocnt = 1;
  }
  *(optr)++ = ch;
}


static void
qcopen (void)
{
  if (oflag == 0) {                             /*  */
	optr = (unsigned char *)obuf;
	oflag = _IOREAD | _IOEOF;
  } else {
	ofclose ();
	ofopen (form_file, IOR);
  }
}

static const char *
find_fhead (int i)
{
  if (i > nfile)
	return SNULL;
  else
	return globbuf.gl_pathv[i];
}

static int view_list (void);


static int
scan_glob (char *name)
{
  char *gname = get_str;
  int i;
  char tmps[MLS];

rescan:
  /*      */
  while (*gname == ' ')
	memmove (gname, gname + 1, strlen(gname + 1) + 1);
  if (ifg (gname) == -1)
	return 1;                       /*   */
  inhis (gname, TOHISTORY | FILE_VSTR); /*   */
  view25 (WAIT_SS);
  strcpy (tmps, gname);

  put_scr_buff_swap ();
  get2_box (13, 56, 2, 23, &buf_scr[0][0]);
  nfile = -1;
  if (glob (get_str, GLOB_BRACE | GLOB_TILDE, NULL, &globbuf) == 0) {
	for (; globbuf.gl_pathv[nfile + 1]; nfile++);
  }
  if (nfile >= 0) {
	i = view_list ();
	globfree (&globbuf);
	restore2_box (&buf_scr[0][0]);
	get_scr_buff_swap ();
	i = (i == 1 ? 0 : i == 2 ? 2 : 3);
  } else
	i = 1;
  if ((i & 1) != 0) {
	if (i == 1) {
	  view_flstr (tmps);
	  win_err ("Files", "not found", WB_SFS2 | W_8);
	  flg_ex_macro = 0;
	}
	return 0;
  }
  strcpy (name, get_str);
  if (!i)
	return 1;
  goto rescan;
}


static void
find_astr (int cur, int *x)
{
  int i, xnc = *x;
  strcpy (get_str, find_fhead (cur));
  for (i = 0; i <= xnc; i++)
	if (strncmp (str_rez, get_str, i + 1))
	  break;
  str_rez[i] = 0;
  *x = i - 1;
}


static const char upvsbox0[] = "$T ";

static const struct RESOURSE_BOX upvsbox[] = {
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR33F, COLOR33B, 0), "["},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR11F, COLOR33B, 0), brk_win},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR33F, COLOR33B, 0), "]$."},
  {RESB_COLOR | RESB_NO_REPOS | RESB_TITLE | gencolor (COLOR34F, COLOR34B, 1),
   "List files"},
  {RESB_COLOR | gencolor (COLOR33F, COLOR33B, 0), "$6"},
  {RESB_SHDWN, "$5 Quick find$5 "},
  {RESB_SHDWN, "\032$S "},
  {RESB_SHDWN | RESB_REPEAT | 18, upvsbox0},
  {RESB_DWN_SHDWN | RESB_END, "$T"},
};

static int
view_list (void)
{
  int i;
  int Top, cur;
  int j, xnc = -1;
  int pvf, Pos_val_file;

  str_rez[0] = 0;
  Pos_val_file = -2;
  ogotoxy (13, 2);
  put_sbox (upvsbox);
  ogotoxy (66, 6);
  scroller (14);
  Top = 0;
  cur = 0;
re_all:
  for (i = 0; i < 17; i++) {
	ogotoxy (15, 6 + i);
	textabk (COLOR38F, COLOR38B, 0);
	view_lstr (find_fhead (Top + i), 1);
  }
re0:
  view25 (GLOB_SS);
re:
  pvf = mathscrollbar ((long) cur, 14, (long) nfile);
  if (Pos_val_file != pvf) {
	cur_x = 65;
	if (Pos_val_file != -2) {
	  cur_y = Pos_val_file + 6;
	  oputch (Pos_val_file == -1 ? '^' : Pos_val_file == 14 ? 'V' : '');
	  cur_x--;
	}
	cur_y = pvf + 6;
	textabk (COLOR7F, COLOR7B, 1);
	oputch (TERM_CR);
	Pos_val_file = pvf;
  }
  ogotoxy (15, 4);
  textabk (COLOR44F, COLOR44B, 1);
  view_lstr (str_rez, 1);
  i = strlen (str_rez);
  if (i > 50)
	i = 50;
  ogotoxy (15 + i, 4);
  cset_atrD (1, COLOR5F, COLOR5B, 0);
  ogotoxy (15, 6 + (cur - Top));
  strcpy (get_str, find_fhead (cur));
  textabk (COLOR39F, COLOR39B, 1);
  view_lstr (get_str, 1);
  i = get_key ();
  cur_x = 14;
  textabk (COLOR38F, COLOR38B, 0);
  view_lstr (get_str, 1);
  switch (i) {
  case UP_KEY:
	if (!cur)
	  goto re;
	cur--;
	find_astr (cur, &xnc);
	i = Top;
	if ((cur - Top) < 0)
	  Top--;
	break;
  case DOWN_KEY:
	if (cur == nfile)
	  goto re;
	cur++;
	find_astr (cur, &xnc);
	i = Top;
	if ((cur - Top) >= 17)
	  Top++;
	break;
  case PUP_KEY:
	if (cur >= 17)
	  cur -= 17;
	else
	  cur = 0;
	find_astr (cur, &xnc);
	i = Top;
	if (Top >= 17)
	  Top -= 17;
	else
	  Top = 0;
	break;
  case PDOWN_KEY:
	if ((cur += 17) > nfile)
	  cur = nfile;
	find_astr (cur, &xnc);
	i = Top;
	if ((Top + 17) > nfile)
	  while ((cur - Top) >= 17)
		Top++;
	else
	  Top += 17;
	break;
  case TOP_KEY:
	cur = 0;
	find_astr (cur, &xnc);
	i = Top;
	Top = 0;
	break;
  case BOTTOM_KEY:
	cur = nfile;
	find_astr (cur, &xnc);
	i = Top;
	while ((cur - Top) >= 17)
	  Top++;
	break;
  case ESC_KEY:
	view25 (MAIN_SS);
	return -1;
  case LEFT_KEY:
  case DELETE_KEY:
	i = Top;
	if (xnc >= 0) {
	  str_rez[xnc] = 0;
	  xnc--;
	  if (xnc >= 0) {
		for (j = cur; j >= 0; j--) {
		  strcpy (get_str, find_fhead (j));
		  if (strncmp (str_rez, get_str, xnc + 1))
			break;
		}
		j++;
	  } else
		j = 0;
	  while (cur > j) {
		cur--;
		if ((cur - Top) < 0)
		  Top--;
	  }
	}
	break;
  case CR_KEY:
	if (get_str[strlen (get_str) - 1] == SLASHC) {
	  strcpy (str_rez, str1cat (get_str, '*'));
	  goto re_gvstr;
	}
	view25 (MAIN_SS);
	return 1;
  case TAB_KEY:
re_gvstr:
	wb_miny = &view_list_sav_ywb;
	win_0e (NULL, "Name/mask", WIN_E_OK);
	i = get_vstr (str_rez, FILE_VSTR | VSTR_RWB, 0);
	if (i == ESC_KEY) {
	  strcpy (str_rez, find_fhead (cur));
	  xnc = strlen (str_rez) - 1;
	  goto re0;
	}
	strcpy (get_str, str_rez);
	return 2;
  case RIGHT_KEY:
	if (((int) strlen (get_str)) > xnc) {
	  j = cur;
	  i = get_str[xnc + 1];
	  goto rfound;
	} else
	  goto re;
  default:
	if (i > 0 && i < 256) {
	  for (j = cur; j <= nfile; j++) {
		strcpy (get_str, find_fhead (j));
		if (xnc >= 0 && strncmp (str_rez, get_str, xnc + 1))
		  break;
		if (((int) strlen (get_str)) > xnc && get_str[xnc + 1] == i) {
rfound:
		  xnc++;
		  str1cat (str_rez, i);
		  i = 0;
		  break;
		}
	  }
	  if (i == 0) {
		i = Top;
		while (cur < j) {
		  cur++;
		  if ((cur - Top) >= 17)
			Top++;
		}
		break;
	  }
	}
	i = Top;
	break;
  }
  if (i == Top)
	goto re;
  else
	goto re_all;
}

/*
	    desktop
*/

static const char ver_DSK[] = "#Oex_dAV\n";

struct OE_CONTEXT
{
  void *pval;
  int sizv;
};

static const struct OE_CONTEXT oe_context[] = {
    { (void *)ver_DSK, sizeof(ver_DSK) },
    { &line_str_a,     sizeof(line_str_a) },
    { &tn_f,           sizeof(tn_f) },
    { &tn_a,           sizeof(tn_a) },
    { &flg_avt_form,   sizeof(flg_avt_form) },
    { &flg_mperenos,   sizeof(flg_mperenos) },
    { &find_f_b,       sizeof(find_f_b) },
    { &posid,          sizeof(posid) },
    { &flg_rcase,      sizeof(flg_rcase) },
    { &wwo,            sizeof(wwo) },
    { &flg_F6,         sizeof(flg_F6) },
    { &timessstart,    sizeof(timessstart) },
    { &user_tab,       sizeof(user_tab) },
    { &timesasstart,   sizeof(timesasstart) }
};

#define SIZE_CNTX 14

static stdcall2 int
putgetstrdsk (char *s)
{
  int (*fun_pg) (void *, int);
  int l;

  fun_pg = flg_save_as ? write_raw : read_raw;

  l = strlen (s) + 1;
  if ((*fun_pg) (&l, sizeof (int)))
	return 1;
  if ((*fun_pg) (s, l))
	return 1;
  return 0;
}

static int
putgetdsk (void)
{
  int i, l;
  int (*fun_pg) (void *, int);

  fun_pg = flg_save_as ? write_raw : read_raw;
  for (i = flg_save_as == 0; i < SIZE_CNTX; i++)
	if ((*fun_pg) (oe_context[i].pval, oe_context[i].sizv))
	  return 1;
  for (i = 0; i <= flg_F6; i++) {
	if (putgetstrdsk (files_st[i].filesav))
	  return 1;
	if ((*fun_pg) (&files_st[i].f_pos_cur_y, sizeof (files_st[0].f_pos_cur_y)))
	  return 1;
	if ((*fun_pg) (&files_st[i].f_nstr_pos, sizeof (files_st[0].f_nstr_pos)))
	  return 1;
	if ((*fun_pg) (&files_st[i].f_posx_str, sizeof (files_st[0].f_posx_str)))
	  return 1;
	if ((*fun_pg) (&files_st[i].nstr_file, sizeof (files_st[0].nstr_file)))
	  return 1;
	if ((*fun_pg) (&files_st[i].blk.beg_y, sizeof (struct BUFF_BLK)))
	  return 1;
	if ((*fun_pg) (&files_st[i].skqbsp, sizeof (files_st[0].skqbsp)))
	  return 1;
	if ((*fun_pg) (&files_st[i].flg_s, sizeof (files_st[0].flg_s)))
	  return 1;
  }
  for (i = 0; i < 4; i++) {
	for (l = 0; l < MACMAX && macrox[i][l] != -1; l++);
	l++;
	if ((*fun_pg) (&l, sizeof (int)))
	  return 1;
	if ((*fun_pg) (macrox[i], l * sizeof (macrox[0][0])))
	  return 1;
  }
  for (l = FIRST_HIS; l <= END_HIS; l++) {
	if (flg_save_as != 0)
	  get_buff_swap (l);
	for (i = 0; i < NHIS; i++)
	  if (putgetstrdsk (buff_history (i)))
		return 1;
	if (flg_save_as == 0)
	  put_buff_swap (l);
  }
  if (flg_save_as != 0)
	get_buff_swap (CALC_BUFF);
  for (i = 0; i <= posid; i++) {
	if (putgetstrdsk (identf[i].name))
	  return 1;
	if ((*fun_pg) (&identf[i].val, sizeof (identf[0].val)))
	  return 1;
  }
  if (flg_save_as == 0)
	put_buff_swap (CALC_BUFF);
  if (putgetstrdsk (str_find))
	return 1;
  return putgetstrdsk (BLKF);
}

static void
save_dsk (int actf, int flg_scip_noname)
{
  int i;

  if (open_raw (DSKFILE, IOW) == 0) {
err_dsk:
	win_err ("Can`t saving", "desktop", 0);
	unlink (DSKFILE);
	return;
  }
  flg_F6 = nfiles;
  for (i = 0; i <= flg_F6; i++)
	if (files_st[i].filesav[0] == 0) {
	  if (flg_scip_noname) {
		memcpy (&files_st[i], &files_st[i + 1],
				(NFILES - 1 - i) * sizeof (struct FILES_ST));
		files_st[NFILES - 1].filesav[0] = 0;
		flg_F6--;
		if (actf > i || actf > flg_F6)
		  actf--;
		i--;
	  } else
		files_st[i].flg_s |= FLG_NONAME;
	}
  if (actf >= 0)
	files_st[actf].flg_s |= FLG_ACTIV;
  flg_save_as = 1;
  i = putgetdsk ();
  flg_save_as--;
  close_raw ();
  if (i)
	goto err_dsk;
}

static int
get_dsk (void)
{
  int i;

  if (open_raw (DSKFILE, IOR) == 0)
	return -1;
  flg_no_sd = 1;
  if (read_raw (get_str, sizeof (ver_DSK)))
	goto err_dsk;
  if (strcmp (get_str, ver_DSK)) {
err_dsk:
	win_err ("Bad", "desktop", 0);
	memset (files_st, 0, sizeof (files_st));
	nfiles = -1;
  } else {
	if (putgetdsk ())
	  goto err_dsk;
	for (i = 0; i < NFILES; i++)
	  if ((files_st[i].flg_s & FLG_ACTIV) != 0) {
		files_st[i].flg_s &= ~FLG_ACTIV;
		close_raw ();
		return i;
	  }
  }
  close_raw ();
  return -1;
}

static stdcall2 void find (int);

	/*   */
static stdcall2 void rev_str (const char *, char *);
/*    s1  s2 -    s1,  -1 */
static stdcall2 int nstrstr (char *);


static stdcall2 void
rev_str (const char *str1, char *strr)
{
  int l = strlen (str1);
  while (l)
	*strr++ = str1[--l];
  *strr = '\0';
}

static void
set_cur_revv (int flg_vrv)
{
  if (pos_cur_y <= 13)
	*wb_miny = 18 - (14 - pos_cur_y);
  else
	*wb_miny = 9 + pos_cur_y - 15;
  cset_atrD (flg_vrv, COLOR30F, COLOR30B, 1);
}

/*    s1  s2 -    s1,  -1 */
static stdcall2 int
nstrstr (char *s1)
{
  char *s2 = str_rez;
  int i, j;

  i = 0;
refind_str:
  while (*s1 != *s2 && *s1 != '\0') {
	i++;
	s1++;
  }
  if (*s1 == '\0')
	return -1;
  for (j = 1; s2[j] != '\0'; j++) {
	if (s1[j] != s2[j]) {
	  s1++;
	  i++;
	  goto refind_str;
	}
  }
  return (i);
}

static stdcall2 void
find (int flg_refind)
{
  int i, j;
  stf st_st;
  int x, y;
  long lj;

  if (!flg_refind) {
	i = get_word (str_find, 0);
refindw:
	j = win_find0 (i);
	if (j == ESC_KEY || (flg_replace != 0 && !strcmp (str_replace, str_find)))
	  goto brkfind;
	if (wwo) {
	  str_rez[0] = 0;
	  get_word2 (str_rez, str_find, 0, 0);
	  if (strcmp (str_find, str_rez)) {
		view_flstr (str_find);
		win_err ("String to find", "not word", WB_SFS2 | W_8);
		goto refindw;
	  }
	}
  }
  i = strlen (str_find);
  if (!i) {
brkfind:
	flg_replace = 0;
brkfinda:
	flg_ex_macro = 0;
retfind2:
	flg_F6 = 0;
retfind:
	if (flg_F6 == 0)
	  view25 (MAIN_SS);
	return;
  }
  view25 (WAIT_ESC_SS);
  x = posx_str;
  y = pos_cur_y;
  if (find_f_b)
	rev_str (str_find, str_rez);
  else
	strcpy (str_rez, str_find);
  if (flg_rcase)
	toup_glb (str_rez);
  if (!find_f_b) {
	int ll;
sf:
	ll = lline (y);
	if (ll > x) {
	  memcpy (get_str, &buf_scr[y][x], ll - x);
	  get_str[ll - x] = 0;
	  if (flg_rcase)
		toup_glb (get_str);
	  ll = 0;
no_wwo:
	  if ((j = nstrstr (&get_str[ll])) >= 0) {
		if (wwo) {
		  int lw;
		  str_all_tmp[0] = 0;
		  lw = get_word2 (str_all_tmp, &get_str[ll], j, 0);
		  if (strcmp (str_rez, str_all_tmp)) {
			ll += lw;
			goto no_wwo;
		  }
		}
		j += x + i + ll;
		lj = nstr_pos + y - pos_cur_y;
		while (lj != nstr_pos)
		  down ();
found_set:
		if (recolumn (j))
		  posrev ();
		goto found_str;
	  }
	}
	y++;
	if ((nstr_pos + y - pos_cur_y) > bb_nstr_file)
	  goto not_found;
	x = 0;
	if (y < SIZE_W)
	  goto sf;
	lj = nstr_pos + y - pos_cur_y;
	if (lj > bb_nstr_file)
	  goto not_found;
	st_st = find_head (lj);
	for (; lj <= bb_nstr_file; lj++) {
	  if (!test_input ())
		goto brkfinda;
	  get_str[g_lline (st_st)] = 0;
	  if (flg_rcase)
		toup_glb (get_str);
	  y = 0;
no_wwo1:
	  if ((x = nstrstr (&get_str[y])) >= 0) {
		if (wwo) {
		  int lw;
		  str_all_tmp[0] = 0;
		  lw = get_word2 (str_all_tmp, &get_str[y], x, 0);
		  if (!strcmp (str_rez, str_all_tmp))
			goto found1;
		  y += lw;
		  goto no_wwo1;
		} else {
found1:
		  x += y;
		  goto found;
		}
	  }
	  st_st = st_st->over;
	}
	goto not_found;

  } else {
	int ll;
bwf:
	ll = lline (y);
	if (x > ll)
	  x = ll;
	memcpy (get_str, buf_scr[y], x);
	get_str[x] = 0;
	rev_str (get_str, gets_text);
	if (flg_rcase)
	  toup_glb (gets_text);
	ll = 0;
no_wwo2:
	if ((j = nstrstr (&gets_text[ll])) >= 0) {
	  if (wwo) {
		int lw;
		str_all_tmp[0] = 0;
		lw = get_word2 (str_all_tmp, &gets_text[ll], j, 0);
		if (strcmp (str_rez, str_all_tmp)) {
		  ll += lw;
		  goto no_wwo2;
		}
	  }
	  lj = nstr_pos + y - pos_cur_y;
	  up_d (nstr_pos - lj);
	  posrev ();
	  j = x - j - ll;
	  goto found_set;
	}
	y--;
	x = (MLS - 1);
	if (y >= 0)
	  goto bwf;
	for (lj = nstr_pos + y - pos_cur_y; lj >= 0; lj--) {
	  if (!test_input ())
		goto brkfinda;
	  get_str[ll = g_lline (find_head (lj))] = 0;
	  rev_str (get_str, gets_text);
	  if (flg_rcase)
		toup_glb (gets_text);
	  y = 0;
no_wwo3:
	  if ((x = nstrstr (&gets_text[y])) >= 0) {
		if (wwo) {
		  int lw;
		  str_all_tmp[0] = 0;
		  lw = get_word2 (str_all_tmp, &gets_text[y], x, 0);
		  if (!strcmp (str_rez, str_all_tmp))
			goto wwo3;
		  y += lw;
		  goto no_wwo3;
		} else {
wwo3:
		  x = ll - x - y;
		  goto found;
		}
	  }
	}
  }
not_found:
  view_pos ();
  if (flg_F6 != 0)                              /*      */
	goto retfind2;
  view_flstr (str_find);
  win_1e ("Find", "String", NOFOUND, WIN_E_PSAK | WB_SFS2 | W_8);
  goto brkfinda;
found:                                                  /*      */
  if (!find_f_b)
	x += i;
  recolumn (x);
  set_nl (lj, REVIEW);
found_str:                                              /*     */
  /*  */
  if ((pos_cur_x - i) < 0) {
	ogotoxy (2, pos_cur_y + 2);
	cset_atrD (pos_cur_x, COLOR40F, COLOR40B, 1);
  } else {
	ogotoxy (pos_cur_x - i + 2, pos_cur_y + 2);
	cset_atrD (i, COLOR40F, COLOR40B, 1);
  }
  if (find_f_b) {
	if (recolumn (posx_str - i)) {
	  posrev ();
	  poscur ();
	  for (j = 0; j < i && cur_x < (WXsize - 2); j++) {
		cset_atrD (1, COLOR40F, COLOR40B, 1);
		cur_x++;
	  }
	}
	poscur ();
  }
  put_u_context ();
  view_pos ();
  if (flg_replace) {
	if (no_ask == 0) {
	  wb_miny = &y;
	  set_cur_revv (0);
	  view_flstr (str_replace[0] != 0 ? (const char *)str_replace : "   ");
	  win_1e ("Find and replace",
			  str_replace[0] != 0 ? "Replace to" : "Remove ?",
			  sESC, WB_SFS2 | W_8);
	  view25 (YES_NO_SS);
	  x = 0;
	  j = button3 (&x, sYes, sNo, "All ", 84 | 512);
	  switch (j) {
	  case -1:
	  case 0:
	  case 1:
		break;
	  case ASCII_KEY:
		x = 2;
		/* no break */
	  default:
		j = x != 1;
		if (x == 2) {
		  no_ask++;
		  flg_repl_all = 1;
		}
	  }
	  restore_wb ();
	} else
	  j = 1;
	if (j >= 0 && flg_repl_all)
	  flg_F6 = 1;
	if (j > 0) {
	  insert++;
	  if (find_f_b) {
		if (recolumn (posx_str + i))
		  posrev ();
		put_u_context ();
	  }
	  deleten (i);
	  posrev ();
	  for (i = 0; str_replace[i]; i++)
		u_edc (str_replace[i]);
	  if (find_f_b) {
		if (recolumn (posx_str - i))
		  posrev ();
	  }
	  insert--;
	  put_u_context ();
	} else if (j < 0) {
	  flg_ex_macro = 0;
	  flg_F6 = 0;
	} else
	  posrev ();
	view_pos ();
  }
  flg_ex_macro |= EFOUND;
  goto retfind;
}

static void
find_f (void)
{
  flg_replace = 0;
  flg_F6 = 0;   /*         */
  find (0);
}

static stdcall2 void
loopfind (int Flg_replace)
{
  flg_F6 = 0;
  find (Flg_replace);
  while (flg_F6 != 0 && flg_repl_all) {
	find (1);
	put_u_context ();
  }
  no_ask = flg_repl_all = 0;
}

static void
find_a (void)
{
  flg_replace = 1;
  loopfind (0);
}

static void
refind (void)
{
  loopfind (1);
}

static void
find_z (void)
{                        /*   */
  int c, cok;
  int t = 1, c2 = 0, x, y;
  long lj;

  c = buf_scr[pos_cur_y][posx_str];
  switch (c) {
  case '(':
	c2 = ')';
	break;
  case ')':
	c2 = '(';
	t++;
	break;
  case '{':
	c2 = '}';
	break;
  case '}':
	c2 = '{';
	t++;
	break;
  case '[':
	c2 = ']';
	break;
  case ']':
	c2 = '[';
	t++;
	break;
  }
  if (fun_arg != FIND_Z) {
	fun_arg = c2;
	return;
  }
  if (c2 == 0) {
	win_err ("Possible chars", "()[]{}", 0);
	return;
  }
  x = posx_str;
  y = pos_cur_y;
  lj = nstr_pos;
  if (t == 1) {                                 /*    */
	stf st_st;
	x++;
forwf:
	for (cok = x; cok < MLS; cok++) {
	  if (buf_scr[y][cok] == c)
		t++;
	  else if (buf_scr[y][cok] == c2)
		t--;
	  if (t == 0)
		goto found;
	}
	lj++;
	if (lj > bb_nstr_file)
	  goto not_found;
	x = 0;
	y++;
	if (y < SIZE_W)
	  goto forwf;
	view25 (WAIT_ESC_SS);
	st_st = find_head (lj);
	for (; lj <= bb_nstr_file; lj++) {
	  if (!test_input ())
		goto brkfind;
	  g_space (st_st);
	  for (cok = 0; cok < MLS; cok++) {
		if (get_str[cok] == c)
		  t++;
		else if (get_str[cok] == c2)
		  t--;
		if (t == 0)
		  goto found;
	  }
	  st_st = st_st->over;
	}
	goto not_found;
  } else {                                              /*    */
	t--;
	x--;
bwf:
	for (cok = x; cok >= 0; cok--) {
	  if (buf_scr[y][cok] == c)
		t++;
	  else if (buf_scr[y][cok] == c2)
		t--;
	  if (t == 0)
		goto found;
	}
	y--;
	lj--;
	x = (MLS - 1);
	if (y >= 0)
	  goto bwf;
	view25 (WAIT_ESC_SS);
	for (; lj >= 0; lj--) {
	  if (!test_input ())
		goto brkfind;
	  for (cok = g_lline (find_head (lj)); cok >= 0; cok--) {
		if (get_str[cok] == c)
		  t++;
		else if (get_str[cok] == c2)
		  t--;
		if (t == 0)
		  goto found;
	  }
	}
  }
not_found:
  view_pos ();
  win_err ("Matching parentheses", NOFOUND, 0);
brkfind:
  flg_ex_macro = 0;
  goto ret;
found:
  recolumn (cok);
  set_nl (lj, REVIEW);
ret:
  view25 (MAIN_SS);
}


#define flg_flush flg_F6

static void flbuf_f (void);
static stdcall2 void main_format (int);
static void word_f (void);
static void form_home0 (void);

static void
centr_right_str (void)
{
  int j = 0, l;
  l = lline (pos_cur_y);
  if (!l) {
nocentr:
	flg_ex_macro = 0;
	return;
  }
  while (buf_scr[pos_cur_y][j] == ' ')
	j++;
  l -= j;
  if (l > line_str_a)
	goto nocentr;
  strcpy (str_rez, &buf_scr[pos_cur_y][j]);
  j = (line_str_a - l) >> (fun_arg - RIGHT_STR);
  flg_view_mod = 0;
  u_end_line ();
  deleten (posx_str);
  while (j > 0) {
	u_edc (' ');
	j--;
  }
  while (l) {
	u_edc (str_rez[j++]);
	l--;
  }
  flg_view_mod++;
  posrev ();
}

static void
chget (int ns)
{               /*        */
  stf cur;

  if (eds[ns] != 0) {
	memcpy (get_str, buf_scr[ns], MLS);
	reconv_space ();
	/*     y  str */
	cur = find_head (nstr_pos - pos_cur_y + ns);
	sfree (cur);
	memstr (get_str, cur);
  }
}


static void
copy_scr (void)
{               /*        */
  int k;
  long j;

  j = nstr_pos - pos_cur_y;
  for (k = 0; j <= bb_nstr_file && k < SIZE_W; k++, j++) {
	chget (k);
	eds[k] = 0;
  }
}

static void
formator (void)
{
  int j;
  long abz_beg_line, li;

  li = nstr_pos;
  copy_scr ();
  getstext (find_head (li));
  if (gets_text[0] == '\0') {
	flg_ex_macro = 0;
	return;
  }
  view25 (WAIT_SS);
  flg_view_mod = 0;
  for (;;) {
	if (gets_text[0] == '\0') {
	  li++;
	  getstext (find_head (li));
	  break;
	}
	if (!li)
	  break;
	if (gets_text[0] == '\t' || gets_text[0] == ' ') {
	  if (!tn_a)
		break;
	  g_space_f ();
	  for (j = 0; get_str[j] == ' '; j++);
	  if ((tn_f >= 0 && j > tn_a) || (tn_f < 0 && j < tn_a))
		break;
	} else if ((tn_f >= 0 && tn_a < 0) || (tn_f < 0 && tn_a > 0))
	  break;
	li--;
	getstext (find_head (li));
  }
  abz_beg_line = li;
  optr = (unsigned char *)obuf;
  ocnt = 0;
  for (;;) {
	j = 0;
	while (gets_text[j] == '\t' || gets_text[j] == ' ')
	  j++;
	ofputs (&gets_text[j]);
	oputc ('\n');
	li++;
	if (li > bb_nstr_file)
	  break;
	getstext (find_head (li));
	if (gets_text[0] == '\0')
	  break;
	if (gets_text[0] == '\t' || gets_text[0] == ' ') {
	  if (!tn_a)
		break;
	  g_space_f ();
	  for (j = 0; get_str[j] == ' '; j++);
	  if ((tn_f >= 0 && j > tn_a) || (tn_f < 0 && j < tn_a))
		break;
	} else if ((tn_f >= 0 && tn_a < 0) || (tn_f < 0 && tn_a > 0))
	  break;
  }
  qcopen ();
  up_d (nstr_pos - abz_beg_line);
  li--;
  for (; abz_beg_line < li; abz_beg_line++)
	del_line ();
  end_line ();
  put_u_context ();
  deleten (posx_str);
  insert++;
  put_u_context ();
  main_format (tn_f);
  insert--;
  ofclose ();
  flg_view_mod++;
  posrev ();
  view25 (MAIN_SS);
}

static void
avt_form (void)
{
  int flg_ao, save_px;

  flg_view_mod = 0;
  optr = (unsigned char *)obuf;
  flg_ao = ocnt = 0;
  while (buf_scr[pos_cur_y][flg_ao] == ' ')
	flg_ao++;
  if ((tn_f >= 0 && flg_ao > tn_a) || (tn_f < 0 && flg_ao < tn_a))
	flg_ao = tn_f;
  else
	flg_ao = 0;
  ofputs (buf_scr[pos_cur_y]);
  oputc ('\n');
  qcopen ();
  u_end_line ();
  save_px = posx_str;
  deleten (posx_str);
  insert++;
  put_u_context ();
  main_format (flg_ao);
  if (posx_str == save_px) {
	cr ();
	form_home0 ();
	while (posx_str != tn_a)
	  u_edc (' ');
  }
  insert--;
  put_u_context ();
  oflag = 0;
  flg_view_mod++;
  posrev ();
  view25 (MAIN_SS);
}

static void
form_text (void)
{
  int fem = flg_ex_macro;
  view25 (WAIT_ESC_SS);
  flg_ex_macro |= EFORMT;
  do {
	formator ();
	if (flg_ex_macro) {
	  down ();
	  home ();
	  put_u_context ();
	} else {
	  flg_ex_macro = fem;
	  break;
	}
	view_pos ();
	if (test_input () == 0) {
	  flg_ex_macro = 0;
	  break;
	}
  } while (flg_ex_macro);
  view25 (MAIN_SS);
}

static void
form_blk (void)
{
  int i;
  if (!(i = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (i) {
	struct BUFF_BLK blk_sav;
	int tn_a_s_f_par = tn_a;
	int line_str_a_s_f_par = line_str_a;
	char si = insert;

	if (buff_blk->typeb != 2) {
	  win_err ("Formating only", "square-ware block", 0);
	  return;
	}
	i = buff_blk->end_x - buff_blk->beg_x;
	if (i < 6) {
	  win_err ("Small", "block witch", 0);
	  return;
	}
	line_str_a = i;
	flg_blk_form = buff_blk->beg_x;
	tn_a = 0;
	view25 (WAIT_SS);
	tmp_blk ();
	blk_sav = *buff_blk;
	insert = 0;
	blk_to_del (0);
	main_format (0);
	flg_blk_form = 0;
	ofclose ();
	insert = si;
	flg_view_mod++;
	flg_vb = 1;
	*buff_blk = blk_sav;
	tn_a = tn_a_s_f_par;
	line_str_a = line_str_a_s_f_par;
	put_u_context ();
  }
  posrev ();
  view25 (MAIN_SS);
}

static void
form_home0 (void)
{
  recolumn (flg_blk_form);
  put_u_context ();
}

static void
flbuf_f (void)
{
  if (!flg_flush) {
	int i;
	for (i = 0; get_str[i]; i++)
	  u_edc (get_str[i]);
	if (!flg_eof) {
	  cr ();
	  form_home0 ();
	  flg_flush++;
	}
  }
}

static stdcall2 void
main_format (int d1)
{
  int ns, j, i;
  char *pgstr;
  flg_flush = 1;
  flg_eof = 0;
  d1 += tn_a;

  word_f ();
  for (;;) {
	ns = 0;
	pgstr = get_str;
	for (i = 0; i < d1; i++)
	  *pgstr++ = ' ';
	d1 = tn_a;
	strcpy (pgstr, str_rez);
r1:
	flg_flush = 0;
	if (flg_eof) {
	  flbuf_f ();
	  return;
	}
	if ((int)strlen (get_str) >= line_str_a) {
	  word_f ();
	  i = flg_eof;
	  if (str_rez[0] != 0)
		flg_eof = 0;
	  flbuf_f ();
	  if (str_rez[0] == 0)
		return;
	  flg_eof = i;
	  continue;
	}
	word_f ();
	j = strlen (get_str);
	i = strlen (str_rez);
	if ((i + j + 1) <= line_str_a) {
	  if (i != 0) {
		strcat (str1cat (get_str, ' '), str_rez);
		ns++;
	  }
	  goto r1;
	}
	if (flg_mperenos) {
	  i = main_prenos (str_rez, line_str_a - j - 1);
	  if (i != 0) {
		strcat (str1cat (get_str, ' '), str_rez);
		j += i + 1;
		get_str[j] = 0;
		str1cat (get_str, '-');
		j++;
		memmove (str_rez, str_rez + i, strlen(str_rez + i) + 1);
		ns++;
	  }
	}
	if (!ns) {
	  flbuf_f ();
	  continue;
	} {
	  int ii;
	  i = line_str_a - j;
	  j = i / ns;
	  i = i % ns;
	  pgstr = get_str;
	  while (*pgstr == ' ') {
		u_edc (' ');
		pgstr++;
	  }
	  for (; *pgstr; pgstr++) {
		u_edc (*pgstr);
		if (*pgstr != ' ')
		  continue;
		for (ii = 0; ii < j; ii++)
		  u_edc (' ');
		if (i < ns)
		  i++;
		else
		  u_edc (' ');
	  }
	}
	cr ();
	form_home0 ();
  }
}

#define ungetc() ocnt++; optr--

static void
word_f (void)
{
  char *p;
  int c;
  p = str_rez;
  do {
	c = Qogetc ();
	if (c == EOF) {
	  flg_eof++;
	  goto r;
	}
  } while (c == ' ' || c == '\n' || c == '\t');
refor:
  ungetc ();
  for (;;) {
	c = Qogetc ();
	if (c == EOF) {
	  flg_eof++;
	  goto r;
	}
	if (c == ' ' || c == '\n' || c == '\t')
	  break;
	*p = (char) c;
	p++;
  }
  if (*(p - 1) == '-' && c == '\n' && p != &str_rez[1] && Qogetc () != EOF) {
	p--;                                            /*   */
	goto refor;
  }
r:
  *p = '\0';
}

static void
help_view (void)
{
  win_1e ("About", "Text editor for busybox", "(c) vodz 1992-2017", WIN_E_PSAK);
}


static void
top (void)
{
  set_nl (0l, REVIEW);
}

static void
bottom (void)
{
  copy_scr ();
  nstr_pos = bb_nstr_file;
  pos_cur_y = bb_nstr_file < (SIZE_W - 1) ? bb_nstr_file : (SIZE_W - 1);
  review_scr (REVIEW);
}

static void
btab (void)
{
  int bt;
  bt = posx_str - posx_str % user_tab;
  if (bt == posx_str)
	bt -= user_tab;
  if (bt < 0) {
	flg_ex_macro = 0;
	return;
  }
  while (bt > posx_str)
	left ();
}

static void
v_old_s (void)
{
}


static void
goto_line (void)
{
  int sav_ywb;
  long nl;

  wb_miny = &sav_ywb;
  set_cur_revv (1);
  win_0e ("Set", "Go to line", WIN_E_OK);
  sprintf (str_rez, "%ld", nstr_pos + 1);
  if (get_vstr (str_rez, VSTR_RWB, 0) != ESC_KEY) {
	nl = atol (str_rez) - 1;
	if (nl <= bb_nstr_file && nl >= 0)
	  set_nl (nl, REVIEW);
  }
  view_str (pos_cur_y);
}

static void
fun_save (void)
{
  save_all (ESC_KEY);
  flg_ex_macro = 0;
}

static void
ascii_view (void)
{
  int i =
	ascii_w (buf_scr[pos_cur_y][posx_str], pos_cur_x > (WXsize / 2 - 2));
  if (i <= 0) {
	flg_ex_macro = 0;
	view_str (pos_cur_y);
  } else
	u_edc (i);
}

static void
shell (void)
{
  old_set (-2);
  if (fork () == 0) {
	old_set_sig ();
	bb_error_msg ("***SHELL***");
	run_shell(NULL, NULL, NULL);
  }
  wait (NULL);
  scr_review ();
}

static void
shcom (void)
{
  wb_miny = &shcom_sav_ywb;
  win_0e ("SHELL", "Command", WIN_E_OK);
  get_buff_swap (SHELL_HIS);
  strcpy (get_str, buff_history (0));
  if (get_vstr (get_str, SHELL_VSTR | VSTR_RWB, 0) != ESC_KEY) {
	old_set (-2);
	if (fork () == 0) {
	  old_set_sig ();
	  bb_error_msg ("%s", get_str);
	  run_shell(NULL, get_str, NULL);
	}
	wait (NULL);
	reset (1);
  } else
	return;
  write_err (PSAK);
  reset (-1);
  any (0);
  scr_review ();
}

static void
gotox_pos (void)
{
  int pos;
  pos = fun_arg - GOTO0_KEY;
  if (kqbs[pos] < 0) {
	flg_ex_macro = 0;
	return;
  }
  if (kqbs[pos] > bb_nstr_file)
	kqbs[pos] = bb_nstr_file;
  recolumn (kqbp[pos]);
  set_nl (kqbs[pos], REVIEW);
}

static void
setx_pos (void)
{
  int i;
  i = fun_arg - SET0_KEY;
  kqbs[i] = nstr_pos;
  kqbp[i] = posx_str;
}

static void
open_fun (void)
{                                                               /*      */
  int nf;
  nf = pnfiles;
  if (++nf > nfiles)
	nf = 0;
  set_nfile (nf);
}

static void
delf_fun (void)
{                                                               /*   */
  int save_nfiles;
  save_nfiles = nfiles;
  del_file (pnfiles);
  if (save_nfiles == nfiles)
	return;
  if (nfiles < 0)
	load_file ();
  else
	set_nfile (pnfiles > nfiles ? nfiles : pnfiles);
}

static void
cr_ask (void)
{
  if (insert) {
	if (lline (pos_cur_y) > posx_str) {     /*  */
	  paste ();
	  return;
	}
	home ();
  }
  cr ();
}

static void
delupcur2 (void)
{
  if (insert) {
	if (lline (pos_cur_y) <= posx_str) {    /*  */
	  if (nstr_pos != bb_nstr_file)
		paste ();
	  else
		flg_ex_macro = 0;
	  return;
	}
  }
  if (!insert)
	delupcur (1);
  else
	spec_del (0);
}

static void
delete2 (void)
{
  if (!posx_str) {
	if (nstr_pos) {
	  up ();
	  u_end_line ();
	  if (insert)
		paste ();                               /*  */
	  return;
	}
	flg_ex_macro = 0;
	return;
  }
  left ();
  put_u_context ();
  if (!insert) {
	u_edc (' ');
	left ();
  } else
	spec_del (1);
}

static void
begmacro (void)
{                                                               /*      */
  if (flg_sav_macro == -1)
	begmacrox (0);
  else {
	macrox[nmacro][flg_sav_macro - 1] = -1;
	flg_sav_macro = -1;
	view25 (MAIN_SS);
  }
}

static void
addmacro (void)
{
  if (flg_sav_macro == -1)
	begmacrox (1);
  else {
	beep ();
	flg_sav_macro--;
  }
}

static void
delbeg (void)
{
  if (!posx_str)
	flg_ex_macro = 0;
  else
	deleten (posx_str);
}

static const char calc_tab_arg[] = "+-*/ ";

static void
calc (void)
{
  int i;
  int l;
  long j;
  int cc;

  cc = calc_tab_arg[fun_arg - CALC1_KEY];
  if (!test_blk (1))
	return;
  j = 0;
  str_rez[0] = '\0';
  while (blk_to_buff (j++, 1) == 1) {
	i = strlen (get_str);
	l = strlen (str_rez);
	if (i && j != 1) {
	  str1cat (str_rez, cc);
	  l++;
	}
	if (i && get_str[i - 1] == '\n')
	  get_str[--i] = '\0';
	if ((l + i) >= (MLS - 1)) {
	  win_err ("Big", "block", 0);
	  flg_ex_macro = 0;
	  return;
	}
	strcat (str_rez, get_str);
  }
  if (main_calc ()) {
	l = 0;
	i = strlen (str_rez);
revicalc:
	if (buf_scr[pos_cur_y][MLS - 2] == ' ' && i) {
	  u_edc (str_rez[l++]);
	  i--;
	  goto revicalc;
	}
	if (i)
	  beep ();
  }
}

static void
calcv (void)
{
  str_rez[0] = ' ';
  str_rez[1] = 0;
  view_flstr (str_rez);
  for (;;) {
	wb_miny = &calcv_sav_ywb;
	win_e ("Calculate", "Arithmetical expression", NULL, "Result",
		   WIN_E_OK | WB_SFS4 | W_9);
	get_buff_swap (CALC_HIS);
	strcpy (str_rez, buff_history (0));
	if (get_vstr (str_rez, CALC_VSTR | RIGH_WORD | VSTR_RWB,
				  get_word (str_rez, '.')) != ESC_KEY) {
	  if (main_calc () == 0) {
		str_rez[0] = ' ';
		str_rez[1] = 0;
	  }
	  view_flstr (str_rez);
	} else
	  break;
  }
}

static void
calt (void)
{
  flg_rus ^= ALT;
  setoverscan (flg_rus & ALT ? 'G' : flg_rus ? 'R' : 'L');
}

static void
crus_lat (void)
{
  flg_rus = (flg_rus ^ RUS) & ~ALT;
  setoverscan (flg_rus ? 'R' : 'L');
}

static void
cinsert (void)
{
  insert ^= 1;
}

static void
tab (void)
{
  tabx (user_tab);
}

static stdcall2 void
ocputsnt (const char *s)
{
  oputch (' ');
  ocputsn (s);
  putch_next (' ');
}

static stdcall2 void
ocputsn (const char *s)
{
  int c, i;
  set_offs_sn ();
  while ((c = *s) != 0) {
	if (c == '@')
	  ocputs (MfILEl);
	else if (c != '$')
	  putch_next (c);
	else {
	  s++;
	  i = (unsigned char)(*s++);    /* may be > 127 */
	  i -= ' ';
	  c = *s;
	  while (i--)
		putch_next (c);
	}
	s++;
  }
}

#define any_ret(arc) { c=(arc); goto ret; }

	/*    <Enter> <Esc> <Y> <N> <Tab> Alt-Y Alt-N <- -> */
static stdcall2 int
any (int t)
{
  int c;
  int sm;
  int flg_macro;

  flg_macro = flg_ex_macro;
  flg_ex_macro = 0;
  sm = flg_sav_macro;
  flg_sav_macro = -1;
  while (test_input () != 1);
reget:
  c = get_key ();
  switch (c) {
  case U_C (''):                               /* Alt-Y */
	c = 'y';
	break;
  case U_C (''):                               /* Alt-N */
	c = 'n';
	break;
  case LEFT_KEY:
	if ((t & 64) != 0)
	  goto ret;
	else
	  c = TAB_KEY;
	break;
  case RIGHT_KEY:
	c = TAB_KEY;
	break;
  case ASCII_KEY:
  case 'a':
  case 'A':
	if ((t & 512) != 0)
	  goto ret;
	goto reget;
  }
  if (!t)
	any_ret (0);
  if ((c == 'y' || c == 'Y') && (t & 8) == 0 && (t & 128) == 0)
	any_ret (1);
  if (c == CR_KEY)
	any_ret (2);
  if ((c == 'n' || c == 'N') && (t & 8) == 0)
	any_ret (0);
  if (c == TAB_KEY) {
	if ((t & 4) != 0)
	  any_ret ('\t');
  }
  if (c == ESC_KEY || c == DELF_FUN) {
	if ((t & 2) == 0)
	  any_ret (-1);
  }
  if ((t & 256) != 0) {
	if (c >= '0' && c <= '3')
	  goto ret;
	if (c == OPEN_KEY)
	  any_ret ('0');
	if (c >= SET_FILE1 && c <= SET_FILE3)
	  any_ret (c - SET_FILE1 + '1');
  }
  if (c == ' ')
	if ((t & 32) != 0)
	  goto ret;
  goto reget;
ret:
  if ((t & 16) == 0)
	restore_wb ();
  flg_sav_macro = sm;
  flg_ex_macro = flg_macro;
  return c;
}

static void
scroller (int n)
{
  textabk (COLOR6F, COLOR6B, 0);
  oputch ('^');
  cur_x--;
  cur_y++;
  while (n--) {
	oputch ('');
	cur_x--;
	cur_y++;
  }
  oputch ('V');
}

static void
load_list (const char *str)
{
  stf new_stf;

  new_stf = memstf ();
  new_stf->over = NULL;
  if (bb_nstr_file >= 0) {
	bottom_stf->over = new_stf;
	bottom_stf = new_stf;
  } else {
	save_stf_cur_list = stf0 = bottom_stf = new_stf;
	save_stf_cur_nstr = 0;
  }
  memstr (str, new_stf);
  bb_nstr_file++;
}

static void
del_list (long y)
{
  stf cur, next, under;

  if (!y)
	cur = stf0;
  else {
	under = find_head (y - 1);
	cur = under->over;
  }
  next = cur->over;
  sfree (cur);
  if (next == NULL)
	/*    ,   ,    */
	memstr (SNULL, cur);
  else {
	freemems (cur);
	if (!y) {
	  stf0 = next;
	  save_stf_cur_list = next;
	  save_stf_cur_nstr = 0;
	} else
	  under->over = next;
	bb_nstr_file--;
  }
}

static void
ins_list (long y)
{               /*      y */
  stf line_list, new_list;

  line_list = find_head (y);
  new_list = memstf ();
  new_list->over = line_list->over;
  line_list->over = new_list;
  memstr (SNULL, new_list);
  bb_nstr_file++;
}

		/*    ,  y */
static void
ins_dell_list (long y)
{
  stf line_list, new_list;

  new_list = memstf ();
  if (y) {
	line_list = find_head (y - 1);
	new_list->over = line_list->over;
	line_list->over = new_list;
  } else {
	new_list->over = stf0;
	stf0 = new_list;
	save_stf_cur_list = new_list;
	save_stf_cur_nstr = 0;
  }
  memstr (SNULL, new_list);
  bb_nstr_file++;
}

static int
loadfiles (char *names)
{
  int i;
  struct FILES_ST *ff;
  int nextf;
  uid_t uid;
  unsigned int mode;
  struct stat st_stat;

  nextf = 1 << (nfiles + 1);
  ff = &files_st[nfiles + 1];

reglob:
  if (*names == 0)
	goto set_noname;
  strcpy (get_str, names);
  if (!scan_glob (names))
	return -1;
  view_flstr (names);

  i = 0;
  if (stat (names, &st_stat) == -1) {
	if (names == s_auto_save)
	  return -1;
	if (names[strlen (names) - 1] == SLASHC) {
	  str1cat (names, '*');
	  goto reglob;
	}
set_noname:
	SET_CREATM (nextf);
	i = 1;
	st_stat.st_mtime = 0;
	goto rwopen;
  } else {
	mode = st_stat.st_mode;
	if ((mode & S_IFMT) != S_IFREG) {
	  if ((mode & S_IFMT) == S_IFDIR) {

		strcat (names, "/*");
		goto reglob;
	  }
errl:
	  win_err ("Can`t edit",
			   (i == 0 ? "Special file" : "Access rw denied"), WB_SFS2 | W_8);
	  return -1;
	}
	uid = getuid ();
	if (uid == st_stat.st_uid || uid == 0)
	  mode = (mode & 0700) >> 6;
	else if (getgid () == st_stat.st_gid)
	  mode = (mode & 070) >> 3;
	else
	  mode &= 07;
	if ((mode & AC) != AC && chmod (names, 0664) == -1) {
	  if (!ofopen (names, IOR)) {
		i++;
		goto errl;
	  } else {
		win_0e (SWARN, "View only", WIN_E_PSAK | WB_SFS2 | W_8);
		SET_VONLYM (nextf);
		goto rwopen;
	  }
	}
  }
  mode = st_stat.st_mode;               /*     */
  if (!i)
	ofopen (names, IOR);
rwopen:
  bb_nstr_file = -1;
  if (ff->filesav[0] == 0)
	strcpy (ff->filesav, names);    /* pasterecalc()  names */
  nfiles++;
  if (!i) {
	win_1e (NULL, "Loading", MFILE, WB_SFS3 | W_N_IC);
	t_fflush ();
	pasterecalc ();
	ofclose ();
	if (IS_MODIFYI (nfiles)) {
	  win_e (SWARN, "Breaked", "long lines", MFILE,
			 WIN_E_PSAK | WB_SFS4 | W_9);
	} else
	  restore_wb ();
	ff->mode = mode;
  } else {
	ff->mode = 0664;
  }
  load_list (SNULL);
  ff->nstr_file = bb_nstr_file;
  ff->mtime = st_stat.st_mtime;
  pswapnstr (nfiles);
  return 1;
}

static const struct RESOURSE_BOX box_load1[] = {
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR12F, COLOR12B, 0), "["},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR11F, COLOR12B, 0), brk_win,},
  {RESB_COLOR | gencolor (COLOR12F, COLOR12B, 0), "]$7 List @s $="},
  {RESB_SHDWN | RESB_REPEAT | NFILES, "$d "},
  {RESB_DWN_SHDWN | RESB_END, "$d"},
};

static const struct RESOURSE_BOX box_load2[] = {
  {RESB_COLOR | gencolor (COLOR15F, COLOR15B, 0) | RESB_NO_REPOS, SNULL},
  {RESB_REPEAT | NFILES | RESB_END, "$. "},
};

static int
ifactiv (void)
{                                                               /*     ? */
  int i, j;
  j = 1;
  for (i = 0; i <= nfiles; i++, j <<= 1) {
	if (IS_ACTIVM (j)) {
	  copy_scr ();
	  return j;
	}
  }
  return 0;
}

static void
load_file (void)
{
  int i;
  int p;
  int act_but;
  int max_act_but;

reload:
  if (ifactiv ())
	p = pnfiles;
  else
	p = 0;
reload2:
  act_but = 0;
  view25 (OPEN_SS);
  ogotoxy (5, 2);
  put_sbox (box_load1);
  for (i = 0; i < NFILES; i++) {
	cur_y = i + 2;
	if (i > (nfiles + 1))
	  cur_x = 6;
	else {
	  cur_x = 5;
	  oputch ('1' + i);
	}
	if (IS_OK_MODI (i)) {
	  textabk (COLOR4F, COLOR4B, 1);
	  oputch (TERM_CR2);
	} else
	  cur_x++;
	textabk (COLOR36F, COLOR36B, 0);
	view_lstr (files_st[i].filesav[0] == 0 && i <= nfiles ?
			   NONAME : (const char *)files_st[i].filesav, 1);
	textabk (COLOR12F, COLOR12B, 0);
  }
rev:
  ogotoxy (59, 3);
  put_sbox (box_load2);
  max_act_but = 0;
  if (p <= nfiles) {
	but1ysax (4, " Edit  ", 60, act_but == 0);
	max_act_but++;
  }
  if (nfiles != (NFILES - 1)) {
	but1ysax (6, " Open  ", 60, (act_but == 1 && p <= nfiles) ||
			  (act_but == 0 && p > nfiles));
	but1ysax (8, " New   ", 60, act_but == 2 || (act_but == 1 && p > nfiles));
	max_act_but++;
	max_act_but++;
  }
  if (p <= nfiles) {
	but1ysax (10, " Close ", 60,
			  act_but == 3 || (act_but == 1 && nfiles == (NFILES - 1)));
	max_act_but++;
  }
  ogotoxy (8, p + 3);
  cset_atrD (50, COLOR37F, COLOR37B, 1);
  i = get_key ();
  cset_atrD (50, COLOR36F, COLOR36B, 0);
  switch (i) {
  case '1':
  case '2':
  case '3':
  case '4':
  case '5':
  case '6':
  case '7':
  case '8':
  case '9':
  case SET_FILE1:
  case SET_FILE2:
  case SET_FILE3:
  case SET_FILE4:
  case SET_FILE5:
  case SET_FILE6:
  case SET_FILE7:
  case SET_FILE8:
  case SET_FILE9:
	if (i >= SET_FILE1)
	  i -= SET_FILE1;
	else
	  i -= '1';
	if ((nfiles + 1) >= i) {
	  if (p == i)
		goto comm_cr;
	  else
		p = i;
	}
	goto rev;
  case TAB_KEY:
	act_but++;
	if (act_but >= max_act_but)
	  act_but = 0;
	goto rev;
  case ESC_KEY:
	if (ifactiv ()) {
	  reset (0);
	  goto ret;
	}
	if (nfiles < 0)
	  goto comm_new;
	if (p <= nfiles)
	  goto comm_edit;
	goto rev;
  case 'c':
  case 'C':
  case U_C (''):                               /* Alt-C */
  case DELUPCUR:
comm_close:
	if (p > nfiles)
	  goto rev;
	del_file (p);
	if (p > nfiles && p == 0)
	  goto reload;
	if (p > nfiles)
	  p--;
	goto reload2;
  case UP_KEY:
	if (--p < 0)
	  p = nfiles < NFILES - 1 ? nfiles + 1 : NFILES - 1;
	act_but = 0;
	goto rev;
  case DOWN_KEY:
	if (++p > (nfiles + 1) || p == NFILES)
	  p = 0;
	act_but = 0;
	goto rev;
  case 'n':
  case 'N':
  case U_C (''):                               /* Alt-N */
comm_new:
	if (nfiles == (NFILES - 1))
	  goto rev;
	unload ();
	loadfiles ((char *) SNULL);
	set_nfile (nfiles);
	goto ret;
  case 'E':
  case 'e':
  case U_C (''):                               /* Alt-E */
	if (p > nfiles)
	  goto rev;
comm_edit:
	if (ifactiv () && pnfiles == p)
	  reset (0);
	else
	  set_nfile (p);
	goto ret;
  case CR_KEY:
comm_cr:
	switch (act_but) {
	case 0:
	  if (p <= nfiles)                      /* Edit */
		goto comm_edit;
	  goto comm_open;
	case 1:
	  if (p > nfiles)
		goto comm_new;
	  else if (nfiles == (NFILES - 1))
		goto comm_close;
	  else
		goto comm_open;
	case 2:
	  goto comm_new;
	default:
	  goto comm_close;
	}
  case U_C (''):                               /* Alt-O */
  case 'o':
  case 'O':
comm_open:
	if (nfiles == (NFILES - 1))
	  goto rev;
	while (p <= nfiles)
	  p++;
	wb_miny = &load_file_sav_ywb;
	win_0e ("Open", "Load/Create", WIN_E_OK);
	get_str[0] = '*';
	get_str[1] = 0;
	i = get_vstr (get_str, FILE_VSTR | VSTR_RWB, 0);
	if (i == ESC_KEY)
	  goto reload;
	if (!scan_glob (get_str))
	  goto reload;
	unload ();
	if (loadfiles (get_str) < 0)
	  goto reload;
	set_nfile (p);
	goto ret;
  default:
	goto rev;
  }
ret:
  ;
}

static void
chkmodf (void)
{
  int i;
  struct stat st_stat;

rescan:
  for (i = 0; i <= nfiles; i++) {
	strcpy (str_all_tmp, files_st[i].filesav);
	if (str_all_tmp[0] == 0)
	  continue;
	if (stat (str_all_tmp, &st_stat) != -1) {
	  if (files_st[i].mtime < st_stat.st_mtime) {
		set_nfile (i);
		view_flstr (str_all_tmp);
		win_e (SWARN, MFILE, MODIFYED, "Reload ?", WB_SFS2 | W_9 | W_N_IC);
		if (button2ny () > 0) {
		  UNSET_MODIFY ();
		  UNSET_LOAD ();
		  del_file (i);
		  loadfiles (str_all_tmp);
		  set_nfile (nfiles);
		  goto rescan;
		} else
		  files_st[i].mtime = st_stat.st_mtime;
	  }
	}
  }
}


	/*    */
static stdcall2 void ocputsc (const char *);
	/*      */
static stdcall2 void edc_avt_form (int);
	/*  Ctrl-K-x  Ctrl-Q-x */
static stdcall2 int decode_key (int);
	/*   autosave.X  dsk  */
static stdcall2 int load_dsk_as (int);


	/*   */

static stdcall2 int
recolumn (int j)
{                       /*     X */
  int sc = column;
  if (j < 0)
	j = 0;
  if (j > (MLS - 1))
	j = (MLS - 1);
  posx_str = pos_cur_x = j;
  column = 0;
  while (pos_cur_x >= (WXsize - 4)) {
	column += 8;
	pos_cur_x -= 8;
  }
  return (sc != column);
}

static int
re2column (int j)
{                       /*    X */
  int sc = column;
  int delta;

  if (j < 0)
	j = 0;
  if (j > (MLS - 1))
	j = (MLS - 1);
  delta = posx_str - j;
  posx_str = j;
  pos_cur_x -= delta;
  while (pos_cur_x >= (WXsize - 2)) {
	column++;
	pos_cur_x--;
  }
  while (pos_cur_x < 0 && column > 0) {
	column--;
	pos_cur_x++;
  }
  return (sc != column);
}

/*   ,       */
static void
view_pos (void)
{
  int pvf;
  if (flg_view_mod) {
	textabk (COLOR6F, COLOR6B, 0);
	ogotoxy (3, SIZE_W + 2);
	set_offs_sn ();
	putch_next (' ');
	textabk (COLOR4F, COLOR4B, 1);
	putch_next (IS_OK_MOD ()? TERM_CR2 : ' ');
	textabk (COLOR6F, COLOR6B, 0);
	putch_next (' ');
	textabk (COLOR3F, COLOR3B, 0);
	/* ocputs(vfmtmsgb("%d-%d:%d", nstr_file+1,nstr_pos+1,posx_str+1)); */
	dec_str (bb_nstr_file);
	putch_next ('-');
	dec_str (nstr_pos);
	putch_next (':');
	dec_str ((long) posx_str);
	textabk (COLOR6F, COLOR6B, 0);
	putch_next (' ');
	while (cur_x < 23)
	  putch_next ('');
  }
  pvf = mathscrollbar (nstr_pos, SIZE_W - 2, bb_nstr_file);
  if (pos_val_file != pvf) {
	if (pos_val_file != -2) {
	  ogotoxy (WXsize, pos_val_file + 3);
	  oputch (pos_val_file == -1 ? '^' :
			  pos_val_file == SIZE_W - 2 ? 'V' : '');
	}
	ogotoxy (WXsize, pvf + 3);
	textabk (COLOR7F, COLOR7B, 1);
	oputch (TERM_CR);
	pos_val_file = pvf;
  }
  pvf = mathscrollbar ((long) posx_str, 40, (long) MLS - 1);
  if (posx_val_file != pvf) {
	if (posx_val_file != -2) {
	  ogotoxy (37 + posx_val_file, SIZE_W + 2);
	  oputch (posx_val_file == -1 ? '<' : posx_val_file == 40 ? '>' : '');
	}
	ogotoxy (37 + pvf, SIZE_W + 2);
	textabk (COLOR7F, COLOR7B, 1);
	oputch (TERM_CR);
	posx_val_file = pvf;
  }
}

	/*  Ctrl-K-x  Ctrl-Q-x */
#define mac_ret(MK) { c=(MK); goto ret; }

static stdcall2 int
decode_key (int c1)
{
  int c;

  view25 (c1 == BLK_FUN ? K_PREF_SS : FIND_SS);
  c = getch ();
  if (c == 033)
	c = get_term_decode_key ();
  view25 (MAIN_SS);
  switch (c) {
  case '+':
	mac_ret (CALC1_KEY);
  case '-':
	mac_ret (CALC2_KEY);
  case '*':
	mac_ret (CALC3_KEY);
  case '/':
	mac_ret (CALC4_KEY);
  case '=':
	mac_ret (CALC5_KEY);
  case '0':
  case '1':
  case '2':
  case '3':
  case '4':
  case '5':
  case '6':
  case '7':
  case '8':
  case '9':
	mac_ret (c1 == BLK_FUN ? SET0_KEY + c - '0' : GOTO0_KEY + c - '0');
  case ')':
  case '(':
  case '\035':                                  /* Ctrl-] */
  case '\033':                                  /* Ctrl-[ */
	mac_ret (FIND_Z);
  case UP_KEY:
  case CTRL_UP_KEY:
	mac_ret (BLK_UPC);
  case DOWN_KEY:
  case CTRL_DOWN_KEY:
	mac_ret (BLK_LOWC);
  }
  if (c >= 128) {
	size_t i;

	for (i = 0; i < sizeof (rus_latc); i++)
	  if (rus_code[i] == c) {
		c = rus_latc[i];
		break;
	}
	if (c >= 128)
	  mac_ret (0);
  }
  if (c1 == BLK_FUN) {
	switch (c & 037) {                      /* to CTRL */
	case '\002':
	  mac_ret (BEG_BLK);            /* CTRL B */
	case '\003':
	  mac_ret (BLK_COPY);           /* CTRL C */
	case '\006':
	  mac_ret (FORM_BLK_KEY);       /* CTRL F */
	case '\010':
	  mac_ret (BLK_CLS);            /* CTRL H */
	case '\013':
	  mac_ret (END_BLK);            /* CTRL K */
	case '\014':
	  mac_ret (BLK_LAT);            /* CTRL L */
	case '\022':
	  mac_ret (INPUT_BUF);          /* CTRL R */
	case '\023':
	  mac_ret (SAVE_NO_R);          /* CTRL S */
	case '\025':
	  mac_ret (BLK_RUS);            /* CTRL U */
	case '\026':
	  mac_ret (BLK_MOVE);           /* CTRL V */
	case '\027':
	  mac_ret (BLK_SAVE);           /* CTRL W */
	case '\030':
	  mac_ret (PBLK_KEY);           /* CTRL X */
	case '\031':
	  mac_ret (BLK_DEL);            /* CTRL Y */
	}
  } else {
	switch (c & 037) {              /* to CTRL */
	case '\001':
	  mac_ret (FINDA_KEY);          /* CTRL A */
	case '\002':
	  mac_ret (CTRL_UP_KEY);        /* CTRL B */
	case '\004':
	  mac_ret (END_KEY);            /* CTRL D */
	case '\006':
	  mac_ret (FINDF_KEY);          /* CTRL F */
	case '\013':
	  mac_ret (CTRL_DOWN_KEY);      /* CTRL K */
	case '\023':
	  mac_ret (HOME_KEY);           /* CTRL S */
	case '\017':
	  mac_ret (DELBEG_KEY);         /* CTRL O */
	case '\035':
	  mac_ret (FIND_Z);             /* Ctrl-] */
	}
  }
ret:
  if (flg_sav_macro != -1)
	macrox[nmacro][flg_sav_macro - 1] = c;
  return (c);
}

	/*      */
static stdcall2 void
edc_avt_form (int c)
{
  if (c == 0)
	beep ();
  else {
	if (chk_c_id (c, 0) == 0) {
	  if (flg_avt_form && posx_str >= line_str_a) {
		if (c != ' ')
		  u_edc (c);
		avt_form ();
		if (c == ' ' && lline (pos_cur_y) != 0)
		  u_edc (' ');
		c = 0;
	  }
	}
	if (c != 0)
	  u_edc (c);
  }
}

static stdcall2 void
view_lstr (const char *str, int fspace)
{
  int l;

  l = strlen (str);
  set_offs_sn ();
  if (l > 50)
	putch_next (17);
  ocputs (&str[l > 50 ? l - 49 : 0]);
  if (fspace)
	while (l < 50) {
	  putch_next (' ');
	  l++;
	}
}

	/*    */
static stdcall2 void
ocputsc (const char *s)
{
  int loop_flg;
  int j;

  for (j = loop_flg = 0;; loop_flg ^= 1) {
	if (loop_flg == 0) {
	  textabk (COLOR9F, COLOR9B, 0);
	  if (!j)
		putch_next (' ');
	} else
	  textabk (COLOR10F, COLOR10B, 1);
	while (*s && *s != ' ') {
	  j++;
	  if (*s == 1)
		putch_next (' ');
	  else
		putch_next (*s);
	  s++;
	}
	if (!*s)
	  break;
	putch_next (' ');
	j++;
	s++;                                            /* Skip ' ' */
	if (loop_flg != 0) {
	  putch_next (' ');
	  j++;
	}
  }
  textabk (COLOR10F, COLOR10B, 1);
  while (j < (WXsize - 1)) {
	j++;
	putch_next (' ');
  }
}

static stdcall2 void
view25 (int n)
{
  int scx, scy;

  if ((flg_ex_macro & (EFORMT | EMACRO | EREPEAT)) != 0) {
	if (n == MAIN_SS)
	  n = WAIT_ESC_SS;
	else
	  return;
  } else if (flg_sav_macro != -1 && n == MAIN_SS)
	n = MACRO_SS;
  scx = cur_x;
  scy = cur_y;
  ogotoxy (1, END_W);
  set_offs_sn ();
  ocputsc (pstr25[n]);
  ogotoxy (scx + 1, scy + 1);
  t_fflush ();
}


static void
unload (void)
{
  struct FILES_ST *ff;

  if (!ifactiv ())
	return;
  ff = &files_st[pnfiles];
  pswapnstr (pnfiles);
  ff->f_pos_cur_y = pos_cur_y;
  ff->f_nstr_pos = nstr_pos;
  ff->f_posx_str = posx_str;
  ff->f_pos_cur_x = pos_cur_x;
  ff->f_column = column;
  ff->nstr_file = bb_nstr_file;
  ff->flg_s = flg_synt_highl | (flg_vb ? FLG_ACTIVB : 0);
  flg_vb = 0;
  UNSET_ACTIV ();
}

static stdcall2 void
save_all (int flg_esc)
{
  int i;
  struct FILES_ST *ff;
  int c, actf = 0;

  if (ifactiv ()) {
	actf = pnfiles;
	unload ();
  }
  ff = &files_st[0];
  for (i = 0; i <= nfiles; i++, ff++) {
	if (IS_OK_MODI (i)) {
	  set_nfile (i);
re_paranoic:
	  view_flstr (ff->filesav);
	  win_e (SWARN, MFILE, MODIFYED, SAVE, WB_SFS2 | W_9 |
			 (flg_esc == ESC_KEY ? 0 : W_N_IC));
	  c = flg_esc == ESC_KEY ? button3ny (0) : button2ny ();
	  if (c > 0) {
		view25 (WAIT_SS);
		save_file ();
		if (IS_OK_MODI (i))
		  goto re_paranoic;
	  }
	  if (c < 0)
		return;
	}
	if (IS_LOADI (i) && ff->filesav[0] != 0)
	  chmod (ff->filesav, ff->mode);
  }
  s_auto_save[N_F_A_S] = '/';
  for (i = 0; i < NFILES; i++) {
	s_auto_save[N_F_A_S]++;
	unlink (s_auto_save);
  }
  if (flg_no_sd)
	save_dsk (actf, 1);
  else
	unlink (DSKFILE);
  fun_arg = 0;
  old_set (0);
}

static void
pasterecalc (void)
{
  /*      -
      ,   ,   */
  char *str;
  int j, c;
  char *str2;
  int flg_scip;     /*  ,      */

  str2 = (char *) 0;
  flg_scip = 0;

loop:
  str = get_str;
  for (;;) {
	if (str2 != (char *) 0) {
	  c = *str2++;
	  c &= 0377;    /* no EOF */
	  if (c == 0) {
		str2 = (char *) 0;
		continue;
	  }
	} else
	  c = Qogetc ();
	if (c == '\t') {
	  if (flg_scip)
		continue;
	  j = (str + 8 - get_str) & ~7;
	  if (j > (MLS - 3)) {
		*str = 0;
		flg_scip++;
		break;
	  }
	  while (str < &get_str[j])
		*str++ = ' ';
	  continue;
	}
	if (c == '\n') {
	  if (flg_scip) {                       /*  */
		flg_scip = 0;
		continue;
	  }
	  *str = 0;
	  break;
	}
	if (c == EOF) {
	  if (str == get_str)
		return;         /*  ""    scip */
	  *str = 0;
	  break;
	}
	if (c == 0)
	  c = ' ';                      /*  -   */
	if (c == ' ' && flg_scip != 0)
	  continue;
	flg_scip = 0;
	*str++ = c;
	if ((str - get_str) <= (MLS - 3))
	  continue;
	SET_MODIFYI (nfiles);           /*    */
	*str = 0;
	/*    ( - ) */
	j = (str - get_str);
	while (str != get_str && *--str != ' ');
	if (str == get_str) {           /*  ,    */
	  str += j;
	  break;
	}
	*str = 0;                       /*    */
	str2 = str + 1;                 /*  */
	flg_scip++;
	break;
  }
  /*    */
  while (str != get_str && *--str == ' ')
	*str = 0;
  str = get_str;                /*      */
  while (*str == ' ')
	str++;
  j = (str - get_str) >> 3;
  str -= (str - get_str) - (j << 3);
  while (j) {
	str--;
	*str = '\t';
	j--;
  }
  load_list (str);
  if (c != EOF)
	goto loop;
}

static stdcall2 void
del_file (int p)
{                               /*    */
  int c;
  {
	struct FILES_ST *ff;
	ff = &files_st[p];
	set_nfile (p);
	if (IS_OK_MOD ()) {
re_paranoic:
	  view_flstr (ff->filesav);
	  win_e (SWARN, MFILE, MODIFYED, SAVE, WB_SFS2 | W_9);
	  c = button3ny (0);
	  if (c > 0) {
		view25 (WAIT_SS);
		save_file ();
		if (IS_OK_MOD ())
		  goto re_paranoic;
	  }
	  if (c < 0)
		return;
	}
	all_free (stf0);
	u_del_file ();
	textabk (COLOR1F, COLOR1B, 0);
	oclrscr ();
	if (IS_LOAD () && ff->filesav[0] != 0)
	  chmod (ff->filesav, ff->mode);
  }
  {
	int p2;                 /*        */
	for (;; p++) {
	  c = GEN_BM (p);
	  p2 = c << 1;
	  if ((indsk & p2) != 0)
		indsk |= c;
	  else
		indsk &= ~c;
	  if ((b_flg_modify & p2) != 0)
		b_flg_modify |= c;
	  else
		b_flg_modify &= ~c;
	  if ((b_flg_as & p2) != 0)
		b_flg_as |= c;
	  else
		b_flg_as &= ~c;
	  if ((b_flg_load & p2) != 0)
		b_flg_load |= c;
	  else
		b_flg_load &= ~c;
	  if ((b_flg_vonly & p2) != 0)
		b_flg_vonly |= c;
	  else
		b_flg_vonly &= ~c;
	  if ((b_flg_creat & p2) != 0)
		b_flg_creat |= c;
	  else
		b_flg_creat &= ~c;
	  if ((b_u_mdf & p2) != 0)
		b_u_mdf |= c;
	  else
		b_u_mdf &= ~c;
	  if (p != (NFILES - 1))
		files_st[p] = files_st[p + 1];
	  else
		break;
	}
  }
  UNSET_ACTIV ();
  memset (&files_st[NFILES - 1], 0, sizeof (files_st[0]));
  nfiles--;
}

static int
main_loop_get (int flg_decod)
{
  int c;
  view_pos ();
  poscur ();
  cursor (insert == 0 ? FULLCURSOR : NORMCURSOR);
  c = get_key ();
  flg_as_on = 0;
  if (flg_decod != 0 && c >= BLK_FUN)
	c = decode_key (c);
  cursor (NOCURSOR);
  return c;
}

/*   autosave.X  dsk  */
static stdcall2 int
load_dsk_as (int n)
{
  int r = -1;
  struct FILES_ST *ff;

  s_auto_save[N_F_A_S]++;
  ff = &files_st[n];
  if ((ff->flg_s & FLG_A_S_SYHL) != 0) {
	r = loadfiles (s_auto_save);
	if ((ff->flg_s & FLG_NONAME) != 0)
	  ff->filesav[0] = 0;
  }
  if (r >= 0)
	SET_MODIFYI (n);
  else
	r = loadfiles (ff->filesav);
  return r;
}

static void
autosave ()
{
  int i;
  int actf;

  if (timesasstart != 0 && b_flg_as != 0) {
	actf = pnfiles;
	unload ();
	for (i = 0; i <= nfiles; i++) {
	  if (IS_ASMODFI (i)) {
		set_nfile (i);
		view25 (WAIT_SS);
		files_st[i].flg_s |= FLG_A_S_SYHL;
		s_auto_save[N_F_A_S] = i + '0';
		flg_save_as = AUTO_SAVE;
		save_file ();
		UNSET_ASMODF ();
		view25 (MAIN_SS);
	  }
	}
	save_dsk (actf, 0);
	if (pnfiles != actf)
	  set_nfile (actf);
	t_fflush ();
	view_pos ();
  }
  flg_as_on = 0;
}

static void tflush (void);


int
ocxb_main(void)
{
  int j;
  int argc;
  char **argv;

#ifndef __BIONIC__
  swap_file = xasprintf ("/tmp/S%d", getpid ());
#else
  swap_file = xasprintf ("?S%d", getpid ());
#endif
  /* init data form BSS */
  buff_altk = SNULL;
  dp = buff_0screen;
  line_str_a = 75;
  tn_f = 3;
  flg_mperenos = 1;
  flg_view_mod = 1;
  timesasstart = 15 * 60;
  bb_nstr_file = -1;
  insert = 1;
  user_tab = 8;
  nswpnaf = 1;
  macrox[0][0] = macrox[1][0] = macrox[2][0] = macrox[3][0] = -1;
  flg_sav_macro = -1;
  identf = (struct ID *) shelp;
  posid = -1;
  max_y_wbs = -1;
  min_y_wbs = 1000;
  nfiles = -1;
  p_ustf0 = ustf0;
  p_sizeuswap = sizeuswap;
  p_cur_posu = cur_posu;
  strcpy(s_auto_save, s_auto_save_st);
  sav_y_form = 6;
  sav_yfswb = 12;
  sav_yparm = 5;
  view_list_sav_ywb = 12;
  shcom_sav_ywb = 12;
  calcv_sav_ywb = 12;
  load_file_sav_ywb = 12;
  save_file_sav_ywb = 12;
  save_as_sav_ywb = 10;
  blk_save_sav_ywb = 12;
  eparm_sav_ywb = 12;
  input_buf_sav_ywb = 12;
  timessstart = 300;

  init_c_main ();
  {
    char *ps;

    for (ps = buff_0screen; ps < (buff_0screen + sizeof(buff_0screen)); ) {
	*ps = ' ';
	ps += 2;
    }
  }
  toclrscr ();
  tflush ();
  cur_x = cur_y = 0;
  textabk (COLOR0F, COLOR0B, 0);
  cursor (NOCURSOR);
  atexit (oexit);
  reset (1);
  oclrscr ();
  ogotoxy (2, END_W - 1);
  ocputs ("Text editor. Author Vladimir Oleynik (C) 1992-2017");
  t_fflush ();
  form_file[PTMPFILE] = 'F';
  argc = bb_getopt_ulflags("sr");
  if(argc & 1)
	nswpnaf = 0;
  if((argc & 2) == 0) {
	  if ((argc = get_dsk ()) >= 0) {
		for (j = 0; j <= flg_F6; j++) {
		  if (load_dsk_as (j) < 0) {
			if (j == argc)
			  argc = 0;
			memcpy (&files_st[j], &files_st[j + 1],
					(NFILES - 1 - j) * sizeof (struct FILES_ST));
			files_st[NFILES - 1].filesav[0] = 0;
			flg_F6--;
			j--;
		  } else
			indsk |= GEN_BM (j);
		}
	  } else
		argc = 0;
  }

  argv = Gargv;
  argc = 0;
cont2:
  while (*argv != NULL) {
	safe_strncpy (str_rez, *argv, MLS);
	argv++;
	for (j = 0; j <= nfiles; j++)
	  if (!strcmp (files_st[j].filesav, str_rez)) {
		argc = j;
		goto cont2;
	  }
	if (nfiles == (NFILES - 1)) {
	  del_file (0);
	  if (argc > 0)
		argc--;
	}
	if (loadfiles (str_rez) >= 0)
	  argc = nfiles;
  }
  if (nfiles == -1)
	loadfiles ((char *) SNULL);
  set_nfile (argc);
  /*    */
  for (;;) {
	flg_as_on = 1;
	j = main_loop_get (1);
	if ((flg_ex_macro & EFOUND)) {  /*   */
	  view_str (pos_cur_y);
	  flg_ex_macro &= ~EFOUND;
	}
	if (j != UNDO_KEY && j != REDO_KEY && j != MENU_KEY)
	  save_u_context ();
	if (j >= UP_KEY && j <= ESC_KEY) {
	  fun_arg = j;
	  (*((EF) fun_edit[j - UP_KEY])) ();
	} else
	  edc_avt_form (j);
	if (fun_arg != UNDO_KEY && fun_arg != REDO_KEY)
	  put_all_context ();
  }
  return 0;
}
	/*    -    */
static stdcall2 void
g_space (stf st)
{
  char *s1;
  char *s2;

  getstext (st);
  s1 = get_str;
  memset (s1, ' ', MLS - 1);
  s2 = gets_text;
  while (*s2 == '\t') {
	s2++;
	s1 += 8;
  }
  while (*s2)
	*s1++ = *s2++;
}

	 /*   get_str    */
static stdcall2 int
g_lline (stf st)
{
  int j;
  char *str = get_str;

  g_space (st);
  for (j = (MLS - 2); j >= 0 && str[j] == ' '; j--);
  return (++j);
}



	/*        */
static stdcall2 void
view_str (int posy)
{
  int x;
  int k;
  char *ptr;
  long lj;
  char attr_rez_word[MLS];
  char *ptr_attr;

  if (!flg_view_mod)
	return;
  /*   (  busybox ) */
  memset (attr_rez_word, gencolor (COLOR1F, COLOR1B, 0), MLS);
  ptr = &buf_scr[posy][column];
  ptr_attr = &attr_rez_word[column];
  ogotoxy (2, posy + 2);
  set_offs_sn ();
  lj = nstr_pos - pos_cur_y + posy;
  x = 0;
  if (!flg_vb || IS_ACTIV () == 0)
	goto puts_all;
  if (buff_blk->beg_y <= lj && buff_blk->end_y >= lj) {
	if (buff_blk->typeb == 2)
	  goto pblk_beg;
	if (buff_blk->beg_y != lj && buff_blk->end_y != lj) {
all_color:
	  memset (attr_rez_word, gencolor (COLOR13F, COLOR13B, 1), MLS);
	  goto puts_all;
	}
	if (buff_blk->beg_y == lj) {
pblk_beg:
	  for (k = x; k < (WXsize - 2) && (k + column) < buff_blk->beg_x; k++)
		if ((k + column) > (MLS - 1))
		  putch_next (' ');
		else {
		  cur_attr = ptr_attr[k];
		  putch_next (*ptr++);
		}
	  x = k;
	  if (buff_blk->end_y != lj && buff_blk->typeb == 1)
		goto all_color;
color_end:
	  textabk (COLOR13F, COLOR13B, 1);
	  for (; k < (WXsize - 2) && (k + column) < buff_blk->end_x; k++)
		if ((k + column) > (MLS - 1))
		  putch_next (' ');
		else
		  putch_next (*ptr++);
	  x = k;
	  goto puts_all;
	}
	k = x;
	goto color_end;
  } else {
puts_all:
	for (k = x; k < (WXsize - 2); k++)
	  if ((k + column) > (MLS - 1))
		putch_next (' ');
	  else {
		cur_attr = ptr_attr[k];
		putch_next (*ptr++);
	  }
  }
}

static void
poscur (void)
{
  ogotoxy (pos_cur_x + 2, pos_cur_y + 2);
}

static void
posrev (void)
{                       /*  */
  int i;

  for (i = 0; i < SIZE_W; i++)
	view_str (i);
}

static stdcall2 void
review_scr (int flg)
{
  int i;
  stf head;

  copy_scr ();
  head = find_head (nstr_pos - pos_cur_y);
  for (i = 0; i < SIZE_W; i++) {
	if (head != NULL) {
	  g_space (head);
	  head = head->over;
	  memcpy (buf_scr[i], get_str, MLS);
	} else
	  memset (buf_scr[i], ' ', MLS - 1);
  }
  if (flg)
	posrev ();
  else
	poscur ();
}


static void
chtsget (int ns)
{                       /*        */
  stf head;

  eds[ns] = 0;
  head = find_head (nstr_pos);
  if (head != NULL) {
	g_space (head);
	memcpy (buf_scr[ns], get_str, MLS);
  } else
	memset (buf_scr[ns], ' ', MLS - 1);
}

			/* Execute funtions */
/*   u_ -      undo- */

static int
comm_up (void)
{
  if (!nstr_pos) {
	flg_ex_macro = 0;
	return 0;
  }
  if (!pos_cur_y) {
	int k;

	chget (SIZE_W - 1);
	for (k = (SIZE_W - 2); k >= 0; k--) {
	  memcpy (buf_scr[k + 1], buf_scr[k], MLS);
	  eds[k + 1] = eds[k];
	}
	nstr_pos--;
	chtsget (0);
	return 1;
  } else {
	pos_cur_y--;
	nstr_pos--;
	return 0;
  }
}

static void
up (void)
{
  if (comm_up () && flg_view_mod) {
	int i, j;
	/*   */
	for (i = SIZE_W - 1; i >= 1; i--)
		for (j = 1; j <= (WXsize - 2); j++)
			putch_a_coo (get_ca (j, i), j, i + 1);
	if (min_y_wbs > 1)
		min_y_wbs = 1;
	if (max_y_wbs < 1)
		max_y_wbs = 1;
	view_str (0);
  }
}

static int
comm_left (void)
{
  if (posx_str)
	return re2column (posx_str - 1);
  else {
	flg_ex_macro = 0;
	return 0;
  }
}

static void
left (void)
{
  if (comm_left ())
	posrev ();
}

static int
comm_right (void)
{
  if (posx_str < (MLS - 1))
	return re2column (posx_str + 1);
  else {
	flg_ex_macro = 0;
	return 0;
  }
}

static void
right (void)
{
  if (comm_right ())
	posrev ();
}

static void
down (void)
{
  if (comm_down () && flg_view_mod) {
	unsigned i, j;
	/*   */
	for (i = 1; i < SIZE_W; i++)
		for (j = 1; j <= (WXsize - 2); j++)
			putch_a_coo (get_ca (j, i + 1), j, i);
	if (min_y_wbs > 1)
		min_y_wbs = 1;
	if (max_y_wbs < 1)
		max_y_wbs = 1;
	view_str (SIZE_W - 1);
  }
}

static void
home (void)
{
  int j;
  for (j = 0; j < (MLS - 1); j++)
	if (buf_scr[pos_cur_y][j] != ' ')
	  break;
  if (j == (MLS - 1))
	j = 0;
  if (recolumn (j))
	posrev ();
}

static void
home0 (void)
{               /*     */
  int j;

  j = column;
  column = posx_str = pos_cur_x = 0;
  if (j)
	posrev ();
}

static void
end_line (void)
{
  if (re2column (lline (pos_cur_y)))
	posrev ();
}

static void
u_end_line (void)
{
  end_line ();
  put_u_context ();
}

static void
pdown (void)
{
  long int j, k;

  if ((k = nstr_pos + SIZE_W) > bb_nstr_file) {
	if (nstr_pos == (j = bb_nstr_file)) {
	  flg_ex_macro = 0;
	  end_line ();
	  return;
	}
	while (nstr_pos != j)
	  comm_down ();
	posrev ();
	return;
  }
  copy_scr ();
  nstr_pos = k;
  review_scr (REVIEW);
}

static void
move_xy_blk (void)
{
  int op = fun_arg - CTRL_UP_KEY;

  if (!flg_vb)
	flg_vb = 1;
  if (!test_blk (1))
	return;
  recolumn (op ? buff_blk->end_x : buff_blk->beg_x);
  set_nl (op ? buff_blk->end_y : buff_blk->beg_y, REVIEW);
}

static void
pup (void)
{
  long int k;

  if (!nstr_pos) {
	flg_ex_macro = 0;
	return;
  }
  if ((k = nstr_pos - SIZE_W) >= 0) {
	copy_scr ();
	nstr_pos = k;
	if (k < pos_cur_y)
	  pos_cur_y = k;
	review_scr (REVIEW);
  } else {
	up_d (nstr_pos);
	posrev ();
  }
}

static void
cr (void)
{
  if (insert) {
	int j;
	char buff_undo[2];

	for (j = 0; j < N_KQB; j++)
	  if (kqbs[j] > nstr_pos)
		kqbs[j]++;
	SET_MODIFY ();
	put_u_context ();
	comm_cr ();
	if (nstr_pos <= buff_blk->beg_y) {
	  buff_blk->beg_y++;
	  buff_blk->end_y++;
	} else if (buff_blk->beg_y < nstr_pos && nstr_pos <= buff_blk->end_y)
	  buff_blk->end_y++;
	j = flg_link;
	if (flg_link)
	  buff_undo[0] = UNDO_LINK;
	else
	  flg_link++;
	buff_undo[j] = UC_INS_CR | UNDO_SZ_0;
	write_b_u (buff_undo, j + 1);
	posrev ();
  } else {
	down ();
	home ();
  }
  put_u_context ();
}

static stdcall2 void
tabx (int ut)
{
  int t;

  t = (posx_str + ut);
  t -= t % ut;
  if (t > (MLS - 1)) {
	flg_ex_macro = 0;
	return;
  }
  flg_ex_macro |= EOKOP;
  while (t != posx_str && flg_ex_macro)
	if (!insert)
	  right ();
	else
	  u_edc (' ');
  flg_ex_macro &= ~EOKOP;
}

static stdcall2 void
deleten (int ndel)
{
  while (ndel > 0) {
	left ();
	put_u_context ();
	if (!insert) {
	  u_edc (' ');
	  left ();
	  put_u_context ();
	} else
	  delupcur (1);
	ndel--;
  }
}

static stdcall2 void
spec_del (int flg_bs)
{
  /*    ""    */
  int i, min;
  int y_scr;
  long y_prob;

  for (i = 0; buf_scr[pos_cur_y][i] == ' '; i++);
  if (i == (MLS - 1))
	i = posx_str + 1;
  if (i <= posx_str)
	i = 1;
  else {
	y_prob = nstr_pos;
	y_scr = pos_cur_y;
	for (;;) {
	  if (!y_prob) {
		if (flg_bs) {
		  i = posx_str + 1;
		  home0 ();
		  break;
		}
del0:
		i -= posx_str;
		break;
	  }
	  --y_prob;
	  if (y_scr > 0)
		memcpy (get_str, buf_scr[--y_scr], MLS);
	  else
		g_space (find_head (y_prob));
	  for (min = 0; get_str[min] == ' '; min++);
	  if (min < i) {
		if (min <= posx_str) {
		  if (flg_bs) {
			i = 1;
			while (min < posx_str) {
			  i++;
			  left ();
			}
			break;
		  }
		  goto del0;
		}
		i -= min;
		break;
	  }
	}
  }
  delupcur (i);
}

static stdcall2 void
delupcur (int i)
{                       /*     */
  char *t;
  int y;

  set_max_min_syh (0);
  eds[pos_cur_y] = 1;
  SET_MODIFY ();
  while (i--) {
	for (y = 0; y < N_KQB; y++)
	  if (kqbs[y] == nstr_pos && kqbp[y] > posx_str)
		kqbp[y]--;
	put_u_context ();
	t = &buf_scr[pos_cur_y][posx_str];
	putdelta (t, UC_DELUPCUR | UNDO_SZ_B);
	while (*t) {
	  *t = *(t + 1);
	  t++;
	}
	*(t - 1) = ' ';
	if (buff_blk->end_y == nstr_pos && buff_blk->end_x > posx_str)
	  buff_blk->end_x--;
	if (buff_blk->beg_y == nstr_pos && buff_blk->beg_x > posx_str)
	  buff_blk->beg_x--;
  }
  put_u_context ();
  view_str (pos_cur_y);
}

static void
bsscroll (int y)
{
  int j;
  for (j = y; j < (SIZE_W - 1); j++) {
	memcpy (buf_scr[j], buf_scr[j + 1], MLS);
	eds[j] = eds[j + 1];
  }
}

static void
del_line (void)
{
  int j;
#ifndef lj32
  long lj32;
#endif

  for (j = 0; j < N_KQB; j++)
	if (kqbs[j] > nstr_pos)
	  kqbs[j]--;
  lj32 = nstr_pos;
  if (buff_blk->beg_y > lj32) {
	buff_blk->beg_y--;
	buff_blk->end_y--;
  } else if (buff_blk->beg_y <= lj32 && buff_blk->end_y >= lj32) {
	buff_blk->end_y--;
	if (buff_blk->beg_y == lj32) {
	  buff_blk->beg_x = 0;
	} else {
	  if (buff_blk->end_y < lj32) {
		if ((lj32 = pos_cur_y + (buff_blk->end_y - lj32)) < 0)
		  buff_blk->end_x = g_lline (find_head (buff_blk->end_y));
		else
		  buff_blk->end_x = lline (lj32);
	  }
	}
  }
  SET_MODIFY ();
  put_u_context ();
  u_comm_dl (buf_scr[pos_cur_y], lline (pos_cur_y));
  bsscroll (pos_cur_y);
  lj32 = nstr_pos;
  nstr_pos = nstr_pos - pos_cur_y + SIZE_W;
  chtsget ((SIZE_W - 1));
  nstr_pos = lj32;
  del_list (lj32);
  set_m2_syh (-1, 0);
  for (j = pos_cur_y; j < SIZE_W; j++)
	view_str (j);
}

static void
paste (void)
{
  int l;
  int j, l1, lp;

  l = lline (pos_cur_y);
  if (l <= posx_str) {
	/*  */
	down ();
	for (j = 0; j < N_KQB; j++) {
	  if (kqbs[j] == nstr_pos)
		kqbs[j] = -2;
	  else if (kqbs[j] > nstr_pos)
		kqbs[j]--;
	}
	l1 = lline (lp = pos_cur_y);
	up ();
	j = 0;
	while (buf_scr[lp][j] == ' ')
	  j++;
	if (j > l1)
	  j = 0;
	if ((l1 - j + posx_str) > (MLS - 1)) {
	  beep ();              /*       */
	  flg_ex_macro = 0;
	  put_u_context ();
	  return;
	}
	if (buff_blk->end_y == nstr_pos) {
	  if (buff_blk->end_x > posx_str) {
		buff_blk->end_y++;
		buff_blk->end_x = 0;
	  }
	  goto ok_past;
	}
	if (buff_blk->beg_y > nstr_pos) {
	  buff_blk->beg_y--;
	  if (buff_blk->beg_y == nstr_pos) {
		buff_blk->beg_x -= j;
		if (buff_blk->beg_x < 0)
		  buff_blk->beg_x = 0;
		buff_blk->beg_x += posx_str;
	  }
	}
	if (buff_blk->end_y > nstr_pos) {
	  buff_blk->end_y--;
	  if (buff_blk->end_y == nstr_pos) {
		if (buff_blk->end_x < j)
		  buff_blk->end_x = buff_blk->beg_x;
		else
		  buff_blk->end_x += posx_str - j;
	  }
	}
ok_past:
	for (l = 0; l < N_KQB; l++)
	  if (kqbs[l] == -2) {
		kqbs[l] = nstr_pos;
		kqbp[l] -= j;
		if (kqbp[l] < 0)
		  kqbp[l] = 0;
		kqbp[l] += posx_str;
	  }
	SET_MODIFY ();
	put_u_context ();
	putdelta (&j, UC_PAST | UNDO_SZ_SHRT);
	for (l = posx_str; j < l1; l++)
	  buf_scr[pos_cur_y][l] = buf_scr[lp][j++];
	set_max_min_syh (0);
	eds[pos_cur_y++] = 1;
	nstr_pos++;
	bsscroll (pos_cur_y);
	{
#ifndef lj32
	  long lj32;
#endif
	  lj32 = nstr_pos;
	  nstr_pos = nstr_pos - pos_cur_y + SIZE_W;
	  chtsget (SIZE_W - 1);
	  del_list (nstr_pos = lj32);
	}
	pos_cur_y--;
	nstr_pos--;
	for (j = pos_cur_y; j < SIZE_W; j++)
	  view_str (j);
	put_u_context ();
  } else {                                              /*  */
	j = posx_str;
	home ();
	lp = posx_str;
	recolumn (j);
	insert++;
	put_u_context ();
	paste2 (lp);
	posrev ();
	insert--;
	put_u_context ();
  }
}

	/*      */
static stdcall2 int
get_word2 (char *stw,
		   const char *stwfs, int posx, int flg_no_rus)
{
  int i, j;

  j = 0;
  for (i = posx; i >= 0; i--) {
	if (chk_c_id (stwfs[i], flg_no_rus))
	  j++;
	else if (i != posx)
	  break;
  }
  if (j != 0) {
	for (++i;; i++) {
	  if (!chk_c_id (*stw = stwfs[i], flg_no_rus))
		break;
	  stw++;
	}
	*stw = '\0';
	return (i);
  } else
	return (posx);
}

static void
save_file (void)
{
  stf st_st;
  char *pfs;
  struct stat st_stat;
  long nssave;

  if (!flg_save_as) {
	if (IS_VONLY () || IS_MODIFY () == 0)
	  return;
	copy_scr ();
	pfs = files_st[pnfiles].filesav;
	if (pfs[0] == 0) {
	  wb_miny = &save_file_sav_ywb;
	  win_0e (SAVING, "File name", WIN_E_OK);
	  get_str[0] = 0;
	  if (get_vstr (get_str, FILE_VSTR | VSTR_RWB, 0) == ESC_KEY)
		goto retnull;
	  if (scan_glob (get_str) == 0)
		goto retnull;
	  strcpy (pfs, get_str);
	  flg_save_as = SAVENONAME;
	}
  } else if (flg_save_as == AUTO_SAVE)
	pfs = s_auto_save;
  else
	pfs = get_str;
  if (!flg_save_as && IS_CREAT () == 0) {
	gen_name_bak ();
	unlink (str_rez);
	if (link (pfs, str_rez) == -1) {
	  view_flstr (str_rez);
	  win_err (cant_create, "bak file", WB_SFS3 | W_8);
	}
	unlink (pfs);
  }
  if (flg_save_as > 0) {
	if (stat (pfs, &st_stat) != -1 && (st_stat.st_mode & S_IFMT) == S_IFREG) {
	  view_flstr (pfs);
	  win_e (SWARN, MFILE, "present", "Rewrite ?", WB_SFS2 | W_9 | W_N_IC);
	  if (button2ny () <= 0) {
		if (flg_save_as == SAVENONAME)
		  files_st[pnfiles].filesav[0] = 0;
		goto retnull;
	  }
	}
  }
  if (!ofopen (pfs, IOW)) {
	view_flstr (pfs);
	win_err (cant_create, "file for write", WB_SFS3 | W_8);
	goto retnull;
  }
  if (flg_save_as == SAVE_AS) {
	strcpy (files_st[pnfiles].filesav, pfs);
	UNSET_VONLY ();
  }
  win_1e (flg_save_as == AUTO_SAVE ? "Autosave" :
		  flg_save_as > SAVENONAME ? sBlk : NULL, NULL, SAVING,
		  WB_STD | W_N_IC);
  t_fflush ();
  if (flg_save_as <= SAVENONAME && flg_save_as != AUTO_SAVE) {
	UNSET_MODIFY ();
	UNSET_CREAT ();
	UNSET_ASMODF ();
  }
  if (flg_save_as >= SAVECLIP) {
	nssave = 0;
	if (test_blk (1)) {
	  while (blk_to_buff (nssave++, 1) == 1)
		ofputs (get_str);
	}
  } else {
	st_st = stf0;
	for (nssave = 0; nssave <= bb_nstr_file; nssave++) {
	  getstext (st_st);
	  ofputs (gets_text);
	  if (nssave != bb_nstr_file || gets_text[0] != '\0')
		oputc ('\n');
	  st_st = st_st->over;
	}
  }
  ofclose ();
  if (flg_save_as <= SAVENONAME && flg_save_as != AUTO_SAVE) {
	stat (pfs, &st_stat);
	files_st[pnfiles].mtime = st_stat.st_mtime;
	if (flg_save_as != 0)
	  reset (0);
  }
retnull:
  flg_save_as = 0;
  restore_wb ();
}

static stdcall2 int
test_blk (int fem)
{
  if (buff_blk->beg_y > buff_blk->end_y || buff_blk->beg_y > bb_nstr_file ||
	  ((buff_blk->beg_y == buff_blk->end_y || buff_blk->typeb == 2)
	   && buff_blk->beg_x >= buff_blk->end_x)) {
	flg_vb = 0;
	if (fem > 0)
	  flg_ex_macro = 0;
  }
  if (buff_blk->end_y > bb_nstr_file)
	buff_blk->end_y = bb_nstr_file;
  if (fem >= 0)
	put_u_context ();
  return (flg_vb);
}

static stdcall2 int
blk_to_buff (long ns, int frs)
{
  long i, j;

  if ((i = ns + buff_blk->beg_y) > buff_blk->end_y)
	return 0;
  j = nstr_pos - pos_cur_y;
  if (i >= j && i < (j + SIZE_W))
	memcpy (get_str, buf_scr[i - j], MLS);
  else
	g_space (find_head (i));
  if (ns == 0 || buff_blk->typeb == 2)
	memmove (get_str, get_str + buff_blk->beg_x, strlen(get_str + buff_blk->beg_x) + 1);
  if (i == buff_blk->end_y || buff_blk->typeb == 2) {
	get_str[(buff_blk->beg_y != buff_blk->end_y && buff_blk->typeb != 2) ?
			buff_blk->end_x : buff_blk->end_x - buff_blk->beg_x] = '\0';
	if (frs && buff_blk->typeb == 2)
	  reconv_space ();
	if (i != buff_blk->end_y && buff_blk->typeb == 2)
	  str1cat (get_str, '\n');
  } else {
	reconv_space ();
	str1cat (get_str, '\n');
  }
  return 1;
}

static void
in_clip (void)
{
  if (!typebclip)
	return;
  flg_save_as = -1;
  buff_blk->typeb = typebclip;
  put_u_context ();
  input_buf ();
  flg_save_as = 0;
}

static void
in_clip_conv (void)
{
  if (!typebclip)
	return;
  flg_save_as = -1;
  if (typebclip == 1) {
	buff_blk->typeb = typebclip = 2;
	lenghbclip = 0;
  } else
	buff_blk->typeb = typebclip = 1;
  put_u_context ();
  input_buf ();
  flg_save_as = 0;
}

static stdcall2 void
u_edc (int c)
{
  int pos;
  int i;
  char *ptr = buf_scr[pos_cur_y];
  int flg_blk_edc;

  SET_MODIFY ();
  put_u_context ();
  set_max_min_syh (0);
  eds[pos_cur_y] = 1;
  pos = posx_str;
  flg_blk_edc = fun_arg == BLK_FUN;
  c &= 0377;
  if (insert) {
	long int j = nstr_pos;

	if (ptr[MLS - 2] != ' ') {
	  flg_ex_macro = 0;
	  return;
	}
	if (!flg_blk_edc) {
	  if (buff_blk->beg_y == j && pos < buff_blk->beg_x)
		buff_blk->beg_x++;
	  if (buff_blk->end_y == j && pos < buff_blk->end_x)
		buff_blk->end_x++;
	}
	for (i = 0; i < N_KQB; i++)
	  if (kqbs[i] == nstr_pos && pos <= kqbp[i])
		kqbp[i]++;
	for (i = (MLS - 3); i >= pos; i--)
	  ptr[i + 1] = ptr[i];
  }
  i = (ptr[pos] << 8) | c;
  ptr[pos] = c;
  if (insert)
	putdelta (&i, UNDO_SZ_SHRT + UC_CH_CHAR + 1);
  else
	putdelta (&i, UNDO_SZ_SHRT + UC_CH_CHAR);
  if (!flg_blk_edc) {
	view_str (pos_cur_y);
	right ();
  } else
	comm_right ();
  put_u_context ();
}

static void
save_as (void)
{
  copy_scr ();
  strcpy (get_str, files_st[pnfiles].filesav);
  view_flstr (get_str);
  wb_miny = &save_as_sav_ywb;
  win_e (SAVING, MFILE, "Save as", NULL, W_9 | WB_SFS2 | WIN_E_OK);
  if (get_vstr (get_str, FILE_VSTR | VSTR_RWB | DOWN2_VSTR, 0) != ESC_KEY)
	if (scan_glob (get_str)) {
	  if (files_st[pnfiles].filesav[0] == 0) {
		strcpy (files_st[pnfiles].filesav, get_str);
		flg_save_as = SAVENONAME;
	  } else
		flg_save_as++;
	  save_file ();
	}
}

static void
repeat (void)
{
  int j = 0, c;
#ifndef lj32
  long lj32;
#endif

  int sav_ex_macro = flg_ex_macro & EREPEAT;

  str_rez[0] = '\0';
  view25 (REPEAT_SS);
  ogotoxy (61, END_W);
  textabk (COLOR26F, COLOR26B, 0);
  ocputsn (" Repeat$( ");
  cur_x -= 7;
  for (;;) {
	if ((flg_ex_macro & EMACRO) == 0)
	  cursor (NORMCURSOR);
	c = get_key ();
	cursor (NOCURSOR);
	if (c >= BLK_FUN)
	  c = decode_key (c);
	if (c == ESC_KEY || c == 0)
	  goto ret;
	if (c >= '0' && c <= '9') {
	  if (j == 7)
		beep ();
	  else {
		str_rez[j++] = c;
		str_rez[j] = '\0';
		oputch (c);
	  }
	} else
	  break;
  }
  lj32 = atol (str_rez);
  poscur ();
  switch (c) {
	/*  */
  case UP_KEY:
	if ((lj32 = nstr_pos - lj32) < 0)
	  lj32 = 0;
	goto posret;

  case DOWN_KEY:
	if ((lj32 += nstr_pos) > bb_nstr_file)
	  lj32 = bb_nstr_file;
posret:
	set_nl (lj32, REVIEW);
	goto ret;
  case ASCII_KEY:                               /*   edc() */
	c = ascii_w (buf_scr[pos_cur_y][posx_str], pos_cur_x > (WXsize / 2 - 2));
	if (c <= 0) {
	  flg_ex_macro = 0;
	  view_str (pos_cur_y);
	  goto ret;
	}
  }
  if (c >= HOME_KEY) {
	win_1e (SWARN, "Only one", "do", W_N_IC);
	j = button2ny ();
	if (j < 0)
	  goto ret;
	lj32 = 1;
  }
  view25 (WAIT_ESC_SS);
  flg_ex_macro |= EREPEAT;
  while (lj32 > 0 && (flg_ex_macro & EREPEAT)) {
	if (test_input () == 0) {
	  flg_ex_macro = 0;
	  break;
	}
	if ((flg_ex_macro & EFOUND)) {  /*   */
	  view_str (pos_cur_y);
	  flg_ex_macro &= ~EFOUND;
	}
	if (c != UNDO_KEY && c != REDO_KEY && c != MENU_KEY)
	  save_u_context ();
	if (c >= UP_KEY && c <= ESC_KEY) {
	  fun_arg = c;
	  /*     */
	  (*((EF) fun_edit[c - UP_KEY])) ();
	} else
	  u_edc (c);
	lj32--;
	view_pos ();
	if (c != UNDO_KEY && c != REDO_KEY)
	  put_all_context ();
  }
  if (sav_ex_macro == 0)
	flg_ex_macro &= ~EREPEAT;
ret:
  view25 (MAIN_SS);
}

static void
exemacro (void)
{
  int c;
  int nm;
  int savnm;
  int n;

  n = fun_arg - EXEMACRO;
  if (flg_sav_macro != -1 && nmacro == n)
	/*       */
	/*     */
	begmacro ();
/*    */
  savnm = nmacro;
  nm = GEN_BM (n);
  if ((flg_ex_macro & nm) != 0) {
	flg_ex_macro = 0;
	win_err ("Recursion", "in macros", 0);
	return;
  }
  view25 (WAIT_ESC_SS);
  flg_ex_macro |= nm;
  for (nmacro = n, flg_p_macro[n] = 0;
	   (flg_ex_macro & EMACRO) && (c = macrox[n][flg_p_macro[n]]) != -1;) {
	flg_p_macro[n]++;
	if ((flg_ex_macro & EFOUND)) {  /*   */
	  flg_ex_macro &= ~EFOUND;
	  view_str (pos_cur_y);
	}
	if (test_input () == 0) {
	  flg_ex_macro = 0;
	  goto ret;
	}
	if (c != UNDO_KEY && c != REDO_KEY)
	  save_u_context ();
	if (c >= UP_KEY && c <= ESC_KEY) {
	  fun_arg = c;
	  (*((EF) fun_edit[c - UP_KEY])) ();
	  nmacro = n;
	} else
	  edc_avt_form (c);
	view_pos ();
	if (c != UNDO_KEY && c != REDO_KEY)
	  put_all_context ();
  }
  flg_ex_macro &= ~nm;
ret:
  view25 (MAIN_SS);
  nmacro = savnm;
}

static stdcall2 void
begmacrox (int flg_add)
{
  int c;
  win_1e (flg_add ? "Macros - add" : "Macros - save",
		  "Activate key", "F4   Alt-<   Alt->   Alt-?", WIN_E_Cancel);
  for (;;) {
	c = get_key ();
	switch (c) {
	case EXEMACRO:
	case TXTMAC1_KEY:
	case TXTMAC2_KEY:
	case TXTMAC3_KEY:
	  nmacro = c - EXEMACRO;
	  if (flg_add) {
		for (c = 0; c < MACMAX; c++)
		  if (macrox[nmacro][c] == -1)
			break;
		flg_sav_macro = c;
	  } else
		flg_sav_macro = 0;
	  view25 (MACRO_SS);
	  break;
	case ESC_KEY:
	case CR_KEY:
	  break;
	default:
	  continue;
	}
	break;
  }
  restore_wb ();
}

static void
sig15 (int s)
{
  (void)&s;
  flg_view_mod = 1;
  bb_signal((1 << SIGTERM), sig15);
  while (vtisthis (1) == 0)
	pause ();
  win_1e ("Signal", "Terminated", b_flg_modify ? SAVE : NULL, W_N_IC);
  if (b_flg_modify)
	if (button2ny () > 0)
	  save_all (~ESC_KEY);
  old_set (15);
}

static stdcall2 void
blk_to_del (int flg_cx)
{
  int i;
  int savblkx = buff_blk->beg_x;
  int savblkex = buff_blk->end_x;
  int ni_end = buff_blk->end_x - buff_blk->beg_x;
  long li;
  char ins;

  flg_tmp = nstr_pos;
  flg_eof = posx_str;
  ins = insert;
  if (buff_blk->typeb == 1)
	insert = 1;
  set_nl (buff_blk->beg_y, NOREVIEW);
  flg_view_mod = 0;
  put_u_context ();
  if (buff_blk->typeb == 2)
	goto repblkd;
  if (buff_blk->end_y > buff_blk->beg_y) {
	comm_down ();
	li = buff_blk->end_y - buff_blk->beg_y;
	put_u_context ();
	while (--li) {
	  if (flg_tmp > nstr_pos)
		flg_tmp--;
	  del_line ();
	  put_time (-1);
	}
	comm_up ();
	put_u_context ();
  }
  if (buff_blk->end_y != buff_blk->beg_y) {
	if (buff_blk->beg_x == 0) {
	  if (flg_tmp > nstr_pos)
		flg_tmp--;
	  del_line ();
	} else {
	  recolumn (lline (pos_cur_y));
	  i = posx_str - buff_blk->beg_x;
	  put_u_context ();
	  deleten (i);
	  comm_down ();
	}
	buff_blk->beg_x = 0;
	ni_end = buff_blk->end_x;
	put_u_context ();
  }
repblkd:
  recolumn (savblkex);
  i = ni_end;
  put_u_context ();
  if (i) {
	if (flg_tmp == nstr_pos && flg_eof > savblkex)
	  flg_eof -= i;
	deleten (i);
  }
  if (buff_blk->typeb == 2) {
	buff_blk->end_y--;
	comm_down ();
	put_u_context ();
	put_time (-1);
	if (buff_blk->end_y >= buff_blk->beg_y)
	  goto repblkd;
  }
  insert = ins;
  if (!flg_cx) {
	recolumn (savblkx);
	set_nl (buff_blk->beg_y, NOREVIEW);
  }
  put_u_context ();
  copy_scr ();
}

static void
blk_save (void)
{
  int j;

  if (!(j = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (!j) {
	posrev ();
	return;
  }
  strcpy (get_str, BLKF);
  wb_miny = &blk_save_sav_ywb;
  win_0e (sBlk, "File for block", WIN_E_OK);
  if (get_vstr (get_str, FILE_VSTR | VSTR_RWB, 0) != ESC_KEY) {
	strcpy (BLKF, get_str);
	if (scan_glob (BLKF)) {
	  flg_save_as = SAVEBLOCK;
	  save_file ();
	}
  }
}

static void
save_clip (void)
{
  int j;
  if (!(j = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (!j) {
	posrev ();
	return;
  }
  flg_save_as = SAVECLIP;
  typebclip = buff_blk->typeb;
  if (typebclip == 2)
	lenghbclip = buff_blk->end_x - buff_blk->beg_x;
  strcpy (get_str, clipboard);
  get_str[PTMPFILE] = 'C';
  unlink (get_str);
  save_file ();
}

static void
paste2 (int i)
{               /*  */
  int l;
  int l1, lp, si = i, sx;

  l = lline (pos_cur_y);
  sx = l1 = posx_str;
  home ();
  cr ();
  lp = pos_cur_y;
  up ();
  /*     i */
  if (buff_blk->beg_y == nstr_pos && buff_blk->beg_x >= l1) {
	buff_blk->beg_y++;
	buff_blk->beg_x = posx_str + buff_blk->beg_x - l1;
  }
  if (buff_blk->end_y == nstr_pos && buff_blk->end_x > l1) {
	buff_blk->end_y++;
	buff_blk->end_x = posx_str + buff_blk->end_x - l1;
  }
  for (; l1 < l; l1++) {
	buf_scr[lp][i++] = buf_scr[pos_cur_y][l1];
	buf_scr[pos_cur_y][l1] = ' ';
  }
  set_m2_syh (0, 1);
  eds[pos_cur_y++] = 1;
  nstr_pos++;
  eds[pos_cur_y] = 1;
  put_u_context ();
  {
	long llp = (((long) si) << 16) + sx;
	putdelta (&llp, UC_PAST2 | UNDO_SZ_LONG);
  }
}

static void
tmp_blk (void)
{               /*      */
  long c;

  lenghbclip = buff_blk->end_x - buff_blk->beg_x;
  optr = (unsigned char *)obuf;
  c = 0;
  ocnt = 0;
  while (blk_to_buff (c++, 0) == 1)
	ofputs (get_str);
  qcopen ();
}

static void
blk_del (void)
{
  int i;
  if (!(i = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (i) {
	view25 (WAIT_SS);
	blk_to_del (0);
	flg_vb = 0;
	flg_view_mod++;
  }
  posrev ();
  view25 (MAIN_SS);
}

static void
beg_blk (void)
{
  buff_blk->beg_y = nstr_pos;
  buff_blk->beg_x = posx_str;
  flg_vb = 1;
  buff_blk->typeb = 1;
  test_blk (0);
  if (!buff_blk->typeb)
	buff_blk->typeb = 1;
  posrev ();
}

static void
end_blk (void)
{
  if (buff_blk->beg_y > nstr_pos ||
	  (buff_blk->beg_y == nstr_pos && buff_blk->beg_x > posx_str)) {
	int j;
#ifndef lj32
	long lj32;
#endif
	lj32 = buff_blk->beg_y;
	buff_blk->beg_y = nstr_pos;
	buff_blk->end_y = lj32;
	j = buff_blk->beg_x;
	buff_blk->beg_x = posx_str;
	buff_blk->end_x = j;
  } else {
	buff_blk->end_y = nstr_pos;
	buff_blk->end_x = posx_str;
  }
  flg_vb = 1;
  test_blk (0);
  if (!buff_blk->typeb)
	buff_blk->typeb = 1;
  posrev ();
}

static void
blk_cls (void)
{
  flg_vb = !flg_vb;
  test_blk (1);
  if (!buff_blk->typeb)
	buff_blk->typeb = 1;
  posrev ();
}

static void
expblk (void)
{
  int f;
  int x_old;
  long y_old;
  int flg_review;

  x_old = posx_str;
  y_old = nstr_pos;
  f = column;

  switch (fun_arg) {
  case EXPB_PUP:
	if (!nstr_pos)
	  return;
	pup ();
	break;
  case EXPB_UP:
	if (!nstr_pos)
	  return;
	up ();
	break;
  case EXPB_HOME:
	home ();
	break;
  case EXPB_END:
	end_line ();
	break;
  case EXPB_LEFT:
	if (!x_old)
	  return;
	comm_left ();
	break;
  case EXPB_PDOWN:
	if (nstr_pos == bb_nstr_file)
	  return;
	pdown ();
	break;
  case EXPB_DOWN:
	if (nstr_pos == bb_nstr_file)
	  return;
	comm_down ();
	break;
  case EXPB_RIGHT:
	if (x_old >= (MLS - 2))
	  return;
	comm_right ();
	break;
  case EXPB_WR_KEY:
  case EXPB_WL_KEY:
	flg_ex_macro |= EOKOP;
	if (fun_arg == EXPB_WR_KEY)
	  word_plus ();
	else
	  left_word ();
	if (!flg_ex_macro)
	  return;
	break;
  }
  flg_review = (y_old != nstr_pos) || (f != column);

  f = (!flg_vb || buff_blk->end_y < 0 || buff_blk->beg_y < 0 ||
	   !buff_blk->typeb ||
	   buff_blk->end_y < buff_blk->beg_y ||
	   buff_blk->beg_x < 0 ||
	   buff_blk->end_x < 0 ||
	   buff_blk->beg_y > bb_nstr_file || buff_blk->end_y > bb_nstr_file);

  if ((!f && buff_blk->end_y < y_old) || buff_blk->beg_y > y_old ||
	  (buff_blk->typeb == 1 &&
	   buff_blk->beg_y < y_old && buff_blk->end_y > y_old)) f++;
  if (!f && buff_blk->typeb == 2) {
	if (buff_blk->beg_x >= buff_blk->end_x)
	  f++;
	else if (buff_blk->beg_x == x_old && x_old != posx_str)
	  buff_blk->beg_x = posx_str;
	else if (buff_blk->end_x == x_old && x_old != posx_str)
	  buff_blk->end_x = posx_str;
	else if (y_old != nstr_pos && buff_blk->beg_y == y_old &&
			 buff_blk->beg_y == buff_blk->end_y) {
	  if (y_old > nstr_pos)
		buff_blk->beg_y = nstr_pos;
	  else
		buff_blk->end_y = nstr_pos;
	} else if (buff_blk->beg_y == y_old && y_old != nstr_pos)
	  buff_blk->beg_y = nstr_pos;
	else if (buff_blk->end_y == y_old && y_old != nstr_pos)
	  buff_blk->end_y = nstr_pos;
	else
	  f++;
  }
  if (!f && buff_blk->typeb == 1) {
	if (buff_blk->end_y == buff_blk->beg_y &&
		buff_blk->beg_x >= buff_blk->end_x) f++;
	else if (buff_blk->beg_y == y_old && buff_blk->beg_x == x_old) {
	  buff_blk->beg_x = posx_str;
	  buff_blk->beg_y = nstr_pos;
	} else if (buff_blk->end_y == y_old && buff_blk->end_x == x_old) {
	  buff_blk->end_x = posx_str;
	  buff_blk->end_y = nstr_pos;
	} else
	  f++;
  }
  if (f) {
	buff_blk->end_y = nstr_pos;
	buff_blk->beg_y = y_old;
	buff_blk->beg_x = x_old;
	buff_blk->end_x = posx_str;
  }
  if (buff_blk->typeb == 2 || buff_blk->beg_y == buff_blk->end_y)
	if (buff_blk->beg_x > buff_blk->end_x) {
chg_x:
	  x_old = buff_blk->beg_x;
	  buff_blk->beg_x = buff_blk->end_x;
	  buff_blk->end_x = x_old;
	}
  if (buff_blk->beg_y > buff_blk->end_y) {
	y_old = buff_blk->beg_y;
	buff_blk->beg_y = buff_blk->end_y;
	buff_blk->end_y = y_old;
	goto chg_x;
  }
  if (!flg_vb)
	flg_vb = 1;
  if (buff_blk->typeb != 1)
	f++;
  if (!buff_blk->typeb)
	buff_blk->typeb = 1;
  f += flg_review;
  if (f != 0)
	posrev ();
  else
	view_str (pos_cur_y);
}

static void
pblk_beg (void)
{
  if (flg_vb != 0)
	blk_cls ();
  buff_blk->typeb = 2;
  fun_arg = EXPB_RIGHT;
  expblk ();
}

static void
blk_rus_lat (void)
{
  int c, i;
  char savi;
  int mode;

  if (!test_blk (1))
	return;
  mode = fun_arg - BLK_RUS;
  set_nl (buff_blk->beg_y, NOREVIEW);
  savi = insert;
  insert = 0;
  flg_view_mod = 0;
  view25 (WAIT_ESC_SS);
nl:
  i = buff_blk->beg_x;
nl2:
  recolumn (i);
  put_u_context ();
  if (buff_blk->typeb == 2 || nstr_pos == buff_blk->end_y)
	i = buff_blk->end_x;
  else
	i = lline (pos_cur_y);
  while (i > posx_str) {
	if (test_input () == 0) {
	  flg_ex_macro = 0;
	  goto lbrk;
	}
	c = buf_scr[pos_cur_y][posx_str];
	if (mode == 0) {                /* Lat - Rus */
	  if (c >= 34 && c < 127)
		c = rus_code[c - 34];
	} else if (mode == 1) {         /* Rus - Lat */
	  size_t j;

	  for (j = 0; j < sizeof (rus_code); j++)
		if (rus_code[j] == c) {
		  c = code[j + 34];
		  break;
		}
	} else if (mode == 2) {         /* to UpperCase */
	  c = conv_up_rus (c);
	} else {                        /* to lowerCase */
	  c = conv_low_rus (c);
	}
	u_edc (c);
  }
  if (nstr_pos == buff_blk->end_y) {
lbrk:
	insert = savi;
	flg_view_mod++;
	view25 (MAIN_SS);
	posrev ();
	return;
  }
  comm_down ();
  if (buff_blk->typeb == 2)
	goto nl;
  else {
	i = 0;
	goto nl2;
  }
}

static void
cut (void)
{
  flg_save_as = CUT;
  save_clip ();
  if (flg_save_as == CUT) {
	flg_save_as = 0;
	flg_ex_macro = 0;
	return;
  }
  blk_del ();
}

static stdcall2 int
ascii_w (int ci, int flg_x0)
{

  static const struct RESOURSE_BOX res_box_ascii[] = {
     {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR30F, COLOR30B, 0), "["},
     {RESB_COLOR | gencolor (COLOR31F, COLOR30B, 0) | RESB_NO_REPOS, brk_win},
     {RESB_COLOR | gencolor (COLOR30F, COLOR30B, 0), "]$<"},
     {RESB_SHDWN | RESB_REPEAT | 17, "$@ "},
     {RESB_DWN_SHDWN | RESB_END,     "$@"}
  };

  int i, j = 1;
  int c;
  unsigned short ascii_box[36 * 20 + 4];

  flg_x0 = flg_x0 ? 4 : 42;

  cset_atrD (1, COLOR30F, COLOR30B, 1);
  get2_box (flg_x0, 36, 3, 20, ascii_box);
  view25 (ESC_SS);
  ogotoxy (flg_x0, 3);
  put_sbox (res_box_ascii);
  for (i = 0; i < 256; i++) {
	ogotoxy (flg_x0 + 1 + ((i % 16) << 1), 4 + j);
	oputch (i != 0 ? i : ' ');
	if (((i + 1) >> 4) == j)
	  j++;
  }
  ci &= 0377;
  j = i = 0;
  for (;;) {
	ogotoxy (flg_x0 + 3, 4);
	textabk (COLOR31F, COLOR31B, 0);
	if (ci != -1) {
	  i = ci % 16;
	  j = ci >> 4;
	  c = ci;
	  ci = -1;
	} else
	  c = i + (j << 4);
	sprintf (str_all_tmp, "Dec: %-5dHex: %-5xOct: %-5o", c, c, c);
	ocputsn (str_all_tmp);
	ogotoxy (flg_x0 + 1 + (((i + (j << 4)) % 16) << 1), 5 + j);
	cset_atrD (1, COLOR32F, COLOR32B, 1);
	c = get_key ();
	cset_atrD (1, COLOR30F, COLOR30B, 0);
	if (c < 256) {
	  i = c % 16;
	  j = c >> 4;
	  continue;
	}
	switch (c) {
	case UP_KEY:
	  if (j)
		j--;
	  else
		j = 15;
	  break;
	case DOWN_KEY:
	  if (j != 15)
		j++;
	  else
		j = 0;
	  break;
	case RIGHT_KEY:
	  if (i != 15)
		i++;
	  else
		i = 0;
	  break;
	case LEFT_KEY:
	  if (i)
		i--;
	  else
		i = 15;
	  break;
	case CR_KEY:
	  i += (j << 4);
	  if (i == 0 || i == '\t' || i == '\n') {
		i = -1;
		beep ();
	  }
	  goto ret;
	case ESC_KEY:
	  i = 0;
	  goto ret;
	}
  }
ret:
  restore2_box (ascii_box);
  view25 (MAIN_SS);
  return i;
}


static const EF fun_edit[] = {
  up, down, left, right, pdown, pup, cr_ask, tab,
  delete2, del_line,
  delupcur2, btab, input_buf,
  expblk, expblk, expblk, expblk, expblk, expblk,
  blk_copy, in_clip, formator,
  word_plus, in_clip_conv,
  find_f, find_a, refind,
  exemacro, exemacro, exemacro, exemacro,
  left_word,
  form_text, calc, calc, calc, calc, calc,
  undo, redo, expblk, expblk,
  /*   -  */
  home, end_line,
  scr_review, top, save_file, bottom, home0,
  shell,
  save_as, expblk, begmacro,
  help_view, beg_blk, end_blk, blk_move,
  blk_save, blk_del, blk_cls,
  load_file, save_clip,
  addmacro, ascii_view,
  man,
  calcv,
  form_set, centr_right_str, centr_right_str, pblk_beg,
  blk_rus_lat, blk_rus_lat, blk_rus_lat, blk_rus_lat,
  cut, delbeg,
  setx_pos, setx_pos, setx_pos, setx_pos, setx_pos, setx_pos, setx_pos,
  setx_pos, setx_pos, setx_pos,
  gotox_pos, gotox_pos, gotox_pos, gotox_pos, gotox_pos, gotox_pos, gotox_pos,
  gotox_pos, gotox_pos, gotox_pos,
  shcom,
  crus_lat, calt, cinsert,
  set_filex, set_filex, set_filex, set_filex, set_filex, set_filex,
  set_filex, set_filex, set_filex,
  v_old_s,
  open_fun, delf_fun, find_z, goto_line, move_xy_blk, move_xy_blk,
  repeat, fun_save, menu, main_drp, form_blk, avt_param_form,
  beep, er_dic, expblk,
  beep,
};

/*
	     UNIX,
	    kbscanco.c */

struct KTAB
{
  const char *str_ctrl;
  int ret_ctrl;
};

static const struct KTAB ktab[] = {
  { "\033", ESC_KEY     },         /* ESC ESC   */
  { "[A",   UP_KEY      },         /*           */
  { "[B",   DOWN_KEY    },         /*           */
  { "[C",   RIGHT_KEY   },         /* ->        */
  { "[1;5C",WORD_P_KEY  },         /* Ctrl -> */
  { "[D",   LEFT_KEY    },         /* <-        */
  { "[1;5D",LEFT_WORD   },         /* Ctrl <- */
  { "[H",   HOME_KEY    },
  { "[F",   END_KEY     },         /* End       */
  { "[[D",  EXEMACRO    },         /* F4        */
  { "[14~", EXEMACRO    },         /* F4        */
  { "[P",   EXEMACRO    },         /* F4        */
  { "OS",   EXEMACRO    },         /* F4 */
  { "[2~",  INSERT_FUN  },         /* Ins       */
  { "[[A",  HELP_KEY    },         /* F1        */
  { "[11~", HELP_KEY    },         /* F1        */
  { "OP",   HELP_KEY    },         /* F1        */
  { "[6~",  PDOWN_KEY   },         /* Page Down */
  { "[[E",  REPEAT_KEY  },         /* F5        */
  { "[15~", REPEAT_KEY  },         /* F5        */
  { "[Q",   REPEAT_KEY  },         /* F5        */
  { "[28~", GLINE_KEY   },         /* Shift F5  */
  { "[15;2~",GLINE_KEY  },         /* Shift F5  */
  { "[5~",  PUP_KEY     },         /* Page Up   */
  { "[L",   INSERT_FUN  },         /* Ins       */
  { "[2;5~",IN_CLIP     },         /* Ctrl Ins  */
  { "[M",   HELP_KEY    },         /* F1        */
  { "[G",   PDOWN_KEY   },         /* Page Down */
  { "[I",   PUP_KEY     },         /* Page Up   */
  { "[Z",   BTAB_KEY    },         /* Shift Tab */
  { "[f",   SHELL_KEY   },         /* Shift F10 */
  { "[d",   FORMS_KEY   },         /* Shift F8  */
  { "[Y",   PBLK_KEY    },         /* Shift F3  */
  { "O2R",  PBLK_KEY    },         /* Shift F3  */
  { "[X",   SAVE_AS_K   },         /* Shift F2  */
  { "O2Q",  SAVE_AS_K   },         /* Shift F2  */
  { "[O",   OPEN_KEY    },         /* F3        */
  { "OR",   OPEN_KEY    },         /* F3 */
  { "[b",   BEGTXTM_KEY },         /* Shift F6  */
  { "[R",   BEGMACRO    },         /* F6        */
  { "[V",   MENU_KEY    },         /* F10       */
  { "[N",   SAVE_NO_R   },         /* F2        */
  { "OQ",   SAVE_NO_R   },         /* F2 */
  { "[T",   CENTR_KEY   },         /* F8        */
  { "[W",   OPEN_FUN    },         /* F11       */
  { "[r",   NOT_SAVE    },         /* Ctrl F12  */
  { "[U",   RUS_LAT_FUN },         /* F9        */
  { "[e",   ALT_FUN     },         /* Shift F9  */
  { "[S",   -SET_FILE1  },         /* F7        */
  { "[c",   REFIND_KEY  },         /* Shift F7  */
  { "[q",   ASCII_KEY   },         /* Ctrl F11  */
  { "[26~", IN_CLIP2    },         /* Shift F4  */
  { "O2S",  IN_CLIP2    },         /* Shift F4  */
  { "[34~", SHELL_KEY   },         /* Shift F10 */
  { "[32~", FORMS_KEY   },         /* Shift F8  */
  { "[25~", PBLK_KEY    },         /* Shift F3  */
  { "\r",   GOTO_LINE   },         /* Alt-Enter */
  { "a",    ASCII_KEY   },         /* Alt-a     */
  { "x",    NOT_SAVE    },         /* Alt-x     */
  { "0",    OPEN_KEY    },         /* Alt-0     */
  { "1",    SET_FILE1   },         /* Alt-1     */
  { "2",    SET_FILE2   },         /* Alt-2     */
  { "3",    SET_FILE3   },         /* Alt-3     */
  { "4",    SET_FILE4   },         /* Alt-4     */
  { "5",    SET_FILE5   },         /* Alt-5     */
  { "6",    SET_FILE6   },         /* Alt-6     */
  { "7",    SET_FILE7   },         /* Alt-7     */
  { "8",    SET_FILE8   },         /* Alt-8     */
  { "9",    SET_FILE9   },         /* Alt-9     */
  { "<",    TXTMAC1_KEY },         /* Alt-<     */
  { ">",    TXTMAC2_KEY },         /* Alt->     */
  { "/",    TXTMAC3_KEY },         /* Alt-/     */
  { "=",    CALCV_KEY   },         /* Alt-=     */
  { "\b",   UNDO_KEY    },         /* Alt-Bs    */
  { "\177", UNDO_KEY    },         /* Alt-Bs    */
  { "s",    U_C('') },
  { "r",    U_C('') },
  { "b",    U_C('') },
  { "e",    U_C('') },
  { "w",    U_C('') },
  { "g",    U_C('') },
  { "l",    U_C('') },
  { "f",    U_C('') },
  { "o",    U_C('') },
  { "n",    U_C('') },
  { "d",    U_C('') },
  { "p",    U_C('') },
  { "c",    OUT_CLIP },
  { "y",    U_C('') },
  { "k",    U_C('') },
  { "[1~",  HOME_KEY    },         /* Home      */
  { "[1;5~",HOME0_KEY   },         /* Ctrl Home */
  { "[1;5H",HOME0_KEY   },         /* Ctrl Home */
  { "[3~",  DELUPCUR    },         /* Delete    */
  { "[24~", SAVE_AS_K   },         /* Shift F2  */
  { "[[C",  OPEN_KEY    },         /* F3        */
  { "[13~", OPEN_KEY    },         /* F3        */
  { "[29~", BEGTXTM_KEY },         /* Shift F6  */
  { "[17;2~",BEGTXTM_KEY },        /* Shift F6  */
  { "[4~",  END_KEY     },         /* End       */
  { "[17~", BEGMACRO    },         /* F6        */
  { "[12~", SAVE_NO_R   },         /* F2        */
  { "[21~", MENU_KEY    },         /* F10       */
  { "[[B",  SAVE_NO_R   },         /* F2        */
  { "[12~", SAVE_NO_R   },         /* F2        */
  { "[19~", CENTR_KEY   },         /* F8        */
  { "[23~", OPEN_FUN    },         /* F11       */
  { "[20~", RUS_LAT_FUN },         /* F9        */
  { "[33~", ALT_FUN     },         /* Shift F9  */
  { "[18~", -SET_FILE1  },         /* F7        */
  { "[31~", REFIND_KEY  }          /* Shift F7  */
};

static const short code[128] = {
/*    ^A         ^B         ^C         ^D          ^E       ^F          ^G  */
0, SCR_REVIEW, BOTTOM_KEY, BLK_COPY, OPEN_KEY, EXPB_UP, EXPB_LEFT, EXPB_DOWN,
/* ^H   */
  DELETE_KEY,
/* ^I        ^J      ^K     ^L        ^M       ^N           ^O */
  TAB_KEY, GOTO_LINE, 0, REFIND_KEY, CR_KEY, EXPB_RIGHT, LEFT_WORD,
/* ^P      ^Q    ^R     ^S    ^T        ^U        ^V        ^W       ^X */
  EXPB_END, 0, REDO_KEY, 0, TOP_KEY, HOME0_KEY, BTAB_KEY, IN_CLIP, OUT_CLIP,
/*      ^Y         ^Z         ^[        ^\ */
  DEL_LINE_KEY, WORD_P_KEY, ESC_KEY, TXTMAC1_KEY,
/* ^]          ^^      ^_  */
  FIND_Z, TXTMAC2_KEY, TXTMAC3_KEY,
  ' ', '!', 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
  50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,
  65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80,
  81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98, 99,
  100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112, 113, 114,
  115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, DELETE_KEY
};

static int
get_term_decode_key (void)
{
  int pos_S, c;
  char bufk[8];
  size_t nktab;

  c = pos_S = -1;
  nktab = 0;
new_get:
  bufk[++c] = getch ();
  pos_S++;
  for (; nktab < ((sizeof ktab) / sizeof (struct KTAB)); nktab++) {
recmp:
	if (*(ktab[nktab].str_ctrl + pos_S) == bufk[pos_S]) {
	  if (!*(ktab[nktab].str_ctrl + pos_S + 1)) {
		pos_S = ktab[nktab].ret_ctrl;
		if (pos_S < 0) {
		  c = getch ();
		  if (c >= '1' && c <= '9')
			return (-pos_S + c - '1');
		  return (ESC_KEY);
		}
		return (pos_S);
	  } else {
		if (c > pos_S) {
		  pos_S++;
		  goto recmp;
		}
		goto new_get;
	  }
	}
	pos_S = 0;
  }
  return (ESC_KEY);
}

#define mac_ret(MK) { c=(MK); goto ret; }

static int
get_key (void)
{
  int c;

  if ((flg_ex_macro & EMACRO) != 0) {
	c = macrox[nmacro][flg_p_macro[nmacro]++];
	goto ret2;
  }

  while (kbhit () == 0) {
	t_fflush ();
	put_time (1);
  }

  c = getch ();
  if (c == '\013')                              /* CTRL K - bloks command */
	mac_ret (BLK_FUN);
  if (c == '\021')                              /* Ctrl Q - find-command */
	mac_ret (FIND_FUN);

  if (c == 033) {
	c = get_term_decode_key ();
	mac_ret (c);
  }
  if (c >= 0200)
	mac_ret (c);
  if (code[c] >= 256)
	mac_ret (code[c]);
  if ((flg_rus & ALT) && c >= 65)
	mac_ret (alt_code[c - 65]);
  if ((flg_rus & RUS) && c >= 34)
	mac_ret (rus_code[c - 34]);
  mac_ret (code[c]);
ret:
  if (flg_sav_macro != -1) {
	if (flg_sav_macro < (MACMAX - 1))
	  macrox[nmacro][flg_sav_macro++] = c;
	else {
	  win_err ("Macros buffer", "overflow", 0);
	  macrox[nmacro][flg_sav_macro] = -1;
	  flg_sav_macro = -1;
	  view25 (MAIN_SS);
	}
  }
ret2:
  return (c);
}

static void
oexit (void)
{
  clipboard[PTMPFILE] = 'C';
  unlink (clipboard);
  form_file[PTMPFILE] = 'F';
  unlink (form_file);
  swap_file[PTMPFILE] = 'S';
  unlink (swap_file);
}

static void
old_set_sig (void)
{
  bb_signal((1 << SIGFPE), SIG_DFL);
  close (fd_swap);
  bb_signal( (1 << SIGINT) | (1 << SIGTERM) | (1 << SIGQUIT), SIG_DFL);
}

static stdcall2 void
old_set (int excode)
{
  unset_alarm ();
  textabk (COLOR0F, COLOR0B, 0);
  oclrscr ();
  wb_miny = NULL;
  psav = 0;
  tcursorvisible (1);
  t_fflush ();
  vtscanclose ();
  re_reset = 0;
  if (excode >= 0) {
	exit (excode);
  }
}

static char up0w[]   = "$n";
static char down0w[] = "$n";
static struct RESOURSE_BOX roset_w0[] = {
  {RESB_COLOR | gencolor (COLOR6F, COLOR6B, 0), up0w},
  {0, ""},
  {RESB_NO_REPOS | RESB_END, down0w},
};


static stdcall2 void
reset (int sig)
{
  if (sig > 0) {
	bb_signal((1 << SIGTERM), sig15);
	bb_signal( (1 << SIGINT) | (1 << SIGQUIT), SIG_IGN);
  }
  vtscaninit ();
  settss ();    /*        screen saver */
  textabk (COLOR1F, COLOR1B, 0);
  if (!sig) {
	re_reset = 1;
	cursor (NOCURSOR);
	pos_val_file = posx_val_file = -2;
	oclrscr ();
	wb_miny = NULL;
	psav = 0;

	/* WXsize -   */
	up0w[2] = down0w[2] = WXsize - 2 + ' ';
	roset_w0[1].flg = RESB_REPEAT | SIZE_W;

	put_sbox (roset_w0);
	cur_x = 35;
	ocputsn ("<$H>");
	ogotoxy (WXsize, 2);
	scroller (SIZE_W - 2);
	ogotoxy (3, 1);
	textabk (COLOR6F, COLOR6B, 1);
	oputch ('[');
	textabk (COLOR11F, COLOR11B, 0);
	oputch (brk_win[0]);
	textabk (COLOR6F, COLOR6B, 1);
	oputch (']');
	textabk (COLOR35F, COLOR35B, 0);
	oputch (' ');
	view_lstr ((files_st[pnfiles].filesav[0] == 0 ? NONAME :
			   (const char *)files_st[pnfiles].filesav), 0);
	oputch (' ');
	ogotoxy (63, 1);
	textabk (COLOR6F, COLOR6B, 1);
	oputch ('[');
	textabk (COLOR11F, COLOR11B, 0);
	oputch (pnfiles + '1');
	textabk (COLOR6F, COLOR6B, 1);
	oputch (']');
	setoverscan (flg_rus & ALT ? 'G' : flg_rus ? 'R' : 'L');
	view25 (MAIN_SS);
	review_scr (REVIEW);
  }
}

static void
set_filex (void)
{
  int n;
  n = fun_arg - SET_FILE1;
  if (pnfiles == n)
	return;
  if (n > nfiles) {
	flg_ex_macro = 0;
	return;
  }
  set_nfile (n);
}

static stdcall2 void
set_nfile (int n)
{
  int i;
  struct FILES_ST *ff;

  unload ();
  pnfiles = n;
  bpnfiles = 1 << n;
  ff = &files_st[n];
  buff_blk = &ff->blk;
  kqbs = ff->skqbsp.dkqbs;
  kqbp = ff->skqbsp.dkqbp;
  bb_nstr_file = ff->nstr_file;
  gswapnstr ();

/*    undo  */
  p_ustf0 = &ustf0[pnfiles];
  p_sizeuswap = &sizeuswap[pnfiles];
  p_cur_posu = &cur_posu[pnfiles];

  if (IS_LOAD () != 0 || (IS_DSK () != 0 && IS_CREAT () == 0)) {
	flg_vb = ff->flg_s & FLG_ACTIVB;
	flg_synt_highl = ff->flg_s & 0xf;
	nstr_pos = ff->f_nstr_pos;
	pos_cur_y = ff->f_pos_cur_y;
	if (nstr_pos < 0 || nstr_pos > bb_nstr_file)
	  goto bad_sav_pos;
	else {
	  if (pos_cur_y >= SIZE_W)
		pos_cur_y = SIZE_W >> 1;
	  if (IS_LOAD () == 0)
		recolumn (ff->f_posx_str);
	  else {
		posx_str = ff->f_posx_str;
		pos_cur_x = ff->f_pos_cur_x;
		column = ff->f_column;
	  }
	}
  } else if (IS_LOAD () == 0) {
	buff_blk->beg_x = buff_blk->end_x = 0;
	buff_blk->beg_y = buff_blk->end_y = 0;
	buff_blk->typeb = 0;
	for (i = 0; i < N_KQB; i++)
	  kqbs[i] = -1;
bad_sav_pos:
	nstr_pos = 0;
	flg_vb = 0;
	pos_cur_y = 0;
	column = 0;
	posx_str = 0;
	pos_cur_x = 0;
	flg_synt_highl = 0;
  }
  SET_ACTIV ();
  SET_LOAD ();
  UNSET_DSK ();
  reset (0);
  save_glob_context ();
  save_u_context ();
}


static stdcall2 stf
find_head (long y)
{
  stf head;
  long yi;

  if (y > bb_nstr_file)
	return ((stf) 0);
  yi = y - save_stf_cur_nstr;
  if (yi >= 0)
	head = save_stf_cur_list;
  else {
	head = stf0;
	yi = y;
  }
  while (yi-- > 0)
	head = head->over;
  save_stf_cur_list = head;
  save_stf_cur_nstr = y;
  return (head);
}

	/* "" ,    stf */
static stdcall2 void
freemems (stf st)
{
  st->over = mem_free_root;
  mem_free_root = st;
}

#define VALGET 128

#define AMEM_STF(ms)    ms*sizeof(stfkernel)

static stf
memstf (void)
{                       /*     stf */
  stf st;

  if (mem_free_root != NULL) {
	st = mem_free_root;
	mem_free_root = mem_free_root->over;
	return (st);
  } else {
	if (!mem_size_gen) {
	  for (mem_size_gen = VALGET; mem_size_gen; mem_size_gen >>= 1)
		if ((beg_mem = malloc(AMEM_STF(mem_size_gen))) != NULL)
		  goto ok_allok;
	  /* ,   */
	  if (swap_free != NULL) {
		/*    */
		st = swap_free;
		swap_free = swap_free->over;
		return (st);
	  }
	  win_err (bb_msg_memory_exhausted, NULL, 0);
	  /*   ,     */
	  beg_mem = (stf) str_all_tmp;
	  mem_size_gen = MLS / sizeof (stfkernel);
	  save_all (~ESC_KEY);
	}
  }
ok_allok:
  st = beg_mem;
  beg_mem++;
  mem_size_gen--;
  return (st);
}

	/*         */
static void
swap_gen (unsigned n, stf st)
{
  stf gen;
  stf pred;

  for (pred = gen = swap_free; gen != NULL; gen = gen->over) {
	if (gen->swap_lenght >= n) {    /*    */
	  st->asl.adr_swap = gen->asl.adr_swap;
	  if ((gen->swap_lenght - n) > sizeof (union A_S_L)) {
		/*  */
		gen->asl.adr_swap += n;
		gen->swap_lenght -= n;
		st->swap_lenght = n;
	  } else {
		st->swap_lenght = gen->swap_lenght;
		if (gen == swap_free)
		  swap_free = swap_free->over;
		else
		  pred->over = gen->over;
		freemems (gen);
	  }
	  io_seek (st->asl.adr_swap);
	  return;
	}
	pred = gen;
  }
  /*     */
  st->asl.adr_swap = ioseekend ();
  st->swap_lenght = n;
  size_swap += n;
}

static stdcall2 void
getstext (stf cur)
{
  if (cur->swap_lenght == 0) {
	memcpy(gets_text, cur->asl.small_str, sizeof(long));
	gets_text[sizeof(long)] = '\0';
  } else {
	io_seek (cur->asl.adr_swap);
	str_r_ioc ();
  }
}

static stdcall2 void
sfree (stf st)
{                       /*     */
  stf gen_st;
  unsigned int l = st->swap_lenght;

  if (l == 0)
	return;
  if (swap_free == NULL) {
not_found:           /*        */
	gen_st = memstf ();
	gen_st->over = swap_free;
	swap_free = gen_st;
	gen_st->swap_lenght = l;
	gen_st->asl.adr_swap = st->asl.adr_swap;
	return;
  }
  /*         */
/*   */
  for (gen_st = swap_free; gen_st != NULL; gen_st = gen_st->over)
	if ((gen_st->asl.adr_swap + gen_st->swap_lenght) ==
		st->asl.adr_swap)
	  /*       */  {
	  if (((long) gen_st->swap_lenght + (long) l) <= 0xffffl) {
		/* lenght <= MAXUSHORT */
lpp:
		gen_st->swap_lenght += l;
		return; /*      */
	  }
	  break;
	  }
/*   */
  for (gen_st = swap_free; gen_st != NULL; gen_st = gen_st->over)
	if ((st->asl.adr_swap + (t_adr_swap)l) == gen_st->asl.adr_swap) {
	  if (((long) gen_st->swap_lenght + (long) l) <= 0xffffl) {
		gen_st->asl.adr_swap -= l;
		goto lpp;
	  }
	  goto not_found;
	}
  goto not_found;
}

	/*  ""      str */
static stdcall2 void
memstr (const char *str, stf st)
{
  int l;
  l = strlen (str);
  if (l <= (int)sizeof(long)) {
	memcpy(st->asl.small_str, str, sizeof(long));
	st->swap_lenght = 0;
  } else {
	l++;
	swap_gen ((unsigned int)l, st);
	write_cb (str, l);
  }
}

static stdcall2 void
all_free (stf stf0sf)
{
  stf st;
  for (st = stf0sf; stf0sf != NULL;) {
	st = st->over;
	sfree (stf0sf);
	freemems (stf0sf);
	stf0sf = st;
  }
}
			/*   */

static void
put_xbuff (void *xbuff, long sb, int sz)
{
  io_seek (sb);
  write_cb (xbuff, sz);
  if (seek_io > size_swap)
	size_swap = seek_io;
}

/*   ,       help */

static internal_function void
put_buff_swap (int nb)
{
  put_xbuff (shelp, (long) sizeof (shelp) * nb, sizeof (shelp));
}

static internal_function void
get_buff_swap (int nb)
{
  io_seek (sizeof (shelp) * nb);
  read_cb (shelp, sizeof (shelp));
}


	/*    */

static void
put_scr_buff_swap (void)
{
  put_xbuff (buf_scr, OFF_0, SIZ_OFF_1);
}

static void
get_scr_buff_swap (void)
{
  io_seek (OFF_0);
  read_cb (buf_scr, SIZ_OFF_1);
}

			/*  UNDO */

static stf ufind_head (long);

static stf
ufind_head (long y)
{
  int nbu, i;
  stf head;
  stf prev_head;

  i = nbu = y / U_BLK;
  prev_head = head = *p_ustf0;
  if (head != NULL && i) {
	head = head->over;
	while (--nbu > 0) {
	  prev_head = head;
	  head = head->over;
	}
  }
  if (head == NULL) {
	head = memstf ();
	head->over = NULL;
	swap_gen (U_BLK, head);
	if (i == 0)
	  *p_ustf0 = head;
	else
	  prev_head->over = head;
  }
  return (head);
}

static stdcall2 void
write_b_u (const char *buff, int nbytes)
{
  stf head;
  long y;
  int nb, b1;

  for (y = *p_cur_posu, nb = y % U_BLK; nbytes > 0;) {
	head = ufind_head (y);
	io_seek (head->asl.adr_swap + nb);
	b1 = 0;
	do {
	  nb++;
	  nbytes--;
	  b1++;
	  y++;
	  if (*p_sizeuswap < y)
		(*p_sizeuswap)++;
	  if ((nb %= U_BLK) == 0)
		break;
	} while (nbytes);

	write_cb (buff, b1);
	buff += b1;
	*p_cur_posu = y;
  }
}

static void
read_b_u (void *pbuff, int nbytes)
{
  stf head;
  long y;
  int nb, b1;
  char *buff = pbuff;

  for (y = *p_cur_posu, nb = y % U_BLK; nbytes > 0;) {
	head = ufind_head (y);
	io_seek (head->asl.adr_swap + nb);
	b1 = 0;
	do {
	  nb++;
	  nbytes--;
	  b1++;
	  y++;
	  if ((nb %= U_BLK) == 0)
		break;
	} while (nbytes);

	read_cb (buff, b1);
	buff += b1;
	*p_cur_posu = y;
  }
}

static void
u_del_file (void)
{
  int p = pnfiles;

  all_free (*p_ustf0);
  for (; p < (NFILES - 1); p++) {
	ustf0[p] = ustf0[p + 1];
	cur_posu[p] = cur_posu[p + 1];
	sizeuswap[p] = sizeuswap[p + 1];
  }
  ustf0[NFILES - 1] = NULL;
  cur_posu[NFILES - 1] = sizeuswap[NFILES - 1] = 0;
}
/*
		     winbox

	    -  goto. 19 
*/



static stdcall2 int
get_vstr (char *old_str, unsigned flg_hist, int righ_word)
{
  int c, poss;
  int l, poss0;
  int last_key = -1;
  int px;
  int save_righ_word = righ_word;
  char flg_first;
  int arg_v25;
  int ins;
  ins = 1;
  flg_first = 1;
  arg_v25 = (flg_hist & H_VSTR) == 0 ? VSTR_NH_SS :
	(flg_hist & TAB_RET) ? VSTR_OPT_SS : VSTR_SS;

  view25 (arg_v25);
ldell_reget:
  righ_word = save_righ_word;
  ogotoxy (25, 14 + *wb_miny - 12 + ((flg_hist & DOWN2_VSTR) ? 2 : 0));
  if ((flg_hist & RIGH_WORD) != 0) {
	textabk (COLOR42F, COLOR42B, 0);
	oputch ('<');
  } else {
	textabk (COLOR15F, COLOR15B, 0);
	oputch (' ');
  }
  if ((flg_hist & H_VSTR) != 0) {
	cur_x = 53;
	textabk (COLOR25F, COLOR25B, 0);
	oputch ('>');
  }
end_key:
  l = strlen (old_str);
  poss = l;
  if (l > 26) {
	poss0 = l - 26;
	px = 52;
  } else {
	poss0 = 0;
	px = 26 + poss;
  }
reget:
  ogotoxy (26, 14 + *wb_miny - 12 + ((flg_hist & DOWN2_VSTR) ? 2 : 0));
  set_offs_sn ();
  if (poss0 == 0) {
	textabk (COLOR15F, COLOR15B, 0);
	putch_next (' ');
  }
  if (!flg_first)
	textabk (COLOR20F, COLOR20B, 0);        /* change color not first key */
  else
	textabk (COLOR19F, COLOR19B, 1);
  if (poss0 != 0)
	putch_next ('<');
  for (c = poss0; old_str[c] != '\0' && (c - poss0) < 26; c++)
	putch_next (old_str[c]);
  if (old_str[c] != '\0')
	putch_next ('>');
  else {
	textabk (COLOR20F, COLOR20B, 0);
	while ((c - poss0) != 27) {
	  putch_next (' ');
	  c++;
	}
	if (flg_first && old_str[0] != 0)
	  textabk (COLOR19F, COLOR19B, 1);
  }
  if ((flg_hist & NO_GetKey) != 0)
	goto ret_mouse;
  cur_x = px;
cur_get:
  if (last_key != -1) {
	c = last_key;
	last_key = -1;
  } else {
	cursor (ins == 0 ? FULLCURSOR : NORMCURSOR);
	do
	  c = get_key ();
	while (c == 0);
	cursor (NOCURSOR);
  }
  if (c == INSERT_FUN) {
	ins ^= 1;
	goto cur_get;
  }
  if (c == RUS_LAT_FUN || c == ALT_FUN) {
	(*((EF) fun_edit[c - UP_KEY])) ();
	goto cur_get;
  }
  if (c == DOWN_KEY) {
	if ((flg_hist & H_VSTR) == 0)
	  goto err_key;
	/*   */
	inhis (old_str, INHISTORY | flg_hist);
	view25 (arg_v25);
	if (old_str[0] == 0)
	  goto ldell_reget;
end2_key:
	flg_first = 0;
	goto end_key;
  }
  if (c == ESC_KEY || c == CR_KEY) {
esc_exit:
	if ((flg_hist & VSTR_RWB) != 0)
	  restore_wb ();
esc_exit2:
	if (!(flg_hist & NDES))         /*    */
	  while (l > 0 && old_str[--l] == ' ')
		old_str[l] = '\0';
	if (c == CR_KEY && old_str[0] == '\0') {
	  if ((flg_hist & FILE_VSTR) != 0) {
		old_str[0] = '*';
		old_str[1] = 0;
	  } else if (old_str != str_replace)
		c = ESC_KEY;
	}
	if (c != ESC_KEY && (flg_hist & H_VSTR) != 0)
	  inhis (old_str, TOHISTORY | flg_hist);
	view25 (MAIN_SS);
	goto ret_mouse;
  }
  if (c == TAB_KEY) {
	if ((flg_hist & TAB_RET) == 0)
	  goto err_key;
	else
	  goto esc_exit2;
  }
  if (c == MOVE_KEY) {
	wbmove ();
	view25 (arg_v25);
	goto reget;
  }
  if (c == DELUPCUR) {
	if (flg_first)
	  goto ldell;
	if (poss != l) {
	  for (c = poss; c < l; c++)
		old_str[c] = old_str[c + 1];
	  l--;
	}
refirst:
	flg_first = 0;
	goto reget;
  }
  if (c == DELETE_KEY) {
	if (poss == 0)
	  goto err_key;
del_end_sp:
	poss--;
	if (!ins)
	  old_str[poss] = ' ';
	else {
	  for (c = poss; c < l; c++)
		old_str[c] = old_str[c + 1];
	  l--;
	}
left_cur:
	px--;
	if (poss0 != 0 && px < 27) {
	  poss0--;
	  px++;
	}
	goto refirst;
  }
  if (c == LEFT_KEY) {
	if (poss == 0)
	  goto err_key;
	if (poss == l && old_str[poss - 1] == ' ')
	  goto del_end_sp;
	poss--;
	goto left_cur;
  }
  if (c == RIGHT_KEY) {
	if (poss >= (MLS - 1)) {
err_key:
	  beep ();
	  goto reget;
	}
	if (poss == l) {
	  if ((flg_hist & RIGH_WORD) != 0) {
		old_str[poss] = buf_scr[pos_cur_y][righ_word++];
		old_str[poss + 1] = '\0';
		c = 0;
		l++;
	  } else
		goto refirst;
	}
right_key:
	poss++;
	px++;
	if (px > 52) {
	  px--;
	  poss0++;
	}
	if (c == 0)
	  goto reget;
	goto refirst;
  }
  if (c == DEL_LINE_KEY) {
ldell:
	old_str[0] = '\0';
	l = 0;
home_key:
	poss = 0;
	poss0 = 0;
	px = 26;
	if (c == HOME_KEY || c < 256)
	  goto refirst;
	goto ldell_reget;
  }
  if (c == HOME_KEY)
	goto home_key;
  if (c == END_KEY)
	goto end2_key;
  if (c == ASCII_KEY) {
	c = ascii_w (old_str[poss], poss > 13);
	view25 (arg_v25);
	if (c <= 0)
	  goto reget;
  }
  if (c == U_C ('') /* Alt-O */ ) {
	c = CR_KEY;
	goto esc_exit;
  }
  if (c > 255)
	goto err_key;
  {
	int i;
	for (i = 0; buff_altk[i]; i++)
	  if (c == (unsigned char)buff_altk[i])
		goto esc_exit2;
  }
  if (poss >= (MLS - 1))
	goto err_key;
  if (flg_first) {
	last_key = c;
	goto ldell;
  }
  if (!ins) {
sym:
	old_str[poss] = c;
	if (poss == l) {
	  l++;
	  old_str[l] = '\0';
	}
	goto right_key;
  } {
	int i;
	for (i = l++; i >= poss; i--)
	  old_str[i + 1] = old_str[i];
  }
  goto sym;
ret_mouse:
  return (c);
}
		/*    */
static void putshis (const char *, int);

static void
putshis (const char *ph, int lx)
{
  int i = 0;
  if (*ph == 0) {
	ocputs ("<Empty>");
	return;
  }
  if (lx > 28) {
	oputch ('<');
	ph += lx - 27;
	i++;
  }
  for (; *ph && i < 28; i++)
	oputch (*ph++);
  if (*ph)
	putch_next ('>');
  else {
	textabk (COLOR17F, COLOR17B, 0);
	while (i < 29) {
	  oputch (' ');
	  i++;
	}
  }
}
				/*   */
static stdcall2 void
inhis (char *old_str, int mode)
{
  int i, c;
  char *namehistory;
  unsigned short box_history[33 * (NHIS + 3) + 4];
  int nb;
  int lx;
  int nhis;

  switch (mode & H_VSTR) {
  case FIND_VSTR:
	namehistory = "find ";
	nb = FIND_HIS;
	break;
  case FILE_VSTR:
	namehistory = "@s ";
	nb = FILE_HIS;
	break;
  case CALC_VSTR:
	namehistory = "calc ";
	nb = CALC_HIS;
	break;
  case REPL_VSTR:
	namehistory = "replace ";
	nb = REPL_HIS;
	break;
  case MAN_VSTR:
	namehistory = "helps ";
	nb = MAN_HIS;
	break;
  default:
	namehistory = "commands ";
	nb = SHELL_HIS;
  }
  get_buff_swap (nb);
  for (i = 0; i < NHIS; i++)
	if (strcmp (buff_history (i), old_str) == 0)
	  break;
  if (i > 0 && *old_str != 0) {
	if (i == NHIS)
	  for (i = NHIS - 1; i > 0; i--)
		strcpy (buff_history (i), buff_history (i - 1));
	else
	  strcpy (buff_history (i), buff_history (0));
	strcpy (buff_history (0), old_str);
  }
  if ((mode & INHISTORY) != 0) {
	view25 (HIST_SS);
	get2_box (24, 33, 15 + *wb_miny - 12, (NHIS + 3), box_history);
	ogotoxy (24, 15 + *wb_miny - 12);
	textabk (COLOR17F, COLOR17B, 0);
	ocputsn ("[ ]$:");
	cur_x = 25;
	textabk (COLOR2F, COLOR2B, 0);
	oputch (brk_win[0]);
	cur_x = 29;
	ocputsnt ("History:");
	ocputsn (namehistory);
	nhis = NHIS;
	for (i = NHIS - 1; i >= 0; i--)
	  if (buff_history (i)[0] == 0)
		nhis--;
	  else
		break;
	if (nhis == NHIS)
	  nhis--;
	i = 0;
rev_h:
	textabk (COLOR17F, COLOR17B, 0);
	for (c = 0;; c++) {
	  ogotoxy (24, c + 16 + *wb_miny - 12);
	  if (c > nhis)
		break;
	  ocputs2n ("$= ");
	  cur_x = 24;
	  putshis (buff_history (c), strlen (buff_history (c)));
	}
	ocputs3n ("$=");
rep:
	lx = strlen (buff_history (i));
lrep2:
	ogotoxy (25, i + 16 + *wb_miny - 12);
	textabk (COLOR18F, COLOR18B, 1);
	putshis (buff_history (i), lx);
	c = get_key ();
	cur_x = 24;
	cset_atrD (29, COLOR17F, COLOR17B, 0);
	switch (c) {
	case LEFT_KEY:
	  if (lx > 28)
		lx--;
	  goto lrep2;
	case RIGHT_KEY:
	  if (lx < (int)strlen (buff_history (i)))
		lx++;
	  goto lrep2;
	case HOME_KEY:
	  while (lx > 28)
		lx--;
	  goto lrep2;
	case END_KEY:
	  goto rep;
	case ESC_KEY:
esc:
	  restore2_box (box_history);
	  break;
	case UP_KEY:
	  if (--i < 0)
		i = nhis;
	  goto rep;
	case DOWN_KEY:
	  if (++i > nhis)
		i = 0;
	  goto rep;
	case CR_KEY:
	  strcpy (old_str, buff_history (i));
	  goto esc;
	case DEL_LINE_KEY:
	  if (buff_history (i)[0] == 0)
		goto rep;
	  for (c = i; c < (NHIS - 1); c++)
		strcpy (buff_history (c), buff_history (c + 1));
	  buff_history (NHIS - 1)[0] = 0;
	  restore_box (24, 33, 16 + *wb_miny - 12, (NHIS + 2),
				   &box_history[33 + 4]);
	  if (nhis != 0) {
		nhis--;
		if (i > nhis)
		  i--;
	  }
	  goto rev_h;
	default:
	  goto rep;
	}
  }
  put_buff_swap (nb);
}



static stdcall2 void set_flstr (int);


static stdcall2 void
oacputs (const char *s)
{
  int c;
  cur_x = x_centr (s) - 1;
  while ((c = *s) != 0) {
	oputch (c);
	s++;
	if (c == '(') {
	  textabk (COLOR24F, COLOR24B, 1);
	  while (*s != ')')
		oputch (*s++);
	  textabk (COLOR14F, COLOR14B, 0);
	}
  }
}

static stdcall2 void
win_1e (const char *str_titl,
		const char *str_mesg_e1,
		const char *str_mesg_e2, int flg)
{
  win_e (str_titl, str_mesg_e1, str_mesg_e2, NULL, flg);
}

static stdcall2 void
win_0e (const char *str_titl,
		const char *str_mesg_e1, int flg)
{
  win_1e (str_titl, str_mesg_e1, NULL, flg);
}

static stdcall2 void
win_err (const char *str_mesg_e1,
		 const char *str_mesg_e2, int flg)
{
  win_1e (ERROR, str_mesg_e1, str_mesg_e2, flg | WIN_E_PSAK);
}


static void
restore_wb (void)
{
  if (psav) {
	restore2_box (mem_winbox);
	psav--;
	wb_miny = NULL;
  }
}


static stdcall2 char *
view_flstr (const char *str)
{
  int l;
  l = strlen (str);
  return strcpy (p_flsrt, &str[l > 30 ? l - 30 : 0]);
}

static stdcall2 void
set_flstr (int y)
{
  int l;
  const char *psfl;
  textabk (COLOR8F, COLOR8B, 1);
  l = strlen (psfl = p_flsrt);
  if (l == 0)
	l = strlen (psfl = NONAME);
  if (l > 29) {
	ogotoxy (25, y);
	oputch (17);
	ocputs (&psfl[l - 28]);
  } else {
	ogotoxy (x_centr (psfl), y);
	ocputs (psfl);
  }
  textabk (COLOR14F, COLOR14B, 0);
}


static stdcall2 void
win_e (const char *str_titl,
	   const char *str_mesg_e1,
	   const char *str_mesg_e2,
	   const char *str_mesg_e3, int flg)
{
  int i, y;

  if (wb_miny == NULL) {
	ssav_ywb = 12;
	wb_miny = &ssav_ywb;
  }
  y = *wb_miny;
  if (!psav) {
	i = 7 + (flg & (W_8 | W_9)) / W_8;
	if (wb_miny == &ywb_wf)
	  i += 3 + (flg_replace ? 2 : 0);       /* +  */
	get2_box (24, 34, y, i, mem_winbox);
	psav++;
  }
  textabk (COLOR15F, COLOR15B, 0);
  for (i = y;; i++) {
	ogotoxy (24, i);
	if (i == y) {
	  ocputsn (sS3n_u);
	  if ((flg & W_N_IC) == 0) {
		cur_x = 25;
		oputch ('[');
		textabk (COLOR11F, COLOR15B, 0);
		oputch (brk_win[0]);
		textabk (COLOR15F, COLOR15B, 0);
		oputch (']');
	  }
	  if (str_titl != NULL) {
		cur_x = x_centr (str_titl) - 2;
		ocputsnt (str_titl);
	  }
	  continue;
	}
	if (i == (y + 5 + (flg & (W_8 | W_9)) / W_8)) {
	  ocputs3n (sS3n_d);
	  break;
	}
	ocputs2n (sS3n_m);
  }
  wb_maxy = cur_y;
  wb_maxy++;
  y++;
  textabk (COLOR14F, COLOR14B, 0);
  if (str_mesg_e1 != NULL) {
	cur_y = y - 1;
	oacputs (str_mesg_e1);
  }
  y++;
  if ((flg & WB_SFS2) != 0) {
	set_flstr (y);
	y++;
  }
  if (str_mesg_e2 != NULL) {
	cur_y = y - 1;
	oacputs (str_mesg_e2);
  }
  y++;
  if ((flg & WB_SFS3) != 0) {
	set_flstr (y);
	y++;
  }
  if (str_mesg_e3 != NULL) {
	cur_y = y - 1;
	oacputs (str_mesg_e3);
  }
  y++;
  if ((flg & WB_SFS4) != 0)
	set_flstr (y);
  y = wb_maxy - 2;
  if (flg & WIN_E_PSAK) {
	but1ysax (y, PSAK, x_centr (PSAK), 1);
	any (0);
  }
  if (flg & (WIN_E_OK | WIN_E_Cancel))
	but1ysaxc (y, (flg & WIN_E_Cancel) ? sESC : OK);
}

static void
wbmove (void)
{
  unsigned short mem_wbmove[32 * 13 + 4];
  int c, i, a;
  int sm;

  sm = flg_sav_macro;

  a = wb_maxy;
  view25 (MOVEWB_SS);
  textabk (COLOR11F, COLOR15B, 0);
  i = *wb_miny;
  for (;;) {
	get2_box (24, 32, i, a - i + 1, mem_wbmove);
	while (i <= a) {
	  ogotoxy (24, i);
	  if (i == *wb_miny || i == a) {
		oputch (i == a ? U_C ('') : U_C (''));
		for (c = 25; c < 24 + 31; c++)
		  oputch (U_C (''));
		oputch (i == a ? U_C ('') : U_C (''));
	  } else {
		oputch (U_C (''));
		cur_x = 54;
		oputch (U_C (''));
	  }
	  i++;
	}
	i = *wb_miny;
	do
	  c = get_key ();
	while (c == 0);
	switch (c) {
	case DOWN_KEY:
	  if (a != (SIZE_W + 2)) {
		a++;
		i++;
	  }
	  break;
	case UP_KEY:
	  if (i != 1) {
		i--;
		a--;
	  }
	  break;
	case ESC_KEY:
	case CR_KEY:
	  restore2_box (mem_wbmove);
	  if (sm != -1)
		flg_sav_macro = sm - 1;
	  return;
	}
	restore2_box (mem_winbox);
	get2_box (24, 34, i, a - i + 2, mem_winbox);
	mem_wbmove[2] = i;
	mem_wbmove[3] = a - i + 1;
	restore2_box (mem_wbmove);
	*wb_miny = i;
	wb_maxy = a;
	for (c = i + 1; c <= a; c++) {
	  ogotoxy (24 + 32, c);
	  cset_atr (2, DARKGRAY);
	}
	ogotoxy (25, c);
	cset_atr (33, DARKGRAY);
  }
}

static stdcall2 int
x_centr (const char *s)
{
  return (40 - (strlen (s) >> 1));
}

static stdcall2 void
but1ysaxc (int y, const char *sw)
{
  but1ysax (y, sw, x_centr (sw), 0);
}

static stdcall2 int
button2 (int actb, const char *sb1,
		 const char *sb2, int any_arg)
{
  int x, l1;

  l1 = strlen (sb1) + 3;
  x = 40 - ((l1 + strlen (sb2)) >> 1);
  but1ysax (wb_maxy - 2, actb == 0 ? sb1 : sb2, x + actb * l1, 1);
  but1ysax (wb_maxy - 2, actb != 0 ? sb1 : sb2, x + (!actb) * l1, 0);
  return (any (any_arg));
}

static stdcall2 int
button3 (int *actb, const char *sb1, const char *sb2,
		    const char *sb3, int any_arg)
{
  int x, l1, l2;
  int ret;

  l1 = strlen (sb1) + 3;
  l2 = strlen (sb2) + 3;
  x = 40 - ((l1 + l2 + strlen (sb3)) >> 1);
  for (;;) {
	but1ysax (wb_maxy - 2, *actb == 0 ? sb1 : *actb == 1 ? sb2 : sb3,
		    x + ((*actb == 1) * l1) + ((*actb == 2) * (l1 + l2)), 1);
	but1ysax (wb_maxy - 2, *actb != 0 ? sb1 : sb2,
			  x + ((*actb == 0) * l1), 0);
	but1ysax (wb_maxy - 2, *actb == 2 ? sb2 : sb3,
			  x + l1 + ((*actb != 2) * l2), 0);
	ret = any (any_arg);
	if (ret == '\t') {
	  (*actb)++;
	  if (*actb == 3)
		*actb = 0;
	  continue;
	}
	if (ret == LEFT_KEY) {
	  (*actb)--;
	  if (*actb < 0)
		*actb = 2;
	  continue;
	}
	return ret;
  }
}

static int
button2ny (void)
{
  int c, actb;
  actb = 0;
  for (;;) {
	c = button2 (actb, sYes, sNo, 22);
	switch (c) {
	case 0:
	case 1:
	  break;
	case '\t':
	  actb = !actb;
	  continue;
	default:
	  c = !actb;
	  break;
	}
	break;
  }
  restore_wb ();
  return c;
}

static stdcall2 int
button3ny (int flg_space)
{
  int actb;
  int c;

  actb = 0;
  c = button3 (&actb, sYes, sNo, sESC, flg_space ? 32 | 20 | 64 : 20 | 64);
  switch (c) {
  case 0:
  case 1:
  case -1:
  case ' ':
	break;
  default:
	switch (actb) {
	case 0:
	case 1:
	  c = !actb;
	  break;
	default:
	  c = -1;
	  break;
	}
  }
  restore_wb ();
  return c;
}

static stdcall2 void
but1ysax (int y, const char *sw, int x, int flg_act)
{
  if (flg_act)
	textabk (COLOR22F, COLOR22B, 1);
  else
	textabk (COLOR23F, COLOR23B, 0);
  ogotoxy (x, y);
  ocputs (sw);
  if (flg_act == 0) {
	textabk (COLOR22F, COLOR22B, 1);
	while (*sw == ' ') {
	  sw++;
	  flg_act++;
	}
	if (*sw == '(') {
	  sw++;
	  flg_act++;
	  cur_x = x + flg_act - 1;
	  while (*sw != ')') {
		oputch (*sw);
		sw++;
	  }
	} else {
	  if ((int)U_C(*sw) < 128) {                      /*    */
		cur_x = x + flg_act - 1;
		oputch (*sw);
	  }
	}
  }
}

static stdcall2 void
put_sbox (const struct RESOURSE_BOX *pres)
{
  int x;
  int rep;
  x = cur_x;

  for (;; pres++) {
	rep = -1;
lrep:
	if ((pres->flg & RESB_COLOR) != 0)
	  cur_attr = pres->flg & 0xff;
	if ((pres->flg & RESB_SHDWN) != 0)
	  ocputs2n (pres->info);
	else if ((pres->flg & RESB_DWN_SHDWN) != 0)
	  ocputs3n (pres->info);
	else {
	  if ((pres->flg & RESB_TITLE) != 0)
		ocputsnt (pres->info);
	  else
		ocputsn (pres->info);
	}
	if ((pres->flg & RESB_NO_REPOS) == 0) {
	  cur_x = x;
	  cur_y++;
	}
	if ((pres->flg & RESB_REPEAT) != 0) {
	  if (rep < 0)
		rep = pres->flg & 0xff;
	  rep--;
	  if (rep > 0)
		goto lrep;
	}
	if ((pres->flg & RESB_COLOR_END) != 0)
	  cur_attr = pres->flg & 0xff;
	if ((pres->flg & RESB_END) != 0)
	  break;
  }
}

static stdcall2 char *
str1cat (char *s, char c)
{
  char *sold = s;
  while (*s)
	s++;
  *s++ = c;
  *s = '\0';
  return sold;
}

static stdcall2 int
mathscrollbar (long cur_nstr_pos, int sw, long nstr)
{

  textabk (COLOR6F, COLOR6B, 0);
  if (cur_nstr_pos == 0)
	return -1;
  else
	return cur_nstr_pos * sw / nstr;
}

static stdcall2 void
form_d (int parm)
{
  sprintf (str_rez, "%d", parm);
}

static void
gen_name_bak (void)
{
  int len, j;
  int k;
  char *nsf;

  nsf = files_st[pnfiles].filesav;
  j = -1;
  for (len = 0; (k = nsf[len]) != '\0'; len++) {
	str_rez[len] = (char) k;
	if (k == SLASHC)
	  j = len;
  }
  if ((len - j) > 254)
	len = j + 254;
  str_rez[len] = '~';
  str_rez[len + 1] = '\0';
}

static void
g_space_f (void)
{                       /*    -  */
  char *str = gets_text;
  char *str2 = get_str;

  memset (str2, ' ', MLS - 1);
  while (*str == '\t') {
	str2 += 8;
	str++;
  }
  while (*str)
	*str2++ = *str++;
}

static void
reconv_space (void)
{
  char *str = get_str;
  int i, k;

  i = strlen (str);
  while (i != 0 && str[i - 1] == ' ')
	str[--i] = '\0';
  for (i = 0; str[i] == ' '; i++);
  if ((i >>= 3)) {
	for (k = 0; k < i; k++)
	  *str++ = '\t';
	i = (i << 3) - k;
	while (str[i]) {
	  *str = str[i];
	  str++;
	}
	*str = '\0';
  }
}

/*
	
*/

#define DEC_XTERM 0


static const struct RESOURSE_BOX box_parm_txt[] = {
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR27F, COLOR27B, 0), "[",},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR11F, COLOR27B, 0), brk_win,},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR27F, COLOR27B, 0), "]",},
  {RESB_COLOR | RESB_NO_REPOS | RESB_TITLE | gencolor (COLOR28F, COLOR28B, 1),
   "Editor Options"},
  {RESB_COLOR | gencolor (COLOR27F, COLOR27B, 0), ""},
  {RESB_SHDWN, " Time for on     [0-60](min)"},
  {RESB_SHDWN, "  screen saver$. "},
  {RESB_SHDWN, "  autosaving$0 "},
  {RESB_SHDWN, " Save desktop$/ "},
  {RESB_SHDWN, " Tab positions$. "},
  {RESB_SHDWN, " Syntax higlihting...$' "},
  {RESB_DWN_SHDWN | RESB_END,       "$<"}
};

static stdcall2 void
put_parm (int arg)
{
  const char *ps;

  cur_x = 48;
  if (arg <= 0)
	ps = af_on_off[-arg];
  else {
	ps = str_rez;
	sprintf (str_rez, " %4d", arg);
  }
  ocputs (ps);
  cur_y++;
}

static void
eparm (void)
{
  int y, c;
  unsigned short textparam_wbox[28 + 4];
  int sm;
  char *p_parm;
  int sav_flg_synt_highl;
  int chk;
  int *p_tparm;

  sm = flg_sav_macro;
  if (sm != -1)
	sm--;
  flg_sav_macro = -1;
  get2_box (25, 34, 3, 10 - DEC_XTERM, shelp);
  ogotoxy (25, 3);
  put_sbox (box_parm_txt);
  y = sav_yparm;
  sav_flg_synt_highl = flg_synt_highl;
re_update:
  view25 (CHG_PARM_SS);
  textabk (COLOR29F, COLOR29B, 0);
  cur_y = 4;
  put_parm (timessstart / 60);
  put_parm (timesasstart / 60);
  put_parm (-flg_no_sd);
  put_parm (user_tab);
  for (;;) {
	get2_box (26, 28, y, 1, textparam_wbox);
	ogotoxy (26, y);
	cset_atrD (28, COLOR41F, COLOR41B, 1);
	c = get_key ();
	restore2_box (textparam_wbox);
	switch (c) {
	case UP_KEY:
	  if (y == 5)
		y = 9 - DEC_XTERM;
	  else
		y--;
	  break;
	case DOWN_KEY:
	  if (y == (9 - DEC_XTERM))
		y = 5;
	  else
		y++;
	  break;
	case CR_KEY:
	case ' ':
	case TAB_KEY:
	  switch (y) {
	  case 5:
		p_tparm = &timessstart;
		p_parm = "Screen saver";
		goto new_time_parm;
	  case 6 - DEC_XTERM:
		p_tparm = &timesasstart;
		p_parm = "Autosave";
	  new_time_parm:
		form_d (*p_tparm / 60);
		wb_miny = &eparm_sav_ywb;
		win_e (p_parm, "Time activation (min.)", NULL,
			   "0 - switch off", W_8 | WIN_E_OK);
		c = *p_tparm;
		do {
		  if (get_vstr (str_rez, 0, 0) == ESC_KEY) {
			*p_tparm = c;
			goto new_parm;
		  }
		  chk = atoi (str_rez) * 60;
		} while (chk < 0 || chk > 3600);
		*p_tparm = chk;
new_parm:
		restore_wb ();
		goto re_update;
	  case 8 - DEC_XTERM:
		form_d (user_tab);
		wb_miny = &eparm_sav_ywb;
		win_e ("Tab pos", "Position for", "tabs", NULL, W_8 | WIN_E_OK);
		c = user_tab;
		do {
		  if (get_vstr (str_rez, 0, 0) == ESC_KEY) {
			user_tab = c;
			goto new_parm;
		  }
		  chk = atoi (str_rez);
		} while (chk <= 1 || chk > 255);
		user_tab = chk;
		goto new_parm;
	  default:
		wb_miny = &eparm_sav_ywb;
		win_1e ("Options", "Save desktop", "before exit", 0);
		p_parm = &flg_no_sd;
		for (;;) {
		  c = button2 (*p_parm, baf_on_off[0], baf_on_off[1], 20);
		  if (c == 2 || c == -1)
			break;
		  if (c == 1 || c == 0) {
			*p_parm = c;
			break;
		  } else
			*p_parm ^= 1;
		}
		goto new_parm;
	  case 9 - DEC_XTERM:
		wb_miny = &eparm_sav_ywb;
		win_e ("Higlihting",
			   "Syntax higlihting",
			   "(0)No (1)++", "(2)ASM (3)DBase", W_9 | WIN_E_Cancel);
		c = any (256 | 8);
		switch (c) {
		case '0':
		case '1':
		case '2':
		case '3':
		  flg_synt_highl = c - '0';
		}
		break;
	  }
	case END_KEY:
	case PDOWN_KEY:
	  y = 9 - DEC_XTERM;
	  break;
	case HOME_KEY:
	case PUP_KEY:
	  y = 5;
	  break;
	case ESC_KEY:
	  goto ret_esc;
	}
  }
ret_esc:
  sav_yparm = y;
  flg_sav_macro = sm;
  view25 (MAIN_SS);
  restore2_box (shelp);
  if (sav_flg_synt_highl != flg_synt_highl)
	posrev ();
}


	/*       */
#define MAX_num_ipdown 16

static const char spopup[] = "\
  File   Edit            Blocks Find   Calc         Formater  Window  Other   ";


static const char * const pdowm_n[] = {
  "Files$* F3$' ",
  "Save$+ F2$' ",
  "Save as...     Shift-F2 ",
  "Close     Ctrl-Shift-F3 ",
  "Quit$+ Alt-X$$ ",
  "Go to line ...$( Ctrl-Entr ",
  "Delete begin line     Ctrl-O$$ ",
  "Repeat do...          F5$( ",
  "Undo$2 Alt-BS$$ ",
  "Redo$2 Ctrl-R$$ ",
  "Draw tables$+ Shift-F5  ",
  "Begin typical$* Ctrl-K-B  ",
  "Begin square-ware      Ctrl-K-X  ",
  "End block$. Ctrl-K-K  ",
  "Copy$3 Ctrl-C$$ ",
  "Move$3 Ctrl-V$$ ",
  "Hide/unhide$, Ctrl-K-H  ",
  "Save block to @...  Ctrl-K-W  ",
  "Load block from @.. Ctrl-K-R  ",
  "Cut to clipboard$' Alt-C$% ",
  "Save to clipboard$& Shift-Del ",
  "Paste from clipboard$# Ctrl-W    ",
  "Insert witch change ty Shift-F4  ",
  "Latin to russian       Ctrl-K-U  ",
  "Russian to translit    Ctrl-K-L  ",
  "TO UPPER SYMBOLS$' Ctrl-K-^  ",
  "to lower symbols$' Ctrl-K-v  ",
  "Find$- F7$' ",
  "Find and replace Ctrl-Q-A ",
  "Next find        Ctrl-L   ",
  "Find math  (){[  Ctrl-]   ",
  "Calc$3 Alt-=$$ ",
  "Sum block              Ctrl-K-+ ",
  "Substract block        Ctrl-K-- ",
  "Multiply in block      Ctrl-K-* ",
  "Divide in block        Ctrl-K-/ ",
  "Calulate block$) Ctrl-K-= ",
  "Formator options$' Shift-F8 ",
  "Sample (first line)$$ Ctrl-F3  ",
  "Format paragraph$' Ctrl-F8  ",
  "Format text$, Ctrl-F9  ",
  "Format in block        Ctrl-F6  ",
  "Center line$, F8$' ",
  "Left line              Cl-St-F8 ",
  "Next window$) F11$$ ",
  "System screen       CSt-F5 ",
  "Help$0 F1$% ",
  "Redraw/reset screen Ctrl-A ",
  "Editor options      F10$' ",
  "English-russian dic Ctrl-F12  ",
  "Ascii table$) Ctrl-F11$\" ",
  "Call shell          Shift-F10 ",
  "Call shell command  Ctrl-F10  ",
#define INC_M_UNIX 1
  "Call man$, Ctrl-F1   ",
};


	/*  x      */
static const char xpos_popup[I_P_M + 1] = {
  3, 10, 26, 33, 40, 53, 63, 71, 79
};

	/*  x     */
static const char xpos_pdown[I_P_M] = { 1, 8, 24, 31, 38, 41, 46, 43, };

	/*      */
static const char num_ipdown[I_P_M] = { 5, 6, 16, 4, 6, 7, 4, 5 + INC_M_UNIX,
};

static const char noff_ipdown[I_P_M] = {
  0, 5, 5 + 6, 5 + 6 + 16, 5 + 6 + 16 + 4, 5 + 6 + 16 + 4 + 6,
  5 + 6 + 16 + 4 + 6 + 7,
  5 + 6 + 16 + 4 + 6 + 7 + 4
};

	/*      */
static const char len_infdwn[I_P_M] = { 25, 33, 34, 27, 33, 33, 28, 31, };
static const char uimbox[] = " $X ";
static const char dimbox[] = " $X ";

	/*         */
static const EF fun_m_edit[I_P_M][MAX_num_ipdown] = {
  { load_file, save_file, save_as, delf_fun, fun_save, },

  { goto_line, delbeg, repeat, undo, redo, main_drp, },

  { beg_blk, pblk_beg, end_blk, blk_copy, blk_move, blk_cls, blk_save,
    input_buf, save_clip, cut, in_clip,
    in_clip_conv, blk_rus_lat, blk_rus_lat, blk_rus_lat, blk_rus_lat, },

  { find_f, find_a, refind, find_z, },

  { calcv, calc, calc, calc, calc, calc, },

  { form_set, avt_param_form, formator, form_text, form_blk,
    centr_right_str, centr_right_str, },

  { open_fun, v_old_s, help_view, scr_review, },

  { eparm,  er_dic, ascii_view, shell, shcom, man, },
};

static const short fun_m_arg[I_P_M][MAX_num_ipdown] = {
  { OPEN_KEY, SAVE_NO_R, SAVE_AS_K, DELF_FUN, NOT_SAVE, },

  { GOTO_LINE, DELBEG_KEY, REPEAT_KEY, UNDO_KEY, REDO_KEY, GLINE_KEY, },

  { BEG_BLK, PBLK_KEY, END_BLK, BLK_COPY, BLK_MOVE, BLK_CLS, BLK_SAVE,
    INPUT_BUF, OUT_CLIP, CUT_KEY, IN_CLIP, IN_CLIP2, BLK_RUS, BLK_LAT,
    BLK_UPC, BLK_LOWC },

  { FINDF_KEY, FINDA_KEY, REFIND_KEY, FIND_Z },

  { CALCV_KEY, CALC1_KEY, CALC2_KEY, CALC3_KEY, CALC4_KEY, CALC5_KEY, },

  { FORMS_KEY, AVT_FPRM_KEY, FORM_KEY, FORM_TEXT, FORM_BLK_KEY,
    CENTR_KEY, RIGHT_STR, },

  { OPEN_FUN, VIEW_OLD_S, HELP_KEY, SCR_REVIEW, },

  { MENU_KEY, ERDIC, ASCII_KEY, SHELL_KEY, SHCOM_KEY, MAN_KEY, },
};


static void
menu (void)
{
  int sm = flg_sav_macro;
  int i, c;
  unsigned short text1line[78 + 4];

  if (sm != -1)
	sm--;
  flg_sav_macro = -1;
  get2_box (2, 78, 2, 1, text1line);
  view25 (MENU_SS);
  ogotoxy (2, 2);
  textabk (COLOR46F, COLOR46B, 0);
  ocputsn (spopup);
  bflg_noasm[0] = (IS_VONLY () || IS_MODIFY () == 0) ? 2 : 0; /*   */
  bflg_noasm[1] = 0;
  bflg_noasm[1] |= posx_str == 0 ? 2 : 0;       /*   */
  bflg_noasm[1] |= utell (1) == 0 ? 8 : 0;      /* Undo */
  bflg_noasm[1] |= utell (0) == 0 ? 16 : 0;     /* Redo */
  bflg_noasm[2] = flg_vb != 0 && test_blk (-1) != 0 ? 0 :       /*   */
	8 | 16 | 64 | 256 | 512 | 4096 | 8192 | 16384 | 32768;
  bflg_noasm[3] = 0;
  bflg_noasm[3] |= str_find[0] != 0 ? 0 : 4;
  find_z ();                            /*     {}[]() */
  bflg_noasm[3] |= fun_arg == 0 ? 8 : 0;
  bflg_noasm[4] = bflg_noasm[2] == 0 ? 0 : 2 | 4 | 8 | 16 | 32 | 64;    /*   */
  bflg_noasm[5] = bflg_noasm[4] == 0 ? 0 : 16;
  bflg_noasm[6] = nfiles == 0 ? 1 : 0;
  bflg_noasm[7] = 2 | 32;    /*       */
  c = 0;
  for (;;) {
	if (c == 0) {   /*      */
	  char uimbox_buf[8], dimbox_buf[8];
	  ogotoxy (c = xpos_popup[sav_popup], 2);
	  cset_atrD (xpos_popup[sav_popup + 1] - c, COLOR47F, COLOR47B, 1);
	  /*   */
	  textabk (COLOR46F, COLOR46B, 0);
	  c = xpos_pdown[sav_popup];
	  cur_x = c;
	  cur_y = 2;
	  get2_box (c + 1, len_infdwn[sav_popup] + 6,
				3, num_ipdown[sav_popup] + 3, shelp);
	  strcpy(uimbox_buf, uimbox);
	  strcpy(dimbox_buf, dimbox);
	  uimbox_buf[3] = dimbox_buf[3] = len_infdwn[sav_popup] + ' ';
	  ocputsn (uimbox_buf);
	  for (i = 0;; i++) {
		cur_x = c;
		cur_y++;
		if (i == num_ipdown[sav_popup])
		  break;
		ocputs ("  ");
		ocputsn (pdowm_n[noff_ipdown[sav_popup] + i]);
		ocputs2n (" ");
		cur_x = c + 2;
		if ((bflg_noasm[sav_popup] & (1 << i)) == 0)
		  cset_atrD (len_infdwn[sav_popup], COLOR46F, COLOR46B, 0);
		else
		  cset_atrD (len_infdwn[sav_popup], COLOR48F, COLOR46B, 0);
	  }
	  ocputs3n (dimbox_buf);
	}
	/*    */
	ogotoxy (xpos_pdown[sav_popup] + 3, sav_pos_menu[sav_popup] + 4);
	i = len_infdwn[sav_popup];
	if ((bflg_noasm[sav_popup] & (1 << sav_pos_menu[sav_popup])) == 0)
	  cset_atrD (i, COLOR47F, COLOR47B, 1);
	else
	  cset_atrD (i, COLOR48F, COLOR48B, 0);
	c = get_key ();
	switch (c) {
	case LEFT_KEY:
	  i = sav_popup;
	  sav_popup--;
	  if (sav_popup < 0)
		sav_popup = I_P_M - 1;
	  c = 0;
	  break;
	case RIGHT_KEY:
	  i = sav_popup;
	  sav_popup++;
	  if (sav_popup == I_P_M)
		sav_popup = 0;
	  c = 0;
	  break;
	case CR_KEY:
emu_enter:
	  if ((bflg_noasm[sav_popup] & (1 << sav_pos_menu[sav_popup])) != 0)
		continue;
	  c = 0;
	  goto brk_loop;
	case ESC_KEY:
	  goto brk_loop;
	case DOWN_KEY:
	  i = sav_pos_menu[sav_popup];
	  sav_pos_menu[sav_popup]++;
	  if (sav_pos_menu[sav_popup] == num_ipdown[sav_popup])
		sav_pos_menu[sav_popup] = 0;
	  break;
	case UP_KEY:
	  i = sav_pos_menu[sav_popup];
	  sav_pos_menu[sav_popup]--;
	  if (sav_pos_menu[sav_popup] < 0)
		sav_pos_menu[sav_popup] = num_ipdown[sav_popup] - 1;
	  break;
	case HOME_KEY:
	  i = sav_pos_menu[sav_popup];
	  sav_pos_menu[sav_popup] = 0;
	  break;
	case END_KEY:
	  i = sav_pos_menu[sav_popup];
	  sav_pos_menu[sav_popup] = num_ipdown[sav_popup] - 1;
	  break;
	default:
	  for (i = 0; i < num_ipdown[sav_popup]; i++)
		if (c == fun_m_arg[sav_popup][i]) {
		  sav_pos_menu[sav_popup] = i;
		  goto emu_enter;
		}
	}
	if (c) {        /*       */
	  if ((bflg_noasm[sav_popup] & (1 << i)) == 0)
		cset_atrD (len_infdwn[sav_popup], COLOR46F, COLOR46B, 0);
	  else
		cset_atrD (len_infdwn[sav_popup], COLOR48F, COLOR46B, 0);
	} else {
	  /*     */
	  restore2_box (shelp);
	  /*      .  */
	  ogotoxy (xpos_popup[i], 2);
	  cset_atrD (xpos_popup[i + 1] - xpos_popup[i], COLOR46F, COLOR46B, 0);
	}
  }
brk_loop:               /*   */
  flg_sav_macro = sm;
  restore2_box (shelp);
  restore2_box (text1line);
  view25 (MAIN_SS);
  if (c == 0) {         /*    */
	c = sav_pos_menu[sav_popup];
	fun_arg = fun_m_arg[sav_popup][c];
	if (fun_arg != UNDO_KEY && fun_arg != REDO_KEY)
	  save_u_context ();
	if (sm != -1)
	  macrox[nmacro][flg_sav_macro++] = fun_arg;
	poscur ();
	(*((EF) fun_m_edit[sav_popup][c])) ();;
  }
}

static void
scr_review (void)
{
  reset (0);
  chkmodf ();
}

static void
word_plus (void)
{
  int i;

reword:
  i = get_word (get_str, 0);
  if (i != posx_str)
	while (i > posx_str)
	  comm_right ();
  else {
	if (lline (pos_cur_y) > i) {
	  comm_right ();
	  goto reword;
	} else {
	  if (nstr_pos < bb_nstr_file) {
		down ();
		home ();
		goto reword;
	  }
	}
	flg_ex_macro = 0;
  }
  posrev ();
}

static void
left_word (void)
{
  int i, l;

  /*    */
  get_str[0] = 0;
  i = get_word (get_str, 0);
  if (get_str[0] != 0) {
	l = strlen (get_str) - (i - posx_str);
	if (l) {
l_ok:
	  while (l--)
		comm_left ();
	  goto ret;
	}
  }
  for (;;) {                    /*    */
	if (posx_str) {
	  comm_left ();
	  get_str[0] = 0;
	  i = get_word (get_str, 0);
	  if (get_str[0] != 0) {
		l = strlen (get_str) - (i - posx_str);
		goto l_ok;
	  }
	} else {
	  if (nstr_pos == 0)
		goto ret;
	  comm_up ();
	  end_line ();
	}
  }
ret:
  posrev ();
}

static void
man (void)
{
  help_view ();
}

static stdcall2 void
up_d (long delta_up)
{
  while (delta_up-- > 0)
	comm_up ();
  put_u_context ();
}

static int
comm_down (void)
{
  if (nstr_pos == bb_nstr_file) {
	end_line ();
	return flg_ex_macro = 0;
  }
  if (pos_cur_y == (SIZE_W - 1)) {
	chget (0);
	bsscroll (0);
	nstr_pos++;
	chtsget ((SIZE_W - 1));
	return 1;
  } else {
	pos_cur_y++;
	nstr_pos++;
	return 0;
  }
}



static void
comm_cr (void)
{
#ifndef lj32
  long lj32;
#endif
  int j;

  if (pos_cur_y == (SIZE_W - 1)) {
	chget (0);
	bsscroll (0);
  } else {
	chget ((SIZE_W - 1));
	for (j = (SIZE_W - 2); j > pos_cur_y; j--) {
	  memcpy (buf_scr[j + 1], buf_scr[j], MLS);
	  eds[j + 1] = eds[j];
	}
	pos_cur_y++;
  }
  memset (buf_scr[pos_cur_y], ' ', (MLS - 1));
  set_m2_syh (0, 2);
  eds[pos_cur_y] = 0;
  lj32 = ++nstr_pos;
  if (lj32 > bb_nstr_file)
	load_list (SNULL);
  else
	ins_list (lj32 - 1);
}

static stdcall2 int
get_word (char *stw, int flg_no_rus)
{
  return get_word2 (stw, buf_scr[pos_cur_y], posx_str, flg_no_rus);
}

static stdcall2 void
set_nl (long lp, int flg_review)
{
  long ln;

  ln = lp - nstr_pos + pos_cur_y;
  if (ln > bb_nstr_file)
	return;
  if (ln >= 0 && ln < SIZE_W) {
	pos_cur_y = ln;
	nstr_pos = lp;
	if (flg_review)
	  posrev ();
	else
	  poscur ();
  } else {
	copy_scr ();
	pos_cur_y = lp > 12 ? 12 : lp;
	nstr_pos = lp;
	review_scr (flg_review);
  }
}

static stdcall2 int
lline (int line)
{
  /*   line       */
  int j;
  char *ptr = buf_scr[line];
  for (j = (MLS - 2); j >= 0 && ptr[j] == ' '; j--);
  return (++j);
}


static void ibb (void);

static void
input_buf (void)
{
  strcpy (get_str, flg_save_as ? clipboard : BLKF);
  if (flg_save_as)
	get_str[PTMPFILE] = 'C';
  if (flg_save_as > 0)
	goto no_open;
  if (flg_save_as < 0)
	goto load_c;
  else
	buff_blk->typeb = 1;
  wb_miny = &input_buf_sav_ywb;
  win_0e (sBlk, "Output file", WIN_E_OK);
  if (get_vstr (get_str, FILE_VSTR | VSTR_RWB, 0) != ESC_KEY) {
	strcpy (BLKF, get_str);
	if (!scan_glob (BLKF))
	  return;
load_c:
	if (!ofopen (get_str, IOR)) {
	  if (!flg_save_as) {
		view_flstr (get_str);
		win_err (can_t_open, MFILE, WB_SFS3 | W_8);
	  }
	  return;
	}
no_open:
	view25 (WAIT_SS);
	ibb ();
	posrev ();
  }
}

static void
blk_copy (void)
{
  int i;

  if (!(i = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (i) {
	view25 (WAIT_SS);
	tmp_blk ();
	ibb ();
  }
  posrev ();
}

static void
blk_move (void)
{
  long scy;
  int xs;

  if (!(xs = flg_vb))
	flg_vb = 1;
  if (!test_blk (1))
	return;
  if (xs) {
	view25 (WAIT_SS);
	tmp_blk ();
	scy = -nstr_pos + pos_cur_y;
	blk_to_del (1);
	posx_str = flg_eof;
	nstr_pos = flg_tmp;
	scy += nstr_pos;
	if (scy < 0 || scy > (SIZE_W - 1))
	  scy = 12;
	pos_cur_y = scy > nstr_pos ? nstr_pos : scy;
	recolumn (posx_str);
	put_u_context ();
	review_scr (NOREVIEW);
	ibb ();
  }
  posrev ();
}

static void
ibb (void)
{
  int x;
  int c;
  int flg_cr_already;

  fun_arg = BLK_FUN;                    /*  u_edc */
  flg_view_mod = 0;
  buff_blk->beg_y = nstr_pos;
  x = buff_blk->beg_x = posx_str;
  flg_cr_already = 0;
  put_u_context ();
  while ((c = Qogetc ()) != EOF) {
	if (c == '\n') {
	  if (buff_blk->typeb == 2 || !insert) {
		if (buff_blk->typeb == 2) {
		  flg_ex_macro |= EOKOP;
		  while ((posx_str - x) < lenghbclip && flg_ex_macro != 0)
			u_edc (' ');
		}
		if (nstr_pos == bb_nstr_file) {
		  insert++;
		  cr ();
		  insert--;
		}
		recolumn (buff_blk->typeb == 2 ? x : 0);
		if (nstr_pos != bb_nstr_file)
		  comm_down ();
		put_u_context ();
	  } else if (flg_cr_already == 0) {
		if (lline (pos_cur_y) > posx_str)
		  paste2 (0);
		else
		  cr ();
		/* home0() */
		column = posx_str = pos_cur_x = 0;
		put_u_context ();
	  } else {
		flg_cr_already--;
		comm_down ();
		/* home0() */
		column = posx_str = pos_cur_x = 0;
		put_u_context ();
	  }
	} else {
	  if (buff_blk->typeb == 1 && insert != 0 &&
		  buf_scr[pos_cur_y][MLS - 2] != ' ') {
		flg_cr_already = posx_str;
		if (lline (pos_cur_y) > posx_str)
		  paste2 (0);
		else
		  cr ();
		recolumn (flg_cr_already);
		flg_cr_already = 1;
		comm_up ();
		put_u_context ();
	  }
	  if (c == '\t') {
		tabx (8);
		put_u_context ();
	  } else
		u_edc (c);
	}
  }
  ofclose ();
  if (buff_blk->typeb == 2) {
	flg_ex_macro |= EOKOP;
	while ((posx_str - x) < lenghbclip && flg_ex_macro != 0)
	  u_edc (' ');
  }
  buff_blk->end_x = posx_str;
  buff_blk->end_y = nstr_pos;
  flg_view_mod++;
  view25 (MAIN_SS);
  flg_vb = 1;
  fun_arg = 1;
  put_u_context ();
}

/* (C) DZO */



#define write_u1b(c) *pbuff_undo++ = (c)

static stdcall2 void dou_edc (int, int);
static stdcall2 void redou_edc (int, int);
static stdcall2 void dou_del_line (int, const char *, int);
static stdcall2 void redou_del_line (void);
static stdcall2 void do_paste (int);
static stdcall2 void do_paste2 (long);
static void redo_paste (void);
static stdcall2 void redo_paste2 (int);
static stdcall2 int chg_ur (int, long, int);
static void saveulnk_context (void);
static stdcall2 int get_undo_info (unsigned char *, long *, char *);

#define useek_cur(ls)   *p_cur_posu += (ls)

static stdcall2 int
utell (int flg_undo_redo)
{
  return flg_undo_redo ? (*p_cur_posu != 0) : (*p_cur_posu != *p_sizeuswap);
}

static void
save_glob_context (void)
{
  ubblk = *buff_blk;
  u_flg_vb = flg_vb != 0;
  u_skqbsp = files_st[pnfiles].skqbsp;
}

static void
saveulnk_context (void)
{
  u_nstr_pos = nstr_pos;
  u_posx_str = posx_str;
  u_insert = insert != 0;
  u_f_modify = IS_MODIFY () != 0;
}

static void
save_u_context (void)
{
  flg_link = 0;
  saveulnk_context ();
  if ((*p_cur_posu / U_BLK) > 99) {     /*  undo  99  */
	win_1e (SWARN, NULL, "Undo breaked", WB_STD | W_N_IC);
	t_fflush ();
	*p_cur_posu = 0;
	*p_sizeuswap = 0;
	SET_UMDF ();
	restore_wb ();
  }
}

static stdcall2 void
putdelta (const void *delta, int infob)
{
  char buff_undo[8];
  char *pbuff_undo = buff_undo;
  long s;
  const char *gcc_3_4_6_suck = delta;

  if (flg_link)
	write_u1b (UNDO_LINK);
  else
	flg_link++;
  if ((infob & MASK_USZ) == UNDO_SZ_LONG) {
	s = (*(long *) delta);
slab:
	if (s >= -128 && s <= 127) {
	  infob &= ~MASK_USZ;
	  infob |= UNDO_SZ_B;
	  write_u1b (infob);
	} else if (s >= -32768 && s <= 32767) {
	  infob &= ~MASK_USZ;
	  infob |= UNDO_SZ_SHRT;
	  write_u1b (infob);
	  /* sizeof (short) */
l_w_short:
	  write_u1b (*gcc_3_4_6_suck++);
	} else {
	  write_u1b (infob);
	  /* sizeof (long) */
	  write_u1b (*gcc_3_4_6_suck++);
	  write_u1b (*gcc_3_4_6_suck++);
	  goto l_w_short;
	}
  } else if ((infob & MASK_USZ) == UNDO_SZ_B) {
	write_u1b (infob);
  } else {
	s = (*(short *) delta);
	goto slab;
  }
  write_u1b (*gcc_3_4_6_suck);
  write_u1b (infob);
  write_b_u (buff_undo, pbuff_undo - buff_undo);
}

static void
put_u_context (void)
{
  long ldelta;
  short sdelta;

  ldelta = u_nstr_pos - nstr_pos;
  if (ldelta)
	putdelta (&ldelta, UC_NSP | UNDO_SZ_LONG);

  sdelta = u_posx_str - posx_str;
  if (sdelta)
	putdelta (&sdelta, UC_PXS | UNDO_SZ_SHRT);

  if (u_insert != (insert != 0))
	putdelta (&u_insert, UC_INSERT | UNDO_SZ_B);
  if (u_f_modify != (IS_MODIFY () != 0))
	putdelta (&u_f_modify, UC_FUM | UNDO_SZ_B);

  saveulnk_context ();
  *p_sizeuswap = *p_cur_posu;   /*  redo   undo,   */
}

static void
put_all_context (void)
{
  long ldelta;
  short sdelta;
  int i;

  ldelta = ubblk.beg_y - buff_blk->beg_y;
  if (ldelta)
	putdelta (&ldelta, UC_BEG_Y | UNDO_SZ_LONG);

  sdelta = ubblk.beg_x - buff_blk->beg_x;
  if (sdelta)
	putdelta (&sdelta, UC_BEG_X | UNDO_SZ_SHRT);

  sdelta = ubblk.end_x - buff_blk->end_x;
  if (sdelta)
	putdelta (&sdelta, UC_END_X | UNDO_SZ_SHRT);

  ldelta = ubblk.end_y - buff_blk->end_y;
  if (ldelta)
	putdelta (&ldelta, UC_END_Y | UNDO_SZ_LONG);

  sdelta = ubblk.typeb - buff_blk->typeb;
  if (sdelta)
	putdelta (&sdelta, UC_TYPEB | UNDO_SZ_SHRT);

  if (u_flg_vb != (flg_vb != 0))
	putdelta (&u_flg_vb, UC_FVB | UNDO_SZ_B);

  for (i = 0; i < N_KQB; i++) {
	ldelta = u_skqbsp.dkqbs[i] - kqbs[i];
	if (ldelta)
	  putdelta (&ldelta, (UC_KQBS1 + i) | UNDO_SZ_LONG);
	sdelta = u_skqbsp.dkqbp[i] - kqbp[i];
	if (sdelta)
	  putdelta (&sdelta, (UC_KQBP1 + i) | UNDO_SZ_SHRT);
  }
  save_glob_context ();
  put_u_context ();
}

static stdcall2 int
get_undo_info (unsigned char *commu, long *lp, char *buff)
{
  unsigned char ssui;
  int sui = 0;
  long ldelta;
  void *pdelta;
  int flg_un_re_do = buff != (void *) 0;

  if (utell (flg_un_re_do) == 0)
	return -1;
  if (flg_un_re_do)
	useek_cur (-1);
  pdelta = &ldelta;
  read_b_u (commu, 1);
  ssui = *commu & MASK_USZ;
  *commu &= ~MASK_USZ;
  switch (ssui) {
  case UNDO_SZ_LONG:
	sui = sizeof (long);
	break;
  case UNDO_SZ_B:
	sui = 1;
	break;
  case UNDO_SZ_SHRT:
	sui = sizeof (short);
	break;
  case UNDO_SZ_0:
	sui = 0;
	pdelta = (void *) 0;
	break;
  }
  if (flg_un_re_do)
	useek_cur (-(1 + sui));
  if (pdelta == (void *) 0)
	useek_cur (sui);
  else
	read_b_u (pdelta, sui);
  switch (ssui) {
  case UNDO_SZ_LONG:
	*lp = *(long *) pdelta;
	break;
  case UNDO_SZ_B:
	*lp = *(char *) pdelta;
	break;
  case UNDO_SZ_SHRT:
	*lp = *(short *) pdelta;
	break;
  }
  if (*commu < UC_DELLINE || *commu >= UC_DELUPCUR) {
	if (sui) {
	  if (flg_un_re_do)
		useek_cur (-(1 + sui));
	  else
		useek_cur (1);
	}
  } else {
	if (flg_un_re_do) {
	  useek_cur (-(int) (*lp + sui));
	  read_b_u (buff, (int) *lp);
	} else
	  useek_cur (*lp);
	if (flg_un_re_do)
	  useek_cur (-(int) (*lp + sui + 1));
	else
	  useek_cur (1 + sui);
  }
  if (utell (flg_un_re_do) == 0)
	return 0;
  if (flg_un_re_do)
	useek_cur (-1);
  read_b_u (&ssui, 1);
  if (ssui == UNDO_LINK) {
	if (flg_un_re_do)
	  useek_cur (-1);
	return UNDO_LINK;
  } else if (!flg_un_re_do)
	useek_cur (-1);
  return 0;
}

static stdcall2 int
chg_ur (int commu, long lp, int flgs)
{
  switch (commu) {
  case UC_BEG_Y:
	buff_blk->beg_y += lp;
	break;
  case UC_BEG_X:
	buff_blk->beg_x += lp;
	break;
  case UC_END_X:
	buff_blk->end_x += lp;
	break;
  case UC_END_Y:
	buff_blk->end_y += lp;
	break;
  case UC_TYPEB:
	buff_blk->typeb += lp;
	break;
  case UC_NSP:
	set_nl (nstr_pos + lp, NOREVIEW);
	break;
  case UC_PXS:
	recolumn (posx_str + lp);
	break;
  case UC_KQBS1:
  case UC_KQBS2:
  case UC_KQBS3:
  case UC_KQBS4:
  case UC_KQBS5:
  case UC_KQBS6:
  case UC_KQBS7:
  case UC_KQBS8:
  case UC_KQBS9:
  case UC_KQBS10:
	kqbs[commu - UC_KQBS1] += lp;
	break;
  case UC_KQBP1:
  case UC_KQBP2:
  case UC_KQBP3:
  case UC_KQBP4:
  case UC_KQBP5:
  case UC_KQBP6:
  case UC_KQBP7:
  case UC_KQBP8:
  case UC_KQBP9:
  case UC_KQBP10:
	kqbp[commu - UC_KQBP1] += lp;
	break;
  case UC_FVB:
	flg_vb = flgs;
	break;
  case UC_INSERT:
	insert = flgs;
	break;
  case UC_FUM:
	if (flgs == 0 && IS_UMDF () == 0)
	  UNSET_MODIFY ();
	break;
  default:
	SET_MODIFY ();
	return 0;
  }
  return 1;
}

static void
undo (void)
{
  unsigned char commu;
  long lp;
  int lnk;
  char char2[MLS];

  view25 (WAIT_SS);
loop:
  if ((lnk = get_undo_info (&commu, &lp, char2)) == -1) {
	flg_ex_macro = 0;
	beep ();
  } else {
	if (chg_ur (commu, lp, lp != 0) == 0) {
	  switch (commu) {
	  case UC_CH_CHAR:
		dou_edc (UC_CH_CHAR, (int) (lp >> 8));
		break;
	  case UC_INS_CHAR:
		dou_edc (UC_INS_CHAR, (int) (lp >> 8));
		break;
	  case UC_DELLINE:
		dou_del_line (0, char2, (int) lp);
		break;
	  case UC_DELLINE0:
		dou_del_line (1, char2, (int) lp);
		break;
	  case UC_DELUPCUR:
		redou_edc (UC_INS_CHAR, (int) lp);
		break;
	  case UC_INS_CR:
		{
		  int x = posx_str;
		  comm_down ();
		  redou_del_line ();
		  comm_up ();
		  recolumn (x);
		}
		break;
	  case UC_PAST:
		do_paste ((int) lp);
		break;
	  case UC_PAST2:
		do_paste2 (lp);
		break;
	  }
	}
	if (lnk == UNDO_LINK) {
	  put_time (-1);
	  goto loop;
	}
  }
  posrev ();
  view25 (MAIN_SS);
  save_glob_context ();
}

static void
redo (void)
{
  unsigned char commu;
  long lp;
  int lnk;

  view25 (WAIT_SS);
loop:
  if ((lnk = get_undo_info (&commu, &lp, (void *) 0)) == -1) {
	flg_ex_macro = 0;
	beep ();
  } else {
	if (chg_ur (commu, -lp, lp == 0) == 0) {
	  switch (commu) {
	  case UC_CH_CHAR:
		redou_edc (UC_CH_CHAR, (int) (lp & 0xff));
		break;
	  case UC_INS_CHAR:
		redou_edc (UC_INS_CHAR, (int) (lp & 0xff));
		break;
	  case UC_DELLINE:
	  case UC_DELLINE0:
		redou_del_line ();
		break;
	  case UC_DELUPCUR:
		dou_edc (UC_INS_CHAR, 0);
		break;
	  case UC_INS_CR:
		comm_cr ();
		comm_up ();
		break;
	  case UC_PAST:
		redo_paste ();
		break;
	  case UC_PAST2:
		redo_paste2 (lp & 0xffff);
		break;
	  }
	}
	if (lnk == UNDO_LINK) {
	  put_time (-1);
	  goto loop;
	}
  }
  posrev ();
  view25 (MAIN_SS);
  save_glob_context ();
}

static stdcall2 void
dou_edc (int f, int c)
{
  char *t = &buf_scr[pos_cur_y][posx_str];

  set_max_min_syh (0);
  eds[pos_cur_y] = 1;
  if (f == UC_CH_CHAR)
	*t = c;
  else {
	while (*t) {
	  *t = *(t + 1);
	  t++;
	}
	*(t - 1) = ' ';
  }
}

static stdcall2 void
redou_edc (int f, int c)
{
  int pos;
  char *ptr = buf_scr[pos_cur_y];

  set_max_min_syh (0);
  eds[pos_cur_y] = 1;
  pos = posx_str;
  if (f == UC_INS_CHAR) {
	int i;
	if (posx_str == (MLS - 1)) {
	  flg_ex_macro = 0;
	  return;
	}
	for (i = (MLS - 3); i >= pos; i--)
	  ptr[i + 1] = ptr[i];
  }
  ptr[pos] = c;
}

static stdcall2 void
u_comm_dl (char *sl, int ll)
{
  int op;
  char *vp;
  char buff_undo[4];
  char *pbuff_undo = buff_undo;

  if (flg_link)
	write_u1b (UNDO_LINK);
  else
	flg_link++;
  op = (UC_DELLINE + (nstr_pos == bb_nstr_file)) | UNDO_SZ_SHRT;
  write_u1b (op);
  vp = (char *) &ll;
  write_u1b (*vp);                              /* sizeof (short) */
  vp++;
  write_u1b (*vp);
  write_b_u (buff_undo, pbuff_undo - buff_undo);
  write_b_u (sl, ll);
  buff_undo[0] = *(vp - 1);             /* sizeof (short) */
  buff_undo[1] = *vp;
  buff_undo[2] = op;
  write_b_u (buff_undo, 3);
}

static stdcall2 void
redou_del_line (void)
{
#ifndef lj32
  long lj32;
#else
  int j;
#endif
  bsscroll (pos_cur_y);
  lj32 = nstr_pos;
  nstr_pos = nstr_pos - pos_cur_y + SIZE_W;
  chtsget (SIZE_W - 1);
  nstr_pos = lj32;
  set_m2_syh (-1, 0);
  del_list (lj32);
}

static stdcall2 void
dou_del_line (int flg_end_line, const char *old_str, int ll)
{
  if (flg_end_line)
	memset (buf_scr[pos_cur_y], ' ', MLS - 1);
  else {
	copy_scr ();
	ins_dell_list (nstr_pos);
	review_scr (NOREVIEW);
  }
  memcpy (buf_scr[pos_cur_y], old_str, ll);
  set_m2_syh (-1, 1);
  eds[pos_cur_y] = 1;
}

static stdcall2 void
do_paste (int lp)
{                       /*  - udo   */
  int j;
  int l;
  int l1;

  l = lline (pos_cur_y);
  l1 = posx_str;
  comm_cr ();
  comm_up ();
  j = pos_cur_y + 1;
  /*     l1 */
  for (; l1 < l; l1++) {
	buf_scr[j][lp++] = buf_scr[pos_cur_y][l1];
	buf_scr[pos_cur_y][l1] = ' ';
  }
  eds[pos_cur_y] = 1;
  eds[pos_cur_y + 1] = 1;
}

static void
redo_paste (void)
{                       /*  - redo  undo  */
  int l, j;
  int l1, lp;

  comm_down ();
  l1 = lline (lp = pos_cur_y);
  comm_up ();
  j = 0;
  while (buf_scr[lp][j] == ' ')
	j++;
  if (j > l1)
	j = 0;
  for (l = posx_str; j < l1; l++)
	buf_scr[pos_cur_y][l] = buf_scr[lp][j++];
  set_max_min_syh (0);
  eds[pos_cur_y++] = 1;
  nstr_pos++;
  bsscroll (pos_cur_y);
  {
#ifndef lj32
	long lj32;
#endif
	lj32 = nstr_pos;
	nstr_pos = nstr_pos - pos_cur_y + SIZE_W;
	chtsget ((SIZE_W - 1));
	del_list (nstr_pos = lj32);
  }
  pos_cur_y--;
  nstr_pos--;
}

static stdcall2 void
do_paste2 (long si)
{                       /*  - undo  */
  int j, lp;
  int l1;

  l1 = lline (pos_cur_y);
  comm_up ();
  lp = si & 0xffff;
  for (j = si >> 16; j < l1; j++)
	buf_scr[pos_cur_y][lp++] = buf_scr[pos_cur_y + 1][j];
  set_max_min_syh (0);
  eds[pos_cur_y] = 1;
  comm_down ();
  eds[pos_cur_y] = 1;
}

static stdcall2 void
redo_paste2 (int lp)
{                       /*  - udo   */
  int j;
  int l;
  int l1;

  l = lline (pos_cur_y - 1) - lp;
  l1 = posx_str;
  j = pos_cur_y - 1;
  /*     l1 */
  while (l) {
	buf_scr[pos_cur_y][l1++] = buf_scr[j][lp];
	buf_scr[j][lp++] = ' ';
	l--;
  }
  set_m2_syh (-1, 1);
  eds[pos_cur_y - 1] = 1;
  eds[pos_cur_y] = 1;
}

/*    */
/*  . (C) TSW. 15  1995.  */

#define LiU     1
#define LiD     2
#define LiL     4
#define LiR     8

#define LiA     (LiU|LiD|LiL|LiR)

#define DoubleG         0x10
#define DoubleV         0x20
#define DoubleVG        0x30
#define DoubleGV        0x30
#define ClearGr         0x40
#define MoveGV          0x80


static void getaround (void);
static stdcall2 int getscr (int, int);
static stdcall2 int get_attr_gr (int);
static stdcall2 void newpos (int);
static stdcall2 int drp (int);

/*    ,   
        */
static const unsigned char array[64] = {
	' ','','','','','','','','','','','','','','','',
	 ' ','','','','','','','','','','','','','','','',
	' ','','','','','','','','','','','','','','','',
	 ' ','','','','','','','','','','','','','','',''
};

/*    ,   
        */
static const unsigned char attr_gr[64] = {
	' ',' ',' ','',' ','','','',' ','','','','','','','',
	 ' ',' ',' ',' ',' ','','','',' ','','','',' ','','','',
	' ',' ',' ',' ',' ','','','',' ','','','',' ','','','',
	 ' ',' ',' ','',' ','','','',' ','','','','','','','',
};

/*     */
static stdcall2 int
get_attr_gr (int c)
{
  int i;
  for (i = 0; i < 64; i++)
	if (c == attr_gr[i])
	  return i;
  return 0;
}

static stdcall2 int
getscr (int dx, int dy)
{
  long txy;
  dx += posx_str;
  txy = nstr_pos + dy;
  if (dx >= (MLS - 1) || dx < 0 || txy < 0)
	return 0;
  if (txy > bb_nstr_file) {     /*  ,   */
	flg_view_mod = 0;
	insert++;
	cr ();
	insert--;
	comm_up ();
	flg_view_mod++;
	posrev ();
	put_u_context ();
  }
  dy += pos_cur_y;
  if (dy < 0) {
	up ();
	comm_down ();
	dy++;
  }
  if (dy >= (SIZE_W - 1)) {
	down ();
	comm_up ();
	if (dy > (SIZE_W - 1))
	  dy--;
  }
  return buf_scr[dy][dx];
}

/*       */
static void
getaround (void)
{
  chU = get_attr_gr (getscr (0, -1));
  chD = get_attr_gr (getscr (0, 1));
  chL = get_attr_gr (getscr (-1, 0));
  chR = get_attr_gr (getscr (1, 0));
}

static stdcall2 void
newpos (int ch)
{
  if (ch & LiD)
	down ();
  else if (ch & LiU)
	up ();
  else if (ch & LiR)
	right ();
  else
	left ();
  put_u_context ();
}

/*    */
static stdcall2 int
drp (int key)
{
  int ch, f, vv;
  int tc;
  int mouse_move = 0;
  /*       */
  switch (key) {
  case UP_KEY:
	ch = LiU;
	break;
  case DOWN_KEY:
	ch = LiD;
	break;
  case LEFT_KEY:
	ch = LiL;
	break;
  case RIGHT_KEY:
	ch = LiR;
	break;
  case ESC_KEY:
	return 0;
  case U_C (''):                               /* Alt-V */
	flg_eof = 0;
	return 1;
  case U_C (''):                               /* Alt-W */
	flg_eof = DoubleGV;
	return 1;
  case U_C (''):                               /* Alt-R */
	flg_eof = ClearGr;
	return 1;
  case U_C (''):                               /* Alt-M */
	flg_eof = MoveGV;
	return 1;
  default:
	return 1;
  }
repeat:
  tc = get_attr_gr (getscr (0, 0));
  getaround ();
  if (flg_eof & MoveGV) {
	newpos (ch);
	goto ret;
  }
  if (flg_eof & ClearGr) {              /*   */
	f = 0;
	if (ch & (LiL | LiR) /*&& ( (chU&LiD)>>1 & chD&LiU) */ )
	  f = (chU & ((LiD >> 1) | DoubleVG)) | (chD & ((LiU << 1) | DoubleVG));
	else if (ch & (LiU | LiD) /* && ( (chL&LiR)>>1 & chR&LiL) */ )
	  f = (chL & ((LiR >> 1) | DoubleVG)) | (chR & ((LiL << 1) | DoubleVG));
	if (tc != 0) {
	  u_edc (array[f]);
	  left ();
	}
	newpos (ch);
	goto ret;
  }
/*     (, ),
          ,   
     */
  vv = (ch & (LiU | LiD)) ? (flg_eof & DoubleV) : (flg_eof & DoubleG);

  if ((!(tc & ch)) ||                   /*    */
	  (flg_eof && !(tc & vv)) ||
	  ((flg_eof == 0) && ((((tc & DoubleG)) && (ch & (LiR | LiL))) ||
						  (((tc & DoubleV)) && (ch & (LiD | LiU)))))) {
	f =
	  ch | (chU & LiD) >> 1 | (chD & LiU) << 1 | (chL & LiR) >> 1 | (chR &
																	 LiL) <<
	  1;
	if (ch & (LiR | LiL))
	  if ((chU ^ chD) & DoubleV && flg_eof == 0)
		f = (f & LiA) | vv;
	  else
		f = f | ((chU | chD) & DoubleV) | vv;
	else if ((chL ^ chR) & DoubleG && flg_eof == 0)
	  f = (f & LiA) | vv;
	else
	  f = f | ((chL | chR) & DoubleG) | vv;
  } else {
	newpos (ch);
	getaround ();
	f =
	  ((chU & LiD) >> 1 | (chD & LiU) << 1 | (chL & LiR) >> 1 | (chR & LiL) <<
	   1) & ~ch;
	if (ch & (LiR | LiL))
	  if ((chU ^ chD) & DoubleV && flg_eof == 0)
		f = (f & LiA) | vv;
	  else
		f = f | ((chU | chD) & DoubleV) | (vv & DoubleG);
	else if ((chL ^ chR) & DoubleG && flg_eof == 0)
	  f = (f & LiA) | vv;
	else
	  f = f | ((chL | chR) & DoubleG) | (vv & DoubleV);
  }
  u_edc (array[f]);
  left ();
  put_u_context ();
ret:
  if (mouse_move) {
	mouse_move--;
	goto repeat;
  }
  return 1;
}

static void
main_drp (void)
{
  int c;
  char sav_ins;

  sav_ins = insert;
  insert = 0;
  flg_eof = 0;
  view25 (GLINE_SS);
  for (;;) {
	c = main_loop_get (0);
	if (!drp (c))
	  break;
	save_u_context ();
	put_all_context ();
  }
  view25 (MAIN_SS);
  insert = sav_ins;
}

#define MAX_BLK_S_NS (((1<<16)-1)/(sizeof(t_adr_swap)+sizeof(t_swap_lenght)))

static stdcall2 void
pswapnstr (int nf)
{
  int i;
  int flg_new_mem;
  long n;
  t_adr_swap as;
  t_swap_lenght sl;
  stf st;
  stf st2;

  if (nswpnaf == 0) {
	st = &(files_st[nf].stf0f);
	flg_new_mem = 0;
	for (n = bb_nstr_file + 1; n > 0;) {
	  if (n > (long)MAX_BLK_S_NS) {
		flg_new_mem++;
		i = MAX_BLK_S_NS;
	  } else
		i = n;
	  n -= i;
	  swap_gen (i * (sizeof (t_adr_swap) + sizeof (t_swap_lenght)), st);
	  while (i--) {
		as = stf0->asl.adr_swap;
		sl = stf0->swap_lenght;
		write_cb (&as, sizeof (stf0->asl.adr_swap));
		write_cb (&sl, sizeof (stf0->swap_lenght));
		st2 = stf0;
		stf0 = stf0->over;
		freemems (st2);
	  }
	  if (flg_new_mem) {
		st2 = memstf ();
		st2->over = NULL;
		st->over = st2;
		st = st2;
		flg_new_mem = 0;
	  }
	}
	files_st[nf].top_stf = NULL;
  } else
	files_st[nf].top_stf = stf0;
}

static void
gswapnstr (void)
{
  stf st;
  long n;
  int mn;
  stf st2;
  stf st3;
  t_adr_swap as;
  t_swap_lenght sl;

  if (files_st[pnfiles].top_stf != NULL) {
	st2 = stf0 = files_st[pnfiles].top_stf;
	for (n = 0; n < bb_nstr_file; n++)
	  st2 = st2->over;
  } else {
	st = &(files_st[pnfiles].stf0f);
	mn = 0;
	for (n = 0; n <= bb_nstr_file; n++) {
	  if (mn >= (int)MAX_BLK_S_NS) {
		st = st->over;
		mn = 0;
	  }
	  if (mn == 0)
		io_seek (st->asl.adr_swap);
	  st2 = memstf ();
	  st2->over = NULL;
	  read_cb (&as, sizeof (t_adr_swap));
	  read_cb (&sl, sizeof (t_swap_lenght));
	  st2->asl.adr_swap = as;
	  st2->swap_lenght = sl;
	  if (n == 0)
		st3 = stf0 = st2;
	  else {
		st3->over = st2;
		st3 = st2;
	  }
	  mn++;
	}
	st = &(files_st[pnfiles].stf0f);
	sfree (st);
	all_free (st->over);
	st->over = NULL;
  }
  save_stf_cur_list = bottom_stf = st2;
  save_stf_cur_nstr = files_st[pnfiles].nstr_file;
}

static stdcall2 int win_find (int);

static const char swf[] =
  "Backward (B / Forward\0Case insensetive (C\0Word only (W\0\
Global(G / One\0Automatic (L";

static char * const fwf[] = {
  &find_f_b,
  &flg_rcase,
  &wwo,
  &flg_repl_all,
  &no_ask
};

static void put_mesg_hk (int);

static void
put_mesg_hk (int i)
{
  const char *s;
  char c;
  s = swf;
  while (i--)
	while (*s++);
  while ((c = *s) != 0) {
end_hlk:
	oputch (c);
	s++;
	if (c == '(') {
	  textabk (COLOR24F, COLOR24B, 1);
	  oputch (*s);
	  textabk (COLOR21F, COLOR21B, 0);
	  c = ')';
	  goto end_hlk;
	}
  }
}

#define P_VSTR_find NDES|RIGH_WORD|TAB_RET|VSTR_RWB

static stdcall2 int
win_find0 (int l)
{
  int i;
  int lr = 0;

  ywb_wf = flg_replace ? 10 : 12;
  wb_miny = &ywb_wf;

  win_e ("Find",
		 flg_replace ? "Line for find and repl (S)" : "Find (F)",
		 NULL,
		 flg_replace ? "Line for replace (R)" : NULL, flg_replace ? W_9 : 0);
  buff_altk = flg_replace ? "" : "";
  textabk (COLOR15F, COLOR15B, 0);
  for (i = 5 + ywb_wf;; i++) {
	ogotoxy (24, i);
	if ((i == 8 + ywb_wf && flg_replace == 0) ||
		(i == 12 + ywb_wf && flg_replace != 0)) {
	  ocputs3n (sS3n_d);
	  break;
	}
	ocputs2n (sS3n_m);
  }
  wb_maxy = cur_y;
  for (i = 0; i < 5; i++) {
	if (i == 3 && flg_replace == 0)
	  break;
	ogotoxy (26, (flg_replace ? 5 : 3) + ywb_wf + i);
	textabk (COLOR21F, COLOR21B, 0);
	ocputs ("[ ] ");
	put_mesg_hk (i);
	cur_x = 26;
	textabk (COLOR24F, COLOR24B, 1);
	oputch (*fwf[i] ? 'X' : ' ');
  }
  but1ysaxc ((flg_replace ? 10 : 6) + ywb_wf, OK);
  if (flg_replace) {
	if (l != posx_str) {
	  lr = l - strlen (str_find);
	  if (lr < 0)
		lr = 0;
	}
	get_vstr (str_replace, P_VSTR_find | NO_GetKey
			  | DOWN2_VSTR | REPL_VSTR, lr);
  }
refind:
  i = get_vstr (str_find, FIND_VSTR | P_VSTR_find, l);
  if (i < 256) {
	if (i == U_C ('') || i == U_C (''))
	  goto refind;
	if (i == U_C (''))
	  goto lloop;
	goto w2;
  }
  if (i == TAB_KEY) {
	if (flg_replace) {
lloop:
	  do
		i = get_vstr (str_replace, P_VSTR_find | DOWN2_VSTR | REPL_VSTR, lr);
	  while (i == U_C (''));
	  if (i == U_C (''))
		goto refind;
	  if (i >= 256 && i != TAB_KEY)
		goto brk_win;
	}
w2:
	i = win_find (i);
	if (i == 0)
	  goto refind;
	if (i == 1)
	  goto lloop;
  }
brk_win:
  buff_altk = SNULL;
  return i;
}


static stdcall2 int
win_find (int c0)
{
  int i;
  int cany;

  view25 (OPTS_SS);
  for (i = 0;;) {
	ogotoxy (27, (flg_replace ? 5 : 3) + ywb_wf + i);
	if (c0 >= 256) {
	  cursor (insert == 0 ? FULLCURSOR : NORMCURSOR);
	  cany = get_key ();
	  cursor (NOCURSOR);
	} else {
	  cany = c0;
	  c0 = 256;
	}
	switch (cany) {
	case 'Y':
	case 'y':
	  *fwf[i] = 1;
	  break;
	case 'N':
	case 'n':
	  *fwf[i] = 0;
	  break;
	case U_C (''):                 /* Alt-S */
	  if (flg_replace == 0)
		continue;
	  return 0;
	case U_C (''):                 /* Alt-F */
	  if (flg_replace)
		continue;
	  return 0;
	case U_C (''):                 /* Alt-R */
	  if (flg_replace == 0)
		continue;
	  return 1;
	case 'B':
	case 'b':
	case U_C (''):                 /* Alt-B */
	  i = 0;
lchange:
	  *fwf[i] ^= 1;
	  break;
	case 'C':
	case 'c':
	case U_C (''):                 /* Alt-C */
	  i = 1;
	  goto lchange;
	case 'W':
	case 'w':
	case U_C (''):                 /* Alt-W */
	  i = 2;
	  goto lchange;
	case 'G':
	case 'g':
	case U_C (''):                 /* Alt-G */
	  if (flg_replace == 0)
		continue;
	  i = 3;
	  goto lchange;
	case 'L':
	case 'l':
	case U_C (''):                 /* Alt-L */
	  if (flg_replace == 0)
		continue;
	  i = 4;
	  goto lchange;
	case TAB_KEY:
	  i++;
	  if ((i == 3 && flg_replace == 0) || i == 5)
		return 0;
	  continue;
	case RUS_LAT_FUN:
	case ALT_FUN:
	  (*((EF) fun_edit[cany - UP_KEY])) ();
	  continue;
	case UP_KEY:
	  i--;
	  if (i < 0)
		i = flg_replace == 0 ? 2 : 4;
	  continue;
	case DOWN_KEY:
	  i++;
	  if ((i == 3 && flg_replace == 0) || i == 5)
		i = 0;
	  continue;
	case MOVE_KEY:
	  wbmove ();
	  view25 (OPTS_SS);
	  continue;
	case ' ':
	  *fwf[i] ^= 1;
	  if (flg_sav_macro != -1)
		macrox[nmacro][flg_sav_macro - 1] = OPT_FIND_FUN + *fwf[i];
	  break;
	case OPT_FIND_FUN:
	case OPT_FIND_FUN1:
	  *fwf[i] = cany - OPT_FIND_FUN;
	  break;
	case CR_KEY:
	case ESC_KEY:
	  restore_wb ();
	  return cany;
	}
	ogotoxy (27, (flg_replace ? 5 : 3) + ywb_wf + i);
	textabk (COLOR24F, COLOR24B, 1);
	oputch (*fwf[i] ? 'X' : ' ');
  }
}


static void
er_dic (void)
{
  help_view ();
}

static const char SA[] = "Parag";

static const struct RESOURSE_BOX form_set_txt[] = {
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR27F, COLOR27B, 0), "[",},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR11F, COLOR27B, 0), brk_win,},
  {RESB_COLOR | RESB_NO_REPOS | gencolor (COLOR27F, COLOR27B, 0), "]$&",},
  {RESB_COLOR | RESB_NO_REPOS | RESB_TITLE | gencolor (COLOR28F, COLOR28B, 1),
   SA},
  {RESB_COLOR | gencolor (COLOR27F, COLOR27B, 0), "$-"},
  {RESB_SHDWN, " With$9 "},
  {RESB_SHDWN, " Indention$4 "},
  {RESB_SHDWN, " First line indention$) "},
  {RESB_SHDWN, " Auto format$2 "},
  {RESB_SHDWN, " Carrying russian words$' "},
  {RESB_DWN_SHDWN | RESB_END, sS3n_d}
};

static stdcall2 void
dumputfs (int x)
{
  sprintf (str_rez, P3_d, x);
  ocputs (str_rez);
  cur_x = 48;
  cur_y++;
}

static void
wafset (const char *s, int d)
{
  wb_miny = &sav_yfswb;
  win_0e (SA, s, WIN_E_OK);
  form_d (d);
}

static void
form_set (void)
{

  int c, sm, y;
  unsigned short textparam_wbox[7 + 4];
  unsigned short textsav_wbox[34 * 8 + 4];
  int *p_opt;

  get2_box (24, 34, 5, 8, textsav_wbox);
  ogotoxy (24, 5);
  put_sbox (form_set_txt);
  y = sav_y_form;
re_update:
  view25 (CHG_PARM_SS);
  textabk (COLOR29F, COLOR29B, 0);
  ogotoxy (49, 6);
  dumputfs (line_str_a);
  dumputfs (tn_a);
  dumputfs (tn_f);
  ocputs (af_on_off[flg_avt_form]);
  cur_x = 48;
  cur_y++;
  ocputs (af_on_off[flg_mperenos]);
  for (;;) {
	ogotoxy (48, y);
	get2_box (48, 7, y, 1, textparam_wbox);
	cset_atrD (7, COLOR41F, COLOR41B, 1);
	c = get_key ();
	restore2_box (textparam_wbox);
	if (y == 10)
	  p_opt = &flg_mperenos;
	else
	  p_opt = &flg_avt_form;
	switch (c) {
	case UP_KEY:
	  if (y == 6)
		y = 10;
	  else
		y--;
	  break;
	case DOWN_KEY:
	  if (y == 10)
		y = 6;
	  else
		y++;
	  break;
	case ESC_KEY:
	  goto ret_esc;
	case FORM_FUN:
	case FORM_FUN1:
	  *p_opt = c - FORM_FUN;
	  break;
	case CR_KEY:
	case ' ':
	case TAB_KEY:
	  sm = flg_sav_macro;
	  switch (y) {
	  case 6:
		wafset ("width [8-250]", line_str_a);
		c = line_str_a;
		do {
		  if (get_vstr (str_rez, 0, 0) == ESC_KEY) {
			line_str_a = c;
			break;
		  }
		  line_str_a = atoi (str_rez);
		} while (line_str_a <= 8 || line_str_a >= 250);
re_u1:
		restore_wb ();
		goto re_update;
	  case 7:
		wafset ("idention < width", tn_a);
		c = tn_a;
		do {
		  if (get_vstr (str_rez, 0, 0) == ESC_KEY) {
			tn_a = c;
			break;
		  }
		  tn_a = atoi (str_rez);
		} while (tn_a >= line_str_a || tn_a < 0);
		goto re_u1;
	  case 8:
		wafset ("First line width", tn_f);
		c = tn_f;
		do {
		  if (get_vstr (str_rez, 0, 0) == ESC_KEY) {
			tn_f = c;
			break;
		  }
		  tn_f = atoi (str_rez);
		} while (tn_f >= line_str_a || tn_f < (-tn_a));
		goto re_u1;
	  case 9:
		wb_miny = &sav_yfswb;
		win_1e (SA, "Automatic", "format", 0);
remac:
		for (;;) {
		  c = button2 (*p_opt, baf_on_off[0], baf_on_off[1], 20);
		  if (c == 2 || c == -1)
			break;
		  if (c == 1 || c == 0) {
			*p_opt = c;
			break;
		  } else
			*p_opt ^= 1;
		}
		if (sm != -1) {
		  macrox[nmacro][sm - 1] = FORM_FUN + *p_opt;
		  flg_sav_macro = sm;
		}
		goto re_u1;
	  case 10:
		wb_miny = &sav_yfswb;
		win_1e (SA, "Carrying", "russian words", 0);
		goto remac;
	  }
	}
  }
ret_esc:
  sav_y_form = y;
  view25 (MAIN_SS);
  restore2_box (textsav_wbox);
}

static void
avt_param_form (void)
{
  int i;
  int la, lo;

  if (nstr_pos == bb_nstr_file) {
err:
	win_err ("Can`t set", " option", 0);
ret:
	view_str (pos_cur_y);
	return;
  } {
	int y;
	wb_miny = &y;
	set_cur_revv (1);
	win_e (SA, "Cursor in first", "paragraph line ?", NULL, WIN_E_OK);
	lo = any (8);
	if (lo <= 0)
	  goto ret;
  }
  if (pos_cur_y == (SIZE_W - 1)) {
	down ();
	comm_up ();
  }                                                             /*  */
  la = lline (pos_cur_y);
  lo = lline (pos_cur_y + 1);
  if (lo > la)
	la = lo;
  if (la < 8 || la >= 250)
	goto err;
  /*  */
  for (lo = 0; buf_scr[pos_cur_y + 1][lo] == ' '; lo++);
  if (lo == (MLS - 1))
	goto err;
  if (lo >= la || lo < 0)
	goto err;
  for (i = 0; buf_scr[pos_cur_y][i] == ' '; i++);
  if (i == (MLS - 1))
	goto err;
  i = i - lo;                                   /*   */
  if (i >= la || i < (-lo))
	goto err;
  tn_f = i;
  line_str_a = la;
  tn_a = lo;
  form_set ();
  goto ret;
}

/*         */

static void putch_code (int);

static void putcht (int);

static void
putcht (int ch)
{
  putchar (ch);
}

static void
tflush (void)
{
  fflush (stdout);
}

static void
update_display (void)
{
  int nl, nc;
  int beg_x, end_x;
  for (nl = min_y_wbs; nl <= max_y_wbs; nl++) {
	nc = 0;
	beg_x = -1;
	end_x = WXsize;
rescan:
	for (; nc < WXsize; nc++)
	  if (buff_0screen[(WXsize * nl + nc) * 2] !=
		  old_scr[(WXsize * nl + nc) * 2]
		  || buff_0screen[(WXsize * nl + nc) * 2 + 1] !=
		  old_scr[(WXsize * nl + nc) * 2 + 1])
		break;
	if (nc != WXsize) {
	  if (beg_x == -1)
		beg_x = nc;
	  for (; nc < WXsize; nc++)
		if (buff_0screen[(WXsize * nl + nc) * 2] ==
			old_scr[(WXsize * nl + nc) * 2]
			&& buff_0screen[(WXsize * nl + nc) * 2 + 1] ==
			old_scr[(WXsize * nl + nc) * 2 + 1])
		  break;
	  end_x = nc;
	  goto rescan;
	}
	if (beg_x != -1) {
	  if (nl == (END_W - 1) && end_x == WXsize)
		end_x--;
	  togotoxy (beg_x, nl);
	  for (nc = beg_x; nc < end_x; nc++) {
		flg_video = old_scr[(WXsize * nl + nc) * 2 + 1] =
		  buff_0screen[(WXsize * nl + nc) * 2 + 1];
		flg_video &= 0377;
		putch_code (old_scr[(WXsize * nl + nc) * 2] =
					buff_0screen[(WXsize * nl + nc) * 2]);
	  }
	}
  }
  if (typ_cursor_save != NOCURSOR)
	togotoxy (cur_x, cur_y);
  else
	togotoxy (WXsize - 1, END_W - 1);
  tflush ();
}

static inline void
termclose (void)
{
  togotoxy (0, END_W - 1);
  flg_video = 0;
  putch_code (' ');     /*  .   */
  putcht ('\b');
  tflush ();
}

/*******************************************************************/
		/* -  */
	/*          */
  /* vt-52  (  )  vt-100 */

static void
toclrscr (void)
{                       /*  */
  flg_video = 0;
  putch_code (' ');     /*  .   */
#ifndef TERMvt52
  printf ("\b\033[H\033[J");
#else
  printf ("\b\033H\033J");
#endif
  memcpy (old_scr, buff_0screen, MAX_WY * MAX_WX * 2);
}

#ifdef TERMvt52
static stdcall2 void
tcursorvisible (int flg_on_off)
{                                 /* -  */
  static char save_cv;
  if (save_cv != flg_on_off) {

	putcht (033);
	putcht (flg_on_off ? 'c' : 'n');
	save_cv = flg_on_off;
  }
}
#endif

static stdcall2 void
togotoxy (int x, int y)
{                               /*   */
#ifndef TERMvt52
  x++;
  y++;
  printf ("\033[%d;%dH", y, x);
#else
  putcht (033);
  putcht ('Y');
  putcht (y + ' ');
  putcht (x + ' ');
#endif
}

	/*   [1-256]    */

static void
putch_code (int c)
{
#ifndef TERMvt52
  int v1;

  c &= 0377;
  if (c == 0233)
	c = 0x8a;
  if (c == 0177 || c < ' ') {
	v1 = ((flg_video & 0xf) << 4) & 0x70;
	v1 |= flg_video >> 4;
	flg_video = v1;
	if (c == 0177)
	  c = '*';
	else
	  c += 'A';
  }
  if (cur_rev != flg_video) {
	int vt, vrgb;
	putcht (033);
	putcht ('[');
	v1 = flg_video & 0x77;
	if ((flg_video & 0x8) != 0)
	  putcht ('1');
	else
	  putcht ('0');
	putcht ('m');
	if (flg_video != 0) {
	  putcht (033);
	  putcht ('[');
	  putcht ('3');
	  vt = v1 & 0xf;
	  vrgb = vt & 2;
	  if (vt & 1)
		vrgb |= 4;
	  if (vt & 4)
		vrgb |= 1;
	  putcht (vrgb + '0');
	  putcht ('m');
	  putcht (033);
	  putcht ('[');
	  putcht ('4');
	  vt = v1 >> 4;
	  vrgb = vt & 2;
	  if (vt & 1)
		vrgb |= 4;
	  if (vt & 4)
		vrgb |= 1;
	  putcht (vrgb + '0');
	  putcht ('m');
	}
	cur_rev = flg_video;
  }
#else
  if (cur_rev != flg_video) {
	putcht (033);
	putcht (flg_video ? 'i' : 'm');
	cur_rev = flg_video;
  }
  if (c == '\r' || c == '\n' || c == '\b' || c == 7 || c == 033 || c == '\t'
	  || c == '\f' || c == 14 || c == 15 || c == 0177 || c == 0)
	c = '*';
#endif
  putcht (c);
}

/*  pcvt,     kbscanco.c
	(XENIX-286  ) */


static void
vtscanclose (void)
{
  if (keybrd_inited) {
	termclose ();
	tcsetattr(0, TCSANOW, &told);
	bb_signal( (1 << SIGHUP) | (1 << SIGILL)
			| (1 << SIGSEGV) | (1 << SIGBUS), SIG_DFL);
	keybrd_inited = 0;
  }
}

static void
sig_catcher (int sig)
{
  (void)&sig;
  if (keybrd_inited) {
	vtscanclose ();
	kill (getpid (), 9);
  }
}

static void
vtscaninit (void)
{
  if (!keybrd_inited) {
	tcgetattr(0, &told);
	tnew = told;
	tnew.c_cc[VMIN] = 1;
	tnew.c_cc[VTIME] = 0;
	tnew.c_lflag &= ~(ISIG   | ECHO  | ECHOE | ECHOK  | ICANON);
	tnew.c_iflag &= ~(IXON   | ICRNL | INLCR | PARMRK | INPCK |
			  ISTRIP | IGNCR | IXANY | IXOFF);
	tnew.c_oflag &= ~ONLCR;
	tcsetattr(0, TCSANOW, &tnew);
	bb_signal( (1 << SIGHUP) | (1 << SIGILL)
			| (1 << SIGSEGV) | (1 << SIGBUS), sig_catcher);
	keybrd_inited = 1;
  }
}

static int
getch (void)
{
  char c;

  t_fflush ();
  read (0, &c, 1);
  return c & 0377;
}

static int
kbhit (void)
{
  int rd;

  ioctl (0, FIONREAD, &rd);
  return rd;
}

#define id get_str


typedef unsigned char operator;

/* An operator's token id is a bit of a bitfield. The lower 5 bits are the
 * precedence, and 3 high bits are an ID unique accross operators of that
 * precedence. The ID portion is so that multiple operators can have the
 * same precedence, ensuring that the leftmost one is evaluated first.
 * Consider * and /. High (4<<5) bit is indicator integer operands also. */

#define tok_decl(prec,id) (((id)<<5)|(prec))
#define PREC(op) ((op) & 0x1F)

#define TOK_LPAREN tok_decl(0,0)

#define TOK_COMMA tok_decl(1,0)

#define TOK_ASSIGN tok_decl(2,0)

#define TOK_BOR tok_decl(3,0|4)

#define TOK_BXOR tok_decl(4,0|4)

#define TOK_BAND tok_decl(5,0|4)

#define TOK_LSHIFT tok_decl(6,0|4)
#define TOK_RSHIFT tok_decl(6,1|4)

#define TOK_ADD tok_decl(7,0)
#define TOK_SUB tok_decl(7,1)

#define TOK_MUL tok_decl(8,0)
#define TOK_DIV tok_decl(8,1)
#define TOK_REM tok_decl(8,2|4)

/* For now unary operators. */
#define UNARYPREC 9
#define TOK_BNOT tok_decl(UNARYPREC,0)
#define TOK_UMINUS tok_decl(UNARYPREC,0)
#define TOK_UPLUS tok_decl(UNARYPREC,1)

#define SPEC_PREC (UNARYPREC+1)

#define TOK_NUM tok_decl(SPEC_PREC, 0)
#define TOK_RPAREN tok_decl(SPEC_PREC, 1)

#define NUMPTR (*numstackptr)


typedef struct ARITCH_VAR_NUM {
	double val;
	char *var;      /* if NULL then is regular number,
			   else is varable name */
} v_n_t;


static int arith_lookup_val(v_n_t *t)
{
    if(t->var) {
	int i;

	for (i = 0; i <= posid; i++)
		if (!strcmp (t->var, identf[i].name)) {
			t->val = identf[i].val;
			return i;
		}
	ntlfcnv = t->var;
	return -3;
    }
    return 0;
}



static stdcall2 int
okr (double o, long *l)
{
  if (o > (double) ULONG_MAX || o < (double) LONG_MIN) {
	ntlfcnv = "for integer";
	return -4;
  }
  *l = (long) o;
  return 0;
}

#define END_ID (MAX_ID-1)

/* "applying" a token means performing it on the top elements on the integer
 * stack. For a unary operator it will only change the top element, but a
 * binary operator will pop two arguments and push a result */
static inline int
arith_apply(operator op, v_n_t *numstack, v_n_t **numstackptr)
{
	long numptr_val_long;
	double numptr_val;
	v_n_t *numptr_m1;
	double rez;
	long rez_long = 0;

	if (NUMPTR == numstack) goto err; /* There is no operator that can work
										 without arguments */
	numptr_m1 = NUMPTR - 1;

	/* check operand is undeclared var */
	if(arith_lookup_val(numptr_m1) < 0 && op != TOK_COMMA)
		return -3;

	rez = numptr_m1->val;
	if(op & 0200)
		if(okr(rez, &rez_long))
			return -4;
	if (op == TOK_UMINUS)
		rez *= -1;
	else if (op == TOK_BNOT)
		rez = ~rez_long;
	else if (op != TOK_UPLUS) {

	    /* Binary operators */
	    const char * var_comma = numptr_m1->var;

	    /* check and binary operators need two arguments */
	    if (numptr_m1 == numstack) goto err;

	    /* ... and they pop one */
	    --NUMPTR;
	    numptr_val = rez;
	    numptr_val_long = rez_long;

	    numptr_m1 = NUMPTR - 1;
	    if(op != TOK_ASSIGN) {
		/* check operand is undeclared var for not '=' */
		if(arith_lookup_val(numptr_m1) < 0)
		    return -3;
	    }
	    rez = numptr_m1->val;
	    if(op & 0200)
		if(okr(rez, &rez_long))
			return -4;
	    if (op == TOK_BOR)
			rez = rez_long | numptr_val_long;
	    else if (op == TOK_BAND)
			rez = rez_long & numptr_val_long;
	    else if (op == TOK_BXOR)
			rez = rez_long ^ numptr_val_long;
	    else if (op == TOK_RSHIFT)
			rez = rez_long >> numptr_val_long;
	    else if (op == TOK_LSHIFT)
			rez = rez_long << numptr_val_long;
	    else if (op == TOK_MUL)
			rez *= numptr_val;
	    else if (op == TOK_ADD)
			rez += numptr_val;
	    else if (op == TOK_SUB)
			rez -= numptr_val;
	    else if (op == TOK_ASSIGN)
			rez = numptr_val;
	    else if (op == TOK_COMMA) {
			if(var_comma != NULL)
				preset_format = var_comma[0];
			else
				rez = numptr_val;
	    }
	    else if(numptr_val==0)          /* zero divisor check */
			return -2;
	    else if (op == TOK_DIV)
			rez /= numptr_val;
	    else if (op == TOK_REM)
			rez = rez_long % numptr_val_long;
	}
	if(op == TOK_ASSIGN) {
		int i;

		if(numptr_m1->var == NULL) {
			/* Hmm, 1=2 ? */
			goto err;
		}
		i = arith_lookup_val(numptr_m1);
		if(i < 0) {
			if (posid == END_ID)
				memcpy (identf, &identf[1], END_ID * (sizeof (struct ID)));
			else
				posid++;
			strcpy (identf[posid].name, numptr_m1->var);
			i = posid;
		}
		identf[i].val = rez;
	}
	numptr_m1->val = rez;
	/* protect geting var value, is number now */
	numptr_m1->var = NULL;
	return 0;
err: return(-1);
}

static const char op_chr_tokens[] = {
	'<',
	'>',
	'=',
	'|',
	'&',
	'*',
	'/',
	'%',
	'+',
	'-',
	'^',
	'~',
	',',
	'(',
	')',
	0
};

/* ptr to ")" */
#define endexpression &op_chr_tokens[sizeof(op_tokens)-2]

static const char op_tokens[] = {
	TOK_LSHIFT,
	TOK_RSHIFT,
	TOK_ASSIGN,
	TOK_BOR,
	TOK_BAND,
	TOK_MUL,
	TOK_DIV,
	TOK_REM,
	TOK_ADD,
	TOK_SUB,
	TOK_BXOR,
	TOK_BNOT,
	TOK_COMMA,
	TOK_LPAREN,
	TOK_RPAREN,
	0
};

static const char *
endofname(const char *name)
{
	const char *p;

	p = name;
	while (*p) {
		if (!chk_c_id(*p, '.'))
			break;
		p++;
	}
	return p;
}


static stdcall2 int
setformat (double rez)
{
  long rez_long;

  preset_format = conv_up_rus ((int)((unsigned char)preset_format));
  if (preset_format == 'D') {
	  rez_long = 0;
	  if (okr(rez, &rez_long) || rez_long != rez)
		sprintf (str_rez, "%g", rez);
	  else
		sprintf (str_rez, "%lu", (unsigned long) rez);
	} else if (preset_format == 'X' || preset_format == 'H' || preset_format == 'O') {
	  if(okr(rez, &rez_long))
		return -4;
	  sprintf (str_rez, preset_format == 'O' ? "0%lo" : "0x%lx", rez_long);
	}
  else if (preset_format == 'C') {
	  if (rez < -128 || rez > 255) {
		ntlfcnv = "for char";
		return -4;
	   } else
		sprintf (str_rez, "'%c'", (char) (rez));
  }
  return 0;
}


static int ocxb_arith (const char *expr)
{
    char arithval; /* Current character under analysis */
    operator lasttok, op;
    operator prec;

    const char *p = endexpression;
    int errcode;

    /* Stack of integers */
    v_n_t numstack[(MLS+2)/2];
    v_n_t *numstackptr = numstack;
    /* Stack of operator tokens */
    operator stack[(MLS+2)];
    operator *stackptr = stack;

    *stackptr++ = lasttok = TOK_LPAREN;     /* start off with a left paren */
    id[0] = 0;
    preset_format = 'D';

    while(1) {
	arithval = *expr;
	if (arithval == 0) {
		if (p == endexpression) {
			/* Null expression. */
			numstack->val = 0;
			goto end_ret_ok;
		}

		/* This is only reached after all tokens have been extracted from the
		 * input stream. If there are still tokens on the operator stack, they
		 * are to be applied in order. At the end, there should be a final
		 * result on the integer stack */

		if (expr != endexpression + 1) {
			/* If we haven't done so already, */
			/* append a closing right paren */
			expr = endexpression;
			/* and let the loop process it. */
			continue;
		}
		/* At this point, we're done with the expression. */
		if (numstackptr != numstack+1) {
			/* ... but if there isn't, it's bad */
		  err:
			return -1;
		}
		if(numstack->var) {
		    /* expression is $((var)) only, lookup now */
		    errcode = arith_lookup_val(numstack);
		    if(errcode < 0)
			return errcode;
		}
end_ret_ok:
		return setformat(numstack->val);
	} else {
		/* Continue processing the expression. */
		if (arithval == ' ') {
			/* Skip whitespace */
			goto prologue;
		}
		if ((arithval >= '0' && arithval <= '9') || arithval == '.') {
			char *e;

			numstackptr->var = NULL;
			numstackptr->val = strtol(expr, &e, 0);
			if(*e == '.' || *e == 'e' || *e == 'E')
				numstackptr->val = strtod(expr, &e);
			p = e;
			goto num;
		} else if((p = endofname(expr)) != expr) {
			int var_name_size = (p-expr) + 1;  /* trailing zero */

			if(var_name_size > 9)
				var_name_size = 9;
			numstackptr->var = safe_strncpy(id + strlen(id) + 1,
							expr, var_name_size);
		num:
			expr = p;
			numstackptr++;
			lasttok = TOK_NUM;
			continue;
		} else if(arithval == '\'') {
			p = expr;
			arithval = *++p;
			if (arithval != '\\') {
rq:
			  if(*p && *++p == '\'') {
				numstackptr->var = NULL;
				numstackptr->val = arithval;
				p++;
				goto num;
			  }
			  /* Syntax error */
			  goto err;
			}
			expr = ++p;
			arithval = bb_process_escape_sequence(&p);
			if(p > expr)
				p--;
			else
				arithval = *p;
			goto rq;
		}

		p = strchr(op_chr_tokens, arithval);
		if(p == NULL) {
			/* strange operator not found */
			goto err;
		}
		if(arithval == '<' || arithval == '>') {
			expr++;
			if(*expr != arithval) {
				/* support << or >> only */
				goto err;
			}
		}
		op = op_tokens[(p-op_chr_tokens)];
		p = op_chr_tokens;      /* set p != endexpression */

		/* Plus and minus are binary (not unary) _only_ if the last
		 * token was as number, or a right paren (which pretends to be
		 * a number, since it evaluates to one). Think about it.
		 * It makes sense. */
		if (lasttok != TOK_NUM) {
			switch(op) {
				case TOK_ADD:
				    op = TOK_UPLUS;
				    break;
				case TOK_SUB:
				    op = TOK_UMINUS;
				    break;
			}
		}
		/* We don't want a unary operator to cause recursive descent on the
		 * stack, because there can be many in a row and it could cause an
		 * operator to be evaluated before its argument is pushed onto the
		 * integer stack. */
		/* But for binary operators, "apply" everything on the operator
		 * stack until we find an operator with a lesser priority than the
		 * one we have just extracted. */
		/* Left paren is given the lowest priority so it will never be
		 * "applied" in this way.
		 * if associativity is right and priority eq, applied also skip
		 */
		prec = PREC(op);
		if ((prec > 0 && prec < UNARYPREC) || prec == SPEC_PREC) {
			/* not left paren or unary */
			if (lasttok != TOK_NUM) {
				/* binary op must be preceded by a num */
				goto err;
			}
			while (stackptr != stack) {
			    if (op == TOK_RPAREN) {
				/* The algorithm employed here is simple: while we don't
				 * hit an open paren nor the bottom of the stack, pop
				 * tokens and apply them */
				if (stackptr[-1] == TOK_LPAREN) {
				    --stackptr;
				    /* Any operator directly after a */
				    lasttok = TOK_NUM;
				    /* close paren should consider itself binary */
				    goto prologue;
				}
			    } else {
				operator prev_prec = PREC(stackptr[-1]);

				if (prev_prec < prec)
					break;
				/* check right assoc */
				if(prev_prec == prec && prec == PREC(TOK_ASSIGN))
					break;
			    }
			    errcode = arith_apply(*--stackptr, numstack, &numstackptr);
			    if(errcode) return errcode;
			}
			if (op == TOK_RPAREN) {
				goto err;
			}
		}

		/* Push this operator to the stack and remember it. */
		*stackptr++ = lasttok = op;

	  prologue:
		++expr;
	}
    }
}


static int
main_calc (void)
{
  get_buff_swap (CALC_BUFF);
  strcpy (gets_text, str_rez);
  switch (ocxb_arith (str_rez)) {
  case -1:
	win_err ("Syntax ?", NULL, 0);
	break;
  case -2:
	win_err ("Divide by zero", NULL, 0);
	break;
  case -3:
	win_err (ntlfcnv, NOFOUND, 0);
	break;
  case -4:
	win_err (ntlfcnv, "Number too big", 0);
	break;
  case 0:
	put_buff_swap (CALC_BUFF);
	return 1;
  }
  return 0;
}

#if 0
const char *bb_applet_name = "ocxb";
int main(int argc, char **argv) { return ocxb_main(argc, argv); }
#endif
#endif /* APPLET_USAGE */
