/*
 * Copyright (C) 2009-2014 Karel Zak <kzak@redhat.com>
 * Copyright (C) 2012 Davidlohr Bueso <dave@gnu.org>
 * Copyright (C) 2014 Ondrej Oprala <ooprala@redhat.com>
 * Copyright (C) 1992 A. V. Le Blanc (LeBlanc@mcc.ac.uk)
 *
 * GPT: Copyright (C) 2012 Davidlohr Bueso <dave@gnu.org>
 * SGI: Copyright (C) 2012 Davidlohr Bueso <dave@gnu.org>
 *
 * atari partitions parsing code:
 *   Copyright (C) 2018 Vaclav Dolezal <vdolezal@redhat.com>
 *
 * table - functions handling the data at the table level
 *   Copyright (C) 2010-2014 Karel Zak <kzak@redhat.com>
 *   Copyright (C) 2016 Igor Gnatenko <i.gnatenko.brain@gmail.com>
 *   Copyright (C) 2014 Ondrej Oprala <ooprala@redhat.com>
 *
 * topology - gathers information about device topology
 *  Copyright 2009 Red Hat, Inc.  All rights reserved.
 *
 * blklib
 *
 * Copyright (C) 2008 Kay Sievers <kay.sievers@vrfy.org>
 * Copyright (C) 2009-2014 Karel Zak <kzak@redhat.com>
 * with
 * BSF: Copyright (C) 2009 Red Hat, Inc.
 * ZFS: Copyright (C) 2009-2010 by Andreas Dilger <adilger@sun.com>
 *   Copyright (C) 2010 Davidlohr Bueso <dave@gnu.org>
 * MINIX: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * nilfs: Copyright (C) 2010 by Jiro SEKIBA <jir@unicus.jp>
 * ext2: Copyright (C) 1999, 2001 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 * apfs: Copyright (C) 2018 Harry Mallon <hjmallon@gmail.com>
 * vdo: Copyright (C) 2017 Red Hat, Inc.
 * bcache Copyright (C) 2013 Rolf Fokkens <rolf@fokkens.nl>
 *   Based on code fragments from bcache-tools by Kent Overstreet:
 *   http://evilpiepirate.org/git/bcache-tools.git
 * ubifs: Copyright (C) 2009 Corentin Chary <corentincj@iksaif.net>
 * drbdproxy_datalog: Copyright (C) 2011 by Philipp Marek <philipp.marek@linbit.com>
 * jfs: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * ocfs: Copyright (C) 1999, 2001 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 * exfs: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 *   Copyright (C) 2013 Eric Sandeen <sandeen@redhat.com>
 *   Copyright (C) 2017 Hewlett Packard Enterprise Development LP
 * cramfs: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * romfs: Copyright (C) 1999, 2001 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 * mpool: Copyright (C) 2016 Micron Technology, Inc.
 * DRBD: Copyright (C) 2015 by Philipp Marek <philipp.marek@linbit.com>
 *   Copyright (C) 2009 by Bastian Friedrich <bastian.friedrich@collax.com>
 * f2fs: Copyright (C) 2013 Alejandro Martinez Ruiz <alex@nowcomputing.com>
 * swap: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * reiserfs: Copyright (C) 1999, 2001 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 * exfat: Copyright (C) 2010 Andrew Nayenko <resver@gmail.com>
 * befs: Copyright (C) 2010 Jeroen Oortwijn <oortwijn@gmail.com>
 *   Partly based on the Haiku BFS driver by
 *     Axel Dörfler <axeld@pinc-software.de>
 *   Also inspired by the Linux BeFS driver by
 *     Will Dyson <will_dyson@pobox.com>, et al.
 * iso9660: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * UBI:Copyright (C) 2017 Rafał Miłecki <rafal@milecki.pl>
 * vfat: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 * lvm2: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 *   Copyright (C) 2012 Milan Broz <mbroz@redhat.com>
 * LUKS: Copyright (C) 2018 Milan Broz <gmazyland@gmail.com>
 * stratis: Copyright (C) 2018 Tony Asleson <tasleson@redhat.com>
 * vmfs: Copyright (C) 2009 Mike Hommey <mh@glandium.org>
 * udf: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 *   Copyright (C) 2014-2017 Pali Rohár <pali.rohar@gmail.com>
 * xfs: Copyright (C) 1999 by Andries Brouwer
 *   Copyright (C) 1999, 2000, 2003 by Theodore Ts'o
 *   Copyright (C) 2001 by Andreas Dilger
 *   Copyright (C) 2013 Eric Sandeen <sandeen@redhat.com>
 *
 * llseek.c -- stub Copyright (C) 1994, 1995, 1996, 1997 Theodore Ts'o.
 * dup_fd_cloexec - Copyright (C) 2012 Sami Kerola <kerolasa@iki.fi>
 * devno.c - find a particular device by its device number (major/minor) -
 *  Copyright (C) 2000, 2001, 2003 Theodore Ts'o
 *  Copyright (C) 2001 Andreas Dilger
 * Align/Truncate a string in a given screen width
 *  Copyright (C) 2009-2010 Free Software Foundation, Inc.
 *  Written by Pádraig Brady.
 *
 * http://www.kernel.org/pub/linux/utils/util-linux/
 * version 2.33.1
 *
 * Vladimir Oleynik <dzo@simtreas.ru> 2001-2019
 *  Busybox port
 *
 * This file may be redistributed under the terms of the
 * GNU Lesser General Public License. */

#ifdef APPLET_USAGE
#define fdisk_trivial_usage \
	"[options] [-l] <disk>"
#define fdisk_full_usage \
	"Display or manipulate a disk partition table.\n\n" \
	"\nOptions:\n" \
	"\t-b\tphysical and logical sector size\n" \
	"\t-B\tdon't erase bootbits when creating a new label\n" \
	"t-c mode\tmode is 'dos' or 'nondos' (default)\n" \
	"\t-l\tdisplay partitions and exit\n" \
	"\t-o\toutput columns\n" \
	"\t-s PARTITION\tGive partition size(s) in blocks\n" \
	"\t-t\trecognize specified partition table type only\n" \
	"\t-u\tdisplay units: 'cylinders' or 'sectors' (default)\n" \
	"\t-w\twipe signatures (auto, always or never)\n" \
	"\t-W\twipe signatures from new partitions (auto, always or never)\n" \
	"\t-C\tspecify the number of cylinders\n" \
	"\t-H\tspecify the number of heads\n" \
	"\t-S\tspecify the number of sectors per track"
#else

#include "bb_config.h"
#ifndef CONFIG_LFS
# ifdef FDISK_SUPPORT_LARGE_DISKS
#  define _LARGEFILE_SOURCE
#  define _LARGEFILE64_SOURCE
#  define _FILE_OFFSET_BITS 64
# endif
#endif

#include "busybox.h"

#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/syscall.h>
#include <sys/wait.h>
#include <sys/sysmacros.h>     /* for major, minor */
#include <sys/utsname.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>
#include <inttypes.h>
#include <time.h>
#include <fcntl.h>
#include <stddef.h>
#include <paths.h>
#include <termios.h>
#include <dirent.h>
#include <pwd.h>
#include <signal.h>
#include <poll.h>
#include <sched.h>
#include <byteswap.h>
#include <endian.h>
#include <libgen.h>
#include <getopt.h>
#if defined(CONFIG_FEATURE_LIBBLKID) || defined(CONFIG_FEATURE_GPT_LABEL)
#include "uuid.h"
#endif
#if defined(CONFIG_FEATURE_LIBBLKID)
#include "md5.h"
#endif
#ifdef CONFIG_FEATURE_COMMAND_EDITING
#include "cmdedit.h"
#endif
#include <linux/fd.h>

/* Define to the full name and version of this package. */
#define PACKAGE_STRING "util-linux 2.33.1"

/* Enables colorized output from utils by default */
#define USE_COLORS_BY_DEFAULT 1

#ifdef __GNUC__

/* force a compilation error if condition is true, but also produce a
 * result (of value 0 and type size_t), so the expression can be used
 * e.g. in a structure initializer (or wherever else comma expressions
 * aren't permitted). */
# define UL_BUILD_BUG_ON_ZERO(e) __extension__ (sizeof(struct { int:-!!(e); }))

/* &a[0] degrades to a pointer: a different type from an array */
# define __must_be_array(a) \
	UL_BUILD_BUG_ON_ZERO(__builtin_types_compatible_p(__typeof__(a), __typeof__(&a[0])))

#else /* !__GNUC__ */
# define __must_be_array(a)     0
# define __attribute__(_arg_)
#endif /* !__GNUC__ */

#ifndef ARRAY_SIZE
# define ARRAY_SIZE(arr) (sizeof(arr) / sizeof((arr)[0]) + __must_be_array(arr))
#endif

#ifndef min
# define min(x, y) __extension__ ({             \
	__typeof__(x) _min1 = (x);              \
	__typeof__(y) _min2 = (y);              \
	(void) (&_min1 == &_min2);              \
	_min1 < _min2 ? _min1 : _min2; })
#endif

#ifndef max
# define max(x, y) __extension__ ({             \
	__typeof__(x) _max1 = (x);              \
	__typeof__(y) _max2 = (y);              \
	(void) (&_max1 == &_max2);              \
	_max1 > _max2 ? _max1 : _max2; })
#endif

#ifndef cmp_numbers
# define cmp_numbers(x, y) __extension__ ({     \
	__typeof__(x) _a = (x);                 \
	__typeof__(y) _b = (y);                 \
	(void) (&_a == &_b);                    \
	_a == _b ? 0 : _a > _b ? 1 : -1; })
#endif

#ifndef offsetof
#define offsetof(TYPE, MEMBER) ((size_t) &((TYPE *)0)->MEMBER)
#endif

/* cast a member of a structure out to the containing structure
 * @ptr:        the pointer to the member.
 * @type:       the type of the container struct this is embedded in.
 * @member:     the name of the member within the struct. */
#ifndef container_of
#define container_of(ptr, type, member) __extension__ ({        \
	const __typeof__( ((type *)0)->member ) *__mptr = (ptr); \
	(type *)( (char *)__mptr - offsetof(type,member) );})
#endif

/* After failed execvp() */
#define EX_EXEC_FAILED          126     /* Program located, but not usable. */
#define EX_EXEC_ENOENT          127     /* Could not find program to exec.  */

static inline __attribute__((const)) int is_power_of_2(unsigned long num)
{
	return (num != 0 && ((num & (num - 1)) == 0));
}

/* Fallback defines for old versions of glibc */
#ifdef O_CLOEXEC
# define UL_CLOEXECSTR   "e"
#else
# define UL_CLOEXECSTR   ""
#endif

#ifndef O_CLOEXEC
# define O_CLOEXEC 0
#endif

/* Macros to convert #define'itions to strings, for example
 * #define XYXXY 42
 * printf ("%s=%s\n", stringify(XYXXY), stringify_value(XYXXY)); */
#define stringify_value(s) stringify(s)
#define stringify(s) #s

/* Simple doubly linked list implementation.
 *
 * Some of the internal functions ("__xxx") are useful when
 * manipulating whole lists rather than single entries, as
 * sometimes we already know the next/prev entries and we can
 * generate better code by using them directly rather than
 * using the generic single-entry routines. */

struct list_head {
	struct list_head *next, *prev;
};

#define INIT_LIST_HEAD(ptr) do { \
	(ptr)->next = (ptr); (ptr)->prev = (ptr); \
} while (0)

/* Insert a new entry between two known consecutive entries.
 *
 * This is only for internal list manipulation where we know
 * the prev/next entries already! */
static inline void __list_add(struct list_head * add,
	struct list_head * prev,
	struct list_head * next)
{
	next->prev = add;
	add->next = next;
	add->prev = prev;
	prev->next = add;
}

/* Insert a new entry after the specified head.
 * This is good for implementing stacks. */
static inline void list_add(struct list_head *add, struct list_head *head)
{
	__list_add(add, head, head->next);
}

/* Insert a new entry before the specified head.
 * This is useful for implementing queues. */
static inline void list_add_tail(struct list_head *add, struct list_head *head)
{
	__list_add(add, head->prev, head);
}

/* Delete a list entry by making the prev/next entries
 * point to each other.
 *
 * This is only for internal list manipulation where we know
 * the prev/next entries already! */
static inline void __list_del(struct list_head * prev,
				  struct list_head * next)
{
	next->prev = prev;
	prev->next = next;
}

static inline void list_del(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
}

/* deletes entry from list and reinitialize it. */
static inline void list_del_init(struct list_head *entry)
{
	__list_del(entry->prev, entry->next);
	INIT_LIST_HEAD(entry);
}

/* tests whether a list is empty */
static inline int list_empty(struct list_head *head)
{
	return head->next == head;
}

/* tests whether is entry last in the list */
static inline int list_entry_is_last(struct list_head *entry, struct list_head *head)
{
	return head->prev == entry;
}

/* join two lists
 * @list:       the new list to add.
 * @head:       the place to add it in the first list. */
static inline void list_splice(struct list_head *list, struct list_head *head)
{
	struct list_head *first = list->next;

	if (first != list) {
		struct list_head *last = list->prev;
		struct list_head *at = head->next;

		first->prev = head;
		head->next = first;

		last->next = at;
		at->prev = last;
	}
}

/* get the struct for this entry
 * @ptr:        the &struct list_head pointer.
 * @type:       the type of the struct this is embedded in.
 * @member:     the name of the list_struct within the struct. */
#define list_entry(ptr, type, member)   container_of(ptr, type, member)

/* iterate over elements in a list
 * @pos:        the &struct list_head to use as a loop counter.
 * @head:       the head for your list. */
#define list_for_each(pos, head) \
	for (pos = (head)->next; pos != (head); pos = pos->next)

/* iterate over elements in a list, but don't dereference
 *                      pos after the body is done (in case it is freed)
 * @pos:        the &struct list_head to use as a loop counter.
 * @pnext:      the &struct list_head to use as a pointer to the next item.
 * @head:       the head for your list (not included in iteration). */
#define list_for_each_safe(pos, pnext, head) \
	for (pos = (head)->next, pnext = pos->next; pos != (head); \
	     pos = pnext, pnext = pos->next)

#define MAX_LIST_LENGTH_BITS 20

/* Returns a list organized in an intermediate format suited
 * to chaining of merge() calls: null-terminated, no reserved or
 * sentinel head node, "prev" links not maintained. */
static struct list_head *merge(int (*cmp)(struct list_head *a,
					  struct list_head *b,
					  void *data),
			       void *data,
			       struct list_head *a, struct list_head *b)
{
	struct list_head head, *tail = &head;

	while (a && b) {
		/* if equal, take 'a' -- important for sort stability */
		if ((*cmp)(a, b, data) <= 0) {
			tail->next = a;
			a = a->next;
		} else {
			tail->next = b;
			b = b->next;
		}
		tail = tail->next;
	}
	tail->next = a ? a : b;
	return head.next;
}

/* Combine final list merge with restoration of standard doubly-linked
 * list structure.  This approach duplicates code from merge(), but
 * runs faster than the tidier alternatives of either a separate final
 * prev-link restoration pass, or maintaining the prev links
 * throughout. */
static void merge_and_restore_back_links(int (*cmp)(struct list_head *a,
						    struct list_head *b,
						    void *data),
					 void *data,
					 struct list_head *head,
					 struct list_head *a, struct list_head *b)
{
	struct list_head *tail = head;

	while (a && b) {
		/* if equal, take 'a' -- important for sort stability */
		if ((*cmp)(a, b, data) <= 0) {
			tail->next = a;
			a->prev = tail;
			a = a->next;
		} else {
			tail->next = b;
			b->prev = tail;
			b = b->next;
		}
		tail = tail->next;
	}
	tail->next = a ? a : b;

	do {
		/* In worst cases this loop may run many iterations.
		 * Continue callbacks to the client even though no
		 * element comparison is needed, so the client's cmp()
		 * routine can invoke cond_resched() periodically. */
		(*cmp)(tail->next, tail->next, data);

		tail->next->prev = tail;
		tail = tail->next;
	} while (tail->next);

	tail->next = head;
	head->prev = tail;
}

/* sort a list
 * This function implements "merge sort", which has O(nlog(n))
 * complexity.
 *
 * The comparison function @cmp must return a negative value if @a
 * should sort before @b, and a positive value if @a should sort after
 * @b. If @a and @b are equivalent, and their original relative
 * ordering is to be preserved, @cmp must return 0. */
static void list_sort(struct list_head *head,
			int (*cmp)(struct list_head *a,
				   struct list_head *b,
				   void *data),
			void *data)
{
	struct list_head *part[MAX_LIST_LENGTH_BITS+1]; /* sorted partial lists
							   -- last slot is a sentinel */
	size_t lev;  /* index into part[] */
	size_t max_lev = 0;
	struct list_head *list;

	if (list_empty(head))
		return;

	memset(part, 0, sizeof(part));

	head->prev->next = NULL;
	list = head->next;

	while (list) {
		struct list_head *cur = list;
		list = list->next;
		cur->next = NULL;

		for (lev = 0; part[lev]; lev++) {
			cur = merge(cmp, data, part[lev], cur);
			part[lev] = NULL;
		}
		if (lev > max_lev) {
			/* list passed to list_sort() too long for efficiency */
			if (lev >= ARRAY_SIZE(part) - 1)
				lev--;
			max_lev = lev;
		}
		part[lev] = cur;
	}

	for (lev = 0; lev < max_lev; lev++)
		if (part[lev])
			list = merge(cmp, data, part[lev], list);

	merge_and_restore_back_links(cmp, data, head, part[max_lev], list);
}

#define UL_COLOR_RESET          "\033[0m"
#define UL_COLOR_BOLD           "\033[1m"
#define UL_COLOR_HALFBRIGHT     "\033[2m"
#define UL_COLOR_UNDERSCORE     "\033[4m"
#define UL_COLOR_BLINK          "\033[5m"
#define UL_COLOR_REVERSE        "\033[7m"

/* Standard colors */
#define UL_COLOR_BLACK          "\033[30m"
#define UL_COLOR_RED            "\033[31m"
#define UL_COLOR_GREEN          "\033[32m"
#define UL_COLOR_BROWN          "\033[33m"      /* well, brown */
#define UL_COLOR_BLUE           "\033[34m"
#define UL_COLOR_MAGENTA        "\033[35m"
#define UL_COLOR_CYAN           "\033[36m"
#define UL_COLOR_GRAY           "\033[37m"

/* Bold variants */
#define UL_COLOR_DARK_GRAY      "\033[1;30m"
#define UL_COLOR_BOLD_RED       "\033[1;31m"
#define UL_COLOR_BOLD_GREEN     "\033[1;32m"
#define UL_COLOR_BOLD_YELLOW    "\033[1;33m"
#define UL_COLOR_BOLD_BLUE      "\033[1;34m"
#define UL_COLOR_BOLD_MAGENTA   "\033[1;35m"
#define UL_COLOR_BOLD_CYAN      "\033[1;36m"

#define UL_COLOR_WHITE          "\033[1;37m"


/* maximal length of human readable name of ESC seq. */
#define UL_COLORNAME_MAXSZ      32

/* --color[=WHEN] */
enum colortmode {
	UL_COLORMODE_AUTO = 0,
	UL_COLORMODE_NEVER,
	UL_COLORMODE_ALWAYS,
	UL_COLORMODE_UNDEF,

	__UL_NCOLORMODES        /* last */
};

/* Generic iterator */
struct libscols_iter {
	struct list_head        *p;             /* current position */
	struct list_head        *head;          /* start position */
	int                     direction;      /* SCOLS_ITER_{FOR,BACK}WARD */
};

/* Tree symbols */
struct libscols_symbols {
	int     refcount;
	char    *branch;
	char    *vert;
	char    *right;
	char    *title_padding;
	char    *cell_padding;
};

/* Table cells */
struct libscols_cell {
	char    *data;
	char    *color;
	void    *userdata;
	int     flags;
};

/* Table line */
struct libscols_line {
	int     refcount;
	size_t  seqnum;

	void    *userdata;
	char    *color;         /* default line color */

	struct libscols_cell    *cells;         /* array with data */
	size_t                  ncells;         /* number of cells */

	struct list_head        ln_lines;       /* table lines */
	struct list_head        ln_branch;      /* begin of branch (head of ln_children) */
	struct list_head        ln_children;

	struct libscols_line    *parent;
};

/* Table column */
struct libscols_column {
	int     refcount;       /* reference counter */
	size_t  seqnum;         /* column index */

	size_t  width;          /* real column width */
	size_t  width_min;      /* minimal width (usually header width) */
	size_t  width_max;      /* maximal width */
	size_t  width_avg;      /* average width, used to detect extreme fields */
	size_t  width_treeart;  /* size of the tree ascii art */
	double  width_hint;     /* hint (N < 1 is in percent of termwidth) */

	int     flags;
	int     is_extreme;
	char    *color;         /* default column color */
	char    *safechars;     /* do not encode this bytes */

	char    *pending_data;
	size_t  pending_data_sz;
	char    *pending_data_buf;

	int (*cmpfunc)(struct libscols_cell *,
		       struct libscols_cell *,
		       void *);                 /* cells comparison function */
	void *cmpfunc_data;

	size_t (*wrap_chunksize)(const struct libscols_column *,
			const char *, void *);
	char *(*wrap_nextchunk)(const struct libscols_column *,
			char *, void *);
	void *wrapfunc_data;


	struct libscols_cell    header;
	struct list_head        cl_columns;

	struct libscols_table   *table;
};

enum {

	SCOLS_ITER_FORWARD = 0,
	SCOLS_ITER_BACKWARD
};

/* Column flags */
enum {
	SCOLS_FL_TRUNC       = (1 << 0),   /* truncate fields data if necessary */
	SCOLS_FL_TREE        = (1 << 1),   /* use tree "ascii art" */
	SCOLS_FL_RIGHT       = (1 << 2),   /* align to the right */
	SCOLS_FL_STRICTWIDTH = (1 << 3),   /* don't reduce width if column is empty */
	SCOLS_FL_NOEXTREMES  = (1 << 4),   /* ignore extreme fields when count column width */
	SCOLS_FL_HIDDEN      = (1 << 5),   /* maintain data, but don't print */
	SCOLS_FL_WRAP        = (1 << 6)    /* wrap long lines to multi-line cells */
};

/* Cell flags */
enum {
	/* alignment evaluated in order: right,center,left */
	SCOLS_CELL_FL_LEFT    = 0,
	SCOLS_CELL_FL_CENTER  = (1 << 0),
	SCOLS_CELL_FL_RIGHT   = (1 << 1)
};

enum {
	SCOLS_TERMFORCE_AUTO = 0,
	SCOLS_TERMFORCE_NEVER,
	SCOLS_TERMFORCE_ALWAYS
};

enum {
	SCOLS_FMT_HUMAN = 0,            /* default, human readable */
	SCOLS_FMT_RAW,                  /* space separated */
	SCOLS_FMT_EXPORT,               /* COLNAME="data" ... */
};

/* The table */
struct libscols_table {
	int     refcount;
	char    *name;          /* optional table name (for JSON) */
	size_t  ncols;          /* number of columns */
	size_t  ntreecols;      /* number of columns with SCOLS_FL_TREE */
	size_t  nlines;         /* number of lines */
	size_t  termwidth;      /* terminal width (number of columns) */
	size_t  termheight;     /* terminal height  (number of lines) */
	size_t  termreduce;     /* extra blank space */
	int     termforce;      /* SCOLS_TERMFORCE_* */
	FILE    *out;           /* output stream */

	char    *colsep;        /* column separator */
	char    *linesep;       /* line separator */

	struct list_head        tb_columns;
	struct list_head        tb_lines;
	struct libscols_symbols *symbols;
	struct libscols_cell    title;          /* optional table title (for humans) */

	int     format;         /* SCOLS_FMT_* */

	size_t  termlines_used; /* printed line counter */
	size_t  header_next;    /* where repeat header */

	/* flags */
	unsigned int    ascii           :1,     /* don't use unicode */
			colors_wanted   :1,     /* enable colors */
			is_term         :1,     /* isatty() */
			padding_debug   :1,     /* output visible padding chars */
			maxout          :1,     /* maximize output */
			header_repeat   :1,     /* print header after libscols_table->termheight */
			header_printed  :1,     /* header already printed */
			priv_symbols    :1,     /* default private symbols */
			no_headings     :1,     /* don't print header */
			no_encode       :1,     /* don't care about control and non-printable chars */
			no_linesep      :1,     /* don't print line separator */
			no_wrap         :1;     /* never wrap lines */
};

#define SCOLS_IS_ITER_FORWARD(_i)     ((_i)->direction == SCOLS_ITER_FORWARD)

#define SCOLS_ITER_INIT(itr, list) \
	do { \
		(itr)->p = SCOLS_IS_ITER_FORWARD(itr) ? \
				(list)->next : (list)->prev; \
		(itr)->head = (list); \
	} while(0)

#define SCOLS_ITER_ITERATE(itr, res, restype, member) \
	do { \
		res = list_entry((itr)->p, restype, member); \
		(itr)->p = SCOLS_IS_ITER_FORWARD(itr) ? \
				(itr)->p->next : (itr)->p->prev; \
	} while(0)


static inline int scols_iter_is_last(const struct libscols_iter *itr)
{
	if (!itr || !itr->head || !itr->p)
		return 0;

	return itr->p == itr->head;
}


#define _PATH_PROC_DEVICES      "/proc/devices"
#define _PATH_TERMCOLORS_DIRNAME "terminal-colors.d"
#define _PATH_TERMCOLORS_DIR    "/etc/" _PATH_TERMCOLORS_DIRNAME
#define _PATH_PROC_PARTITIONS   "/proc/partitions"
#define _PATH_SYS_BLOCK         "/sys/block"
#define _PATH_SYS_DEVBLOCK      "/sys/dev/block"
#define _PATH_DEV_MAPPER        "/dev/mapper"
#define _PATH_DEV_BYID          "/dev/disk/by-id"
#define _PATH_DEV_BYPATH        "/dev/disk/by-path"

#define UUID_STR_LEN    37

/* Note that RFC4122 defines UUID in more details:
 *
 *     Field               Data Type     Octet  Note
 * -------------------------------------------------
 *  time_low               unsigned 32   0-3    The low field of the
 *                         bit integer          timestamp
 *
 *  time_mid               unsigned 16   4-5    The middle field of the
 *                         bit integer          timestamp
 *
 *  time_hi_and_version    unsigned 16   6-7    The high field of the
 *                         bit integer          timestamp multiplexed
 *                                              with the version number
 *
 *  clock_seq_hi_and_rese  unsigned 8    8      The high field of the
 *  rved                   bit integer          clock sequence
 *                                              multiplexed with the
 *                                              variant
 *
 *  clock_seq_low          unsigned 8    9      The low field of the
 *                         bit integer          clock sequence
 *
 *  node                   unsigned 48   10-15  The spatially unique
 *                         bit integer          node identifier
 *
 * We have clock_seq_hi_and_reserved (8bit) and clock_seq_low (8bit)
 * merged into clock_seq (16bit). */
struct uuid {
	uint32_t        time_low;
	uint16_t        time_mid;
	uint16_t        time_hi_and_version;
	uint16_t        clock_seq;
	uint8_t node[6];
};


#define UUIDD_OP_GETPID                 0
#define UUIDD_OP_GET_MAXOP              1
#define UUIDD_OP_TIME_UUID              2
#define UUIDD_OP_RANDOM_UUID            3
#define UUIDD_OP_BULK_TIME_UUID         4
#define UUIDD_OP_BULK_RANDOM_UUID       5
#define UUIDD_MAX_OP                    UUIDD_OP_BULK_RANDOM_UUID


/* Disk label specific driver and setting. */
struct fdisk_label;

/* Partition types */
struct fdisk_parttype {
	unsigned int    code;           /* type as number or zero */
	char            *name;          /* description */
	char            *typestr;       /* type as string or NULL */

	unsigned int    flags;          /* FDISK_PARTTYPE_* flags */
	int             refcount;       /* reference counter for allocated types */
};

/* LBA addresses type */
typedef uint64_t fdisk_sector_t;

#define fdisk_parttype_is_invisible(_x) ((_x) && ((_x)->flags & FDISK_PARTTYPE_INVISIBLE))
#define fdisk_parttype_is_allocated(_x) ((_x) && ((_x)->flags & FDISK_PARTTYPE_ALLOCATED))

struct fdisk_partition {
	int             refcount;               /* reference counter */

	size_t          partno;                 /* partition number */
	size_t          parent_partno;          /* for logical partitions */

	fdisk_sector_t  start;                  /* first sectors */
	fdisk_sector_t  size;                   /* size in sectors */

	int             movestart;              /* FDISK_MOVE_* (scripts only) */
	int             resize;                 /* FDISK_RESIZE_* (scripts only) */

	char            *name;                  /* partition name */
	char            *uuid;                  /* partition UUID */
	char            *attrs;                 /* partition flags/attributes converted to string */
	struct fdisk_parttype *type;            /* partition type */

	char            *fstype;                /* filesystem type */
	char            *fsuuid;                /* filesystem uuid  */
	char            *fslabel;               /* filesystem label */

	struct list_head        parts;          /* list of partitions */

	/* extra fields for partition_to_string() */
	char            start_post;             /* start postfix  (e.g. '+') */
	char            end_post;               /* end postfix */
	char            size_post;              /* size postfix */

	uint64_t        fsize;                  /* bsd junk */
	uint64_t        bsize;
	uint64_t        cpg;

	char            *start_chs;             /* start C/H/S in string */
	char            *end_chs;               /* end C/H/S in string */

	unsigned int    boot;                   /* MBR: bootable */

	unsigned int    container : 1,                  /* container partition (e.g. extended partition) */
			end_follow_default : 1,         /* use default end */
			freespace : 1,                  /* this is free space */
			partno_follow_default : 1,      /* use default partno */
			size_explicit : 1,              /* don't align the size */
			start_follow_default : 1,       /* use default start */
			fs_probed : 1,                  /* already probed by blkid */
			used : 1,                       /* partition already used */
			wholedisk : 1;                  /* special system partition */
};

/* Ask API handler for dialogs with users. */
struct ask_menuitem {
	char    key;
	const char      *name;
	const char      *desc;

	struct ask_menuitem *next;
};

/* fdisk dialog -- note that nothing from this stuff will be directly exported,
 * we will have get/set() function for everything. */
struct fdisk_ask {
	int             type;           /* FDISK_ASKTYPE_* */
	char            *query;

	int             refcount;

	union {
		/* FDISK_ASKTYPE_{NUMBER,OFFSET} */
		struct ask_number {
			uint64_t        hig;            /* high limit */
			uint64_t        low;            /* low limit */
			uint64_t        dfl;            /* default */
			uint64_t        result;
			uint64_t        base;           /* for relative results */
			uint64_t        unit;           /* unit for offsets */
			const char      *range;         /* by library generated list */
			unsigned int    relative :1,
					inchars  :1,
					wrap_negative   :1;
		} num;
		/* FDISK_ASKTYPE_{WARN,WARNX,..} */
		struct ask_print {
			const char      *mesg;
			int             errnum;         /* errno */
		} print;
		/* FDISK_ASKTYPE_YESNO */
		struct ask_yesno {
			int             result;         /* TRUE or FALSE */
		} yesno;
		/* FDISK_ASKTYPE_STRING */
		struct ask_string {
			char            *result;        /* allocated */
		} str;
		/* FDISK_ASKTYPE_MENU */
		struct ask_menu {
			int             dfl;            /* default menu item */
			int             result;
			struct ask_menuitem *first;
		} menu;
	} data;
};

/* Generic iterator */
struct fdisk_iter {
	struct list_head        *p;             /* current position */
	struct list_head        *head;          /* start position */
	int                     direction;      /* FDISK_ITER_{FOR,BACK}WARD */
};

/* Container for fdisk_partition objects */
struct fdisk_table {
	struct list_head        parts;          /* partitions */
	int                     refcount;
	size_t                  nents;          /* number of partitions */
};

/* The fields describes how to display libfdisk_partition */
struct fdisk_field {
	int             id;             /* FDISK_FIELD_* */
	const char      *name;          /* field name */
	double          width;          /* field width (compatible with libsmartcols whint) */
	int             flags;          /* FDISK_FIELDFL_* */
};

/* Supported partition table types (labels) */
enum fdisk_labeltype {
	FDISK_DISKLABEL_DOS = (1 << 1),         /* MBR label type */
	FDISK_DISKLABEL_SUN = (1 << 2),         /* SUN label type */
	FDISK_DISKLABEL_SGI = (1 << 3),         /* SGI label type */
	FDISK_DISKLABEL_BSD = (1 << 4),         /* BSD label type */
	FDISK_DISKLABEL_GPT = (1 << 5)          /* UEFI GPT type */
};

/* library handler for label specific information. See
 * generic FDISK_LABELITEM_* and label specific {GPT,MBR,..}_LABELITEM_*. */
struct fdisk_labelitem {
	int             refcount;       /* reference counter */
	int             id;             /* <label>_ITEM_* */
	char            type;           /* s = string, j = uint64 */
	const char      *name;          /* human readable name */

	union {
		char            *str;
		uint64_t        num64;
	} data;
};

/* Ask API dialog types */
enum fdisk_asktype {
	FDISK_ASKTYPE_NONE = 0,
	FDISK_ASKTYPE_NUMBER,
	FDISK_ASKTYPE_OFFSET,
	FDISK_ASKTYPE_WARN,
	FDISK_ASKTYPE_WARNX,
	FDISK_ASKTYPE_INFO,
	FDISK_ASKTYPE_YESNO,
	FDISK_ASKTYPE_STRING,
	FDISK_ASKTYPE_MENU
};

#define FDISK_PLURAL    0
#define FDISK_SINGULAR  1

enum {
	FDISK_SIZEUNIT_HUMAN    = 0,    /* default, human readable {M,G,P,...} */
	FDISK_SIZEUNIT_BYTES            /* bytes */
};

/* Types of fdisk_field. The fields describe a partition. */
enum fdisk_fieldtype {
	FDISK_FIELD_NONE = 0,

	/* generic */
	FDISK_FIELD_DEVICE,
	FDISK_FIELD_START,
	FDISK_FIELD_END,
	FDISK_FIELD_SECTORS,
	FDISK_FIELD_CYLINDERS,
	FDISK_FIELD_SIZE,
	FDISK_FIELD_TYPE,
	FDISK_FIELD_TYPEID,

	/* label specific */
	FDISK_FIELD_ATTR,
	FDISK_FIELD_BOOT,
	FDISK_FIELD_BSIZE,
	FDISK_FIELD_CPG,
	FDISK_FIELD_EADDR,
	FDISK_FIELD_FSIZE,
	FDISK_FIELD_NAME,
	FDISK_FIELD_SADDR,
	FDISK_FIELD_UUID,

	FDISK_FIELD_FSUUID,
	FDISK_FIELD_FSLABEL,
	FDISK_FIELD_FSTYPE,

	FDISK_NFIELDS           /* must be last */
};

/* Generic disklabel items. */
enum fdisk_labelitem_gen {
	FDISK_LABELITEM_ID = 0,
	__FDISK_NLABELITEMS = 8
};

#define FDISK_ALIGN_UP          1
#define FDISK_ALIGN_DOWN        2
#define FDISK_ALIGN_NEAREST     3

/* Basic library handler. */
struct fdisk_context;

/* script control struct */
struct fdisk_script {
	struct fdisk_table      *table;
	struct list_head        headers;
	struct fdisk_context    *cxt;

	int                     refcount;
	char                    *(*fn_fgets)(struct fdisk_script *, char *, size_t, FILE *);
	void                    *userdata;

	/* parser's state */
	size_t                  nlines;
	struct fdisk_label      *label;

	unsigned int            force_label : 1;        /* label: <name> specified */
};

/* Legacy CHS based geometry */
struct fdisk_geometry {
	unsigned int heads;
	fdisk_sector_t sectors;
	fdisk_sector_t cylinders;
};

struct fdisk_context {
	int dev_fd;         /* device descriptor */
	char *dev_path;     /* device path */
	char *dev_model;    /* on linux /sys/block/<name>/device/model or NULL */
	struct stat dev_st; /* stat(2) result */

	int refcount;

	unsigned char *firstsector; /* buffer with master boot record */
	unsigned long firstsector_bufsz;


	/* topology */
	unsigned long io_size;          /* I/O size used by fdisk */
	unsigned long optimal_io_size;  /* optional I/O returned by device */
	unsigned long min_io_size;      /* minimal I/O size */
	unsigned long phy_sector_size;  /* physical size */
	unsigned long sector_size;      /* logical size */
	unsigned long alignment_offset;

	unsigned int readonly : 1,              /* don't write to the device */
		     display_in_cyl_units : 1,  /* for obscure labels */
		     display_details : 1,       /* expert display mode */
		     protect_bootbits : 1,      /* don't zeroize first sector */
		     pt_collision : 1,          /* another PT detected by libblkid */
		     no_disalogs : 1,           /* disable dialog-driven partititoning */
		     dev_model_probed : 1,      /* tried to read from sys */
		     listonly : 1;              /* list partition, nothing else */

	char *collision;                        /* name of already existing FS/PT */
	struct list_head wipes;                 /* list of areas to wipe before write */

	int sizeunit;                           /* SIZE fields, FDISK_SIZEUNIT_* */

	/* alignment */
	unsigned long grain;            /* alignment unit */
	fdisk_sector_t first_lba;               /* recommended begin of the first partition */
	fdisk_sector_t last_lba;                /* recommended end of last partition */

	/* geometry */
	fdisk_sector_t total_sectors;   /* in logical sectors */
	struct fdisk_geometry geom;

	/* user setting to overwrite device default */
	struct fdisk_geometry user_geom;
	unsigned long user_pyh_sector;
	unsigned long user_log_sector;
	unsigned long user_grain;

	struct fdisk_label *label;      /* current label, pointer to labels[] */

	size_t nlabels;                 /* number of initialized label drivers */
	struct fdisk_label *labels[8];  /* all supported labels,
					 * FIXME: use any enum rather than hardcoded number */

	int     (*ask_cb)(struct fdisk_context *, struct fdisk_ask *, void *);  /* fdisk dialogs callback */
	void    *ask_data;              /* ask_cb() data */

	struct fdisk_context    *parent;        /* for nested PT */
	struct fdisk_script     *script;        /* what we want to follow */
};

enum {

	FDISK_ITER_FORWARD = 0,
	FDISK_ITER_BACKWARD
};

#define DOS_FLAG_ACTIVE 1

/* GPT partition attributes */

/* GPT attribute; marks a partition as system partition (disk
 * partitioning utilities must preserve the partition as is) */
#define GPT_FLAG_REQUIRED       1

/* GPT attribute; EFI firmware should ignore the content of the
 * partition and not try to read from it */
#define GPT_FLAG_NOBLOCK        2

/* GPT attribute; use the partition for legacy boot method */
#define GPT_FLAG_LEGACYBOOT     3

/* GPT attribute; for bites 48-63, defined and used by the individual partition
 * type.
 *
 * The flag GPT_FLAG_GUIDSPECIFIC forces libfdisk to ask (by ask API)
 * for a bit number. If you want to toggle specific bit and avoid any
 * dialog, then use the bit number (in range 48..63). */
#define GPT_FLAG_GUIDSPECIFIC   4


/* GPT specific label items. */
enum fdisk_labelitem_gpt {
	/* generic */
	GPT_LABELITEM_ID = FDISK_LABELITEM_ID,
	/* specific */
	GPT_LABELITEM_FIRSTLBA = __FDISK_NLABELITEMS,
	GPT_LABELITEM_LASTLBA,
	GPT_LABELITEM_ALTLBA,
	GPT_LABELITEM_ENTRIESLBA,
	GPT_LABELITEM_ENTRIESALLOC
};

#define fdisk_is_ask(a, x) (fdisk_ask_get_type(a) == FDISK_ASKTYPE_ ## x)

# define P_(Singular, Plural, n) ((n) == 1 ? (Singular) : (Plural))

#define FDISK_GPT_NPARTITIONS_DEFAULT   128

#define FDISK_IS_ITER_FORWARD(_i)     ((_i)->direction == FDISK_ITER_FORWARD)

#define FDISK_ITER_INIT(itr, list) \
	do { \
		(itr)->p = FDISK_IS_ITER_FORWARD(itr) ? \
				(list)->next : (list)->prev; \
		(itr)->head = (list); \
	} while(0)

#define FDISK_ITER_ITERATE(itr, res, restype, member) \
	do { \
		res = list_entry((itr)->p, restype, member); \
		(itr)->p = FDISK_IS_ITER_FORWARD(itr) ? \
				(itr)->p->next : (itr)->p->prev; \
	} while(0)


enum {
	FDISK_PARTTYPE_UNKNOWN          = (1 << 1),
	FDISK_PARTTYPE_INVISIBLE        = (1 << 2),
	FDISK_PARTTYPE_ALLOCATED        = (1 << 3)
};

enum {
	FDISK_MOVE_NONE = 0,
	FDISK_MOVE_DOWN = -1,
	FDISK_MOVE_UP = 1
};

enum {
	FDISK_RESIZE_NONE = 0,
	FDISK_RESIZE_REDUCE = -1,
	FDISK_RESIZE_ENLARGE = 1
};

#define FDISK_INIT_UNDEF(_x)    ((_x) = (__typeof__(_x)) -1)
#define FDISK_IS_UNDEF(_x)      ((_x) == (__typeof__(_x)) -1)

/* Label specific operations */
struct fdisk_label_operations {
	/* probe disk label */
	int (*probe)(struct fdisk_context *cxt);
	/* write in-memory changes to disk */
	int (*write)(struct fdisk_context *cxt);
	/* verify the partition table */
	int (*verify)(struct fdisk_context *cxt);
	/* create new disk label */
	int (*create)(struct fdisk_context *cxt);
	/* returns offset and size of the 'n' part of the PT */
	int (*locate)(struct fdisk_context *cxt, int n, const char **name,
		      uint64_t *offset, size_t *size);
	/* reorder partitions */
	int (*reorder)(struct fdisk_context *cxt);
	/* get details from label */
	int (*get_item)(struct fdisk_context *cxt, struct fdisk_labelitem *item);
	/* set disk label ID */
	int (*set_id)(struct fdisk_context *cxt);


	/* new partition */
	int (*add_part)(struct fdisk_context *cxt, struct fdisk_partition *pa,
						size_t *partno);
	/* delete partition */
	int (*del_part)(struct fdisk_context *cxt, size_t partnum);

	/* fill in partition struct */
	int (*get_part)(struct fdisk_context *cxt, size_t n,
						struct fdisk_partition *pa);
	/* modify partition */
	int (*set_part)(struct fdisk_context *cxt, size_t n,
						struct fdisk_partition *pa);

	/* return state of the partition */
	int (*part_is_used)(struct fdisk_context *cxt, size_t partnum);

	int (*part_toggle_flag)(struct fdisk_context *cxt, size_t i, unsigned long flag);

	/* refresh alignment setting */
	int (*reset_alignment)(struct fdisk_context *cxt);

	/* free in-memory label stuff */
	void (*free)(struct fdisk_label *lb);

	/* deinit in-memory label stuff */
	void (*deinit)(struct fdisk_label *lb);
};

/* note that the defaults is to display a column always */
enum {
	FDISK_FIELDFL_DETAIL    = (1 << 1),     /* only display if fdisk_is_details() */
	FDISK_FIELDFL_EYECANDY  = (1 << 2),     /* don't display if fdisk_is_details() */
	FDISK_FIELDFL_NUMBER    = (1 << 3),     /* column display numbers */
};

/* Generic label */
struct fdisk_label {
	const char              *name;          /* label name */
	enum fdisk_labeltype    id;             /* FDISK_DISKLABEL_* */
	struct fdisk_parttype  *parttypes;      /* supported partitions types */
	size_t                  nparttypes;     /* number of items in parttypes[] */

	size_t                  nparts_max;     /* maximal number of partitions */
	size_t                  nparts_cur;     /* number of currently used partitions */

	int                     flags;          /* FDISK_LABEL_FL_* flags */

	struct fdisk_geometry   geom_min;       /* minimal geometry */
	struct fdisk_geometry   geom_max;       /* maximal geometry */

	unsigned int            changed:1,      /* label has been modified */
				disabled:1;     /* this driver is disabled at all */

	const struct fdisk_field *fields;       /* all possible fields */
	size_t                  nfields;

	const struct fdisk_label_operations *op;
};

/* label driver flags */
enum {
	FDISK_LABEL_FL_REQUIRE_GEOMETRY = (1 << 2),
	FDISK_LABEL_FL_INCHARS_PARTNO   = (1 << 3)
};

static struct fdisk_label *fdisk_new_dos_label(struct fdisk_context *cxt);
#ifdef CONFIG_FEATURE_BSD_LABEL
static struct fdisk_label *fdisk_new_bsd_label(struct fdisk_context *cxt);
#endif

enum {
	FDISK_DIFF_UNCHANGED = 0,
	FDISK_DIFF_REMOVED,
	FDISK_DIFF_ADDED,
	FDISK_DIFF_MOVED,
	FDISK_DIFF_RESIZED
};

/* Use only internally for non-allocated items, never use
 * refcouting for such items! */
#define FDISK_LABELITEM_INIT    { .type = 0, .refcount = 0 }

#define MBR_PT_OFFSET           0x1be
#define MBR_PT_BOOTBITS_SIZE    440

enum {
	MBR_EMPTY_PARTITION             = 0x00,
	MBR_FAT12_PARTITION             = 0x01,
	MBR_XENIX_ROOT_PARTITION        = 0x02,
	MBR_XENIX_USR_PARTITION         = 0x03,
	MBR_FAT16_LESS32M_PARTITION     = 0x04,
	MBR_DOS_EXTENDED_PARTITION      = 0x05,
	MBR_FAT16_PARTITION             = 0x06, /* DOS 16-bit >=32M */
	MBR_HPFS_NTFS_PARTITION         = 0x07, /* OS/2 IFS, eg, HPFS or NTFS or QNX */
	MBR_AIX_PARTITION               = 0x08, /* AIX boot (AIX -- PS/2 port) or SplitDrive */
	MBR_AIX_BOOTABLE_PARTITION      = 0x09, /* AIX data or Coherent */
	MBR_OS2_BOOTMNGR_PARTITION      = 0x0a, /* OS/2 Boot Manager */
	MBR_W95_FAT32_PARTITION         = 0x0b,
	MBR_W95_FAT32_LBA_PARTITION     = 0x0c, /* LBA really is `Extended Int 13h' */
	MBR_W95_FAT16_LBA_PARTITION     = 0x0e,
	MBR_W95_EXTENDED_PARTITION      = 0x0f,
	MBR_OPUS_PARTITION              = 0x10,
	MBR_HIDDEN_FAT12_PARTITION      = 0x11,
	MBR_COMPAQ_DIAGNOSTICS_PARTITION = 0x12,
	MBR_HIDDEN_FAT16_L32M_PARTITION = 0x14,
	MBR_HIDDEN_FAT16_PARTITION      = 0x16,
	MBR_HIDDEN_HPFS_NTFS_PARTITION  = 0x17,
	MBR_AST_SMARTSLEEP_PARTITION    = 0x18,
	MBR_HIDDEN_W95_FAT32_PARTITION  = 0x1b,
	MBR_HIDDEN_W95_FAT32LBA_PARTITION = 0x1c,
	MBR_HIDDEN_W95_FAT16LBA_PARTITION = 0x1e,
	MBR_NEC_DOS_PARTITION           = 0x24,
	MBR_PLAN9_PARTITION             = 0x39,
	MBR_PARTITIONMAGIC_PARTITION    = 0x3c,
	MBR_VENIX80286_PARTITION        = 0x40,
	MBR_PPC_PREP_BOOT_PARTITION     = 0x41,
	MBR_SFS_PARTITION               = 0x42,
	MBR_QNX_4X_PARTITION            = 0x4d,
	MBR_QNX_4X_2ND_PARTITION        = 0x4e,
	MBR_QNX_4X_3RD_PARTITION        = 0x4f,
	MBR_DM_PARTITION                = 0x50,
	MBR_DM6_AUX1_PARTITION          = 0x51, /* (or Novell) */
	MBR_CPM_PARTITION               = 0x52, /* CP/M or Microport SysV/AT */
	MBR_DM6_AUX3_PARTITION          = 0x53,
	MBR_DM6_PARTITION               = 0x54,
	MBR_EZ_DRIVE_PARTITION          = 0x55,
	MBR_GOLDEN_BOW_PARTITION        = 0x56,
	MBR_PRIAM_EDISK_PARTITION       = 0x5c,
	MBR_SPEEDSTOR_PARTITION         = 0x61,
	MBR_GNU_HURD_PARTITION          = 0x63, /* GNU HURD or Mach or Sys V/386 (such as ISC UNIX) */
	MBR_UNIXWARE_PARTITION          = MBR_GNU_HURD_PARTITION,
	MBR_NETWARE_286_PARTITION       = 0x64,
	MBR_NETWARE_386_PARTITION       = 0x65,
	MBR_DISKSECURE_MULTIBOOT_PARTITION = 0x70,
	MBR_PC_IX_PARTITION             = 0x75,
	MBR_OLD_MINIX_PARTITION         = 0x80, /* Minix 1.4a and earlier */
	MBR_MINIX_PARTITION             = 0x81, /* Minix 1.4b and later */
	MBR_LINUX_SWAP_PARTITION        = 0x82,
	MBR_SOLARIS_X86_PARTITION       = MBR_LINUX_SWAP_PARTITION,
	MBR_LINUX_DATA_PARTITION        = 0x83,
	MBR_OS2_HIDDEN_DRIVE_PARTITION  = 0x84, /* also hibernation MS APM, Intel Rapid Start */
	MBR_INTEL_HIBERNATION_PARTITION = MBR_OS2_HIDDEN_DRIVE_PARTITION,
	MBR_LINUX_EXTENDED_PARTITION    = 0x85,
	MBR_NTFS_VOL_SET1_PARTITION     = 0x86,
	MBR_NTFS_VOL_SET2_PARTITION     = 0x87,
	MBR_LINUX_PLAINTEXT_PARTITION   = 0x88,
	MBR_LINUX_LVM_PARTITION         = 0x8e,
	MBR_AMOEBA_PARTITION            = 0x93,
	MBR_AMOEBA_BBT_PARTITION        = 0x94, /* (bad block table) */
	MBR_BSD_OS_PARTITION            = 0x9f, /* BSDI */
	MBR_THINKPAD_HIBERNATION_PARTITION = 0xa0,
	MBR_FREEBSD_PARTITION           = 0xa5, /* various BSD flavours */
	MBR_OPENBSD_PARTITION           = 0xa6,
	MBR_NEXTSTEP_PARTITION          = 0xa7,
	MBR_DARWIN_UFS_PARTITION        = 0xa8,
	MBR_NETBSD_PARTITION            = 0xa9,
	MBR_DARWIN_BOOT_PARTITION       = 0xab,
	MBR_HFS_HFS_PARTITION           = 0xaf,
	MBR_BSDI_FS_PARTITION           = 0xb7,
	MBR_BSDI_SWAP_PARTITION         = 0xb8,
	MBR_BOOTWIZARD_HIDDEN_PARTITION = 0xbb,
	MBR_ACRONIS_FAT32LBA_PARTITION  = 0xbc, /* Acronis Secure Zone with ipl for loader F11.SYS */
	MBR_SOLARIS_BOOT_PARTITION      = 0xbe,
	MBR_SOLARIS_PARTITION           = 0xbf,
	MBR_DRDOS_FAT12_PARTITION       = 0xc1,
	MBR_DRDOS_FAT16_L32M_PARTITION  = 0xc4,
	MBR_DRDOS_FAT16_PARTITION       = 0xc6,
	MBR_SYRINX_PARTITION            = 0xc7,
	MBR_NONFS_DATA_PARTITION        = 0xda,
	MBR_CPM_CTOS_PARTITION          = 0xdb, /* CP/M or Concurrent CP/M or Concurrent DOS or CTOS */
	MBR_DELL_UTILITY_PARTITION      = 0xde, /* Dell PowerEdge Server utilities */
	MBR_BOOTIT_PARTITION            = 0xdf, /* BootIt EMBRM */
	MBR_DOS_ACCESS_PARTITION        = 0xe1, /* DOS access or SpeedStor 12-bit FAT extended partition */
	MBR_DOS_RO_PARTITION            = 0xe3, /* DOS R/O or SpeedStor */
	MBR_SPEEDSTOR_EXTENDED_PARTITION = 0xe4, /* SpeedStor 16-bit FAT extended partition < 1024 cyl. */
	MBR_RUFUS_EXTRA_PARTITION       = 0xea, /* Rufus extra partition for alignment */
	MBR_BEOS_FS_PARTITION           = 0xeb,
	MBR_GPT_PARTITION               = 0xee, /* Intel EFI GUID Partition Table */
	MBR_EFI_SYSTEM_PARTITION        = 0xef, /* Intel EFI System Partition */
	MBR_LINUX_PARISC_BOOT_PARTITION = 0xf0, /* Linux/PA-RISC boot loader */
	MBR_SPEEDSTOR1_PARTITION        = 0xf1,
	MBR_SPEEDSTOR2_PARTITION        = 0xf4, /* SpeedStor large partition */
	MBR_DOS_SECONDARY_PARTITION     = 0xf2, /* DOS 3.3+ secondary */
	MBR_VMWARE_VMFS_PARTITION       = 0xfb,
	MBR_VMWARE_VMKCORE_PARTITION    = 0xfc, /* VMware kernel dump partition */
	MBR_LINUX_RAID_PARTITION        = 0xfd, /* Linux raid partition with autodetect using persistent superblock */
	MBR_LANSTEP_PARTITION           = 0xfe, /* SpeedStor >1024 cyl. or LANstep */
	MBR_XENIX_BBT_PARTITION         = 0xff, /* Xenix Bad Block Table */
};

struct dos_partition {
	unsigned char boot_ind;         /* 0x80 - active */
	unsigned char bh, bs, bc;       /* begin CHS */
	unsigned char sys_ind;
	unsigned char eh, es, ec;       /* end CHS */
	unsigned char start_sect[4];
	unsigned char nr_sects[4];
} __attribute__((packed));

static inline struct dos_partition *mbr_get_partition(unsigned char *mbr, int i)
{
	return (struct dos_partition *)
		(mbr + MBR_PT_OFFSET + (i * sizeof(struct dos_partition)));
}

/* assemble badly aligned little endian integer */
static inline uint32_t __dos_assemble_4le(const unsigned char *p)
{
	uint32_t last_byte = p[3];

	return p[0] | (p[1] << 8) | (p[2] << 16) | (last_byte << 24);
}

static inline void __dos_store_4le(unsigned char *p, unsigned int val)
{
	p[0] = (val & 0xff);
	p[1] = ((val >> 8) & 0xff);
	p[2] = ((val >> 16) & 0xff);
	p[3] = ((val >> 24) & 0xff);
}

static inline unsigned int dos_partition_get_start(struct dos_partition *p)
{
	return __dos_assemble_4le(&(p->start_sect[0]));
}

static inline void dos_partition_set_start(struct dos_partition *p, unsigned int n)
{
	__dos_store_4le(p->start_sect, n);
}

static inline unsigned int dos_partition_get_size(struct dos_partition *p)
{
	return __dos_assemble_4le(&(p->nr_sects[0]));
}

static inline void dos_partition_set_size(struct dos_partition *p, unsigned int n)
{
	__dos_store_4le(p->nr_sects, n);
}

static inline int mbr_is_valid_magic(const unsigned char *mbr)
{
	return mbr[510] == 0x55 && mbr[511] == 0xaa ? 1 : 0;
}

static inline void mbr_set_magic(unsigned char *b)
{
	b[510] = 0x55;
	b[511] = 0xaa;
}

static inline unsigned int mbr_get_id(const unsigned char *mbr)
{
	return __dos_assemble_4le(&mbr[440]);
}

static inline void mbr_set_id(unsigned char *b, unsigned int id)
{
	__dos_store_4le(&b[440], id);
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* For compatibility with the rest of libblkid API (with the old high-level
 * API) we use completely opaque typedefs for all structs. Don't forget that
 * the final blkid_* types are pointers! See blkid.h.
 *
 * [Just for the record, I hate typedef for pointers --kzak] */

/* information about a partition table */
typedef struct blkid_struct_parttable *blkid_parttable;

/* exported as opaque type "blkid_partition" */
struct blkid_struct_partition {
	uint64_t        start;          /* begin of the partition (512-bytes sectors) */
	uint64_t        size;           /* size of the partitions (512-bytes sectors) */

	int             type;           /* partition type */
	char            typestr[UUID_STR_LEN]; /* partition type string (GPT and Mac) */

	unsigned long long flags;       /* partition flags / attributes */

	int             partno;         /* partition number */
	char            uuid[UUID_STR_LEN]; /* UUID (when supported by PT), e.g GPT */
	unsigned char   name[128];      /* Partition in UTF8 name (when supported by PT), e.g. Mac */

	blkid_parttable tab;            /* partition table */
};

/* information about a partition */
typedef struct blkid_struct_partition *blkid_partition;

/* exported as opaque type "blkid_parttable" */
struct blkid_struct_parttable {
	const char      *type;          /* partition table type */
	uint64_t        offset;         /* begin of the partition table (in bytes) */
	int             nparts;         /* number of partitions */
	blkid_partition parent;         /* parent of nested partition table */
	char            id[UUID_STR_LEN]; /* PT identifier (e.g. UUID for GPT) */

	struct list_head t_tabs;        /* all tables */
};


/* information about all system devices */
typedef struct blkid_struct_cache *blkid_cache;

/* The device object keeps information about one device */
typedef struct blkid_struct_dev *blkid_dev;

/* low-level probing setting */
typedef struct blkid_struct_probe *blkid_probe;

/* device topology information */
/* Binary interface */
struct blkid_struct_topology {
	unsigned long   alignment_offset;
	unsigned long   minimum_io_size;
	unsigned long   optimal_io_size;
	unsigned long   logical_sector_size;
	unsigned long   physical_sector_size;
};
typedef struct blkid_struct_topology *blkid_topology;

/* exported as opaque type "blkid_partlist" */
struct blkid_struct_partlist {
	int             next_partno;    /* next partition number */
	blkid_partition next_parent;    /* next parent if parsing nested PT */

	int             nparts;         /* number of partitions */
	int             nparts_max;     /* max.number of partitions */
	blkid_partition parts;          /* array of partitions */

	struct list_head l_tabs;        /* list of partition tables */
};

/* list of all detected partitions and partitions tables */
typedef struct blkid_struct_partlist *blkid_partlist;

/* 64-bit signed number for offsets and sizes */
typedef int64_t blkid_loff_t;

#define BLKID_DEV_FIND          0x0000
#define BLKID_DEV_CREATE        0x0001
#define BLKID_DEV_VERIFY        0x0002
#define BLKID_DEV_NORMAL        (BLKID_DEV_CREATE | BLKID_DEV_VERIFY)


/* This describes the attributes of a specific device.
 * We can traverse all of the tags by bid_tags (linking to the tag bit_names).
 * The bid_label and bid_uuid fields are shortcuts to the LABEL and UUID tag
 * values, if they exist. */
struct blkid_struct_dev
{
	struct list_head        bid_devs;       /* All devices in the cache */
	struct list_head        bid_tags;       /* All tags for this device */
	blkid_cache             bid_cache;      /* Dev belongs to this cache */
	char                    *bid_name;      /* Device real path (as used in cache) */
	char                    *bid_xname;     /* Device path as used by application (maybe symlink..) */
	char                    *bid_type;      /* Preferred device TYPE */
	int                     bid_pri;        /* Device priority */
	dev_t                   bid_devno;      /* Device major/minor number */
	time_t                  bid_time;       /* Last update time of device */
	suseconds_t             bid_utime;      /* Last update time (microseconds) */
	unsigned int            bid_flags;      /* Device status bitflags */
	char                    *bid_label;     /* Shortcut to device LABEL */
	char                    *bid_uuid;      /* Shortcut to binary UUID */
};

#define BLKID_BID_FL_VERIFIED   0x0001  /* Device data validated from disk */
#define BLKID_BID_FL_INVALID    0x0004  /* Device is invalid */
#define BLKID_BID_FL_REMOVABLE  0x0008  /* Device added by blkid_probe_all_removable() */

/* Each tag defines a NAME=value pair for a particular device.  The tags
 * are linked via bit_names for a single device, so that traversing the
 * names list will get you a list of all tags associated with a device.
 * They are also linked via bit_values for all devices, so one can easily
 * search all tags with a given NAME for a specific value. */
struct blkid_struct_tag
{
	struct list_head        bit_tags;       /* All tags for this device */
	struct list_head        bit_names;      /* All tags with given NAME */
	char                    *bit_name;      /* NAME of tag (shared) */
	char                    *bit_val;       /* value of tag */
	blkid_dev               bit_dev;        /* pointer to device */
};
typedef struct blkid_struct_tag *blkid_tag;

/* Chain IDs */
enum {
	BLKID_CHAIN_SUBLKS,     /* FS/RAID superblocks (enabled by default) */
	BLKID_CHAIN_TOPLGY,     /* Block device topology */
	BLKID_CHAIN_PARTS,      /* Partition tables */

	BLKID_NCHAINS           /* number of chains */
};

struct blkid_chain {
	const struct blkid_chaindrv *driver;    /* chain driver */

	int             enabled;        /* boolean */
	int             flags;          /* BLKID_<chain>* */
	int             binary;         /* boolean */
	int             idx;            /* index of the current prober or -1 */
	unsigned long   *fltr;          /* filter or NULL */
	void            *data;          /* private chain data or NULL */
};

/* Chain driver */
struct blkid_chaindrv {
	const size_t    id;             /* BLKID_CHAIN_* */
	const char      *name;          /* name of chain (for debug purpose) */
	const int       dflt_flags;     /* default chain flags */
	const int       dflt_enabled;   /* default enabled boolean */
	int             has_fltr;       /* boolean */

	const struct blkid_idinfo * const *idinfos; /* description of probing functions */
	const size_t    nidinfos;       /* number of idinfos */

	/* driver operations */
	int             (*probe)(blkid_probe, struct blkid_chain *);
	int             (*safeprobe)(blkid_probe, struct blkid_chain *);
	void            (*free_data)(blkid_probe, void *);
};

/* Low-level probe result */
struct blkid_prval
{
	const char      *name;          /* value name */
	unsigned char   *data;          /* value data */
	size_t          len;            /* length of value data */

	struct blkid_chain      *chain;         /* owner */
	struct list_head        prvals;         /* list of results */
};

/* Filesystem / Raid magic strings */
struct blkid_idmag
{
	const char      *magic;         /* magic string */
	unsigned int    len;            /* length of magic */

	long            kboff;          /* kilobyte offset of superblock */
	unsigned int    sboff;          /* byte offset within superblock */
};

/* Filesystem / Raid description */
struct blkid_idinfo
{
	const char      *name;          /* fs, raid or partition table name */
	int             usage;          /* BLKID_USAGE_* flag */
	int             flags;          /* BLKID_IDINFO_* flags */
	int             minsz;          /* minimal device size */

					/* probe function */
	int             (*probefunc)(blkid_probe pr, const struct blkid_idmag *mag);

	struct blkid_idmag      magics[];       /* NULL or array with magic strings */
};

#define BLKID_NONE_MAGIC        {{ NULL }}

/* tolerant FS - can share the same device with more filesystems (e.g. typical
 * on CD-ROMs). We need this flag to detect ambivalent results (e.g. valid fat
 * and valid linux swap on the same device). */
#define BLKID_IDINFO_TOLERANT   (1 << 1)

struct blkid_bufinfo {
	unsigned char           *data;
	uint64_t                off;
	uint64_t                len;
	struct list_head        bufs;   /* list of buffers */
};

/* Low-level probing control struct */
struct blkid_struct_probe
{
	int                     fd;             /* device file descriptor */
	uint64_t                off;            /* begin of data on the device */
	uint64_t                size;           /* end of data on the device */

	dev_t                   devno;          /* device number (st.st_rdev) */
	dev_t                   disk_devno;     /* devno of the whole-disk or 0 */
	unsigned int            blkssz;         /* sector size (BLKSSZGET ioctl) */
	mode_t                  mode;           /* struct stat.sb_mode */

	int                     flags;          /* private library flags */
	int                     prob_flags;     /* always zeroized by blkid_do_*() */

	uint64_t                wipe_off;       /* begin of the wiped area */
	uint64_t                wipe_size;      /* size of the wiped area */
	struct blkid_chain      *wipe_chain;    /* superblock, partition, ... */

	struct list_head        buffers;        /* list of buffers */

	struct blkid_chain      chains[BLKID_NCHAINS];  /* array of chains */
	struct blkid_chain      *cur_chain;             /* current chain */

	struct list_head        values;         /* results */

	struct blkid_struct_probe *parent;      /* for clones */
	struct blkid_struct_probe *disk_probe;  /* whole-disk probing */
};

/* private flags library flags */
#define BLKID_FL_PRIVATE_FD     (1 << 1)        /* see blkid_new_probe_from_filename() */
#define BLKID_FL_TINY_DEV       (1 << 2)        /* <= 1.47MiB (floppy or so) */
#define BLKID_FL_CDROM_DEV      (1 << 3)        /* is a CD/DVD drive */
#define BLKID_FL_NOSCAN_DEV     (1 << 4)        /* do not scan this device */
#define BLKID_FL_MODIF_BUFF     (1 << 5)        /* cached bufferes has been modified */

/* private per-probing flags */
#define BLKID_PROBE_FL_IGNORE_PT (1 << 1)       /* ignore partition table */

/* Evaluation methods (for blkid_eval_* API) */
enum {
	BLKID_EVAL_UDEV = 0,
	BLKID_EVAL_SCAN,

	__BLKID_EVAL_LAST
};

/* Library config options */
struct blkid_config {
	int eval[__BLKID_EVAL_LAST];    /* array with EVALUATION=<udev,cache> options */
	int nevals;                     /* number of elems in eval array */
	int uevent;                     /* SEND_UEVENT=<yes|not> option */
	char *cachefile;                /* CACHE_FILE=<path> option */
};

/* Minimum number of seconds between device probes, even when reading
 * from the cache.  This is to avoid re-probing all devices which were
 * just probed by another program that does not share the cache. */
#define BLKID_PROBE_MIN         2

/* Time in seconds an entry remains verified in the in-memory cache
 * before being reverified (in case of long-running processes that
 * keep a cache in memory and continue to use it for a long time). */
#define BLKID_PROBE_INTERVAL    200

/* This describes an entire blkid cache file and probed devices.
 * We can traverse all of the found devices via bic_list.
 * We can traverse all of the tag types by bic_tags, which hold empty tags
 * for each tag type.  Those tags can be used as list_heads for iterating
 * through all devices with a specific tag type (e.g. LABEL). */
struct blkid_struct_cache
{
	struct list_head        bic_devs;       /* List head of all devices */
	struct list_head        bic_tags;       /* List head of all tag types */
	time_t                  bic_time;       /* Last probe time */
	time_t                  bic_ftime;      /* Mod time of the cachefile */
	unsigned int            bic_flags;      /* Status flags of the cache */
	char                    *bic_filename;  /* filename of cache */
	blkid_probe             probe;          /* low-level probing stuff */
};

#define BLKID_PROBE_OK   0
#define BLKID_PROBE_NONE 1

#define BLKID_ERR_IO     5
#define BLKID_ERR_PROC   9
#define BLKID_ERR_MEM   12
#define BLKID_ERR_CACHE 14
#define BLKID_ERR_DEV   19
#define BLKID_ERR_PARAM 22
#define BLKID_ERR_BIG   27

/* Priority settings for different types of devices */
#define BLKID_PRI_UBI   50
#define BLKID_PRI_DM    40
#define BLKID_PRI_EVMS  30
#define BLKID_PRI_LVM   20
#define BLKID_PRI_MD    10

struct dir_list {
	char    *name;
	struct dir_list *next;
};

/* returns superblock according to 'struct blkid_idmag' */
#define blkid_probe_get_sb(_pr, _mag, type) \
			((type *) blkid_probe_get_buffer((_pr),\
					(_mag)->kboff << 10, sizeof(type)))

/* filter bitmap macros */
#define blkid_bmp_wordsize              (8 * sizeof(unsigned long))
#define blkid_bmp_idx_bit(item)         (1UL << ((item) % blkid_bmp_wordsize))
#define blkid_bmp_idx_byte(item)        ((item) / blkid_bmp_wordsize)

#define blkid_bmp_get_item(bmp, item)   \
		((bmp)[ blkid_bmp_idx_byte(item) ] & blkid_bmp_idx_bit(item))

#define BLKID_ENC_UTF16BE       0
#define BLKID_ENC_UTF16LE       1
#define BLKID_ENC_LATIN1        2

#define BLKID_SUBLKS_LABEL      (1 << 1) /* read LABEL from superblock */
#define BLKID_SUBLKS_LABELRAW   (1 << 2) /* read and define LABEL_RAW result value */
#define BLKID_SUBLKS_UUID       (1 << 3) /* read UUID from superblock */
#define BLKID_SUBLKS_UUIDRAW    (1 << 4) /* read and define UUID_RAW result value */
#define BLKID_SUBLKS_TYPE       (1 << 5) /* define TYPE result value */
#define BLKID_SUBLKS_SECTYPE    (1 << 6) /* define compatible fs type (second type) */
#define BLKID_SUBLKS_USAGE      (1 << 7) /* define USAGE result value */
#define BLKID_SUBLKS_VERSION    (1 << 8) /* read FS type from superblock */
#define BLKID_SUBLKS_MAGIC      (1 << 9) /* define SBMAGIC and SBMAGIC_OFFSET */
#define BLKID_SUBLKS_BADCSUM    (1 << 10) /* allow a bad checksum */

#define BLKID_SUBLKS_DEFAULT    (BLKID_SUBLKS_LABEL | BLKID_SUBLKS_UUID | \
				 BLKID_SUBLKS_TYPE | BLKID_SUBLKS_SECTYPE)

#define BLKID_FLTR_NOTIN                1
#define BLKID_FLTR_ONLYIN               2

#define BLKID_USAGE_FILESYSTEM          (1 << 1)
#define BLKID_USAGE_RAID                (1 << 2)
#define BLKID_USAGE_CRYPTO              (1 << 3)
#define BLKID_USAGE_OTHER               (1 << 4)

/* partitions probing flags */
#define BLKID_PARTS_FORCE_GPT           (1 << 1)
#define BLKID_PARTS_ENTRY_DETAILS       (1 << 2)
#define BLKID_PARTS_MAGIC               (1 << 3)


/* partition probers */
struct path_cxt {
	int     dir_fd;
	char    *dir_path;

	int     refcount;

	char *prefix;
	char path_buffer[PATH_MAX];

	void    *dialect;
	void    (*free_dialect)(struct path_cxt *);
	int     (*redirect_on_enoent)(struct path_cxt *, const char *, int *);
};

/* Linux kernel linux/drivers/base/core.c: device_get_devnode()
 * defines a replacement of '!' in the /sys device name by '/' in the
 * /dev device name. This helper replaces all occurrences of '!' in
 * @name by '/' to convert from /sys to /dev. */
static void sysfs_devname_sys_to_dev(char *name)
{
	char *c;

	if (name)
		while ((c = strchr(name, '!')))
			c[0] = '/';
}

/* See sysfs_devname_sys_to_dev(). */
static void sysfs_devname_dev_to_sys(char *name)
{
	char *c;

	if (name)
		while ((c = strchr(name, '/')))
			c[0] = '!';
}

struct sysfs_blkdev {
	dev_t   devno;
	struct path_cxt *parent;

	unsigned int    scsi_host,
			scsi_channel,
			scsi_target,
			scsi_lun;

	unsigned int    has_hctl   : 1,
			hctl_error : 1 ;
};
#endif /* CONFIG_FEATURE_LIBBLKID */

struct child_process {
	const char **argv;
	pid_t pid;
	int in;
	int out;
	int err;

	int org_err;
	int org_out;
	struct sigaction orig_sigint;
	struct sigaction orig_sighup;
	struct sigaction orig_sigterm;
	struct sigaction orig_sigquit;
	struct sigaction orig_sigpipe;

	unsigned no_stdin:1;
	void (*preexec_cb)(void);
};

#ifdef USE_COLORS_BY_DEFAULT
# define UL_COLORMODE_DEFAULT   UL_COLORMODE_AUTO       /* check isatty() */
#else
# define UL_COLORMODE_DEFAULT   UL_COLORMODE_NEVER      /* no colors by default */
#endif

/* terminal-colors.d file types */
enum {
	UL_COLORFILE_DISABLE,           /* .disable */
	UL_COLORFILE_ENABLE,            /* .enable */
	UL_COLORFILE_SCHEME,            /* .scheme */

	__UL_COLORFILE_COUNT
};

struct ul_color_scheme {
	char *name;
	char *seq;
};

/* Global colors control struct
 *
 * The terminal-colors.d/ evaluation is based on "scores":
 *
 *  filename                    score
 *  ---------------------------------------
 *  type                        1
 *  @termname.type              10 + 1
 *  utilname.type               20 + 1
 *  utilname@termname.type      20 + 10 + 1
 *
 * the match with higher score wins. The score is per type. */
struct ul_color_ctl {
	const char      *utilname;      /* util name */
	const char      *termname;      /* terminal name ($TERM) */

	char            *sfile; /* path to scheme */

	struct ul_color_scheme  *schemes;       /* array with color schemes */
	size_t                  nschemes;       /* number of the items */
	size_t                  schemes_sz;     /* number of the allocated items */

	int             mode;           /* UL_COLORMODE_* */
	unsigned int    has_colors : 1, /* based on mode and scores[] */
			cs_configured : 1, /* color schemes read */
			configured : 1; /* terminal-colors.d parsed */

	int             scores[__UL_COLORFILE_COUNT];   /* the best match */
};

/* used by fdisk and sfdisk */
enum {
	WIPEMODE_AUTO = 0,      /* for bss */
	WIPEMODE_NEVER = 1,
	WIPEMODE_ALWAYS = 2
};

CALC_BSS struct BB_COMMON_BSS
{
	int device_is_used;
	int is_interactive;
	struct fdisk_table *original_layout;
#ifdef CONFIG_FEATURE_LIBBLKID
	int do_compat_llseek;
#endif
#if defined(CONFIG_FEATURE_LIBBLKID) || defined(CONFIG_FEATURE_GPT_LABEL)
	uint32_t crc32_tab[256];
#endif
	int *fields_ids;
	const struct fdisk_label *fields_label;
	size_t fields_nids;
	const char *fields_string;
	unsigned int info_count;
	const char *pager_argv[4];
	struct child_process pager_process;
	int pwipemode; /* = WIPEMODE_AUTO */
	int wipemode; /* = WIPEMODE_AUTO */
	unsigned char nilfs_valid_sb_sum[4];
	/* Control struct, globally shared. */
	struct ul_color_ctl ul_colors;
#ifdef CONFIG_FEATURE_SUN_LABEL
	unsigned int *verify_sun_starts;
#endif
} bb_common_bss;
#define device_is_used bb_common_bss.device_is_used
#define is_interactive bb_common_bss.is_interactive
#define original_layout bb_common_bss.original_layout
#define do_compat_llseek bb_common_bss.do_compat_llseek
#define crc32_tab bb_common_bss.crc32_tab
#define fields_ids bb_common_bss.fields_ids
#define fields_label bb_common_bss.fields_label
#define fields_nids bb_common_bss.fields_nids
#define fields_string bb_common_bss.fields_string
#define info_count bb_common_bss.info_count
#define pager_argv bb_common_bss.pager_argv
#define pager_process bb_common_bss.pager_process
#define pwipemode bb_common_bss.pwipemode
#define wipemode bb_common_bss.wipemode
#define nilfs_valid_sb_sum bb_common_bss.nilfs_valid_sb_sum
#define ul_colors bb_common_bss.ul_colors
#define verify_sun_starts bb_common_bss.verify_sun_starts

/* Fallbacks
 * casts are necessary for constants, because we never know how for sure
 * how U/UL/ULL map to __u16, __u32, __u64. At least not in a portable way. */
#ifndef bswap_16
# define bswap_16(x) ((uint16_t)( \
	(((uint16_t)(x) & 0x00FF) << 8) | \
	(((uint16_t)(x) & 0xFF00) >> 8)))
#endif

#ifndef bswap_32
# define bswap_32(x) ((uint32_t)( \
	(((uint32_t)(x) & 0x000000FF) << 24) | \
	(((uint32_t)(x) & 0x0000FF00) << 8)  | \
	(((uint32_t)(x) & 0x00FF0000) >> 8)  | \
	(((uint32_t)(x) & 0xFF000000) >> 24)))
#endif

#ifndef bswap_64
# define bswap_64(x) ((uint64_t)( \
	(((uint64_t)(x) & 0x00000000000000FFULL) << 56) | \
	(((uint64_t)(x) & 0x000000000000FF00ULL) << 40) | \
	(((uint64_t)(x) & 0x0000000000FF0000ULL) << 24) | \
	(((uint64_t)(x) & 0x00000000FF000000ULL) << 8)  | \
	(((uint64_t)(x) & 0x000000FF00000000ULL) >> 8)  | \
	(((uint64_t)(x) & 0x0000FF0000000000ULL) >> 24) | \
	(((uint64_t)(x) & 0x00FF000000000000ULL) >> 40) | \
	(((uint64_t)(x) & 0xFF00000000000000ULL) >> 56)))
#endif

#ifndef htobe16
# if !defined(WORDS_BIGENDIAN)
#  define htobe16(x) bswap_16 (x)
#  define htole16(x) (x)
#  define be16toh(x) bswap_16 (x)
#  define le16toh(x) (x)
#  define htobe32(x) bswap_32 (x)
#  define htole32(x) (x)
#  define be32toh(x) bswap_32 (x)
#  define le32toh(x) (x)
#  define htobe64(x) bswap_64 (x)
#  define htole64(x) (x)
#  define be64toh(x) bswap_64 (x)
#  define le64toh(x) (x)
# else
#  define htobe16(x) (x)
#  define htole16(x) bswap_16 (x)
#  define be16toh(x) (x)
#  define le16toh(x) bswap_16 (x)
#  define htobe32(x) (x)
#  define htole32(x) bswap_32 (x)
#  define be32toh(x) (x)
#  define le32toh(x) bswap_32 (x)
#  define htobe64(x) (x)
#  define htole64(x) bswap_64 (x)
#  define be64toh(x) (x)
#  define le64toh(x) bswap_64 (x)
# endif
#endif

/* Byte swab macros (based on linux/byteorder/swab.h) */
#define swab16(x) bswap_16(x)
#define swab32(x) bswap_32(x)
#define swab64(x) bswap_64(x)

#define cpu_to_le16(x) ((uint16_t) htole16(x))
#define cpu_to_le32(x) ((uint32_t) htole32(x))
#define cpu_to_le64(x) ((uint64_t) htole64(x))

#define cpu_to_be16(x) ((uint16_t) htobe16(x))
#define cpu_to_be32(x) ((uint32_t) htobe32(x))
#define cpu_to_be64(x) ((uint64_t) htobe64(x))

#define le16_to_cpu(x) ((uint16_t) le16toh(x))
#define le32_to_cpu(x) ((uint32_t) le32toh(x))
#define le64_to_cpu(x) ((uint64_t) le64toh(x))

#define be16_to_cpu(x) ((uint16_t) be16toh(x))
#define be32_to_cpu(x) ((uint32_t) be32toh(x))
#define be64_to_cpu(x) ((uint64_t) be64toh(x))


/* Resets the iterator. */
static void scols_reset_iter(struct libscols_iter *itr, int direction)
{
	if (direction == -1)
		direction = itr->direction;

	memset(itr, 0, sizeof(*itr));
	itr->direction = direction;
}

/* Returns: a pointer to a newly allocated struct libscols_symbols instance. */
static struct libscols_symbols *scols_new_symbols(void)
{
	struct libscols_symbols *sy = zmalloc(sizeof(struct libscols_symbols));

	sy->refcount = 1;
	return sy;
}

/* Increases the refcount of @sy. */
static inline void scols_ref_symbols(struct libscols_symbols *sy)
{
	if (sy)
		sy->refcount++;
}

/* Decreases the refcount of @sy. */
static void scols_unref_symbols(struct libscols_symbols *sy)
{
	if (sy && --sy->refcount <= 0) {
		free(sy->branch);
		free(sy->vert);
		free(sy->right);
		free(sy->title_padding);
		free(sy->cell_padding);
		free(sy);
	}
}

static int strdup_to_offset(void *stru, size_t offset, const char *str)
{
	char *n = NULL;
	char **o;

	if (!stru)
		return -EINVAL;

	o = (char **) ((char *) stru + offset);
	if (str)
		n = xstrdup(str);

	free(*o);
	*o = n;
	return 0;
}

#define strdup_to_struct_member(_s, _m, _str) \
		strdup_to_offset((void *) _s, offsetof(__typeof__(*(_s)), _m), _str)

/* Returns: 0, a negative value in case of an error. */
static int scols_symbols_set_branch(struct libscols_symbols *sy, const char *str)
{
	return strdup_to_struct_member(sy, branch, str);
}

/* Returns: 0, a negative value in case of an error. */
static int scols_symbols_set_vertical(struct libscols_symbols *sy, const char *str)
{
	return strdup_to_struct_member(sy, vert, str);
}

/* Returns: 0, a negative value in case of an error. */
static int scols_symbols_set_right(struct libscols_symbols *sy, const char *str)
{
	return strdup_to_struct_member(sy, right, str);
}

/* The current implementation uses only the first byte from the padding string.
 * A multibyte chars are not supported yet.
 *
 * Returns: 0, a negative value in case of an error. */
static int scols_symbols_set_title_padding(struct libscols_symbols *sy, const char *str)
{
	return strdup_to_struct_member(sy, title_padding, str);
}

/* The padding char has to take up just one cell on the terminal.
 *
 * Returns: 0, a negative value in case of an error. */
static int scols_symbols_set_cell_padding(struct libscols_symbols *sy, const char *str)
{
	return strdup_to_struct_member(sy, cell_padding, str);
}

/* Removes whitespace from the right-hand side of a string (trailing
 * whitespace).
 * Returns size of the new string (without \0). */
static size_t rtrim_whitespace(unsigned char *str)
{
	size_t i;

	if (!str)
		return 0;
	i = strlen((char *) str);
	while (i) {
		i--;
		if (!isspace(str[i])) {
			i++;
			break;
		}
	}
	str[i] = '\0';
	return i;
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* Search in buffers we already in memory */
static struct blkid_bufinfo *get_cached_buffer(blkid_probe pr, uint64_t off, uint64_t len)
{
	uint64_t real_off = pr->off + off;
	struct list_head *p;

	list_for_each(p, &pr->buffers) {
		struct blkid_bufinfo *x = list_entry(p, struct blkid_bufinfo, bufs);

		if (real_off >= x->off && real_off + len <= x->off + x->len)
			return x;
	}
	return NULL;
}

#define my_llseek lseek64

static blkid_loff_t blkid_llseek(int fd, blkid_loff_t offset, int whence)
{
	blkid_loff_t result;

	if ((sizeof(off_t) >= sizeof(blkid_loff_t)) ||
	    (offset < ((blkid_loff_t) 1 << ((sizeof(off_t)*8) -1))))
		return lseek(fd, (off_t) offset, whence);

	if (do_compat_llseek) {
		errno = EOVERFLOW;
		return -1;
	}

	result = my_llseek(fd, offset, whence);
	if (result == -1 && errno == ENOSYS) {
		/* Just in case this code runs on top of an old kernel
		 * which does not support the llseek system call */
		do_compat_llseek++;
		errno = EOVERFLOW;
	}
	return result;
}

/* CDROMs may fail when probed for RAID (last sector problem) */
static inline int blkid_probe_is_cdrom(blkid_probe pr)
{
	return (pr->flags & BLKID_FL_CDROM_DEV);
}

static struct blkid_bufinfo *read_buffer(blkid_probe pr, uint64_t real_off, uint64_t len)
{
	ssize_t ret;
	struct blkid_bufinfo *bf = NULL;

	if (blkid_llseek(pr->fd, real_off, SEEK_SET) < 0) {
		errno = 0;
		return NULL;
	}

	/* someone trying to overflow some buffers? */
	if (len > ULONG_MAX - sizeof(struct blkid_bufinfo)) {
		errno = ENOMEM;
		return NULL;
	}

	/* allocate info and space for data by one malloc call */
	bf = zmalloc(sizeof(struct blkid_bufinfo) + len);
	bf->data = ((unsigned char *) bf) + sizeof(struct blkid_bufinfo);
	bf->len = len;
	bf->off = real_off;
	INIT_LIST_HEAD(&bf->bufs);

	ret = read(pr->fd, bf->data, len);
	if (ret != (ssize_t) len) {
		free(bf);

		/* I/O errors on CDROMs are non-fatal to work with hybrid
		 * audio+data disks */
		if (ret >= 0 || blkid_probe_is_cdrom(pr))
			errno = 0;
		return NULL;
	}

	return bf;
}

/* Note that @off is offset within probing area, the probing area is defined by
 * pr->off and pr->size. */
static unsigned char *blkid_probe_get_buffer(blkid_probe pr, uint64_t off, uint64_t len)
{
	struct blkid_bufinfo *bf = NULL;
	uint64_t real_off = pr->off + off;

	if (pr->size == 0) {
		errno = EINVAL;
		return NULL;
	}

	if (len == 0 || (!S_ISCHR(pr->mode) && pr->off + pr->size < real_off + len)) {
		errno = 0;
		return NULL;
	}

	if (pr->parent &&
	    pr->parent->devno == pr->devno &&
	    pr->parent->off <= pr->off &&
	    pr->parent->off + pr->parent->size >= pr->off + pr->size) {
		/* This is a cloned prober and points to the same area as
		 * parent. Let's use parent's buffers.
		 *
		 * Note that pr->off (and pr->parent->off) is always from the
		 * begin of the device. */
		return blkid_probe_get_buffer(pr->parent,
				pr->off + off - pr->parent->off, len);
	}

	/* try buffers we already have in memory or read from device */
	bf = get_cached_buffer(pr, off, len);
	if (!bf) {
		bf = read_buffer(pr, real_off, len);
		if (!bf)
			return NULL;

		list_add_tail(&bf->bufs, &pr->buffers);
	}

	errno = 0;
	return real_off ? bf->data + (real_off - bf->off) : bf->data;
}

/* BFS actually has two different labels in the superblock, each
 * of them only 6 bytes long.  Until we find out what their use
 * we just ignore them. */
static const struct blkid_idinfo bfs_idinfo =
{
	.name           = "bfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.magics         = {
		{ .magic = "\xce\xfa\xad\x1b", .len = 4 },
		{ NULL }
	}
};

static const struct blkid_idinfo refs_idinfo =
{
	.name           = "ReFS",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.magics         =
	{
		{ .magic = "\000\000\000ReFS\000", .len = 8 },
		{ NULL }
	}
};

static struct blkid_prval *blkid_probe_assign_value(blkid_probe pr, const char *name)
{
	struct blkid_prval *v;

	v = zmalloc(sizeof(struct blkid_prval));
	INIT_LIST_HEAD(&v->prvals);
	v->name = name;
	v->chain = pr->cur_chain;
	list_add_tail(&v->prvals, &pr->values);

	return v;
}

static void blkid_probe_free_value(struct blkid_prval *v)
{
	if (!v)
		return;

	list_del(&v->prvals);
	free(v->data);
	free(v);
}

static int blkid_probe_vsprintf_value(blkid_probe pr, const char *name,
		const char *fmt, va_list ap)
{
	ssize_t len;
	struct blkid_prval *v = blkid_probe_assign_value(pr, name);

	len = vasprintf((char **) &v->data, fmt, ap);
	if (len <= 0) {
		blkid_probe_free_value(v);
		return len == 0 ? -EINVAL : -ENOMEM;
	}
	v->len = len + 1;
	return 0;
}

static int blkid_probe_sprintf_value(blkid_probe pr, const char *name,
		const char *fmt, ...)
{
	int rc;
	va_list ap;

	va_start(ap, fmt);
	rc = blkid_probe_vsprintf_value(pr, name, fmt, ap);
	va_end(ap);

	return rc;
}

static inline struct blkid_chain *blkid_probe_get_chain(blkid_probe pr)
{
	return pr->cur_chain;
}

/* Note that value data is always terminated by zero to keep things robust,
 * this extra zero is not count to the value length. It's caller responsibility
 * to set proper value length (for strings we count terminator to the length,
 * for binary data it's without terminator). */
static void blkid_probe_value_set_data(struct blkid_prval *v,
		const unsigned char *data, size_t len)
{
	v->data = zmalloc(len + 1);   /* always terminate by \0 */
	memcpy(v->data, data, len);
	v->len = len;
}

static void blkid_probe_set_value(blkid_probe pr, const char *name,
		const unsigned char *data, size_t len)
{
	struct blkid_prval *v = blkid_probe_assign_value(pr, name);

	blkid_probe_value_set_data(v, data, len);
}

static int blkid_probe_set_magic(blkid_probe pr, uint64_t offset,
			size_t len, const unsigned char *magic)
{
	int rc = 0;
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (!chn || !len || chn->binary)
		return 0;

	switch (chn->driver->id) {
	case BLKID_CHAIN_SUBLKS:
		if (!(chn->flags & BLKID_SUBLKS_MAGIC))
			return 0;
		blkid_probe_set_value(pr, "SBMAGIC", magic, len);
		rc = blkid_probe_sprintf_value(pr, "SBMAGIC_OFFSET", "%llu", (unsigned long long)offset);
		break;
	case BLKID_CHAIN_PARTS:
		if (!(chn->flags & BLKID_PARTS_MAGIC))
			return 0;
		blkid_probe_set_value(pr, "PTMAGIC", magic, len);
		rc = blkid_probe_sprintf_value(pr, "PTMAGIC_OFFSET", "%llu", (unsigned long long)offset);
		break;
	default:
		break;
	}

	return rc;
}

static void blkid_probe_set_label(blkid_probe pr, const unsigned char *label, size_t len)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if ((chn->flags & BLKID_SUBLKS_LABELRAW))
	    blkid_probe_set_value(pr, "LABEL_RAW", label, len);

	if (!(chn->flags & BLKID_SUBLKS_LABEL))
		return;

	v = blkid_probe_assign_value(pr, "LABEL");
	blkid_probe_value_set_data(v, label, len);
	v->len = rtrim_whitespace(v->data) + 1;
	if (v->len > 1)
		return;
	blkid_probe_free_value(v);
}

/* like uuid_is_null() from libuuid, but works with arbitrary size of UUID */
static int blkid_uuid_is_empty(const unsigned char *buf, size_t len)
{
	size_t i;

	for (i = 0; i < len; i++)
		if (buf[i])
			return 0;
	return 1;
}

static int blkid_probe_sprintf_uuid(blkid_probe pr, const unsigned char *uuid,
				size_t len, const char *fmt, ...)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	va_list ap;
	int rc = 0;

	if (blkid_uuid_is_empty(uuid, len))
		return 0;

	if ((chn->flags & BLKID_SUBLKS_UUIDRAW))
		blkid_probe_set_value(pr, "UUID_RAW", uuid, len);

	if (!(chn->flags & BLKID_SUBLKS_UUID))
		return 0;

	va_start(ap, fmt);
	rc = blkid_probe_vsprintf_value(pr, "UUID", fmt, ap);
	va_end(ap);

	return rc;
}

#define VDEV_LABEL_UBERBLOCK    (128 * 1024ULL)
#define VDEV_LABEL_NVPAIR       ( 16 * 1024ULL)
#define VDEV_LABEL_SIZE         (256 * 1024ULL)
#define UBERBLOCK_SIZE          1024ULL
#define UBERBLOCKS_COUNT   128

#define UBERBLOCK_MAGIC         0x00bab10c              /* oo-ba-bloc!  */
struct zfs_uberblock {
	uint64_t        ub_magic;       /* UBERBLOCK_MAGIC              */
	uint64_t        ub_version;     /* SPA_VERSION                  */
	uint64_t        ub_txg;         /* txg of last sync             */
	uint64_t        ub_guid_sum;    /* sum of all vdev guids        */
	uint64_t        ub_timestamp;   /* UTC time of last sync        */
	char            ub_rootbp;      /* MOS objset_phys_t            */
} __attribute__((packed));

#define ZFS_WANT         4

#define DATA_TYPE_UINT64 8
#define DATA_TYPE_STRING 9

struct nvpair {
	uint32_t        nvp_size;
	uint32_t        nvp_unkown;
	uint32_t        nvp_namelen;
	char            nvp_name[0]; /* aligned to 4 bytes */
	/* aligned ptr array for string arrays */
	/* aligned array of data for value */
};

struct nvstring {
	uint32_t        nvs_type;
	uint32_t        nvs_elem;
	uint32_t        nvs_strlen;
	unsigned char   nvs_string[0];
};

struct nvuint64 {
	uint32_t        nvu_type;
	uint32_t        nvu_elem;
	uint64_t        nvu_value;
};

struct nvlist {
	uint32_t        nvl_unknown[3];
	struct nvpair   nvl_nvpair;
};

static int zfs_process_value(blkid_probe pr, char *name, size_t namelen,
			     void *value, size_t max_value_size)
{
	if (strncmp(name, "name", namelen) == 0 &&
	    sizeof(struct nvstring) <= max_value_size) {
		struct nvstring *nvs = value;
		uint32_t nvs_type = be32_to_cpu(nvs->nvs_type);
		uint32_t nvs_strlen = be32_to_cpu(nvs->nvs_strlen);

		if (nvs_type != DATA_TYPE_STRING ||
		    (uint64_t)nvs_strlen + sizeof(*nvs) > max_value_size)
			return 0;

		blkid_probe_set_label(pr, nvs->nvs_string, nvs_strlen);

		return 1;
	} else if (strncmp(name, "guid", namelen) == 0 &&
		   sizeof(struct nvuint64) <= max_value_size) {
		struct nvuint64 *nvu = value;
		uint32_t nvu_type = be32_to_cpu(nvu->nvu_type);
		uint64_t nvu_value;

		memcpy(&nvu_value, &nvu->nvu_value, sizeof(nvu_value));
		nvu_value = be64_to_cpu(nvu_value);

		if (nvu_type != DATA_TYPE_UINT64)
			return 0;

		blkid_probe_sprintf_value(pr, "UUID_SUB", "%"PRIu64, nvu_value);

		return 1;
	} else if (strncmp(name, "pool_guid", namelen) == 0 &&
		   sizeof(struct nvuint64) <= max_value_size) {
		struct nvuint64 *nvu = value;
		uint32_t nvu_type = be32_to_cpu(nvu->nvu_type);
		uint64_t nvu_value;

		memcpy(&nvu_value, &nvu->nvu_value, sizeof(nvu_value));
		nvu_value = be64_to_cpu(nvu_value);

		if (nvu_type != DATA_TYPE_UINT64)
			return 0;

		blkid_probe_sprintf_uuid(pr, (unsigned char *) &nvu_value,
					 sizeof(nvu_value),
					 "%"PRIu64, nvu_value);
		return 1;
	}

	return 0;
}

static void zfs_extract_guid_name(blkid_probe pr, loff_t offset)
{
	unsigned char *p;
	struct nvlist *nvl;
	struct nvpair *nvp;
	size_t left = 4096;
	int found = 0;

	offset = (offset & ~(VDEV_LABEL_SIZE - 1)) + VDEV_LABEL_NVPAIR;

	/* Note that we currently assume that the desired fields are within
	 * the first 4k (left) of the nvlist.  This is true for all pools
	 * I've seen, and simplifies this code somewhat, because we don't
	 * have to handle an nvpair crossing a buffer boundary. */
	p = blkid_probe_get_buffer(pr, offset, left);
	if (!p)
		return;

	nvl = (struct nvlist *) p;
	nvp = &nvl->nvl_nvpair;
	left -= (unsigned char *)nvp - p; /* Already used up 12 bytes */

	while (left > sizeof(*nvp) && nvp->nvp_size != 0 && found < 3) {
		uint32_t nvp_size = be32_to_cpu(nvp->nvp_size);
		uint32_t nvp_namelen = be32_to_cpu(nvp->nvp_namelen);
		uint64_t namesize = ((uint64_t)nvp_namelen + 3) & ~3;
		size_t max_value_size;
		void *value;

		/* nvpair fits in buffer and name fits in nvpair? */
		if (nvp_size > left || namesize + sizeof(*nvp) > nvp_size)
			break;

		max_value_size = nvp_size - (namesize + sizeof(*nvp));
		value = nvp->nvp_name + namesize;

		found += zfs_process_value(pr, nvp->nvp_name, nvp_namelen,
					   value, max_value_size);

		left -= nvp_size;

		nvp = (struct nvpair *)((char *)nvp + nvp_size);
	}
}

static int find_uberblocks(const void *label, loff_t *ub_offset, int *swap_endian)
{
	uint64_t swab_magic = swab64((uint64_t)UBERBLOCK_MAGIC);
	const struct zfs_uberblock *ub;
	int i, found = 0;
	loff_t offset = VDEV_LABEL_UBERBLOCK;

	for (i = 0; i < UBERBLOCKS_COUNT; i++, offset += UBERBLOCK_SIZE) {
		ub = (const struct zfs_uberblock *)((const char *) label + offset);

		if (ub->ub_magic == UBERBLOCK_MAGIC) {
			*ub_offset = offset;
			*swap_endian = 0;
			found++;
		}

		if (ub->ub_magic == swab_magic) {
			*ub_offset = offset;
			*swap_endian = 1;
			found++;
		}
	}

	return found;
}

static void blkid_probe_sprintf_version(blkid_probe pr, const char *fmt, ...)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	if (chn->flags & BLKID_SUBLKS_VERSION) {
		va_list ap;

		va_start(ap, fmt);
		blkid_probe_vsprintf_value(pr, "VERSION", fmt, ap);
		va_end(ap);
	}
}

/* ZFS has 128x1kB host-endian root blocks, stored in 2 areas at the start
 * of the disk, and 2 areas at the end of the disk.  Check only some of them...
 * #4 (@ 132kB) is the first one written on a new filesystem. */
static int probe_zfs(blkid_probe pr,
	const struct blkid_idmag *mag  __attribute__((__unused__)))
{
	int swab_endian = 0;
	struct zfs_uberblock *ub;
	loff_t offset = 0, ub_offset = 0;
	int label_no, found = 0, found_in_label;
	void *label;
	loff_t blk_align = (pr->size % (256 * 1024ULL));

	/* Look for at least 4 uberblocks to ensure a positive match */
	for (label_no = 0; label_no < 4; label_no++) {
		switch(label_no) {
		case 0: // jump to L0
			offset = 0;
			break;
		case 1: // jump to L1
			offset = VDEV_LABEL_SIZE;
			break;
		case 2: // jump to L2
			offset = pr->size - 2 * VDEV_LABEL_SIZE - blk_align;
			break;
		case 3: // jump to L3
			offset = pr->size - VDEV_LABEL_SIZE - blk_align;
			break;
		}

		label = blkid_probe_get_buffer(pr, offset, VDEV_LABEL_SIZE);
		if (label == NULL)
			return errno ? -errno : 1;

		found_in_label = find_uberblocks(label, &ub_offset, &swab_endian);

		if (found_in_label > 0) {
			found+= found_in_label;
			ub = (struct zfs_uberblock *)((char *) label + ub_offset);
			ub_offset += offset;

			if (found >= ZFS_WANT)
				break;
		}
	}

	if (found < ZFS_WANT)
		return 1;

	/* If we found the 4th uberblock, then we will have exited from the
	 * scanning loop immediately, and ub will be a valid uberblock. */
	blkid_probe_sprintf_version(pr, "%" PRIu64, swab_endian ?
				    (uint64_t)swab64(ub->ub_version) : ub->ub_version);

	zfs_extract_guid_name(pr, offset);

	if (blkid_probe_set_magic(pr, ub_offset,
				sizeof(ub->ub_magic),
				(unsigned char *) &ub->ub_magic))
		return 1;

	return 0;
}

static const struct blkid_idinfo zfs_idinfo =
{
	.name           = "zfs_member",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_zfs,
	.minsz          = 64 * 1024 * 1024,
	.magics         = BLKID_NONE_MAGIC
};

static size_t blkid_encode_to_utf8(int enc, unsigned char *dest, size_t len,
			const unsigned char *src, size_t count)
{
	size_t i, j;
	uint16_t c;

	for (j = i = 0; i < count; i++) {
		if (enc == BLKID_ENC_UTF16LE) {
			if (i+2 > count)
				break;
			c = (src[i+1] << 8) | src[i];
			i++;
		} else if (enc == BLKID_ENC_UTF16BE) {
			if (i+2 > count)
				break;
			c = (src[i] << 8) | src[i+1];
			i++;
		} else if (enc == BLKID_ENC_LATIN1) {
			c = src[i];
		} else {
			return 0;
		}
		if (c == 0) {
			dest[j] = '\0';
			break;
		} else if (c < 0x80) {
			if (j+1 >= len)
				break;
			dest[j++] = (uint8_t) c;
		} else if (c < 0x800) {
			if (j+2 >= len)
				break;
			dest[j++] = (uint8_t) (0xc0 | (c >> 6));
			dest[j++] = (uint8_t) (0x80 | (c & 0x3f));
		} else {
			if (j+3 >= len)
				break;
			dest[j++] = (uint8_t) (0xe0 | (c >> 12));
			dest[j++] = (uint8_t) (0x80 | ((c >> 6) & 0x3f));
			dest[j++] = (uint8_t) (0x80 | (c & 0x3f));
		}
	}
	dest[j] = '\0';
	return j;
}

static unsigned char *blkid_encode_alloc(size_t count, size_t *reslen)
{
	*reslen = (count * 3) + 1;
	return zmalloc(*reslen);
}

#endif /* CONFIG_FEATURE_LIBBLKID */

#if defined(CONFIG_FEATURE_LIBBLKID) || defined(CONFIG_FEATURE_GPT_LABEL)
/* COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or
 * code or tables extracted from it, as desired without restriction. */

static inline uint32_t crc32_add_char(uint32_t crc, unsigned char c)
{
	return crc32_tab[(crc ^ c) & 0xff] ^ (crc >> 8);
}

static uint32_t count_crc32(const unsigned char *buf, size_t len,
			      size_t exclude_off, size_t exclude_len)
{
	uint32_t crc = ~0L;
	const unsigned char *p = buf;
	size_t i;

	for (i = 0; i < len; i++) {
		unsigned char x = *p++;

		if (i >= exclude_off && i < exclude_off + exclude_len)
			x = 0;

		crc = crc32_add_char(crc, x);
	}

	return crc ^ ~0L;
}
#endif

#ifdef CONFIG_FEATURE_LIBBLKID
/* This a generic crc32() function, it takes seed as an argument,
 * and does __not__ xor at the end. Then individual users can do
 * whatever they need. */
static uint32_t ul_crc32(uint32_t seed, const unsigned char *buf, size_t len)
{
	uint32_t crc = seed;
	const unsigned char *p = buf;

	while (len) {
		crc = crc32_add_char(crc, *p++);
		len--;
	}

	return crc;
}
#endif

#if defined(CONFIG_FEATURE_LIBBLKID) || defined(CONFIG_FEATURE_BSD_LABEL) || defined(CONFIG_FEATURE_FDISK_ADVANCED)
static ssize_t read_all(int fd, char *buf, size_t count)
{
	ssize_t ret;
	ssize_t c = 0;
	int tries = 0;

	memset(buf, 0, count);
	while (count > 0) {
		ret = read(fd, buf, count);
		if (ret <= 0) {
			if (ret < 0 && (errno == EAGAIN || errno == EINTR) && (tries++ < 5)) {
				xusleep(250000);
				continue;
			}
			return c ? c : -1;
		}
		if (ret > 0)
			tries = 0;
		count -= ret;
		buf += ret;
		c += ret;
	}
	return c;
}
#endif

/* Removes whitespace from the left-hand side of a string.
 *
 * Returns size of the new string (without \0). */
static size_t ltrim_whitespace(unsigned char *str)
{
	size_t len;
	unsigned char *p;

	if (!str)
		return 0;
	for (p = str; *p && isspace(*p); p++);

	len = strlen((char *) p);

	if (p > str)
		memmove(str, p, len + 1);

	return len;
}

/* Converts private "dm-N" names to "/dev/mapper/<name>"
 *
 * Since 2.6.29 (patch 784aae735d9b0bba3f8b9faef4c8b30df3bf0128) kernel sysfs
 * provides the real DM device names in /sys/block/<ptname>/dm/name */
static char *__canonicalize_dm_name(const char *prefix, const char *ptname)
{
	FILE    *f;
	size_t  sz;
	char    path[256], name[sizeof(path) - sizeof(_PATH_DEV_MAPPER)], *res = NULL;

	if (!ptname || !*ptname)
		return NULL;

	if (!prefix)
		prefix = "";

	snprintf(path, sizeof(path), "%s/sys/block/%s/dm/name", prefix, ptname);
	if (!(f = fopen(path, "r" UL_CLOEXECSTR)))
		return NULL;

	/* read "<name>\n" from sysfs */
	if (fgets(name, sizeof(name), f) && (sz = strlen(name)) > 1) {
		name[sz - 1] = '\0';
		snprintf(path, sizeof(path), _PATH_DEV_MAPPER "/%s", name);

		if (prefix || access(path, F_OK) == 0)
			res = xstrdup(path);
	}
	fclose(f);
	return res;
}

static char *canonicalize_dm_name(const char *ptname)
{
	return __canonicalize_dm_name(NULL, ptname);
}

#ifdef CONFIG_FEATURE_LIBBLKID
static int is_dm_devname(char *canonical, char **name)
{
	struct stat sb;
	char *p = strrchr(canonical, '/');

	*name = NULL;

	if (!p
	    || strncmp(p, "/dm-", 4) != 0
	    || !isdigit(*(p + 4))
	    || stat(canonical, &sb) != 0
	    || !S_ISBLK(sb.st_mode))
		return 0;

	*name = p + 1;
	return 1;
}

static char *canonicalize_path(const char *path)
{
	char *canonical, *dmname;

	if (!path || !*path)
		return NULL;

	canonical = realpath(path, NULL);
	if (!canonical)
		return xstrdup(path);

	if (is_dm_devname(canonical, &dmname)) {
		char *dm = canonicalize_dm_name(dmname);
		if (dm) {
			free(canonical);
			return dm;
		}
	}

	return canonical;
}
#endif

/* Bit map related macros. Usually provided by libc. */
#ifndef NBBY
# define NBBY            CHAR_BIT
#endif

#ifndef setbit
# define setbit(a,i)    ((a)[(i)/NBBY] |= 1<<((i)%NBBY))
# define clrbit(a,i)    ((a)[(i)/NBBY] &= ~(1<<((i)%NBBY)))
# define isset(a,i)     ((a)[(i)/NBBY] & (1<<((i)%NBBY)))
# define isclr(a,i)     (((a)[(i)/NBBY] & (1<<((i)%NBBY))) == 0)
#endif

static int do_scale_by_power (uintmax_t *x, int base, int power)
{
	while (power--) {
		if (UINTMAX_MAX / base < *x)
			return -ERANGE;
		*x *= base;
	}
	return 0;
}

/* strtosize() - convert string to size (uintmax_t).
 *
 * Supported suffixes:
 *
 * XiB or X for 2^N
 *     where X = {K,M,G,T,P,E,Z,Y}
 *        or X = {k,m,g,t,p,e}  (undocumented for backward compatibility only)
 * for example:
 *              10KiB   = 10240
 *              10K     = 10240
 *
 * XB for 10^N
 *     where X = {K,M,G,T,P,E,Z,Y}
 * for example:
 *              10KB    = 10000
 *
 * The optional 'power' variable returns number associated with used suffix
 * {K,M,G,T,P,E,Z,Y}  = {1,2,3,4,5,6,7,8}.
 *
 * The function also supports decimal point, for example:
 *              0.5MB   = 500000
 *              0.5MiB  = 512000
 *
 * Note that the function does not accept numbers with '-' (negative sign)
 * prefix. */
static int parse_size(const char *str, uintmax_t *res, int *power)
{
	const char *p;
	char *end;
	uintmax_t x, frac = 0;
	int base = 1024, rc = 0, pwr = 0, frac_zeros = 0;

	static const char suf[]  = "KMGTPEZY";
	static const char suf2[] = "kmgtpezy";
	const char *sp;

	*res = 0;

	if (!str || !*str) {
		rc = -EINVAL;
		goto err;
	}

	/* Only positive numbers are acceptable
	 *
	 * Note that this check is not perfect, it would be better to
	 * use lconv->negative_sign. But coreutils use the same solution,
	 * so it's probably good enough... */
	p = str;
	while (isspace((unsigned char) *p))
		p++;
	if (*p == '-') {
		rc = -EINVAL;
		goto err;
	}

	errno = 0, end = NULL;
	x = strtoumax(str, &end, 0);

	if (end == str ||
	    (errno != 0 && (x == UINTMAX_MAX || x == 0))) {
		rc = errno ? -errno : -EINVAL;
		goto err;
	}
	if (!end || !*end)
		goto done;                      /* without suffix */
	p = end;

	/* Check size suffixes */
check_suffix:
	if (*(p + 1) == 'i' && (*(p + 2) == 'B' || *(p + 2) == 'b') && !*(p + 3))
		base = 1024;                    /* XiB, 2^N */
	else if ((*(p + 1) == 'B' || *(p + 1) == 'b') && !*(p + 2))
		base = 1000;                    /* XB, 10^N */
	else if (*(p + 1)) {
		if (frac == 0 && *p && p[0] == '.') {
			const char *fstr = p + 1;

			for (p = fstr; *p == '0'; p++)
				frac_zeros++;
			errno = 0, end = NULL;
			frac = strtoumax(fstr, &end, 0);
			if (end == fstr ||
			    (errno != 0 && (frac == UINTMAX_MAX || frac == 0))) {
				rc = errno ? -errno : -EINVAL;
				goto err;
			}
			if (frac && (!end  || !*end)) {
				rc = -EINVAL;
				goto err;               /* without suffix, but with frac */
			}
			p = end;
			goto check_suffix;
		}
		rc = -EINVAL;
		goto err;                       /* unexpected suffix */
	}

	sp = strchr(suf, *p);
	if (sp)
		pwr = (sp - suf) + 1;
	else {
		sp = strchr(suf2, *p);
		if (sp)
			pwr = (sp - suf2) + 1;
		else {
			rc = -EINVAL;
			goto err;
		}
	}

	rc = do_scale_by_power(&x, base, pwr);
	if (power)
		*power = pwr;
	if (frac && pwr) {
		int zeros_in_pwr = frac_zeros % 3;
		int frac_pwr = pwr - (frac_zeros / 3) - 1;
		uintmax_t y = frac * (zeros_in_pwr == 0 ? 100 :
				      zeros_in_pwr == 1 ?  10 : 1);

		if (frac_pwr < 0) {
			rc = -EINVAL;
			goto err;
		}
		do_scale_by_power(&y, base, frac_pwr);
		x += y;
	}
done:
	*res = x;
err:
	if (rc < 0)
		errno = -rc;
	return rc;
}

static int isdigit_strend(const char *str)
{
	const char *p;

	for (p = str; p && *p && isdigit((unsigned char) *p); p++);

	return p && p > str && !*p;
}

static uint32_t strtou32_or_err(const char *str, const char *errmesg)
{
	return bb_xparse_ui_number(10 | BB_PN_ERR_STRV | BB_PN_SET_UPPER, str, 0xffffffff, "%s: '%s'", errmesg, str);
}


/* Parses comma delimited list to array with IDs, for example:
 *
 * "aaa,bbb,ccc" --> ary[0] = FOO_AAA;
 *                   ary[1] = FOO_BBB;
 *                   ary[3] = FOO_CCC;
 *
 * The function name2id() provides conversion from string to ID.
 *
 * Returns: >= 0  : number of items added to ary[]
 *            -1  : parse error or unknown item
 *            -2  : arysz reached */
static int string_to_idarray(const char *list, int ary[], size_t arysz,
			int (name2id)(const char *, size_t))
{
	const char *begin = NULL, *p;
	size_t n = 0;

	if (!list || !*list || !ary || !arysz || !name2id)
		return -1;

	for (p = list; p && *p; p++) {
		const char *end = NULL;
		int id;

		if (n >= arysz)
			return -2;
		if (!begin)
			begin = p;              /* begin of the column name */
		if (*p == ',')
			end = p;                /* terminate the name */
		if (*(p + 1) == '\0')
			end = p + 1;            /* end of string */
		if (!begin || !end)
			continue;
		if (end <= begin)
			return -1;

		id = name2id(begin, end - begin);
		if (id == -1)
			return -1;
		ary[ n++ ] = id;
		begin = NULL;
		if (end && !*end)
			break;
	}
	return n;
}

/* Parses the array like string_to_idarray but if format is "+aaa,bbb"
 * it adds fields to array instead of replacing them. */
static int string_add_to_idarray(const char *list, int ary[], size_t arysz,
			size_t *ary_pos, int (name2id)(const char *, size_t))
{
	const char *list_add;
	int r;

	if (!list || !*list || !ary_pos || *ary_pos > arysz)
		return -1;

	if (list[0] == '+')
		list_add = &list[1];
	else {
		list_add = list;
		*ary_pos = 0;
	}

	r = string_to_idarray(list_add, &ary[*ary_pos], arysz - *ary_pos, name2id);
	if (r > 0)
		*ary_pos += r;
	return r;
}

/* Based on linux-perf/git scm
 *
 * Some modifications and simplifications for util-linux
 * by Davidlohr Bueso <dave@xxxxxxx> - March 2012. */

static inline void close_pair(int fd[2])
{
	close(fd[0]);
	close(fd[1]);
}

static int start_command(struct child_process *cmd)
{
	int need_in;
	int fdin[2];

	/* In case of errors we must keep the promise to close FDs
	 * that have been passed in via ->in and ->out. */
	need_in = !cmd->no_stdin && cmd->in < 0;
	if (need_in) {
		if (pipe(fdin) < 0) {
			if (cmd->out > 0)
				close(cmd->out);
			return -1;
		}
		cmd->in = fdin[1];
	}

	fflush(NULL);
	cmd->pid = fork();
	if (!cmd->pid) {
		if (need_in) {
			dup2(fdin[0], STDIN_FILENO);
			close_pair(fdin);
		} else if (cmd->in > 0) {
			dup2(cmd->in, STDIN_FILENO);
			close(cmd->in);
		}

		cmd->preexec_cb();
		execvp(cmd->argv[0], (char *const*) cmd->argv);
		bb_default_error_retval = errno == ENOENT ? EX_EXEC_ENOENT : EX_EXEC_FAILED;
		bb_perror_msg_and_die("failed to execute %s", cmd->argv[0]);
	}

	if (cmd->pid < 0) {
		if (need_in)
			close_pair(fdin);
		else if (cmd->in)
			close(cmd->in);
		return -1;
	}

	if (need_in)
		close(fdin[0]);
	else if (cmd->in)
		close(cmd->in);
	return 0;
}

static int finish_command(struct child_process *cmd)
{
	pid_t pid = cmd->pid;
	for (;;) {
		int status, code;
		pid_t waiting = waitpid(pid, &status, 0);

		if (waiting < 0) {
			if (errno == EINTR)
				continue;
			bb_perror_msg_and_die("waitpid failed");
		}
		if (waiting != pid)
			return -1;
		if (WIFSIGNALED(status))
			return -1;

		if (!WIFEXITED(status))
			return -1;
		code = WEXITSTATUS(status);
		switch (code) {
		case 127:
			return -1;
		case 0:
			return 0;
		default:
			return -1;
		}
	}
}

static void pager_preexec(void)
{
	/* Work around bug in "less" by not starting it until we have real input */
	fd_set in, ex;

	FD_ZERO(&in);
	FD_SET(STDIN_FILENO, &in);
	ex = in;

	select(STDIN_FILENO + 1, &in, NULL, &ex, NULL);

	if (setenv("LESS", "FRSX", 0) != 0)
		bb_perror_msg("failed to set the %s environment variable", "LESS");
}

static void wait_for_pager(void)
{
	if (pager_process.pid == 0)
		return;

	fflush(stdout);
	fflush(stderr);
	/* signal EOF to pager */
	close(STDOUT_FILENO);
	close(STDERR_FILENO);
	finish_command(&pager_process);
}

static void wait_for_pager_signal(int signo)
{
	wait_for_pager();
	raise(signo);
}

static int has_command(const char *cmd)
{
	const char *path;
	char *p, *s;
	int rc = 0;

	if (!cmd)
		goto done;
	if (*cmd == '/') {
		rc = access(cmd, X_OK) == 0;
		goto done;
	}

	path = getenv("PATH");
	if (!path)
		goto done;
	p = xstrdup(path);
	if (!p)
		goto done;

	for(s = strtok(p, ":"); s; s = strtok(NULL, ":")) {
		int fd = open(s, O_RDONLY|O_CLOEXEC);
		if (fd < 0)
			continue;
		rc = faccessat(fd, cmd, X_OK, 0) == 0;
		close(fd);
		if (rc)
			break;
	}
	free(p);
done:
	return rc;
}

/* Setup pager and redirect output, the pager may be closed by pager_close(). */
static void pager_open(void)
{
	const char *pager;
	struct sigaction sa;

	if (pager_process.pid)
		return;         /* already running */

	pager_process.org_out = dup(STDOUT_FILENO);
	pager_process.org_err = dup(STDERR_FILENO);


	if (!isatty(STDOUT_FILENO))
		return;

	pager = getenv("PAGER");
	if (!pager)
		pager = "less";
	else if (!*pager || !strcmp(pager, "cat"))
		return;

	if (!has_command(pager))
		return;

	/* spawn the pager */
	pager_argv[2] = pager;
	pager_process.argv = pager_argv;
	pager_process.in = -1;
	pager_process.preexec_cb = pager_preexec;

	if (start_command(&pager_process))
		return;

	/* original process continues, but writes to the pipe */
	dup2(pager_process.in, STDOUT_FILENO);
	if (isatty(STDERR_FILENO))
		dup2(pager_process.in, STDERR_FILENO);
	close(pager_process.in);

	memset(&sa, 0, sizeof(sa));
	sa.sa_handler = wait_for_pager_signal;

	/* this makes sure that the parent terminates after the pager */
	sigaction(SIGINT,  &sa, &pager_process.orig_sigint);
	sigaction(SIGHUP,  &sa, &pager_process.orig_sighup);
	sigaction(SIGTERM, &sa, &pager_process.orig_sigterm);
	sigaction(SIGQUIT, &sa, &pager_process.orig_sigquit);
	sigaction(SIGPIPE, &sa, &pager_process.orig_sigpipe);
}

/* Close pager and restore original std{out,err}. */
static void pager_close(void)
{
	if (pager_process.pid == 0)
		return;

	wait_for_pager();

	/* restore original output */
	dup2(pager_process.org_out, STDOUT_FILENO);
	dup2(pager_process.org_err, STDERR_FILENO);

	close(pager_process.org_out);
	close(pager_process.org_err);

	/* restore original segnals setting */
	sigaction(SIGINT,  &pager_process.orig_sigint, NULL);
	sigaction(SIGHUP,  &pager_process.orig_sighup, NULL);
	sigaction(SIGTERM, &pager_process.orig_sigterm, NULL);
	sigaction(SIGQUIT, &pager_process.orig_sigquit, NULL);
	sigaction(SIGPIPE, &pager_process.orig_sigpipe, NULL);

	memset(&pager_process, 0, sizeof(pager_process));
}



struct ul_color_name {
	const char *name;
	const char *seq;
};

/* Maintains human readable color names */
static const char *color_sequence_from_colorname(const char *str)
{
	static const struct ul_color_name basic_schemes[] = {
		{ "black",      UL_COLOR_BLACK           },
		{ "blink",      UL_COLOR_BLINK           },
		{ "blue",       UL_COLOR_BLUE            },
		{ "bold",       UL_COLOR_BOLD            },
		{ "brown",      UL_COLOR_BROWN           },
		{ "cyan",       UL_COLOR_CYAN            },
		{ "darkgray",   UL_COLOR_DARK_GRAY       },
		{ "gray",       UL_COLOR_GRAY            },
		{ "green",      UL_COLOR_GREEN           },
		{ "halfbright", UL_COLOR_HALFBRIGHT      },
		{ "lightblue",  UL_COLOR_BOLD_BLUE       },
		{ "lightcyan",  UL_COLOR_BOLD_CYAN       },
		{ "lightgray,", UL_COLOR_GRAY            },
		{ "lightgreen", UL_COLOR_BOLD_GREEN      },
		{ "lightmagenta", UL_COLOR_BOLD_MAGENTA  },
		{ "lightred",   UL_COLOR_BOLD_RED        },
		{ "magenta",    UL_COLOR_MAGENTA         },
		{ "red",        UL_COLOR_RED             },
		{ "reset",      UL_COLOR_RESET,          },
		{ "reverse",    UL_COLOR_REVERSE         },
		{ "yellow",     UL_COLOR_BOLD_YELLOW     },
		{ NULL, NULL }
	};
	const struct ul_color_name *res;

	if (!str)
		return NULL;

	res = find_string_from_struct(basic_schemes, sizeof(struct ul_color_name), str);
	return res ? res->seq : NULL;
}

/* The cell has no ref-counting, free() and new() functions. All is
 * handled by libscols_line. */

/* Frees the cell's internal data and resets its status.
 * Returns: 0, a negative value in case of an error. */
static int scols_reset_cell(struct libscols_cell *ce)
{
	if (!ce)
		return -EINVAL;

	free(ce->data);
	free(ce->color);
	memset(ce, 0, sizeof(*ce));
	return 0;
}

/* Stores a copy of the @str in @ce, the old data are deallocated by free().
 * Returns: 0, a negative value in case of an error. */
static inline int scols_cell_set_data(struct libscols_cell *ce, const char *data)
{
	return strdup_to_struct_member(ce, data, data);
}

/* Adds a reference to @str to @ce. The pointer is deallocated by
 * scols_reset_cell() or scols_unref_line(). This function is mostly designed
 * for situations when the data for the cell are already composed in allocated
 * memory (e.g. asprintf()) to avoid extra unnecessary strdup(). */
static inline void scols_cell_refer_data(struct libscols_cell *ce, char *data)
{
	free(ce->data);
	ce->data = data;
}

/* Returns: data in @ce or NULL. */
static const char *scols_cell_get_data(const struct libscols_cell *ce)
{
	return ce ? ce->data : NULL;
}

/* Set the color of @ce to @color.
 * Returns: 0, a negative value in case of an error. */
static int scols_cell_set_color(struct libscols_cell *ce, const char *color)
{
	if (color && isalpha(*color)) {
		color = color_sequence_from_colorname(color);
		if (!color)
			return -EINVAL;
	}
	return strdup_to_struct_member(ce, color, color);
}

/* Returns: SCOLS_CELL_FL_{RIGHT,CELNTER,LEFT} */
static int scols_cell_get_alignment(const struct libscols_cell *ce)
{
	if (ce->flags & SCOLS_CELL_FL_RIGHT)
		return SCOLS_CELL_FL_RIGHT;
	else if (ce->flags & SCOLS_CELL_FL_CENTER)
		return SCOLS_CELL_FL_CENTER;

	return SCOLS_CELL_FL_LEFT;      /* default */
}

/* Note that the line is allocated without cells, the cells will be allocated
 * later when you add the line to the table. If you want to use the line
 * without table then you have to explicitly allocate the cells by
 * scols_line_alloc_cells().
 *
 * Returns: a pointer to a new struct libscols_line instance. */
static struct libscols_line *scols_new_line(void)
{
	struct libscols_line *ln;

	ln = zmalloc(sizeof(*ln));
	ln->refcount = 1;
	INIT_LIST_HEAD(&ln->ln_lines);
	INIT_LIST_HEAD(&ln->ln_children);
	INIT_LIST_HEAD(&ln->ln_branch);
	return ln;
}

/* Increases the refcount of @ln. */
static inline void scols_ref_line(struct libscols_line *ln)
{
	if (ln)
		ln->refcount++;
}

/* Frees the allocated cells referenced to by @ln. */
static void scols_line_free_cells(struct libscols_line *ln)
{
	size_t i;

	if (!ln || !ln->cells)
		return;

	for (i = 0; i < ln->ncells; i++)
		scols_reset_cell(&ln->cells[i]);

	free(ln->cells);
	ln->ncells = 0;
	ln->cells = NULL;
}

/* Decreases the refcount of @ln. When the count falls to zero, the instance
 * is automatically deallocated. */
static void scols_unref_line(struct libscols_line *ln)
{
	if (ln && --ln->refcount <= 0) {
		list_del(&ln->ln_lines);
		list_del(&ln->ln_children);
		scols_line_free_cells(ln);
		free(ln->color);
		free(ln);
		return;
	}
}

/* Allocates space for @n cells. This function is optional,
 * and libsmartcols automatically allocates necessary cells
 * according to number of columns in the table when you add
 * the line to the table. See scols_table_add_line().
 *
 * Returns: 0, a negative value in case of an error. */
static int scols_line_alloc_cells(struct libscols_line *ln, size_t n)
{
	struct libscols_cell *ce;

	if (!ln)
		return -EINVAL;
	if (ln->ncells == n)
		return 0;

	if (!n) {
		scols_line_free_cells(ln);
		return 0;
	}

	ce = xrealloc(ln->cells, n * sizeof(struct libscols_cell));
	if (n > ln->ncells)
		memset(ce + ln->ncells, 0,
		       (n - ln->ncells) * sizeof(struct libscols_cell));

	ln->cells = ce;
	ln->ncells = n;
	return 0;
}

/* Removes @child as a child of @ln.
 * Returns: 0, a negative value in case of an error. */
static int scols_line_remove_child(struct libscols_line *ln, struct libscols_line *child)
{
	if (!ln || !child)
		return -EINVAL;

	list_del_init(&child->ln_children);
	child->parent = NULL;
	scols_unref_line(child);

	scols_unref_line(ln);
	return 0;
}

/* Sets @child as a child of @ln.
 * Returns: 0, a negative value in case of an error. */
static int scols_line_add_child(struct libscols_line *ln, struct libscols_line *child)
{
	if (!ln || !child)
		return -EINVAL;

	scols_ref_line(child);
	scols_ref_line(ln);

	/* unref old<->parent */
	if (child->parent)
		scols_line_remove_child(child->parent, child);

	/* new reference from parent to child */
	list_add_tail(&child->ln_children, &ln->ln_branch);

	/* new reference from child to parent */
	child->parent = ln;
	return 0;
}

/** Returns: the @n-th cell in @ln, NULL in case of an error. */
static struct libscols_cell *scols_line_get_cell(struct libscols_line *ln,
					  size_t n)
{
	if (!ln || n >= ln->ncells)
		return NULL;
	return &ln->cells[n];
}

static int scols_line_refer_data(struct libscols_line *ln, size_t n, char *data)
{
	struct libscols_cell *ce = scols_line_get_cell(ln, n);

	if (!ce)
		return -EINVAL;
	scols_cell_refer_data(ce, data);
	return 0;
}

/* Returns: A newly allocated table. */
static struct libscols_table *scols_new_table(void)
{
	struct libscols_table *tb;
	int c, l;

	tb = zmalloc(sizeof(struct libscols_table));

	tb->refcount = 1;
	tb->out = stdout;

	get_terminal_width_height(&c, &l);
	tb->termwidth  = c;
	tb->termheight = l;

	INIT_LIST_HEAD(&tb->tb_lines);
	INIT_LIST_HEAD(&tb->tb_columns);

	return tb;
}

/* Decreases the refcount of @cl. When the count falls to zero, the instance
 * is automatically deallocated. */
static void scols_unref_column(struct libscols_column *cl)
{
	if (cl && --cl->refcount <= 0) {
		list_del(&cl->cl_columns);
		scols_reset_cell(&cl->header);
		free(cl->color);
		free(cl->safechars);
		free(cl->pending_data_buf);
		free(cl);
	}
}

/* Removes @cl from @tb.
 * Returns: 0, a negative number in case of an error. */
static int scols_table_remove_column(struct libscols_table *tb,
			      struct libscols_column *cl)
{
	if (!tb || !cl || !list_empty(&tb->tb_lines))
		return -EINVAL;

	if (cl->flags & SCOLS_FL_TREE)
		tb->ntreecols--;

	list_del_init(&cl->cl_columns);
	tb->ncols--;
	cl->table = NULL;
	scols_unref_column(cl);
	return 0;
}

/* Removes all of @tb's columns.
 * Returns: 0, a negative number in case of an error. */
static int scols_table_remove_columns(struct libscols_table *tb)
{
	if (!tb || !list_empty(&tb->tb_lines))
		return -EINVAL;

	while (!list_empty(&tb->tb_columns)) {
		struct libscols_column *cl = list_entry(tb->tb_columns.next,
					struct libscols_column, cl_columns);
		scols_table_remove_column(tb, cl);
	}
	return 0;
}

/* Note that this function does not destroy the parent<->child relationship between lines.
 * You have to call scols_line_remove_child()
 * Returns: 0, a negative value in case of an error. */
static int scols_table_remove_line(struct libscols_table *tb,
			    struct libscols_line *ln)
{
	if (!tb || !ln)
		return -EINVAL;

	list_del_init(&ln->ln_lines);
	tb->nlines--;
	scols_unref_line(ln);
	return 0;
}

/* This empties the table and also destroys all the parent<->child relationships. */
static void scols_table_remove_lines(struct libscols_table *tb)
{
	if (!tb)
		return;

	while (!list_empty(&tb->tb_lines)) {
		struct libscols_line *ln = list_entry(tb->tb_lines.next,
						struct libscols_line, ln_lines);
		if (ln->parent)
			scols_line_remove_child(ln->parent, ln);
		scols_table_remove_line(tb, ln);
	}
}

/* Decreases the refcount of @tb. When the count falls to zero, the instance
 * is automatically deallocated. */
static void scols_unref_table(struct libscols_table *tb)
{
	if (tb && (--tb->refcount <= 0)) {
		scols_table_remove_lines(tb);
		scols_table_remove_columns(tb);
		scols_unref_symbols(tb->symbols);
		scols_reset_cell(&tb->title);
		free(tb->linesep);
		free(tb->colsep);
		free(tb->name);
		free(tb);
	}
}

/* Increases the refcount of @cl. */
static inline void scols_ref_column(struct libscols_column *cl)
{
	if (cl)
		cl->refcount++;
}

/* Finds the next line and returns a pointer to it via @ln.
 * Returns: 0, a negative value in case of an error. */
static int scols_table_next_line(struct libscols_table *tb,
			  struct libscols_iter *itr,
			  struct libscols_line **ln)
{
	int rc = 1;

	if (!tb || !itr || !ln)
		return -EINVAL;
	*ln = NULL;

	if (!itr->head)
		SCOLS_ITER_INIT(itr, &tb->tb_lines);
	if (itr->p != itr->head) {
		SCOLS_ITER_ITERATE(itr, *ln, struct libscols_line, ln_lines);
		rc = 0;
	}

	return rc;
}

/* Adds @cl to @tb's column list. The column cannot be shared between more tables.
 * Returns: 0, a negative number in case of an error. */
static int scols_table_add_column(struct libscols_table *tb, struct libscols_column *cl)
{
	struct libscols_iter itr;
	struct libscols_line *ln;
	int rc = 0;

	if (!tb || !cl || cl->table)
		return -EINVAL;

	if (cl->flags & SCOLS_FL_TREE)
		tb->ntreecols++;

	list_add_tail(&cl->cl_columns, &tb->tb_columns);
	cl->seqnum = tb->ncols++;
	cl->table = tb;
	scols_ref_column(cl);

	if (list_empty(&tb->tb_lines))
		return 0;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);

	/* Realloc line cell arrays */
	while (scols_table_next_line(tb, &itr, &ln) == 0) {
		rc = scols_line_alloc_cells(ln, tb->ncols);
		if (rc)
			break;
	}

	return rc;
}

/* Sets the flags of @cl to @flags. Returns: 0, a negative value in case of an error. */
static int scols_column_set_flags(struct libscols_column *cl, int flags)
{
	if (!cl)
		return -EINVAL;

	if (cl->table) {
		if (!(cl->flags & SCOLS_FL_TREE) && (flags & SCOLS_FL_TREE))
			cl->table->ntreecols++;
		else if ((cl->flags & SCOLS_FL_TREE) && !(flags & SCOLS_FL_TREE))
			cl->table->ntreecols--;
	}

	cl->flags = flags;
	return 0;
}

/* Allocates space for a new column.
 * Returns: a pointer to a new struct libscols_column instance. */
static struct libscols_column *scols_new_column(void)
{
	struct libscols_column *cl = zmalloc(sizeof(*cl));

	cl->refcount = 1;
	INIT_LIST_HEAD(&cl->cl_columns);
	return cl;
}

/* Sets the width hint of column @cl to @whint. See scols_table_new_column(). */
static inline void scols_column_set_whint(struct libscols_column *cl, double whint)
{
	cl->width_hint = whint;
}

/* Returns: A pointer to a struct libscols_cell instance, representing the
 * header info of column @cl or NULL in case of an error. */
static inline struct libscols_cell *scols_column_get_header(struct libscols_column *cl)
{
	return &cl->header;
}

/* This is shortcut for
 *
 *   cl = scols_new_column();
 *   scols_column_set_....(cl, ...);
 *   scols_table_add_column(tb, cl);
 *
 * The column width is possible to define by:
 *
 *  @whint: 0 < N < 1  : relative width, percent of terminal width
 *
 *  @whint: N >= 1     : absolute width, empty column will be truncated to
 *                     the column header width if no specified STRICTWIDTH flag
 *
 * Note that if table has disabled "maxout" flag (disabled by default) than
 * relative width is used as a hint only. It's possible that column will be
 * narrow if the specified size is too large for column data.
 *
 *
 * If the width of all columns is greater than terminal width then library
 * tries to reduce width of the individual columns. It's done in three stages:
 *
 * #1 reduce columns with SCOLS_FL_TRUNC flag and with relative width if the
 *    width is greater than width defined by @whint (@whint * terminal_width)
 *
 * #2 reduce all columns with SCOLS_FL_TRUNC flag
 *
 * #3 reduce all columns with relative width
 *
 * The next stage is always used if the previous stage is unsuccessful. Note
 * that SCOLS_FL_WRAP is interpreted as SCOLS_FL_TRUNC when calculate column
 * width (if custom wrap function is not specified), but the final text is not
 * truncated, but wrapped to multi-line cell.
 *
 *
 * The column is necessary to address by sequential number. The first defined
 * column has the colnum = 0. For example:
 *
 *      scols_table_new_column(tab, "FOO", 0.5, 0);             // colnum = 0
 *      scols_table_new_column(tab, "BAR", 0.5, 0);             // colnum = 1
 *      .
 *      .
 *      scols_line_get_cell(line, 0);                           // FOO column
 *      scols_line_get_cell(line, 1);                           // BAR column
 *
 * Returns: newly allocated column */
static struct libscols_column *scols_table_new_column(struct libscols_table *tb,
					       const char *name,
					       double whint,
					       int flags)
{
	struct libscols_column *cl;
	struct libscols_cell *hr;

	if (!tb)
		return NULL;

	cl = scols_new_column();

	/* set column name */
	hr = scols_column_get_header(cl);
	if (!hr)
		goto err;
	if (scols_cell_set_data(hr, name))
		goto err;

	scols_column_set_whint(cl, whint);
	scols_column_set_flags(cl, flags);

	if (scols_table_add_column(tb, cl))     /* this increments column ref-counter */
		goto err;

	scols_unref_column(cl);
	return cl;
err:
	scols_unref_column(cl);
	return NULL;
}

/* Returns the next column of @tb via @cl.
 * Returns: 0, a negative value in case of an error. */
static int scols_table_next_column(struct libscols_table *tb,
			    struct libscols_iter *itr,
			    struct libscols_column **cl)
{
	int rc = 1;

	if (!tb || !itr || !cl)
		return -EINVAL;
	*cl = NULL;

	if (!itr->head)
		SCOLS_ITER_INIT(itr, &tb->tb_columns);
	if (itr->p != itr->head) {
		SCOLS_ITER_ITERATE(itr, *cl, struct libscols_column, cl_columns);
		rc = 0;
	}

	return rc;
}

/* Returns: pointer to column or NULL */
static struct libscols_column *scols_table_get_column(struct libscols_table *tb,
					       size_t n)
{
	struct libscols_iter itr;
	struct libscols_column *cl;

	if (!tb)
		return NULL;
	if (n >= tb->ncols)
		return NULL;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (scols_table_next_column(tb, &itr, &cl) == 0) {
		if (cl->seqnum == n)
			return cl;
	}
	return NULL;
}

/* Note that this function calls scols_line_alloc_cells() if number
 * of the cells in the line is too small for @tb.
 * Returns: 0, a negative value in case of an error. */
static int scols_table_add_line(struct libscols_table *tb, struct libscols_line *ln)
{
	if (!tb || !ln)
		return -EINVAL;

	if (tb->ncols > ln->ncells) {
		int rc = scols_line_alloc_cells(ln, tb->ncols);
		if (rc)
			return rc;
	}

	list_add_tail(&ln->ln_lines, &tb->tb_lines);
	ln->seqnum = tb->nlines++;
	scols_ref_line(ln);
	return 0;
}

/* This is shortcut for
 *
 *   ln = scols_new_line();
 *   scols_table_add_line(tb, ln);
 *   scols_line_add_child(parent, ln);
 * Returns: newly allocate line */
static struct libscols_line *scols_table_new_line(struct libscols_table *tb,
					   struct libscols_line *parent)
{
	struct libscols_line *ln;

	if (!tb)
		return NULL;

	ln = scols_new_line();
	if (scols_table_add_line(tb, ln))
		goto err;
	if (parent)
		scols_line_add_child(parent, ln);

	scols_unref_line(ln);   /* ref-counter incremented by scols_table_add_line() */
	return ln;
err:
	scols_unref_line(ln);
	return NULL;
}

/* Add a reference to @sy from the table. The symbols are used by library to
 * draw tree output. If no symbols are used for the table then library creates
 * default temporary symbols to draw output by scols_table_set_default_symbols().
 *
 * If @sy is NULL then remove reference from the currently used symbols.
 *
 * Returns: 0, a negative value in case of an error. */
static int scols_table_set_symbols(struct libscols_table *tb,
			    struct libscols_symbols *sy)
{
	if (!tb)
		return -EINVAL;

	/* remove old */
	if (tb->symbols) {
		scols_unref_symbols(tb->symbols);
		tb->symbols = NULL;
	}

	/* set new */
	if (sy) {                                       /* ref user defined */
		tb->symbols = sy;
		scols_ref_symbols(sy);
	}
	return 0;
}

/* The library check the current environment to select ASCII or UTF8 symbols.
 * Use scols_table_set_symbols() to unset symbols or use your own setting.
 * Returns: 0, a negative value in case of an error. */
static int scols_table_set_default_symbols(struct libscols_table *tb)
{
	struct libscols_symbols *sy;
	int rc;

	if (!tb)
		return -EINVAL;

	sy = scols_new_symbols();
	scols_symbols_set_branch(sy, "|-");
	scols_symbols_set_vertical(sy, "| ");
	scols_symbols_set_right(sy, "`-");
	scols_symbols_set_title_padding(sy, " ");
	scols_symbols_set_cell_padding(sy, " ");

	rc = scols_table_set_symbols(tb, sy);
	scols_unref_symbols(sy);
	return rc;
}

/* Enable/disable colors. */
static inline void scols_table_enable_colors(struct libscols_table *tb, int enable)
{
	tb->colors_wanted = enable;
}

/* Returns: 1 if the table is empty. */
static inline int scols_table_is_empty(const struct libscols_table *tb)
{
	return !tb->nlines;
}

/* Returns: 1 if header output is disabled. */
static inline int scols_table_is_noheadings(const struct libscols_table *tb)
{
	return tb->no_headings;
}

/* Returns: 1 if export output format is enabled. */
static inline int scols_table_is_export(const struct libscols_table *tb)
{
	return tb->format == SCOLS_FMT_EXPORT;
}

/* Returns: 1 if output maximization is enabled or 0 */
static inline int scols_table_is_maxout(const struct libscols_table *tb)
{
	return tb->maxout;
}

/* Returns: returns 1 tree-like output is expected. */
static inline int scols_table_is_tree(const struct libscols_table *tb)
{
	return tb->ntreecols > 0;
}

/* The library automatically detects terminal width or defaults to 80 chars if
 * detections is unsuccessful. This function override this behaviour. */
static inline void scols_table_set_termwidth(struct libscols_table *tb, size_t width)
{
	tb->termwidth = width;
}

/* Returns: terminal width. */
static inline size_t scols_table_get_termwidth(const struct libscols_table *tb)
{
	return tb->termwidth;
}

/* Table output API. */
typedef enum { MBS_ALIGN_LEFT, MBS_ALIGN_RIGHT, MBS_ALIGN_CENTER } mbs_align_t;

enum {
  /* Use unibyte mode for invalid multibyte strings or
     or when heap memory is exhausted.  */
  MBA_UNIBYTE_FALLBACK = 0x0001,
};

static void fputs_quoted_case(const char *data, FILE *out, int dir)
{
	const char *p;

	fputc('"', out);
	for (p = data; p && *p; p++) {
		if ((unsigned char) *p == 0x22 ||               /* " */
		    (unsigned char) *p == 0x5c ||               /* \ */
		    (unsigned char) *p == 0x60 ||               /* ` */
		    (unsigned char) *p == 0x24 ||               /* $ */
		    !isprint((unsigned char) *p) ||
		    iscntrl((unsigned char) *p)) {

			fprintf(out, "\\x%02x", (unsigned char) *p);
		} else
			fputc(dir ==  1 ? toupper(*p) :
			      dir == -1 ? tolower(*p) :
			      *p, out);
	}
	fputc('"', out);
}

#define fputs_quoted(_d, _o)            fputs_quoted_case(_d, _o, 0)
#define fputs_quoted_upper(_d, _o)      fputs_quoted_case(_d, _o, 1)
#define fputs_quoted_lower(_d, _o)      fputs_quoted_case(_d, _o, -1)

static inline void fputs_nonblank(const char *data, FILE *out)
{
	const char *p;

	for (p = data; p && *p; p++) {
		if (isblank((unsigned char) *p) ||
		    (unsigned char) *p == 0x5c ||               /* \ */
		    !isprint((unsigned char) *p) ||
		    iscntrl((unsigned char) *p)) {

			fprintf(out, "\\x%02x", (unsigned char) *p);

		} else
			fputc(*p, out);
	}
}

#define colsep(tb)      ((tb)->colsep ? (tb)->colsep : " ")
#define linesep(tb)     ((tb)->linesep ? (tb)->linesep : "\n")

/* Fallback for symbols
 *
 * Note that by default library define all the symbols, but in case user does
 * not define all symbols or if we extended the symbols struct then we need
 * fallback to be more robust and backwardly compatible. */
#define titlepadding_symbol(tb) ((tb)->symbols->title_padding ? (tb)->symbols->title_padding : " ")
#define branch_symbol(tb)       ((tb)->symbols->branch ? (tb)->symbols->branch : "|-")
#define vertical_symbol(tb)     ((tb)->symbols->vert ? (tb)->symbols->vert : "| ")
#define right_symbol(tb)        ((tb)->symbols->right ? (tb)->symbols->right : "`-")

#define cellpadding_symbol(tb)  ((tb)->padding_debug ? "." : \
				 ((tb)->symbols->cell_padding ? (tb)->symbols->cell_padding: " "))

#define want_repeat_header(tb)  (!(tb)->header_repeat || (tb)->header_next <= (tb)->termlines_used)


/* This is private struct to work with output data */
struct libscols_buffer {
	char    *begin;         /* begin of the buffer */
	char    *cur;           /* current end of  the buffer */
	char    *encdata;       /* encoded buffer */

	size_t  bufsz;          /* size of the buffer */
	size_t  art_idx;        /* begin of the tree ascii art or zero */
};

static struct libscols_buffer *new_buffer(size_t sz)
{
	struct libscols_buffer *buf = xmalloc(sz + sizeof(struct libscols_buffer));

	buf->cur = buf->begin = ((char *) buf) + sizeof(struct libscols_buffer);
	buf->encdata = NULL;
	buf->bufsz = sz;

	return buf;
}

static void free_buffer(struct libscols_buffer *buf)
{
	if (!buf)
		return;
	free(buf->encdata);
	free(buf);
}

static int buffer_reset_data(struct libscols_buffer *buf)
{
	if (!buf)
		return -EINVAL;

	buf->begin[0] = '\0';
	buf->cur = buf->begin;
	buf->art_idx = 0;
	return 0;
}

static int buffer_append_data(struct libscols_buffer *buf, const char *str)
{
	size_t maxsz, sz;

	if (!buf)
		return -EINVAL;
	if (!str || !*str)
		return 0;

	sz = strlen(str);
	maxsz = buf->bufsz - (buf->cur - buf->begin);

	if (maxsz <= sz)
		return -EINVAL;
	memcpy(buf->cur, str, sz + 1);
	buf->cur += sz;
	return 0;
}

static int buffer_set_data(struct libscols_buffer *buf, const char *str)
{
	int rc = buffer_reset_data(buf);
	return rc ? rc : buffer_append_data(buf, str);
}

/* save the current buffer position to art_idx */
static void buffer_set_art_index(struct libscols_buffer *buf)
{
	if (buf)
		buf->art_idx = buf->cur - buf->begin;
}

static char *buffer_get_data(struct libscols_buffer *buf)
{
	return buf ? buf->begin : NULL;
}

/* Replace non printable chars.
   Note \t and \n etc. are non printable.
   Return 1 if replacement made, 0 otherwise.  */

/* Counts number of cells in multibyte string. For all control and
 * non-printable chars is the result width enlarged to store \x?? hex
 * sequence.
 *
 * Returns: number of cells, @sz returns number of bytes. */
static size_t mbs_safe_nwidth(const char *buf, size_t bufsz, size_t *sz)
{
	const char *p = buf, *last = buf;
	size_t width = 0, bytes = 0;

	if (p && *p && bufsz)
		last = p + (bufsz - 1);

	while (p && *p && p <= last) {
		if ((p < last && *p == '\\' && *(p + 1) == 'x')
		    || iscntrl((unsigned char) *p)) {
			width += 4, bytes += 4;         /* *p encoded to \x?? */
			p++;
		}
		else if (!isprint((unsigned char) *p)) {
			width += 4, bytes += 4;         /* *p encoded to \x?? */
			p++;
		} else {
			width++, bytes++;
			p++;
		}
	}

	if (sz)
		*sz = bytes;
	return width;
}

static size_t mbs_safe_width(const char *s)
{
	if (!s || !*s)
		return 0;
	return mbs_safe_nwidth(s, strlen(s), NULL);
}

/* Copy @s to @buf and replace control and non-printable chars with
 * \x?? hex sequence. The @width returns number of cells. The @safechars
 * are not encoded.
 *
 * The @buf has to be big enough to store mbs_safe_encode_size(strlen(s))) bytes. */
static char *mbs_safe_encode_to_buffer(const char *s, size_t *width, char *buf, const char *safechars)
{
	const char *p = s;
	char *r;
	size_t sz = s ? strlen(s) : 0;

	if (!sz || !buf)
		return NULL;

	r = buf;
	*width = 0;

	while (p && *p) {
		if (safechars && strchr(safechars, *p)) {
			*r++ = *p++;
			continue;
		}

		if ((*p == '\\' && *(p + 1) == 'x')
		    || iscntrl((unsigned char) *p)) {
			sprintf(r, "\\x%02x", (unsigned char) *p);
			r += 4;
			*width += 4;
			p++;
		}
		else if (!isprint((unsigned char) *p)) {
			sprintf(r, "\\x%02x", (unsigned char) *p);
			p++;
			r += 4;
			*width += 4;
		} else {
			*r++ = *p++;
			(*width)++;
		}
	}

	*r = '\0';
	return buf;
}

static inline size_t mbs_safe_encode_size(size_t bytes)
{
	return (bytes * 4) + 1;
}

/* encode data by mbs_safe_encode() to avoid control and non-printable chars */
static char *buffer_get_safe_data(struct libscols_table *tb,
				  struct libscols_buffer *buf,
				  size_t *cells,
				  const char *safechars)
{
	char *data = buffer_get_data(buf);
	char *res = NULL;

	if (!data)
		goto nothing;

	if (!buf->encdata)
		buf->encdata = xmalloc(mbs_safe_encode_size(buf->bufsz) + 1);

	if (tb->no_encode) {
		*cells = mbs_safe_width(data);
		strcpy(buf->encdata, data);
		res = buf->encdata;
	} else {
		res = mbs_safe_encode_to_buffer(data, cells, buf->encdata, safechars);
	}

	if (!res || !*cells || *cells == (size_t) -1)
		goto nothing;
	return res;
nothing:
	*cells = 0;
	return NULL;
}


/* returns size in bytes of the ascii art (according to art_idx) in safe encoding */
static size_t buffer_get_safe_art_size(struct libscols_buffer *buf)
{
	char *data = buffer_get_data(buf);
	size_t bytes = 0;

	if (!data || !buf->art_idx)
		return 0;

	mbs_safe_nwidth(data, buf->art_idx, &bytes);
	return bytes;
}

/* returns pointer to the end of used data */
static int line_ascii_art_to_buffer(struct libscols_table *tb,
				    struct libscols_line *ln,
				    struct libscols_buffer *buf)
{
	const char *art;
	int rc;

	if (!ln->parent)
		return 0;

	rc = line_ascii_art_to_buffer(tb, ln->parent, buf);
	if (rc)
		return rc;

	if (list_entry_is_last(&ln->ln_children, &ln->parent->ln_branch))
		art = "  ";
	else
		art = vertical_symbol(tb);

	return buffer_append_data(buf, art);
}

/* Gets the value of @cl's flag hidden. Returns: 0 or 1 */
static inline int scols_column_is_hidden(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_HIDDEN ? 1 : 0;
}

static int is_last_column(struct libscols_column *cl)
{
	int rc = list_entry_is_last(&cl->cl_columns, &cl->table->tb_columns);
	struct libscols_column *next;

	if (rc)
		return 1;

	next = list_entry(cl->cl_columns.next, struct libscols_column, cl_columns);
	if (next && scols_column_is_hidden(next) && is_last_column(next))
		return 1;
	return 0;
}


static int has_pending_data(struct libscols_table *tb)
{
	struct libscols_column *cl;
	struct libscols_iter itr;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (scols_table_next_column(tb, &itr, &cl) == 0) {
		if (scols_column_is_hidden(cl))
			continue;
		if (cl->pending_data)
			return 1;
	}
	return 0;
}

/* Gets the value of @cl's flag tree. Returns: 0 or 1 */
static inline int scols_column_is_tree(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_TREE ? 1 : 0;
}

/* print padding or ASCII-art instead of data of @cl */
static void print_empty_cell(struct libscols_table *tb,
			  struct libscols_column *cl,
			  struct libscols_line *ln,     /* optional */
			  size_t bufsz)
{
	size_t len_pad = 0;             /* in screen cells as opposed to bytes */

	/* generate tree ASCII-art rather than padding */
	if (ln && scols_column_is_tree(cl)) {
		if (!ln->parent) {
			/* only print symbols->vert if followed by child */
			if (!list_empty(&ln->ln_branch)) {
				fputs(vertical_symbol(tb), tb->out);
				len_pad = mbs_safe_width(vertical_symbol(tb));
			}
		} else {
			/* use the same draw function as though we were intending to draw an L-shape */
			struct libscols_buffer *art = new_buffer(bufsz);
			char *data;

			/* whatever the rc, len_pad will be sensible */
			line_ascii_art_to_buffer(tb, ln, art);
			if (!list_empty(&ln->ln_branch) && has_pending_data(tb))
				buffer_append_data(art, vertical_symbol(tb));
			data = buffer_get_safe_data(tb, art, &len_pad, NULL);
			if (data && len_pad)
				fputs(data, tb->out);
			free_buffer(art);
		}
	}

	if (is_last_column(cl))
		return;

	/* fill rest of cell with space */
	for(; len_pad < cl->width; ++len_pad)
		fputs(cellpadding_symbol(tb), tb->out);

	fputs(colsep(tb), tb->out);
}

static const char *get_cell_color(struct libscols_table *tb,
				  struct libscols_column *cl,
				  struct libscols_line *ln,     /* optional */
				  struct libscols_cell *ce)     /* optional */
{
	const char *color = NULL;

	if (tb && tb->colors_wanted) {
		if (ce)
			color = ce->color;
		if (ln && !color)
			color = ln->color;
		if (!color)
			color = cl->color;
	}
	return color;
}

/* Fill the start of a line with padding (or with tree ascii-art).
 *
 * This is necessary after a long non-truncated column, as this requires the
 * next column to be printed on the next line. For example (see 'DDD'):
 *
 * aaa bbb ccc ddd eee
 * AAA BBB CCCCCCC
 *             DDD EEE
 * ^^^^^^^^^^^^
 *  new line padding */
static void print_newline_padding(struct libscols_table *tb,
				  struct libscols_column *cl,
				  struct libscols_line *ln,     /* optional */
				  size_t bufsz)
{
	size_t i;

	fputs(linesep(tb), tb->out);            /* line break */
	tb->termlines_used++;

	/* fill cells after line break */
	for (i = 0; i <= (size_t) cl->seqnum; i++)
		print_empty_cell(tb, scols_table_get_column(tb, i), ln, bufsz);
}

/* Pending data
 *
 * The first line in the multi-line cells (columns with SCOLS_FL_WRAP flag) is
 * printed as usually and output is truncated to match column width.
 *
 * The rest of the long text is printed on next extra line(s). The extra lines
 * don't exist in the table (not represented by libscols_line). The data for
 * the extra lines are stored in libscols_column->pending_data_buf and the
 * function print_line() adds extra lines until the buffer is not empty in all
 * columns. */

/* set data that will be printed by extra lines */
static int set_pending_data(struct libscols_column *cl, const char *data, size_t sz)
{
	char *p = NULL;

	if (data && *data)
		p = xstrdup(data);

	free(cl->pending_data_buf);
	cl->pending_data_buf = p;
	cl->pending_data_sz = sz;
	cl->pending_data = cl->pending_data_buf;
	return 0;
}

/* the next extra line has been printed, move pending data cursor */
static int step_pending_data(struct libscols_column *cl, size_t bytes)
{
	if (bytes >= cl->pending_data_sz)
		return set_pending_data(cl, NULL, 0);

	cl->pending_data += bytes;
	cl->pending_data_sz -= bytes;
	return 0;
}

/* Truncate multi-byte string to @width and returns number of
 * bytes of the new string @str, and in @width returns number
 * of cells. */
static size_t mbs_truncate(char *str, size_t *width)
{
	ssize_t bytes = strlen(str);
	if (bytes >= 0 && *width < (size_t) bytes)
		bytes = *width;
	if (bytes >= 0)
		str[bytes] = '\0';
	return bytes;
}

static int scols_column_is_customwrap(const struct libscols_column *cl)
{
	return (cl->flags & SCOLS_FL_WRAP)
		&& cl->wrap_chunksize
		&& cl->wrap_nextchunk ? 1 : 0;
}

/* print next pending data for the column @cl */
static int print_pending_data(
		struct libscols_table *tb,
		struct libscols_column *cl,
		struct libscols_line *ln,       /* optional */
		struct libscols_cell *ce)
{
	const char *color = get_cell_color(tb, cl, ln, ce);
	size_t width = cl->width, bytes;
	size_t len = width, i;
	char *data;
	char *nextchunk = NULL;

	if (!cl->pending_data)
		return 0;
	if (!width)
		return -EINVAL;

	data = xstrdup(cl->pending_data);

	if (scols_column_is_customwrap(cl)
	    && (nextchunk = cl->wrap_nextchunk(cl, data, cl->wrapfunc_data))) {
		bytes = nextchunk - data;

		len = mbs_safe_nwidth(data, bytes, NULL);
	} else
		bytes = mbs_truncate(data, &len);

	if (bytes == (size_t) -1)
		goto err;

	if (bytes)
		step_pending_data(cl, bytes);

	if (color)
		fputs(color, tb->out);
	fputs(data, tb->out);
	if (color)
		fputs(UL_COLOR_RESET, tb->out);
	free(data);

	if (is_last_column(cl))
		return 0;

	for (i = len; i < width; i++)
		fputs(cellpadding_symbol(tb), tb->out);         /* padding */

	fputs(colsep(tb), tb->out);     /* columns separator */
	return 0;
err:
	free(data);
	return -errno;
}

/* Gets the value of @cl's flag right. Returns: 0 or 1 */
static inline int scols_column_is_right(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_RIGHT ? 1 : 0;
}

/* Gets the value of @cl's flag trunc. Returns: 0 or 1 */
static inline int scols_column_is_trunc(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_TRUNC ? 1 : 0;
}


/* Gets the value of @cl's flag wrap. Returns: 0 or 1 */
static inline int scols_column_is_wrap(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_WRAP ? 1 : 0;
}

/* Returns: safe chars */
static inline const char *scols_column_get_safechars(const struct libscols_column *cl)
{
	return cl->safechars;
}

static int print_data(struct libscols_table *tb,
		      struct libscols_column *cl,
		      struct libscols_line *ln, /* optional */
		      struct libscols_cell *ce, /* optional */
		      struct libscols_buffer *buf)
{
	size_t len = 0, i, width, bytes;
	const char *color = NULL;
	char *data, *nextchunk;
	int is_last;

	data = buffer_get_data(buf);
	if (!data)
		data = "";

	is_last = is_last_column(cl);

	switch (tb->format) {
	case SCOLS_FMT_RAW:
		fputs_nonblank(data, tb->out);
		if (!is_last)
			fputs(colsep(tb), tb->out);
		return 0;

	case SCOLS_FMT_EXPORT:
		fprintf(tb->out, "%s=", scols_cell_get_data(&cl->header));
		fputs_quoted(data, tb->out);
		if (!is_last)
			fputs(colsep(tb), tb->out);
		return 0;

	case SCOLS_FMT_HUMAN:
		break;          /* continue below */
	}

	color = get_cell_color(tb, cl, ln, ce);

	/* Encode. Note that 'len' and 'width' are number of cells, not bytes. */
	data = buffer_get_safe_data(tb, buf, &len, scols_column_get_safechars(cl));
	if (!data)
		data = "";
	bytes = strlen(data);
	width = cl->width;

	/* custom multi-line cell based */
	if (*data && scols_column_is_customwrap(cl)
	    && (nextchunk = cl->wrap_nextchunk(cl, data, cl->wrapfunc_data))) {
		set_pending_data(cl, nextchunk, bytes - (nextchunk - data));
		bytes = nextchunk - data;
		len = mbs_safe_nwidth(data, bytes, NULL);
	}

	if (is_last
	    && len < width
	    && !scols_table_is_maxout(tb)
	    && !scols_column_is_right(cl))
		width = len;

	/* truncate data */
	if (len > width && scols_column_is_trunc(cl)) {
		len = width;
		bytes = mbs_truncate(data, &len);       /* updates 'len' */
	}

	/* standard multi-line cell */
	if (len > width && scols_column_is_wrap(cl)
	    && !scols_column_is_customwrap(cl)) {
		set_pending_data(cl, data, bytes);

		len = width;
		bytes = mbs_truncate(data, &len);
		if (bytes  != (size_t) -1 && bytes > 0)
			step_pending_data(cl, bytes);
	}

	if (bytes == (size_t) -1) {
		bytes = len = 0;
		data = NULL;
	}

	if (data) {
		if (scols_column_is_right(cl)) {
			if (color)
				fputs(color, tb->out);
			for (i = len; i < width; i++)
				fputs(cellpadding_symbol(tb), tb->out);
			fputs(data, tb->out);
			if (color)
				fputs(UL_COLOR_RESET, tb->out);
			len = width;

		} else if (color) {
			char *p = data;
			size_t art = buffer_get_safe_art_size(buf);

			/* we don't want to colorize tree ascii art */
			if (scols_column_is_tree(cl) && art && art < bytes) {
				fwrite(p, 1, art, tb->out);
				p += art;
			}

			fputs(color, tb->out);
			fputs(p, tb->out);
			fputs(UL_COLOR_RESET, tb->out);
		} else
			fputs(data, tb->out);
	}
	for (i = len; i < width; i++)
		fputs(cellpadding_symbol(tb), tb->out); /* padding */

	if (is_last)
		return 0;

	if (len > width && !scols_column_is_trunc(cl))
		print_newline_padding(tb, cl, ln, buf->bufsz);  /* next column starts on next line */
	else
		fputs(colsep(tb), tb->out);             /* columns separator */

	return 0;
}

static int cell_to_buffer(struct libscols_table *tb,
			  struct libscols_line *ln,
			  struct libscols_column *cl,
			  struct libscols_buffer *buf)
{
	const char *data;
	struct libscols_cell *ce;
	int rc = 0;

	buffer_reset_data(buf);

	ce = scols_line_get_cell(ln, cl->seqnum);
	data = ce ? scols_cell_get_data(ce) : NULL;
	if (!data)
		return 0;

	if (!scols_column_is_tree(cl))
		return buffer_set_data(buf, data);

	/* Tree stuff */
	if (ln->parent) {
		rc = line_ascii_art_to_buffer(tb, ln->parent, buf);

		if (!rc && list_entry_is_last(&ln->ln_children, &ln->parent->ln_branch))
			rc = buffer_append_data(buf, right_symbol(tb));
		else if (!rc)
			rc = buffer_append_data(buf, branch_symbol(tb));
		if (!rc)
			buffer_set_art_index(buf);
	}

	if (!rc)
		rc = buffer_append_data(buf, data);
	return rc;
}

static void fput_children_open(struct libscols_table *tb)
{
	/* between parent and child is separator */
	fputs(linesep(tb), tb->out);
	tb->termlines_used++;
}

static void fput_line_close(struct libscols_table *tb, int last, int last_in_table)
{
	if (tb->no_linesep == 0 && last_in_table == 0) {
		fputs(linesep(tb), tb->out);
		tb->termlines_used++;
	}
}

/* Prints data. Data can be printed in more formats (raw, NAME=xxx pairs), and
 * control and non-printable characters can be encoded in the \x?? encoding. */
static int print_line(struct libscols_table *tb,
		      struct libscols_line *ln,
		      struct libscols_buffer *buf)
{
	int rc = 0, pending = 0;
	struct libscols_column *cl;
	struct libscols_iter itr;

	/* regular line */
	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (rc == 0 && scols_table_next_column(tb, &itr, &cl) == 0) {
		if (scols_column_is_hidden(cl))
			continue;
		rc = cell_to_buffer(tb, ln, cl, buf);
		if (rc == 0)
			rc = print_data(tb, cl, ln,
					scols_line_get_cell(ln, cl->seqnum),
					buf);
		if (rc == 0 && cl->pending_data)
			pending = 1;
	}

	/* extra lines of the multi-line cells */
	while (rc == 0 && pending) {
		pending = 0;
		fputs(linesep(tb), tb->out);
		tb->termlines_used++;
		scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
		while (rc == 0 && scols_table_next_column(tb, &itr, &cl) == 0) {
			if (scols_column_is_hidden(cl))
				continue;
			if (cl->pending_data) {
				rc = print_pending_data(tb, cl, ln, scols_line_get_cell(ln, cl->seqnum));
				if (rc == 0 && cl->pending_data)
					pending = 1;
			} else
				print_empty_cell(tb, cl, ln, buf->bufsz);
		}
	}

	return 0;
}

/* Write N_SPACES space characters to DEST while ensuring
   nothing is written beyond DEST_END. A terminating NUL
   is always added to DEST.
   A pointer to the terminating NUL is returned.  */
static char*
mbs_align_pad (char *dest, const char* dest_end, size_t n_spaces, int padchar)
{
  /* FIXME: Should we pad with "figure space" (\u2007)
     if non ascii data present?  */
  for (/* nothing */; n_spaces && (dest < dest_end); n_spaces--)
    *dest++ = padchar;
  *dest = '\0';
  return dest;
}

/* Align a string, SRC, in a field of *WIDTH columns, handling multi-byte
   characters; write the result into the DEST_SIZE-byte buffer, DEST.
   ALIGNMENT specifies whether to left- or right-justify or to center.
   If SRC requires more than *WIDTH columns, truncate it to fit.
   When centering, the number of trailing spaces may be one less than the
   number of leading spaces. The FLAGS parameter is unused at present.
   Return the length in bytes required for the final result, not counting
   the trailing NUL.  A return value of DEST_SIZE or larger means there
   wasn't enough space.  DEST will be NUL terminated in any case.
   Return (size_t) -1 upon error (invalid multi-byte sequence in SRC,
   or malloc failure), unless MBA_UNIBYTE_FALLBACK is specified.
   Update *WIDTH to indicate how many columns were used before padding.  */

static size_t
mbsalign_with_padding (const char *src, char *dest, size_t dest_size,
		       size_t *width, mbs_align_t align,
		       int flags __attribute__((__unused__)),
		       int padchar)
{
  size_t ret = -1;
  size_t src_size = strlen (src) + 1;
  char *newstr = NULL;
  char *str_wc = NULL;
  const char *str_to_print = src;
  size_t n_cols = src_size - 1;
  size_t n_used_bytes = n_cols; /* Not including NUL */
  size_t n_spaces = 0, space_left;

  if (n_cols > *width) /* Unibyte truncation required.  */
    {
      n_cols = *width;
      n_used_bytes = n_cols;
    }

  if (*width > n_cols) /* Padding required.  */
    n_spaces = *width - n_cols;

  /* indicate to caller how many cells needed (not including padding).  */
  *width = n_cols;

  /* indicate to caller how many bytes needed (not including NUL).  */
  ret = n_used_bytes + (n_spaces * 1);

  /* Write as much NUL terminated output to DEST as possible.  */
  if (dest_size != 0)
    {
      char *dest_end = dest + dest_size - 1;
      size_t start_spaces;
      size_t end_spaces;

      switch (align)
	{
	case MBS_ALIGN_CENTER:
	  start_spaces = n_spaces / 2 + n_spaces % 2;
	  end_spaces = n_spaces / 2;
	  break;
	case MBS_ALIGN_LEFT:
	  start_spaces = 0;
	  end_spaces = n_spaces;
	  break;
	case MBS_ALIGN_RIGHT:
	  start_spaces = n_spaces;
	  end_spaces = 0;
	  break;
	default:
	  abort();
	}

      dest = mbs_align_pad (dest, dest_end, start_spaces, padchar);
      space_left = dest_end - dest;
      dest = mempcpy (dest, str_to_print, min (n_used_bytes, space_left));
      mbs_align_pad (dest, dest_end, end_spaces, padchar);
    }
  free (str_wc);
  free (newstr);

  return ret;
}

static size_t mbsalign (const char *src, char *dest, size_t dest_size,
	  size_t *width, mbs_align_t align, int flags)
{
	return mbsalign_with_padding(src, dest, dest_size, width, align, flags, ' ');
}

static int print_title(struct libscols_table *tb)
{
	int rc, color = 0;
	mbs_align_t align;
	size_t width, len = 0, bufsz, titlesz;
	char *title = NULL, *buf = NULL;

	if (!tb->title.data)
		return 0;

	/* encode data */
	if (tb->no_encode) {
		len = bufsz = strlen(tb->title.data) + 1;
		buf = xstrdup(tb->title.data);
	} else {
		bufsz = mbs_safe_encode_size(strlen(tb->title.data)) + 1;
		if (bufsz == 1)
			return 0;
		buf = xmalloc(bufsz);
		if (!mbs_safe_encode_to_buffer(tb->title.data, &len, buf, NULL) ||
		    !len || len == (size_t) -1) {
			rc = -EINVAL;
			goto done;
		}
	}

	/* truncate and align */
	width = tb->is_term ? tb->termwidth : 80;
	titlesz = width + bufsz;

	title = xmalloc(titlesz);

	switch (scols_cell_get_alignment(&tb->title)) {
	case SCOLS_CELL_FL_RIGHT:
		align = MBS_ALIGN_RIGHT;
		break;
	case SCOLS_CELL_FL_CENTER:
		align = MBS_ALIGN_CENTER;
		break;
	case SCOLS_CELL_FL_LEFT:
	default:
		align = MBS_ALIGN_LEFT;
		/* Don't print extra blank chars after the title if on left
		 * (that's same as we use for the last column in the table). */
		if (len < width
		    && !scols_table_is_maxout(tb)
		    && isblank(*titlepadding_symbol(tb)))
			width = len;
		break;

	}

	/* copy from buf to title and align to width with title_padding */
	rc = mbsalign_with_padding(buf, title, titlesz,
			&width, align,
			0, (int) *titlepadding_symbol(tb));

	if (rc == -1) {
		rc = -EINVAL;
		goto done;
	}

	if (tb->colors_wanted && tb->title.color)
		color = 1;
	if (color)
		fputs(tb->title.color, tb->out);

	fputs(title, tb->out);

	if (color)
		fputs(UL_COLOR_RESET, tb->out);

	fputc('\n', tb->out);
	rc = 0;
done:
	free(buf);
	free(title);
	return rc;
}

static int print_header(struct libscols_table *tb, struct libscols_buffer *buf)
{
	int rc = 0;
	struct libscols_column *cl;
	struct libscols_iter itr;

	if ((tb->header_printed == 1 && tb->header_repeat == 0) ||
	    scols_table_is_noheadings(tb) ||
	    scols_table_is_export(tb) ||
	    list_empty(&tb->tb_lines))
		return 0;

	/* set the width according to the size of the data */
	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (rc == 0 && scols_table_next_column(tb, &itr, &cl) == 0) {
		if (scols_column_is_hidden(cl))
			continue;
		rc = buffer_set_data(buf, scols_cell_get_data(&cl->header));
		if (!rc)
			rc = print_data(tb, cl, NULL, &cl->header, buf);
	}

	if (rc == 0) {
		fputs(linesep(tb), tb->out);
		tb->termlines_used++;
	}

	tb->header_printed = 1;
	tb->header_next = tb->termlines_used + tb->termheight;
	return rc;
}


static int print_range( struct libscols_table *tb,
			struct libscols_buffer *buf,
			struct libscols_iter *itr,
			struct libscols_line *end)
{
	int rc = 0;
	struct libscols_line *ln;

	while (rc == 0 && scols_table_next_line(tb, itr, &ln) == 0) {

		int last = scols_iter_is_last(itr);

		rc = print_line(tb, ln, buf);
		fput_line_close(tb, last, last);

		if (end && ln == end)
			break;

		if (!last && want_repeat_header(tb))
			print_header(tb, buf);
	}

	return rc;

}

static int print_table(struct libscols_table *tb, struct libscols_buffer *buf)
{
	struct libscols_iter itr;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	return print_range(tb, buf, &itr, NULL);
}


static int print_tree_line(struct libscols_table *tb,
			   struct libscols_line *ln,
			   struct libscols_buffer *buf,
			   int last, int last_in_table)
{
	int rc;

	/* print the line */
	rc = print_line(tb, ln, buf);
	if (rc)
		goto done;

	/* print children */
	if (!list_empty(&ln->ln_branch)) {
		struct list_head *p;

		fput_children_open(tb);

		/* print all children */
		list_for_each(p, &ln->ln_branch) {
			struct libscols_line *chld =
					list_entry(p, struct libscols_line, ln_children);
			int last_child = p->next == &ln->ln_branch;

			rc = print_tree_line(tb, chld, buf, last_child, last_in_table && last_child);
			if (rc)
				goto done;
		}

	}

	if (list_empty(&ln->ln_branch))
		fput_line_close(tb, last, last_in_table);
done:
	return rc;
}

static int print_tree(struct libscols_table *tb, struct libscols_buffer *buf)
{
	int rc = 0;
	struct libscols_line *ln, *last = NULL;
	struct libscols_iter itr;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);

	while (scols_table_next_line(tb, &itr, &ln) == 0)
		if (!last || !ln->parent)
			last = ln;

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (rc == 0 && scols_table_next_line(tb, &itr, &ln) == 0) {
		if (ln->parent)
			continue;
		rc = print_tree_line(tb, ln, buf, ln == last, ln == last);
	}

	return rc;
}

/* Gets the value of @cl's flag strict_width. Returns: 0 or 1 */
static inline int scols_column_is_strict_width(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_STRICTWIDTH ? 1 : 0;
}

/* Gets the value of @cl's flag no_extremes. Returns: 0 or 1 */
static inline int scols_column_is_noextremes(const struct libscols_column *cl)
{
	return cl->flags & SCOLS_FL_NOEXTREMES ? 1 : 0;
}

/* This function counts column width.
 *
 * For the SCOLS_FL_NOEXTREMES columns it is possible to call this function
 * two times. The first pass counts the width and average width. If the column
 * contains fields that are too large (a width greater than 2 * average) then
 * the column is marked as "extreme". In the second pass all extreme fields
 * are ignored and the column width is counted from non-extreme fields only. */
static int count_column_width(struct libscols_table *tb,
			      struct libscols_column *cl,
			      struct libscols_buffer *buf)
{
	struct libscols_line *ln;
	struct libscols_iter itr;
	int extreme_count = 0, rc = 0, no_header = 0;
	size_t extreme_sum = 0;

	cl->width = 0;
	if (!cl->width_min) {
		if (cl->width_hint < 1 && scols_table_is_maxout(tb) && tb->is_term) {
			cl->width_min = (size_t) (cl->width_hint * tb->termwidth);
			if (cl->width_min && !is_last_column(cl))
				cl->width_min--;
		}
		if (scols_cell_get_data(&cl->header)) {
			size_t len = mbs_safe_width(scols_cell_get_data(&cl->header));
			cl->width_min = max(cl->width_min, len);
		} else
			no_header = 1;

		if (!cl->width_min)
			cl->width_min = 1;
	}

	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (scols_table_next_line(tb, &itr, &ln) == 0) {
		size_t len;
		char *data;

		rc = cell_to_buffer(tb, ln, cl, buf);
		if (rc)
			goto done;

		data = buffer_get_data(buf);

		if (!data)
			len = 0;
		else if (scols_column_is_customwrap(cl))
			len = cl->wrap_chunksize(cl, data, cl->wrapfunc_data);
		else
			len = mbs_safe_width(data);

		if (len == (size_t) -1)         /* ignore broken multibyte strings */
			len = 0;
		cl->width_max = max(len, cl->width_max);

		if (cl->is_extreme && cl->width_avg && len > cl->width_avg * 2)
			continue;
		else if (scols_column_is_noextremes(cl)) {
			extreme_sum += len;
			extreme_count++;
		}
		cl->width = max(len, cl->width);
		if (scols_column_is_tree(cl)) {
			size_t treewidth = buffer_get_safe_art_size(buf);
			cl->width_treeart = max(cl->width_treeart, treewidth);
		}
	}

	if (extreme_count && cl->width_avg == 0) {
		cl->width_avg = extreme_sum / extreme_count;
		if (cl->width_avg && cl->width_max > cl->width_avg * 2)
			cl->is_extreme = 1;
	}

	/* enlarge to minimal width */
	if (cl->width < cl->width_min && !scols_column_is_strict_width(cl))
		cl->width = cl->width_min;

	/* use absolute size for large columns */
	else if (cl->width_hint >= 1 && cl->width < (size_t) cl->width_hint
		 && cl->width_min < (size_t) cl->width_hint)

		cl->width = (size_t) cl->width_hint;


	/* Column without header and data, set minimal size to zero (default is 1) */
	if (cl->width_max == 0 && no_header && cl->width_min == 1 && cl->width <= 1)
		cl->width = cl->width_min = 0;

done:
	return rc;
}

/* This is core of the scols_* voodoo... */
static int recount_widths(struct libscols_table *tb, struct libscols_buffer *buf)
{
	struct libscols_column *cl;
	struct libscols_iter itr;
	size_t width = 0, width_min = 0;        /* output width */
	int stage, rc = 0;
	int extremes = 0;
	size_t colsepsz;


	colsepsz = mbs_safe_width(colsep(tb));

	/* set basic columns width */
	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (scols_table_next_column(tb, &itr, &cl) == 0) {
		int is_last;

		if (scols_column_is_hidden(cl))
			continue;
		rc = count_column_width(tb, cl, buf);
		if (rc)
			goto done;

		is_last = is_last_column(cl);

		width += cl->width + (is_last ? 0 : colsepsz);          /* separator for non-last column */
		width_min += cl->width_min + (is_last ? 0 : colsepsz);
		extremes += cl->is_extreme;
	}

	if (!tb->is_term)
		goto done;

	/* be paranoid */
	if (width_min > tb->termwidth && scols_table_is_maxout(tb)) {
		scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
		while (width_min > tb->termwidth
		       && scols_table_next_column(tb, &itr, &cl) == 0) {
			if (scols_column_is_hidden(cl))
				continue;
			width_min--;
			cl->width_min--;
		}
	}

	/* reduce columns with extreme fields */
	if (width > tb->termwidth && extremes) {
		scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
		while (scols_table_next_column(tb, &itr, &cl) == 0) {
			size_t org_width;

			if (!cl->is_extreme || scols_column_is_hidden(cl))
				continue;

			org_width = cl->width;
			rc = count_column_width(tb, cl, buf);
			if (rc)
				goto done;

			if (org_width > cl->width)
				width -= org_width - cl->width;
			else
				extremes--;     /* hmm... nothing reduced */
		}
	}

	if (width < tb->termwidth) {
		if (extremes) {
			/* enlarge the first extreme column */
			scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
			while (scols_table_next_column(tb, &itr, &cl) == 0) {
				size_t add;

				if (!cl->is_extreme || scols_column_is_hidden(cl))
					continue;

				add = tb->termwidth - width;
				if (add && cl->width + add > cl->width_max)
					add = cl->width_max - cl->width;

				cl->width += add;
				width += add;

				if (width == tb->termwidth)
					break;
			}
		}

		if (width < tb->termwidth && scols_table_is_maxout(tb)) {
			/* try enlarging all columns */
			while (width < tb->termwidth) {
				scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
				while (scols_table_next_column(tb, &itr, &cl) == 0) {
					if (scols_column_is_hidden(cl))
						continue;
					cl->width++;
					width++;
					if (width == tb->termwidth)
						break;
				}
			}
		} else if (width < tb->termwidth) {
			/* enlarge the last column */
			struct libscols_column *col = list_entry(
				tb->tb_columns.prev, struct libscols_column, cl_columns);

			if (!scols_column_is_right(col) && tb->termwidth - width > 0) {
				col->width += tb->termwidth - width;
				width = tb->termwidth;
			}
		}
	}

	/* bad, we have to reduce output width, this is done in three stages:
	 *
	 * 1) trunc relative with trunc flag if the column width is greater than
	 *    expected column width (it means "width_hint * terminal_width").
	 *
	 * 2) trunc all with trunc flag
	 *
	 * 3) trunc relative without trunc flag
	 *
	 * Note that SCOLS_FL_WRAP (if no custom wrap function is specified) is
	 * interpreted as SCOLS_FL_TRUNC. */
	for (stage = 1; width > tb->termwidth && stage <= 3; ) {
		size_t org_width = width;

		scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
		while (scols_table_next_column(tb, &itr, &cl) == 0) {

			int trunc_flag = 0;

			if (scols_column_is_hidden(cl))
				continue;
			if (width <= tb->termwidth)
				break;

			/* never truncate if already minimal width */
			if (cl->width == cl->width_min)
				continue;

			/* never truncate the tree */
			if (scols_column_is_tree(cl) && width <= cl->width_treeart)
				continue;

			/* nothing to truncate */
			if (cl->width == 0 || width == 0)
				continue;

			trunc_flag = scols_column_is_trunc(cl)
				    || (scols_column_is_wrap(cl) && !scols_column_is_customwrap(cl));

			switch (stage) {
			/* #1 stage - trunc relative with TRUNC flag */
			case 1:
				if (!trunc_flag)                /* ignore: missing flag */
					break;
				if (cl->width_hint <= 0 || cl->width_hint >= 1) /* ignore: no relative */
					break;
				if (cl->width < (size_t) (cl->width_hint * tb->termwidth)) /* ignore: smaller than expected width */
					break;

				cl->width--;
				width--;
				break;

			/* #2 stage - trunc all with TRUNC flag */
			case 2:
				if (!trunc_flag)                /* ignore: missing flag */
					break;

				cl->width--;
				width--;
				break;

			/* #3 stage - trunc relative without flag */
			case 3:
				if (cl->width_hint <= 0 || cl->width_hint >= 1) /* ignore: no relative */
					break;

				cl->width--;
				width--;
				break;
			}

			/* hide zero width columns */
			if (cl->width == 0)
				cl->flags |= SCOLS_FL_HIDDEN;
		}

		/* the current stage is without effect, go to the next */
		if (org_width == width)
			stage++;
	}

	/* ignore last column(s) or force last column to be truncated if
	 * nowrap mode enabled */
	if (tb->no_wrap && width > tb->termwidth) {
		scols_reset_iter(&itr, SCOLS_ITER_BACKWARD);
		while (scols_table_next_column(tb, &itr, &cl) == 0) {

			if (scols_column_is_hidden(cl))
				continue;
			if (width <= tb->termwidth)
				break;
			if (width - cl->width < tb->termwidth) {
				size_t r =  width - tb->termwidth;

				cl->flags |= SCOLS_FL_TRUNC;
				cl->width -= r;
				width -= r;
			} else {
				cl->flags |= SCOLS_FL_HIDDEN;
				width -= cl->width + colsepsz;
			}
		}
	}
done:
	return rc;
}

static size_t strlen_line(struct libscols_line *ln)
{
	size_t i, sz = 0;

	for (i = 0; i < ln->ncells; i++) {
		struct libscols_cell *ce = scols_line_get_cell(ln, i);
		const char *data = ce ? scols_cell_get_data(ce) : NULL;

		sz += data ? strlen(data) : 0;
	}

	return sz;
}

static void cleanup_printing(struct libscols_table *tb, struct libscols_buffer *buf)
{
	if (!tb)
		return;

	free_buffer(buf);

	if (tb->priv_symbols) {
		scols_table_set_symbols(tb, NULL);
		tb->priv_symbols = 0;
	}
}

static int initialize_printing(struct libscols_table *tb, struct libscols_buffer **buf)
{
	size_t bufsz, extra_bufsz = 0;
	struct libscols_line *ln;
	struct libscols_iter itr;
	int rc;

	*buf = NULL;

	if (!tb->symbols) {
		rc = scols_table_set_default_symbols(tb);
		if (rc)
			goto err;
		tb->priv_symbols = 1;
	} else
		tb->priv_symbols = 0;

	if (tb->format == SCOLS_FMT_HUMAN)
		tb->is_term = tb->termforce == SCOLS_TERMFORCE_NEVER  ? 0 :
			      tb->termforce == SCOLS_TERMFORCE_ALWAYS ? 1 :
			      isatty(STDOUT_FILENO);

	if (tb->is_term) {
		size_t width = (size_t) scols_table_get_termwidth(tb);

		if (tb->termreduce > 0 && tb->termreduce < width) {
			width -= tb->termreduce;
			scols_table_set_termwidth(tb, width);
		}
		bufsz = width;
	} else
		bufsz = BUFSIZ;

	if (!tb->is_term || tb->format != SCOLS_FMT_HUMAN || scols_table_is_tree(tb))
		tb->header_repeat = 0;

	/* Estimate extra space necessary for tree, JSON or another output decoration. */
	if (scols_table_is_tree(tb))
		extra_bufsz += tb->nlines * strlen(vertical_symbol(tb));

	switch (tb->format) {
	case SCOLS_FMT_RAW:
		extra_bufsz += tb->ncols;                       /* separator between columns */
		break;
	case SCOLS_FMT_EXPORT:
	{
		struct libscols_column *cl;

		scols_reset_iter(&itr, SCOLS_ITER_FORWARD);

		while (scols_table_next_column(tb, &itr, &cl) == 0) {
			if (scols_column_is_hidden(cl))
				continue;
			extra_bufsz += strlen(scols_cell_get_data(&cl->header));        /* data */
			extra_bufsz += 2;                                               /* separators */
		}
		break;
	}
	case SCOLS_FMT_HUMAN:
		break;
	}

	/* Enlarge buffer if necessary, the buffer should be large enough to
	 * store line data and tree ascii art (or another decoration). */
	scols_reset_iter(&itr, SCOLS_ITER_FORWARD);
	while (scols_table_next_line(tb, &itr, &ln) == 0) {
		size_t sz;

		sz = strlen_line(ln) + extra_bufsz;
		if (sz > bufsz)
			bufsz = sz;
	}

	*buf = new_buffer(bufsz + 1);   /* data + space for \0 */

	if (tb->format == SCOLS_FMT_HUMAN) {
		rc = recount_widths(tb, *buf);
		if (rc != 0)
			goto err;
	}

	return 0;
err:
	cleanup_printing(tb, *buf);
	return rc;
}

static int __scols_print_table(struct libscols_table *tb, int *is_empty)
{
	int rc = 0;
	struct libscols_buffer *buf = NULL;

	if (!tb)
		return -EINVAL;

	if (is_empty)
		*is_empty = 0;

	if (list_empty(&tb->tb_columns))
		return -EINVAL;
	if (list_empty(&tb->tb_lines)) {
		if (is_empty)
			*is_empty = 1;
		return 0;
	}

	tb->header_printed = 0;
	rc = initialize_printing(tb, &buf);
	if (rc)
		return rc;

	if (tb->format == SCOLS_FMT_HUMAN)
		print_title(tb);

	rc = print_header(tb, buf);
	if (rc)
		goto done;

	if (scols_table_is_tree(tb))
		rc = print_tree(tb, buf);
	else
		rc = print_table(tb, buf);

done:
	cleanup_printing(tb, buf);
	return rc;
}

/* Prints the table to the output stream and terminate by \n.
 *
 * Returns: 0, a negative value in case of an error. */
static int scols_print_table(struct libscols_table *tb)
{
	int empty = 0;
	int rc = __scols_print_table(tb, &empty);

	if (rc == 0 && !empty)
		fputc('\n', tb->out);
	return rc;
}

/* qsort/bsearch buddy */
static int cmp_scheme_name(const void *a0, const void *b0)
{
	const struct ul_color_scheme *a = (const struct ul_color_scheme *) a0,
				     *b = (const struct ul_color_scheme *) b0;
	return strcmp(a->name, b->name);
}

/* Parses [[<utilname>][@<termname>].]<type> */
static int filename_to_tokens(const char *str,
			      const char **name, size_t *namesz,
			      const char **term, size_t *termsz,
			      int  *filetype)
{
	const char *type_start, *term_start, *p;

	if (!str || !*str || *str == '.' || strlen(str) > PATH_MAX)
		return -EINVAL;

	/* parse .type */
	p = strrchr(str, '.');
	type_start = p ? p + 1 : str;

	if (strcmp(type_start, "disable") == 0)
		*filetype = UL_COLORFILE_DISABLE;
	else if (strcmp(type_start, "enable") == 0)
		*filetype = UL_COLORFILE_ENABLE;
	else if (strcmp(type_start, "scheme") == 0)
		*filetype = UL_COLORFILE_SCHEME;
	else {
		return 1;                               /* unknown type */
	}

	if (type_start == str)
		return 0;                               /* "type" only */

	/* parse @termname */
	p = strchr(str, '@');
	term_start = p ? p + 1 : NULL;
	if (term_start) {
		*term = term_start;
		*termsz = type_start - term_start - 1;
		if (term_start - 1 == str)
			return 0;                       /* "@termname.type" */
	}

	/* parse utilname */
	p = term_start ? term_start : type_start;
	*name =  str;
	*namesz = p - str - 1;

	return 0;
}

/* Scans @dirname and select the best matches for UL_COLORFILE_* types.
 * The result is stored to cc->scores. The path to the best "scheme"
 * file is stored to cc->scheme. */
static int colors_readdir(struct ul_color_ctl *cc, const char *dirname)
{
	DIR *dir;
	int rc = 0;
	struct dirent *d;
	char sfile[PATH_MAX] = { '\0' };
	size_t namesz, termsz;

	if (!dirname || !cc || !cc->utilname || !*cc->utilname)
		return -EINVAL;

	dir = opendir(dirname);
	if (!dir)
		return -errno;

	namesz = strlen(cc->utilname);
	termsz = cc->termname ? strlen(cc->termname) : 0;

	while ((d = readdir(dir))) {
		int type, score = 1;
		const char *tk_name = NULL, *tk_term = NULL;
		size_t tk_namesz = 0, tk_termsz = 0;

		if (*d->d_name == '.')
			continue;
#ifdef _DIRENT_HAVE_D_TYPE
		if (d->d_type != DT_UNKNOWN && d->d_type != DT_LNK &&
		    d->d_type != DT_REG)
			continue;
#endif
		if (filename_to_tokens(d->d_name,
				       &tk_name, &tk_namesz,
				       &tk_term, &tk_termsz, &type) != 0)
			continue;

		/* count theoretical score before we check names to avoid
		 * unnecessary strcmp() */
		if (tk_name)
			score += 20;
		if (tk_term)
			score += 10;

		if (score < cc->scores[type])
			continue;

		/* filter out by names */
		if (tk_namesz && (tk_namesz != namesz ||
				 strncmp(tk_name, cc->utilname, namesz) != 0))
			continue;

		if (tk_termsz && (termsz == 0 || tk_termsz != termsz ||
				  strncmp(tk_term, cc->termname, termsz) != 0))
			continue;

		cc->scores[type] = score;
		if (type == UL_COLORFILE_SCHEME)
			strncpy(sfile, d->d_name, sizeof(sfile));
	}

	if (*sfile) {
		sfile[sizeof(sfile) - 1] = '\0';
		cc->sfile = xasprintf("%s/%s", dirname, sfile);
	}

	closedir(dir);
	return rc;
}

/* Returns path to $XDG_CONFIG_HOME/terminal-colors.d */
static char *colors_get_homedir(char *buf, size_t bufsz)
{
	char *p = getenv("XDG_CONFIG_HOME");

	if (p) {
		snprintf(buf, bufsz, "%s/" _PATH_TERMCOLORS_DIRNAME, p);
		return buf;
	}

	p = getenv("HOME");
	if (p) {
		snprintf(buf, bufsz, "%s/.config/" _PATH_TERMCOLORS_DIRNAME, p);
		return buf;
	}

	return NULL;
}

/* canonicalize sequence */
static void cn_sequence(const char *str, char **seq)
{
	char *in, *out;

	*seq = NULL;
	/* convert logical names like "red" to the real sequence */
	if (*str != '\\' && isalpha(*str)) {
		const char *s = color_sequence_from_colorname(str);
		*seq = xstrdup(s ? s : str);
		return;
	}

	/* convert xx;yy sequences to "\033[xx;yy" */
	*seq = xasprintf("\033[%sm", str);
	for (in = *seq, out = *seq; in && *in; in++) {
		if (*in != '\\') {
			*out++ = *in;
			continue;
		}
		switch(*(in + 1)) {
		case 'a':
			*out++ = '\a';  /* Bell */
			break;
		case 'b':
			*out++ = '\b';  /* Backspace */
			break;
		case 'e':
			*out++ = '\033';        /* Escape */
			break;
		case 'f':
			*out++ = '\f';  /* Form Feed */
			break;
		case 'n':
			*out++ = '\n';  /* Newline */
			break;
		case 'r':
			*out++ = '\r';  /* Carriage Return */
			break;
		case 't':
			*out++ = '\t';  /* Tab */
			break;
		case 'v':
			*out++ = '\v';  /* Vertical Tab */
			break;
		case '\\':
			*out++ = '\\';  /* Backslash */
			break;
		case '_':
			*out++ = ' ';   /* Space */
			break;
		case '#':
			*out++ = '#';   /* Hash mark */
			break;
		case '?':
			*out++ = '?';   /* Question mark */
			break;
		default:
			*out++ = *in;
			*out++ = *(in + 1);
			break;
		}
		in++;
	}

	*out = '\0';
}

/* Adds one color sequence to array with color scheme.
 * When returning success (0) this function takes ownership of
 * @seq and @name, which have to be allocated strings. */
static int colors_add_scheme(struct ul_color_ctl *cc,
			     char *name,
			     char *seq0)
{
	struct ul_color_scheme *cs = NULL;
	char *seq = NULL;

	if (!cc || !name || !*name || !seq0)
		return -EINVAL;

	cn_sequence(seq0, &seq);

	/* convert logical name (e.g. "red") to real ESC code */
	if (isalpha(*seq)) {
		const char *s = color_sequence_from_colorname(seq);
		char *p;

		if (!s) {
			if (cs) {
				free(cs->seq);
				free(cs->name);
				cs->seq = cs->name = NULL;
			} else
				free(seq);
			return -EINVAL;
		}

		p = xstrdup(s);
		free(seq);
		seq = p;
	}

	/* enlarge the array */
	if (cc->nschemes == cc->schemes_sz) {
		void *tmp = xrealloc(cc->schemes, (cc->nschemes + 10)
					* sizeof(struct ul_color_scheme));
		cc->schemes = tmp;
		cc->schemes_sz = cc->nschemes + 10;
	}

	/* add a new item */
	cs = &cc->schemes[cc->nschemes];
	cs->seq = seq;
	cs->name = xstrdup(name);
	cc->nschemes++;
	return 0;
}

/* The scheme configuration has to be sorted for bsearch */
static void colors_sort_schemes(struct ul_color_ctl *cc)
{
	if (!cc->nschemes)
		return;

	qsort(cc->schemes, cc->nschemes,
	      sizeof(struct ul_color_scheme), cmp_scheme_name);
}


/* Parses filenames in terminal-colors.d */
static int colors_read_configuration(struct ul_color_ctl *cc)
{
	int rc = -ENOENT;
	char *dirname, buf[PATH_MAX];

	cc->termname = getenv("TERM");

	dirname = colors_get_homedir(buf, sizeof(buf));
	if (dirname)
		rc = colors_readdir(cc, dirname);               /* ~/.config */
	if (rc == -EPERM || rc == -EACCES || rc == -ENOENT)
		rc = colors_readdir(cc, _PATH_TERMCOLORS_DIR);  /* /etc */

	cc->configured = 1;
	return rc;
}

/* Default behavior, maybe be override by terminal-colors.d/{enable,disable}. */
/* Reads terminal-colors.d/ scheme file into array schemes */
static int colors_read_schemes(struct ul_color_ctl *cc)
{
	int rc = 0;
	FILE *f = NULL;
	char buf[BUFSIZ], cn[129], seq[129];

	if (!cc->configured)
		rc = colors_read_configuration(cc);

	cc->cs_configured = 1;

	if (rc || !cc->sfile)
		goto done;

	f = fopen(cc->sfile, "r");
	if (!f) {
		rc = -errno;
		goto done;
	}

	while (fgets(buf, sizeof(buf), f)) {
		char *p = strchr_set0(buf, '\n');

		if (!p) {
			if (!feof(f)) {
				rc = -errno;
				goto done;
			}
		}
		p = bb_skip_whitespace(buf);
		if (*p == '\0' || *p == '#')
			continue;

		rc = sscanf(p, "%128[^ ] %128[^\n ]", cn, seq);
		if (rc == 2 && *cn && *seq) {
			rc = colors_add_scheme(cc, cn, seq);    /* set rc=0 on success */
			if (rc)
				goto done;
		}
	}
	rc = 0;

done:
	if (f)
		fclose(f);
	colors_sort_schemes(cc);

	return rc;
}

static int colors_terminal_is_ready(void)
{
	if (isatty(STDOUT_FILENO) != 1)
		return 0;

	return 1;
}

/* Initialize private color control struct and initialize the colors
 * status. The color schemes are parsed on demand by colors_get_scheme().
 *
 * Returns: >0 on success. */
static int colors_init(int mode, const char *name)
{
	int ready = -1;
	struct ul_color_ctl *cc = &ul_colors;

	cc->utilname = name;
	cc->mode = mode;

	if (mode == UL_COLORMODE_UNDEF && (ready = colors_terminal_is_ready())) {
		int rc = colors_read_configuration(cc);
		if (rc)
			cc->mode = UL_COLORMODE_DEFAULT;
		else {

			/* evaluate scores */
			if (cc->scores[UL_COLORFILE_DISABLE] >
			    cc->scores[UL_COLORFILE_ENABLE])
				cc->mode = UL_COLORMODE_NEVER;
			else
				cc->mode = UL_COLORMODE_DEFAULT;
		}
	}

	switch (cc->mode) {
	case UL_COLORMODE_AUTO:
		cc->has_colors = ready == -1 ? colors_terminal_is_ready() : ready;
		break;
	case UL_COLORMODE_ALWAYS:
		cc->has_colors = 1;
		break;
	case UL_COLORMODE_NEVER:
	default:
		cc->has_colors = 0;
	}

	return cc->has_colors;
}

/* Is terminal-colors.d/ configured to use colors? */
static inline int colors_wanted(void)
{
	return ul_colors.has_colors;
}

/* Enable @seq color */
static void color_fenable(const char *seq, FILE *f)
{
	if (ul_colors.has_colors && seq)
		fputs(seq, f);
}

/* Returns just one color scheme */
static struct ul_color_scheme *colors_get_scheme(struct ul_color_ctl *cc,
						 const char *name)
{
	struct ul_color_scheme key = { .name = (char *) name}, *res;

	if (!cc || !name || !*name)
		return NULL;

	if (!cc->cs_configured) {
		int rc = colors_read_schemes(cc);
		if (rc)
			return NULL;
	}
	if (!cc->nschemes)
		return NULL;

	res = bsearch(&key, cc->schemes, cc->nschemes,
				sizeof(struct ul_color_scheme),
				cmp_scheme_name);

	return res && res->seq ? res  : NULL;
}

/* Returns escape sequence by logical @name, if undefined then returns @dflt. */
static const char *color_scheme_get_sequence(const char *name, const char *dflt)
{
	struct ul_color_scheme *cs;

	if (!ul_colors.has_colors)
		return NULL;

	cs = colors_get_scheme(&ul_colors, name);
	return cs && cs->seq ? cs->seq : dflt;
}

/* Enable color by logical @name, if undefined enable @dflt. */
static void color_scheme_fenable(const char *name, const char *dflt, FILE *f)
{
	const char *seq = color_scheme_get_sequence(name, dflt);

	if (!seq)
		return;
	color_fenable(seq, f);
}

static inline void color_scheme_enable(const char *name, const char *dflt)
{
	color_scheme_fenable(name, dflt, stdout);
}

/* Disable previously enabled color */
static void color_fdisable(FILE *f)
{
	if (ul_colors.has_colors)
		fputs(UL_COLOR_RESET, f);
}

static inline void color_disable(void)
{
	color_fdisable(stdout);
}

/* Parses @str to return UL_COLORMODE_* */
static int colormode_from_string(const char *str)
{
	size_t i;
	static const char * const modes[] = {
		[UL_COLORMODE_AUTO]   = "auto",
		[UL_COLORMODE_NEVER]  = "never",
		[UL_COLORMODE_ALWAYS] = "always",
		[UL_COLORMODE_UNDEF] = ""
	};

	if (!str || !*str)
		return -EINVAL;

	for (i = 0; i < ARRAY_SIZE(modes); i++) {
		if (strcasecmp(str, modes[i]) == 0)
			return i;
	}

	return -EINVAL;
}

/* Parses @str and exit(EXIT_FAILURE) on error */
static int colormode_or_err(const char *str, const char *errmsg)
{
	const char *p = str && *str == '=' ? str + 1 : str;
	int colormode;

	colormode = colormode_from_string(p);
	if (colormode < 0)
		bb_perror_msg_and_die("%s: '%s'", errmsg, p);

	return colormode;
}

#define from_hex(c)             (isdigit(c) ? c - '0' : tolower(c) - 'a' + 10)

static size_t unhexmangle_to_buffer(const char *s, char *buf, size_t len)
{
	size_t sz = 0;
	const char *buf0 = buf;

	if (!s)
		return 0;

	while(*s && sz < len - 1) {
		if (*s == '\\' && sz + 3 < len - 1 && s[1] == 'x' &&
		    isxdigit(s[2]) && isxdigit(s[3])) {

			*buf++ = from_hex(s[2]) << 4 | from_hex(s[3]);
			s += 4;
			sz += 4;
		} else {
			*buf++ = *s++;
			sz++;
		}
	}
	*buf = '\0';
	return buf - buf0 + 1;
}

static inline void unhexmangle_string(char *s)
{
	unhexmangle_to_buffer(s, s, strlen(s) + 1);
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* Simple functions to access files. Paths can be globally prefixed to read
 * data from an alternative source (e.g. a /proc dump for regression tests).
 *
 * The paths is possible to format by printf-like way for functions with "f"
 * postfix in the name (e.g. readf, openf, ... ul_path_readf_u64()).
 *
 * The ul_path_read_* API is possible to use without path_cxt handler. In this
 * case is not possible to use global prefix and printf-like formatting.
 *
 * No copyright is claimed.  This code is in the public domain; do with
 * it what you wish.
 *
 * Written by Karel Zak <kzak@redhat.com> [February 2018] */
static void ul_unref_path(struct path_cxt *pc)
{
	if (!pc)
		return;

	pc->refcount--;

	if (pc->refcount <= 0) {
		if (pc->dialect)
			pc->free_dialect(pc);
		if (pc->dir_fd >= 0)
			close(pc->dir_fd);
		free(pc->dir_path);
		free(pc->prefix);
		free(pc);
	}
}

static struct path_cxt *ul_new_path(void)
{
	struct path_cxt *pc = zmalloc(sizeof(*pc));

	pc->refcount = 1;
	pc->dir_fd = -1;
	return pc;
}

static inline void ul_ref_path(struct path_cxt *pc)
{
	pc->refcount++;
}

static inline void ul_path_set_prefix(struct path_cxt *pc, const char *prefix)
{
	free(pc->prefix);
	pc->prefix = xstrdup(prefix);
}

static const char *ul_path_get_prefix(struct path_cxt *pc)
{
	return pc ? pc->prefix : NULL;
}

static int ul_path_set_dir(struct path_cxt *pc, const char *dir)
{
	char *p = NULL;

	if (dir)
		p = xstrdup(dir);

	if (pc->dir_fd >= 0) {
		close(pc->dir_fd);
		pc->dir_fd = -1;
	}

	free(pc->dir_path);
	pc->dir_path = p;
	return 0;
}

static int ul_path_set_dialect(struct path_cxt *pc, void *data, void free_data(struct path_cxt *))
{
	pc->dialect = data;
	pc->free_dialect = free_data;
	return 0;
}

static void *ul_path_get_dialect(struct path_cxt *pc)
{
	return pc ? pc->dialect : NULL;
}

static int ul_path_set_enoent_redirect(struct path_cxt *pc, int (*func)(struct path_cxt *, const char *, int *))
{
	pc->redirect_on_enoent = func;
	return 0;
}

static const char *get_absdir(struct path_cxt *pc)
{
	int rc;
	const char *dirpath;

	if (!pc->prefix)
		return pc->dir_path;

	dirpath = pc->dir_path;
	if (!dirpath)
		return pc->prefix;
	if (*dirpath == '/')
		dirpath++;

	rc = snprintf(pc->path_buffer, sizeof(pc->path_buffer), "%s/%s", pc->prefix, dirpath);
	if (rc < 0)
		return NULL;
	if ((size_t)rc >= sizeof(pc->path_buffer)) {
		errno = ENAMETOOLONG;
		return NULL;
	}

	return pc->path_buffer;
}

static int ul_path_get_dirfd(struct path_cxt *pc)
{
	if (pc->dir_fd < 0) {
		const char *path = get_absdir(pc);
		if (!path)
			return -errno;

		pc->dir_fd = open(path, O_RDONLY|O_CLOEXEC);
	}

	return pc->dir_fd;
}

static int ul_path_access(struct path_cxt *pc, int mode, const char *path)
{
	int dir, rc;

	dir = ul_path_get_dirfd(pc);
	if (dir < 0)
		return dir;

	rc = faccessat(dir, path, mode, 0);

	if (rc && errno == ENOENT
	    && pc->redirect_on_enoent
	    && pc->redirect_on_enoent(pc, path, &dir) == 0)
		rc = faccessat(dir, path, mode, 0);
	return rc;
}

static int ul_path_open(struct path_cxt *pc, int flags, const char *path)
{
	int fd;

	if (!pc) {
		fd = open(path, flags);
	} else {
		int dir = ul_path_get_dirfd(pc);
		if (dir < 0)
			return dir;

		fd = openat(dir, path, flags);

		if (fd < 0 && errno == ENOENT
		    && pc->redirect_on_enoent
		    && pc->redirect_on_enoent(pc, path, &dir) == 0)
			fd = openat(dir, path, flags);

	}
	return fd;
}

/* Maybe stupid, but good enough ;-) */
static int mode2flags(const char *mode)
{
	int flags = 0;
	const char *p;

	for (p = mode; p && *p; p++) {
		if (*p == 'r' && *(p + 1) == '+')
			flags |= O_RDWR;
		else if (*p == 'r')
			flags |= O_RDONLY;

		else if (*p == 'w' && *(p + 1) == '+')
			flags |= O_RDWR | O_TRUNC;
		else if (*p == 'w')
			flags |= O_WRONLY | O_TRUNC;

		else if (*p == 'a' && *(p + 1) == '+')
			flags |= O_RDWR | O_APPEND;
		else if (*p == 'a')
			flags |= O_WRONLY | O_APPEND;
#ifdef O_CLOEXEC
		else if (*p == *UL_CLOEXECSTR)
			flags |= O_CLOEXEC;
#endif
	}

	return flags;
}

static FILE *ul_path_fopen(struct path_cxt *pc, const char *mode, const char *path)
{
	int flags = mode2flags(mode);
	int fd = ul_path_open(pc, flags, path);

	if (fd < 0)
		return NULL;

	return fdopen(fd, mode);
}

static int dup_fd_cloexec(int oldfd, int lowfd)
{
	int fd, flags, errno_save;

#ifdef F_DUPFD_CLOEXEC
	fd = fcntl(oldfd, F_DUPFD_CLOEXEC, lowfd);
	if (fd >= 0)
		return fd;
#endif

	fd = dup(oldfd);
	if (fd < 0)
		return fd;

	flags = fcntl(fd, F_GETFD);
	if (flags < 0)
		goto unwind;
	if (fcntl(fd, F_SETFD, flags | FD_CLOEXEC) < 0)
		goto unwind;

	return fd;

unwind:
	errno_save = errno;
	close(fd);
	errno = errno_save;

	return -1;
}

/* returns basename and keeps dirname in the @path, if @path is "/" (root)
 * then returns empty string */
static char *stripoff_last_component(char *path)
{
	char *p = path ? strrchr(path, '/') : NULL;

	if (!p)
		return NULL;
	*p = '\0';
	return p + 1;
}

/* Open directory @path in read-onl mode. If the path is NULL then duplicate FD
 *  to the directory addressed by @pc. */
static DIR *ul_path_opendir(struct path_cxt *pc, const char *path)
{
	DIR *dir;
	int fd = -1;

	if (path)
		fd = ul_path_open(pc, O_RDONLY|O_CLOEXEC, path);
	else if (pc->dir_path)
		fd = dup_fd_cloexec(ul_path_get_dirfd(pc), STDERR_FILENO + 1);

	if (fd < 0)
		return NULL;

	dir = fdopendir(fd);
	if (!dir) {
		close(fd);
		return NULL;
	}
	if (!path)
		 rewinddir(dir);
	return dir;
}

/* If @path is NULL then readlink is called on @pc directory. */
static ssize_t ul_path_readlink(struct path_cxt *pc, char *buf, size_t bufsiz, const char *path)
{
	int dirfd;

	if (!path) {
		const char *p = get_absdir(pc);
		if (!p)
			return -errno;
		return readlink(p, buf, bufsiz);
	}

	dirfd = ul_path_get_dirfd(pc);
	if (dirfd < 0)
		return dirfd;

	return readlinkat(dirfd, path, buf, bufsiz);
}

static int ul_path_read(struct path_cxt *pc, char *buf, size_t len, const char *path)
{
	int rc, errsv;
	int fd;

	fd = ul_path_open(pc, O_RDONLY|O_CLOEXEC, path);
	if (fd < 0)
		return -errno;

	rc = read_all(fd, buf, len);

	errsv = errno;
	close(fd);
	errno = errsv;
	return rc;
}

/* Returns newly allocated buffer with data from file. Maximal size is BUFSIZ
 * (send patch if you need something bigger;-)
 *
 * Returns size of the string! */
static int ul_path_read_string(struct path_cxt *pc, char **str, const char *path)
{
	char buf[BUFSIZ];
	int rc;

	*str = NULL;

	rc = ul_path_read(pc, buf, sizeof(buf) - 1, path);
	if (rc < 0 || !str)
		return rc;

	/* Remove tailing newline (usuall in sysfs) */
	if (rc > 0 && *(buf + rc - 1) == '\n')
		--rc;

	buf[rc] = '\0';
	*str = xstrdup(buf);
	return rc;
}

static int ul_path_scanf(struct path_cxt *pc, const char *path, const char *fmt, ...)
{
	FILE *f;
	va_list fmt_ap;
	int rc;

	f = ul_path_fopen(pc, "r" UL_CLOEXECSTR, path);
	if (!f)
		return -EINVAL;

	va_start(fmt_ap, fmt);
	rc = vfscanf(f, fmt, fmt_ap);
	va_end(fmt_ap);

	fclose(f);
	return rc;
}

static int ul_path_read_s64(struct path_cxt *pc, int64_t *res, const char *path)
{
	int64_t x = 0;
	int rc;

	rc = ul_path_scanf(pc, path, "%"SCNd64, &x);
	if (rc != 1)
		return -1;
	if (res)
		*res = x;
	return 0;
}

static int ul_path_read_u64(struct path_cxt *pc, uint64_t *res, const char *path)
{
	uint64_t x = 0;
	int rc;

	rc = ul_path_scanf(pc, path, "%"SCNu64, &x);
	if (rc != 1)
		return -1;
	if (res)
		*res = x;
	return 0;
}
#endif /* CONFIG_FEATURE_LIBBLKID */


#ifndef EBADFD
# define EBADFD 77              /* File descriptor in bad state */
#endif

#define DEFAULT_SECTOR_SIZE       512

#ifdef __linux__
/* very basic ioctls, should be available everywhere */
# ifndef BLKROSET
#  define BLKROSET   _IO(0x12,93)       /* set device read-only (0 = read-write) */
#  define BLKROGET   _IO(0x12,94)       /* get read-only status (0 = read_write) */
#  define BLKRRPART  _IO(0x12,95)       /* re-read partition table */
#  define BLKGETSIZE _IO(0x12,96)       /* return device size /512 (long *arg) */
#  define BLKFLSBUF  _IO(0x12,97)       /* flush buffer cache */
#  define BLKRASET   _IO(0x12,98)       /* set read ahead for block device */
#  define BLKRAGET   _IO(0x12,99)       /* get current read ahead setting */
#  define BLKFRASET  _IO(0x12,100)      /* set filesystem (mm/filemap.c) read-ahead */
#  define BLKFRAGET  _IO(0x12,101)      /* get filesystem (mm/filemap.c) read-ahead */
#  define BLKSECTSET _IO(0x12,102)      /* set max sectors per request (ll_rw_blk.c) */
#  define BLKSECTGET _IO(0x12,103)      /* get max sectors per request (ll_rw_blk.c) */
#  define BLKSSZGET  _IO(0x12,104)      /* get block device sector size */

/* ioctls introduced in 2.2.16, removed in 2.5.58 */
#  define BLKELVGET  _IOR(0x12,106,size_t) /* elevator get */
#  define BLKELVSET  _IOW(0x12,107,size_t) /* elevator set */

#  define BLKBSZGET  _IOR(0x12,112,size_t)
#  define BLKBSZSET  _IOW(0x12,113,size_t)
# endif /* !BLKROSET */

# ifndef BLKGETSIZE64
#  define BLKGETSIZE64 _IOR(0x12,114,size_t) /* return device size in bytes (u64 *arg) */
# endif

/* block device topology ioctls, introduced in 2.6.32 (commit ac481c20) */
# ifndef BLKIOMIN
#  define BLKIOMIN   _IO(0x12,120)
#  define BLKIOOPT   _IO(0x12,121)
#  define BLKALIGNOFF _IO(0x12,122)
#  define BLKPBSZGET _IO(0x12,123)
# endif

/* discard zeroes support, introduced in 2.6.33 (commit 98262f27) */
# ifndef BLKDISCARDZEROES
#  define BLKDISCARDZEROES _IO(0x12,124)
# endif

/* filesystem freeze, introduced in 2.6.29 (commit fcccf502) */
# ifndef FIFREEZE
#  define FIFREEZE   _IOWR('X', 119, int)    /* Freeze */
#  define FITHAW     _IOWR('X', 120, int)    /* Thaw */
# endif

/* uniform CD-ROM information */
# ifndef CDROM_GET_CAPABILITY
#  define CDROM_GET_CAPABILITY 0x5331
# endif

#endif /* __linux */


#ifndef HDIO_GETGEO
# ifdef __linux__
#  define HDIO_GETGEO 0x0301
# endif

struct hd_geometry {
	unsigned char heads;
	unsigned char sectors;
	unsigned short cylinders;       /* truncated */
	unsigned long start;
};
#endif /* HDIO_GETGEO */


static long blkdev_valid_offset (int fd, off_t offset) {
	char ch;

	if (lseek (fd, offset, 0) < 0)
		return 0;
	if (read (fd, &ch, 1) < 1)
		return 0;
	return 1;
}

static off_t blkdev_find_size (int fd) {
	uintmax_t high, low = 0;

	for (high = 1024; blkdev_valid_offset (fd, high); ) {
		if (high == UINTMAX_MAX)
			return -1;

		low = high;

		if (high >= UINTMAX_MAX/2)
			high = UINTMAX_MAX;
		else
			high *= 2;
	}

	while (low < high - 1)
	{
		uintmax_t mid = (low + high) / 2;

		if (blkdev_valid_offset (fd, mid))
			low = mid;
		else
			high = mid;
	}
	blkdev_valid_offset (fd, 0);
	return (low + 1);
}

/* get size in bytes */
static int blkdev_get_size(int fd, unsigned long long *bytes)
{
#ifdef DKIOCGETBLOCKCOUNT
	/* Apple Darwin */
	if (ioctl(fd, DKIOCGETBLOCKCOUNT, bytes) >= 0) {
		*bytes <<= 9;
		return 0;
	}
#endif

#ifdef BLKGETSIZE64
	if (ioctl(fd, BLKGETSIZE64, bytes) >= 0)
		return 0;
#endif

#ifdef BLKGETSIZE
	{
		unsigned long size;

		if (ioctl(fd, BLKGETSIZE, &size) >= 0) {
			*bytes = ((unsigned long long)size << 9);
			return 0;
		}
	}

#endif /* BLKGETSIZE */

#ifdef DIOCGMEDIASIZE
	/* FreeBSD */
	if (ioctl(fd, DIOCGMEDIASIZE, bytes) >= 0)
		return 0;
#endif

#ifdef FDGETPRM
	{
		struct floppy_struct this_floppy;

		if (ioctl(fd, FDGETPRM, &this_floppy) >= 0) {
			*bytes = ((unsigned long long) this_floppy.size) << 9;
			return 0;
		}
	}
#endif /* FDGETPRM */

	{
		struct stat st;

		if (fstat(fd, &st) == 0 && S_ISREG(st.st_mode)) {
			*bytes = st.st_size;
			return 0;
		}
		if (!S_ISBLK(st.st_mode))
			return -1;
	}

	*bytes = blkdev_find_size(fd);
	return 0;
}

/* get 512-byte sector count */
static int blkdev_get_sectors(int fd, unsigned long long *sectors)
{
	unsigned long long bytes;

	if (blkdev_get_size(fd, &bytes) == 0) {
		*sectors = (bytes >> 9);
		return 0;
	}

	return -1;
}

/* Get logical sector size.
 *
 * This is the smallest unit the storage device can
 * address. It is typically 512 bytes. */
#ifdef BLKSSZGET
static int blkdev_get_sector_size(int fd, int *sector_size)
{
	if (ioctl(fd, BLKSSZGET, sector_size) >= 0)
		return 0;
	return -1;
}
#else
static int blkdev_get_sector_size(int fd __attribute__((__unused__)), int *sector_size)
{
	*sector_size = DEFAULT_SECTOR_SIZE;
	return 0;
}
#endif

#ifdef CONFIG_FEATURE_LIBBLKID
#ifdef CDROM_GET_CAPABILITY
static int blkdev_is_cdrom(int fd)
{
	int ret;

	if ((ret = ioctl(fd, CDROM_GET_CAPABILITY, NULL)) < 0)
		return 0;
	else
		return ret;
}
#else
static int blkdev_is_cdrom(int fd __attribute__((__unused__)))
{
	return 0;
}
#endif
#endif /* CONFIG_FEATURE_LIBBLKID */

/* Get kernel's interpretation of the device's geometry.
 *
 * Returns the heads and sectors - but not cylinders
 * as it's truncated for disks with more than 65535 tracks.
 *
 * Note that this is deprecated in favor of LBA addressing. */
#ifdef HDIO_GETGEO
static int blkdev_get_geometry(int fd, unsigned int *h, unsigned int *s)
{
	struct hd_geometry geometry;

	if (ioctl(fd, HDIO_GETGEO, &geometry) == 0) {
		*h = geometry.heads;
		*s = geometry.sectors;
		return 0;
	}
#else
static int blkdev_get_geometry(int fd __attribute__((__unused__)),
		unsigned int *h, unsigned int *s)
{
	*h = 0;
	*s = 0;
#endif
	return -1;
}

#ifdef CONFIG_FEATURE_LIBBLKID
static void sysfs_blkdev_deinit_path(struct path_cxt *pc)
{
	struct sysfs_blkdev *blk;

	if (!pc)
		return;

	blk = ul_path_get_dialect(pc);
	if (!blk)
		return;

	ul_ref_path(blk->parent);
	free(blk);

	ul_path_set_dialect(pc, NULL, NULL);
}

static int sysfs_blkdev_set_parent(struct path_cxt *pc, struct path_cxt *parent)
{
	struct sysfs_blkdev *blk = ul_path_get_dialect(pc);

	if (!pc || !blk)
		return -EINVAL;

	if (blk->parent) {
		ul_unref_path(blk->parent);
		blk->parent = NULL;
	}

	if (parent) {
		ul_ref_path(parent);
		blk->parent = parent;
	} else
		blk->parent = NULL;

	return 0;
}

/* Redirects ENOENT errors to the parent, if the path is to the queue/
 * sysfs directory. For example
 *
 *      /sys/dev/block/8:1/queue/logical_block_size redirects to
 *      /sys/dev/block/8:0/queue/logical_block_size */
static int sysfs_blkdev_enoent_redirect(struct path_cxt *pc, const char *path, int *dirfd)
{
	struct sysfs_blkdev *blk = ul_path_get_dialect(pc);

	if (blk && blk->parent && strncmp(path, "queue/", 6) == 0) {
		*dirfd = ul_path_get_dirfd(blk->parent);
		if (*dirfd >= 0)
			return 0;
	}
	return 1;       /* no redirect */
}

/* sysfs_blkdev_* is sysfs extension to ul_path_* API for block devices.
 *
 * The function is possible to call in loop and without sysfs_blkdev_deinit_path().
 * The sysfs_blkdev_deinit_path() is automatically called by ul_unref_path(). */
static int sysfs_blkdev_init_path(struct path_cxt *pc, dev_t devno, struct path_cxt *parent)
{
	struct sysfs_blkdev *blk;
	int rc;
	char buf[sizeof(_PATH_SYS_DEVBLOCK)
		 + sizeof(stringify_value(UINT32_MAX)) * 2
		 + 3];

	/* define path to devno stuff */
	snprintf(buf, sizeof(buf), _PATH_SYS_DEVBLOCK "/%d:%d", major(devno), minor(devno));
	rc = ul_path_set_dir(pc, buf);
	if (rc)
		return rc;

	/* make sure path exists */
	rc = ul_path_get_dirfd(pc);
	if (rc < 0)
		return rc;

	/* initialize sysfs blkdev specific stuff */
	blk = ul_path_get_dialect(pc);
	if (!blk) {
		blk = zmalloc(sizeof(struct sysfs_blkdev));
		ul_path_set_dialect(pc, blk, sysfs_blkdev_deinit_path);
		ul_path_set_enoent_redirect(pc, sysfs_blkdev_enoent_redirect);
	}

	blk->devno = devno;
	sysfs_blkdev_set_parent(pc, parent);

	return 0;
}

static char *sysfs_blkdev_get_name(struct path_cxt *pc, char *buf, size_t bufsiz)
{
	char link[PATH_MAX];
	char *name;
	ssize_t sz;

	/* read /sys/dev/block/<maj:min> link */
	sz = ul_path_readlink(pc, link, sizeof(link) - 1, NULL);
	if (sz < 0)
		return NULL;
	link[sz] = '\0';

	name = strrchr(link, '/');
	if (!name)
		return NULL;

	name++;
	sz = strlen(name);
	if ((size_t) sz + 1 > bufsiz)
		return NULL;

	memcpy(buf, name, sz + 1);
	sysfs_devname_sys_to_dev(buf);
	return buf;
}

/* Returns slave name if there is only one slave, otherwise returns NULL.
 * The result should be deallocated by free(). */
static char *sysfs_blkdev_get_slave(struct path_cxt *pc)
{
	DIR *dir;
	struct dirent *d;
	char *name = NULL;

	dir = ul_path_opendir(pc, "slaves");
	if (!dir)
		return NULL;

	while ((d = readdir(dir))) {
		if (!strcmp(d->d_name, ".") ||
		    !strcmp(d->d_name, ".."))
			continue;
		if (name)
			goto err;       /* more slaves */
		name = xstrdup(d->d_name);
	}

	closedir(dir);
	return name;
err:
	free(name);
	closedir(dir);
	return NULL;
}

static dev_t sysfs_blkdev_get_devno(struct path_cxt *pc)
{
	return ((struct sysfs_blkdev *) ul_path_get_dialect(pc))->devno;
}

static struct path_cxt *ul_new_sysfs_path(dev_t devno, struct path_cxt *parent, const char *prefix)
{
	struct path_cxt *pc = ul_new_path();

	if (prefix)
		ul_path_set_prefix(pc, prefix);

	if (sysfs_blkdev_init_path(pc, devno, parent) != 0) {
		ul_unref_path(pc);
		return NULL;
	}

	return pc;
}

/* Returns 1 if the device is private device mapper device. The @uuid
 * (if not NULL) returns DM device UUID, use free() to deallocate. */
static int sysfs_devno_is_dm_private(dev_t devno, char **uuid)
{
	struct path_cxt *pc = NULL;
	char *id = NULL;
	int rc = 0;

	pc = ul_new_sysfs_path(devno, NULL, NULL);
	if (!pc)
		goto done;
	if (ul_path_read_string(pc, &id, "dm/uuid") <= 0 || !id)
		goto done;

	/* Private LVM devices use "LVM-<uuid>-<name>" uuid format (important
	 * is the "LVM" prefix and "-<name>" postfix). */
	if (strncmp(id, "LVM-", 4) == 0) {
		char *p = strrchr(id + 4, '-');

		if (p && *(p + 1))
			rc = 1;

	/* Private Stratis devices prefix the UUID with "stratis-1-private" */
	} else if (strncmp(id, "stratis-1-private", 17) == 0) {
		rc = 1;
	}
done:
	ul_unref_path(pc);
	if (uuid)
		*uuid = id;
	else
		free(id);
	return rc;
}

static dev_t read_devno(const char *path)
{
	FILE *f;
	int maj = 0, min = 0;
	dev_t dev = 0;

	f = fopen(path, "r" UL_CLOEXECSTR);
	if (!f)
		return 0;

	if (fscanf(f, "%d:%d", &maj, &min) == 2)
		dev = makedev(maj, min);
	fclose(f);
	return dev;
}

static dev_t __sysfs_devname_to_devno(const char *prefix, const char *name, const char *parent)
{
	char buf[PATH_MAX];
	char *_name = NULL;     /* name as encoded in sysfs */
	dev_t dev = 0;
	int len;

	if (!prefix)
		prefix = "";

	if (strncmp("/dev/", name, 5) == 0) {
		/* Read from /dev */
		struct stat st;

		if (stat(name, &st) == 0) {
			dev = st.st_rdev;
			goto done;
		}
		name += 5;      /* unaccesible, or not node in /dev */
	}

	_name = xstrdup(name);
	sysfs_devname_dev_to_sys(_name);

	if (parent && strncmp("dm-", name, 3)) {
		/* Create path to /sys/block/<parent>/<name>/dev */
		char *_parent = xstrdup(parent);

		sysfs_devname_dev_to_sys(_parent);
		len = snprintf(buf, sizeof(buf),
				"%s" _PATH_SYS_BLOCK "/%s/%s/dev",
				prefix, _parent, _name);
		free(_parent);
		if (len < 0 || (size_t) len >= sizeof(buf))
			goto done;

		/* don't try anything else for dm-* */
		dev = read_devno(buf);
		goto done;
	}

	/* Read from /sys/block/<sysname>/dev */
	len = snprintf(buf, sizeof(buf), "%s" _PATH_SYS_BLOCK "/%s/dev",
			prefix, _name);
	if (len < 0 || (size_t) len >= sizeof(buf))
		goto done;
	dev = read_devno(buf);

	if (!dev) {
		/* Read from /sys/block/<sysname>/device/dev */
		len = snprintf(buf, sizeof(buf),
				"%s" _PATH_SYS_BLOCK "/%s/device/dev",
				prefix, _name);
		if (len < 0 || (size_t) len >= sizeof(buf))
			goto done;
		dev = read_devno(buf);
	}
done:
	free(_name);
	return dev;
}

static dev_t sysfs_devname_to_devno(const char *name)
{
	return __sysfs_devname_to_devno(NULL, name, NULL);
}

static char *sysfs_blkdev_get_path(struct path_cxt *pc, char *buf, size_t bufsiz)
{
	const char *name = sysfs_blkdev_get_name(pc, buf, bufsiz);
	char *res = NULL;
	size_t sz;
	struct stat st;

	if (!name)
		goto done;

	sz = strlen(name);
	if (sz + sizeof("/dev/") > bufsiz)
		goto done;

	/* create the final "/dev/<name>" string */
	memmove(buf + 5, name, sz + 1);
	memcpy(buf, "/dev/", 5);

	if (!stat(buf, &st) && S_ISBLK(st.st_mode) && st.st_rdev == sysfs_blkdev_get_devno(pc))
		res = buf;
done:
	return res;
}

/* Returns devname (e.g. "/dev/sda1") for the given devno.
 *
 * Please, use more robust blkid_devno_to_devname() in your applications. */
static char *sysfs_devno_to_devpath(dev_t devno, char *buf, size_t bufsiz)
{
	struct path_cxt *pc = ul_new_sysfs_path(devno, NULL, NULL);
	char *res = NULL;

	if (pc) {
		res = sysfs_blkdev_get_path(pc, buf, bufsiz);
		ul_unref_path(pc);
	}
	return res;
}

static char *blkid_strconcat(const char *a, const char *b, const char *c)
{
	char *res, *p;
	size_t len, al, bl, cl;

	al = a ? strlen(a) : 0;
	bl = b ? strlen(b) : 0;
	cl = c ? strlen(c) : 0;

	len = al + bl + cl;
	if (!len)
		return NULL;
	p = res = xmalloc(len + 1);
	if (al) {
		memcpy(p, a, al);
		p += al;
	}
	if (bl) {
		memcpy(p, b, bl);
		p += bl;
	}
	if (cl) {
		memcpy(p, c, cl);
		p += cl;
	}
	*p = '\0';
	return res;
}

/* This function adds an entry to the directory list */
static void add_to_dirlist(const char *dir, const char *subdir,
				struct dir_list **list)
{
	struct dir_list *dp;

	dp = xmalloc(sizeof(struct dir_list));
	dp->name = subdir ? blkid_strconcat(dir, "/", subdir) :
		   dir ? xstrdup(dir) : NULL;

	if (!dp->name) {
		free(dp);
		return;
	}
	dp->next = *list;
	*list = dp;
}

/* This function frees a directory list */
static void free_dirlist(struct dir_list **list)
{
	struct dir_list *dp, *next;

	for (dp = *list; dp; dp = next) {
		next = dp->next;
		free(dp->name);
		free(dp);
	}
	*list = NULL;
}

static void blkid__scan_dir(char *dirname, dev_t devno, struct dir_list **list,
		     char **devname)
{
	DIR     *dir;
	struct dirent *dp;
	struct stat st;

	if ((dir = opendir(dirname)) == NULL)
		return;

	while ((dp = readdir(dir)) != NULL) {
#ifdef _DIRENT_HAVE_D_TYPE
		if (dp->d_type != DT_UNKNOWN && dp->d_type != DT_BLK &&
		    dp->d_type != DT_LNK && dp->d_type != DT_DIR)
			continue;
#endif
		if (dp->d_name[0] == '.' &&
		    ((dp->d_name[1] == 0) ||
		     ((dp->d_name[1] == '.') && (dp->d_name[2] == 0))))
			continue;

		if (fstatat(dirfd(dir), dp->d_name, &st, 0))
			continue;

		if (S_ISBLK(st.st_mode) && st.st_rdev == devno) {
			*devname = blkid_strconcat(dirname, "/", dp->d_name);
			break;
		}

		if (!list || !S_ISDIR(st.st_mode))
			continue;

		/* add subdirectory (but not symlink) to the list */
#ifdef _DIRENT_HAVE_D_TYPE
		if (dp->d_type == DT_LNK)
			continue;
		if (dp->d_type == DT_UNKNOWN)
#endif
		{
			if (fstatat(dirfd(dir), dp->d_name, &st, 1) ||
			    !S_ISDIR(st.st_mode))
				continue;       /* symlink or lstat() failed */
		}

		if (*dp->d_name == '.' || (
#ifdef _DIRENT_HAVE_D_TYPE
		    dp->d_type == DT_DIR &&
#endif
		    strcmp(dp->d_name, "shm") == 0))
			/* ignore /dev/.{udev,mount,mdadm} and /dev/shm */
			continue;

		add_to_dirlist(dirname, dp->d_name, list);
	}
	closedir(dir);
	return;
}

/* Directories where we will try to search for device numbers */
static const char * const devdirs[] = { "/devices", "/devfs", "/dev", NULL };

static char *scandev_devno_to_devpath(dev_t devno)
{
	struct dir_list *list = NULL, *new_list = NULL;
	char *devname = NULL;
	const char * const * dir;

	/* Add the starting directories to search in reverse order of
	 * importance, since we are using a stack... */
	for (dir = devdirs; *dir; dir++)
		add_to_dirlist(*dir, NULL, &list);

	while (list) {
		struct dir_list *current = list;

		list = list->next;
		blkid__scan_dir(current->name, devno, &new_list, &devname);
		free(current->name);
		free(current);
		if (devname)
			break;
		/* If we're done checking at this level, descend to
		 * the next level of subdirectories. (breadth-first) */
		if (list == NULL) {
			list = new_list;
			new_list = NULL;
		}
	}
	free_dirlist(&list);
	free_dirlist(&new_list);

	return devname;
}

/* This function finds the pathname to a block device with a given
 * device number.
 * Returns: a pointer to allocated memory to the pathname on success,
 * and NULL on failure. */
static char *blkid_devno_to_devname(dev_t devno)
{
	char *path;
	char buf[PATH_MAX];

	path = sysfs_devno_to_devpath(devno, buf, sizeof(buf));
	if (path)
		path = xstrdup(path);
	if (!path)
		path = scandev_devno_to_devpath(devno);

	return path;
}

/* Returns 1 if the @major number is associated with @drvname. */
static int blkid_driver_has_major(const char *drvname, int drvmaj)
{
	FILE *f;
	char buf[128];
	int match = 0;

	f = fopen(_PATH_PROC_DEVICES, "r" UL_CLOEXECSTR);
	if (!f)
		return 0;

	while (fgets(buf, sizeof(buf), f)) {    /* skip to block dev section */
		if (strncmp("Block devices:\n", buf, sizeof(buf)) == 0)
			break;
	}

	while (fgets(buf, sizeof(buf), f)) {
		int maj;
		char name[64 + 1];

		if (sscanf(buf, "%d %64[^\n ]", &maj, name) != 2)
			continue;

		if (maj == drvmaj && strcmp(name, drvname) == 0) {
			match = 1;
			break;
		}
	}

	fclose(f);

	return match;
}
#endif /* CONFIG_FEATURE_LIBBLKID */

#ifdef CONFIG_FEATURE_LIBBLKID
/* The low-level probing routines always and directly read information from
 * the selected (see blkid_probe_set_device()) device.
 *
 * The probing routines are grouped together into separate chains. Currently,
 * the library provides superblocks, partitions and topology chains.
 *
 * The probing routines is possible to filter (enable/disable) by type (e.g.
 * fstype "vfat" or partype "gpt") or by usage flags (e.g. BLKID_USAGE_RAID).
 * These filters are per-chain. Note that always when you touch the chain
 * filter the current probing position is reset and probing starts from
 * scratch.  It means that the chain filter should not be modified during
 * probing, for example in loop where you call blkid_do_probe().
 *
 * For more details see the chain specific documentation.
 *
 * The low-level API provides two ways how access to probing results.
 *
 *   1. The NAME=value (tag) interface. This interface is older and returns all data
 *      as strings. This interface is generic for all chains.
 *
 *   2. The binary interfaces. These interfaces return data in the native formats.
 *      The interface is always specific to the probing chain.
 *
 *  Note that the previous probing result (binary or NAME=value) is always
 *  zeroized when a chain probing function is called.
 *
 * overwrites the previous probing result for the partitions chain, the superblocks
 * result is not modified. */

/* The probing routines inside the chain are mutually exclusive by default --
 * only few probing routines are marked as "tolerant". The "tolerant" probing
 * routines are used for filesystem which can share the same device with any
 * other filesystem.
 *
 * The SUPERBLOCKS chain is enabled by default. The all others chains is
 * necessary to enable by blkid_probe_enable_'CHAINNAME'(). See chains specific
 * documentation.
 *
 * The blkid_do_probe() function returns a result from only one probing
 * routine, and the next call from the next probing routine. It means you need
 * to call the function in loop.
 *
 * The probing result is set of NAME=value pairs (the NAME is always unique). */

#include <linux/cdrom.h>

/* All supported chains */
static const struct blkid_chaindrv * const chains_drvs[];

static void blkid_probe_reset_values(blkid_probe pr)
{
	if (list_empty(&pr->values))
		return;

	while (!list_empty(&pr->values)) {
		struct blkid_prval *v = list_entry(pr->values.next,
						struct blkid_prval, prvals);
		blkid_probe_free_value(v);
	}

	INIT_LIST_HEAD(&pr->values);
}

/* libblkid reuse all already read buffers from the device. The bufferes may be
 * modified by blkid_probe_hide_range(). This function reset and free all
 * cached bufferes. The next blkid_do_probe() will read all data from the
 * device. */
static void blkid_probe_reset_buffers(blkid_probe pr)
{
	uint64_t ct = 0, len = 0;

	pr->flags &= ~BLKID_FL_MODIF_BUFF;

	if (list_empty(&pr->buffers))
		return;

	while (!list_empty(&pr->buffers)) {
		struct blkid_bufinfo *bf = list_entry(pr->buffers.next,
						struct blkid_bufinfo, bufs);
		ct++;
		len += bf->len;
		list_del(&bf->bufs);
		free(bf);
	}

	INIT_LIST_HEAD(&pr->buffers);
}

/* Deallocates the probe struct, buffers and all allocated
 * data that are associated with this probing control struct. */
static void blkid_free_probe(blkid_probe pr)
{
	int i;

	if (!pr)
		return;

	for (i = 0; i < BLKID_NCHAINS; i++) {
		struct blkid_chain *ch = &pr->chains[i];

		if (ch->driver->free_data)
			ch->driver->free_data(pr, ch->data);
		free(ch->fltr);
	}

	if ((pr->flags & BLKID_FL_PRIVATE_FD) && pr->fd >= 0)
		close(pr->fd);
	blkid_probe_reset_buffers(pr);
	blkid_probe_reset_values(pr);
	blkid_free_probe(pr->disk_probe);

	free(pr);
}

/* Removes chain values from probing result. */
static void blkid_probe_chain_reset_values(blkid_probe pr, struct blkid_chain *chn)
{

	struct list_head *p, *pnext;

	if (list_empty(&pr->values))
		return;

	list_for_each_safe(p, pnext, &pr->values) {
		struct blkid_prval *v = list_entry(p, struct blkid_prval, prvals);

		if (v->chain == chn)
			blkid_probe_free_value(v);
	}
}

static void blkid_probe_chain_reset_position(struct blkid_chain *chn)
{
	chn->idx = -1;
}

/* Move chain values from probing result to @vals */
static int blkid_probe_chain_save_values(blkid_probe pr, struct blkid_chain *chn,
				struct list_head *vals)
{
	struct list_head *p, *pnext;
	struct blkid_prval *v;

	list_for_each_safe(p, pnext, &pr->values) {

		v = list_entry(p, struct blkid_prval, prvals);
		if (v->chain != chn)
			continue;

		list_del_init(&v->prvals);
		list_add_tail(&v->prvals, vals);
	}
	return 0;
}

/* Appends values from @vals to the probing result */
static void blkid_probe_append_values_list(blkid_probe pr, struct list_head *vals)
{
	list_splice(vals, &pr->values);
	INIT_LIST_HEAD(vals);
}


static void blkid_probe_free_values_list(struct list_head *vals)
{
	if (!vals)
		return;

	while (!list_empty(vals)) {
		struct blkid_prval *v = list_entry(vals->next, struct blkid_prval, prvals);
		blkid_probe_free_value(v);
	}
}

static void *blkid_probe_get_binary_data(blkid_probe pr, struct blkid_chain *chn)
{
	int rc, org_prob_flags;
	struct blkid_chain *org_chn;

	/* save the current setting -- the binary API has to be completely
	 * independent on the current probing status */
	org_chn = pr->cur_chain;
	org_prob_flags = pr->prob_flags;

	pr->cur_chain = chn;
	pr->prob_flags = 0;
	chn->binary = TRUE;
	blkid_probe_chain_reset_position(chn);

	rc = chn->driver->probe(pr, chn);

	chn->binary = FALSE;
	blkid_probe_chain_reset_position(chn);

	/* restore the original setting */
	pr->cur_chain = org_chn;
	pr->prob_flags = org_prob_flags;

	if (rc != 0)
		return NULL;

	return chn->data;
}

/* Some mkfs-like utils wipe some parts (usually begin) of the device.
 * For example LVM (pvcreate) or mkswap(8). This information could be used
 * for later resolution to conflicts between superblocks.
 *
 * For example we found valid LVM superblock, LVM wipes 8KiB at the begin of
 * the device. If we found another signature (for example MBR) within the
 * wiped area then the signature has been added later and LVM superblock
 * should be ignore.
 *
 * Note that this heuristic is not 100% reliable, for example "pvcreate --zero
 * n" allows to keep the begin of the device unmodified. It's probably better
 * to use this heuristic for conflicts between superblocks and partition tables
 * than for conflicts between filesystem superblocks -- existence of unwanted
 * partition table is very unusual, because PT is pretty visible (parsed and
 * interpreted by kernel).
 *
 * Note that we usually expect only one signature on the device, it means that
 * we have to remember only one wiped area from previously successfully
 * detected signature.
 *
 * blkid_probe_set_wiper() -- defines wiped area (e.g. LVM)
 * blkid_probe_use_wiper() -- try to use area (e.g. MBR)
 *
 * Note that there is not relation between _wiper and blkid_to_wipe(). */
static void blkid_probe_set_wiper(blkid_probe pr, uint64_t off, uint64_t size)
{
	struct blkid_chain *chn;

	if (!size) {
		pr->wipe_size = pr->wipe_off = 0;
		pr->wipe_chain = NULL;
		return;
	}

	chn = pr->cur_chain;

	if (!chn || !chn->driver ||
	    chn->idx < 0 || (size_t) chn->idx >= chn->driver->nidinfos)
		return;

	pr->wipe_size = size;
	pr->wipe_off = off;
	pr->wipe_chain = chn;
}

/* Zeroize probing results and resets the current probing (this has impact to
 * blkid_do_probe() only). This function does not touch probing filters and
 * keeps assigned device. */
static void blkid_reset_probe(blkid_probe pr)
{
	int i;

	blkid_probe_reset_values(pr);
	blkid_probe_set_wiper(pr, 0, 0);

	pr->cur_chain = NULL;

	for (i = 0; i < BLKID_NCHAINS; i++)
		blkid_probe_chain_reset_position(&pr->chains[i]);
}


/* Zeroize in-memory data in already read buffer. The next blkid_probe_get_buffer()
 * will return modified buffer. This is usable when you want to call the same probing
 * function more than once and hide previously detected magic strings. */
static int hide_buffer(blkid_probe pr, uint64_t off, uint64_t len)
{
	uint64_t real_off = pr->off + off;
	struct list_head *p;
	int ct = 0;

	list_for_each(p, &pr->buffers) {
		struct blkid_bufinfo *x =
			list_entry(p, struct blkid_bufinfo, bufs);
		unsigned char *data;

		if (real_off >= x->off && real_off + len <= x->off + x->len) {

			data = real_off ? x->data + (real_off - x->off) : x->data;

			memset(data, 0, len);
			ct++;
		}
	}
	return ct == 0 ? -EINVAL : 0;
}

/* This function modifies in-memory cached data from the device. The specified
 * range is zeroized. This is usable together with blkid_probe_step_back().
 * The next blkid_do_probe() will not see specified area.
 * Note that this is usable for already (by library) read data, and this
 * function is not a way how to hide any large areas on your device.
 * The function blkid_probe_reset_buffers() reverts all.
 * Returns: <0 in case of failure, or 0 on success. */
static int blkid_probe_hide_range(blkid_probe pr, uint64_t off, uint64_t len)
{
	int rc = hide_buffer(pr, off, len);

	if (rc == 0)
		pr->flags |= BLKID_FL_MODIF_BUFF;
	return rc;
}

/* Small devices need a special care. */
static int blkid_probe_is_tiny(blkid_probe pr)
{
	return (pr->flags & BLKID_FL_TINY_DEV);
}


#ifdef CDROM_GET_CAPABILITY

static int is_sector_readable(int fd, uint64_t sector)
{
	char buf[512];
	ssize_t sz;

	if (blkid_llseek(fd, sector * 512, SEEK_SET) < 0)
		goto failed;

	sz = read(fd, buf, sizeof(buf));
	if (sz != (ssize_t) sizeof(buf))
		goto failed;

	return 1;
failed:
	errno = 0;
	return 0;
}

/* Linux kernel reports (BLKGETSIZE) cdrom device size greater than area
 * readable by read(2). We have to reduce the probing area to avoid unwanted
 * I/O errors in probing functions. It seems that unreadable are always last 2
 * or 3 CD blocks (CD block size is 2048 bytes, it means 12 in 512-byte
 * sectors). */
static void cdrom_size_correction(blkid_probe pr)
{
	uint64_t n, nsectors = pr->size >> 9;

	for (n = nsectors - 12; n < nsectors; n++) {
		if (!is_sector_readable(pr->fd, n))
			goto failed;
	}

	return;
failed:
	/* 'n' is the failed sector, reduce device size to n-1; */
	pr->size = n << 9;
}

#endif

/* Returns: block device number, or 0 for regular files. */
static inline dev_t blkid_probe_get_devno(blkid_probe pr)
{
	return pr->devno;
}

static int get_dm_wholedisk(struct path_cxt *pc, char *diskname,
		size_t len, dev_t *diskdevno)
{
    int rc = 0;
    char *name;

    /* Note, sysfs_blkdev_get_slave() returns the first slave only,
     * if there is more slaves, then return NULL */
    name = sysfs_blkdev_get_slave(pc);
    if (!name)
	return -1;

    if (diskname && len)
	safe_strncpy(diskname, name, len);

    if (diskdevno) {
	*diskdevno = __sysfs_devname_to_devno(ul_path_get_prefix(pc), name, NULL);
	if (!*diskdevno)
	    rc = -1;
    }

    free(name);
    return rc;
}

/* Returns by @diskdevno whole disk device devno and (optionally) by
 * @diskname the whole disk device name. */
static int sysfs_blkdev_get_wholedisk( struct path_cxt *pc,
				char *diskname,
				size_t len,
				dev_t *diskdevno)
{
    int is_part = 0;

    if (!pc)
	return -1;

    is_part = ul_path_access(pc, F_OK, "partition") == 0;
    if (!is_part) {
	/* Extra case for partitions mapped by device-mapper.
	 *
	 * All regular partitions (added by BLKPG ioctl or kernel PT
	 * parser) have the /sys/.../partition file. The partitions
	 * mapped by DM don't have such file, but they have "part"
	 * prefix in DM UUID. */
	char *uuid = NULL, *tmp, *prefix;

	ul_path_read_string(pc, &uuid, "dm/uuid");
	tmp = uuid;
	prefix = uuid ? strsep(&tmp, "-") : NULL;

	if (prefix && strncasecmp(prefix, "part", 4) == 0)
	    is_part = 1;
	free(uuid);

	if (is_part &&
	    get_dm_wholedisk(pc, diskname, len, diskdevno) == 0)
	    /* partitioned device, mapped by DM */
	    goto done;

	is_part = 0;
    }

    if (!is_part) {
	/* unpartitioned device */
	if (diskname && !sysfs_blkdev_get_name(pc, diskname, len))
	    goto err;
	if (diskdevno)
	    *diskdevno = sysfs_blkdev_get_devno(pc);

    } else {
	/* partitioned device
	 *  - readlink /sys/dev/block/8:1   = ../../block/sda/sda1
	 *  - dirname  ../../block/sda/sda1 = ../../block/sda
	 *  - basename ../../block/sda      = sda */
	char linkpath[PATH_MAX];
	char *name;
	ssize_t linklen;

	linklen = ul_path_readlink(pc, linkpath, sizeof(linkpath) - 1, NULL);
	if (linklen < 0)
	    goto err;
	linkpath[linklen] = '\0';

	stripoff_last_component(linkpath);      /* dirname */
	name = stripoff_last_component(linkpath);   /* basename */
	if (!name)
	    goto err;

	sysfs_devname_sys_to_dev(name);
	if (diskname && len)
	    safe_strncpy(diskname, name, len);

	if (diskdevno) {
	    *diskdevno = __sysfs_devname_to_devno(ul_path_get_prefix(pc), name, NULL);
	    if (!*diskdevno)
		goto err;
	}
    }

done:
    return 0;
err:
    return -1;
}

static int sysfs_devno_to_wholedisk(dev_t devno, char *diskname,
			     size_t len, dev_t *diskdevno)
{
	struct path_cxt *pc;
	int rc = 0;

	if (!devno)
		return -EINVAL;
	pc = ul_new_sysfs_path(devno, NULL, NULL);
	if (!pc)
		return -ENOMEM;

	rc = sysfs_blkdev_get_wholedisk(pc, diskname, len, diskdevno);
	ul_unref_path(pc);
	return rc;
}

/** This function uses sysfs to convert the @devno device number to the *name*
 * of the whole disk. The function DOES NOT return full device name. The @dev
 * argument could be partition or whole disk -- both is converted.
 * For example: sda1, 0x0801 --> sda, 0x0800
 * Returns: 0 on success or -1 in case of error. */
static int blkid_devno_to_wholedisk(dev_t dev, char *diskname,
			size_t len, dev_t *diskdevno)
{
	return sysfs_devno_to_wholedisk( dev, diskname, len, diskdevno);
}


/* Returns: device number of the wholedisk, or 0 for regular files. */
static dev_t blkid_probe_get_wholedisk_devno(blkid_probe pr)
{
	if (!pr->disk_devno) {
		dev_t devno, disk_devno = 0;

		devno = blkid_probe_get_devno(pr);
		if (!devno)
			return 0;

		if (blkid_devno_to_wholedisk(devno, NULL, 0, &disk_devno) == 0)
			pr->disk_devno = disk_devno;
	}
	return pr->disk_devno;
}

/* Returns: 1 if the device is whole-disk or 0. */
static int blkid_probe_is_wholedisk(blkid_probe pr)
{
	dev_t devno, disk_devno;

	devno = blkid_probe_get_devno(pr);
	if (!devno)
		return 0;

	disk_devno = blkid_probe_get_wholedisk_devno(pr);
	if (!disk_devno)
		return 0;

	return devno == disk_devno;
}

/* Assigns the device to probe control struct, resets internal buffers and
 * resets the current probing.
 *
 * Returns: -1 in case of failure, or 0 on success. */
static int blkid_probe_set_device(blkid_probe pr, int fd,
		blkid_loff_t off, blkid_loff_t size)
{
	struct stat sb;
	uint64_t devsiz = 0;
	char *dm_uuid = NULL;

	blkid_reset_probe(pr);
	blkid_probe_reset_buffers(pr);

	if ((pr->flags & BLKID_FL_PRIVATE_FD) && pr->fd >= 0)
		close(pr->fd);

	pr->flags &= ~BLKID_FL_PRIVATE_FD;
	pr->flags &= ~BLKID_FL_TINY_DEV;
	pr->flags &= ~BLKID_FL_CDROM_DEV;
	pr->prob_flags = 0;
	pr->fd = fd;
	pr->off = (uint64_t) off;
	pr->size = 0;
	pr->devno = 0;
	pr->disk_devno = 0;
	pr->mode = 0;
	pr->blkssz = 0;
	pr->wipe_off = 0;
	pr->wipe_size = 0;
	pr->wipe_chain = NULL;

#if defined(POSIX_FADV_RANDOM)
	/* Disable read-ahead */
	posix_fadvise(fd, 0, 0, POSIX_FADV_RANDOM);
#endif
	if (fstat(fd, &sb))
		goto err;

	if (!S_ISBLK(sb.st_mode) && !S_ISCHR(sb.st_mode) && !S_ISREG(sb.st_mode)) {
		errno = EINVAL;
		goto err;
	}

	pr->mode = sb.st_mode;
	if (S_ISBLK(sb.st_mode) || S_ISCHR(sb.st_mode))
		pr->devno = sb.st_rdev;

	if (S_ISBLK(sb.st_mode)) {
		if (blkdev_get_size(fd, (unsigned long long *) &devsiz)) {
			goto err;
		}
	} else if (S_ISCHR(sb.st_mode))
		devsiz = 1;             /* UBI devices are char... */
	else if (S_ISREG(sb.st_mode))
		devsiz = sb.st_size;    /* regular file */

	pr->size = size ? (uint64_t)size : devsiz;

	if (off && size == 0)
		/* only offset without size specified */
		pr->size -= (uint64_t) off;

	if (pr->off + pr->size > devsiz) {
		errno = EINVAL;
		goto err;
	}

	if (pr->size <= 1440 * 1024 && !S_ISCHR(sb.st_mode))
		pr->flags |= BLKID_FL_TINY_DEV;

	if (S_ISBLK(sb.st_mode) &&
	    sysfs_devno_is_dm_private(sb.st_rdev, &dm_uuid)) {
		pr->flags |= BLKID_FL_NOSCAN_DEV;
	}

#ifdef CDROM_GET_CAPABILITY
	else if (S_ISBLK(sb.st_mode) &&
	    !blkid_probe_is_tiny(pr) &&
	    !dm_uuid &&
	    blkid_probe_is_wholedisk(pr) &&
	    ioctl(fd, CDROM_GET_CAPABILITY, NULL) >= 0) {

		pr->flags |= BLKID_FL_CDROM_DEV;
		cdrom_size_correction(pr);
	}
#endif
	free(dm_uuid);

	return 0;
err:
	return -1;

}

static int blkid_probe_set_dimension(blkid_probe pr, uint64_t off, uint64_t size)
{
	pr->off = off;
	pr->size = size;
	pr->flags &= ~BLKID_FL_TINY_DEV;

	if (pr->size <= 1440ULL * 1024ULL && !S_ISCHR(pr->mode))
		pr->flags |= BLKID_FL_TINY_DEV;

	blkid_probe_reset_buffers(pr);
	return 0;
}

/* Check for matching magic value.
 * Returns BLKID_PROBE_OK if found, BLKID_PROBE_NONE if not found
 * or no magic present, or negative value on error. */
static int blkid_probe_get_idmag(blkid_probe pr, const struct blkid_idinfo *id,
			uint64_t *offset, const struct blkid_idmag **res)
{
	const struct blkid_idmag *mag = NULL;
	uint64_t off = 0;

	if (id)
		mag = &id->magics[0];
	if (res)
		*res = NULL;

	/* try to detect by magic string */
	while(mag && mag->magic) {
		unsigned char *buf;

		off = (mag->kboff + (mag->sboff >> 10)) << 10;
		buf = blkid_probe_get_buffer(pr, off, 1024);

		if (!buf && errno)
			return -errno;

		if (buf && !memcmp(mag->magic,
				buf + (mag->sboff & 0x3ff), mag->len)) {

			if (offset)
				*offset = off + (mag->sboff & 0x3ff);
			if (res)
				*res = mag;
			return BLKID_PROBE_OK;
		}
		mag++;
	}

	if (id && id->magics[0].magic)
		/* magic string(s) defined, but not found */
		return BLKID_PROBE_NONE;

	return BLKID_PROBE_OK;
}

static inline void blkid_probe_start(blkid_probe pr)
{
	pr->cur_chain = NULL;
	pr->prob_flags = 0;
	blkid_probe_set_wiper(pr, 0, 0);
}

static inline void blkid_probe_end(blkid_probe pr)
{
	pr->cur_chain = NULL;
	pr->prob_flags = 0;
	blkid_probe_set_wiper(pr, 0, 0);
}

/* Calls probing functions in all enabled chains. The superblocks chain is
 * enabled by default. The blkid_do_probe() stores result from only one
 * probing function. It's necessary to call this routine in a loop to get
 * results from all probing functions in all chains. The probing is reset
 * by blkid_reset_probe() or by filter functions.
 *
 * This is string-based NAME=value interface only.
 *
 * Returns: 0 on success, 1 when probing is done and -1 in case of error. */
static int blkid_do_probe(blkid_probe pr)
{
	int rc = 1;

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return 1;

	do {
		struct blkid_chain *chn = pr->cur_chain;

		if (!chn) {
			blkid_probe_start(pr);
			chn = pr->cur_chain = &pr->chains[0];
		}
		/* we go to the next chain only when the previous probing
		 * result was nothing (rc == 1) and when the current chain is
		 * disabled or we are at end of the current chain (chain->idx +
		 * 1 == sizeof chain) or the current chain bailed out right at
		 * the start (chain->idx == -1) */
		else if (rc == 1 && (chn->enabled == FALSE ||
				     chn->idx + 1 == (int) chn->driver->nidinfos ||
				     chn->idx == -1)) {

			size_t idx = chn->driver->id + 1;

			if (idx < BLKID_NCHAINS)
				chn = pr->cur_chain = &pr->chains[idx];
			else {
				blkid_probe_end(pr);
				return 1;       /* all chains already probed */
			}
		}

		chn->binary = FALSE;            /* for sure... */

		if (!chn->enabled)
			continue;

		/* rc: -1 = error, 0 = success, 1 = no result */
		rc = chn->driver->probe(pr, chn);

	} while (rc == 1);

	return rc;
}

/* file descriptor for assigned device/file */
static inline int blkid_probe_get_fd(blkid_probe pr)
{
	return pr->fd;
}

static struct blkid_prval *__blkid_probe_lookup_value(blkid_probe pr, const char *name)
{
	struct list_head *p;

	if (list_empty(&pr->values))
		return NULL;

	list_for_each(p, &pr->values) {
		struct blkid_prval *v = list_entry(p, struct blkid_prval,
						prvals);

		if (v->name && strcmp(name, v->name) == 0)
			return v;
	}
	return NULL;
}

/* Note, the @len returns length of the @data, including the terminating
 * '\0' character.
 * Returns: 0 on success, or -1 in case of error. */
static int blkid_probe_lookup_value(blkid_probe pr, const char *name,
			const char **data, size_t *len)
{
	struct blkid_prval *v = __blkid_probe_lookup_value(pr, name);

	if (!v)
		return -1;
	if (data)
		*data = (char *) v->data;
	if (len)
		*len = v->len;
	return 0;
}

/* This function move pointer to the probing chain one step back -- it means
 * that the previously used probing function will be called again in the next
 * blkid_do_probe() call.
 *
 * This is necessary for example if you erase or modify on-disk superblock
 * according to the current libblkid probing result.
 *
 * Note that blkid_probe_hide_range() changes semantic of this function and
 * cached bufferes are not reset, but library uses in-memory modified
 * buffers to call the next probing function.
 *
 * Returns: 0 on success, and -1 in case of error. */
static int blkid_probe_step_back(blkid_probe pr)
{
	struct blkid_chain *chn;

	chn = pr->cur_chain;
	if (!chn)
		return -1;

	if (!(pr->flags & BLKID_FL_MODIF_BUFF))
		blkid_probe_reset_buffers(pr);

	if (chn->idx >= 0)
		chn->idx--;

	if (chn->idx == -1) {
		/* blkid_do_probe() goes to the next chain if the index
		 * of the current chain is -1, so we have to set the
		 * chain pointer to the previous chain. */
		size_t idx = chn->driver->id > 0 ? chn->driver->id - 1 : 0;

		if (idx > 0)
			pr->cur_chain = &pr->chains[idx];
		else if (idx == 0)
			pr->cur_chain = NULL;
	}

	return 0;
}

/* @dryrun: if TRUE then don't touch the device.
 *
 * This function erases the current signature detected by @pr. The @pr has to
 * be open in O_RDWR mode, BLKID_SUBLKS_MAGIC or/and BLKID_PARTS_MAGIC flags
 * has to be enabled (if you want to erase also superblock with broken check
 * sums then use BLKID_SUBLKS_BADCSUM too).
 *
 * After successful signature removing the @pr prober will be moved one step
 * back and the next blkid_do_probe() call will again call previously called
 * probing function. All in-memory cached data from the device are always
 * reset.
 *
 * Returns: 0 on success, and -1 in case of error. */
static int blkid_do_wipe(blkid_probe pr, int dryrun)
{
	const char *off = NULL;
	size_t len = 0;
	uint64_t offset, magoff, l;
	char buf[BUFSIZ];
	int fd, rc = 0;
	struct blkid_chain *chn;

	chn = pr->cur_chain;
	if (!chn)
		return -1;

	switch (chn->driver->id) {
	case BLKID_CHAIN_SUBLKS:
		rc = blkid_probe_lookup_value(pr, "SBMAGIC_OFFSET", &off, NULL);
		if (!rc)
			rc = blkid_probe_lookup_value(pr, "SBMAGIC", NULL, &len);
		break;
	case BLKID_CHAIN_PARTS:
		rc = blkid_probe_lookup_value(pr, "PTMAGIC_OFFSET", &off, NULL);
		if (!rc)
			rc = blkid_probe_lookup_value(pr, "PTMAGIC", NULL, &len);
		break;
	default:
		return 0;
	}

	if (rc || len == 0 || off == NULL)
		return 0;

	magoff = strtoumax(off, NULL, 10);
	offset = magoff + pr->off;
	fd = blkid_probe_get_fd(pr);
	if (fd < 0)
		return -1;

	if (len > sizeof(buf))
		len = sizeof(buf);

	l = blkid_llseek(fd, offset, SEEK_SET);
	if ((blkid_loff_t)l == (off_t) -1)
		return -1;

	memset(buf, 0, len);

	if (!dryrun && len) {
		/* wipen on device */
		if (write_all(fd, buf, len))
			return -1;
		fsync(fd);
		pr->flags &= ~BLKID_FL_MODIF_BUFF;      /* be paranoid */

		return blkid_probe_step_back(pr);

	} else if (dryrun) {
		/* wipe in memory only */
		blkid_probe_hide_range(pr, magoff, len);
		return blkid_probe_step_back(pr);
	}

	return 0;
}


/* This function gathers probing results from all enabled chains.
 *
 * This is string-based NAME=value interface only.
 *
 * Returns: 0 on success, 1 if nothing is detected or -1 on case of error. */
static int blkid_do_fullprobe(blkid_probe pr)
{
	int i, count = 0, rc = 0;

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return 1;

	blkid_probe_start(pr);

	for (i = 0; i < BLKID_NCHAINS; i++) {
		struct blkid_chain *chn;

		chn = pr->cur_chain = &pr->chains[i];
		chn->binary = FALSE;            /* for sure... */

		if (!chn->enabled)
			continue;

		blkid_probe_chain_reset_position(chn);

		rc = chn->driver->probe(pr, chn);

		blkid_probe_chain_reset_position(chn);

		/* rc: -1 = error, 0 = success, 1 = no result */
		if (rc < 0)
			goto done;      /* error */
		if (rc == 0)
			count++;        /* success */
	}

done:
	blkid_probe_end(pr);
	if (rc < 0)
		return rc;
	return count ? 0 : 1;
}

/* same sa blkid_probe_get_buffer() but works with 512-sectors */
static unsigned char *blkid_probe_get_sector(blkid_probe pr, unsigned int sector)
{
	return blkid_probe_get_buffer(pr, ((uint64_t) sector) << 9, 0x200);
}


static int blkid_probe_verify_csum(blkid_probe pr, uint64_t csum, uint64_t expected)
{
	if (csum != expected) {
		struct blkid_chain *chn = blkid_probe_get_chain(pr);

		/* Accept bad checksum if BLKID_SUBLKS_BADCSUM flags is set */
		if (chn->driver->id == BLKID_CHAIN_SUBLKS
		    && (chn->flags & BLKID_SUBLKS_BADCSUM)) {
			blkid_probe_set_value(pr, "SBBADCSUM", (unsigned char *) "1", 2);
			goto accept;
		}
		return 0;       /* bad checksum */
	}

accept:
	return 1;
}

/* This function returns size of probing area as defined by blkid_probe_set_device().
 * If the size of the probing area is unrestricted then this function returns
 * the real size of device. */
static inline blkid_loff_t blkid_probe_get_size(blkid_probe pr)
{
	return (blkid_loff_t) pr->size;
}


/* Returns: block device logical sector size (BLKSSZGET ioctl, default 512). */
static unsigned int blkid_probe_get_sectorsize(blkid_probe pr)
{
	if (pr->blkssz)
		return pr->blkssz;

	if (S_ISBLK(pr->mode) &&
	    blkdev_get_sector_size(pr->fd, (int *) &pr->blkssz) == 0)
		return pr->blkssz;

	pr->blkssz = DEFAULT_SECTOR_SIZE;
	return pr->blkssz;
}

/* converts DCE UUID (uuid[16]) to human readable string
 * - the @len should be always 37 */
static void blkid_unparse_uuid(const unsigned char *uuid, char *str,
			size_t len __attribute__((__unused__)))
{
	uuid_unparse(uuid, str);
}


/* Removes whitespace from the left-hand side of a string.
 *
 * Returns size of the new string (without \0). */
static size_t blkid_ltrim_whitespace(unsigned char *str)
{
	return ltrim_whitespace(str);
}

/* Returns 1 if the <@off,@size> area was wiped */
static int blkid_probe_is_wiped(blkid_probe pr, struct blkid_chain **chn, uint64_t off, uint64_t size)
{
	if (!size)
		return 0;

	if (pr->wipe_off <= off && off + size <= pr->wipe_off + pr->wipe_size) {
		*chn = pr->wipe_chain;
		return 1;
	}
	return 0;
}

/* Try to use any area -- if the area has been previously wiped then the
 *  previous probing result should be ignored (reset). */
static void blkid_probe_use_wiper(blkid_probe pr, uint64_t off, uint64_t size)
{
	struct blkid_chain *chn = NULL;

	if (blkid_probe_is_wiped(pr, &chn, off, size) && chn) {
		blkid_probe_set_wiper(pr, 0, 0);
		blkid_probe_chain_reset_values(pr, chn);
	}
}

/* default _set_uuid function to set DCE UUIDs */
static int blkid_probe_set_uuid_as(blkid_probe pr, const unsigned char *uuid, const char *name)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;
	int rc = 0;

	if (blkid_uuid_is_empty(uuid, 16))
		return 0;

	if (!name) {
		if ((chn->flags & BLKID_SUBLKS_UUIDRAW))
			blkid_probe_set_value(pr, "UUID_RAW", uuid, 16);

		if (!(chn->flags & BLKID_SUBLKS_UUID))
			return 0;

		v = blkid_probe_assign_value(pr, "UUID");
	} else
		v = blkid_probe_assign_value(pr, name);

	v->len = UUID_STR_LEN;
	v->data = zmalloc(v->len);
	if (!rc) {
		blkid_unparse_uuid(uuid, (char *) v->data, v->len);
		return 0;
	}

	blkid_probe_free_value(v);
	return rc;
}

static int blkid_probe_set_uuid(blkid_probe pr, const unsigned char *uuid)
{
	return blkid_probe_set_uuid_as(pr, uuid, NULL);
}


struct minix_inode {
	uint16_t i_mode;
	uint16_t i_uid;
	uint32_t i_size;
	uint32_t i_time;
	uint8_t  i_gid;
	uint8_t  i_nlinks;
	uint16_t i_zone[9];
};

struct minix2_inode {
	uint16_t i_mode;
	uint16_t i_nlinks;
	uint16_t i_uid;
	uint16_t i_gid;
	uint32_t i_size;
	uint32_t i_atime;
	uint32_t i_mtime;
	uint32_t i_ctime;
	uint32_t i_zone[10];
};

struct minix_super_block {
	uint16_t s_ninodes;
	uint16_t s_nzones;
	uint16_t s_imap_blocks;
	uint16_t s_zmap_blocks;
	uint16_t s_firstdatazone;
	uint16_t s_log_zone_size;
	uint32_t s_max_size;
	uint16_t s_magic;
	uint16_t s_state;
	uint32_t s_zones;
};

/* V3 minix super-block data on disk */
struct minix3_super_block {
	uint32_t s_ninodes;
	uint16_t s_pad0;
	uint16_t s_imap_blocks;
	uint16_t s_zmap_blocks;
	uint16_t s_firstdatazone;
	uint16_t s_log_zone_size;
	uint16_t s_pad1;
	uint32_t s_max_size;
	uint32_t s_zones;
	uint16_t s_magic;
	uint16_t s_pad2;
	uint16_t s_blocksize;
	uint8_t  s_disk_version;
};

/* Minix subpartitions are always within primary dos partition. */
#define MINIX_MAXPARTITIONS  4

#define MINIX_BLOCK_SIZE_BITS 10
#define MINIX_BLOCK_SIZE     (1 << MINIX_BLOCK_SIZE_BITS)

#define MINIX_NAME_MAX       255             /* # chars in a file name */
#define MINIX_MAX_INODES     65535

#define MINIX_INODES_PER_BLOCK ((MINIX_BLOCK_SIZE)/(sizeof (struct minix_inode)))
#define MINIX2_INODES_PER_BLOCK ((MINIX_BLOCK_SIZE)/(sizeof (struct minix2_inode)))

/* minix_super_block.s_state */
#define MINIX_VALID_FS       0x0001          /* Clean fs. */
#define MINIX_ERROR_FS       0x0002          /* fs has errors. */


#define MINIX_SUPER_MAGIC    0x137F          /* minix V1 fs, 14 char names */
#define MINIX_SUPER_MAGIC2   0x138F          /* minix V1 fs, 30 char names */

#define MINIX2_SUPER_MAGIC   0x2468          /* minix V2 fs, 14 char names */
#define MINIX2_SUPER_MAGIC2  0x2478          /* minix V2 fs, 30 char names */

#define MINIX3_SUPER_MAGIC   0x4d5a          /* minix V3 fs (60 char names) */


#define minix_swab16(doit, num) ((uint16_t) (doit ? swab16(num) : num))
#define minix_swab32(doit, num) ((uint32_t) (doit ? swab32(num) : num))

static int get_minix_version(const unsigned char *data, int *other_endian)
{
	const struct minix_super_block *sb = (const struct minix_super_block *) data;
	const struct minix3_super_block *sb3 = (const struct minix3_super_block *) data;
	int version = 0;

	*other_endian = 0;

	switch (sb->s_magic) {
	case MINIX_SUPER_MAGIC:
	case MINIX_SUPER_MAGIC2:
		version = 1;
		break;
	case MINIX2_SUPER_MAGIC:
	case MINIX2_SUPER_MAGIC2:
		version = 2;
		break;
	default:
		if (sb3->s_magic == MINIX3_SUPER_MAGIC)
			version = 3;
		break;
	}

	if (!version) {
		*other_endian = 1;

		switch (swab16(sb->s_magic)) {
		case MINIX_SUPER_MAGIC:
		case MINIX_SUPER_MAGIC2:
			version = 1;
			break;
		case MINIX2_SUPER_MAGIC:
		case MINIX2_SUPER_MAGIC2:
			version = 2;
			break;
		default:
			if (sb3->s_magic == MINIX3_SUPER_MAGIC)
				version = 3;
			break;
		}
	}
	if (!version)
		return -1;

	return version;
}

static int probe_minix(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	unsigned char *ext;
	const unsigned char *data;
	int version = 0, swabme = 0;
	unsigned long zones, ninodes, imaps, zmaps;
	off_t firstz;
	size_t zone_size;

	data = blkid_probe_get_buffer(pr, 1024,
			max(sizeof(struct minix_super_block),
			    sizeof(struct minix3_super_block)));
	if (!data)
		return errno ? -errno : 1;
	version = get_minix_version(data, &swabme);
	switch (version) {
	case 1:
	case 2: {
		const struct minix_super_block *sb = (const struct minix_super_block *) data;

		uint16_t state = minix_swab16(swabme, sb->s_state);
		if ((state & (MINIX_VALID_FS | MINIX_ERROR_FS)) != state)
			return 1;

		zones = version == 2 ? minix_swab32(swabme, sb->s_zones) :
				       minix_swab16(swabme, sb->s_nzones);
		ninodes = minix_swab16(swabme, sb->s_ninodes);
		imaps   = minix_swab16(swabme, sb->s_imap_blocks);
		zmaps   = minix_swab16(swabme, sb->s_zmap_blocks);
		firstz  = minix_swab16(swabme, sb->s_firstdatazone);
		zone_size = sb->s_log_zone_size;
		break;
	}
	case 3: {
		const struct minix3_super_block *sb = (const struct minix3_super_block *) data;

		zones = minix_swab32(swabme, sb->s_zones);
		ninodes = minix_swab32(swabme, sb->s_ninodes);
		imaps   = minix_swab16(swabme, sb->s_imap_blocks);
		zmaps   = minix_swab16(swabme, sb->s_zmap_blocks);
		firstz  = minix_swab16(swabme, sb->s_firstdatazone);
		zone_size = sb->s_log_zone_size;
		break;
	}
	default:
		return 1;
	}

	/* sanity checks to be sure that the FS is really minix.
	 * see disk-utils/fsck.minix.c read_superblock */
	if (zone_size != 0 || ninodes == 0 || ninodes == UINT32_MAX)
		return 1;
	if (imaps * MINIX_BLOCK_SIZE * 8 < ninodes + 1)
		return 1;
	if (firstz > (off_t) zones)
		return 1;
	if (zmaps * MINIX_BLOCK_SIZE * 8 < zones - firstz + 1)
		return 1;

	/* unfortunately, some parts of ext3 is sometimes possible to
	 * interpreted as minix superblock. So check for extN magic
	 * string. (For extN magic string and offsets see ext.c.) */
	ext = blkid_probe_get_buffer(pr, 0x400 + 0x38, 2);
	if (!ext)
		return errno ? -errno : 1;
	else if (memcmp(ext, "\123\357", 2) == 0)
		return 1;

	blkid_probe_sprintf_version(pr, "%d", version);
	return 0;
}

static const struct blkid_idinfo minix_idinfo =
{
	.name           = "minix",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_minix,
	.magics         =
	{
		/* version 1 - LE */
		{ .magic = "\177\023", .len = 2, .kboff = 1, .sboff = 0x10 },
		{ .magic = "\217\023", .len = 2, .kboff = 1, .sboff = 0x10 },

		/* version 1 - BE */
		{ .magic = "\023\177", .len = 2, .kboff = 1, .sboff = 0x10 },
		{ .magic = "\023\217", .len = 2, .kboff = 1, .sboff = 0x10 },

		/* version 2 - LE */
		{ .magic = "\150\044", .len = 2, .kboff = 1, .sboff = 0x10 },
		{ .magic = "\170\044", .len = 2, .kboff = 1, .sboff = 0x10 },

		/* version 2 - BE */
		{ .magic = "\044\150", .len = 2, .kboff = 1, .sboff = 0x10 },
		{ .magic = "\044\170", .len = 2, .kboff = 1, .sboff = 0x10 },

		/* version 3 - LE */
		{ .magic = "\132\115", .len = 2, .kboff = 1, .sboff = 0x18 },

		/* version 3 - BE */
		{ .magic = "\115\132", .len = 2, .kboff = 1, .sboff = 0x18 },

		{ NULL }
	}
};

struct nilfs_super_block {
	uint32_t        s_rev_level;
	uint16_t        s_minor_rev_level;
	uint16_t        s_magic;

	uint16_t        s_bytes;

	uint16_t        s_flags;
	uint32_t        s_crc_seed;
	uint32_t        s_sum;

	uint32_t        s_log_block_size;

	uint64_t        s_nsegments;
	uint64_t        s_dev_size;
	uint64_t        s_first_data_block;
	uint32_t        s_blocks_per_segment;
	uint32_t        s_r_segments_percentage;

	uint64_t        s_last_cno;
	uint64_t        s_last_pseg;
	uint64_t        s_last_seq;
	uint64_t        s_free_blocks_count;

	uint64_t        s_ctime;

	uint64_t        s_mtime;
	uint64_t        s_wtime;
	uint16_t        s_mnt_count;
	uint16_t        s_max_mnt_count;
	uint16_t        s_state;
	uint16_t        s_errors;
	uint64_t        s_lastcheck;

	uint32_t        s_checkinterval;
	uint32_t        s_creator_os;
	uint16_t        s_def_resuid;
	uint16_t        s_def_resgid;
	uint32_t        s_first_ino;

	uint16_t        s_inode_size;
	uint16_t        s_dat_entry_size;
	uint16_t        s_checkpoint_size;
	uint16_t        s_segment_usage_size;

	uint8_t         s_uuid[16];
	char            s_volume_name[80];

	uint32_t        s_c_interval;
	uint32_t        s_c_block_max;
	uint32_t        s_reserved[192];
};

#define NILFS_SB_MAGIC          0x3434
#define NILFS_SB_OFFSET         0x400
#define NILFS_SBB_OFFSET(_sz)   ((((_sz) / 0x200) - 8) * 0x200)

static int nilfs_valid_sb(blkid_probe pr, struct nilfs_super_block *sb, int is_bak)
{
	const int sumoff = offsetof(struct nilfs_super_block, s_sum);
	size_t bytes;
	const size_t crc_start = sumoff + 4;
	uint32_t crc;

	if (!sb || le16_to_cpu(sb->s_magic) != NILFS_SB_MAGIC)
		return 0;

	if (is_bak && blkid_probe_is_wholedisk(pr) &&
	    sb->s_dev_size != pr->size)
		return 0;

	bytes = le16_to_cpu(sb->s_bytes);
	/* ensure that no underrun can happen in the length parameter
	 * of the crc32 call or more data are processed than read into
	 * sb */
	if (bytes < crc_start || bytes > sizeof(struct nilfs_super_block))
		return 0;

	crc = ul_crc32(le32_to_cpu(sb->s_crc_seed), (unsigned char *)sb, sumoff);
	crc = ul_crc32(crc, nilfs_valid_sb_sum, 4);
	crc = ul_crc32(crc, (unsigned char *)sb + crc_start, bytes - crc_start);

	return blkid_probe_verify_csum(pr, crc, le32_to_cpu(sb->s_sum));
}

static int probe_nilfs2(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct nilfs_super_block *sb, *sbp, *sbb;
	int valid[2], swp = 0;
	uint64_t magoff;

	/* primary */
	sbp = (struct nilfs_super_block *) blkid_probe_get_buffer(
			pr, NILFS_SB_OFFSET, sizeof(struct nilfs_super_block));
	if (!sbp)
		return errno ? -errno : 1;

	valid[0] = nilfs_valid_sb(pr, sbp, 0);


	/* backup */
	sbb = (struct nilfs_super_block *) blkid_probe_get_buffer(
			pr, NILFS_SBB_OFFSET(pr->size), sizeof(struct nilfs_super_block));
	if (!sbb) {
		valid[1] = 0;

		/* If the primary block is valid then continue and ignore also
		 * I/O errors for backup block. Note the this is probably CD
		 * where I/O errors and the end of the disk/session are "normal". */
		if (!valid[0])
			return errno ? -errno : 1;
	} else
		valid[1] = nilfs_valid_sb(pr, sbb, 1);


	/* Compare two super blocks and set 1 in swp if the secondary
	 * super block is valid and newer.  Otherwise, set 0 in swp. */
	if (!valid[0] && !valid[1])
		return 1;

	swp = valid[1] && (!valid[0] ||
			   le64_to_cpu(sbp->s_last_cno) >
			   le64_to_cpu(sbb->s_last_cno));
	sb = swp ? sbb : sbp;

	if (*(sb->s_volume_name) != '\0')
		blkid_probe_set_label(pr, (unsigned char *) sb->s_volume_name,
				      sizeof(sb->s_volume_name));

	blkid_probe_set_uuid(pr, sb->s_uuid);
	blkid_probe_sprintf_version(pr, "%u", le32_to_cpu(sb->s_rev_level));

	magoff = swp ? NILFS_SBB_OFFSET(pr->size) : NILFS_SB_OFFSET;
	magoff += offsetof(struct nilfs_super_block, s_magic);

	if (blkid_probe_set_magic(pr, magoff, sizeof(sb->s_magic),
				(unsigned char *) &sb->s_magic))
		return 1;

	return 0;
}

static void blkid_probe_set_utf8label(blkid_probe pr, const unsigned char *label,
				size_t len, int enc)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if ((chn->flags & BLKID_SUBLKS_LABELRAW))
	    blkid_probe_set_value(pr, "LABEL_RAW", label, len);

	if (!(chn->flags & BLKID_SUBLKS_LABEL))
		return;

	v = blkid_probe_assign_value(pr, "LABEL");
	v->data = blkid_encode_alloc(len, &v->len);
	blkid_encode_to_utf8(enc, v->data, v->len, label, len);
	v->len = rtrim_whitespace(v->data) + 1;
	if (v->len > 1)
		return;
	blkid_probe_free_value(v);
}

static const struct blkid_idinfo nilfs2_idinfo =
{
	.name           = "nilfs2",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_nilfs2,
	/* default min.size is 128MiB, but 1MiB for "mkfs.nilfs2 -b 1024 -B 16" */
	.minsz          = (1024 * 1024),
	.magics         = BLKID_NONE_MAGIC
};

struct ntfs_bios_parameters {
	uint16_t        sector_size;    /* Size of a sector in bytes. */
	uint8_t         sectors_per_cluster;    /* Size of a cluster in sectors. */
	uint16_t        reserved_sectors;       /* zero */
	uint8_t         fats;                   /* zero */
	uint16_t        root_entries;           /* zero */
	uint16_t        sectors;                /* zero */
	uint8_t         media_type;             /* 0xf8 = hard disk */
	uint16_t        sectors_per_fat;        /* zero */
	uint16_t        sectors_per_track;      /* irrelevant */
	uint16_t        heads;                  /* irrelevant */
	uint32_t        hidden_sectors;         /* zero */
	uint32_t        large_sectors;          /* zero */
} __attribute__ ((__packed__));

struct ntfs_super_block {
	uint8_t         jump[3];
	uint8_t         oem_id[8];      /* magic string */

	struct ntfs_bios_parameters     bpb;

	uint16_t        unused[2];
	uint64_t        number_of_sectors;
	uint64_t        mft_cluster_location;
	uint64_t        mft_mirror_cluster_location;
	int8_t          clusters_per_mft_record;
	uint8_t         reserved1[3];
	int8_t          cluster_per_index_record;
	uint8_t         reserved2[3];
	uint64_t        volume_serial;
	uint32_t        checksum;
} __attribute__((packed));

struct master_file_table_record {
	uint32_t        magic;
	uint16_t        usa_ofs;
	uint16_t        usa_count;
	uint64_t        lsn;
	uint16_t        sequence_number;
	uint16_t        link_count;
	uint16_t        attrs_offset;
	uint16_t        flags;
	uint32_t        bytes_in_use;
	uint32_t        bytes_allocated;
} __attribute__((__packed__));

struct file_attribute {
	uint32_t        type;
	uint32_t        len;
	uint8_t         non_resident;
	uint8_t         name_len;
	uint16_t        name_offset;
	uint16_t        flags;
	uint16_t        instance;
	uint32_t        value_len;
	uint16_t        value_offset;
} __attribute__((__packed__));

#define MFT_RECORD_VOLUME       3
/* Windows 10 Creators edition has extended the cluster size limit to 2MB */
#define NTFS_MAX_CLUSTER_SIZE   (2 * 1024 * 1024)

#define MFT_RECORD_ATTR_VOLUME_NAME     0x60
#define MFT_RECORD_ATTR_END             0xffffffff

static int probe_ntfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct ntfs_super_block *ns;
	struct master_file_table_record *mft;

	uint32_t sectors_per_cluster, mft_record_size;
	uint16_t sector_size;
	uint64_t nr_clusters, off, attr_off;
	unsigned char *buf_mft;

	ns = blkid_probe_get_sb(pr, mag, struct ntfs_super_block);
	if (!ns)
		return errno ? -errno : 1;

	/* Check bios parameters block */
	sector_size = le16_to_cpu(ns->bpb.sector_size);

	if (sector_size < 256 || sector_size > 4096)
		return 1;

	switch (ns->bpb.sectors_per_cluster) {
	case 1: case 2: case 4: case 8: case 16: case 32: case 64: case 128:
		sectors_per_cluster = ns->bpb.sectors_per_cluster;
		break;
	default:
		if ((ns->bpb.sectors_per_cluster < 240)
		    || (ns->bpb.sectors_per_cluster > 249))
			return 1;
		sectors_per_cluster = 1 << (256 - ns->bpb.sectors_per_cluster);
	}

	if ((uint16_t) le16_to_cpu(ns->bpb.sector_size) *
			sectors_per_cluster > NTFS_MAX_CLUSTER_SIZE)
		return 1;

	/* Unused fields must be zero */
	if (le16_to_cpu(ns->bpb.reserved_sectors)
	    || le16_to_cpu(ns->bpb.root_entries)
	    || le16_to_cpu(ns->bpb.sectors)
	    || le16_to_cpu(ns->bpb.sectors_per_fat)
	    || le32_to_cpu(ns->bpb.large_sectors)
	    || ns->bpb.fats)
		return 1;

	if ((uint8_t) ns->clusters_per_mft_record < 0xe1
	    || (uint8_t) ns->clusters_per_mft_record > 0xf7) {

		switch (ns->clusters_per_mft_record) {
		case 1: case 2: case 4: case 8: case 16: case 32: case 64:
			break;
		default:
			return 1;
		}
	}

	if (ns->clusters_per_mft_record > 0)
		mft_record_size = ns->clusters_per_mft_record *
				  sectors_per_cluster * sector_size;
	else
		mft_record_size = 1 << (0 - ns->clusters_per_mft_record);

	nr_clusters = le64_to_cpu(ns->number_of_sectors) / sectors_per_cluster;

	if ((le64_to_cpu(ns->mft_cluster_location) > nr_clusters) ||
	    (le64_to_cpu(ns->mft_mirror_cluster_location) > nr_clusters))
		return 1;


	off = le64_to_cpu(ns->mft_cluster_location) * sector_size *
		sectors_per_cluster;

	buf_mft = blkid_probe_get_buffer(pr, off, mft_record_size);
	if (!buf_mft)
		return errno ? -errno : 1;

	if (memcmp(buf_mft, "FILE", 4))
		return 1;

	off += MFT_RECORD_VOLUME * mft_record_size;

	buf_mft = blkid_probe_get_buffer(pr, off, mft_record_size);
	if (!buf_mft)
		return errno ? -errno : 1;

	if (memcmp(buf_mft, "FILE", 4))
		return 1;

	mft = (struct master_file_table_record *) buf_mft;
	attr_off = le16_to_cpu(mft->attrs_offset);

	while (attr_off + sizeof(struct file_attribute) <= mft_record_size &&
	       attr_off <= le32_to_cpu(mft->bytes_allocated)) {

		uint32_t attr_len;
		struct file_attribute *attr;

		attr = (struct file_attribute *) (buf_mft + attr_off);
		attr_len = le32_to_cpu(attr->len);
		if (!attr_len)
			break;

		if (le32_to_cpu(attr->type) == (uint32_t) MFT_RECORD_ATTR_END)
			break;
		if (le32_to_cpu(attr->type) == (uint32_t) MFT_RECORD_ATTR_VOLUME_NAME) {
			unsigned int val_off = le16_to_cpu(attr->value_offset);
			unsigned int val_len = le32_to_cpu(attr->value_len);
			unsigned char *val = ((uint8_t *) attr) + val_off;

			if (attr_off + val_off + val_len <= mft_record_size)
				blkid_probe_set_utf8label(pr, val, val_len,
							  BLKID_ENC_UTF16LE);
			break;
		}

		attr_off += attr_len;
	}

	blkid_probe_sprintf_uuid(pr,
			(unsigned char *) &ns->volume_serial,
			sizeof(ns->volume_serial),
			"%016" PRIX64, le64_to_cpu(ns->volume_serial));
	return 0;
}


static const struct blkid_idinfo ntfs_idinfo =
{
	.name           = "ntfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ntfs,
	.magics         =
	{
		{ .magic = "NTFS    ", .len = 8, .sboff = 3 },
		{ NULL }
	}
};

struct hpt45x_metadata {
	uint32_t        magic;
};

#define HPT45X_MAGIC_OK                 0x5a7816f3
#define HPT45X_MAGIC_BAD                0x5a7816fd

static int probe_highpoint45x(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct hpt45x_metadata *hpt;
	uint64_t off;
	uint32_t magic;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200) - 11) * 0x200;
	hpt = (struct hpt45x_metadata *)
			blkid_probe_get_buffer(pr,
					off,
					sizeof(struct hpt45x_metadata));
	if (!hpt)
		return errno ? -errno : 1;
	magic = le32_to_cpu(hpt->magic);
	if (magic != HPT45X_MAGIC_OK && magic != HPT45X_MAGIC_BAD)
		return 1;
	if (blkid_probe_set_magic(pr, off, sizeof(hpt->magic),
				(unsigned char *) &hpt->magic))
		return 1;
	return 0;
}

static int probe_highpoint37x(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;
	return 0;
}


static const struct blkid_idinfo highpoint45x_idinfo = {
	.name           = "hpt45x_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_highpoint45x,
	.magics         = BLKID_NONE_MAGIC
};

static const struct blkid_idinfo highpoint37x_idinfo = {
	.name           = "hpt37x_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_highpoint37x,
	.magics         = {
		/* Superblock offset:                     4608 bytes  (9 sectors)
		 * Magic string offset within superblock:   32 bytes
		 *
		 * kboff = (4608 + 32) / 1024
		 * sboff = (4608 + 32) % kboff */
		{ .magic = "\xf0\x16\x78\x5a", .len = 4, .kboff = 4, .sboff = 544 },
		{ .magic = "\xfd\x16\x78\x5a", .len = 4, .kboff = 4, .sboff = 544 },
		{ NULL }
	}
};

struct ext2_super_block {
	uint32_t                s_inodes_count;
	uint32_t                s_blocks_count;
	uint32_t                s_r_blocks_count;
	uint32_t                s_free_blocks_count;
	uint32_t                s_free_inodes_count;
	uint32_t                s_first_data_block;
	uint32_t                s_log_block_size;
	uint32_t                s_dummy3[7];
	unsigned char           s_magic[2];
	uint16_t                s_state;
	uint16_t                s_errors;
	uint16_t                s_minor_rev_level;
	uint32_t                s_lastcheck;
	uint32_t                s_checkinterval;
	uint32_t                s_creator_os;
	uint32_t                s_rev_level;
	uint16_t                s_def_resuid;
	uint16_t                s_def_resgid;
	uint32_t                s_first_ino;
	uint16_t                s_inode_size;
	uint16_t                s_block_group_nr;
	uint32_t                s_feature_compat;
	uint32_t                s_feature_incompat;
	uint32_t                s_feature_ro_compat;
	unsigned char           s_uuid[16];
	char                    s_volume_name[16];
	char                    s_last_mounted[64];
	uint32_t                s_algorithm_usage_bitmap;
	uint8_t                 s_prealloc_blocks;
	uint8_t                 s_prealloc_dir_blocks;
	uint16_t                s_reserved_gdt_blocks;
	uint8_t                 s_journal_uuid[16];
	uint32_t                s_journal_inum;
	uint32_t                s_journal_dev;
	uint32_t                s_last_orphan;
	uint32_t                s_hash_seed[4];
	uint8_t                 s_def_hash_version;
	uint8_t                 s_jnl_backup_type;
	uint16_t                s_reserved_word_pad;
	uint32_t                s_default_mount_opts;
	uint32_t                s_first_meta_bg;
	uint32_t                s_mkfs_time;
	uint32_t                s_jnl_blocks[17];
	uint32_t                s_blocks_count_hi;
	uint32_t                s_r_blocks_count_hi;
	uint32_t                s_free_blocks_hi;
	uint16_t                s_min_extra_isize;
	uint16_t                s_want_extra_isize;
	uint32_t                s_flags;
	uint16_t                s_raid_stride;
	uint16_t                s_mmp_interval;
	uint64_t                s_mmp_block;
	uint32_t                s_raid_stripe_width;
	uint32_t                s_reserved[163];
} __attribute__((packed));

/* magic string */
#define EXT_SB_MAGIC                            "\123\357"
/* supper block offset */
#define EXT_SB_OFF                              0x400
/* supper block offset in kB */
#define EXT_SB_KBOFF                            (EXT_SB_OFF >> 10)
/* magic string offset within super block */
#define EXT_MAG_OFF                             0x38



/* for s_flags */
#define EXT2_FLAGS_TEST_FILESYS         0x0004

/* for s_feature_compat */
#define EXT3_FEATURE_COMPAT_HAS_JOURNAL         0x0004

/* for s_feature_ro_compat */
#define EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER     0x0001
#define EXT2_FEATURE_RO_COMPAT_LARGE_FILE       0x0002
#define EXT2_FEATURE_RO_COMPAT_BTREE_DIR        0x0004
#define EXT4_FEATURE_RO_COMPAT_HUGE_FILE        0x0008
#define EXT4_FEATURE_RO_COMPAT_GDT_CSUM         0x0010
#define EXT4_FEATURE_RO_COMPAT_DIR_NLINK        0x0020
#define EXT4_FEATURE_RO_COMPAT_EXTRA_ISIZE      0x0040

/* for s_feature_incompat */
#define EXT2_FEATURE_INCOMPAT_FILETYPE          0x0002
#define EXT3_FEATURE_INCOMPAT_RECOVER           0x0004
#define EXT3_FEATURE_INCOMPAT_JOURNAL_DEV       0x0008
#define EXT2_FEATURE_INCOMPAT_META_BG           0x0010
#define EXT4_FEATURE_INCOMPAT_EXTENTS           0x0040 /* extents support */
#define EXT4_FEATURE_INCOMPAT_64BIT             0x0080
#define EXT4_FEATURE_INCOMPAT_MMP               0x0100
#define EXT4_FEATURE_INCOMPAT_FLEX_BG           0x0200

#define EXT2_FEATURE_RO_COMPAT_SUPP     (EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER| \
					 EXT2_FEATURE_RO_COMPAT_LARGE_FILE| \
					 EXT2_FEATURE_RO_COMPAT_BTREE_DIR)
#define EXT2_FEATURE_INCOMPAT_SUPP      (EXT2_FEATURE_INCOMPAT_FILETYPE| \
					 EXT2_FEATURE_INCOMPAT_META_BG)
#define EXT2_FEATURE_INCOMPAT_UNSUPPORTED       ~EXT2_FEATURE_INCOMPAT_SUPP
#define EXT2_FEATURE_RO_COMPAT_UNSUPPORTED      ~EXT2_FEATURE_RO_COMPAT_SUPP

#define EXT3_FEATURE_RO_COMPAT_SUPP     (EXT2_FEATURE_RO_COMPAT_SPARSE_SUPER| \
					 EXT2_FEATURE_RO_COMPAT_LARGE_FILE| \
					 EXT2_FEATURE_RO_COMPAT_BTREE_DIR)
#define EXT3_FEATURE_INCOMPAT_SUPP      (EXT2_FEATURE_INCOMPAT_FILETYPE| \
					 EXT3_FEATURE_INCOMPAT_RECOVER| \
					 EXT2_FEATURE_INCOMPAT_META_BG)
#define EXT3_FEATURE_INCOMPAT_UNSUPPORTED       ~EXT3_FEATURE_INCOMPAT_SUPP
#define EXT3_FEATURE_RO_COMPAT_UNSUPPORTED      ~EXT3_FEATURE_RO_COMPAT_SUPP

/* reads superblock and returns:
 *      fc = feature_compat
 *      fi = feature_incompat
 *      frc = feature_ro_compat */
static struct ext2_super_block *ext_get_super(
		blkid_probe pr, uint32_t *fc, uint32_t *fi, uint32_t *frc)
{
	struct ext2_super_block *es;

	es = (struct ext2_super_block *)
			blkid_probe_get_buffer(pr, EXT_SB_OFF, 0x200);
	if (!es)
		return NULL;
	if (fc)
		*fc = le32_to_cpu(es->s_feature_compat);
	if (fi)
		*fi = le32_to_cpu(es->s_feature_incompat);
	if (frc)
		*frc = le32_to_cpu(es->s_feature_ro_compat);

	return es;
}

static void ext_get_info(blkid_probe pr, int ver, struct ext2_super_block *es)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (*es->s_volume_name != '\0')
		blkid_probe_set_label(pr, (unsigned char *) es->s_volume_name,
					sizeof(es->s_volume_name));
	blkid_probe_set_uuid(pr, es->s_uuid);

	if (le32_to_cpu(es->s_feature_compat) & EXT3_FEATURE_COMPAT_HAS_JOURNAL)
		blkid_probe_set_uuid_as(pr, es->s_journal_uuid, "EXT_JOURNAL");

	if (ver != 2 && (chn->flags & BLKID_SUBLKS_SECTYPE) &&
	    ((le32_to_cpu(es->s_feature_incompat) & EXT2_FEATURE_INCOMPAT_UNSUPPORTED) == 0))
		blkid_probe_set_value(pr, "SEC_TYPE", (unsigned char *) "ext2", sizeof("ext2"));

	blkid_probe_sprintf_version(pr, "%u.%u",
		le32_to_cpu(es->s_rev_level),
		le16_to_cpu(es->s_minor_rev_level));
}


static int probe_jbd(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct ext2_super_block *es;
	uint32_t fi;

	es = ext_get_super(pr, NULL, &fi, NULL);
	if (!es)
		return errno ? -errno : 1;
	if (!(fi & EXT3_FEATURE_INCOMPAT_JOURNAL_DEV))
		return 1;

	ext_get_info(pr, 2, es);
	blkid_probe_set_uuid_as(pr, es->s_uuid, "LOGUUID");

	return 0;
}

static int probe_ext2(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct ext2_super_block *es;
	uint32_t fc, frc, fi;

	es = ext_get_super(pr, &fc, &fi, &frc);
	if (!es)
		return errno ? -errno : 1;

	/* Distinguish between ext3 and ext2 */
	if (fc & EXT3_FEATURE_COMPAT_HAS_JOURNAL)
		return 1;

	/* Any features which ext2 doesn't understand */
	if ((frc & EXT2_FEATURE_RO_COMPAT_UNSUPPORTED) ||
	    (fi  & EXT2_FEATURE_INCOMPAT_UNSUPPORTED))
		return 1;

	ext_get_info(pr, 2, es);
	return 0;
}

static int probe_ext3(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct ext2_super_block *es;
	uint32_t fc, frc, fi;

	es = ext_get_super(pr, &fc, &fi, &frc);
	if (!es)
		return errno ? -errno : 1;

	/* ext3 requires journal */
	if (!(fc & EXT3_FEATURE_COMPAT_HAS_JOURNAL))
		return 1;

	/* Any features which ext3 doesn't understand */
	if ((frc & EXT3_FEATURE_RO_COMPAT_UNSUPPORTED) ||
	    (fi  & EXT3_FEATURE_INCOMPAT_UNSUPPORTED))
		return 1;

	ext_get_info(pr, 3, es);
	return 0;
}


static int probe_ext4dev(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct ext2_super_block *es;
	uint32_t fc, frc, fi;

	es = ext_get_super(pr, &fc, &fi, &frc);
	if (!es)
		return errno ? -errno : 1;

	/* Distinguish from jbd */
	if (fi & EXT3_FEATURE_INCOMPAT_JOURNAL_DEV)
		return 1;

	if (!(le32_to_cpu(es->s_flags) & EXT2_FLAGS_TEST_FILESYS))
		return 1;

	ext_get_info(pr, 4, es);
	return 0;
}

static int probe_ext4(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct ext2_super_block *es;
	uint32_t fc, frc, fi;

	es = ext_get_super(pr, &fc, &fi, &frc);
	if (!es)
		return errno ? -errno : 1;

	/* Distinguish from jbd */
	if (fi & EXT3_FEATURE_INCOMPAT_JOURNAL_DEV)
		return 1;

	/* Ext4 has at least one feature which ext3 doesn't understand */
	if (!(frc & EXT3_FEATURE_RO_COMPAT_UNSUPPORTED) &&
	    !(fi  & EXT3_FEATURE_INCOMPAT_UNSUPPORTED))
		return 1;

	/* If the filesystem is a OK for use by in-development
	 * filesystem code, and ext4dev is supported or ext4 is not
	 * supported, then don't call ourselves ext4, so we can redo
	 * the detection and mark the filesystem as ext4dev.
	 *
	 * If the filesystem is marked as in use by production
	 * filesystem, then it can only be used by ext4 and NOT by
	 * ext4dev. */
	if (le32_to_cpu(es->s_flags) & EXT2_FLAGS_TEST_FILESYS)
		return 1;

	ext_get_info(pr, 4, es);
	return 0;
}

#define BLKID_EXT_MAGICS \
	{ \
		{        \
			.magic = EXT_SB_MAGIC, \
			.len = sizeof(EXT_SB_MAGIC) - 1, \
			.kboff = EXT_SB_KBOFF, \
			.sboff = EXT_MAG_OFF \
		}, \
		{ NULL } \
	}

static const struct blkid_idinfo jbd_idinfo =
{
	.name           = "jbd",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_jbd,
	.magics         = BLKID_EXT_MAGICS
};

static const struct blkid_idinfo ext2_idinfo =
{
	.name           = "ext2",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ext2,
	.magics         = BLKID_EXT_MAGICS
};

static const struct blkid_idinfo ext3_idinfo =
{
	.name           = "ext3",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ext3,
	.magics         = BLKID_EXT_MAGICS
};

static const struct blkid_idinfo ext4_idinfo =
{
	.name           = "ext4",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ext4,
	.magics         = BLKID_EXT_MAGICS
};

static const struct blkid_idinfo ext4dev_idinfo =
{
	.name           = "ext4dev",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ext4dev,
	.magics         = BLKID_EXT_MAGICS
};

struct promise_metadata {
	uint8_t sig[24];
};

#define PDC_CONFIG_OFF          0x1200
#define PDC_SIGNATURE           "Promise Technology, Inc."

static int probe_pdcraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	size_t i;
	static const unsigned int sectors[] = {
	  63, 255, 256, 16, 399, 591, 675, 735, 911, 974, 991, 951, 3087
	};
	uint64_t nsectors;

	if (pr->size < 0x40000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	nsectors = pr->size >> 9;

	for (i = 0; i < ARRAY_SIZE(sectors); i++) {
		uint64_t off;
		struct promise_metadata *pdc;

		if (nsectors < sectors[i])
			return 1;

		off = (nsectors - sectors[i]) << 9;
		pdc = (struct promise_metadata *)
				blkid_probe_get_buffer(pr,
					off,
					sizeof(struct promise_metadata));
		if (!pdc)
			return errno ? -errno : 1;

		if (memcmp(pdc->sig, PDC_SIGNATURE,
				sizeof(PDC_SIGNATURE) - 1) == 0) {

			if (blkid_probe_set_magic(pr, off, sizeof(pdc->sig),
						(unsigned char *) pdc->sig))
				return 1;
			return 0;
		}
	}
	return 1;
}

static const struct blkid_idinfo pdcraid_idinfo = {
	.name           = "promise_fasttrack_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_pdcraid,
	.magics         = BLKID_NONE_MAGIC
};


struct lsi_metadata {
	uint8_t         sig[6];
};


#define LSI_SIGNATURE           "$XIDE$"

static int probe_lsiraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct lsi_metadata *lsi;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200) - 1) * 0x200;
	lsi = (struct lsi_metadata *)
		blkid_probe_get_buffer(pr,
				off,
				sizeof(struct lsi_metadata));
	if (!lsi)
		return errno ? -errno : 1;

	if (memcmp(lsi->sig, LSI_SIGNATURE, sizeof(LSI_SIGNATURE)-1) != 0)
		return 1;
	if (blkid_probe_set_magic(pr, off, sizeof(lsi->sig),
				(unsigned char *) lsi->sig))
		return 1;
	return 0;
}

static const struct blkid_idinfo lsiraid_idinfo = {
	.name           = "lsi_mega_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_lsiraid,
	.magics         = BLKID_NONE_MAGIC
};
#endif /* CONFIG_FEATURE_LIBBLKID */

struct fdisk_wipe {
	struct list_head        wipes;
	uint64_t                start;          /* sectors */
	uint64_t                size;           /* sectors */
};

static struct fdisk_wipe *fdisk_get_wipe_area(
			struct fdisk_context *cxt,
			uint64_t start,
			uint64_t size)
{
	struct list_head *p;

	if (cxt == NULL || list_empty(&cxt->wipes))
		return NULL;

	list_for_each(p, &cxt->wipes) {
		struct fdisk_wipe *wp = list_entry(p, struct fdisk_wipe, wipes);
		if (wp->start == start && wp->size == size)
			return wp;
	}
	return NULL;
}

static void fdisk_free_wipe_areas(struct fdisk_context *cxt)
{
	while (!list_empty(&cxt->wipes)) {
		struct fdisk_wipe *wp = list_entry(cxt->wipes.next, struct fdisk_wipe, wipes);
		list_del(&wp->wipes);
		free(wp);
	}
}

static int fdisk_has_wipe_area(struct fdisk_context *cxt,
			uint64_t start,
			uint64_t size)
{
	return fdisk_get_wipe_area(cxt, start, size) != NULL;
}

/* Add/remove new wiping area
 *
 * Returns: <0 on error, or old area setting (1: enabled, 0: disabled) */
static int fdisk_set_wipe_area(struct fdisk_context *cxt,
			uint64_t start,
			uint64_t size,
			int enable)
{
	struct fdisk_wipe *wp;

	if (FDISK_IS_UNDEF(start) || FDISK_IS_UNDEF(size))
		return -EINVAL;

	wp = fdisk_get_wipe_area(cxt, start, size);

	/* disable */
	if (!enable) {
		if (wp) {
			list_del(&wp->wipes);
			free(wp);
			return 1;
		}
		return 0;
	}

	/* enable */
	if (wp)
		return 1;       /* already enabled */

	wp = zmalloc(sizeof(*wp));
	INIT_LIST_HEAD(&wp->wipes);
	wp->start = start;
	wp->size = size;
	list_add_tail(&wp->wipes, &cxt->wipes);

	return 0;
}

/* There are two basic types of parttypes, string based (e.g. GPT)
 * and code/hex based (e.g. MBR). */
static struct fdisk_parttype *fdisk_new_parttype(void)
{
	struct fdisk_parttype *t = zmalloc(sizeof(*t));

	t->refcount = 1;
	t->flags = FDISK_PARTTYPE_ALLOCATED;
	return t;
}

/* Increments reference counter for allocated types */
static void fdisk_ref_parttype(struct fdisk_parttype *t)
{
	if (fdisk_parttype_is_allocated(t))
		t->refcount++;
}

/* Decrements reference counter, on zero the @t is automatically deallocated. */
static void fdisk_unref_parttype(struct fdisk_parttype *t)
{
	if (!fdisk_parttype_is_allocated(t))
		return;

	t->refcount--;
	if (t->refcount <= 0) {
		free(t->typestr);
		free(t->name);
		free(t);
	}
}

/* Sets type name to allocated partition type, for static types
 * it returns -EINVAL.
 * Return: 0 on success, <0 on error */
static int fdisk_parttype_set_name(struct fdisk_parttype *t, const char *str)
{
	char *p = NULL;

	if (!t || !fdisk_parttype_is_allocated(t))
		return -EINVAL;
	if (str)
		p = xstrdup(str);

	free(t->name);
	t->name = p;
	return 0;
}

/* Sets type string to allocated partition type, for static types
 * it returns -EINVAL. Don't use this function for MBR, see
 * fdisk_parttype_set_code().
 * Return: 0 on success, <0 on error */
static int fdisk_parttype_set_typestr(struct fdisk_parttype *t, const char *str)
{
	char *p = NULL;

	if (!t || !fdisk_parttype_is_allocated(t))
		return -EINVAL;
	if (str)
		p = xstrdup(str);

	free(t->typestr);
	t->typestr = p;
	return 0;
}

/* Sets type code to allocated partition type, for static types it returns
 * -EINVAL. Don't use this function for GPT, see fdisk_parttype_set_typestr().
 * Return: 0 on success, <0 on error */
static int fdisk_parttype_set_code(struct fdisk_parttype *t, int code)
{
	if (!t || !fdisk_parttype_is_allocated(t))
		return -EINVAL;
	t->code = code;
	return 0;
}

/* Returns: number of types supported by label. */
static size_t fdisk_label_get_nparttypes(const struct fdisk_label *lb)
{
	if (!lb)
		return 0;
	return lb->nparttypes;
}

/* Returns: return parttype */
static struct fdisk_parttype *fdisk_label_get_parttype(const struct fdisk_label *lb, size_t n)
{
	if (!lb || n >= lb->nparttypes)
		return NULL;
	return &lb->parttypes[n];
}

/* Returns: 1 if the label uses code as partition type
 *          identifiers (e.g. MBR) or 0. */
static inline int fdisk_label_has_code_parttypes(const struct fdisk_label *lb)
{
	if (lb->parttypes && lb->parttypes[0].typestr)
		return 0;
	return 1;
}


/* Search for partition type in label-specific table. The result
 * is pointer to static array of label types.
 * Returns: partition type or NULL upon failure or invalid @code. */
static struct fdisk_parttype *fdisk_label_get_parttype_from_code(
				const struct fdisk_label *lb,
				unsigned int code)
{
	size_t i;

	if (!lb->nparttypes)
		return NULL;

	for (i = 0; i < lb->nparttypes; i++)
		if (lb->parttypes[i].code == code)
			return &lb->parttypes[i];
	return NULL;
}

/* Search for partition type in label-specific table. The result
 * is pointer to static array of label types.
 * Returns: partition type or NULL upon failure or invalid @str. */
static struct fdisk_parttype *fdisk_label_get_parttype_from_string(
				const struct fdisk_label *lb,
				const char *str)
{
	size_t i;

	if (!lb->nparttypes)
		return NULL;

	for (i = 0; i < lb->nparttypes; i++)
		if (lb->parttypes[i].typestr
		    && strcasecmp(lb->parttypes[i].typestr, str) == 0)
			return &lb->parttypes[i];

	return NULL;
}

/* Allocates new 'unknown' partition type. Use fdisk_unref_parttype() to
 * deallocate.
 * Returns: newly allocated partition type, or NULL upon failure. */
static struct fdisk_parttype *fdisk_new_unknown_parttype(unsigned int code,
						  const char *typestr)
{
	struct fdisk_parttype *t = fdisk_new_parttype();

	if (!t)
		return NULL;

	fdisk_parttype_set_name(t, "unknown");
	fdisk_parttype_set_code(t, code);
	fdisk_parttype_set_typestr(t, typestr);
	t->flags |= FDISK_PARTTYPE_UNKNOWN;

	return t;
}

/* Parses partition type from @str according to the label. The function returns
 * a pointer to static table of the partition types, or newly allocated
 * partition type for unknown types (see fdisk_parttype_is_unknown(). It's
 * safe to call fdisk_unref_parttype() for all results.
 *
 * Returns: pointer to type or NULL on error. */
static struct fdisk_parttype *fdisk_label_parse_parttype(
				const struct fdisk_label *lb,
				const char *str)
{
	const struct fdisk_parttype *types;
	const struct fdisk_parttype *ret = NULL;

	if (!lb->nparttypes)
		return NULL;

	types = lb->parttypes;

	if (types[0].typestr == NULL && isxdigit(*str)) {
		unsigned int code;

		code = bb_xparse_ui_number(16 | BB_PN_SILENT_RE, str);
		if (errno)
			return NULL;
		ret = fdisk_label_get_parttype_from_code(lb, code);
		if (ret)
			goto done;

		ret = fdisk_new_unknown_parttype(code, NULL);
	} else {
		unsigned int i;

		/* maybe specified by type string (e.g. UUID) */
		ret = fdisk_label_get_parttype_from_string(lb, str);
		if (ret)
			goto done;

		/* maybe specified by order number */
		i = bb_xparse_ui_number(BB_PN_SILENT_RE | BB_PN_SET_LOWER1 | BB_PN_SET_UPPER,
					str, (unsigned int)(lb->nparttypes-1));
		if (i) {
			ret = &types[i - 1];
			goto done;
		}

		return fdisk_new_unknown_parttype(0, str);
	}

done:
	return (struct fdisk_parttype *)ret;    /* deconst */
}

/* Returns: partition type string (e.g. GUID for GPT) */
static inline const char *fdisk_parttype_get_string(const struct fdisk_parttype *t)
{
	return t->typestr && *t->typestr ? t->typestr : NULL;
}

/* Returns: partition type code (e.g. for MBR) */
static inline unsigned int fdisk_parttype_get_code(const struct fdisk_parttype *t)
{
	return t->code;
}

/* Returns: partition type human readable name */
static inline const char *fdisk_parttype_get_name(const struct fdisk_parttype *t)
{
	return t->name;
}

/* Returns: field Id (FDISK_FIELD_*) */
static inline int fdisk_field_get_id(const struct fdisk_field *field)
{
	return field ? field->id : -EINVAL;
}

/* Returns: field name */
static inline const char *fdisk_field_get_name(const struct fdisk_field *field)
{
	return field ? field->name : NULL;
}

/* Returns: libsmartcols compatible width. */
static inline double fdisk_field_get_width(const struct fdisk_field *field)
{
	return field ? field->width : -EINVAL;
}

/* Returns: FDISK_FIELDFL_NUMBER if field represent number */
static inline int fdisk_field_is_number(const struct fdisk_field *field)
{
	return field->flags & FDISK_FIELDFL_NUMBER;
}

/* script header (e.g. unit: sectors) */
struct fdisk_scriptheader {
	struct list_head        headers;
	char                    *name;
	char                    *data;
};



static void fdisk_script_free_header(struct fdisk_scriptheader *fi)
{
	if (!fi)
		return;

	free(fi->name);
	free(fi->data);
	list_del(&fi->headers);
	free(fi);
}

/* Increments reference counter. */
static inline void fdisk_ref_script(struct fdisk_script *dp)
{
	if (dp)
		dp->refcount++;
}

static void init_partition(struct fdisk_partition *pa)
{
	FDISK_INIT_UNDEF(pa->size);
	FDISK_INIT_UNDEF(pa->start);
	FDISK_INIT_UNDEF(pa->partno);
	FDISK_INIT_UNDEF(pa->parent_partno);
	FDISK_INIT_UNDEF(pa->boot);

	INIT_LIST_HEAD(&pa->parts);
}

/* Resets partition content. */
static void fdisk_reset_partition(struct fdisk_partition *pa)
{
	int ref;

	if (!pa)
		return;

	ref = pa->refcount;

	fdisk_unref_parttype(pa->type);
	free(pa->name);
	free(pa->uuid);
	free(pa->attrs);
	free(pa->fstype);
	free(pa->fsuuid);
	free(pa->fslabel);
	free(pa->start_chs);
	free(pa->end_chs);

	memset(pa, 0, sizeof(*pa));
	pa->refcount = ref;

	init_partition(pa);
}

/* Decrements reference counter, on zero the @pa is automatically deallocated. */
static void fdisk_unref_partition(struct fdisk_partition *pa)
{
	if (!pa)
		return;

	pa->refcount--;
	if (pa->refcount <= 0) {
		list_del(&pa->parts);
		fdisk_reset_partition(pa);
		free(pa);
	}
}

/* Removes the @pa from the table and de-increment reference counter of the @pa. The
 * partition with zero reference counter will be deallocated. Don't forget to use
 * fdisk_ref_partition() before call fdisk_table_remove_partition() if you want
 * to use @pa later.
 *
 * Returns: 0 on success or negative number in case of error. */
static int fdisk_table_remove_partition(struct fdisk_table *tb, struct fdisk_partition *pa)
{
	if (!tb || !pa)
		return -EINVAL;

	list_del_init(&pa->parts);
	fdisk_unref_partition(pa);
	tb->nents--;

	return 0;
}

/**
 * The fdisk_table is simple container for fdisk_partitions. The table is no
 * directly connected to label data (partition table), and table changes don't
 * affect in-memory or on-disk data. */

/* Removes all entries (partitions) from the table. The partitions with zero
 * reference count will be deallocated. This function does not modify partition
 * table.
 *
 * Returns: 0 on success or negative number in case of error. */
static int fdisk_reset_table(struct fdisk_table *tb)
{
	if (!tb)
		return -EINVAL;

	while (!list_empty(&tb->parts)) {
		struct fdisk_partition *pa = list_entry(tb->parts.next,
						  struct fdisk_partition, parts);
		fdisk_table_remove_partition(tb, pa);
	}

	tb->nents = 0;
	return 0;
}

/* Descrements reference counter, on zero the @tb is automatically deallocated. */
static void fdisk_unref_table(struct fdisk_table *tb)
{
	if (!tb)
		return;

	tb->refcount--;
	if (tb->refcount <= 0) {
		fdisk_reset_table(tb);
		free(tb);
	}
}

static void fdisk_reset_script(struct fdisk_script *dp)
{
	fdisk_unref_table(dp->table);
	dp->table = NULL;

	while (!list_empty(&dp->headers)) {
		struct fdisk_scriptheader *fi = list_entry(dp->headers.next,
						  struct fdisk_scriptheader, headers);
		fdisk_script_free_header(fi);
	}
	INIT_LIST_HEAD(&dp->headers);
}

static void fdisk_unref_context(struct fdisk_context *cxt);

/* Decrements reference counter, on zero the @dp is automatically deallocated. */
static void fdisk_unref_script(struct fdisk_script *dp)
{
	if (!dp)
		return;

	dp->refcount--;
	if (dp->refcount <= 0) {
		fdisk_reset_script(dp);
		fdisk_unref_context(dp->cxt);
		free(dp);
	}
}

static void fdisk_zeroize_device_properties(struct fdisk_context *cxt)
{
	cxt->io_size = 0;
	cxt->optimal_io_size = 0;
	cxt->min_io_size = 0;
	cxt->phy_sector_size = 0;
	cxt->sector_size = 0;
	cxt->alignment_offset = 0;
	cxt->grain = 0;
	cxt->first_lba = 0;
	cxt->last_lba = 0;
	cxt->total_sectors = 0;

	memset(&cxt->geom, 0, sizeof(struct fdisk_geometry));
}

/* Resets the current used label driver to initial state */
static void fdisk_deinit_label(struct fdisk_label *lb)
{
	/* private label information */
	if (lb->op->deinit)
		lb->op->deinit(lb);
}

static void reset_context(struct fdisk_context *cxt)
{
	size_t i;

	/* reset drives' private data */
	for (i = 0; i < cxt->nlabels; i++)
		fdisk_deinit_label(cxt->labels[i]);

	if (cxt->parent) {
		/* the first sector may be independent on parent */
		if (cxt->parent->firstsector != cxt->firstsector)
			free(cxt->firstsector);
	} else {
		/* we close device only in primary context */
		if (cxt->dev_fd > -1)
			close(cxt->dev_fd);
		free(cxt->firstsector);
	}

	free(cxt->dev_path);
	cxt->dev_path = NULL;

	free(cxt->dev_model);
	cxt->dev_model = NULL;
	cxt->dev_model_probed = 0;

	free(cxt->collision);
	cxt->collision = NULL;

	memset(&cxt->dev_st, 0, sizeof(cxt->dev_st));

	cxt->dev_fd = -1;
	cxt->firstsector = NULL;
	cxt->firstsector_bufsz = 0;

	fdisk_zeroize_device_properties(cxt);

	fdisk_unref_script(cxt->script);
	cxt->script = NULL;

	cxt->label = NULL;

	fdisk_free_wipe_areas(cxt);
}

/* Deallocates context struct. */
static void fdisk_unref_context(struct fdisk_context *cxt)
{
	unsigned i;

	if (!cxt)
		return;

	cxt->refcount--;
	if (cxt->refcount <= 0) {
		reset_context(cxt);     /* this is sensitive to parent<->child relationship! */

		/* deallocate label's private stuff */
		for (i = 0; i < cxt->nlabels; i++) {
			if (!cxt->labels[i])
				continue;
			if (cxt->labels[i]->op->free)
				cxt->labels[i]->op->free(cxt->labels[i]);
			else
				free(cxt->labels[i]);
		}

		fdisk_unref_context(cxt->parent);
		cxt->parent = NULL;

		free(cxt);
	}
}

static struct fdisk_scriptheader *script_get_header(struct fdisk_script *dp,
						     const char *name)
{
	struct list_head *p;

	list_for_each(p, &dp->headers) {
		struct fdisk_scriptheader *fi = list_entry(p, struct fdisk_scriptheader, headers);

		if (strcasecmp(fi->name, name) == 0)
			return fi;
	}

	return NULL;
}

/* Returns: pointer to header data or NULL. */
static const char *fdisk_script_get_header(struct fdisk_script *dp, const char *name)
{
	struct fdisk_scriptheader *fi;

	fi = script_get_header(dp, name);
	return fi ? fi->data : NULL;
}

/* The headers are used as global options for whole partition
 * table, always one header per line.
 *
 * If no @data is specified then the header is removed. If header does not exist
 * and @data is specified then a new header is added.
 *
 * Note that libfdisk allows to specify arbitrary custom header, the default
 * build-in headers are "unit" and "label", and some label specific headers
 * (for example "uuid" and "name" for GPT).
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_script_set_header(struct fdisk_script *dp,
			    const char *name,
			    const char *data)
{
	struct fdisk_scriptheader *fi;

	if (!dp || !name)
		return -EINVAL;

	fi = script_get_header(dp, name);
	if (!fi && !data)
		return 0;       /* want to remove header that does not exist, success */

	if (!data) {
		/* no data, remove the header */
		fdisk_script_free_header(fi);
		return 0;
	}

	if (!fi) {
		/* new header */
		fi = zmalloc(sizeof(*fi));
		INIT_LIST_HEAD(&fi->headers);
		fi->name = xstrdup(name);
		fi->data = xstrdup(data);
		list_add_tail(&fi->headers, &dp->headers);
	} else {
		/* update existing */
		char *x = xstrdup(data);

		free(fi->data);
		fi->data = x;
	}

	if (strcmp(name, "label") == 0)
		dp->label = NULL;

	return 0;
}

/* If no @name specified then returns the current context label.
 *
 * The label is allocated and maintained within the context #cxt. There is
 * nothing like reference counting for labels, you cannot deallocate the
 * label.
 *
 * Returns: label struct or NULL in case of error. */
static struct fdisk_label *fdisk_get_label(struct fdisk_context *cxt, const char *name)
{
	size_t i;

	if (!name)
		return cxt->label;
	else if (strcasecmp(name, "mbr") == 0)
		name = "dos";

	for (i = 0; i < cxt->nlabels; i++)
		if (cxt->labels[i]
		    && strcasecmp(cxt->labels[i]->name, name) == 0)
			return cxt->labels[i];

	return NULL;
}

static struct fdisk_label *script_get_label(struct fdisk_script *dp)
{
	if (!dp->label) {
		dp->label = fdisk_get_label(dp->cxt, fdisk_script_get_header(dp, "label"));
	}
	return dp->label;
}

/**
 * The maximal number of the partitions depends on disklabel and does not
 * have to describe the real limit of PT.
 *
 * For example the limit for MBR without extend partition is 4, with extended
 * partition it's unlimited (so the function returns the current number of all
 * partitions in this case).
 *
 * And for example for GPT it depends on space allocated on disk for array of
 * entry records (usually 128).
 *
 * Note that the recommended way to list partitions is to use
 * fdisk_get_partitions() and struct fdisk_table than ask disk driver for each
 * individual partitions.
 *
 * Returns: maximal number of partitions for the current label. */
static size_t fdisk_get_npartitions(struct fdisk_context *cxt)
{
	return cxt && cxt->label ? cxt->label->nparts_max : 0;
}

/* Returns: FDISK_DISKLABEL_*. */
static inline int fdisk_label_get_type(const struct fdisk_label *lb)
{
	return lb->id;
}

/* Returns: return 1 if the current label is @id */
static int fdisk_is_labeltype(struct fdisk_context *cxt, enum fdisk_labeltype id)
{
	return cxt->label && (unsigned)fdisk_label_get_type(cxt->label) == id;
}

#define fdisk_is_label(c, x) fdisk_is_labeltype(c, FDISK_DISKLABEL_ ## x)

/* Returns: grain in bytes used to align partitions (usually 1MiB) */
static inline unsigned long fdisk_get_grain_size(struct fdisk_context *cxt)
{
	return cxt->grain;
}

/* Returns: label name */
static inline const char *fdisk_label_get_name(const struct fdisk_label *lb)
{
	return lb ? lb->name : NULL;
}


static int fdisk_partition_has_start(struct fdisk_partition *pa)
{
	return pa && !FDISK_IS_UNDEF(pa->start);
}

static inline int is_header_line(const char *s)
{
	const char *p = strchr(s, ':');

	if (!p || p == s || !*(p + 1) || strchr(s, '='))
		return 0;

	return 1;
}

/* parses "<name>: value", note modifies @s */
static int parse_line_header(struct fdisk_script *dp, char *s)
{
	int rc = -EINVAL;
	char *name, *value;

	if (!s || !*s)
		return -EINVAL;

	name = s;
	value = strchr_set0(s, ':');
	if (!value)
		goto done;
	value++;

	ltrim_whitespace((unsigned char *) name);
	rtrim_whitespace((unsigned char *) name);
	ltrim_whitespace((unsigned char *) value);
	rtrim_whitespace((unsigned char *) value);

	if (strcmp(name, "label") == 0) {
		if (dp->cxt && !fdisk_get_label(dp->cxt, value))
			goto done;                      /* unknown label name */
		dp->force_label = 1;
	} else if (strcmp(name, "unit") == 0) {
		if (strcmp(value, "sectors") != 0)
			goto done;                      /* only "sectors" supported */
	} else if (strcmp(name, "label-id") == 0
		   || strcmp(name, "device") == 0
		   || strcmp(name, "grain") == 0
		   || strcmp(name, "first-lba") == 0
		   || strcmp(name, "last-lba") == 0
		   || strcmp(name, "table-length") == 0) {
		;                                       /* whatever is possible */
	} else
		goto done;                              /* unknown header */

	if (*name && *value)
		rc = fdisk_script_set_header(dp, name, value);
done:
	return rc;

}

/* returns zero terminated string with next token and @str is updated */
static char *next_token(char **str)
{
	char *tk_begin = NULL,
	     *tk_end = NULL,
	     *end = NULL,
	     *p;
	int open_quote = 0, terminated = 0;

	for (p = *str; p && *p; p++) {
		if (!tk_begin) {
			if (isblank(*p))
				continue;
			tk_begin = *p == '"' ? p + 1 : p;
		}
		if (*p == '"')
			open_quote ^= 1;
		if (open_quote)
			continue;
		if (isblank(*p) || *p == ',' || *p == ';' || *p == '"' )
			tk_end = p;
		else if (*(p + 1) == '\0')
			tk_end = p + 1;
		if (tk_begin && tk_end)
			break;
	}

	if (!tk_end)
		return NULL;

	end = tk_end;

	/* skip closing quotes */
	if (*end == '"')
		end++;

	/* token is terminated by blank (or blank is before "," or ";") */
	if (isblank(*end)) {
		end = bb_skip_whitespace(end);
		terminated++;
	}

	/* token is terminated by "," or ";" */
	if (*end == ',' || *end == ';') {
		end++;
		terminated++;

	/* token is terminated by \0 */
	} else if (!*end)
		terminated++;

	if (!terminated)
		return NULL;

	/* skip extra space after terminator */
	end = bb_skip_whitespace(end);

	*tk_end = '\0';
	*str = end;
	return tk_begin;
}

static int next_number(char **s, uint64_t *num, int *power)
{
	char *tk;
	int rc = -EINVAL;

	tk = next_token(s);
	if (tk)
		rc = parse_size(tk, (uintmax_t *) num, power);
	return rc;
}

static int next_string(char **s, char **str)
{
	char *tk;
	int rc = -EINVAL;

	tk = next_token(s);
	if (tk) {
		*str = xstrdup(tk);
		rc = 0;
	}
	return rc;
}

static int partno_from_devname(char *s)
{
	size_t sz;
	char *p;

	sz = rtrim_whitespace((unsigned char *)s);
	p = s + sz - 1;

	while (p > s && isdigit(*(p - 1)))
		p--;

	return bb_xparse_i_number(10 | BB_PN_SILENT_RE | BB_PN_SET_LOWER1, p) - 1;
}

/* Returns: new instance. */
static struct fdisk_partition *fdisk_new_partition(void)
{
	struct fdisk_partition *pa = zmalloc(sizeof(*pa));

	pa->refcount = 1;
	init_partition(pa);
	return pa;
}



/* When @pa used as a template for fdisk_add_partition() when force label
 * driver to use all the possible space for the new partition. */
static int fdisk_partition_end_follow_default(struct fdisk_partition *pa, int enable)
{
	if (!pa)
		return -EINVAL;
	pa->end_follow_default = enable ? 1 : 0;
	return 0;
}

/* Note that zero is valid offset too. Use fdisk_partition_unset_start() to
 * undefine the offset.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_partition_set_start(struct fdisk_partition *pa, fdisk_sector_t off)
{
	if (!pa)
		return -EINVAL;
	if (FDISK_IS_UNDEF(off))
		return -ERANGE;
	pa->start = off;
	pa->fs_probed = 0;
	return 0;
}

/* When @pa used as a template for fdisk_add_partition() when force label driver
 * to use the first possible space for the new partition.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_partition_start_follow_default(struct fdisk_partition *pa, int enable)
{
	if (!pa)
		return -EINVAL;
	pa->start_follow_default = enable ? 1 : 0;
	return 0;
}

/* Note that zero is valid size too. Use fdisk_partition_unset_size() to
 * undefine the size.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_partition_set_size(struct fdisk_partition *pa, fdisk_sector_t sz)
{
	if (!pa)
		return -EINVAL;
	if (FDISK_IS_UNDEF(sz))
		return -ERANGE;
	pa->size = sz;
	pa->fs_probed = 0;
	return 0;
}

/* By default libfdisk aligns the size when add the new partition (by
 * fdisk_add_partition()). If you want to disable this functionality use
 * @enable = 1. */
static inline void fdisk_partition_size_explicit1(struct fdisk_partition *pa)
{
	pa->size_explicit = 1;
}

/* Note that zero is valid partno too. Use fdisk_partition_unset_partno() to
 * undefine the partno.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_partition_set_partno(struct fdisk_partition *pa, size_t num)
{
	if (!pa)
		return -EINVAL;
	if (FDISK_IS_UNDEF(num))
		return -ERANGE;
	pa->partno = num;
	return 0;
}

/* When @pa used as a template for fdisk_add_partition() when force label driver
 * to add a new partition to the default (next) position. */
static void fdisk_partition_partno_follow_default(struct fdisk_partition *pa, int enable)
{
	pa->partno_follow_default = enable ? 1 : 0;
}

/* Increments reference counter. */
static inline void fdisk_ref_partition(struct fdisk_partition *pa)
{
	pa->refcount++;
}


/* Adds a new entry to table and increment @pa reference counter. Don't forget to
 * use fdisk_unref_partition() after fdisk_table_add_partition() if you want to keep
 * the @pa referenced by the table only.
 *
 * Returns: 0 on success or negative number in case of error. */
static int fdisk_table_add_partition(struct fdisk_table *tb, struct fdisk_partition *pa)
{
	if (!tb || !pa)
		return -EINVAL;

	fdisk_ref_partition(pa);
	list_add_tail(&pa->parts, &tb->parts);
	tb->nents++;
	return 0;
}

/* dump format
 * <device>: start=<num>, size=<num>, type=<string>, ... */
static int parse_line_nameval(struct fdisk_script *dp, char *s)
{
	char *p, *x;
	int rc = 0;
	uint64_t num;
	int pno;
	struct fdisk_partition *pa = fdisk_new_partition();

	fdisk_partition_start_follow_default(pa, 1);
	fdisk_partition_end_follow_default(pa, 1);
	fdisk_partition_partno_follow_default(pa, 1);

	/* set partno */
	p = strchr(s, ':');
	x = strchr(s, '=');
	if (p && (!x || p < x)) {
		*p = '\0';
		p++;

		pno = partno_from_devname(s);
		if (pno >= 0) {
			fdisk_partition_partno_follow_default(pa, 0);
			fdisk_partition_set_partno(pa, pno);
		}
	} else
		p = s;

	while (rc == 0 && p && *p) {

		p = bb_skip_whitespace(p);

		if (!strncasecmp(p, "start=", 6)) {
			int pow = 0;
			p += 6;
			rc = next_number(&p, &num, &pow);
			if (!rc) {
				if (pow)        /* specified as <num><suffix> */
					num /= dp->cxt->sector_size;
				fdisk_partition_set_start(pa, num);
				fdisk_partition_start_follow_default(pa, 0);
			}
		} else if (!strncasecmp(p, "size=", 5)) {
			int pow = 0;

			p += 5;
			rc = next_number(&p, &num, &pow);
			if (!rc) {
				if (pow)        /* specified as <num><suffix> */
					num /= dp->cxt->sector_size;
				else            /* specified as number of sectors */
					fdisk_partition_size_explicit1(pa);
				fdisk_partition_set_size(pa, num);
				fdisk_partition_end_follow_default(pa, 0);
			}

		} else if (!strncasecmp(p, "bootable", 8)) {
			/* we use next_token() to skip possible extra space */
			char *tk = next_token(&p);
			if (tk && strcasecmp(tk, "bootable") == 0)
				pa->boot = 1;
			else
				rc = -EINVAL;

		} else if (!strncasecmp(p, "attrs=", 6)) {
			p += 6;
			rc = next_string(&p, &pa->attrs);

		} else if (!strncasecmp(p, "uuid=", 5)) {
			p += 5;
			rc = next_string(&p, &pa->uuid);

		} else if (!strncasecmp(p, "name=", 5)) {
			p += 5;
			rc = next_string(&p, &pa->name);
			unhexmangle_string(pa->name);

		} else if (!strncasecmp(p, "type=", 5) ||
			   !strncasecmp(p, "Id=", 3)) {         /* backward compatibility */
			char *type;

			p += ((*p == 'I' || *p == 'i') ? 3 : 5); /* "Id=", "type=" */

			rc = next_string(&p, &type);
			if (rc)
				break;
			pa->type = fdisk_label_parse_parttype(
					script_get_label(dp), type);
			free(type);

			if (!pa->type) {
				rc = -EINVAL;
				fdisk_unref_parttype(pa->type);
				pa->type = NULL;
				break;
			}

		} else {
			rc = -EINVAL;
			break;
		}
	}

	if (!rc)
		rc = fdisk_table_add_partition(dp->table, pa);

	fdisk_unref_partition(pa);
	return rc;
}

/* original sfdisk supports partition types shortcuts like 'L' = Linux native */
static struct fdisk_parttype *translate_type_shortcuts(struct fdisk_script *dp, char *str)
{
	struct fdisk_label *lb;
	const char *type = NULL;

	if (strlen(str) != 1)
		return NULL;

	lb = script_get_label(dp);
	if (!lb)
		return NULL;

	if (lb->id == FDISK_DISKLABEL_DOS) {
		switch (*str) {
		case 'L':       /* Linux */
			type = "83";
			break;
		case 'S':       /* Swap */
			type = "82";
			break;
		case 'E':       /* Dos extended */
			type = "05";
			break;
		case 'X':       /* Linux extended */
			type = "85";
			break;
		case 'U':       /* UEFI system */
			type = "EF";
			break;
		case 'R':       /* Linux RAID */
			type = "FD";
			break;
		case 'V':       /* LVM */
			type = "8E";
			break;

		}
	} else if (lb->id == FDISK_DISKLABEL_GPT) {
		switch (*str) {
		case 'L':       /* Linux */
			type = "0FC63DAF-8483-4772-8E79-3D69D8477DE4";
			break;
		case 'S':       /* Swap */
			type = "0657FD6D-A4AB-43C4-84E5-0933C84B4F4F";
			break;
		case 'H':       /* Home */
			type = "933AC7E1-2EB4-4F13-B844-0E14E2AEF915";
			break;
		case 'U':       /* UEFI system */
			type = "C12A7328-F81F-11D2-BA4B-00A0C93EC93B";
			break;
		case 'R':       /* Linux RAID */
			type = "A19D880F-05FC-4D3B-A006-743F0F84911E";
			break;
		case 'V':       /* LVM */
			type = "E6D6D379-F507-44C2-A23C-238F2A3DF928";
			break;
		}
	}

	return type ? fdisk_label_parse_parttype(lb, type) : NULL;
}

#define TK_PLUS         1
#define TK_MINUS        -1

#define alone_sign(_sign, _p)   (_sign && (*_p == '\0' || isblank(*_p)))

/* simple format:
 * <start>, <size>, <type>, <bootable>, ... */
static int parse_line_valcommas(struct fdisk_script *dp, char *s)
{
	int rc = 0;
	char *p = s, *str;
	enum { ITEM_START, ITEM_SIZE, ITEM_TYPE, ITEM_BOOTABLE };
	int item = -1;
	struct fdisk_partition *pa = fdisk_new_partition();

	fdisk_partition_start_follow_default(pa, 1);
	fdisk_partition_end_follow_default(pa, 1);
	fdisk_partition_partno_follow_default(pa, 1);

	while (rc == 0 && p && *p) {
		uint64_t num;
		char *begin;
		int sign = 0;

		p = bb_skip_whitespace(p);
		item++;

		if (item != ITEM_BOOTABLE) {
			sign = *p == '-' ? TK_MINUS : *p == '+' ? TK_PLUS : 0;
			if (sign)
				p++;
		}

		begin = p;

		switch (item) {
		case ITEM_START:
			if (*p == ',' || *p == ';' || alone_sign(sign, p))
				fdisk_partition_start_follow_default(pa, 1);
			else {
				int pow = 0;

				rc = next_number(&p, &num, &pow);
				if (!rc) {
					if (pow)        /* specified as <num><suffix> */
						num /= dp->cxt->sector_size;
					fdisk_partition_set_start(pa, num);
					pa->movestart = sign == TK_MINUS ? FDISK_MOVE_DOWN :
							sign == TK_PLUS  ? FDISK_MOVE_UP :
							FDISK_MOVE_NONE;
				}
				fdisk_partition_start_follow_default(pa, 0);
			}
			break;
		case ITEM_SIZE:
			if (*p == ',' || *p == ';' || alone_sign(sign, p)) {
				fdisk_partition_end_follow_default(pa, 1);
				if (sign == TK_PLUS)
					/* '+' alone means use all possible space, '-' alone means nothing */
					pa->resize = FDISK_RESIZE_ENLARGE;
			} else {
				int pow = 0;
				rc = next_number(&p, &num, &pow);
				if (!rc) {
					if (pow) /* specified as <size><suffix> */
						num /= dp->cxt->sector_size;
					else     /* specified as number of sectors */
						fdisk_partition_size_explicit1(pa);
					fdisk_partition_set_size(pa, num);
					pa->resize = sign == TK_MINUS ? FDISK_RESIZE_REDUCE :
						     sign == TK_PLUS  ? FDISK_RESIZE_ENLARGE :
							FDISK_RESIZE_NONE;
				}
				fdisk_partition_end_follow_default(pa, 0);
			}
			break;
		case ITEM_TYPE:
			if (*p == ',' || *p == ';' || alone_sign(sign, p))
				break;  /* use default type */

			rc = next_string(&p, &str);
			if (rc)
				break;

			pa->type = translate_type_shortcuts(dp, str);
			if (!pa->type)
				pa->type = fdisk_label_parse_parttype(
						script_get_label(dp), str);
			free(str);

			if (!pa->type) {
				rc = -EINVAL;
				fdisk_unref_parttype(pa->type);
				pa->type = NULL;
				break;
			}
			break;
		case ITEM_BOOTABLE:
			if (*p == ',' || *p == ';')
				break;
			else {
				char *tk = next_token(&p);
				if (tk && *tk == '*' && *(tk + 1) == '\0')
					pa->boot = 1;
				else if (tk && *tk == '-' && *(tk + 1) == '\0')
					pa->boot = 0;
				else if (tk && *tk == '+' && *(tk + 1) == '\0')
					pa->boot = 1;
				else
					rc = -EINVAL;
			}
			break;
		default:
			break;
		}

		if (begin == p)
			p++;
	}

	if (!rc)
		rc = fdisk_table_add_partition(dp->table, pa);

	fdisk_unref_partition(pa);
	return rc;
}

static struct fdisk_table *fdisk_new_table(void)
{
	struct fdisk_table *tb = zmalloc(sizeof(*tb));

	tb->refcount = 1;
	INIT_LIST_HEAD(&tb->parts);
	return tb;
}

/* Returns: 1 if the table is without filesystems, or 0. */
static int fdisk_table_is_empty(struct fdisk_table *tb)
{
	return tb == NULL || list_empty(&tb->parts) ? 1 : 0;
}

/* modifies @s ! */
static int fdisk_script_read_buffer(struct fdisk_script *dp, char *s)
{
	int rc = 0;

	s = bb_skip_whitespace(s);
	if (!s || !*s)
		return 0;       /* nothing baby, ignore */

	if (!dp->table)
		dp->table = fdisk_new_table();

	/* parse header lines only if no partition specified yet */
	if (fdisk_table_is_empty(dp->table) && is_header_line(s))
		rc = parse_line_header(dp, s);

	/* parse script format */
	else if (strchr(s, '='))
		rc = parse_line_nameval(dp, s);

	/* parse simple <value>, ... format */
	else
		rc = parse_line_valcommas(dp, s);

	return rc;
}

/* Reads next line into dump.
 * Returns: 0 on success, <0 on error, 1 when nothing to read. */
static int fdisk_script_read_line(struct fdisk_script *dp, FILE *f, char *buf, size_t bufsz)
{
	char *s;

	/* read the next non-blank non-comment line */
	do {
		if (dp->fn_fgets) {
			if (dp->fn_fgets(dp, buf, bufsz, f) == NULL)
				return 1;
		} else if (fgets(buf, bufsz, f) == NULL)
			return 1;

		dp->nlines++;
		s = strchr(buf, '\n');
		if (!s) {
			/* Missing final newline?  Otherwise an extremely */
			/* long line - assume file was corrupted */
			if (feof(f)) {
				s = strchr(buf, '\0');
			} else {
				return -EINVAL;
			}
		}

		*s = '\0';
		if (--s >= buf && *s == '\r')
			*s = '\0';
		s = bb_skip_whitespace(buf);
	} while (*s == '\0' || *s == '#');

	return fdisk_script_read_buffer(dp, s);
}


/* Reads file @f into script @dp.
 * Returns: 0 on success, <0 on error. */
static int fdisk_script_read_file(struct fdisk_script *dp, FILE *f)
{
	char buf[BUFSIZ];
	int rc = 1;

	while (!feof(f)) {
		rc = fdisk_script_read_line(dp, f, buf, sizeof(buf));
		if (rc)
			break;
	}

	if (rc == 1)
		rc = 0;         /* end of file */

	return rc;
}

/* Sets reference to the @dp script and remove reference to the previously used
 * script.
 *
 * The script headers might be used by label drivers to overwrite
 * built-in defaults (for example disk label Id) and label driver might
 * optimize the default semantic to be more usable for scripts (for example to
 * not ask for primary/logical/extended partition type).
 *
 * Note that script also contains reference to the fdisk context (see
 * fdisk_new_script()). This context may be completely independent on
 * context used for fdisk_set_script().
 *
 * Returns: <0 on error, 0 on success. */
static int fdisk_set_script(struct fdisk_context *cxt, struct fdisk_script *dp)
{
	/* unref old */
	if (cxt->script)
		fdisk_unref_script(cxt->script);

	/* ref new */
	cxt->script = dp;
	fdisk_ref_script(cxt->script);

	return 0;
}

static int fdisk_has_user_device_geometry(struct fdisk_context *cxt)
{
	return (cxt->user_geom.heads || cxt->user_geom.sectors || cxt->user_geom.cylinders);
}

/* Returns: 1 if user specified any properties */
static int fdisk_has_user_device_properties(struct fdisk_context *cxt)
{
	return (cxt->user_pyh_sector || cxt->user_log_sector ||
		cxt->user_grain ||
		fdisk_has_user_device_geometry(cxt));
}

/* Returns: the current script or NULL. */
static inline struct fdisk_script *fdisk_get_script(struct fdisk_context *cxt)
{
	return cxt->script;
}

/* The labelitem is label specific items stored in the partition table header.
 * The information provided by labelitems are not specific to the partitions.
 *
 * See also fdisk_get_disklabel_item(). The IDs are generic (e.g.
 * FDISK_LABEL_ITEM_*) and label specific ((e.g. GPT_LABELITEM_*). */

/* Zeroize data stored in the @li (does not modify anything in disk label).
 *
 * Returns: 0 on success, or <0 in case of error */
static int fdisk_reset_labelitem(struct fdisk_labelitem *li)
{
	int refcount;

	if (!li)
		return -EINVAL;
	if (li->type == 's')
		free(li->data.str);

	refcount = li->refcount;
	memset(li, 0, sizeof(*li));
	li->refcount = refcount;
	return 0;
}

/* Increments reference counter. */
static inline void fdisk_ref_context(struct fdisk_context *cxt)
{
	if (cxt)
		cxt->refcount++;
}

/* The script hold fdisk_table and additional information to read/write
 * script to the file.
 * Returns: newly allocated script struct. */
static struct fdisk_script *fdisk_new_script(struct fdisk_context *cxt)
{
	struct fdisk_script *dp = zmalloc(sizeof(*dp));

	dp->refcount = 1;
	dp->cxt = cxt;
	fdisk_ref_context(cxt);

	dp->table = fdisk_new_table();
	INIT_LIST_HEAD(&dp->headers);
	return dp;
}

/* Allocates a new script and reads script from @filename.
 * Returns: new script instance or NULL in case of error (check errno for more details). */
static struct fdisk_script *fdisk_new_script_from_file(struct fdisk_context *cxt,
						 const char *filename)
{
	int rc;
	FILE *f;
	struct fdisk_script *dp, *res = NULL;

	f = fopen(filename, "r");
	if (!f)
		return NULL;

	dp = fdisk_new_script(cxt);
	rc = fdisk_script_read_file(dp, f);
	if (rc) {
		errno = -rc;
		goto done;
	}

	res = dp;
done:
	fclose(f);
	if (!res)
		fdisk_unref_script(dp);
	else
		errno = 0;

	return res;
}

/* Set callback for dialog driven partitioning and library warnings/errors. */
static inline void fdisk_set_ask(struct fdisk_context *cxt,
		int (*ask_cb)(struct fdisk_context *, struct fdisk_ask *, void *),
		void *data)
{
	cxt->ask_cb = ask_cb;
	cxt->ask_data = data;
}

static struct fdisk_ask *fdisk_new_ask(void)
{
	struct fdisk_ask *ask = zmalloc(sizeof(struct fdisk_ask));
	ask->refcount = 1;
	return ask;
}

/* Returns: FDISK_ASKTYPE_* */
static inline int fdisk_ask_get_type(struct fdisk_ask *ask)
{
	return ask->type;
}

static void fdisk_ask_menu_reset_items(struct fdisk_ask *ask)
{
	struct ask_menuitem *mi;

	for (mi = ask->data.menu.first; mi; ) {
		struct ask_menuitem *next = mi->next;
		free(mi);
		mi = next;
	}
}

static void fdisk_reset_ask(struct fdisk_ask *ask)
{
	int refcount;

	free(ask->query);

	refcount = ask->refcount;

	if (fdisk_is_ask(ask, MENU))
		fdisk_ask_menu_reset_items(ask);

	memset(ask, 0, sizeof(*ask));
	ask->refcount = refcount;
}

/* Decrements reference counter, on zero the @ask is automatically
 * deallocated. */
static void fdisk_unref_ask(struct fdisk_ask *ask)
{
	if (!ask)
		return;
	ask->refcount--;

	if (ask->refcount <= 0) {
		fdisk_reset_ask(ask);
		free(ask);
	}
}

/* Returns: pointer to dialog string. */
static inline const char *fdisk_ask_get_query(struct fdisk_ask *ask)
{
	return ask->query;
}

static int fdisk_ask_set_query(struct fdisk_ask *ask, const char *str)
{
	return strdup_to_struct_member(ask, query, str);
}


static inline void fdisk_ask_set_type(struct fdisk_ask *ask, int type)
{
	ask->type = type;
}

/* Returns: 1 if dialog driven partitioning enabled (default), or 0. */
static inline int fdisk_has_dialogs(struct fdisk_context *cxt)
{
	return cxt->no_disalogs == 0;
}

static int fdisk_do_ask(struct fdisk_context *cxt, struct fdisk_ask *ask)
{
	int rc;

	if (!fdisk_has_dialogs(cxt) &&
	    !(ask->type == FDISK_ASKTYPE_INFO ||
	      ask->type == FDISK_ASKTYPE_WARNX ||
	      ask->type == FDISK_ASKTYPE_WARN))
		return -EINVAL;

	if (!cxt->ask_cb)
		return -EINVAL;

	rc = cxt->ask_cb(cxt, ask, cxt->ask_data);

	return rc;
}

#define is_number_ask(a)  (fdisk_is_ask(a, NUMBER) || fdisk_is_ask(a, OFFSET))

/* Returns: string with range (e.g. "1,3,5-10") */
static inline const char *fdisk_ask_number_get_range(struct fdisk_ask *ask)
{
	return ask->data.num.range;
}

/* Returns: default number */
static inline uint64_t fdisk_ask_number_get_default(struct fdisk_ask *ask)
{
	return ask->data.num.dfl;
}

static inline void fdisk_ask_number_set_default(struct fdisk_ask *ask, uint64_t dflt)
{
	ask->data.num.dfl = dflt;
}

/* Returns: minimal possible number when ask for numbers in range */
static inline uint64_t fdisk_ask_number_get_low(struct fdisk_ask *ask)
{
	return ask->data.num.low;
}

static inline void fdisk_ask_number_set_low(struct fdisk_ask *ask, uint64_t low)
{
	ask->data.num.low = low;
}

/* Returns: maximal possible number when ask for numbers in range */
static inline uint64_t fdisk_ask_number_get_high(struct fdisk_ask *ask)
{
	return ask->data.num.hig;
}

static inline void fdisk_ask_number_set_high(struct fdisk_ask *ask, uint64_t high)
{
	ask->data.num.hig = high;
}

/* Returns: result */
static inline uint64_t fdisk_ask_number_get_result(struct fdisk_ask *ask)
{
	return ask->data.num.result;
}

static inline void fdisk_ask_number_set_result(struct fdisk_ask *ask, uint64_t result)
{
	ask->data.num.result = result;
}

/* Returns: base when user specify number in relative notation (+size) */
static inline uint64_t fdisk_ask_number_get_base(struct fdisk_ask *ask)
{
	return ask->data.num.base;
}

static inline void fdisk_ask_number_set_base(struct fdisk_ask *ask, uint64_t base)
{
	ask->data.num.base = base;
}

/* Returns: number of bytes per the unit */
static inline uint64_t fdisk_ask_number_get_unit(struct fdisk_ask *ask)
{
	return ask->data.num.unit;
}

static inline void fdisk_ask_number_set_unit(struct fdisk_ask *ask, uint64_t unit)
{
	ask->data.num.unit = unit;
}

static inline int fdisk_ask_number_is_relative(struct fdisk_ask *ask)
{
	return ask->data.num.relative;
}

/* The wrap-negative flag allows to accept negative number from user. In this
 * case the dialog result is calculated as "high - num" (-N from high limit).
 * Returns: 1 or 0. */
static inline int fdisk_ask_number_is_wrap_negative(struct fdisk_ask *ask)
{
	return ask->data.num.wrap_negative;
}

/* Inform libfdisk that user specified number in relative notation rather than
 * by explicit number. This info allows to fdisk do some optimization (e.g.
 * align end of partition, etc.) */
static inline void fdisk_ask_number_set_relative1(struct fdisk_ask *ask)
{
	ask->data.num.relative = 1;
}

/* Returns: 1 if number should be presented as chars */
static inline int fdisk_ask_number_inchars(struct fdisk_ask *ask)
{
	return ask->data.num.inchars;
}

static inline void fdisk_ask_number_set_wrap_negative1(struct fdisk_ask *ask)
{
	ask->data.num.wrap_negative = 1;
}

/* Generates string with list ranges (e.g. 1,2,5-8) for the 'cur' */
#define tochar(num)     ((int) ('a' + num - 1))
static char *mk_string_list(char *ptr, size_t *len, size_t *begin,
			    size_t *run, ssize_t cur, int inchar)
{
	int rlen;

	if (cur != -1) {
		if (!*begin) {                  /* begin of the list */
			*begin = cur + 1;
			return ptr;
		}

		if (*begin + *run == (size_t)cur) {     /* no gap, continue */
			(*run)++;
			return ptr;
		}
	} else if (!*begin) {
		*ptr = '\0';
		return ptr;             /* end of empty list */
	}

					/* add to the list */
	if (!*run)
		rlen = inchar ? snprintf(ptr, *len, "%c,", tochar(*begin)) :
				snprintf(ptr, *len, "%zu,", *begin);
	else if (*run == 1)
		rlen = inchar ?
			snprintf(ptr, *len, "%c,%c,", tochar(*begin), tochar(*begin + 1)) :
			snprintf(ptr, *len, "%zu,%zu,", *begin, *begin + 1);
	else
		rlen = inchar ?
			snprintf(ptr, *len, "%c-%c,", tochar(*begin), tochar(*begin + *run)) :
			snprintf(ptr, *len, "%zu-%zu,", *begin, *begin + *run);

	if (rlen < 0 || (size_t) rlen >= *len)
		return NULL;

	ptr += rlen;
	*len -= rlen;

	if (cur == -1 && *begin) {
		/* end of the list */
		*(ptr - 1) = '\0';      /* remove tailing ',' from the list */
		return ptr;
	}

	*begin = cur + 1;
	*run = 0;

	return ptr;
}

static inline void fdisk_ask_number_set_range(struct fdisk_ask *ask, const char *range)
{
	ask->data.num.range = range;
}


static int fdisk_ask_number(struct fdisk_context *cxt,
		     uintmax_t low,
		     uintmax_t dflt,
		     uintmax_t high,
		     const char *query,
		     uintmax_t *result)
{
	struct fdisk_ask *ask;
	int rc;

	ask = fdisk_new_ask();
	fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);
	fdisk_ask_number_set_low(ask, low);
	fdisk_ask_number_set_default(ask, dflt);
	fdisk_ask_number_set_high(ask, high);
	fdisk_ask_set_query(ask, query);
	rc = fdisk_do_ask(cxt, ask);
	if (!rc)
		*result = fdisk_ask_number_get_result(ask);

	fdisk_unref_ask(ask);
	return rc;
}

/* Returns: pointer to dialog result */
static inline char *fdisk_ask_string_get_result(struct fdisk_ask *ask)
{
	return ask->data.str.result;
}

/* You don't have to care about the @result deallocation, libfdisk is going to
 * deallocate the result when destroy @ask instance. */
static inline void fdisk_ask_string_set_result(struct fdisk_ask *ask, char *result)
{
	ask->data.str.result = result;
}

/* High-level API to ask for strings. Don't forget to deallocate the @result.
 * Returns: 0 on success, <0 on error. */
static int fdisk_ask_string(struct fdisk_context *cxt,
		     const char *query,
		     char **result)
{
	struct fdisk_ask *ask;
	int rc;

	ask = fdisk_new_ask();
	fdisk_ask_set_type(ask, FDISK_ASKTYPE_STRING);
	fdisk_ask_set_query(ask, query);
	rc = fdisk_do_ask(cxt, ask);
	if (!rc)
		*result = fdisk_ask_string_get_result(ask);

	fdisk_unref_ask(ask);
	return rc;
}

/* Returns: 0 or 1 */
static inline int fdisk_ask_yesno_get_result(struct fdisk_ask *ask)
{
	return ask->data.yesno.result;
}

/* High-level API to ask Yes/No questions
 * Returns: 0 on success, <0 on error */
static int fdisk_ask_yesno(struct fdisk_context *cxt, const char *query, int *result)
{
	struct fdisk_ask *ask;
	int rc;

	ask = fdisk_new_ask();
	fdisk_ask_set_type(ask, FDISK_ASKTYPE_YESNO);
	fdisk_ask_set_query(ask, query);
	rc = fdisk_do_ask(cxt, ask);
	if (!rc)
		*result = fdisk_ask_yesno_get_result(ask) == 1 ? 1 : 0;

	fdisk_unref_ask(ask);
	return rc;
}

/* Returns: 0 on success, <0 on error */
static inline void fdisk_ask_yesno_set_result(struct fdisk_ask *ask, int result)
{
	ask->data.yesno.result = result;
}

/* menu */
static inline void fdisk_ask_menu_set_default(struct fdisk_ask *ask, int dfl)
{
	ask->data.menu.dfl = dfl;
}

/* Returns: default menu item key */
static inline int fdisk_ask_menu_get_default(struct fdisk_ask *ask)
{
	return ask->data.menu.dfl;
}

static inline void fdisk_ask_menu_set_result(struct fdisk_ask *ask, int key)
{
	ask->data.menu.result = key;
}

static inline void fdisk_ask_menu_get_result(struct fdisk_ask *ask, int *key)
{
	if (key)
		*key =  ask->data.menu.result;
}

/* Returns: 0 on success, >0 if idx out-of-range */
static int fdisk_ask_menu_get_item(struct fdisk_ask *ask, size_t idx, int *key,
			    const char **name, const char **desc)
{
	size_t i;
	struct ask_menuitem *mi;

	for (i = 0, mi = ask->data.menu.first; mi; mi = mi->next, i++) {
		if (i == idx)
			break;
	}

	if (!mi)
		return 1;       /* no more items */
	if (key)
		*key = mi->key;
	if (name)
		*name = mi->name;
	if (desc)
		*desc = mi->desc;
	return 0;
}

static int fdisk_ask_menu_add_item(struct fdisk_ask *ask, int key,
			const char *name, const char *desc)
{
	struct ask_menuitem *mi;

	mi = zmalloc(sizeof(*mi));
	mi->key = key;
	mi->name = name;
	mi->desc = desc;

	if (!ask->data.menu.first)
		ask->data.menu.first = mi;
	else {
		struct ask_menuitem *last = ask->data.menu.first;

		while (last->next)
			last = last->next;
		last->next = mi;
	}

	return 0;
}


/* print-like */

#define is_print_ask(a) (fdisk_is_ask(a, WARN) || fdisk_is_ask(a, WARNX) || fdisk_is_ask(a, INFO))

/* Returns: error number for warning/error messages */
static inline int fdisk_ask_print_get_errno(struct fdisk_ask *ask)
{
	return ask->data.print.errnum;
}

static inline void fdisk_ask_print_set_errno(struct fdisk_ask *ask, int errnum)
{
	ask->data.print.errnum = errnum;
}

/* Returns: pointer to message */
static inline const char *fdisk_ask_print_get_mesg(struct fdisk_ask *ask)
{
	return ask->data.print.mesg;
}

/* does not reallocate the message! */
static inline void fdisk_ask_print_set_mesg(struct fdisk_ask *ask, const char *mesg)
{
	ask->data.print.mesg = mesg;
}

static int do_vprint(struct fdisk_context *cxt, int errnum, int type,
		     const char *fmt, va_list va)
{
	struct fdisk_ask *ask;
	int rc;
	char *mesg;

	if (vasprintf(&mesg, fmt, va) < 0)
		return -ENOMEM;

	ask = fdisk_new_ask();
	fdisk_ask_set_type(ask, type);
	fdisk_ask_print_set_mesg(ask, mesg);
	if (errnum >= 0)
		fdisk_ask_print_set_errno(ask, errnum);
	rc = fdisk_do_ask(cxt, ask);

	fdisk_unref_ask(ask);
	free(mesg);
	return rc;
}

/* High-level API to print info messages,
 * Returns: 0 on success, <0 on error */
static int fdisk_info(struct fdisk_context *cxt, const char *fmt, ...)
{
	int rc;
	va_list ap;

	va_start(ap, fmt);
	rc = do_vprint(cxt, -1, FDISK_ASKTYPE_INFO, fmt, ap);
	va_end(ap);
	return rc;
}

/* High-level API to print warning message (errno expected)
 * Returns: 0 on success, <0 on error */
static int fdisk_warn(struct fdisk_context *cxt, const char *fmt, ...)
{
	int rc;
	va_list ap;

	va_start(ap, fmt);
	rc = do_vprint(cxt, errno, FDISK_ASKTYPE_WARN, fmt, ap);
	va_end(ap);
	return rc;
}

/* High-level API to print warning message
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_warnx(struct fdisk_context *cxt, const char *fmt, ...)
{
	int rc;
	va_list ap;

	va_start(ap, fmt);
	rc = do_vprint(cxt, -1, FDISK_ASKTYPE_WARNX, fmt, ap);
	va_end(ap);
	return rc;
}

static int fdisk_info_new_partition(struct fdisk_context *cxt,
			int num, fdisk_sector_t start, fdisk_sector_t stop,
			struct fdisk_parttype *t)
{
	int rc;
	char str[SIZE_TO_HUMAN_STRING_BUFSIZ];

	size_to_human_string(SIZE_SUFFIX_3LETTER | SIZE_SUFFIX_SPACE,
				     (uint64_t)(stop - start + 1) * cxt->sector_size, str);
	rc = fdisk_info(cxt, "Created a new partition %d of type '%s' and of size %s.",
			num, t ? t->name : "Unknown", str);
	return rc;
}

static int read_from_device(struct fdisk_context *cxt,
		unsigned char *buf,
		uintmax_t start, size_t size)
{
	ssize_t r;

	r = lseek(cxt->dev_fd, start, SEEK_SET);
	if (r == -1)
		return -errno;

	r = read(cxt->dev_fd, buf, size);
	if (r < 0 || (size_t)r != size) {
		if (!errno)
			errno = EINVAL; /* probably too small file/device */
		return -errno;
	}

	return 0;
}

/* Zeros in-memory first sector buffer */
static int fdisk_init_firstsector_buffer(struct fdisk_context *cxt,
				  unsigned int protect_off,
				  unsigned int protect_size)
{
	if (!cxt)
		return -EINVAL;

	if (!cxt->firstsector || cxt->firstsector_bufsz != cxt->sector_size) {
		/* Let's allocate a new buffer if no allocated yet, or the
		 * current buffer has incorrect size */
		if (!cxt->parent || cxt->parent->firstsector != cxt->firstsector)
			free(cxt->firstsector);

		cxt->firstsector = zmalloc(cxt->sector_size);
		cxt->firstsector_bufsz = cxt->sector_size;
		return 0;
	}

	memset(cxt->firstsector, 0, cxt->firstsector_bufsz);

	if (protect_size) {
		/* It would be possible to reuse data from cxt->firstsector
		 * (call memset() for non-protected area only) and avoid one
		 * read() from the device, but it seems like a too fragile
		 * solution as we have no clue about stuff in the buffer --
		 * maybe it was already modified. Let's re-read from the device
		 * to be sure.                  -- kzak 13-Apr-2015 */
		read_from_device(cxt, cxt->firstsector, protect_off, protect_size);
	}
	return 0;
}

static int fdisk_read_firstsector(struct fdisk_context *cxt)
{
	int rc;

	rc = fdisk_init_firstsector_buffer(cxt, 0, 0);
	if (rc)
		return rc;

	return  read_from_device(cxt, cxt->firstsector, 0, cxt->sector_size);
}

/* Return: allocated buffer with partition name, use free() to deallocate. */
static char *fdisk_partname(const char *dev, size_t partno)
{
	char *res = NULL;
	const char *p = "";
	char *dev_mapped = NULL;
	int w = 0;

	if (!dev || !*dev)
		return xasprintf("%zd", partno);

	/* It is impossible to predict /dev/dm-N partition names. */
	if (strncmp(dev, "/dev/dm-", sizeof("/dev/dm-") - 1) == 0) {
		dev_mapped = canonicalize_dm_name (dev + 5);
		if (dev_mapped)
			dev = dev_mapped;
	}

	w = strlen(dev);
	if (isdigit(dev[w - 1]))
#ifdef __GNU__
		p = "s";
#else
		p = "p";
#endif

	/* devfs kludge - note: fdisk partition names are not supposed
	   to equal kernel names, so there is no reason to do this */
	if (strcmp(dev + w - 4, "disc") == 0) {
		w -= 4;
		p = "part";
	}

	/* udev names partitions by appending -partN
	   e.g. ata-SAMSUNG_SV8004H_0357J1FT712448-part1
	   multipath-tools kpartx.rules also append -partN */
	if ((strncmp(dev, _PATH_DEV_BYID, sizeof(_PATH_DEV_BYID) - 1) == 0) ||
	     strncmp(dev, _PATH_DEV_BYPATH, sizeof(_PATH_DEV_BYPATH) - 1) == 0 ||
	     strncmp(dev, "/dev/mapper", sizeof("/dev/mapper") - 1) == 0) {

		/* check for <name><partno>, e.g. mpatha1 */
		res = xasprintf("%.*s%zu", w, dev, partno);
		if (access(res, F_OK) == 0)
			goto done;

		free(res);

		/* check for partition seperator "p" */
		res = xasprintf("%.*sp%zu", w, dev, partno);
		if (access(res, F_OK) == 0)
			goto done;

		free(res);

		/* otherwise, default to "-path" */
		p = "-part";
	}

	res = xasprintf("%.*s%s%zu", w, dev, p, partno);
done:
	free(dev_mapped);
	return res;
}

/* The iterator keeps the direction and the last position for access to the
 * internal library tables/lists.
 *
 * It's very unusual to use the same iterator on multiple places in your
 * application or share the same iterator, for this purpose libfdisk does not
 * provide reference counting for this object. It's recommended to initialize
 * the iterator by fdisk_new_iter() at begin of your function and then
 * fdisk_free_iter() before you return from the function.
 *
 * Don't forget to call fdisk_reset_iter() if you want to use the iterator more
 * than once. */

/* Returns: newly allocated generic libmount iterator. */
static struct fdisk_iter *fdisk_new_iter(int direction)
{
	struct fdisk_iter *itr = zmalloc(sizeof(*itr));
	itr->direction = direction;
	return itr;
}

/* Deallocates the iterator. */
static inline void fdisk_free_iter(struct fdisk_iter *itr)
{
	free(itr);
}

/* Resets the iterator. */
static void fdisk_reset_iter(struct fdisk_iter *itr, int direction)
{
	if (direction == -1)
		direction = itr->direction;

	memset(itr, 0, sizeof(*itr));
	itr->direction = direction;
}

/* Returns: number of entries in table. */
static size_t fdisk_table_get_nents(struct fdisk_table *tb)
{
	return tb ? tb->nents : 0;
}

/* Returns: 0 on success, negative number in case of error or 1 at the end of list. */
static int fdisk_table_next_partition(struct fdisk_table *tb,
			struct fdisk_iter *itr,
			struct fdisk_partition **pa)
{
	int rc = 1;

	if (!tb || !itr || !pa)
		return -EINVAL;
	*pa = NULL;

	if (!itr->head)
		FDISK_ITER_INIT(itr, &tb->parts);
	if (itr->p != itr->head) {
		FDISK_ITER_ITERATE(itr, *pa, struct fdisk_partition, parts);
		rc = 0;
	}

	return rc;
}

/* Returns: partition with @partno or NULL. */
static struct fdisk_partition *fdisk_table_get_partition_by_partno(
			struct fdisk_table *tb,
			size_t partno)
{
	struct fdisk_partition *pa = NULL;
	struct fdisk_iter itr;

	if (!tb)
		return NULL;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);

	while (fdisk_table_next_partition(tb, &itr, &pa) == 0) {
		if (pa->partno == partno)
			return pa;
	}

	return NULL;
}


/* inserts @pa after @poz */
static int table_insert_partition(struct fdisk_table *tb,
			struct fdisk_partition *poz,
			struct fdisk_partition *pa)
{
	fdisk_ref_partition(pa);
	if (poz)
		list_add(&pa->parts, &poz->parts);
	else
		list_add(&pa->parts, &tb->parts);
	tb->nents++;
	return 0;
}


/* Returns: 1 if the partition points to some area */
static inline int fdisk_partition_is_used(struct fdisk_partition *pa)
{
	return pa && pa->used;
}

/* Check if the partition number @n is used by partition table. This function
 * does not check if the device is used (e.g. mounted) by system!
 *
 * This is faster than fdisk_get_partition() + fdisk_partition_is_used(). */
static int fdisk_is_partition_used(struct fdisk_context *cxt, size_t n)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->part_is_used)
		return -ENOSYS;

	return cxt->label->op->part_is_used(cxt, n);
}

/* Reads disklabel and fills in @pa with data about partition @n.
 *
 * Note that partno may address unused partition and then this function does
 * not fill anything to @pa.  See fdisk_is_partition_used(). If @pa points to
 * NULL then the function allocates a newly allocated fdisk_partition struct,
 * use fdisk_unref_partition() to deallocate.
 *
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_get_partition(struct fdisk_context *cxt, size_t partno,
			struct fdisk_partition **pa)
{
	int rc;
	struct fdisk_partition *np = NULL;

	if (!cxt || !cxt->label || !pa)
		return -EINVAL;
	if (!cxt->label->op->get_part)
		return -ENOSYS;
	if (!fdisk_is_partition_used(cxt, partno))
		return -EINVAL;

	if (!*pa) {
		np = *pa = fdisk_new_partition();
	} else
		fdisk_reset_partition(*pa);

	(*pa)->partno = partno;
	rc = cxt->label->op->get_part(cxt, partno, *pa);

	if (rc) {
		if (np) {
			fdisk_unref_partition(np);
			*pa = NULL;
		} else
			fdisk_reset_partition(*pa);
	} else
		(*pa)->size_explicit = 1;
	return rc;
}

/* This function adds partitions from disklabel to @table, it allocates a new
 * table if if @table points to NULL.
 *
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_get_partitions(struct fdisk_context *cxt, struct fdisk_table **tb)
{
	size_t i;

	if (!cxt || !cxt->label || !tb)
		return -EINVAL;
	if (!cxt->label->op->get_part)
		return -ENOSYS;

	if (!*tb)
		*tb = fdisk_new_table();

	for (i = 0; i < cxt->label->nparts_max; i++) {
		struct fdisk_partition *pa = NULL;

		if (fdisk_get_partition(cxt, i, &pa) != 0)
			continue;
		if (fdisk_partition_is_used(pa))
			fdisk_table_add_partition(*tb, pa);
		fdisk_unref_partition(pa);
	}

	return 0;
}

typedef int (*fdisk_partcmp_t)(struct fdisk_partition *, struct fdisk_partition *);

static int cmp_parts_wrapper(struct list_head *a, struct list_head *b, void *data)
{
	struct fdisk_partition *pa = list_entry(a, struct fdisk_partition, parts),
			       *pb = list_entry(b, struct fdisk_partition, parts);

	fdisk_partcmp_t cmp = (fdisk_partcmp_t) data;

	return cmp(pa, pb);
}

/* Sort partition in the table.
 * Returns: 0 on success, <0 on error. */
static int fdisk_table_sort_partitions(struct fdisk_table *tb,
			int (*cmp)(struct fdisk_partition *,
				   struct fdisk_partition *))
{
	if (!tb)
		return -EINVAL;

	list_sort(&tb->parts, cmp_parts_wrapper, (void *) cmp);

	return 0;
}

/* Alignment according to logical granularity (usually 1MiB) */
static int lba_is_aligned(struct fdisk_context *cxt, uintmax_t lba)
{
	unsigned long granularity = max(cxt->phy_sector_size, cxt->min_io_size);
	uintmax_t offset;

	if (cxt->grain > granularity)
		granularity = cxt->grain;

	offset = (lba * cxt->sector_size) % granularity;

	return !((granularity + cxt->alignment_offset - offset) % granularity);
}

/* This function aligns @lba to the "grain" (see fdisk_get_grain_size()). If the
 * device uses alignment offset then the result is moved according the offset
 * to be on the physical boundary.
 *
 * Returns: alignment LBA. */
static fdisk_sector_t fdisk_align_lba(struct fdisk_context *cxt, fdisk_sector_t lba, int direction)
{
	fdisk_sector_t res;

	if (lba_is_aligned(cxt, lba))
		res = lba;
	else {
		fdisk_sector_t sects_in_phy = cxt->grain / cxt->sector_size;

		if (lba < cxt->first_lba)
			res = cxt->first_lba;

		else if (direction == FDISK_ALIGN_UP)
			res = ((lba + sects_in_phy) / sects_in_phy) * sects_in_phy;

		else if (direction == FDISK_ALIGN_DOWN)
			res = (lba / sects_in_phy) * sects_in_phy;

		else /* FDISK_ALIGN_NEAREST */
			res = ((lba + sects_in_phy / 2) / sects_in_phy) * sects_in_phy;

		if (cxt->alignment_offset && !lba_is_aligned(cxt, res) &&
		    res > cxt->alignment_offset / cxt->sector_size) {
			/* apply alignment_offset
			 *
			 * On disk with alignment compensation physical blocks starts
			 * at LBA < 0 (usually LBA -1). It means we have to move LBA
			 * according the offset to be on the physical boundary. */
			res -= (max(cxt->phy_sector_size, cxt->min_io_size) -
					cxt->alignment_offset) / cxt->sector_size;

			if (direction == FDISK_ALIGN_UP && res < lba)
				res += sects_in_phy;
		}
	}

	return res;
}

/* Align @lba, the result has to be between @start and @stop
 *
 * Returns: aligned LBA */
static fdisk_sector_t fdisk_align_lba_in_range(struct fdisk_context *cxt,
				  fdisk_sector_t lba, fdisk_sector_t start, fdisk_sector_t stop)
{
	fdisk_sector_t res;

	start = fdisk_align_lba(cxt, start, FDISK_ALIGN_UP);
	stop = fdisk_align_lba(cxt, stop, FDISK_ALIGN_DOWN);

	if (lba > start && lba < stop
	    && (lba - start) < (cxt->grain / cxt->sector_size)) {
		res = lba;
		return res;
	}

	lba = fdisk_align_lba(cxt, lba, FDISK_ALIGN_NEAREST);

	if (lba < start)
		res = start;
	else if (lba > stop)
		res = stop;
	else
		res = lba;
	return res;
}

/* allocates a new freespace description */
static void new_freespace(struct fdisk_context *cxt,
			 fdisk_sector_t start,
			 fdisk_sector_t end,
			 struct fdisk_partition *parent,
			 struct fdisk_partition **pa)
{
	fdisk_sector_t aligned_start, size;

	*pa = NULL;

	if (start == end)
		return;

	aligned_start = fdisk_align_lba_in_range(cxt, start, start, end);
	size = end - aligned_start + 1ULL;

	if (size == 0)
		return;

	*pa = fdisk_new_partition();

	(*pa)->freespace = 1;
	(*pa)->start = aligned_start;
	(*pa)->size = size;

	if (parent)
		(*pa)->parent_partno = parent->partno;
}

static inline int fdisk_partition_has_partno(struct fdisk_partition *pa)
{
	return pa && !FDISK_IS_UNDEF(pa->partno);
}


/* Returns: 1 if the partition has defined last sector */
static int fdisk_partition_has_end(struct fdisk_partition *pa)
{
	return pa && !FDISK_IS_UNDEF(pa->start) && !FDISK_IS_UNDEF(pa->size);
}

/* This function may returns absolute non-sense, always check
 * fdisk_partition_has_end().
 *
 * Note that partition end is defined by fdisk_partition_set_start() and
 * fdisk_partition_set_size().
 *
 * Returns: last partition sector LBA. */
static fdisk_sector_t fdisk_partition_get_end(struct fdisk_partition *pa)
{
	return pa->start + pa->size - (pa->size == 0 ? 0 : 1);
}

/* add freespace description to the right place within @tb */
static int table_add_freespace(
			struct fdisk_context *cxt,
			struct fdisk_table *tb,
			fdisk_sector_t start,
			fdisk_sector_t end,
			struct fdisk_partition *parent)
{
	struct fdisk_partition *pa, *x, *real_parent = NULL, *best = NULL;
	struct fdisk_iter itr;
	int rc = 0;

	new_freespace(cxt, start, end, parent, &pa);
	if (!pa)
		return 0;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
	if (parent && fdisk_partition_has_partno(parent)) {
		while (fdisk_table_next_partition(tb, &itr, &x) == 0) {
			if (!fdisk_partition_has_partno(x))
				continue;
			if (x->partno == parent->partno) {
				real_parent = x;
				break;
			}
		}
		if (!real_parent) {
			fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
		}
	}

	while (fdisk_table_next_partition(tb, &itr, &x) == 0) {
		fdisk_sector_t the_end, best_end = 0;

		if (!fdisk_partition_has_end(x))
			continue;

		the_end = fdisk_partition_get_end(x);
		if (best)
			best_end = fdisk_partition_get_end(best);

		if (the_end < pa->start && (!best || best_end < the_end))
			best = x;
	}

	if (!best && real_parent)
		best = real_parent;
	rc = table_insert_partition(tb, best, pa);

	fdisk_unref_partition(pa);

	return rc;
}

/* The zero is also valid offset. The function may return random undefined
 * value when start offset is undefined (for example after
 * fdisk_partition_unset_start()). Always use fdisk_partition_has_start() to be
 * sure that you work with valid numbers.
 *
 * Returns: start offset in sectors */
static inline fdisk_sector_t fdisk_partition_get_start(struct fdisk_partition *pa)
{
	return pa->start;
}

/* The zero is also valid size. The function may return random undefined
 * value when size is undefined (for example after fdisk_partition_unset_size()).
 * Always use fdisk_partition_has_size() to be sure that you work with valid
 * numbers.
 *
 * Returns: size offset in sectors */
static inline fdisk_sector_t fdisk_partition_get_size(struct fdisk_partition *pa)
{
	return pa->size;
}

/* Returns: 1 if the partition is nested (e.g. MBR logical partition) */
static int fdisk_partition_is_nested(struct fdisk_partition *pa)
{
	return !FDISK_IS_UNDEF(pa->parent_partno);
}

/* analyze @cont(ainer) in @parts and add all detected freespace into @tb, note
 * that @parts has to be sorted by partition starts */
static int check_container_freespace(struct fdisk_context *cxt,
				     struct fdisk_table *parts,
				     struct fdisk_table *tb,
				     struct fdisk_partition *cont)
{
	struct fdisk_iter itr;
	struct fdisk_partition *pa;
	fdisk_sector_t x, last, grain, lastplusoff;
	int rc = 0;

	last = fdisk_partition_get_start(cont);
	grain = cxt->grain > cxt->sector_size ? cxt->grain / cxt->sector_size : 1;
	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);

	while (fdisk_table_next_partition(parts, &itr, &pa) == 0) {

		if (!pa->used || !fdisk_partition_is_nested(pa)
			      || !fdisk_partition_has_start(pa))
			continue;

		lastplusoff = last + cxt->first_lba;
		if (pa->start > lastplusoff && pa->start - lastplusoff > grain)
			rc = table_add_freespace(cxt, tb, lastplusoff, pa->start, cont);
		if (rc)
			goto done;
		last = fdisk_partition_get_end(pa);
	}

	/* free-space remaining in extended partition */
	x = fdisk_partition_get_start(cont) + fdisk_partition_get_size(cont) - 1;
	lastplusoff = last + cxt->first_lba;
	if (lastplusoff < x && x - lastplusoff > grain) {
		rc = table_add_freespace(cxt, tb, lastplusoff, x, cont);
	}

done:
	return rc;
}

/* Compares partitions according to start offset, See fdisk_table_sort_partitions().
 *
 * Return: 0 if the same, <0 if @b greater, >0 if @a greater. */
static int fdisk_partition_cmp_start(struct fdisk_partition *a,
			      struct fdisk_partition *b)
{
	int no_a = FDISK_IS_UNDEF(a->start),
	    no_b = FDISK_IS_UNDEF(b->start);

	if (no_a && no_b)
		return 0;
	if (no_a)
		return -1;
	if (no_b)
		return 1;

	return cmp_numbers(a->start, b->start);
}

/* Returns: 1 if the partition is container (e.g. MBR extended partition) */
static inline int fdisk_partition_is_container(struct fdisk_partition *pa)
{
	return pa->container;
}

/* This function adds freespace (described by fdisk_partition) to @table, it
 * allocates a new table if the @table points to NULL.
 *
 * Note that free space smaller than grain (see fdisk_get_grain_size()) is
 * ignored.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_get_freespaces(struct fdisk_context *cxt, struct fdisk_table **tb)
{
	int rc = 0;
	size_t nparts = 0;
	fdisk_sector_t last, grain;
	struct fdisk_table *parts = NULL;
	struct fdisk_partition *pa;
	struct fdisk_iter itr;

	if (!cxt || !cxt->label || !tb)
		return -EINVAL;
	if (!*tb)
		*tb = fdisk_new_table();

	rc = fdisk_get_partitions(cxt, &parts);
	if (rc)
		goto done;

	fdisk_table_sort_partitions(parts, fdisk_partition_cmp_start);
	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
	last = cxt->first_lba;
	grain = cxt->grain > cxt->sector_size ? cxt->grain / cxt->sector_size : 1;

	/* analyze gaps between partitions */
	while (rc == 0 && fdisk_table_next_partition(parts, &itr, &pa) == 0) {

		if (!pa->used || pa->wholedisk || fdisk_partition_is_nested(pa)
			      || !fdisk_partition_has_start(pa))
			continue;
		/* We ignore small free spaces (smaller than grain) to keep partitions
		 * aligned, the exception is space before the first partition where
		 * we assume that cxt->first_lba is aligned. */
		if (last + grain < pa->start
		    || (last < pa->start && nparts == 0)) {
			rc = table_add_freespace(cxt, *tb,
				last + (nparts == 0 ? 0 : 1),
				pa->start - 1, NULL);
		}
		/* add gaps between logical partitions */
		if (fdisk_partition_is_container(pa))
			rc = check_container_freespace(cxt, parts, *tb, pa);
		last = fdisk_partition_get_end(pa);
		nparts++;
	}

	/* add free-space behind last partition to the end of the table (so
	 * don't use table_add_freespace()) */
	if (rc == 0 && last + grain < cxt->total_sectors - 1) {
		new_freespace(cxt,
			last + (last > cxt->first_lba || nparts ? 1 : 0),
			cxt->last_lba, NULL, &pa);
		if (pa) {
			fdisk_table_add_partition(*tb, pa);
			fdisk_unref_partition(pa);
		}
	}

done:
	fdisk_unref_table(parts);

	return rc;
}

/* Returns: 1 if the partition is special whole-disk (e.g. SUN) partition */
static inline int fdisk_partition_is_wholedisk(struct fdisk_partition *pa)
{
	return pa && pa->wholedisk;
}

/* Returns: 1 of the table is not in disk order */
static int fdisk_table_wrong_order(struct fdisk_table *tb)
{
	struct fdisk_partition *pa;
	struct fdisk_iter itr;
	fdisk_sector_t last = 0;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
	while (tb && fdisk_table_next_partition(tb, &itr, &pa) == 0) {
		if (!fdisk_partition_has_start(pa) || fdisk_partition_is_wholedisk(pa))
			continue;
		if (pa->start < last)
			return 1;
		last = pa->start;
	}
	return 0;
}

/* Returns: 1 if label requires CHS geometry */
static int fdisk_label_require_geometry(const struct fdisk_label *lb)
{
	return lb->flags & FDISK_LABEL_FL_REQUIRE_GEOMETRY ? 1 : 0;
}

/* Returns: 1 if list-only mode enabled */
static inline int fdisk_is_listonly(struct fdisk_context *cxt)
{
	return cxt->listonly == 1;
}

static int fdisk_missing_geometry(struct fdisk_context *cxt)
{
	int rc;

	if (!cxt || !cxt->label)
		return 0;

	rc = (fdisk_label_require_geometry(cxt->label) &&
		    (!cxt->geom.heads || !cxt->geom.sectors
				      || !cxt->geom.cylinders));

	if (rc && !fdisk_is_listonly(cxt))
		fdisk_warnx(cxt, "Incomplete geometry setting.");

	return rc;
}

/* If @pa is not specified or any @pa item is missing the libfdisk will ask by
 * fdisk_ask_ API.
 *
 * The @pa template is is important for non-interactive partitioning,
 * especially for MBR where is necessary to differentiate between
 * primary/logical; this is done by start offset or/and partno.
 * The rules for MBR:
 *
 *   A) template specifies start within extended partition: add logical
 *   B) template specifies start out of extended partition: add primary
 *   C) template specifies start (or default), partno < 4: add primary
 *   D) template specifies default start, partno >= 4: add logical
 *
 * otherwise MBR driver uses Ask-API to get missing information.
 *
 * Adds a new partition to disklabel.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_add_partition(struct fdisk_context *cxt,
			struct fdisk_partition *pa,
			size_t *partno)
{
	int rc;

	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->add_part)
		return -ENOSYS;
	if (fdisk_missing_geometry(cxt))
		return -EINVAL;

	if (pa)
		pa->fs_probed = 0;

	rc = cxt->label->op->add_part(cxt, pa, partno);

	return rc;
}

/* Add partitions from table @tb to the in-memory disk label. See
 * fdisk_add_partition(). The partitions
 * that does not define start (or does not follow the default start)
 * are ignored.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_apply_table(struct fdisk_context *cxt, struct fdisk_table *tb)
{
	struct fdisk_partition *pa;
	struct fdisk_iter itr;
	int rc = 0;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
	while (tb && fdisk_table_next_partition(tb, &itr, &pa) == 0) {
		if (!fdisk_partition_has_start(pa) && !pa->start_follow_default)
			continue;
		rc = fdisk_add_partition(cxt, pa, NULL);
		if (rc)
			break;
	}

	return rc;
}

static int fdisk_diff_tables(struct fdisk_table *a, struct fdisk_table *b,
		      struct fdisk_iter *itr,
		      struct fdisk_partition **res, int *change)
{
	struct fdisk_partition *pa, *pb;
	int rc = 1;

	if (a && (itr->head == NULL || itr->head == &a->parts)) {
		do {
			rc = fdisk_table_next_partition(a, itr, &pa);
			if (rc != 0)
				break;
		} while (!fdisk_partition_has_partno(pa));
	}

	if (rc == 1 && b) {
		if (itr->head != &b->parts) {
			fdisk_reset_iter(itr, FDISK_ITER_FORWARD);
		}

		while (fdisk_table_next_partition(b, itr, &pb) == 0) {
			if (!fdisk_partition_has_partno(pb))
				continue;
			if (a == NULL ||
			    fdisk_table_get_partition_by_partno(a, pb->partno) == NULL) {
				*change = FDISK_DIFF_ADDED;
				*res = pb;
				return 0;
			}
		}
	}

	if (rc)
		return rc;      /* error or done */

	pb = fdisk_table_get_partition_by_partno(b, pa->partno);

	if (!pb) {
		*change = FDISK_DIFF_REMOVED;
		*res = pa;
	} else if (pb->start != pa->start) {
		*change = FDISK_DIFF_MOVED;
		*res = pb;
	} else if (pb->size != pa->size) {
		*change = FDISK_DIFF_RESIZED;
		*res = pb;
	} else {
		*change = FDISK_DIFF_UNCHANGED;
		*res = pa;
	}
	return 0;
}

/* UUID */
typedef struct {
	uint32_t time_low;
	uint16_t time_mid;
	uint16_t time_hi_and_version;
	uint8_t clock_seq_hi;
	uint8_t clock_seq_low;
	uint8_t node[6];
} efi_guid_t;


#define GPT_UNUSED_ENTRY_GUID \
	    ((efi_guid_t) { 0x00000000, 0x0000, 0x0000, 0x00, 0x00, \
			    { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }})
#define GPT_HEADER_SIGNATURE 0x5452415020494645ULL

#ifdef CONFIG_FEATURE_LIBBLKID
/* EFI GPT partition parsing code */
#define GPT_PRIMARY_LBA 1

/* Signature - “EFI PART” */
#define GPT_HEADER_SIGNATURE_STR "EFI PART"

/* basic types */
typedef uint16_t efi_char16_t;

struct gpt_header_blkid {
	uint64_t        signature;              /* "EFI PART" */
	uint32_t        revision;
	uint32_t        header_size;            /* usually 92 bytes */
	uint32_t        header_crc32;           /* checksum of header with this
						 * field zeroed during calculation */
	uint32_t        reserved1;

	uint64_t        my_lba;                 /* location of this header copy */
	uint64_t        alternate_lba;          /* location of the other header copy */
	uint64_t        first_usable_lba;       /* first usable LBA for partitions */
	uint64_t        last_usable_lba;        /* last usable LBA for partitions */

	efi_guid_t      disk_guid;              /* disk UUID */

	uint64_t        partition_entries_lba;  /* always 2 in primary header copy */
	uint32_t        num_partition_entries;
	uint32_t        sizeof_partition_entry;
	uint32_t        partition_entry_array_crc32;

	/* The rest of the block is reserved by UEFI and must be zero. EFI
	 * standard handles this by:
	 *
	 * uint8_t              reserved2[ BLKSSZGET - 92 ];
	 *
	 * This definition is useless in practice. It is necessary to read
	 * whole block from the device rather than sizeof(struct gpt_header_blkid) only. */
} __attribute__ ((packed));

struct gpt_entry_blkid {
	efi_guid_t      partition_type_guid;    /* type UUID */
	efi_guid_t      unique_partition_guid;  /* partition UUID */
	uint64_t        starting_lba;
	uint64_t        ending_lba;
	uint64_t        attributes;
	efi_char16_t    partition_name[72 / sizeof(efi_char16_t)]; /* UTF-16LE string */
} __attribute__ ((packed));


static inline unsigned char *get_lba_buffer(blkid_probe pr, uint64_t lba, size_t bytes)
{
	return blkid_probe_get_buffer(pr, blkid_probe_get_sectorsize(pr) * lba, bytes);
}

static inline int guidcmp(efi_guid_t left, efi_guid_t right)
{
	return memcmp(&left, &right, sizeof (efi_guid_t));
}


static int last_lba(blkid_probe pr, uint64_t *lba)
{
	uint64_t sz = blkid_probe_get_size(pr);
	unsigned int ssz = blkid_probe_get_sectorsize(pr);

	if (sz < ssz)
		return -1;

	*lba = (sz / ssz) - 1ULL;
	return 0;
}

/* get private chain flags */
static int blkid_partitions_get_flags(blkid_probe pr)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	return chn ? chn->flags : 0;
}

/* Protective (legacy) MBR.
 *
 * This MBR contains standard DOS partition table with a single partition, type
 * of 0xEE.  The partition usually encompassing the entire GPT drive - or 2TiB
 * for large disks.
 *
 * Note that Apple uses GPT/MBR hybrid disks, where the DOS partition table is
 * synchronized with GPT. This synchronization has many restriction of course
 * (due DOS PT limitations).
 *
 * Note that the PMBR detection is optional (enabled by default) and could be
 * disabled by BLKID_PARTS_FOPCE_GPT flag (see also blkid_partitions_set_flags()). */
static int is_pmbr_valid(blkid_probe pr, int *has)
{
	int flags = blkid_partitions_get_flags(pr);
	unsigned char *data;
	struct dos_partition *p;
	int i;

	if (has)
		*has = 0;
	else if (flags & BLKID_PARTS_FORCE_GPT)
		return 1;                       /* skip PMBR check */

	data = blkid_probe_get_sector(pr, 0);
	if (!data) {
		if (errno)
			return -errno;
		goto failed;
	}

	if (!mbr_is_valid_magic(data))
		goto failed;

	for (i = 0, p = mbr_get_partition(data, 0); i < 4; i++, p++) {
		if (p->sys_ind == MBR_GPT_PARTITION)
			goto ok;
	}
failed:
	return 0;
ok:
	if (has)
		*has = 1;
	return 1;
}

/* Reads GPT header to @hdr and returns a pointer to @hdr or NULL in case of
 * error. The function also returns GPT entries in @ents.
 *
 * Note, this function does not allocate any memory. The GPT header has fixed
 * size so we use stack, and @ents returns memory from libblkid buffer (so the
 * next blkid_probe_get_buffer() will overwrite this buffer).
 *
 * This function checks validity of header and entries array. A corrupted
 * header is not returned. */
static struct gpt_header_blkid *get_gpt_header(
				blkid_probe pr, struct gpt_header_blkid *hdr,
				struct gpt_entry_blkid **ents, uint64_t lba,
				uint64_t lastlba)
{
	struct gpt_header_blkid *h;
	uint32_t crc;
	uint64_t lu, fu;
	uint64_t esz;
	uint32_t hsz, ssz;

	ssz = blkid_probe_get_sectorsize(pr);

	/* whole sector is allocated for GPT header */
	h = (struct gpt_header_blkid *) get_lba_buffer(pr, lba, ssz);
	if (!h)
		return NULL;

	if (le64_to_cpu(h->signature) != GPT_HEADER_SIGNATURE)
		return NULL;

	hsz = le32_to_cpu(h->header_size);

	/* EFI: The HeaderSize must be greater than 92 and must be less
	 *      than or equal to the logical block size. */
	if (hsz > ssz || hsz < sizeof(*h))
		return NULL;

	/* Header has to be verified when header_crc32 is zero */
	crc = count_crc32((unsigned char *) h, hsz,
			offsetof(struct gpt_header_blkid, header_crc32),
			sizeof(h->header_crc32));

	if (crc != le32_to_cpu(h->header_crc32))
		return NULL;

	/* Valid header has to be at MyLBA */
	if (le64_to_cpu(h->my_lba) != lba)
		return NULL;

	fu = le64_to_cpu(h->first_usable_lba);
	lu = le64_to_cpu(h->last_usable_lba);

	/* Check if First and Last usable LBA makes sense */
	if (lu < fu || fu > lastlba || lu > lastlba)
		return NULL;

	/* The header has to be outside usable range */
	if (fu < lba && lba < lu)
		return NULL;

	/* Size of blocks with GPT entries */
	esz = (uint64_t)le32_to_cpu(h->num_partition_entries) *
		le32_to_cpu(h->sizeof_partition_entry);

	if (esz == 0 || esz >= UINT32_MAX ||
	    le32_to_cpu(h->sizeof_partition_entry) != sizeof(struct gpt_entry_blkid))
		return NULL;

	/* The header seems valid, save it
	 * (we don't care about zeros in hdr->reserved2 area) */
	memcpy(hdr, h, sizeof(*h));
	h = hdr;

	/* Read GPT entries */
	*ents = (struct gpt_entry_blkid *) get_lba_buffer(pr,
				le64_to_cpu(h->partition_entries_lba), esz);
	if (!*ents)
		return NULL;

	/* Validate entries */
	crc = count_crc32((unsigned char *) *ents, esz, 0, 0);
	if (crc != le32_to_cpu(h->partition_entry_array_crc32))
		return NULL;

	return h;
}

#undef tab

#ifdef CONFIG_FEATURE_GPT_LABEL
/* set PTUUID variable for non-binary API */
static void blkid_partitions_set_ptuuid(blkid_probe pr, unsigned char *uuid)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if (chn->binary || blkid_uuid_is_empty(uuid, 16))
		return;

	v = blkid_probe_assign_value(pr, "PTUUID");
	v->len = UUID_STR_LEN;
	v->data = zmalloc(v->len);
	blkid_unparse_uuid(uuid, (char *) v->data, v->len);
}

static int blkid_parttable_set_uuid(blkid_parttable tab, const unsigned char *id)
{
	if (!tab)
		return -1;

	blkid_unparse_uuid(id, tab->id, sizeof(tab->id));
	return 0;
}
#endif

static int blkid_partlist_increment_partno(blkid_partlist ls)
{
	return ls ? ls->next_partno++ : -1;
}

static blkid_partition new_partition(blkid_partlist ls, blkid_parttable tab)
{
	blkid_partition par;

	if (ls->nparts + 1 > ls->nparts_max) {
		/* Linux kernel has DISK_MAX_PARTS=256, but it's too much for
		 * generic Linux machine -- let start with 32 partitions. */
		void *tmp = xrealloc(ls->parts, (ls->nparts_max + 32) *
					sizeof(struct blkid_struct_partition));
		ls->parts = tmp;
		ls->nparts_max += 32;
	}

	par = &ls->parts[ls->nparts++];
	memset(par, 0, sizeof(struct blkid_struct_partition));

	tab->nparts++;
	par->tab = tab;
	par->partno = blkid_partlist_increment_partno(ls);

	return par;
}

static blkid_partition blkid_partlist_add_partition(blkid_partlist ls,
					blkid_parttable tab, uint64_t start, uint64_t size)
{
	blkid_partition par = new_partition(ls, tab);

	par->start = start;
	par->size = size;

	return par;
}

/* for internal usage only */
static inline blkid_partlist blkid_probe_get_partlist(blkid_probe pr)
{
	return (blkid_partlist) pr->chains[BLKID_CHAIN_PARTS].data;
}

static blkid_parttable
blkid_partlist_new_parttable(blkid_partlist ls, const char *type, uint64_t offset)
{
	blkid_parttable tab;

	tab = zmalloc(sizeof(struct blkid_struct_parttable));
	tab->type = type;
	tab->offset = offset;
	tab->parent = ls->next_parent;

	INIT_LIST_HEAD(&tab->t_tabs);
	list_add_tail(&tab->t_tabs, &ls->l_tabs);

	return tab;
}


/* probe for *alone* protective MBR */
static int probe_pmbr_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int has = 0;
	struct gpt_entry_blkid *e;
	uint64_t lastlba = 0;
	struct gpt_header_blkid hdr;

	if (last_lba(pr, &lastlba))
		goto nothing;

	is_pmbr_valid(pr, &has);
	if (!has)
		goto nothing;

	if (!get_gpt_header(pr, &hdr, &e, GPT_PRIMARY_LBA, lastlba) &&
	    !get_gpt_header(pr, &hdr, &e, lastlba, lastlba))
		return 0;
nothing:
	return 1;
}

static const struct blkid_idinfo pmbr_pt_idinfo =
{
	.name           = "PMBR",
	.probefunc      = probe_pmbr_pt,
	.magics         =
	{
		{ .magic = "\x55\xAA", .len = 2, .sboff = 510 },
		{ NULL }
	}
};


#define APFS_CONTAINER_SUPERBLOCK_TYPE 1
#define APFS_CONTAINER_SUPERBLOCK_SUBTYPE 0
#define APFS_STANDARD_BLOCK_SIZE 4096

/* This struct is much longer than this, but this seems
 * to contain the useful bits (for now).
 *
 * All values are little-endian. */
struct apfs_super_block {
	// Generic part to all APFS objects
	uint64_t checksum;
	uint64_t oid;
	uint64_t xid;
	uint16_t type;
	uint16_t flags;
	uint16_t subtype;
	uint16_t pad;

	// Specific to container header
	uint32_t magic; // 'NXSB'
	uint32_t block_size;
	uint64_t block_count;
	uint64_t features;
	uint64_t read_only_features;
	uint64_t incompatible_features;
	uint8_t uuid[16];
};

static int probe_apfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct apfs_super_block *sb;

	sb = blkid_probe_get_sb(pr, mag, struct apfs_super_block);
	if (!sb)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (le16_to_cpu(sb->type) != APFS_CONTAINER_SUPERBLOCK_TYPE)
		return BLKID_PROBE_NONE;

	if (le16_to_cpu(sb->subtype) != APFS_CONTAINER_SUPERBLOCK_SUBTYPE)
		return BLKID_PROBE_NONE;

	if (le16_to_cpu(sb->pad) != 0)
		return BLKID_PROBE_NONE;

	/* This check is pretty draconian, but should avoid false
	 * positives. Can be improved as more APFS documentation
	 * is published. */
	if (le32_to_cpu(sb->block_size) != APFS_STANDARD_BLOCK_SIZE)
		return BLKID_PROBE_NONE;

	if (blkid_probe_set_uuid(pr, sb->uuid) < 0)
		return BLKID_PROBE_NONE;

	return BLKID_PROBE_OK;
}

static const struct blkid_idinfo apfs_idinfo =
{
	.name           = "apfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_apfs,
	.magics         =
	{
		{ .magic = "NXSB", .len = 4, .sboff = 32 },
		{ NULL }
	}
};

struct vdo_super_block {
	char magic[8];                  /* magic number 'dmvdo001' */
	char unused[32];                /* 32 bytes of unimportant space */
	unsigned char sb_uuid[16];      /* vdo unique id */

	/* this is not all... but enough for libblkid */
} __attribute__((packed));

static int probe_vdo(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct vdo_super_block *vsb;

	vsb = blkid_probe_get_sb(pr, mag, struct vdo_super_block);
	if (!vsb)
		return errno ? -errno : 1;

	blkid_probe_set_uuid(pr, vsb->sb_uuid);
	return 0;
}

static const struct blkid_idinfo vdo_idinfo =
{
	.name           = "vdo",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_vdo,
	.magics         =
	{
		{ .magic = "dmvdo001", .len = 8 },
		{ NULL }
	}
};


#define SB_LABEL_SIZE      32
#define SB_JOURNAL_BUCKETS 256U

#define node(i, j)         ((i)->d + (j))
#define end(i)             node(i, le16_to_cpu((i)->keys))

struct bcache_super_block {
	uint64_t                csum;
	uint64_t                offset; /* sector where this sb was written */
	uint64_t                version;

	uint8_t                 magic[16];

	uint8_t                 uuid[16];
	union {
		uint8_t         set_uuid[16];
		uint64_t        set_magic;
	};
	uint8_t                 label[SB_LABEL_SIZE];

	uint64_t                flags;
	uint64_t                seq;
	uint64_t                pad[8];

	union {
	struct {
		/* Cache devices */
		uint64_t        nbuckets;       /* device size */

		uint16_t        block_size;     /* sectors */
		uint16_t        bucket_size;    /* sectors */

		uint16_t        nr_in_set;
		uint16_t        nr_this_dev;
	};
	struct {
		/* Backing devices */
		uint64_t        data_offset;

		/* block_size from the cache device section is still used by
		 * backing devices, so don't add anything here until we fix
		 * things to not need it for backing devices anymore */
	};
	};

	uint32_t                last_mount;     /* time_t */

	uint16_t                first_bucket;
	union {
		uint16_t        njournal_buckets;
		uint16_t        keys;
	};
	uint64_t                d[SB_JOURNAL_BUCKETS];  /* journal buckets */
};

/* magic string */
#define BCACHE_SB_MAGIC     "\xc6\x85\x73\xf6\x4e\x1a\x45\xca\x82\x65\xf5\x7f\x48\xba\x6d\x81"
/* magic string len */
#define BCACHE_SB_MAGIC_LEN (sizeof(BCACHE_SB_MAGIC) - 1)
/* super block offset */
#define BCACHE_SB_OFF       0x1000
/* supper block offset in kB */
#define BCACHE_SB_KBOFF     (BCACHE_SB_OFF >> 10)
/* magic string offset within super block */
#define BCACHE_SB_MAGIC_OFF offsetof (struct bcache_super_block, magic)

static int probe_bcache (blkid_probe pr, const struct blkid_idmag *mag)
{
	struct bcache_super_block *bcs;

	bcs = blkid_probe_get_sb(pr, mag, struct bcache_super_block);
	if (!bcs)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (le64_to_cpu(bcs->offset) != BCACHE_SB_OFF / 512)
		return BLKID_PROBE_NONE;

	if (blkid_probe_set_uuid(pr, bcs->uuid) < 0)
		return BLKID_PROBE_NONE;

	return BLKID_PROBE_OK;
}

static const struct blkid_idinfo bcache_idinfo =
{
	.name           = "bcache",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_bcache,
	.minsz          = 8192,
	.magics         =
	{
		{
			.magic = BCACHE_SB_MAGIC,
			.len   = BCACHE_SB_MAGIC_LEN,
			.kboff = BCACHE_SB_KBOFF,
			.sboff = BCACHE_SB_MAGIC_OFF
		},
		{ NULL }
	}
};

struct nv_metadata {
	uint8_t         vendor[8];
	uint32_t        size;
	uint32_t        chksum;
	uint16_t        version;
} __attribute__((packed));

#define NVIDIA_SIGNATURE                "NVIDIA"

static int probe_nvraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct nv_metadata *nv;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200) - 2) * 0x200;
	nv = (struct nv_metadata *)
		blkid_probe_get_buffer(pr,
				off,
				sizeof(struct nv_metadata));
	if (!nv)
		return errno ? -errno : 1;

	if (memcmp(nv->vendor, NVIDIA_SIGNATURE, sizeof(NVIDIA_SIGNATURE)-1) != 0)
		return 1;
	blkid_probe_sprintf_version(pr, "%u", le16_to_cpu(nv->version));
	if (blkid_probe_set_magic(pr, off, sizeof(nv->vendor),
				(unsigned char *) nv->vendor))
		return 1;
	return 0;
}

static const struct blkid_idinfo nvraid_idinfo = {
	.name           = "nvidia_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_nvraid,
	.magics         = BLKID_NONE_MAGIC
};


struct sqsh_super_block {
	uint32_t        s_magic;
	uint32_t        inodes;
	uint32_t        bytes_used_2;
	uint32_t        uid_start_2;
	uint32_t        guid_start_2;
	uint32_t        inode_table_start_2;
	uint32_t        directory_table_start_2;
	uint16_t        s_major;
	uint16_t        s_minor;
} __attribute__((packed));

static int probe_squashfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct sqsh_super_block *sq;
	uint16_t vermaj;
	uint16_t vermin;

	sq = blkid_probe_get_sb(pr, mag, struct sqsh_super_block);
	if (!sq)
		return errno ? -errno : 1;

	vermaj = le16_to_cpu(sq->s_major);
	vermin = le16_to_cpu(sq->s_minor);
	if (vermaj < 4)
		return 1;

	blkid_probe_sprintf_version(pr, "%u.%u", vermaj, vermin);
	return 0;
}

static int probe_squashfs3(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct sqsh_super_block *sq;
	uint16_t vermaj;
	uint16_t vermin;

	sq = blkid_probe_get_sb(pr, mag, struct sqsh_super_block);
	if (!sq)
		return errno ? -errno : 1;

	if (strcmp(mag->magic, "sqsh") == 0) {
		vermaj = be16_to_cpu(sq->s_major);
		vermin = be16_to_cpu(sq->s_minor);
	} else {
		vermaj = le16_to_cpu(sq->s_major);
		vermin = le16_to_cpu(sq->s_minor);
	}

	if (vermaj > 3)
		return 1;

	blkid_probe_sprintf_version(pr, "%u.%u", vermaj, vermin);
	return 0;
}

static const struct blkid_idinfo squashfs_idinfo =
{
	.name           = "squashfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_squashfs,
	.magics         =
	{
		{ .magic = "hsqs", .len = 4 },
		{ NULL }
	}
};

static const struct blkid_idinfo squashfs3_idinfo =
{
	.name           = "squashfs3",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_squashfs3,
	.magics         =
	{
		{ .magic = "sqsh", .len = 4 }, /* big endian */
		{ .magic = "hsqs", .len = 4 }, /* little endian */
		{ NULL }
	}
};


/* Every UBIFS node starts with this common part. If the node has a key, the
 * key always goes next. */
struct ubifs_ch {
	uint32_t magic;
	uint32_t crc;
	uint64_t sqnum;
	uint32_t len;
	uint8_t node_type;
	uint8_t group_type;
	uint8_t padding[2];
} __attribute__ ((packed));

/* superblock node. */
struct ubifs_sb_node {
	struct ubifs_ch ch;
	uint8_t padding[2];
	uint8_t key_hash;
	uint8_t key_fmt;
	uint32_t flags;
	uint32_t min_io_size;
	uint32_t leb_size;
	uint32_t leb_cnt;
	uint32_t max_leb_cnt;
	uint64_t max_bud_bytes;
	uint32_t log_lebs;
	uint32_t lpt_lebs;
	uint32_t orph_lebs;
	uint32_t jhead_cnt;
	uint32_t fanout;
	uint32_t lsave_cnt;
	uint32_t fmt_version;
	uint16_t default_compr;
	uint8_t padding1[2];
	uint32_t rp_uid;
	uint32_t rp_gid;
	uint64_t rp_size;
	uint32_t time_gran;
	uint8_t uuid[16];
	uint32_t ro_compat_version;
	uint8_t padding2[3968];
} __attribute__ ((packed));

static int probe_ubifs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct ubifs_sb_node *sb;

	sb = blkid_probe_get_sb(pr, mag, struct ubifs_sb_node);
	if (!sb)
		return errno ? -errno : 1;

	blkid_probe_set_uuid(pr, sb->uuid);
	blkid_probe_sprintf_version(pr, "w%dr%d",
			le32_to_cpu(sb->fmt_version),
			le32_to_cpu(sb->ro_compat_version));
	return 0;
}

static const struct blkid_idinfo ubifs_idinfo =
{
	.name           = "ubifs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ubifs,
	.magics         =
	{
		{ .magic = "\x31\x18\x10\x06", .len = 4 },
		{ NULL }
	}
};

struct isw_metadata {
	uint8_t         sig[32];
	uint32_t        check_sum;
	uint32_t        mpb_size;
	uint32_t        family_num;
	uint32_t        generation_num;
};

#define ISW_SIGNATURE           "Intel Raid ISM Cfg Sig. "

static int probe_iswraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	unsigned int sector_size;
	struct isw_metadata *isw;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	sector_size = blkid_probe_get_sectorsize(pr);
	off = ((pr->size / sector_size) - 2) * sector_size;

	isw = (struct isw_metadata *)blkid_probe_get_buffer(pr,
			off, sizeof(struct isw_metadata));
	if (!isw)
		return errno ? -errno : 1;

	if (memcmp(isw->sig, ISW_SIGNATURE, sizeof(ISW_SIGNATURE)-1) != 0)
		return 1;

	blkid_probe_sprintf_version(pr, "%6s", &isw->sig[sizeof(ISW_SIGNATURE)-1]);
	if (blkid_probe_set_magic(pr, off, sizeof(isw->sig),
				(unsigned char *) isw->sig))
		return 1;
	return 0;
}

static const struct blkid_idinfo iswraid_idinfo = {
	.name           = "isw_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_iswraid,
	.magics         = BLKID_NONE_MAGIC
};



struct log_header_t {
	uint64_t magic;
	uint64_t version;

	unsigned char uuid[16];

	uint64_t flags;
} __attribute__((packed));


static int probe_drbdproxy_datalog(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct log_header_t *lh;

	lh = (struct log_header_t *) blkid_probe_get_buffer(pr, 0, sizeof(*lh));
	if (!lh)
		return errno ? -errno : 1;

	blkid_probe_set_uuid(pr, lh->uuid);
	blkid_probe_sprintf_version(pr, "v%"PRIu64, le64_to_cpu(lh->version));
	return 0;
}

static const struct blkid_idinfo drbdproxy_datalog_idinfo =
{
	.name           = "drbdproxy_datalog",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_drbdproxy_datalog,
	.minsz          = 16*1024,
	.magics         =
	{
		{ .magic = "DRBDdlh*", .len = 8, .sboff = 0, .kboff = 0 },
		{ NULL }
	}
};

struct adaptec_metadata
{
	uint32_t        b0idcode;
	uint8_t         lunsave[8];
	uint16_t        sdtype;
	uint16_t        ssavecyl;
	uint8_t         ssavehed;
	uint8_t         ssavesec;
	uint8_t         sb0flags;
	uint8_t         jbodEnable;
	uint8_t         lundsave;
	uint8_t         svpdirty;
	uint16_t        biosInfo;
	uint16_t        svwbskip;
	uint16_t        svwbcln;
	uint16_t        svwbmax;
	uint16_t        res3;
	uint16_t        svwbmin;
	uint16_t        res4;
	uint16_t        svrcacth;
	uint16_t        svwcacth;
	uint16_t        svwbdly;
	uint8_t         svsdtime;
	uint8_t         res5;
	uint16_t        firmval;
	uint16_t        firmbln;
	uint32_t        firmblk;
	uint32_t        fstrsvrb;
	uint16_t        svBlockStorageTid;
	uint16_t        svtid;
	uint8_t         svseccfl;
	uint8_t         res6;
	uint8_t         svhbanum;
	uint8_t         resver;
	uint32_t        drivemagic;
	uint8_t         reserved[20];
	uint8_t         testnum;
	uint8_t         testflags;
	uint16_t        maxErrorCount;
	uint32_t        count;
	uint32_t        startTime;
	uint32_t        interval;
	uint8_t         tstxt0;
	uint8_t         tstxt1;
	uint8_t         serNum[32];
	uint8_t         res8[102];
	uint32_t        fwTestMagic;
	uint32_t        fwTestSeqNum;
	uint8_t         fwTestRes[8];
	uint32_t        smagic;
	uint32_t        raidtbl;
	uint16_t        raidline;
	uint8_t         res9[0xF6];
} __attribute__((packed));

#define AD_SIGNATURE    0x4450544D      /* "DPTM" */
#define AD_MAGIC        0x37FC4D1E

static int probe_adraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct adaptec_metadata *ad;

	if (pr->size < 0x10000)
		return BLKID_PROBE_NONE;

	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return BLKID_PROBE_NONE;

	off = ((pr->size / 0x200)-1) * 0x200;
	ad = (struct adaptec_metadata *)
			blkid_probe_get_buffer(pr,
					off,
					sizeof(struct adaptec_metadata));
	if (!ad)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (ad->smagic != be32_to_cpu(AD_SIGNATURE))
		return BLKID_PROBE_NONE;
	if (ad->b0idcode != be32_to_cpu(AD_MAGIC))
		return BLKID_PROBE_NONE;
	blkid_probe_sprintf_version(pr, "%u", ad->resver);
	if (blkid_probe_set_magic(pr, off, sizeof(ad->b0idcode),
				(unsigned char *) &ad->b0idcode))
		return BLKID_PROBE_NONE;

	return BLKID_PROBE_OK;
}

static const struct blkid_idinfo adraid_idinfo = {
	.name           = "adaptec_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_adraid,
	.magics         = BLKID_NONE_MAGIC
};


struct netware_super_block {
	uint8_t         SBH_Signature[4];
	uint16_t        SBH_VersionMajor;
	uint16_t        SBH_VersionMinor;
	uint16_t        SBH_VersionMediaMajor;
	uint16_t        SBH_VersionMediaMinor;
	uint32_t        SBH_ItemsMoved;
	uint8_t         SBH_InternalID[16];
	uint32_t        SBH_PackedSize;
	uint32_t        SBH_Checksum;
	uint32_t        supersyncid;
	int64_t         superlocation[4];
	uint32_t        physSizeUsed;
	uint32_t        sizeUsed;
	uint32_t        superTimeStamp;
	uint32_t        reserved0[1];
	int64_t         SBH_LoggedPoolDataBlk;
	int64_t         SBH_PoolDataBlk;
	uint8_t         SBH_OldInternalID[16];
	uint32_t        SBH_PoolToLVStartUTC;
	uint32_t        SBH_PoolToLVEndUTC;
	uint16_t        SBH_VersionMediaMajorCreate;
	uint16_t        SBH_VersionMediaMinorCreate;
	uint32_t        SBH_BlocksMoved;
	uint32_t        SBH_TempBTSpBlk;
	uint32_t        SBH_TempFTSpBlk;
	uint32_t        SBH_TempFTSpBlk1;
	uint32_t        SBH_TempFTSpBlk2;
	uint32_t        nssMagicNumber;
	uint32_t        poolClassID;
	uint32_t        poolID;
	uint32_t        createTime;
	int64_t         SBH_LoggedVolumeDataBlk;
	int64_t         SBH_VolumeDataBlk;
	int64_t         SBH_SystemBeastBlkNum;
	uint64_t        totalblocks;
	uint16_t        SBH_Name[64];
	uint8_t         SBH_VolumeID[16];
	uint8_t         SBH_PoolID[16];
	uint8_t         SBH_PoolInternalID[16];
	uint64_t        SBH_Lsn;
	uint32_t        SBH_SS_Enabled;
	uint32_t        SBH_SS_CreateTime;
	uint8_t         SBH_SS_OriginalPoolID[16];
	uint8_t         SBH_SS_OriginalVolumeID[16];
	uint8_t         SBH_SS_Guid[16];
	uint16_t        SBH_SS_OriginalName[64];
	uint32_t        reserved2[64-(2+46)];
} __attribute__((__packed__));

static int probe_netware(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct netware_super_block *nw;

	nw = blkid_probe_get_sb(pr, mag, struct netware_super_block);
	if (!nw)
		return errno ? -errno : 1;

	blkid_probe_set_uuid(pr, nw->SBH_PoolID);

	blkid_probe_sprintf_version(pr, "%u.%02u",
		 le16_to_cpu(nw->SBH_VersionMediaMajor),
		 le16_to_cpu(nw->SBH_VersionMediaMinor));
	return 0;
}

static const struct blkid_idinfo netware_idinfo =
{
	.name           = "nss",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_netware,
	.magics         =
	{
		{ .magic = "SPB5", .len = 4, .kboff = 4 },
		{ NULL }
	}
};


struct jm_metadata {
	int8_t          signature[2];
	uint8_t         minor_version;
	uint8_t         major_version;
	uint16_t        checksum;
};

#define JM_SIGNATURE            "JM"

static int probe_jmraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct jm_metadata *jm;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200) - 1) * 0x200;
	jm = (struct jm_metadata *)
		blkid_probe_get_buffer(pr,
				off,
				sizeof(struct jm_metadata));
	if (!jm)
		return errno ? -errno : 1;

	if (memcmp(jm->signature, JM_SIGNATURE, sizeof(JM_SIGNATURE) - 1) != 0)
		return 1;
	blkid_probe_sprintf_version(pr, "%u.%u", jm->major_version, jm->minor_version);
	if (blkid_probe_set_magic(pr, off, sizeof(jm->signature),
				(unsigned char *) jm->signature))
		return 1;
	return 0;
}

static const struct blkid_idinfo jmraid_idinfo = {
	.name           = "jmicron_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_jmraid,
	.magics         = BLKID_NONE_MAGIC
};


struct via_metadata {
	uint16_t        signature;
	uint8_t         version_number;
	struct via_array {
		uint16_t        disk_bit_mask;
		uint8_t         disk_array_ex;
		uint32_t        capacity_low;
		uint32_t        capacity_high;
		uint32_t        serial_checksum;
	} __attribute__((packed)) array;
	uint32_t        serial_checksum[8];
	uint8_t         checksum;
} __attribute__((packed));

#define VIA_SIGNATURE           0xAA55

/* 8 bit checksum on first 50 bytes of metadata. */
static uint8_t via_checksum(struct via_metadata *v)
{
	uint8_t i = 50, cs = 0;

	while (i--)
		cs += ((uint8_t*) v)[i];

	return cs;
}

static int probe_viaraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct via_metadata *v;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200)-1) * 0x200;

	v = (struct via_metadata *)
			blkid_probe_get_buffer(pr,
				off,
				sizeof(struct via_metadata));
	if (!v)
		return errno ? -errno : 1;

	if (le16_to_cpu(v->signature) != VIA_SIGNATURE)
		return 1;
	if (v->version_number > 2)
		return 1;
	if (!blkid_probe_verify_csum(pr, via_checksum(v), v->checksum))
		return 1;

	blkid_probe_sprintf_version(pr, "%u", v->version_number);
	if (blkid_probe_set_magic(pr, off,
				sizeof(v->signature),
				(unsigned char *) &v->signature))
		return 1;
	return 0;
}

static const struct blkid_idinfo viaraid_idinfo = {
	.name           = "via_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_viaraid,
	.magics         = BLKID_NONE_MAGIC
};


struct vxfs_super_block {
	uint32_t                vs_magic;
	int32_t                 vs_version;
};

static int probe_vxfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct vxfs_super_block *vxs;

	vxs = blkid_probe_get_sb(pr, mag, struct vxfs_super_block);
	if (!vxs)
		return errno ? -errno : 1;

	blkid_probe_sprintf_version(pr, "%u", (unsigned int) vxs->vs_version);
	return 0;
}


static const struct blkid_idinfo vxfs_idinfo =
{
	.name           = "vxfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_vxfs,
	.magics         =
	{
		{ .magic = "\365\374\001\245", .len = 4, .kboff = 1 },
		{ NULL }
	}
};

struct silicon_metadata {
	uint8_t         unknown0[0x2E];
	uint8_t         ascii_version[0x36 - 0x2E];
	int8_t          diskname[0x56 - 0x36];
	int8_t          unknown1[0x60 - 0x56];
	uint32_t        magic;
	int8_t          unknown1a[0x6C - 0x64];
	uint32_t        array_sectors_low;
	uint32_t        array_sectors_high;
	int8_t          unknown2[0x78 - 0x74];
	uint32_t        thisdisk_sectors;
	int8_t          unknown3[0x100 - 0x7C];
	int8_t          unknown4[0x104 - 0x100];
	uint16_t        product_id;
	uint16_t        vendor_id;
	uint16_t        minor_ver;
	uint16_t        major_ver;
	uint8_t         seconds;
	uint8_t         minutes;
	uint8_t         hour;
	uint8_t         day;
	uint8_t         month;
	uint8_t         year;
	uint16_t        raid0_stride;
	int8_t          unknown6[0x116 - 0x114];
	uint8_t         disk_number;
	uint8_t         type;                   /* SILICON_TYPE_* */
	int8_t          drives_per_striped_set;
	int8_t          striped_set_number;
	int8_t          drives_per_mirrored_set;
	int8_t          mirrored_set_number;
	uint32_t        rebuild_ptr_low;
	uint32_t        rebuild_ptr_high;
	uint32_t        incarnation_no;
	uint8_t         member_status;
	uint8_t         mirrored_set_state;     /* SILICON_MIRROR_* */
	uint8_t         reported_device_location;
	uint8_t         idechannel;
	uint8_t         auto_rebuild;
	uint8_t         unknown8;
	uint8_t         text_type[0x13E - 0x12E];
	uint16_t        checksum1;
	int8_t          assumed_zeros[0x1FE - 0x140];
	uint16_t        checksum2;
} __attribute__((packed));

#define SILICON_MAGIC           0x2F000000

static uint16_t silraid_checksum(struct silicon_metadata *sil)
{
	int sum = 0;
	unsigned short count = offsetof(struct silicon_metadata, checksum1) / 2;
	uint16_t *p, sil_buf[sizeof(struct silicon_metadata)/sizeof(uint16_t)];

	p = memcpy(sil_buf, sil, sizeof(struct silicon_metadata));

	while (count--) {
		uint16_t x = *p++;
		sum += le16_to_cpu(x);
	}

	return (-sum & 0xFFFF);
}

static int probe_silraid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t off;
	struct silicon_metadata *sil;

	if (pr->size < 0x10000)
		return 1;
	if (!S_ISREG(pr->mode) && !blkid_probe_is_wholedisk(pr))
		return 1;

	off = ((pr->size / 0x200) - 1) * 0x200;

	sil = (struct silicon_metadata *)blkid_probe_get_buffer(pr, off,
						sizeof(struct silicon_metadata));
	if (!sil)
		return errno ? -errno : 1;

	if (le32_to_cpu(sil->magic) != SILICON_MAGIC)
		return 1;
	if (sil->disk_number >= 8)
		return 1;
	if (!blkid_probe_verify_csum(pr, silraid_checksum(sil), le16_to_cpu(sil->checksum1)))
		return 1;

	blkid_probe_sprintf_version(pr, "%u.%u", le16_to_cpu(sil->major_ver), le16_to_cpu(sil->minor_ver));
	if (blkid_probe_set_magic(pr,
			off + offsetof(struct silicon_metadata, magic),
			sizeof(sil->magic),
			(unsigned char *) &sil->magic))
		return 1;
	return 0;
}

static const struct blkid_idinfo silraid_idinfo = {
	.name           = "silicon_medley_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_silraid,
	.magics         = BLKID_NONE_MAGIC
};

struct jfs_super_block {
	unsigned char   js_magic[4];
	uint32_t        js_version;
	uint64_t        js_size;
	uint32_t        js_bsize;       /* 4: aggregate block size in bytes */
	uint16_t        js_l2bsize;     /* 2: log2 of s_bsize */
	uint16_t        js_l2bfactor;   /* 2: log2(s_bsize/hardware block size) */
	uint32_t        js_pbsize;      /* 4: hardware/LVM block size in bytes */
	uint16_t        js_l2pbsize;    /* 2: log2 of s_pbsize */
	uint16_t        js_pad;         /* 2: padding necessary for alignment */
	uint32_t        js_dummy2[26];
	unsigned char   js_uuid[16];
	unsigned char   js_label[16];
	unsigned char   js_loguuid[16];
};

static int probe_jfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct jfs_super_block *js;

	js = blkid_probe_get_sb(pr, mag, struct jfs_super_block);
	if (!js)
		return errno ? -errno : 1;
	if (le32_to_cpu(js->js_bsize) != (1U << le16_to_cpu(js->js_l2bsize)))
		return 1;
	if (le32_to_cpu(js->js_pbsize) != (1U << le16_to_cpu(js->js_l2pbsize)))
		return 1;
	if ((le16_to_cpu(js->js_l2bsize) - le16_to_cpu(js->js_l2pbsize)) !=
	    le16_to_cpu(js->js_l2bfactor))
		return 1;

	if (*((char *) js->js_label) != '\0')
		blkid_probe_set_label(pr, js->js_label, sizeof(js->js_label));
	blkid_probe_set_uuid(pr, js->js_uuid);
	return 0;
}

static const struct blkid_idinfo jfs_idinfo =
{
	.name           = "jfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_jfs,
	.minsz          = 16 * 1024 * 1024,
	.magics         =
	{
		{ .magic = "JFS1", .len = 4, .kboff = 32 },
		{ NULL }
	}
};

struct ocfs_volume_header {
	unsigned char   minor_version[4];
	unsigned char   major_version[4];
	unsigned char   signature[128];
	char            mount[128];
	unsigned char   mount_len[2];
} __attribute__((packed));

struct ocfs_volume_label {
	unsigned char   disk_lock[48];
	char            label[64];
	unsigned char   label_len[2];
	unsigned char   vol_id[16];
	unsigned char   vol_id_len[2];
} __attribute__((packed));

#define ocfsmajor(o) ( (uint32_t) o.major_version[0] \
		   + (((uint32_t) o.major_version[1]) << 8) \
		   + (((uint32_t) o.major_version[2]) << 16) \
		   + (((uint32_t) o.major_version[3]) << 24))

#define ocfsminor(o) ( (uint32_t) o.minor_version[0] \
		   + (((uint32_t) o.minor_version[1]) << 8) \
		   + (((uint32_t) o.minor_version[2]) << 16) \
		   + (((uint32_t) o.minor_version[3]) << 24))

#define ocfslabellen(o) ((uint32_t)o.label_len[0] + (((uint32_t) o.label_len[1]) << 8))
#define ocfsmountlen(o) ((uint32_t)o.mount_len[0] + (((uint32_t) o.mount_len[1]) << 8))

struct ocfs2_super_block {
	uint8_t         i_signature[8];
	uint32_t        i_generation;
	int16_t         i_suballoc_slot;
	uint16_t        i_suballoc_bit;
	uint32_t        i_reserved0;
	uint32_t        i_clusters;
	uint32_t        i_uid;
	uint32_t        i_gid;
	uint64_t        i_size;
	uint16_t        i_mode;
	uint16_t        i_links_count;
	uint32_t        i_flags;
	uint64_t        i_atime;
	uint64_t        i_ctime;
	uint64_t        i_mtime;
	uint64_t        i_dtime;
	uint64_t        i_blkno;
	uint64_t        i_last_eb_blk;
	uint32_t        i_fs_generation;
	uint32_t        i_atime_nsec;
	uint32_t        i_ctime_nsec;
	uint32_t        i_mtime_nsec;
	uint64_t        i_reserved1[9];
	uint64_t        i_pad1;
	uint16_t        s_major_rev_level;
	uint16_t        s_minor_rev_level;
	uint16_t        s_mnt_count;
	int16_t         s_max_mnt_count;
	uint16_t        s_state;
	uint16_t        s_errors;
	uint32_t        s_checkinterval;
	uint64_t        s_lastcheck;
	uint32_t        s_creator_os;
	uint32_t        s_feature_compat;
	uint32_t        s_feature_incompat;
	uint32_t        s_feature_ro_compat;
	uint64_t        s_root_blkno;
	uint64_t        s_system_dir_blkno;
	uint32_t        s_blocksize_bits;
	uint32_t        s_clustersize_bits;
	uint16_t        s_max_slots;
	uint16_t        s_reserved1;
	uint32_t        s_reserved2;
	uint64_t        s_first_cluster_group;
	uint8_t         s_label[64];
	uint8_t         s_uuid[16];
} __attribute__((packed));

struct oracle_asm_disk_label {
	char dummy[32];
	char dl_tag[8];
	char dl_id[24];
} __attribute__((packed));

static int probe_ocfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	unsigned char *buf;
	struct ocfs_volume_header ovh;
	struct ocfs_volume_label ovl;
	uint32_t maj, min;

	/* header */
	buf = blkid_probe_get_buffer(pr, mag->kboff << 10,
			sizeof(struct ocfs_volume_header));
	if (!buf)
		return errno ? -errno : 1;
	memcpy(&ovh, buf, sizeof(ovh));

	/* label */
	buf = blkid_probe_get_buffer(pr, (mag->kboff << 10) + 512,
			sizeof(struct ocfs_volume_label));
	if (!buf)
		return errno ? -errno : 1;
	memcpy(&ovl, buf, sizeof(ovl));

	maj = ocfsmajor(ovh);
	min = ocfsminor(ovh);

	if (maj == 1)
		blkid_probe_set_value(pr, "SEC_TYPE", (unsigned char *) "ocfs1", sizeof("ocfs1"));
	else if (maj >= 9)
		blkid_probe_set_value(pr, "SEC_TYPE", (unsigned char *) "ntocfs", sizeof("ntocfs"));

	blkid_probe_set_label(pr, (unsigned char *) ovl.label, ocfslabellen(ovl));
	blkid_probe_set_value(pr, "MOUNT", (unsigned char *) ovh.mount, ocfsmountlen(ovh));
	blkid_probe_set_uuid(pr, ovl.vol_id);
	blkid_probe_sprintf_version(pr, "%u.%u", maj, min);
	return 0;
}

static int probe_ocfs2(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct ocfs2_super_block *osb;

	osb = blkid_probe_get_sb(pr, mag, struct ocfs2_super_block);
	if (!osb)
		return errno ? -errno : 1;

	blkid_probe_set_label(pr, (unsigned char *) osb->s_label, sizeof(osb->s_label));
	blkid_probe_set_uuid(pr, osb->s_uuid);

	blkid_probe_sprintf_version(pr, "%u.%u",
		le16_to_cpu(osb->s_major_rev_level),
		le16_to_cpu(osb->s_minor_rev_level));

	return 0;
}

static int probe_oracleasm(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct oracle_asm_disk_label *dl;

	dl = blkid_probe_get_sb(pr, mag, struct oracle_asm_disk_label);
	if (!dl)
		return errno ? -errno : 1;

	blkid_probe_set_label(pr, (unsigned char *) dl->dl_id, sizeof(dl->dl_id));
	return 0;
}


static const struct blkid_idinfo ocfs_idinfo =
{
	.name           = "ocfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ocfs,
	.minsz          = 14000 * 1024,
	.magics         =
	{
		{ .magic = "OracleCFS", .len = 9, .kboff = 8 },
		{ NULL }
	}
};

static const struct blkid_idinfo ocfs2_idinfo =
{
	.name           = "ocfs2",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ocfs2,
	.minsz          = 14000 * 1024,
	.magics         =
	{
		{ .magic = "OCFSV2", .len = 6, .kboff = 1 },
		{ .magic = "OCFSV2", .len = 6, .kboff = 2 },
		{ .magic = "OCFSV2", .len = 6, .kboff = 4 },
		{ .magic = "OCFSV2", .len = 6, .kboff = 8 },
		{ NULL }
	}
};

/* Oracle ASM (Automatic Storage Management) */
static const struct blkid_idinfo oracleasm_idinfo =
{
	.name           = "oracleasm",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_oracleasm,
	.magics         =
	{
		{ .magic = "ORCLDISK", .len = 8, .sboff = 32 },
		{ NULL }
	}
};

struct exfs_super_block {
	uint32_t        sb_magicnum;    /* magic number == EXFS_SB_MAGIC */
	uint32_t        sb_blocksize;   /* logical block size, bytes */
	uint64_t        sb_dblocks;     /* number of data blocks */
	uint64_t        sb_rblocks;     /* number of realtime blocks */
	uint64_t        sb_rextents;    /* number of realtime extents */
	unsigned char   sb_uuid[16];    /* file system unique id */
	uint64_t        sb_logstart;    /* starting block of log if internal */
	uint64_t        sb_rootino;     /* root inode number */
	uint64_t        sb_rbmino;      /* bitmap inode for realtime extents */
	uint64_t        sb_rsumino;     /* summary inode for rt bitmap */
	uint32_t        sb_rextsize;    /* realtime extent size, blocks */
	uint32_t        sb_agblocks;    /* size of an allocation group */
	uint32_t        sb_agcount;     /* number of allocation groups */
	uint32_t        sb_rbmblocks;   /* number of rt bitmap blocks */
	uint32_t        sb_logblocks;   /* number of log blocks */

	uint16_t        sb_versionnum;  /* header version == EXFS_SB_VERSION */
	uint16_t        sb_sectsize;    /* volume sector size, bytes */
	uint16_t        sb_inodesize;   /* inode size, bytes */
	uint16_t        sb_inopblock;   /* inodes per block */
	char            sb_fname[12];   /* file system name */
	uint8_t         sb_blocklog;    /* log2 of sb_blocksize */
	uint8_t         sb_sectlog;     /* log2 of sb_sectsize */
	uint8_t         sb_inodelog;    /* log2 of sb_inodesize */
	uint8_t         sb_inopblog;    /* log2 of sb_inopblock */
	uint8_t         sb_agblklog;    /* log2 of sb_agblocks (rounded up) */
	uint8_t         sb_rextslog;    /* log2 of sb_rextents */
	uint8_t         sb_inprogress;  /* mkfs is in progress, don't mount */
	uint8_t         sb_imax_pct;    /* max % of fs for inode space */
					/* statistics */
	uint64_t        sb_icount;      /* allocated inodes */
	uint64_t        sb_ifree;       /* free inodes */
	uint64_t        sb_fdblocks;    /* free data blocks */
	uint64_t        sb_frextents;   /* free realtime extents */

	/* this is not all... but enough for libblkid */

} __attribute__((packed));

#define EXFS_MIN_BLOCKSIZE_LOG  9       /* i.e. 512 bytes */
#define EXFS_MAX_BLOCKSIZE_LOG  16      /* i.e. 65536 bytes */
#define EXFS_MIN_BLOCKSIZE      (1 << EXFS_MIN_BLOCKSIZE_LOG)
#define EXFS_MAX_BLOCKSIZE      (1 << EXFS_MAX_BLOCKSIZE_LOG)
#define EXFS_MIN_SECTORSIZE_LOG 9       /* i.e. 512 bytes */
#define EXFS_MAX_SECTORSIZE_LOG 15      /* i.e. 32768 bytes */
#define EXFS_MIN_SECTORSIZE     (1 << EXFS_MIN_SECTORSIZE_LOG)
#define EXFS_MAX_SECTORSIZE     (1 << EXFS_MAX_SECTORSIZE_LOG)

#define EXFS_DINODE_MIN_LOG     8
#define EXFS_DINODE_MAX_LOG     11
#define EXFS_DINODE_MIN_SIZE    (1 << EXFS_DINODE_MIN_LOG)
#define EXFS_DINODE_MAX_SIZE    (1 << EXFS_DINODE_MAX_LOG)

#define EXFS_MAX_RTEXTSIZE      (1024 * 1024 * 1024)    /* 1GB */
#define EXFS_DFL_RTEXTSIZE      (64 * 1024)             /* 64kB */
#define EXFS_MIN_RTEXTSIZE      (4 * 1024)              /* 4kB */

#define EXFS_MIN_AG_BLOCKS      64
#define EXFS_MAX_DBLOCKS(s) ((uint64_t)(s)->sb_agcount * (s)->sb_agblocks)
#define EXFS_MIN_DBLOCKS(s) ((uint64_t)((s)->sb_agcount - 1) *  \
			 (s)->sb_agblocks + EXFS_MIN_AG_BLOCKS)


static void sb_from_disk(struct exfs_super_block *from,
			 struct exfs_super_block *to)
{

	to->sb_magicnum = be32_to_cpu(from->sb_magicnum);
	to->sb_blocksize = be32_to_cpu(from->sb_blocksize);
	to->sb_dblocks = be64_to_cpu(from->sb_dblocks);
	to->sb_rblocks = be64_to_cpu(from->sb_rblocks);
	to->sb_rextents = be64_to_cpu(from->sb_rextents);
	to->sb_logstart = be64_to_cpu(from->sb_logstart);
	to->sb_rootino = be64_to_cpu(from->sb_rootino);
	to->sb_rbmino = be64_to_cpu(from->sb_rbmino);
	to->sb_rsumino = be64_to_cpu(from->sb_rsumino);
	to->sb_rextsize = be32_to_cpu(from->sb_rextsize);
	to->sb_agblocks = be32_to_cpu(from->sb_agblocks);
	to->sb_agcount = be32_to_cpu(from->sb_agcount);
	to->sb_rbmblocks = be32_to_cpu(from->sb_rbmblocks);
	to->sb_logblocks = be32_to_cpu(from->sb_logblocks);
	to->sb_versionnum = be16_to_cpu(from->sb_versionnum);
	to->sb_sectsize = be16_to_cpu(from->sb_sectsize);
	to->sb_inodesize = be16_to_cpu(from->sb_inodesize);
	to->sb_inopblock = be16_to_cpu(from->sb_inopblock);
	to->sb_blocklog = from->sb_blocklog;
	to->sb_sectlog = from->sb_sectlog;
	to->sb_inodelog = from->sb_inodelog;
	to->sb_inopblog = from->sb_inopblog;
	to->sb_agblklog = from->sb_agblklog;
	to->sb_rextslog = from->sb_rextslog;
	to->sb_inprogress = from->sb_inprogress;
	to->sb_imax_pct = from->sb_imax_pct;
	to->sb_icount = be64_to_cpu(from->sb_icount);
	to->sb_ifree = be64_to_cpu(from->sb_ifree);
	to->sb_fdblocks = be64_to_cpu(from->sb_fdblocks);
	to->sb_frextents = be64_to_cpu(from->sb_frextents);
}

static int exfs_verify_sb(struct exfs_super_block *ondisk)
{
	struct exfs_super_block sb, *sbp = &sb;

	/* beXX_to_cpu(), but don't convert UUID and fsname! */
	sb_from_disk(ondisk, sbp);

	/* sanity checks, we don't want to rely on magic string only */
	if (sbp->sb_agcount <= 0                                        ||
	    sbp->sb_sectsize < EXFS_MIN_SECTORSIZE                      ||
	    sbp->sb_sectsize > EXFS_MAX_SECTORSIZE                      ||
	    sbp->sb_sectlog < EXFS_MIN_SECTORSIZE_LOG                   ||
	    sbp->sb_sectlog > EXFS_MAX_SECTORSIZE_LOG                   ||
	    sbp->sb_sectsize != (1 << sbp->sb_sectlog)                  ||
	    sbp->sb_blocksize < EXFS_MIN_BLOCKSIZE                      ||
	    sbp->sb_blocksize > EXFS_MAX_BLOCKSIZE                      ||
	    sbp->sb_blocklog < EXFS_MIN_BLOCKSIZE_LOG                   ||
	    sbp->sb_blocklog > EXFS_MAX_BLOCKSIZE_LOG                   ||
	    sbp->sb_blocksize != (1ULL << sbp->sb_blocklog)             ||
	    sbp->sb_inodesize < EXFS_DINODE_MIN_SIZE                    ||
	    sbp->sb_inodesize > EXFS_DINODE_MAX_SIZE                    ||
	    sbp->sb_inodelog < EXFS_DINODE_MIN_LOG                      ||
	    sbp->sb_inodelog > EXFS_DINODE_MAX_LOG                      ||
	    sbp->sb_inodesize != (1 << sbp->sb_inodelog)                ||
	    (sbp->sb_blocklog - sbp->sb_inodelog != sbp->sb_inopblog)   ||
	    (sbp->sb_rextsize * sbp->sb_blocksize > EXFS_MAX_RTEXTSIZE) ||
	    (sbp->sb_rextsize * sbp->sb_blocksize < EXFS_MIN_RTEXTSIZE) ||
	    (sbp->sb_imax_pct > 100 /* zero sb_imax_pct is valid */)    ||
	    sbp->sb_dblocks == 0                                        ||
	    sbp->sb_dblocks > EXFS_MAX_DBLOCKS(sbp)                     ||
	    sbp->sb_dblocks < EXFS_MIN_DBLOCKS(sbp))
		return 0;
	return 1;
}

static int probe_exfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct exfs_super_block *xs;

	xs = blkid_probe_get_sb(pr, mag, struct exfs_super_block);
	if (!xs)
		return errno ? -errno : 1;

	if (!exfs_verify_sb(xs))
		return 1;

	if (*xs->sb_fname != '\0')
		blkid_probe_set_label(pr, (unsigned char *) xs->sb_fname, sizeof(xs->sb_fname));
	blkid_probe_set_uuid(pr, xs->sb_uuid);
	return 0;
}

static const struct blkid_idinfo exfs_idinfo =
{
	.name           = "exfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_exfs,
	.magics         =
	{
		{ .magic = "EXFS", .len = 4 },
		{ NULL }
	}
};

/* This is written from scratch according to Linux kernel fs/sysv/super.c file.
 * It seems that sysv probing code in libvolume_id and also in the original
 * blkid is useless. */

#define XENIX_NICINOD                           100
#define XENIX_NICFREE                           100

struct xenix_super_block {
	uint16_t        s_isize;
	uint32_t        s_fsize;
	uint16_t        s_nfree;
	uint32_t        s_free[XENIX_NICFREE];
	uint16_t        s_ninode;
	uint16_t        s_inode[XENIX_NICINOD];
	uint8_t         s_flock;
	uint8_t         s_ilock;
	uint8_t         s_fmod;
	uint8_t         s_ronly;
	uint32_t        s_time;
	uint32_t        s_tfree;
	uint16_t        s_tinode;
	uint16_t        s_dinfo[4];
	uint8_t         s_fname[6];
	uint8_t         s_fpack[6];
	uint8_t         s_clean;
	uint8_t         s_fill[371];
	uint32_t        s_magic;
	uint32_t        s_type;
} __attribute__((packed));


#define SYSV_NICINOD                    100
#define SYSV_NICFREE                    50

struct sysv_super_block
{
	uint16_t        s_isize;
	uint16_t        s_pad0;
	uint32_t        s_fsize;
	uint16_t        s_nfree;
	uint16_t        s_pad1;
	uint32_t        s_free[SYSV_NICFREE];
	uint16_t        s_ninode;
	uint16_t        s_pad2;
	uint16_t        s_inode[SYSV_NICINOD];
	uint8_t         s_flock;
	uint8_t         s_ilock;
	uint8_t         s_fmod;
	uint8_t         s_ronly;
	uint32_t        s_time;
	uint16_t        s_dinfo[4];
	uint32_t        s_tfree;
	uint16_t        s_tinode;
	uint16_t        s_pad3;
	uint8_t         s_fname[6];
	uint8_t         s_fpack[6];
	uint32_t        s_fill[12];
	uint32_t        s_state;
	uint32_t        s_magic;
	uint32_t        s_type;
};

static int probe_xenix(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct xenix_super_block *sb;

	sb = blkid_probe_get_sb(pr, mag, struct xenix_super_block);
	if (!sb)
		return errno ? -errno : 1;
	blkid_probe_set_label(pr, sb->s_fname, sizeof(sb->s_fname));
	return 0;
}

#define SYSV_BLOCK_SIZE 1024

/* Note that we don't probe for Coherent FS, this FS does not have
 * magic string. (It requires to probe fname/fpack field..) */
static int probe_sysv(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct sysv_super_block *sb;
	int blocks[] = {0, 9, 15, 18};
	size_t i;

	for (i = 0; i < ARRAY_SIZE(blocks); i++) {
		int off = blocks[i] * SYSV_BLOCK_SIZE + SYSV_BLOCK_SIZE/2;

		sb = (struct sysv_super_block *)
			blkid_probe_get_buffer(pr,
					off,
					sizeof(struct sysv_super_block));
		if (!sb)
			return errno ? -errno : 1;

		if (sb->s_magic == cpu_to_le32(0xfd187e20) ||
		    sb->s_magic == cpu_to_be32(0xfd187e20)) {
			blkid_probe_set_label(pr, sb->s_fname, sizeof(sb->s_fname));
			if (blkid_probe_set_magic(pr,
					off + offsetof(struct sysv_super_block,
								s_magic),
					sizeof(sb->s_magic),
					(unsigned char *) &sb->s_magic))
				return 1;

			return 0;
		}
	}
	return 1;
}

static const struct blkid_idinfo xenix_idinfo =
{
	.name           = "xenix",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_xenix,
	.magics         =
	{
		{ .magic = "\x2b\x55\x44", .len = 3, .kboff = 1, .sboff = 0x400 },
		{ .magic = "\x44\x55\x2b", .len = 3, .kboff = 1, .sboff = 0x400 },
		{ NULL }
	}
};

static const struct blkid_idinfo sysv_idinfo =
{
	.name           = "sysv",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_sysv,

	/* SYSV is BE and LE and superblock could be on four positions. It's
	 * simpler to probe for the magic string by .probefunc(). */
	.magics         = BLKID_NONE_MAGIC
};

struct cramfs_super
{
	uint8_t         magic[4];
	uint32_t        size;
	uint32_t        flags;
	uint32_t        future;
	uint8_t         signature[16];
	struct cramfs_info
	{
		uint32_t        crc;
		uint32_t        edition;
		uint32_t        blocks;
		uint32_t        files;
	} __attribute__((packed)) info;
	uint8_t         name[16];
} __attribute__((packed));

static int probe_cramfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct cramfs_super *cs;

	cs = blkid_probe_get_sb(pr, mag, struct cramfs_super);
	if (!cs)
		return errno ? -errno : 1;

	blkid_probe_set_label(pr, cs->name, sizeof(cs->name));
	return 0;
}

static const struct blkid_idinfo cramfs_idinfo =
{
	.name           = "cramfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_cramfs,
	.magics         =
	{
		{ "\x45\x3d\xcd\x28", 4, 0, 0 },
		{ "\x28\xcd\x3d\x45", 4, 0, 0 },
		{ NULL }
	}
};

struct romfs_super_block {
	unsigned char   ros_magic[8];
	uint32_t        ros_dummy1[2];
	unsigned char   ros_volume[16];
} __attribute__((packed));

static int probe_romfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct romfs_super_block *ros;

	ros = blkid_probe_get_sb(pr, mag, struct romfs_super_block);
	if (!ros)
		return errno ? -errno : 1;

	if (*((char *) ros->ros_volume) != '\0')
		blkid_probe_set_label(pr, ros->ros_volume, sizeof(ros->ros_volume));
	return 0;
}

static const struct blkid_idinfo romfs_idinfo =
{
	.name           = "romfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_romfs,
	.magics         =
	{
		{ .magic = "-rom1fs-", .len = 8 },
		{ NULL }
	}
};

static void blkid_probe_set_id_label(blkid_probe pr, const char *name,
			     const unsigned char *data, size_t len)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if (!(chn->flags & BLKID_SUBLKS_LABEL))
		return;

	v = blkid_probe_assign_value(pr, name);
	blkid_probe_value_set_data(v, data, len);
	/* remove white spaces */
	v->len = rtrim_whitespace(v->data) + 1;
	if (v->len > 1)
		v->len = blkid_ltrim_whitespace(v->data) + 1;
	if (v->len > 1)
		return;
	blkid_probe_free_value(v);
}

/* This code is from freebsd/sys/libkern/crc32.c
 *
 * Simplest table-based crc32c.  Performance is not important
 * for checking crcs on superblocks
 *  COPYRIGHT (C) 1986 Gary S. Brown.  You may use this program, or
 *  code or tables extracted from it, as desired without restriction. */

static const uint32_t crc32Table[256] = {
	0x00000000L, 0xF26B8303L, 0xE13B70F7L, 0x1350F3F4L,
	0xC79A971FL, 0x35F1141CL, 0x26A1E7E8L, 0xD4CA64EBL,
	0x8AD958CFL, 0x78B2DBCCL, 0x6BE22838L, 0x9989AB3BL,
	0x4D43CFD0L, 0xBF284CD3L, 0xAC78BF27L, 0x5E133C24L,
	0x105EC76FL, 0xE235446CL, 0xF165B798L, 0x030E349BL,
	0xD7C45070L, 0x25AFD373L, 0x36FF2087L, 0xC494A384L,
	0x9A879FA0L, 0x68EC1CA3L, 0x7BBCEF57L, 0x89D76C54L,
	0x5D1D08BFL, 0xAF768BBCL, 0xBC267848L, 0x4E4DFB4BL,
	0x20BD8EDEL, 0xD2D60DDDL, 0xC186FE29L, 0x33ED7D2AL,
	0xE72719C1L, 0x154C9AC2L, 0x061C6936L, 0xF477EA35L,
	0xAA64D611L, 0x580F5512L, 0x4B5FA6E6L, 0xB93425E5L,
	0x6DFE410EL, 0x9F95C20DL, 0x8CC531F9L, 0x7EAEB2FAL,
	0x30E349B1L, 0xC288CAB2L, 0xD1D83946L, 0x23B3BA45L,
	0xF779DEAEL, 0x05125DADL, 0x1642AE59L, 0xE4292D5AL,
	0xBA3A117EL, 0x4851927DL, 0x5B016189L, 0xA96AE28AL,
	0x7DA08661L, 0x8FCB0562L, 0x9C9BF696L, 0x6EF07595L,
	0x417B1DBCL, 0xB3109EBFL, 0xA0406D4BL, 0x522BEE48L,
	0x86E18AA3L, 0x748A09A0L, 0x67DAFA54L, 0x95B17957L,
	0xCBA24573L, 0x39C9C670L, 0x2A993584L, 0xD8F2B687L,
	0x0C38D26CL, 0xFE53516FL, 0xED03A29BL, 0x1F682198L,
	0x5125DAD3L, 0xA34E59D0L, 0xB01EAA24L, 0x42752927L,
	0x96BF4DCCL, 0x64D4CECFL, 0x77843D3BL, 0x85EFBE38L,
	0xDBFC821CL, 0x2997011FL, 0x3AC7F2EBL, 0xC8AC71E8L,
	0x1C661503L, 0xEE0D9600L, 0xFD5D65F4L, 0x0F36E6F7L,
	0x61C69362L, 0x93AD1061L, 0x80FDE395L, 0x72966096L,
	0xA65C047DL, 0x5437877EL, 0x4767748AL, 0xB50CF789L,
	0xEB1FCBADL, 0x197448AEL, 0x0A24BB5AL, 0xF84F3859L,
	0x2C855CB2L, 0xDEEEDFB1L, 0xCDBE2C45L, 0x3FD5AF46L,
	0x7198540DL, 0x83F3D70EL, 0x90A324FAL, 0x62C8A7F9L,
	0xB602C312L, 0x44694011L, 0x5739B3E5L, 0xA55230E6L,
	0xFB410CC2L, 0x092A8FC1L, 0x1A7A7C35L, 0xE811FF36L,
	0x3CDB9BDDL, 0xCEB018DEL, 0xDDE0EB2AL, 0x2F8B6829L,
	0x82F63B78L, 0x709DB87BL, 0x63CD4B8FL, 0x91A6C88CL,
	0x456CAC67L, 0xB7072F64L, 0xA457DC90L, 0x563C5F93L,
	0x082F63B7L, 0xFA44E0B4L, 0xE9141340L, 0x1B7F9043L,
	0xCFB5F4A8L, 0x3DDE77ABL, 0x2E8E845FL, 0xDCE5075CL,
	0x92A8FC17L, 0x60C37F14L, 0x73938CE0L, 0x81F80FE3L,
	0x55326B08L, 0xA759E80BL, 0xB4091BFFL, 0x466298FCL,
	0x1871A4D8L, 0xEA1A27DBL, 0xF94AD42FL, 0x0B21572CL,
	0xDFEB33C7L, 0x2D80B0C4L, 0x3ED04330L, 0xCCBBC033L,
	0xA24BB5A6L, 0x502036A5L, 0x4370C551L, 0xB11B4652L,
	0x65D122B9L, 0x97BAA1BAL, 0x84EA524EL, 0x7681D14DL,
	0x2892ED69L, 0xDAF96E6AL, 0xC9A99D9EL, 0x3BC21E9DL,
	0xEF087A76L, 0x1D63F975L, 0x0E330A81L, 0xFC588982L,
	0xB21572C9L, 0x407EF1CAL, 0x532E023EL, 0xA145813DL,
	0x758FE5D6L, 0x87E466D5L, 0x94B49521L, 0x66DF1622L,
	0x38CC2A06L, 0xCAA7A905L, 0xD9F75AF1L, 0x2B9CD9F2L,
	0xFF56BD19L, 0x0D3D3E1AL, 0x1E6DCDEEL, 0xEC064EEDL,
	0xC38D26C4L, 0x31E6A5C7L, 0x22B65633L, 0xD0DDD530L,
	0x0417B1DBL, 0xF67C32D8L, 0xE52CC12CL, 0x1747422FL,
	0x49547E0BL, 0xBB3FFD08L, 0xA86F0EFCL, 0x5A048DFFL,
	0x8ECEE914L, 0x7CA56A17L, 0x6FF599E3L, 0x9D9E1AE0L,
	0xD3D3E1ABL, 0x21B862A8L, 0x32E8915CL, 0xC083125FL,
	0x144976B4L, 0xE622F5B7L, 0xF5720643L, 0x07198540L,
	0x590AB964L, 0xAB613A67L, 0xB831C993L, 0x4A5A4A90L,
	0x9E902E7BL, 0x6CFBAD78L, 0x7FAB5E8CL, 0x8DC0DD8FL,
	0xE330A81AL, 0x115B2B19L, 0x020BD8EDL, 0xF0605BEEL,
	0x24AA3F05L, 0xD6C1BC06L, 0xC5914FF2L, 0x37FACCF1L,
	0x69E9F0D5L, 0x9B8273D6L, 0x88D28022L, 0x7AB90321L,
	0xAE7367CAL, 0x5C18E4C9L, 0x4F48173DL, 0xBD23943EL,
	0xF36E6F75L, 0x0105EC76L, 0x12551F82L, 0xE03E9C81L,
	0x34F4F86AL, 0xC69F7B69L, 0xD5CF889DL, 0x27A40B9EL,
	0x79B737BAL, 0x8BDCB4B9L, 0x988C474DL, 0x6AE7C44EL,
	0xBE2DA0A5L, 0x4C4623A6L, 0x5F16D052L, 0xAD7D5351L
};

/* This was singletable_crc32c() in bsd
 *
 * If you will not be passing crc back into this function to process more bytes,
 * the answer is:
 *
 *    crc = crc32c(~0L, buf, size);
 *  [ crc = crc32c(crc, buf, size); ]
 *    crc ^= ~0L */
static uint32_t crc32c(uint32_t crc, const void *buf, size_t size)
{
	const uint8_t *p = buf;

	while (size--)
		crc = crc32Table[(crc ^ *p++) & 0xff] ^ (crc >> 8);

	return crc;
}

#define MAX_MPOOL_NAME_LEN 32

struct omf_sb_descriptor {
	uint64_t        osb_magic;
	uint8_t         osb_name[MAX_MPOOL_NAME_LEN];
	unsigned char   osb_poolid[16]; /* UUID of pool this drive belongs to */
	uint16_t        osb_vers;
	uint32_t        osb_gen;
	uint32_t        osb_cksum1; /* crc32c of the preceding fields */
} __attribute__((packed));

static int probe_mpool(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct omf_sb_descriptor *osd;
	uint32_t sb_crc;

	osd = blkid_probe_get_sb(pr, mag, struct omf_sb_descriptor);
	if (!osd)
		return errno ? -errno : 1;

	sb_crc = crc32c(~0L, (const void *)osd,
			offsetof(struct omf_sb_descriptor, osb_cksum1));
	sb_crc ^= ~0L;

	if (!blkid_probe_verify_csum(pr, sb_crc, le32_to_cpu(osd->osb_cksum1)))
		return 1;

	blkid_probe_set_label(pr, osd->osb_name, sizeof(osd->osb_name));
	blkid_probe_set_uuid(pr, osd->osb_poolid);

	return 0;
}

/* "mpoolDev" in ASCII */
#define MPOOL_SB_MAGIC "\x6D\x70\x6f\x6f\x6c\x44\x65\x76"

static const struct blkid_idinfo mpool_idinfo =
{
	.name           = "mpool",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_mpool,
	.magics         =
	{
		{ .magic = MPOOL_SB_MAGIC, .len = 8},
		{ NULL }
	}
};

/* DRBD is a blocklevel replication solution in the Linux kernel,
 * upstream since 2.6.33. (See http://drbd.linbit.com/)
 * DRBDmanage is a configuration frontend that assists in
 * creating/deleting/modifying DRBD resources across multiple machines
 * (a DRBDmanage "cluster"); this file detects its control volume,
 * which is replicated (via DRBD 9) on some of the nodes. */
struct drbdmanage_hdr {
	unsigned char magic[11];
	unsigned char uuid[32];
	unsigned char lf;
} __attribute__ ((packed));

struct drbdmanage_pers {
	char magic[4];
	uint32_t version_le;
} __attribute__ ((packed));


static const char persistence_magic[4] = { '\x1a', '\xdb', '\x98', '\xa2' };

static int probe_drbdmanage(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct drbdmanage_hdr *hdr;
	unsigned char *cp;
	struct drbdmanage_pers *prs;

	hdr = (struct drbdmanage_hdr*)
		blkid_probe_get_buffer(pr, 0, sizeof(*hdr));
	if (!hdr)
		return errno ? -errno : 1;

	for(cp=hdr->uuid; cp<&hdr->lf; cp++)
		if (!isxdigit(*cp))
			return 1;
	if (hdr->lf != '\n')
		return 1;

	blkid_probe_set_id_label(pr, "UUID", hdr->uuid, sizeof(hdr->uuid));

	prs = (struct drbdmanage_pers*)
		blkid_probe_get_buffer(pr, 0x1000, sizeof(*prs));
	if (!prs)
		return errno ? -errno : 1;

	if (memcmp(prs->magic, persistence_magic, sizeof(prs->magic)) == 0)
		blkid_probe_sprintf_version(pr, "%d", be32_to_cpu(prs->version_le));
	return 0;
}


static const struct blkid_idinfo drbdmanage_idinfo =
{
	.name           = "drbdmanage_control_volume",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_drbdmanage,
	.minsz          = 64 * 1024,
	.magics         = {
		{ .magic = "$DRBDmgr=q", .len = 10, .sboff = 0 },
		{ NULL }
	},
};

/* HFS / HFS+ */
struct hfs_finder_info {
	uint32_t        boot_folder;
	uint32_t        start_app;
	uint32_t        open_folder;
	uint32_t        os9_folder;
	uint32_t        reserved;
	uint32_t        osx_folder;
	uint8_t         id[8];
} __attribute__((packed));

#define HFS_SECTOR_SIZE         512

struct hfs_mdb {
	uint8_t         signature[2];
	uint32_t        cr_date;
	uint32_t        ls_Mod;
	uint16_t        atrb;
	uint16_t        nm_fls;
	uint16_t        vbm_st;
	uint16_t        alloc_ptr;
	uint16_t        nm_al_blks;
	uint32_t        al_blk_size;
	uint32_t        clp_size;
	uint16_t        al_bl_st;
	uint32_t        nxt_cnid;
	uint16_t        free_bks;
	uint8_t         label_len;
	uint8_t         label[27];
	uint32_t        vol_bkup;
	uint16_t        vol_seq_num;
	uint32_t        wr_cnt;
	uint32_t        xt_clump_size;
	uint32_t        ct_clump_size;
	uint16_t        num_root_dirs;
	uint32_t        file_count;
	uint32_t        dir_count;
	struct hfs_finder_info finder_info;
	uint8_t         embed_sig[2];
	uint16_t        embed_startblock;
	uint16_t        embed_blockcount;
} __attribute__((packed));


#define HFS_NODE_LEAF                   0xff
#define HFSPLUS_POR_CNID                1

struct hfsplus_bnode_descriptor {
	uint32_t        next;
	uint32_t        prev;
	uint8_t         type;
	uint8_t         height;
	uint16_t        num_recs;
	uint16_t        reserved;
} __attribute__((packed));

struct hfsplus_bheader_record {
	uint16_t                depth;
	uint32_t                root;
	uint32_t                leaf_count;
	uint32_t                leaf_head;
	uint32_t                leaf_tail;
	uint16_t                node_size;
} __attribute__((packed));

struct hfsplus_catalog_key {
	uint16_t        key_len;
	uint32_t        parent_id;
	uint16_t        unicode_len;
	uint8_t         unicode[255 * 2];
} __attribute__((packed));

struct hfsplus_extent {
	uint32_t                start_block;
	uint32_t                block_count;
} __attribute__((packed));

#define HFSPLUS_EXTENT_COUNT            8
struct hfsplus_fork {
	uint64_t                total_size;
	uint32_t                clump_size;
	uint32_t                total_blocks;
	struct hfsplus_extent extents[HFSPLUS_EXTENT_COUNT];
} __attribute__((packed));

struct hfsplus_vol_header {
	uint8_t         signature[2];
	uint16_t        version;
	uint32_t        attributes;
	uint32_t        last_mount_vers;
	uint32_t        reserved;
	uint32_t        create_date;
	uint32_t        modify_date;
	uint32_t        backup_date;
	uint32_t        checked_date;
	uint32_t        file_count;
	uint32_t        folder_count;
	uint32_t        blocksize;
	uint32_t        total_blocks;
	uint32_t        free_blocks;
	uint32_t        next_alloc;
	uint32_t        rsrc_clump_sz;
	uint32_t        data_clump_sz;
	uint32_t        next_cnid;
	uint32_t        write_count;
	uint64_t        encodings_bmp;
	struct hfs_finder_info finder_info;
	struct hfsplus_fork alloc_file;
	struct hfsplus_fork ext_file;
	struct hfsplus_fork cat_file;
	struct hfsplus_fork attr_file;
	struct hfsplus_fork start_file;
}  __attribute__((packed));

#define HFSPLUS_SECTOR_SIZE        512

static int hfs_set_uuid(blkid_probe pr, unsigned char const *hfs_info, size_t len)
{
#define UL_MD5LENGTH 16
	static unsigned char const hash_init[UL_MD5LENGTH] = {
		0xb3, 0xe2, 0x0f, 0x39, 0xf2, 0x92, 0x11, 0xd6,
		0x97, 0xa4, 0x00, 0x30, 0x65, 0x43, 0xec, 0xac
	};
	unsigned char uuid[UL_MD5LENGTH];
	md5_ctx_t md5c;

	if (memcmp(hfs_info, "\0\0\0\0\0\0\0\0", len) == 0)
		return -1;

	md5_begin(&md5c);
	md5_hash(hash_init, UL_MD5LENGTH, &md5c);
	md5_hash(hfs_info, len, &md5c);
	md5_end(uuid, &md5c);

	uuid[6] = 0x30 | (uuid[6] & 0x0f);
	uuid[8] = 0x80 | (uuid[8] & 0x3f);
	return blkid_probe_set_uuid(pr, uuid);
}

static int probe_hfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct hfs_mdb  *hfs;
	int size;

	hfs = blkid_probe_get_sb(pr, mag, struct hfs_mdb);
	if (!hfs)
		return errno ? -errno : 1;

	if ((memcmp(hfs->embed_sig, "H+", 2) == 0) ||
	    (memcmp(hfs->embed_sig, "HX", 2) == 0))
		return 1;       /* Not hfs, but an embedded HFS+ */

	size = be32_to_cpu(hfs->al_blk_size);
	if (!size || (size & (HFS_SECTOR_SIZE - 1)))
		return 1;

	hfs_set_uuid(pr, hfs->finder_info.id, sizeof(hfs->finder_info.id));

	blkid_probe_set_label(pr, hfs->label, hfs->label_len);
	return 0;
}

static int probe_hfsplus(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct hfsplus_extent extents[HFSPLUS_EXTENT_COUNT];
	struct hfsplus_bnode_descriptor *descr;
	struct hfsplus_bheader_record *bnode;
	struct hfsplus_catalog_key *key;
	struct hfsplus_vol_header *hfsplus;
	struct hfs_mdb *sbd;
	unsigned int alloc_block_size;
	unsigned int alloc_first_block;
	unsigned int embed_first_block;
	unsigned int off = 0;
	unsigned int blocksize;
	unsigned int cat_block;
	unsigned int ext_block_start;
	unsigned int ext_block_count;
	unsigned int record_count;
	unsigned int leaf_node_head;
	unsigned int leaf_node_count;
	unsigned int leaf_node_size;
	unsigned int leaf_block;
	int ext;
	uint64_t leaf_off;
	unsigned char *buf;

	sbd = blkid_probe_get_sb(pr, mag, struct hfs_mdb);
	if (!sbd)
		return errno ? -errno : 1;

	/* Check for a HFS+ volume embedded in a HFS volume */
	if (memcmp(sbd->signature, "BD", 2) == 0) {
		if ((memcmp(sbd->embed_sig, "H+", 2) != 0) &&
		    (memcmp(sbd->embed_sig, "HX", 2) != 0))
			/* This must be an HFS volume, so fail */
			return 1;

		alloc_block_size = be32_to_cpu(sbd->al_blk_size);
		alloc_first_block = be16_to_cpu(sbd->al_bl_st);
		embed_first_block = be16_to_cpu(sbd->embed_startblock);
		off = (alloc_first_block * 512) +
			(embed_first_block * alloc_block_size);

		buf = blkid_probe_get_buffer(pr,
				off + (mag->kboff * 1024),
				sizeof(struct hfsplus_vol_header));
		hfsplus = (struct hfsplus_vol_header *) buf;

	} else
		hfsplus = blkid_probe_get_sb(pr, mag,
				struct hfsplus_vol_header);

	if (!hfsplus)
		return errno ? -errno : 1;

	if ((memcmp(hfsplus->signature, "H+", 2) != 0) &&
	    (memcmp(hfsplus->signature, "HX", 2) != 0))
		return 1;

	hfs_set_uuid(pr, hfsplus->finder_info.id, sizeof(hfsplus->finder_info.id));

	blocksize = be32_to_cpu(hfsplus->blocksize);
	if (blocksize < HFSPLUS_SECTOR_SIZE)
		return 1;

	memcpy(extents, hfsplus->cat_file.extents, sizeof(extents));
	cat_block = be32_to_cpu(extents[0].start_block);

	buf = blkid_probe_get_buffer(pr,
			off + ((uint64_t) cat_block * blocksize), 0x2000);
	if (!buf)
		return errno ? -errno : 0;

	bnode = (struct hfsplus_bheader_record *)
		&buf[sizeof(struct hfsplus_bnode_descriptor)];

	leaf_node_head = be32_to_cpu(bnode->leaf_head);
	leaf_node_size = be16_to_cpu(bnode->node_size);
	leaf_node_count = be32_to_cpu(bnode->leaf_count);

	if (leaf_node_size < sizeof(struct hfsplus_bnode_descriptor) +
	    sizeof(struct hfsplus_catalog_key) || leaf_node_count == 0)
		return 0;

	leaf_block = (leaf_node_head * leaf_node_size) / blocksize;

	/* get physical location */
	for (ext = 0; ext < HFSPLUS_EXTENT_COUNT; ext++) {
		ext_block_start = be32_to_cpu(extents[ext].start_block);
		ext_block_count = be32_to_cpu(extents[ext].block_count);
		if (ext_block_count == 0)
			return 0;

		/* this is our extent */
		if (leaf_block < ext_block_count)
			break;

		leaf_block -= ext_block_count;
	}
	if (ext == HFSPLUS_EXTENT_COUNT)
		return 0;

	leaf_off = ((uint64_t) ext_block_start + leaf_block) * blocksize;

	buf = blkid_probe_get_buffer(pr,
				(uint64_t) off + leaf_off,
				leaf_node_size);
	if (!buf)
		return errno ? -errno : 0;

	descr = (struct hfsplus_bnode_descriptor *) buf;
	record_count = be16_to_cpu(descr->num_recs);
	if (record_count == 0)
		return 0;

	if (descr->type != HFS_NODE_LEAF)
		return 0;

	key = (struct hfsplus_catalog_key *)
		&buf[sizeof(struct hfsplus_bnode_descriptor)];

	if (be32_to_cpu(key->parent_id) != HFSPLUS_POR_CNID ||
	    be16_to_cpu(key->unicode_len) > 255)
		return 0;

	blkid_probe_set_utf8label(pr, key->unicode,
			be16_to_cpu(key->unicode_len) * 2,
			BLKID_ENC_UTF16BE);
	return 0;
}

static const struct blkid_idinfo hfs_idinfo =
{
	.name           = "hfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_hfs,
	.flags          = BLKID_IDINFO_TOLERANT,
	.magics         =
	{
		{ .magic = "BD", .len = 2, .kboff = 1 },
		{ NULL }
	}
};

static const struct blkid_idinfo hfsplus_idinfo =
{
	.name           = "hfsplus",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_hfsplus,
	.magics         =
	{
		{ .magic = "BD", .len = 2, .kboff = 1 },
		{ .magic = "H+", .len = 2, .kboff = 1 },
		{ .magic = "HX", .len = 2, .kboff = 1 },
		{ NULL }
	}
};


#define F2FS_MAGIC              "\x10\x20\xF5\xF2"
#define F2FS_MAGIC_OFF          0
#define F2FS_UUID_SIZE          16
#define F2FS_LABEL_SIZE         512
#define F2FS_SB1_OFF            0x400
#define F2FS_SB1_KBOFF          (F2FS_SB1_OFF >> 10)
#define F2FS_SB2_OFF            0x1400
#define F2FS_SB2_KBOFF          (F2FS_SB2_OFF >> 10)

struct f2fs_super_block {                                       /* According to version 1.1 */
/* 0x00 */      uint32_t        magic;                          /* Magic Number */
/* 0x04 */      uint16_t        major_ver;                      /* Major Version */
/* 0x06 */      uint16_t        minor_ver;                      /* Minor Version */
/* 0x08 */      uint32_t        log_sectorsize;                 /* log2 sector size in bytes */
/* 0x0C */      uint32_t        log_sectors_per_block;          /* log2 # of sectors per block */
/* 0x10 */      uint32_t        log_blocksize;                  /* log2 block size in bytes */
/* 0x14 */      uint32_t        log_blocks_per_seg;             /* log2 # of blocks per segment */
/* 0x18 */      uint32_t        segs_per_sec;                   /* # of segments per section */
/* 0x1C */      uint32_t        secs_per_zone;                  /* # of sections per zone */
/* 0x20 */      uint32_t        checksum_offset;                /* checksum offset inside super block */
/* 0x24 */      uint64_t        block_count;                    /* total # of user blocks */
/* 0x2C */      uint32_t        section_count;                  /* total # of sections */
/* 0x30 */      uint32_t        segment_count;                  /* total # of segments */
/* 0x34 */      uint32_t        segment_count_ckpt;             /* # of segments for checkpoint */
/* 0x38 */      uint32_t        segment_count_sit;              /* # of segments for SIT */
/* 0x3C */      uint32_t        segment_count_nat;              /* # of segments for NAT */
/* 0x40 */      uint32_t        segment_count_ssa;              /* # of segments for SSA */
/* 0x44 */      uint32_t        segment_count_main;             /* # of segments for main area */
/* 0x48 */      uint32_t        segment0_blkaddr;               /* start block address of segment 0 */
/* 0x4C */      uint32_t        cp_blkaddr;                     /* start block address of checkpoint */
/* 0x50 */      uint32_t        sit_blkaddr;                    /* start block address of SIT */
/* 0x54 */      uint32_t        nat_blkaddr;                    /* start block address of NAT */
/* 0x58 */      uint32_t        ssa_blkaddr;                    /* start block address of SSA */
/* 0x5C */      uint32_t        main_blkaddr;                   /* start block address of main area */
/* 0x60 */      uint32_t        root_ino;                       /* root inode number */
/* 0x64 */      uint32_t        node_ino;                       /* node inode number */
/* 0x68 */      uint32_t        meta_ino;                       /* meta inode number */
/* 0x6C */      uint8_t         uuid[F2FS_UUID_SIZE];           /* 128-bit uuid for volume */
/* 0x7C */      uint16_t        volume_name[F2FS_LABEL_SIZE];   /* volume name */
#if 0
/* 0x47C */     uint32_t        extension_count;                /* # of extensions below */
/* 0x480 */     uint8_t         extension_list[64][8];          /* extension array */
#endif
} __attribute__((packed));

static int probe_f2fs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct f2fs_super_block *sb;
	uint16_t vermaj, vermin;

	sb = blkid_probe_get_sb(pr, mag, struct f2fs_super_block);
	if (!sb)
		return errno ? -errno : 1;

	vermaj = le16_to_cpu(sb->major_ver);
	vermin = le16_to_cpu(sb->minor_ver);

	/* For version 1.0 we cannot know the correct sb structure */
	if (vermaj == 1 && vermin == 0)
		return 0;

	if (*((unsigned char *) sb->volume_name))
		blkid_probe_set_utf8label(pr, (unsigned char *) sb->volume_name,
						sizeof(sb->volume_name),
						BLKID_ENC_UTF16LE);

	blkid_probe_set_uuid(pr, sb->uuid);
	blkid_probe_sprintf_version(pr, "%u.%u", vermaj, vermin);
	return 0;
}

static const struct blkid_idinfo f2fs_idinfo =
{
	.name           = "f2fs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_f2fs,
	.magics         =
	{
		{
			.magic = F2FS_MAGIC,
			.len = 4,
			.kboff = F2FS_SB1_KBOFF,
			.sboff = F2FS_MAGIC_OFF
		},
		{ NULL }
	}
};

static void blkid_probe_set_version(blkid_probe pr, const char *version)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (chn->flags & BLKID_SUBLKS_VERSION)
		blkid_probe_set_value(pr, "VERSION", (const unsigned char *) version, strlen(version) + 1);
}

/* linux-2.6/include/linux/swap.h */
struct swap_header_v1_2 {
     /* char            bootbits[1024]; */ /* Space for disklabel etc. */
	uint32_t        version;
	uint32_t        lastpage;
	uint32_t        nr_badpages;
	unsigned char   uuid[16];
	unsigned char   volume[16];
	uint32_t        padding[117];
	uint32_t        badpages[1];
} __attribute__((packed));

#define PAGESIZE_MIN    0xff6   /* 4086 (arm, i386, ...) */
#define PAGESIZE_MAX    0xfff6  /* 65526 (ia64) */

#define TOI_MAGIC_STRING        "\xed\xc3\x02\xe9\x98\x56\xe5\x0c"
#define TOI_MAGIC_STRLEN        (sizeof(TOI_MAGIC_STRING) - 1)

static int swap_set_info(blkid_probe pr, const char *version)
{
	struct swap_header_v1_2 *hdr;

	/* Swap header always located at offset of 1024 bytes */
	hdr = (struct swap_header_v1_2 *) blkid_probe_get_buffer(pr, 1024,
				sizeof(struct swap_header_v1_2));
	if (!hdr)
		return errno ? -errno : 1;

	/* SWAPSPACE2 - check for wrong version or zeroed pagecount */
	if (strcmp(version, "1") == 0) {
		if (hdr->version != 1 && swab32(hdr->version) != 1)
			return 1;
		if (hdr->lastpage == 0)
			return 1;
	}

	/* arbitrary sanity check.. is there any garbage down there? */
	if (hdr->padding[32] == 0 && hdr->padding[33] == 0) {
		if (hdr->volume[0])
			blkid_probe_set_label(pr, hdr->volume, sizeof(hdr->volume));
		if (blkid_probe_set_uuid(pr, hdr->uuid) < 0)
			return 1;
	}

	blkid_probe_set_version(pr, version);
	return 0;
}

static int probe_swap(blkid_probe pr, const struct blkid_idmag *mag)
{
	unsigned char *buf;

	if (!mag)
		return 1;

	/* TuxOnIce keeps valid swap header at the end of the 1st page */
	buf = blkid_probe_get_buffer(pr, 0, TOI_MAGIC_STRLEN);
	if (!buf)
		return errno ? -errno : 1;

	if (memcmp(buf, TOI_MAGIC_STRING, TOI_MAGIC_STRLEN) == 0)
		return 1;       /* Ignore swap signature, it's TuxOnIce */

	if (!memcmp(mag->magic, "SWAP-SPACE", mag->len)) {
		/* swap v0 doesn't support LABEL or UUID */
		blkid_probe_set_version(pr, "0");
		return 0;

	} else if (!memcmp(mag->magic, "SWAPSPACE2", mag->len))
		return swap_set_info(pr, "1");

	return 1;
}

static int probe_swsuspend(blkid_probe pr, const struct blkid_idmag *mag)
{
	if (!mag)
		return 1;
	if (!memcmp(mag->magic, "S1SUSPEND", mag->len))
		return swap_set_info(pr, "s1suspend");
	if (!memcmp(mag->magic, "S2SUSPEND", mag->len))
		return swap_set_info(pr, "s2suspend");
	if (!memcmp(mag->magic, "ULSUSPEND", mag->len))
		return swap_set_info(pr, "ulsuspend");
	if (!memcmp(mag->magic, TOI_MAGIC_STRING, mag->len))
		return swap_set_info(pr, "tuxonice");
	if (!memcmp(mag->magic, "LINHIB0001", mag->len))
		return swap_set_info(pr, "linhib0001");

	return 1;       /* no signature detected */
}

static const struct blkid_idinfo swap_idinfo =
{
	.name           = "swap",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_swap,
	.minsz          = 10 * 4096,    /* 10 pages */
	.magics         =
	{
		{ "SWAP-SPACE", 10, 0,  0xff6 },
		{ "SWAPSPACE2", 10, 0,  0xff6 },
		{ "SWAP-SPACE", 10, 0, 0x1ff6 },
		{ "SWAPSPACE2", 10, 0, 0x1ff6 },
		{ "SWAP-SPACE", 10, 0, 0x3ff6 },
		{ "SWAPSPACE2", 10, 0, 0x3ff6 },
		{ "SWAP-SPACE", 10, 0, 0x7ff6 },
		{ "SWAPSPACE2", 10, 0, 0x7ff6 },
		{ "SWAP-SPACE", 10, 0, 0xfff6 },
		{ "SWAPSPACE2", 10, 0, 0xfff6 },
		{ NULL }
	}
};

static const struct blkid_idinfo swsuspend_idinfo =
{
	.name           = "swsuspend",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_swsuspend,
	.minsz          = 10 * 4096,    /* 10 pages */
	.magics         =
	{
		{ TOI_MAGIC_STRING, TOI_MAGIC_STRLEN, 0, 0 },
		{ "S1SUSPEND", 9, 0, 0xff6 },
		{ "S2SUSPEND", 9, 0, 0xff6 },
		{ "ULSUSPEND", 9, 0, 0xff6 },
		{ "LINHIB0001",10,0, 0xff6 },

		{ "S1SUSPEND", 9, 0, 0x1ff6 },
		{ "S2SUSPEND", 9, 0, 0x1ff6 },
		{ "ULSUSPEND", 9, 0, 0x1ff6 },
		{ "LINHIB0001",10,0, 0x1ff6 },

		{ "S1SUSPEND", 9, 0, 0x3ff6 },
		{ "S2SUSPEND", 9, 0, 0x3ff6 },
		{ "ULSUSPEND", 9, 0, 0x3ff6 },
		{ "LINHIB0001",10,0, 0x3ff6 },

		{ "S1SUSPEND", 9, 0, 0x7ff6 },
		{ "S2SUSPEND", 9, 0, 0x7ff6 },
		{ "ULSUSPEND", 9, 0, 0x7ff6 },
		{ "LINHIB0001",10,0, 0x7ff6 },

		{ "S1SUSPEND", 9, 0, 0xfff6 },
		{ "S2SUSPEND", 9, 0, 0xfff6 },
		{ "ULSUSPEND", 9, 0, 0xfff6 },
		{ "LINHIB0001",10,0, 0xfff6 },

		{ NULL }
	}
};

/* Common gfs/gfs2 constants: */
#define GFS_LOCKNAME_LEN        64

/* gfs1 constants: */
#define GFS_FORMAT_FS           1309
#define GFS_FORMAT_MULTI        1401
/* gfs2 constants: */
#define GFS2_FORMAT_FS          1801
#define GFS2_FORMAT_MULTI       1900

struct gfs2_meta_header {
	uint32_t mh_magic;
	uint32_t mh_type;
	uint64_t __pad0;          /* Was generation number in gfs1 */
	uint32_t mh_format;
	uint32_t __pad1;          /* Was incarnation number in gfs1 */
};

struct gfs2_inum {
	uint64_t no_formal_ino;
	uint64_t no_addr;
};

struct gfs2_sb {
	struct gfs2_meta_header sb_header;

	uint32_t sb_fs_format;
	uint32_t sb_multihost_format;
	uint32_t  __pad0;  /* Was superblock flags in gfs1 */

	uint32_t sb_bsize;
	uint32_t sb_bsize_shift;
	uint32_t __pad1;   /* Was journal segment size in gfs1 */

	struct gfs2_inum sb_master_dir; /* Was jindex dinode in gfs1 */
	struct gfs2_inum __pad2; /* Was rindex dinode in gfs1 */
	struct gfs2_inum sb_root_dir;

	char sb_lockproto[GFS_LOCKNAME_LEN];
	char sb_locktable[GFS_LOCKNAME_LEN];

	struct gfs2_inum __pad3; /* Was quota inode in gfs1 */
	struct gfs2_inum __pad4; /* Was license inode in gfs1 */
	uint8_t sb_uuid[16]; /* The UUID maybe 0 for backwards compat */
} __attribute__((packed));

static int probe_gfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct gfs2_sb *sbd;

	sbd = blkid_probe_get_sb(pr, mag, struct gfs2_sb);
	if (!sbd)
		return errno ? -errno : 1;

	if (be32_to_cpu(sbd->sb_fs_format) == GFS_FORMAT_FS &&
	    be32_to_cpu(sbd->sb_multihost_format) == GFS_FORMAT_MULTI)
	{
		if (*sbd->sb_locktable)
			blkid_probe_set_label(pr, (unsigned char *) sbd->sb_locktable, sizeof(sbd->sb_locktable));

		blkid_probe_set_uuid(pr, sbd->sb_uuid);
		return 0;
	}

	return 1;
}

static int probe_gfs2(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct gfs2_sb *sbd;

	sbd = blkid_probe_get_sb(pr, mag, struct gfs2_sb);
	if (!sbd)
		return errno ? -errno : 1;

	if (be32_to_cpu(sbd->sb_fs_format) == GFS2_FORMAT_FS &&
	    be32_to_cpu(sbd->sb_multihost_format) == GFS2_FORMAT_MULTI)
	{
		if (*sbd->sb_locktable)
			blkid_probe_set_label(pr, (unsigned char *) sbd->sb_locktable, sizeof(sbd->sb_locktable));
		blkid_probe_set_uuid(pr, sbd->sb_uuid);
		blkid_probe_set_version(pr, "1");
		return 0;
	}
	return 1;
}

static const struct blkid_idinfo gfs_idinfo =
{
	.name           = "gfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_gfs,
	.minsz          = 32 * 1024 * 1024,     /* minimal size of GFS journal */
	.magics         =
	{
		{ .magic = "\x01\x16\x19\x70", .len = 4, .kboff = 64 },
		{ NULL }
	}
};

static const struct blkid_idinfo gfs2_idinfo =
{
	.name           = "gfs2",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_gfs2,
	.minsz          = 32 * 1024 * 1024,     /* minimal size of GFS journal */
	.magics         =
	{
		{ .magic = "\x01\x16\x19\x70", .len = 4, .kboff = 64 },
		{ NULL }
	}
};

struct reiserfs_super_block {
	uint32_t        rs_blocks_count;
	uint32_t        rs_free_blocks;
	uint32_t        rs_root_block;
	uint32_t        rs_journal_block;
	uint32_t        rs_journal_dev;
	uint32_t        rs_orig_journal_size;
	uint32_t        rs_dummy2[5];
	uint16_t        rs_blocksize;
	uint16_t        rs_dummy3[3];
	unsigned char   rs_magic[12];
	uint32_t        rs_dummy4[5];
	unsigned char   rs_uuid[16];
	char            rs_label[16];
} __attribute__((packed));

struct reiser4_super_block {
	unsigned char   rs4_magic[16];
	uint16_t        rs4_dummy[2];
	unsigned char   rs4_uuid[16];
	unsigned char   rs4_label[16];
	uint64_t        rs4_dummy2;
} __attribute__((packed));

static int probe_reiser(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct reiserfs_super_block *rs;
	unsigned int blocksize;

	rs = blkid_probe_get_sb(pr, mag, struct reiserfs_super_block);
	if (!rs)
		return errno ? -errno : 1;

	blocksize = le16_to_cpu(rs->rs_blocksize);

	/* The blocksize must be at least 512B */
	if ((blocksize >> 9) == 0)
		return 1;

	/* If the superblock is inside the journal, we have the wrong one */
	if (mag->kboff / (blocksize >> 9) > le32_to_cpu(rs->rs_journal_block) / 2)
		return 1;

	/* LABEL/UUID are only valid for later versions of Reiserfs v3.6. */
	if (mag->magic[6] == '2' || mag->magic[6] == '3') {
		if (*rs->rs_label)
			blkid_probe_set_label(pr, (unsigned char *) rs->rs_label, sizeof(rs->rs_label));
		blkid_probe_set_uuid(pr, rs->rs_uuid);
	}

	if (mag->magic[6] == '3')
		blkid_probe_set_version(pr, "JR");
	else if (mag->magic[6] == '2')
		blkid_probe_set_version(pr, "3.6");
	else
		blkid_probe_set_version(pr, "3.5");

	return 0;
}

static int probe_reiser4(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct reiser4_super_block *rs4;

	rs4 = blkid_probe_get_sb(pr, mag, struct reiser4_super_block);
	if (!rs4)
		return errno ? -errno : 1;

	if (*rs4->rs4_label)
		blkid_probe_set_label(pr, rs4->rs4_label, sizeof(rs4->rs4_label));
	blkid_probe_set_uuid(pr, rs4->rs4_uuid);
	blkid_probe_set_version(pr, "4");

	return 0;
}

static const struct blkid_idinfo reiser_idinfo =
{
	.name           = "reiserfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_reiser,
	.minsz          = 128 * 1024,
	.magics         =
	{
		{ .magic = "ReIsErFs",  .len = 8, .kboff = 8,  .sboff = 0x34 },
		{ .magic = "ReIsEr2Fs", .len = 9, .kboff = 64, .sboff = 0x34 },
		{ .magic = "ReIsEr3Fs", .len = 9, .kboff = 64, .sboff = 0x34 },
		{ .magic = "ReIsErFs",  .len = 8, .kboff = 64, .sboff = 0x34 },
		{ .magic = "ReIsErFs",  .len = 8, .kboff =  8, .sboff = 20   },
		{ NULL }
	}
};

static const struct blkid_idinfo reiser4_idinfo =
{
	.name           = "reiser4",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_reiser4,
	.minsz          = 128 * 1024,
	.magics         =
	{
		{ .magic = "ReIsEr4", .len = 7, .kboff = 64 },
		{ NULL }
	}
};

struct exfat_super_block {
	uint8_t jump[3];
	uint8_t oem_name[8];
	uint8_t __unused1[53];
	uint64_t block_start;
	uint64_t block_count;
	uint32_t fat_block_start;
	uint32_t fat_block_count;
	uint32_t cluster_block_start;
	uint32_t cluster_count;
	uint32_t rootdir_cluster;
	uint8_t volume_serial[4];
	struct {
		uint8_t vermin;
		uint8_t vermaj;
	} version;
	uint16_t volume_state;
	uint8_t block_bits;
	uint8_t bpc_bits;
	uint8_t fat_count;
	uint8_t drive_no;
	uint8_t allocated_percent;
} __attribute__((__packed__));

struct exfat_entry_label {
	uint8_t type;
	uint8_t length;
	uint8_t name[30];
} __attribute__((__packed__));

#define BLOCK_SIZE(sb) (1u << (sb)->block_bits)
#define CLUSTER_SIZE(sb) (BLOCK_SIZE(sb) << (sb)->bpc_bits)
#define EXFAT_FIRST_DATA_CLUSTER 2
#define EXFAT_LAST_DATA_CLUSTER 0xffffff6
#define EXFAT_ENTRY_SIZE 32

#define EXFAT_ENTRY_EOD         0x00
#define EXFAT_ENTRY_LABEL       0x83

static uint64_t block_to_offset(const struct exfat_super_block *sb,
		uint64_t block)
{
	return block << sb->block_bits;
}

static uint64_t cluster_to_block(const struct exfat_super_block *sb,
		uint32_t cluster)
{
	return le32_to_cpu(sb->cluster_block_start) +
			((uint64_t) (cluster - EXFAT_FIRST_DATA_CLUSTER)
					<< sb->bpc_bits);
}

static uint64_t cluster_to_offset(const struct exfat_super_block *sb,
		uint32_t cluster)
{
	return block_to_offset(sb, cluster_to_block(sb, cluster));
}

static uint32_t next_cluster(blkid_probe pr,
		const struct exfat_super_block *sb, uint32_t cluster)
{
	uint32_t *next;
	uint64_t fat_offset;

	fat_offset = block_to_offset(sb, le32_to_cpu(sb->fat_block_start))
		+ (uint64_t) cluster * sizeof(cluster);
	next = (uint32_t *) blkid_probe_get_buffer(pr, fat_offset,
			sizeof(uint32_t));
	if (!next)
		return 0;
	return le32_to_cpu(*next);
}

static struct exfat_entry_label *find_label(blkid_probe pr,
		const struct exfat_super_block *sb)
{
	uint32_t cluster = le32_to_cpu(sb->rootdir_cluster);
	uint64_t offset = cluster_to_offset(sb, cluster);
	uint8_t *entry;
	const size_t max_iter = 10000;
	size_t i = 0;

	for (; i < max_iter; i++) {
		entry = (uint8_t *) blkid_probe_get_buffer(pr, offset,
				EXFAT_ENTRY_SIZE);
		if (!entry)
			return NULL;
		if (entry[0] == EXFAT_ENTRY_EOD)
			return NULL;
		if (entry[0] == EXFAT_ENTRY_LABEL)
			return (struct exfat_entry_label *) entry;

		offset += EXFAT_ENTRY_SIZE;
		if (offset % CLUSTER_SIZE(sb) == 0) {
			cluster = next_cluster(pr, sb, cluster);
			if (cluster < EXFAT_FIRST_DATA_CLUSTER)
				return NULL;
			if (cluster > EXFAT_LAST_DATA_CLUSTER)
				return NULL;
			offset = cluster_to_offset(sb, cluster);
		}
	}

	return NULL;
}

static int probe_exfat(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct exfat_super_block *sb;
	struct exfat_entry_label *label;

	sb = blkid_probe_get_sb(pr, mag, struct exfat_super_block);
	if (!sb || !CLUSTER_SIZE(sb))
		return errno ? -errno : BLKID_PROBE_NONE;

	label = find_label(pr, sb);
	if (label)
		blkid_probe_set_utf8label(pr, label->name,
				min(label->length * 2, 30), BLKID_ENC_UTF16LE);
	else if (errno)
		return -errno;

	blkid_probe_sprintf_uuid(pr, sb->volume_serial, 4,
			"%02hhX%02hhX-%02hhX%02hhX",
			sb->volume_serial[3], sb->volume_serial[2],
			sb->volume_serial[1], sb->volume_serial[0]);

	blkid_probe_sprintf_version(pr, "%u.%u", sb->version.vermaj, sb->version.vermin);
	return BLKID_PROBE_OK;
}

static const struct blkid_idinfo exfat_idinfo =
{
	.name           = "exfat",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_exfat,
	.magics         =
	{
		{ .magic = "EXFAT   ", .len = 8, .sboff = 3 },
		{ NULL }
	}
};


#define B_OS_NAME_LENGTH        0x20
#define SUPER_BLOCK_MAGIC1      0x42465331      /* BFS1 */
#define SUPER_BLOCK_MAGIC2      0xdd121031
#define SUPER_BLOCK_MAGIC3      0x15b6830e
#define SUPER_BLOCK_FS_ENDIAN   0x42494745      /* BIGE */
#define INODE_MAGIC1            0x3bbe0ad9
#define BPLUSTREE_MAGIC         0x69f6c2e8
#define BPLUSTREE_NULL          -1LL
#define NUM_DIRECT_BLOCKS       12
#define B_UINT64_TYPE           0x554c4c47      /* ULLG */
#define KEY_NAME                "be:volume_id"
#define KEY_SIZE                8

#define FS16_TO_CPU(value, fs_is_le) (fs_is_le ? le16_to_cpu(value) \
							: be16_to_cpu(value))
#define FS32_TO_CPU(value, fs_is_le) (fs_is_le ? le32_to_cpu(value) \
							: be32_to_cpu(value))
#define FS64_TO_CPU(value, fs_is_le) (fs_is_le ? le64_to_cpu(value) \
							: be64_to_cpu(value))

typedef struct block_run {
	int32_t         allocation_group;
	uint16_t        start;
	uint16_t        len;
} __attribute__((packed)) block_run, inode_addr;

struct befs_super_block {
	char            name[B_OS_NAME_LENGTH];
	int32_t         magic1;
	int32_t         fs_byte_order;
	uint32_t        block_size;
	uint32_t        block_shift;
	int64_t         num_blocks;
	int64_t         used_blocks;
	int32_t         inode_size;
	int32_t         magic2;
	int32_t         blocks_per_ag;
	int32_t         ag_shift;
	int32_t         num_ags;
	int32_t         flags;
	block_run       log_blocks;
	int64_t         log_start;
	int64_t         log_end;
	int32_t         magic3;
	inode_addr      root_dir;
	inode_addr      indices;
	int32_t         pad[8];
} __attribute__((packed));

typedef struct data_stream {
	block_run       direct[NUM_DIRECT_BLOCKS];
	int64_t         max_direct_range;
	block_run       indirect;
	int64_t         max_indirect_range;
	block_run       double_indirect;
	int64_t         max_double_indirect_range;
	int64_t         size;
} __attribute__((packed)) data_stream;

struct befs_inode {
	int32_t         magic1;
	inode_addr      inode_num;
	int32_t         uid;
	int32_t         gid;
	int32_t         mode;
	int32_t         flags;
	int64_t         create_time;
	int64_t         last_modified_time;
	inode_addr      parent;
	inode_addr      attributes;
	uint32_t        type;
	int32_t         inode_size;
	uint32_t        etc;
	data_stream     data;
	int32_t         pad[4];
	int32_t         small_data[0];
} __attribute__((packed));

struct small_data {
	uint32_t        type;
	uint16_t        name_size;
	uint16_t        data_size;
	char            name[0];
} __attribute__((packed));

struct bplustree_header {
	uint32_t        magic;
	uint32_t        node_size;
	uint32_t        max_number_of_levels;
	uint32_t        data_type;
	int64_t         root_node_pointer;
	int64_t         free_node_pointer;
	int64_t         maximum_size;
} __attribute__((packed));

struct bplustree_node {
	int64_t         left_link;
	int64_t         right_link;
	int64_t         overflow_link;
	uint16_t        all_key_count;
	uint16_t        all_key_length;
	char            name[0];
} __attribute__((packed));

static unsigned char *get_block_run(blkid_probe pr, const struct befs_super_block *bs,
					const struct block_run *br, int fs_le)
{
	return blkid_probe_get_buffer(pr,
			((uint64_t) FS32_TO_CPU(br->allocation_group, fs_le)
					<< FS32_TO_CPU(bs->ag_shift, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le))
				+ ((uint64_t) FS16_TO_CPU(br->start, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le)),
			(uint64_t) FS16_TO_CPU(br->len, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le));
}

static unsigned char *get_custom_block_run(blkid_probe pr,
				const struct befs_super_block *bs,
				const struct block_run *br,
				int64_t offset, uint32_t length, int fs_le)
{
	if (offset + length > (int64_t) FS16_TO_CPU(br->len, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le))
		return NULL;

	return blkid_probe_get_buffer(pr,
			((uint64_t) FS32_TO_CPU(br->allocation_group, fs_le)
					<< FS32_TO_CPU(bs->ag_shift, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le))
				+ ((uint64_t) FS16_TO_CPU(br->start, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le))
				+ offset,
			length);
}

static unsigned char *get_tree_node(blkid_probe pr, const struct befs_super_block *bs,
				const struct data_stream *ds,
				int64_t start, uint32_t length, int fs_le)
{
	if (start < (int64_t) FS64_TO_CPU(ds->max_direct_range, fs_le)) {
		int64_t br_len;
		size_t i;

		for (i = 0; i < NUM_DIRECT_BLOCKS; i++) {
			br_len = (int64_t) FS16_TO_CPU(ds->direct[i].len, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le);
			if (start < br_len)
				return get_custom_block_run(pr, bs,
							&ds->direct[i],
							start, length, fs_le);
			else
				start -= br_len;
		}
	} else if (start < (int64_t) FS64_TO_CPU(ds->max_indirect_range, fs_le)) {
		struct block_run *br;
		int64_t max_br, br_len, i;

		start -= FS64_TO_CPU(ds->max_direct_range, fs_le);
		max_br = ((int64_t) FS16_TO_CPU(ds->indirect.len, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le))
				/ sizeof(struct block_run);

		br = (struct block_run *) get_block_run(pr, bs, &ds->indirect,
									fs_le);
		if (!br)
			return NULL;

		for (i = 0; i < max_br; i++) {
			br_len = (int64_t) FS16_TO_CPU(br[i].len, fs_le)
					<< FS32_TO_CPU(bs->block_shift, fs_le);
			if (start < br_len)
				return get_custom_block_run(pr, bs, &br[i],
							start, length, fs_le);
			else
				start -= br_len;
		}
	} else if (start < (int64_t) FS64_TO_CPU(ds->max_double_indirect_range, fs_le)) {
		struct block_run *br;
		int64_t max_br, di_br_size, br_per_di_br, di_index, i_index;

		start -= (int64_t) FS64_TO_CPU(ds->max_indirect_range, fs_le);

		di_br_size = (int64_t) FS16_TO_CPU(ds->double_indirect.len,
				fs_le) << FS32_TO_CPU(bs->block_shift, fs_le);
		if (di_br_size == 0)
			return NULL;

		br_per_di_br = di_br_size / sizeof(struct block_run);
		if (br_per_di_br == 0)
			return NULL;

		di_index = start / (br_per_di_br * di_br_size);
		i_index = (start % (br_per_di_br * di_br_size)) / di_br_size;
		start = (start % (br_per_di_br * di_br_size)) % di_br_size;

		if (di_index >= br_per_di_br)
			return NULL; /* Corrupt? */

		br = (struct block_run *) get_block_run(pr, bs,
						&ds->double_indirect, fs_le);
		if (!br)
			return NULL;

		max_br = ((int64_t)FS16_TO_CPU(br[di_index].len, fs_le)
			  << FS32_TO_CPU(bs->block_shift, fs_le))
			/ sizeof(struct block_run);

		if (i_index >= max_br)
			return NULL; /* Corrupt? */

		br = (struct block_run *) get_block_run(pr, bs, &br[di_index],
									fs_le);
		if (!br)
			return NULL;

		return get_custom_block_run(pr, bs, &br[i_index], start, length,
									fs_le);
	}
	return NULL;
}

#define BAD_KEYS -2

static int32_t compare_keys(const char keys1[], uint16_t keylengths1[],
			    int32_t index, const char *key2,
			    uint16_t keylength2, uint16_t all_key_length,
			    int fs_le)
{
	const char *key1;
	uint16_t keylength1, keystart1;
	int32_t result;

	keystart1 = index == 0 ? 0 : FS16_TO_CPU(keylengths1[index - 1], fs_le);
	keylength1 = FS16_TO_CPU(keylengths1[index], fs_le) - keystart1;

	if (keystart1 + keylength1 > all_key_length)
		return BAD_KEYS; /* Corrupt? */

	key1 = &keys1[keystart1];

	result = strncmp(key1, key2, min(keylength1, keylength2));

	if (result == 0)
		return keylength1 - keylength2;

	if (result < 0) /* Don't clash with BAD_KEYS */
		result = -1;

	return result;
}

static int64_t get_key_value(blkid_probe pr, const struct befs_super_block *bs,
			const struct befs_inode *bi, const char *key, int fs_le)
{
	struct bplustree_header *bh;
	struct bplustree_node *bn;
	uint16_t *keylengths;
	int64_t *values;
	int64_t node_pointer;
	uint32_t bn_size, all_key_count, all_key_length;
	uint32_t keylengths_offset, values_offset;
	int32_t first, last, mid, cmp;
	int loop_detect = 0;

	errno = 0;
	bh = (struct bplustree_header *) get_tree_node(pr, bs, &bi->data, 0,
					sizeof(struct bplustree_header), fs_le);
	if (!bh)
		return errno ? -errno : -ENOENT;

	if ((int32_t) FS32_TO_CPU(bh->magic, fs_le) != BPLUSTREE_MAGIC)
		return -ENOENT;

	node_pointer = FS64_TO_CPU(bh->root_node_pointer, fs_le);
	bn_size = FS32_TO_CPU(bh->node_size, fs_le);

	if (bn_size < sizeof(struct bplustree_node))
		return -ENOENT; /* Corrupt? */

	do {
		errno = 0;

		bn = (struct bplustree_node *) get_tree_node(pr, bs, &bi->data,
			node_pointer, bn_size, fs_le);
		if (!bn)
			return errno ? -errno : -ENOENT;

		all_key_count = FS16_TO_CPU(bn->all_key_count, fs_le);
		all_key_length = FS16_TO_CPU(bn->all_key_length, fs_le);
		keylengths_offset =
			(sizeof(struct bplustree_node) + all_key_length
			 + sizeof(int64_t) - 1) & ~(sizeof(int64_t) - 1);
		values_offset = keylengths_offset +
			all_key_count * sizeof(uint16_t);

		if (values_offset + all_key_count * sizeof(uint64_t) > bn_size)
			return -ENOENT; /* Corrupt? */

		keylengths = (uint16_t *) ((uint8_t *) bn + keylengths_offset);
		values = (int64_t *) ((uint8_t *) bn + values_offset);

		first = 0;
		mid = 0;
		last = all_key_count - 1;

		cmp = compare_keys(bn->name, keylengths, last, key,
				   strlen(key), all_key_length, fs_le);
		if (cmp == BAD_KEYS)
			return -ENOENT;

		if (cmp == 0) {
			if ((int64_t) FS64_TO_CPU(bn->overflow_link, fs_le)
							== BPLUSTREE_NULL)
				return FS64_TO_CPU(values[last], fs_le);
			else
				node_pointer = FS64_TO_CPU(values[last], fs_le);
		} else if (cmp < 0)
			node_pointer = FS64_TO_CPU(bn->overflow_link, fs_le);
		else {
			while (first <= last) {
				mid = (first + last) / 2;

				cmp = compare_keys(bn->name, keylengths, mid,
						   key, strlen(key),
						   all_key_length, fs_le);
				if (cmp == BAD_KEYS)
					return -ENOENT;

				if (cmp == 0) {
					if ((int64_t) FS64_TO_CPU(bn->overflow_link,
						fs_le) == BPLUSTREE_NULL)
						return FS64_TO_CPU(values[mid],
									fs_le);
					else
						break;
				} else if (cmp < 0)
					first = mid + 1;
				else
					last = mid - 1;
			}
			if (cmp < 0)
				node_pointer = FS64_TO_CPU(values[mid + 1],
									fs_le);
			else
				node_pointer = FS64_TO_CPU(values[mid], fs_le);
		}
	} while (++loop_detect < 100 &&
		(int64_t) FS64_TO_CPU(bn->overflow_link, fs_le)
						!= BPLUSTREE_NULL);
	return 0;
}

static int get_uuid(blkid_probe pr, const struct befs_super_block *bs,
					uint64_t * const uuid, int fs_le)
{
	struct befs_inode *bi;
	struct small_data *sd;
	uint64_t bi_size, offset, sd_size, sd_total_size;

	bi = (struct befs_inode *) get_block_run(pr, bs, &bs->root_dir, fs_le);
	if (!bi)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (FS32_TO_CPU(bi->magic1, fs_le) != INODE_MAGIC1)
		return BLKID_PROBE_NONE;

	bi_size = (uint64_t)FS16_TO_CPU(bs->root_dir.len, fs_le) <<
		FS32_TO_CPU(bs->block_shift, fs_le);
	sd_total_size = min(bi_size - sizeof(struct befs_inode),
			    (uint64_t)FS32_TO_CPU(bi->inode_size, fs_le));

	offset = 0;

	while (offset + sizeof(struct small_data) <= sd_total_size) {
		sd = (struct small_data *) ((uint8_t *)bi->small_data + offset);
		sd_size = sizeof(struct small_data)
			+ FS16_TO_CPU(sd->name_size, fs_le) + 3
			+ FS16_TO_CPU(sd->data_size, fs_le) + 1;

		if (offset + sd_size > sd_total_size)
			break;

		if (FS32_TO_CPU(sd->type, fs_le) == B_UINT64_TYPE
			&& FS16_TO_CPU(sd->name_size, fs_le) == strlen(KEY_NAME)
			&& FS16_TO_CPU(sd->data_size, fs_le) == KEY_SIZE
			&& strcmp(sd->name, KEY_NAME) == 0) {

			memcpy(uuid,
			       sd->name + FS16_TO_CPU(sd->name_size, fs_le) + 3,
			       sizeof(uint64_t));

			break;
		} else if (FS32_TO_CPU(sd->type, fs_le) == 0
				&& FS16_TO_CPU(sd->name_size, fs_le) == 0
				&& FS16_TO_CPU(sd->data_size, fs_le) == 0)
			break;

		offset += sd_size;
	}

	if (*uuid == 0
		&& (FS32_TO_CPU(bi->attributes.allocation_group, fs_le) != 0
			|| FS16_TO_CPU(bi->attributes.start, fs_le) != 0
			|| FS16_TO_CPU(bi->attributes.len, fs_le) != 0)) {
		int64_t value;

		bi = (struct befs_inode *) get_block_run(pr, bs,
							&bi->attributes, fs_le);
		if (!bi)
			return errno ? -errno : BLKID_PROBE_NONE;

		if (FS32_TO_CPU(bi->magic1, fs_le) != INODE_MAGIC1)
			return BLKID_PROBE_NONE;

		value = get_key_value(pr, bs, bi, KEY_NAME, fs_le);
		if (value < 0)
			return value == -ENOENT ? BLKID_PROBE_NONE : value;

		else if (value > 0) {
			bi = (struct befs_inode *) blkid_probe_get_buffer(pr,
				value << FS32_TO_CPU(bs->block_shift, fs_le),
				FS32_TO_CPU(bs->block_size, fs_le));
			if (!bi)
				return errno ? -errno : BLKID_PROBE_NONE;

			if (FS32_TO_CPU(bi->magic1, fs_le) != INODE_MAGIC1)
				return 1;

			if (FS32_TO_CPU(bi->type, fs_le) == B_UINT64_TYPE
				&& FS64_TO_CPU(bi->data.size, fs_le) == KEY_SIZE
				&& FS16_TO_CPU(bi->data.direct[0].len, fs_le)
									== 1) {
				uint64_t *attr_data;

				attr_data = (uint64_t *) get_block_run(pr, bs,
						&bi->data.direct[0], fs_le);
				if (!attr_data)
					return errno ? -errno : BLKID_PROBE_NONE;

				*uuid = *attr_data;
			}
		}
	}
	return 0;
}

static int probe_befs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct befs_super_block *bs;
	const char *version = NULL;
	uint64_t volume_id = 0;
	uint32_t block_size, block_shift;
	int fs_le, ret;

	bs = (struct befs_super_block *) blkid_probe_get_buffer(pr,
					mag->sboff - B_OS_NAME_LENGTH,
					sizeof(struct befs_super_block));
	if (!bs)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (le32_to_cpu(bs->magic1) == SUPER_BLOCK_MAGIC1
		&& le32_to_cpu(bs->magic2) == SUPER_BLOCK_MAGIC2
		&& le32_to_cpu(bs->magic3) == SUPER_BLOCK_MAGIC3
		&& le32_to_cpu(bs->fs_byte_order) == SUPER_BLOCK_FS_ENDIAN) {
		fs_le = 1;
		version = "little-endian";
	} else if (be32_to_cpu(bs->magic1) == SUPER_BLOCK_MAGIC1
		&& be32_to_cpu(bs->magic2) == SUPER_BLOCK_MAGIC2
		&& be32_to_cpu(bs->magic3) == SUPER_BLOCK_MAGIC3
		&& be32_to_cpu(bs->fs_byte_order) == SUPER_BLOCK_FS_ENDIAN) {
		fs_le = 0;
		version = "big-endian";
	} else
		return BLKID_PROBE_NONE;

	block_size = FS32_TO_CPU(bs->block_size, fs_le);
	block_shift = FS32_TO_CPU(bs->block_shift, fs_le);

	if (block_shift < 10 || block_shift > 13 ||
	    block_size != 1U << block_shift)
		return BLKID_PROBE_NONE;

	ret = get_uuid(pr, bs, &volume_id, fs_le);

	if (ret != 0)
		return ret;

	/* all checks pass, set LABEL, VERSION and UUID */
	if (*bs->name != '\0')
		blkid_probe_set_label(pr, (unsigned char *) bs->name, sizeof(bs->name));
	if (version)
		blkid_probe_set_version(pr, version);

	if (volume_id)
		blkid_probe_sprintf_uuid(pr, (unsigned char *) &volume_id,
					sizeof(volume_id), "%016" PRIx64,
					FS64_TO_CPU(volume_id, fs_le));
	return BLKID_PROBE_OK;
}

static const struct blkid_idinfo befs_idinfo =
{
	.name           = "befs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_befs,
	.minsz          = 1024 * 1440,
	.magics         = {
		{ .magic = "BFS1", .len = 4, .sboff = B_OS_NAME_LENGTH },
		{ .magic = "1SFB", .len = 4, .sboff = B_OS_NAME_LENGTH },
		{ .magic = "BFS1", .len = 4, .sboff = 0x200 +
							B_OS_NAME_LENGTH },
		{ .magic = "1SFB", .len = 4, .sboff = 0x200 +
							B_OS_NAME_LENGTH },
		{ NULL }
	}
};

struct ufs_super_block {
	uint32_t        fs_link;
	uint32_t        fs_rlink;
	uint32_t        fs_sblkno;
	uint32_t        fs_cblkno;
	uint32_t        fs_iblkno;
	uint32_t        fs_dblkno;
	uint32_t        fs_cgoffset;
	uint32_t        fs_cgmask;
	uint32_t        fs_time;
	uint32_t        fs_size;
	uint32_t        fs_dsize;
	uint32_t        fs_ncg;
	uint32_t        fs_bsize;
	uint32_t        fs_fsize;
	uint32_t        fs_frag;
	uint32_t        fs_minfree;
	uint32_t        fs_rotdelay;
	uint32_t        fs_rps;
	uint32_t        fs_bmask;
	uint32_t        fs_fmask;
	uint32_t        fs_bshift;
	uint32_t        fs_fshift;
	uint32_t        fs_maxcontig;
	uint32_t        fs_maxbpg;
	uint32_t        fs_fragshift;
	uint32_t        fs_fsbtodb;
	uint32_t        fs_sbsize;
	uint32_t        fs_csmask;
	uint32_t        fs_csshift;
	uint32_t        fs_nindir;
	uint32_t        fs_inopb;
	uint32_t        fs_nspf;
	uint32_t        fs_optim;
	uint32_t        fs_npsect_state;
	uint32_t        fs_interleave;
	uint32_t        fs_trackskew;
	uint32_t        fs_id[2];
	uint32_t        fs_csaddr;
	uint32_t        fs_cssize;
	uint32_t        fs_cgsize;
	uint32_t        fs_ntrak;
	uint32_t        fs_nsect;
	uint32_t        fs_spc;
	uint32_t        fs_ncyl;
	uint32_t        fs_cpg;
	uint32_t        fs_ipg;
	uint32_t        fs_fpg;
	struct ufs_csum {
		uint32_t        cs_ndir;
		uint32_t        cs_nbfree;
		uint32_t        cs_nifree;
		uint32_t        cs_nffree;
	} fs_cstotal;
	int8_t          fs_fmod;
	int8_t          fs_clean;
	int8_t          fs_ronly;
	int8_t          fs_flags;
	union {
		struct {
			int8_t  fs_fsmnt[512];
			uint32_t        fs_cgrotor;
			uint32_t        fs_csp[31];
			uint32_t        fs_maxcluster;
			uint32_t        fs_cpc;
			uint16_t        fs_opostbl[16][8];
		} fs_u1;
		struct {
			int8_t          fs_fsmnt[468];
			uint8_t         fs_volname[32];
			uint64_t        fs_swuid;
			int32_t         fs_pad;
			uint32_t        fs_cgrotor;
			uint32_t        fs_ocsp[28];
			uint32_t        fs_contigdirs;
			uint32_t        fs_csp;
			uint32_t        fs_maxcluster;
			uint32_t        fs_active;
			int32_t         fs_old_cpc;
			int32_t         fs_maxbsize;
			int64_t         fs_sparecon64[17];
			int64_t         fs_sblockloc;
			struct ufs2_csum_total {
				uint64_t        cs_ndir;
				uint64_t        cs_nbfree;
				uint64_t        cs_nifree;
				uint64_t        cs_nffree;
				uint64_t        cs_numclusters;
				uint64_t        cs_spare[3];
			} fs_cstotal;
			struct ufs_timeval {
				int32_t         tv_sec;
				int32_t         tv_usec;
			} fs_time;
			int64_t         fs_size;
			int64_t         fs_dsize;
			uint64_t        fs_csaddr;
			int64_t         fs_pendingblocks;
			int32_t         fs_pendinginodes;
		} __attribute__((packed)) fs_u2;
	}  fs_u11;
	union {
		struct {
			int32_t         fs_sparecon[53];
			int32_t         fs_reclaim;
			int32_t         fs_sparecon2[1];
			int32_t         fs_state;
			uint32_t        fs_qbmask[2];
			uint32_t        fs_qfmask[2];
		} fs_sun;
		struct {
			int32_t         fs_sparecon[53];
			int32_t         fs_reclaim;
			int32_t         fs_sparecon2[1];
			uint32_t        fs_npsect;
			uint32_t        fs_qbmask[2];
			uint32_t        fs_qfmask[2];
		} fs_sunx86;
		struct {
			int32_t         fs_sparecon[50];
			int32_t         fs_contigsumsize;
			int32_t         fs_maxsymlinklen;
			int32_t         fs_inodefmt;
			uint32_t        fs_maxfilesize[2];
			uint32_t        fs_qbmask[2];
			uint32_t        fs_qfmask[2];
			int32_t         fs_state;
		} fs_44;
	} fs_u2;
	int32_t         fs_postblformat;
	int32_t         fs_nrpos;
	int32_t         fs_postbloff;
	int32_t         fs_rotbloff;
	uint32_t        fs_magic;
	uint8_t         fs_space[1];
} __attribute__((packed));

#define UFS_MAGIC                       0x00011954
#define UFS2_MAGIC                      0x19540119
#define UFS_MAGIC_FEA                   0x00195612
#define UFS_MAGIC_LFN                   0x00095014
#define UFS_MAGIC_SEC                   0x00612195
#define UFS_MAGIC_4GB                   0x05231994

static int probe_ufs(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int offsets[] = { 0, 8, 64, 256 };
	uint32_t mags[] = {
		UFS2_MAGIC, UFS_MAGIC, UFS_MAGIC_FEA, UFS_MAGIC_LFN,
		UFS_MAGIC_SEC, UFS_MAGIC_4GB
	};
	size_t i;
	uint32_t magic;
	struct ufs_super_block *ufs;
	int is_be;

	for (i = 0; i < ARRAY_SIZE(offsets); i++) {
		uint32_t magLE, magBE;
		size_t y;

		ufs = (struct ufs_super_block *)
				blkid_probe_get_buffer(pr,
					offsets[i] * 1024,
					sizeof(struct ufs_super_block));
		if (!ufs)
			return errno ? -errno : 1;

		magBE = be32_to_cpu(ufs->fs_magic);
		magLE = le32_to_cpu(ufs->fs_magic);

		for (y = 0; y < ARRAY_SIZE(mags); y++) {
			if (magLE == mags[y] || magBE == mags[y]) {
				magic = mags[y];
				is_be = (magBE == mags[y]);
				goto found;
			}
		}
	}

	return 1;

found:
	if (magic == UFS2_MAGIC) {
		blkid_probe_set_version(pr, "2");
		blkid_probe_set_label(pr, ufs->fs_u11.fs_u2.fs_volname, sizeof(ufs->fs_u11.fs_u2.fs_volname));
	} else
		blkid_probe_set_version(pr, "1");
	if (ufs->fs_id[0] || ufs->fs_id[1])
	{
		if (is_be)
			blkid_probe_sprintf_uuid(pr,
					 (unsigned char *) &ufs->fs_id,
						 sizeof(ufs->fs_id),
						 "%08x%08x",
						 be32_to_cpu(ufs->fs_id[0]),
						 be32_to_cpu(ufs->fs_id[1]));
		else
			blkid_probe_sprintf_uuid(pr,
					 (unsigned char *) &ufs->fs_id,
						 sizeof(ufs->fs_id),
						 "%08x%08x",
						 le32_to_cpu(ufs->fs_id[0]),
						 le32_to_cpu(ufs->fs_id[1]));
	}

	if (blkid_probe_set_magic(pr,
			(offsets[i] * 1024) +
				offsetof(struct ufs_super_block, fs_magic),
			sizeof(ufs->fs_magic),
			(unsigned char *) &ufs->fs_magic))
		return 1;

	return 0;
}

/* According to libvolume_id the UFS superblock could be on four positions.
 * The original libblkid has checked one position (.kboff=8) only.
 *
 * We know four UFS magic strings and UFS could be both little-endian and
 * big-endian. ... so we have:
 *
 *      4 position * 4 string * 2 version = 32 magic strings
 *
 * It seems simpler to check for these string in probing function that hardcode
 * all in the .magic array. */
static const struct blkid_idinfo ufs_idinfo =
{
	.name           = "ufs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_ufs,
	.magics         = BLKID_NONE_MAGIC
};

/* drbd/linux/drbd.h */
#define DRBD_MAGIC 0x83740267

/* user/drbdmeta.c
 * We only support v08 for now */
#define DRBD_MD_MAGIC_08         (DRBD_MAGIC+4)
#define DRBD_MD_MAGIC_84_UNCLEAN (DRBD_MAGIC+5)

enum drbd_uuid_index {
	UI_CURRENT,
	UI_BITMAP,
	UI_HISTORY_START,
	UI_HISTORY_END,
	UI_SIZE,                /* nl-packet: number of dirty bits */
	UI_FLAGS,               /* nl-packet: flags */
	UI_EXTENDED_SIZE        /* Everything. */
};

/* Minor modifications wrt. types */
struct md_on_disk_08 {
	uint64_t la_sect;         /* last agreed size. */
	uint64_t uuid[UI_SIZE];   /* UUIDs */
	uint64_t device_uuid;
	uint64_t reserved_u64_1;
	uint32_t flags;
	uint32_t magic;
	uint32_t md_size_sect;
	int32_t  al_offset;       /* signed sector offset to this block */
	uint32_t al_nr_extents;   /* important for restoring the AL */
	int32_t  bm_offset;       /* signed sector offset to the bitmap, from here */
	uint32_t bm_bytes_per_bit;
	uint32_t reserved_u32[4];

	char reserved[8 * 512 - (8*(UI_SIZE+3)+4*11)];
};


static int probe_drbd(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct md_on_disk_08 *md;
	off_t off;

	off = pr->size - sizeof(*md);

	/* Small devices cannot be drbd (?) */
	if (pr->size < 0x10000)
		return 1;

	md = (struct md_on_disk_08 *)
			blkid_probe_get_buffer(pr,
					off,
					sizeof(struct md_on_disk_08));
	if (!md)
		return errno ? -errno : 1;

	if (be32_to_cpu(md->magic) != DRBD_MD_MAGIC_08 &&
			be32_to_cpu(md->magic) != DRBD_MD_MAGIC_84_UNCLEAN)
		return 1;

	/* DRBD does not have "real" uuids; the following resembles DRBD's
	 * notion of uuids (64 bit, see struct above) */
	blkid_probe_sprintf_uuid(pr,
		(unsigned char *) &md->device_uuid, sizeof(md->device_uuid),
		"%" PRIx64, be64_to_cpu(md->device_uuid));

	blkid_probe_set_version(pr, "v08");

	if (blkid_probe_set_magic(pr,
				off + offsetof(struct md_on_disk_08, magic),
				sizeof(md->magic),
				(unsigned char *) &md->magic))
		return 1;

	return 0;
}

static const struct blkid_idinfo drbd_idinfo =
{
	.name           = "drbd",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_drbd,
	.magics         = BLKID_NONE_MAGIC
};


struct iso9660_date {
	unsigned char year[4];
	unsigned char month[2];
	unsigned char day[2];
	unsigned char hour[2];
	unsigned char minute[2];
	unsigned char second[2];
	unsigned char hundredth[2];
	unsigned char offset;
} __attribute__ ((packed));

/* PVD - Primary volume descriptor */
struct iso_volume_descriptor {
	unsigned char   vd_type;
	unsigned char   vd_id[5];
	unsigned char   vd_version;
	unsigned char   flags;
	unsigned char   system_id[32];
	unsigned char   volume_id[32];
	unsigned char   unused[8];
	unsigned char   space_size[8];
	unsigned char   escape_sequences[8];
	unsigned char  unused1[222];
	unsigned char  publisher_id[128];
	unsigned char  unused2[128];
	unsigned char  application_id[128];
	unsigned char  unused3[111];
	struct iso9660_date created;
	struct iso9660_date modified;
} __attribute__((packed));

/* Boot Record */
struct boot_record {
	unsigned char   vd_type;
	unsigned char   vd_id[5];
	unsigned char   vd_version;
	unsigned char   boot_system_id[32];
	unsigned char   boot_id[32];
	unsigned char   unused[1];
} __attribute__((packed));

#define ISO_SUPERBLOCK_OFFSET           0x8000
#define ISO_SECTOR_SIZE                 0x800
#define ISO_VD_OFFSET                   (ISO_SUPERBLOCK_OFFSET + ISO_SECTOR_SIZE)
#define ISO_VD_BOOT_RECORD              0x0
#define ISO_VD_SUPPLEMENTARY            0x2
#define ISO_VD_END                      0xff
#define ISO_VD_MAX                      16

struct high_sierra_volume_descriptor {
	unsigned char   foo[8];
	unsigned char   type;
	unsigned char   id[5];
	unsigned char   version;
	unsigned char   unused1;
	unsigned char   system_id[32];
	unsigned char   volume_id[32];
} __attribute__((packed));

/* returns 1 if the begin of @ascii is equal to @utf16 string. */
static int ascii_eq_utf16be(unsigned char *ascii,
			unsigned char *utf16, size_t len)
{
	size_t a, u;

	for (a = 0, u = 0; u < len; a++, u += 2) {
		if (utf16[u] != 0x0 || ascii[a] != utf16[u + 1])
			return 0;
	}
	return 1;
}

/* old High Sierra format */
static int probe_iso9660_hsfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct high_sierra_volume_descriptor *iso;

	iso = blkid_probe_get_sb(pr, mag, struct high_sierra_volume_descriptor);
	if (!iso)
		return errno ? -errno : 1;

	blkid_probe_set_version(pr, "High Sierra");
	blkid_probe_set_label(pr, iso->volume_id, sizeof(iso->volume_id));
	return 0;
}

static int probe_iso9660_set_uuid (blkid_probe pr, const struct iso9660_date *date)
{
	unsigned char buffer[16];
	unsigned int i, zeros = 0;

	buffer[0] = date->year[0];
	buffer[1] = date->year[1];
	buffer[2] = date->year[2];
	buffer[3] = date->year[3];
	buffer[4] = date->month[0];
	buffer[5] = date->month[1];
	buffer[6] = date->day[0];
	buffer[7] = date->day[1];
	buffer[8] = date->hour[0];
	buffer[9] = date->hour[1];
	buffer[10] = date->minute[0];
	buffer[11] = date->minute[1];
	buffer[12] = date->second[0];
	buffer[13] = date->second[1];
	buffer[14] = date->hundredth[0];
	buffer[15] = date->hundredth[1];

	/* count the number of zeros ('0') in the date buffer */
	for (i = 0, zeros = 0; i < sizeof(buffer); i++)
		if (buffer[i] == '0')
			zeros++;

	/* due to the iso9660 standard if all date fields are '0' and offset is 0, the date is unset */
	if (zeros == sizeof(buffer) && date->offset == 0)
		return 0;

	/* generate an UUID using this date and return success */
	blkid_probe_sprintf_uuid (pr, buffer, sizeof(buffer),
		"%c%c%c%c-%c%c-%c%c-%c%c-%c%c-%c%c-%c%c",
		buffer[0], buffer[1], buffer[2], buffer[3],
		buffer[4], buffer[5],
		buffer[6], buffer[7],
		buffer[8], buffer[9],
		buffer[10], buffer[11],
		buffer[12], buffer[13],
		buffer[14], buffer[15]);

	return 1;
}

static int is_str_empty(const unsigned char *str, size_t len)
{
	size_t i;

	if (!str || !*str)
		return 1;

	for (i = 0; i < len; i++)
		if (!isspace(str[i]))
			return 0;
	return 1;
}

/* iso9660 [+ Microsoft Joliet Extension] */
static int probe_iso9660(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct iso_volume_descriptor *iso;
	unsigned char label[32];
	int i;
	int off;

	if (strcmp(mag->magic, "CDROM") == 0)
		return probe_iso9660_hsfs(pr, mag);

	iso = blkid_probe_get_sb(pr, mag, struct iso_volume_descriptor);
	if (!iso)
		return errno ? -errno : 1;

	memcpy(label, iso->volume_id, sizeof(label));

	if (!is_str_empty(iso->system_id, sizeof(iso->system_id)))
		blkid_probe_set_id_label(pr, "SYSTEM_ID", iso->system_id, sizeof(iso->system_id));

	if (!is_str_empty(iso->publisher_id, sizeof(iso->publisher_id)))
		blkid_probe_set_id_label(pr, "PUBLISHER_ID", iso->publisher_id, sizeof(iso->publisher_id));

	if (!is_str_empty(iso->application_id, sizeof(iso->application_id)))
		blkid_probe_set_id_label(pr, "APPLICATION_ID", iso->application_id, sizeof(iso->application_id));

	/* create an UUID using the modified/created date */
	if (! probe_iso9660_set_uuid(pr, &iso->modified))
		probe_iso9660_set_uuid(pr, &iso->created);

	/* Joliet Extension and Boot Record */
	off = ISO_VD_OFFSET;
	for (i = 0; i < ISO_VD_MAX; i++) {
		struct boot_record *boot= (struct boot_record *)
			blkid_probe_get_buffer(pr,
					off,
					max(sizeof(struct boot_record),
					    sizeof(struct iso_volume_descriptor)));

		if (boot == NULL || boot->vd_type == ISO_VD_END)
			break;

		if (boot->vd_type == ISO_VD_BOOT_RECORD) {
			if (!is_str_empty(boot->boot_system_id,
					  sizeof(boot->boot_system_id)))
				blkid_probe_set_id_label(pr, "BOOT_SYSTEM_ID",
							boot->boot_system_id,
							sizeof(boot->boot_system_id));
			off += ISO_SECTOR_SIZE;
			continue;
		}

		/* Not a Boot record, lets see if its supplementary volume descriptor */
		iso = (struct iso_volume_descriptor *) boot;

		if (iso->vd_type != ISO_VD_SUPPLEMENTARY) {
			off += ISO_SECTOR_SIZE;
			continue;
		}

		if (memcmp(iso->escape_sequences, "%/@", 3) == 0 ||
		    memcmp(iso->escape_sequences, "%/C", 3) == 0 ||
		    memcmp(iso->escape_sequences, "%/E", 3) == 0) {

			blkid_probe_set_version(pr, "Joliet Extension");

			/* Is the Joliet (UTF16BE) label equal to the label in
			 * the PVD? If yes, use PVD label.  The Joliet version
			 * of the label could be trimmed (because UTF16..). */
			if (ascii_eq_utf16be(label, iso->volume_id, 32))
				break;

			blkid_probe_set_utf8label(pr,
					iso->volume_id,
					sizeof(iso->volume_id),
					BLKID_ENC_UTF16BE);
			goto has_label;
		}
		off += ISO_SECTOR_SIZE;
	}

	/* Joliet not found, let use standard iso label */
	blkid_probe_set_label(pr, label, sizeof(label));

has_label:
	return 0;
}

static const struct blkid_idinfo iso9660_idinfo =
{
	.name           = "iso9660",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_iso9660,
	.flags          = BLKID_IDINFO_TOLERANT,
	.magics         =
	{
		{ .magic = "CD001", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "CDROM", .len = 5, .kboff = 32, .sboff = 9 },
		{ NULL }
	}
};

struct hpfs_boot_block
{
	uint8_t         jmp[3];
	uint8_t         oem_id[8];
	uint8_t         bytes_per_sector[2];
	uint8_t         sectors_per_cluster;
	uint8_t         n_reserved_sectors[2];
	uint8_t         n_fats;
	uint8_t         n_rootdir_entries[2];
	uint8_t         n_sectors_s[2];
	uint8_t         media_byte;
	uint16_t        sectors_per_fat;
	uint16_t        sectors_per_track;
	uint16_t        heads_per_cyl;
	uint32_t        n_hidden_sectors;
	uint32_t        n_sectors_l;
	uint8_t         drive_number;
	uint8_t         mbz;
	uint8_t         sig_28h;
	uint8_t         vol_serno[4];
	uint8_t         vol_label[11];
	uint8_t         sig_hpfs[8];
	uint8_t         pad[448];
	uint8_t         magic[2];
} __attribute__((packed));

struct hpfs_super_block
{
	uint8_t         magic[4];
	uint8_t         magic1[4];
	uint8_t         version;
} __attribute__((packed));

struct hpfs_spare_super
{
	uint8_t         magic[4];
	uint8_t         magic1[4];
} __attribute__((packed));


#define HPFS_SB_OFFSET                  0x2000
#define HPFS_SBSPARE_OFFSET             0x2200

static int probe_hpfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct hpfs_super_block *hs;
	struct hpfs_spare_super *hss;
	struct hpfs_boot_block *hbb;
	uint8_t version;

	/* super block */
	hs = blkid_probe_get_sb(pr, mag, struct hpfs_super_block);
	if (!hs)
		return errno ? -errno : 1;
	version = hs->version;

	/* spare super block */
	hss = (struct hpfs_spare_super *)
			blkid_probe_get_buffer(pr,
				HPFS_SBSPARE_OFFSET,
				sizeof(struct hpfs_spare_super));
	if (!hss)
		return errno ? -errno : 1;
	if (memcmp(hss->magic, "\x49\x18\x91\xf9", 4) != 0)
		return 1;

	/* boot block (with UUID and LABEL) */
	hbb = (struct hpfs_boot_block *)
			blkid_probe_get_buffer(pr,
				0,
				sizeof(struct hpfs_boot_block));
	if (!hbb)
		return errno ? -errno : 1;
	if (memcmp(hbb->magic, "\x55\xaa", 2) == 0 &&
	    memcmp(hbb->sig_hpfs, "HPFS", 4) == 0 &&
	    hbb->sig_28h == 0x28) {
		blkid_probe_set_label(pr, hbb->vol_label, sizeof(hbb->vol_label));
		blkid_probe_sprintf_uuid(pr,
				hbb->vol_serno, sizeof(hbb->vol_serno),
				"%02X%02X-%02X%02X",
				hbb->vol_serno[3], hbb->vol_serno[2],
				hbb->vol_serno[1], hbb->vol_serno[0]);
	}
	blkid_probe_sprintf_version(pr, "%u", version);
	return 0;
}

static const struct blkid_idinfo hpfs_idinfo =
{
	.name           = "hpfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_hpfs,
	.magics         =
	{
		{
		  .magic = "\x49\xe8\x95\xf9",
		  .len = 4,
		  .kboff = (HPFS_SB_OFFSET >> 10)
		},
		{ NULL }
	}
};


#define BDE_HDR_SIZE    512
#define BDE_HDR_OFFSET  0

struct bde_header_win7 {
/*   0 */ unsigned char boot_entry_point[3];
/*   3 */ unsigned char fs_signature[8];
/*  11 */ unsigned char __dummy1[67 - 11];
/*  67 */ uint32_t      volume_serial;          /* NTFS uses 64bit serial number */
/*  71 */ unsigned char volume_label[11];       /* "NO NAME\x20\x20\x20\x20" only */
/*  82 */ unsigned char __dummy2[160 - 82];
/* 160 */ unsigned char guid[16];               /* BitLocker specific GUID */
/* 176 */ uint64_t      fve_metadata_offset;
} __attribute__((packed));


struct bde_header_togo {
/*   0 */ unsigned char boot_entry_point[3];
/*   3 */ unsigned char fs_signature[8];
/*  11 */ unsigned char __dummy[424 - 11];
/* 424 */ unsigned char guid[16];
/* 440 */ uint64_t      fve_metadata_offset;
} __attribute__((packed));


struct bde_fve_metadata {
/*   0 */ unsigned char  signature[8];
/*   8 */ uint16_t       size;
/*  10 */ uint16_t       version;
};

enum {
	BDE_VERSION_VISTA = 0,
	BDE_VERSION_WIN7,
	BDE_VERSION_TOGO
};

#define BDE_MAGIC_VISTA         "\xeb\x52\x90-FVE-FS-"
#define BDE_MAGIC_WIN7          "\xeb\x58\x90-FVE-FS-"
#define BDE_MAGIC_TOGO          "\xeb\x58\x90MSWIN4.1"

#define BDE_MAGIC_FVE           "-FVE-FS-"

static int get_bitlocker_type(const unsigned char *buf)
{
	size_t i;
	static const char * const map[] = {
		[BDE_VERSION_VISTA] = BDE_MAGIC_VISTA,
		[BDE_VERSION_WIN7]  = BDE_MAGIC_WIN7,
		[BDE_VERSION_TOGO]  = BDE_MAGIC_TOGO
	};

	for (i = 0; i < ARRAY_SIZE(map); i++) {
		if (memcmp(buf, map[i], 11) == 0)
			return (int) i;
	}

	return -1;
}

/* Returns: < 0 error, 1 nothing, 0 success */
static int get_bitlocker_headers(blkid_probe pr,
				int *type,
				const unsigned char **buf_hdr,
				const unsigned char **buf_fve)
{

	const unsigned char *buf;
	const struct bde_fve_metadata *fve;
	uint64_t off = 0;
	int kind;

	if (buf_hdr)
		*buf_hdr = NULL;
	if (buf_fve)
		*buf_fve = NULL;
	if (type)
		*type = -1;

	buf = blkid_probe_get_buffer(pr, BDE_HDR_OFFSET, BDE_HDR_SIZE);
	if (!buf)
		return errno ? -errno : 1;

	kind = get_bitlocker_type(buf);

	/* Check BitLocker header */
	switch (kind) {
	case BDE_VERSION_WIN7:
		off = le64_to_cpu(((const struct bde_header_win7 *) buf)->fve_metadata_offset);
		break;
	case BDE_VERSION_TOGO:
		off = le64_to_cpu(((const struct bde_header_togo *) buf)->fve_metadata_offset);
		break;
	case BDE_VERSION_VISTA:
		goto done;
	default:
		goto nothing;
	}

	if (!off)
		goto nothing;
	if (buf_hdr)
		*buf_hdr = buf;

	/* Check Bitlocker FVE metadata header */
	buf = blkid_probe_get_buffer(pr, off, sizeof(struct bde_fve_metadata));
	if (!buf)
		return errno ? -errno : 1;

	fve = (const struct bde_fve_metadata *) buf;
	if (memcmp(fve->signature, BDE_MAGIC_FVE, sizeof(fve->signature)) != 0)
		goto nothing;
	if (buf_fve)
		*buf_fve = buf;
done:
	if (type)
		*type = kind;
	return 0;
nothing:
	return 1;
}

/* This is used by vFAT and NTFS prober to avoid collisions with bitlocker. */
static int blkid_probe_is_bitlocker(blkid_probe pr)
{
	return get_bitlocker_headers(pr, NULL, NULL, NULL) == 0;
}

static int probe_bitlocker(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	const unsigned char *buf_fve = NULL;
	const unsigned char *buf_hdr = NULL;
	int rc, kind;

	rc = get_bitlocker_headers(pr, &kind, &buf_hdr, &buf_fve);
	if (rc)
		return rc;

	if (kind == BDE_VERSION_WIN7) {
		const struct bde_header_win7 *hdr = (const struct bde_header_win7 *) buf_hdr;

		/* Unfortunately, it seems volume_serial is always zero */
		blkid_probe_sprintf_uuid(pr,
				(const unsigned char *) &hdr->volume_serial,
				sizeof(hdr->volume_serial),
				"%016d", le32_to_cpu(hdr->volume_serial));
	}

	if (buf_fve) {
		const struct bde_fve_metadata *fve = (const struct bde_fve_metadata *) buf_fve;

		blkid_probe_sprintf_version(pr, "%d", fve->version);
	}
	return 0;
}

/* See header details:
 * https://github.com/libyal/libbde/blob/master/documentation/BitLocker%20Drive%20Encryption%20(BDE)%20format.asciidoc
 */
static const struct blkid_idinfo bitlocker_idinfo =
{
	.name           = "BitLocker",
	.usage          = BLKID_USAGE_CRYPTO,
	.probefunc      = probe_bitlocker,
	.magics         =
	{
		{ .magic = BDE_MAGIC_VISTA, .len = 11 },
		{ .magic = BDE_MAGIC_WIN7,  .len = 11 },
		{ .magic = BDE_MAGIC_TOGO,  .len = 11 },
		{ NULL }
	}
};

struct ubi_ec_hdr {
	uint32_t        magic;
	uint8_t         version;
	uint8_t         padding1[3];
	uint64_t        ec;
	uint32_t        vid_hdr_offset;
	uint32_t        data_offset;
	uint32_t        image_seq;
	uint8_t         padding2[32];
	uint32_t        hdr_crc;
} __attribute__((packed));

static int probe_ubi(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct ubi_ec_hdr *hdr;

	hdr = blkid_probe_get_sb(pr, mag, struct ubi_ec_hdr);
	if (!hdr)
		return -1;

	blkid_probe_sprintf_version(pr, "%u", hdr->version);
	blkid_probe_sprintf_uuid(pr, (unsigned char *)&hdr->image_seq, 4, "%u",
				 be32_to_cpu(hdr->image_seq));
	return 0;
}

static const struct blkid_idinfo ubi_idinfo =
{
	.name           = "ubi",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_ubi,
	.magics         =
	{
		{ .magic = "UBI#", .len = 4 },
		{ NULL }
	}
};

/* Yucky misaligned values */
struct vfat_super_block {
/* 00*/ unsigned char   vs_ignored[3];
/* 03*/ unsigned char   vs_sysid[8];
/* 0b*/ unsigned char   vs_sector_size[2];
/* 0d*/ uint8_t         vs_cluster_size;
/* 0e*/ uint16_t        vs_reserved;
/* 10*/ uint8_t         vs_fats;
/* 11*/ unsigned char   vs_dir_entries[2];
/* 13*/ unsigned char   vs_sectors[2];
/* 15*/ unsigned char   vs_media;
/* 16*/ uint16_t        vs_fat_length;
/* 18*/ uint16_t        vs_secs_track;
/* 1a*/ uint16_t        vs_heads;
/* 1c*/ uint32_t        vs_hidden;
/* 20*/ uint32_t        vs_total_sect;
/* 24*/ uint32_t        vs_fat32_length;
/* 28*/ uint16_t        vs_flags;
/* 2a*/ uint8_t         vs_version[2];
/* 2c*/ uint32_t        vs_root_cluster;
/* 30*/ uint16_t        vs_fsinfo_sector;
/* 32*/ uint16_t        vs_backup_boot;
/* 34*/ uint16_t        vs_reserved2[6];
/* 40*/ unsigned char   vs_unknown[3];
/* 43*/ unsigned char   vs_serno[4];
/* 47*/ unsigned char   vs_label[11];
/* 52*/ unsigned char   vs_magic[8];
/* 5a*/ unsigned char   vs_dummy2[0x1fe - 0x5a];
/*1fe*/ unsigned char   vs_pmagic[2];
} __attribute__((packed));

/* Yucky misaligned values */
struct msdos_super_block {
/* 00*/ unsigned char   ms_ignored[3];
/* 03*/ unsigned char   ms_sysid[8];
/* 0b*/ unsigned char   ms_sector_size[2];
/* 0d*/ uint8_t         ms_cluster_size;
/* 0e*/ uint16_t        ms_reserved;
/* 10*/ uint8_t         ms_fats;
/* 11*/ unsigned char   ms_dir_entries[2];
/* 13*/ unsigned char   ms_sectors[2]; /* =0 iff V3 or later */
/* 15*/ unsigned char   ms_media;
/* 16*/ uint16_t        ms_fat_length; /* Sectors per FAT */
/* 18*/ uint16_t        ms_secs_track;
/* 1a*/ uint16_t        ms_heads;
/* 1c*/ uint32_t        ms_hidden;
/* V3 BPB */
/* 20*/ uint32_t        ms_total_sect; /* iff ms_sectors == 0 */
/* V4 BPB */
/* 24*/ unsigned char   ms_unknown[3]; /* Phys drive no., resvd, V4 sig (0x29) */
/* 27*/ unsigned char   ms_serno[4];
/* 2b*/ unsigned char   ms_label[11];
/* 36*/ unsigned char   ms_magic[8];
/* 3e*/ unsigned char   ms_dummy2[0x1fe - 0x3e];
/*1fe*/ unsigned char   ms_pmagic[2];
} __attribute__((packed));

struct vfat_dir_entry {
	uint8_t         name[11];
	uint8_t         attr;
	uint16_t        time_creat;
	uint16_t        date_creat;
	uint16_t        time_acc;
	uint16_t        date_acc;
	uint16_t        cluster_high;
	uint16_t        time_write;
	uint16_t        date_write;
	uint16_t        cluster_low;
	uint32_t        size;
} __attribute__((packed));

struct fat32_fsinfo {
	uint8_t signature1[4];
	uint32_t reserved1[120];
	uint8_t signature2[4];
	uint32_t free_clusters;
	uint32_t next_cluster;
	uint32_t reserved2[4];
} __attribute__((packed));

/* maximum number of clusters */
#define FAT12_MAX 0xFF4
#define FAT16_MAX 0xFFF4
#define FAT32_MAX 0x0FFFFFF6

#define FAT_ATTR_VOLUME_ID              0x08
#define FAT_ATTR_DIR                    0x10
#define FAT_ATTR_LONG_NAME              0x0f
#define FAT_ATTR_MASK                   0x3f
#define FAT_ENTRY_FREE                  0xe5

static const char no_name[] = "NO NAME    ";

#define unaligned_le16(x) \
		(((unsigned char *) x)[0] + (((unsigned char *) x)[1] << 8))

/* Look for LABEL (name) in the FAT root directory. */
static unsigned char *search_fat_label(blkid_probe pr,
				uint64_t offset, uint32_t entries)
{
	struct vfat_dir_entry *ent, *dir = NULL;
	uint32_t i;

	if (!blkid_probe_is_tiny(pr)) {
		/* large disk, read whole root directory */
		dir = (struct vfat_dir_entry *)
			blkid_probe_get_buffer(pr,
					offset,
					(uint64_t) entries *
						sizeof(struct vfat_dir_entry));
		if (!dir)
			return NULL;
	}

	for (i = 0; i < entries; i++) {
		/* The root directory could be relatively large (4-16kB).
		 * Fortunately, the LABEL is usually the first entry in the
		 * directory. On tiny disks we call read() per entry. */
		if (!dir)
			ent = (struct vfat_dir_entry *)
				blkid_probe_get_buffer(pr,
					(uint64_t) offset + (i *
						sizeof(struct vfat_dir_entry)),
					sizeof(struct vfat_dir_entry));
		else
			ent = &dir[i];

		if (!ent || ent->name[0] == 0x00)
			break;

		if ((ent->name[0] == FAT_ENTRY_FREE) ||
		    (ent->cluster_high != 0 || ent->cluster_low != 0) ||
		    ((ent->attr & FAT_ATTR_MASK) == FAT_ATTR_LONG_NAME))
			continue;

		if ((ent->attr & (FAT_ATTR_VOLUME_ID | FAT_ATTR_DIR)) ==
		    FAT_ATTR_VOLUME_ID) {
			if (ent->name[0] == 0x05)
				ent->name[0] = 0xE5;
			return ent->name;
		}
	}
	return NULL;
}

static int fat_valid_superblock(blkid_probe pr,
			const struct blkid_idmag *mag,
			struct msdos_super_block *ms,
			struct vfat_super_block *vs,
			uint32_t *cluster_count, uint32_t *fat_size)
{
	uint16_t sector_size, dir_entries, reserved;
	uint32_t sect_count, __fat_size, dir_size, __cluster_count, fat_length;
	uint32_t max_count;

	/* extra check for FATs without magic strings */
	if (mag->len <= 2) {
		/* Old floppies have a valid MBR signature */
		if (ms->ms_pmagic[0] != 0x55 || ms->ms_pmagic[1] != 0xAA)
			return 0;

		/* OS/2 and apparently DFSee will place a FAT12/16-like
		 * pseudo-superblock in the first 512 bytes of non-FAT
		 * filesystems --- at least JFS and HPFS, and possibly others.
		 * So we explicitly check for those filesystems at the
		 * FAT12/16 filesystem magic field identifier, and if they are
		 * present, we rule this out as a FAT filesystem, despite the
		 * FAT-like pseudo-header. */
		if ((memcmp(ms->ms_magic, "JFS     ", 8) == 0) ||
		    (memcmp(ms->ms_magic, "HPFS    ", 8) == 0))
			return 0;
	}

	/* fat counts(Linux kernel expects at least 1 FAT table) */
	if (!ms->ms_fats)
		return 0;
	if (!ms->ms_reserved)
		return 0;
	if (!(0xf8 <= ms->ms_media || ms->ms_media == 0xf0))
		return 0;
	if (!is_power_of_2(ms->ms_cluster_size))
		return 0;

	sector_size = unaligned_le16(&ms->ms_sector_size);
	if (!is_power_of_2(sector_size) ||
	    sector_size < 512 || sector_size > 4096)
		return 0;

	dir_entries = unaligned_le16(&ms->ms_dir_entries);
	reserved =  le16_to_cpu(ms->ms_reserved);
	sect_count = unaligned_le16(&ms->ms_sectors);

	if (sect_count == 0)
		sect_count = le32_to_cpu(ms->ms_total_sect);

	fat_length = le16_to_cpu(ms->ms_fat_length);
	if (fat_length == 0)
		fat_length = le32_to_cpu(vs->vs_fat32_length);

	__fat_size = fat_length * ms->ms_fats;
	dir_size = ((dir_entries * sizeof(struct vfat_dir_entry)) +
					(sector_size-1)) / sector_size;

	__cluster_count = (sect_count - (reserved + __fat_size + dir_size)) /
							ms->ms_cluster_size;
	if (!ms->ms_fat_length && vs->vs_fat32_length)
		max_count = FAT32_MAX;
	else
		max_count = __cluster_count > FAT12_MAX ? FAT16_MAX : FAT12_MAX;

	if (__cluster_count > max_count)
		return 0;

	if (fat_size)
		*fat_size = __fat_size;
	if (cluster_count)
		*cluster_count = __cluster_count;

	if (blkid_probe_is_wholedisk(pr)) {
		/* OK, seems like FAT, but it's possible that we found boot
		 * sector with crazy FAT-like stuff (magic strings, media,
		 * etc..) before MBR. Let's make sure that there is no MBR with
		 * usable partition. */
		unsigned char *buf = (unsigned char *) ms;

		if (mbr_is_valid_magic(buf)) {
			struct dos_partition *p0 = mbr_get_partition(buf, 0);

			if (dos_partition_get_size(p0) != 0 &&
			    (p0->boot_ind == 0 || p0->boot_ind == 0x80))
				return 0;
		}
	}

	if (blkid_probe_is_bitlocker(pr))
		return 0;

	return 1;       /* valid */
}

/* FAT label extraction from the root directory taken from Kay
 * Sievers's volume_id library */
static int probe_vfat(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct vfat_super_block *vs;
	struct msdos_super_block *ms;
	const unsigned char *vol_label = NULL;
	const unsigned char *boot_label = NULL;
	unsigned char *vol_serno = NULL, vol_label_buf[11];
	uint16_t sector_size = 0, reserved;
	uint32_t cluster_count, fat_size;
	const char *version = NULL;

	ms = blkid_probe_get_sb(pr, mag, struct msdos_super_block);
	if (!ms)
		return errno ? -errno : 1;

	vs = blkid_probe_get_sb(pr, mag, struct vfat_super_block);
	if (!vs)
		return errno ? -errno : 1;

	if (!fat_valid_superblock(pr, mag, ms, vs, &cluster_count, &fat_size))
		return 1;

	sector_size = unaligned_le16(&ms->ms_sector_size);
	reserved =  le16_to_cpu(ms->ms_reserved);

	if (ms->ms_fat_length) {
		/* the label may be an attribute in the root directory */
		uint32_t root_start = (reserved + fat_size) * sector_size;
		uint32_t root_dir_entries = unaligned_le16(&vs->vs_dir_entries);

		vol_label = search_fat_label(pr, root_start, root_dir_entries);
		if (vol_label) {
			memcpy(vol_label_buf, vol_label, 11);
			vol_label = vol_label_buf;
		}

		boot_label = ms->ms_label;
		vol_serno = ms->ms_serno;

		blkid_probe_set_value(pr, "SEC_TYPE", (unsigned char *) "msdos", sizeof("msdos"));

		if (cluster_count < FAT12_MAX)
			version = "FAT12";
		else if (cluster_count < FAT16_MAX)
			version = "FAT16";

	} else if (vs->vs_fat32_length) {
		unsigned char *buf;
		uint16_t fsinfo_sect;
		int maxloop = 100;

		/* Search the FAT32 root dir for the label attribute */
		uint32_t buf_size = vs->vs_cluster_size * sector_size;
		uint32_t start_data_sect = reserved + fat_size;
		uint32_t entries = le32_to_cpu(vs->vs_fat32_length) *
					sector_size / sizeof(uint32_t);
		uint32_t next = le32_to_cpu(vs->vs_root_cluster);

		while (next && next < entries && --maxloop) {
			uint32_t next_sect_off;
			uint64_t next_off, fat_entry_off;
			int count;

			next_sect_off = (next - 2) * vs->vs_cluster_size;
			next_off = (uint64_t)(start_data_sect + next_sect_off) *
				sector_size;

			count = buf_size / sizeof(struct vfat_dir_entry);

			vol_label = search_fat_label(pr, next_off, count);
			if (vol_label) {
				memcpy(vol_label_buf, vol_label, 11);
				vol_label = vol_label_buf;
				break;
			}

			/* get FAT entry */
			fat_entry_off = ((uint64_t) reserved * sector_size) +
				(next * sizeof(uint32_t));
			buf = blkid_probe_get_buffer(pr, fat_entry_off, buf_size);
			if (buf == NULL)
				break;

			/* set next cluster */
			next = le32_to_cpu(*((uint32_t *) buf)) & 0x0fffffff;
		}

		version = "FAT32";

		boot_label = vs->vs_label;
		vol_serno = vs->vs_serno;

		/* FAT32 should have a valid signature in the fsinfo block,
		 * but also allow all bytes set to '\0', because some volumes
		 * do not set the signature at all. */
		fsinfo_sect = le16_to_cpu(vs->vs_fsinfo_sector);
		if (fsinfo_sect) {
			struct fat32_fsinfo *fsinfo;

			buf = blkid_probe_get_buffer(pr,
					(uint64_t) fsinfo_sect * sector_size,
					sizeof(struct fat32_fsinfo));
			if (buf == NULL)
				return errno ? -errno : 1;

			fsinfo = (struct fat32_fsinfo *) buf;
			if (memcmp(fsinfo->signature1, "\x52\x52\x61\x41", 4) != 0 &&
			    memcmp(fsinfo->signature1, "\x52\x52\x64\x41", 4) != 0 &&
			    memcmp(fsinfo->signature1, "\x00\x00\x00\x00", 4) != 0)
				return 1;
			if (memcmp(fsinfo->signature2, "\x72\x72\x41\x61", 4) != 0 &&
			    memcmp(fsinfo->signature2, "\x00\x00\x00\x00", 4) != 0)
				return 1;
		}
	}

	if (boot_label && memcmp(boot_label, no_name, 11))
		blkid_probe_set_id_label(pr, "LABEL_FATBOOT", boot_label, 11);

	if (vol_label)
		blkid_probe_set_label(pr, vol_label, 11);

	/* We can't just print them as %04X, because they are unaligned */
	if (vol_serno)
		blkid_probe_sprintf_uuid(pr, vol_serno, 4, "%02X%02X-%02X%02X",
			vol_serno[3], vol_serno[2], vol_serno[1], vol_serno[0]);
	if (version)
		blkid_probe_set_version(pr, version);

	return 0;
}

static const struct blkid_idinfo vfat_idinfo =
{
	.name           = "vfat",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_vfat,
	.magics         =
	{
		{ .magic = "MSWIN",    .len = 5, .sboff = 0x52 },
		{ .magic = "FAT32   ", .len = 8, .sboff = 0x52 },
		{ .magic = "MSDOS",    .len = 5, .sboff = 0x36 },
		{ .magic = "FAT16   ", .len = 8, .sboff = 0x36 },
		{ .magic = "FAT12   ", .len = 8, .sboff = 0x36 },
		{ .magic = "FAT     ", .len = 8, .sboff = 0x36 },
		{ .magic = "\353",     .len = 1, },
		{ .magic = "\351",     .len = 1, },
		{ .magic = "\125\252", .len = 2, .sboff = 0x1fe },
		{ NULL }
	}
};


#define LVM1_ID_LEN 128
#define LVM2_ID_LEN 32

struct lvm2_pv_label_header {
	/* label_header */
	uint8_t         id[8];          /* LABELONE */
	uint64_t        sector_xl;      /* Sector number of this label */
	uint32_t        crc_xl;         /* From next field to end of sector */
	uint32_t        offset_xl;      /* Offset from start of struct to contents */
	uint8_t         type[8];        /* LVM2 001 */
	/* pv_header */
	uint8_t         pv_uuid[LVM2_ID_LEN];
} __attribute__ ((packed));

struct lvm1_pv_label_header {
	uint8_t id[2];                  /* HM */
	uint16_t version;               /* version 1 or 2 */
	uint32_t _notused[10];          /* lvm1 internals */
	uint8_t pv_uuid[LVM1_ID_LEN];
} __attribute__ ((packed));

#define LVM2_LABEL_SIZE 512
static unsigned int lvm2_calc_crc(const void *buf, unsigned int size)
{
	static const unsigned int crctab[] = {
		0x00000000, 0x1db71064, 0x3b6e20c8, 0x26d930ac,
		0x76dc4190, 0x6b6b51f4, 0x4db26158, 0x5005713c,
		0xedb88320, 0xf00f9344, 0xd6d6a3e8, 0xcb61b38c,
		0x9b64c2b0, 0x86d3d2d4, 0xa00ae278, 0xbdbdf21c
	};
	unsigned int i, crc = 0xf597a6cf;
	const uint8_t *data = (const uint8_t *) buf;

	for (i = 0; i < size; i++) {
		crc ^= *data++;
		crc = (crc >> 4) ^ crctab[crc & 0xf];
		crc = (crc >> 4) ^ crctab[crc & 0xf];
	}
	return crc;
}

/* Length of real UUID is always LVM2_ID_LEN */
static void format_lvm_uuid(char *dst_uuid, char *src_uuid)
{
	unsigned int i, b;

	for (i = 0, b = 1; i < LVM2_ID_LEN; i++, b <<= 1) {
		if (b & 0x4444440)
			*dst_uuid++ = '-';
		*dst_uuid++ = *src_uuid++;
	}
	*dst_uuid = '\0';
}

static int probe_lvm2(blkid_probe pr, const struct blkid_idmag *mag)
{
	int sector = mag->kboff << 1;
	struct lvm2_pv_label_header *label;
	char uuid[LVM2_ID_LEN + 7];
	unsigned char *buf;

	buf = blkid_probe_get_buffer(pr,
			mag->kboff << 10,
			512 + sizeof(struct lvm2_pv_label_header));
	if (!buf)
		return errno ? -errno : 1;

	/* buf is at 0k or 1k offset; find label inside */
	if (memcmp(buf, "LABELONE", 8) == 0) {
		label = (struct lvm2_pv_label_header *) buf;
	} else if (memcmp(buf + 512, "LABELONE", 8) == 0) {
		label = (struct lvm2_pv_label_header *)(buf + 512);
		sector++;
	} else {
		return 1;
	}

	if (le64_to_cpu(label->sector_xl) != (unsigned) sector)
		return 1;

	if (!blkid_probe_verify_csum(
		pr, lvm2_calc_crc(
			&label->offset_xl, LVM2_LABEL_SIZE -
			((char *) &label->offset_xl - (char *) label)),
			le32_to_cpu(label->crc_xl)))
		return 1;

	format_lvm_uuid(uuid, (char *) label->pv_uuid);
	blkid_probe_sprintf_uuid(pr, label->pv_uuid, sizeof(label->pv_uuid),
			"%s", uuid);

	/* the mag->magic is the same string as label->type,
	 * but zero terminated */
	blkid_probe_set_version(pr, mag->magic);

	/* LVM (pvcreate) wipes begin of the device -- let's remember this
	 * to resolve conflicts between LVM and partition tables, ... */
	blkid_probe_set_wiper(pr, 0, 8 * 1024);

	return 0;
}

static int probe_lvm1(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct lvm1_pv_label_header *label;
	char uuid[LVM2_ID_LEN + 7];
	unsigned int version;

	label = blkid_probe_get_sb(pr, mag, struct lvm1_pv_label_header);
	if (!label)
		return errno ? -errno : 1;

	version = le16_to_cpu(label->version);
	if (version != 1 && version != 2)
		return 1;

	format_lvm_uuid(uuid, (char *) label->pv_uuid);
	blkid_probe_sprintf_uuid(pr, label->pv_uuid, sizeof(label->pv_uuid),
			"%s", uuid);

	return 0;
}

struct verity_sb {
	uint8_t  signature[8];  /* "verity\0\0" */
	uint32_t version;       /* superblock version */
	uint32_t hash_type;     /* 0 - Chrome OS, 1 - normal */
	uint8_t  uuid[16];      /* UUID of hash device */
	uint8_t  algorithm[32];/* hash algorithm name */
	uint32_t data_block_size; /* data block in bytes */
	uint32_t hash_block_size; /* hash block in bytes */
	uint64_t data_blocks;   /* number of data blocks */
	uint16_t salt_size;     /* salt size */
	uint8_t  _pad1[6];
	uint8_t  salt[256];     /* salt */
	uint8_t  _pad2[168];
} __attribute__((packed));

static int probe_verity(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct verity_sb *sb;
	unsigned int version;

	sb = blkid_probe_get_sb(pr, mag, struct verity_sb);
	if (sb == NULL)
		return errno ? -errno : 1;

	version = le32_to_cpu(sb->version);
	if (version != 1)
		return 1;

	blkid_probe_set_uuid(pr, sb->uuid);
	blkid_probe_sprintf_version(pr, "%u", version);
	return 0;
}

struct integrity_sb {
	uint8_t  magic[8];
	uint8_t  version;
	int8_t   log2_interleave_sectors;
	uint16_t integrity_tag_size;
	uint32_t journal_sections;
	uint64_t provided_data_sectors;
	uint32_t flags;
	uint8_t  log2_sectors_per_block;
} __attribute__ ((packed));

static int probe_integrity(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct integrity_sb *sb;

	sb = blkid_probe_get_sb(pr, mag, struct integrity_sb);
	if (sb == NULL)
		return errno ? -errno : 1;

	if (sb->version !=1 && sb->version != 2)
		return 1;

	blkid_probe_sprintf_version(pr, "%u", sb->version);
	return 0;
}

/* NOTE: the original libblkid uses "lvm2pv" as a name */
static const struct blkid_idinfo lvm2_idinfo =
{
	.name           = "LVM2_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_lvm2,
	.magics         =
	{
		{ .magic = "LVM2 001", .len = 8, .sboff = 0x218 },
		{ .magic = "LVM2 001", .len = 8, .sboff = 0x018 },
		{ .magic = "LVM2 001", .len = 8, .kboff = 1, .sboff = 0x018 },
		{ .magic = "LVM2 001", .len = 8, .kboff = 1, .sboff = 0x218 },
		{ NULL }
	}
};

static const struct blkid_idinfo lvm1_idinfo =
{
	.name           = "LVM1_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_lvm1,
	.magics         =
	{
		{ .magic = "HM", .len = 2 },
		{ NULL }
	}
};

static const struct blkid_idinfo snapcow_idinfo =
{
	.name           = "DM_snapshot_cow",
	.usage          = BLKID_USAGE_OTHER,
	.magics         =
	{
		{ .magic = "SnAp", .len = 4 },
		{ NULL }
	}
};

static const struct blkid_idinfo verity_hash_idinfo =
{
	.name           = "DM_verity_hash",
	.usage          = BLKID_USAGE_CRYPTO,
	.probefunc      = probe_verity,
	.magics         =
	{
		{ .magic = "verity\0\0", .len = 8 },
		{ NULL }
	}
};

static const struct blkid_idinfo integrity_idinfo =
{
	.name           = "DM_integrity",
	.usage          = BLKID_USAGE_CRYPTO,
	.probefunc      = probe_integrity,
	.magics         =
	{
		{ .magic = "integrt\0", .len = 8 },
		{ NULL }
	}
};

/* function to set UUIDs that are in superblocks stored as strings */
static int blkid_probe_strncpy_uuid(blkid_probe pr, const unsigned char *str, size_t len)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if (str == NULL || *str == '\0')
		return -EINVAL;

	if (!len)
		len = strlen((const char *) str);

	if ((chn->flags & BLKID_SUBLKS_UUIDRAW))
		blkid_probe_set_value(pr, "UUID_RAW", str, len);

	if (!(chn->flags & BLKID_SUBLKS_UUID))
		return 0;

	v = blkid_probe_assign_value(pr, "UUID");
	blkid_probe_value_set_data(v, str, len);
	v->len = rtrim_whitespace(v->data) + 1;
	if (v->len > 1)
		return 0;

	blkid_probe_free_value(v);
	return 0;
}

/* http://www.snia.org/standards/home */
#define DDF_GUID_LENGTH                 24
#define DDF_REV_LENGTH                  8
#define DDF_MAGIC                       0xDE11DE11


struct ddf_header {
	uint32_t        signature;
	uint32_t        crc;
	uint8_t         guid[DDF_GUID_LENGTH];
	char            ddf_rev[8];     /* 01.02.00 */
	uint32_t        seq;            /* starts at '1' */
	uint32_t        timestamp;
	uint8_t         openflag;
	uint8_t         foreignflag;
	uint8_t         enforcegroups;
	uint8_t         pad0;           /* 0xff */
	uint8_t         pad1[12];       /* 12 * 0xff */
	/* 64 bytes so far */
	uint8_t         header_ext[32]; /* reserved: fill with 0xff */
	uint64_t        primary_lba;
	uint64_t        secondary_lba;
	uint8_t         type;
	uint8_t         pad2[3];        /* 0xff */
	uint32_t        workspace_len;  /* sectors for vendor space -
					 * at least 32768(sectors) */
	uint64_t        workspace_lba;
	uint16_t        max_pd_entries; /* one of 15, 63, 255, 1023, 4095 */
	uint16_t        max_vd_entries; /* 2^(4,6,8,10,12)-1 : i.e. as above */
	uint16_t        max_partitions; /* i.e. max num of configuration
					   record entries per disk */
	uint16_t        config_record_len; /* 1 +ROUNDUP(max_primary_element_entries
					   *12/512) */
	uint16_t        max_primary_element_entries; /* 16, 64, 256, 1024, or 4096 */
	uint8_t         pad3[54];       /* 0xff */
	/* 192 bytes so far */
	uint32_t        controller_section_offset;
	uint32_t        controller_section_length;
	uint32_t        phys_section_offset;
	uint32_t        phys_section_length;
	uint32_t        virt_section_offset;
	uint32_t        virt_section_length;
	uint32_t        config_section_offset;
	uint32_t        config_section_length;
	uint32_t        data_section_offset;
	uint32_t        data_section_length;
	uint32_t        bbm_section_offset;
	uint32_t        bbm_section_length;
	uint32_t        diag_space_offset;
	uint32_t        diag_space_length;
	uint32_t        vendor_offset;
	uint32_t        vendor_length;
	/* 256 bytes so far */
	uint8_t         pad4[256];      /* 0xff */
} __attribute__((packed));

static int probe_ddf(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int hdrs[] = { 1, 257 };
	size_t i;
	struct ddf_header *ddf = NULL;
	char version[DDF_REV_LENGTH + 1];
	uint64_t off, lba;

	if (pr->size < 0x30000)
		return 1;

	for (i = 0; i < ARRAY_SIZE(hdrs); i++) {
		off = ((pr->size / 0x200) - hdrs[i]) * 0x200;

		ddf = (struct ddf_header *) blkid_probe_get_buffer(pr,
					off,
					sizeof(struct ddf_header));
		if (!ddf)
			return errno ? -errno : 1;
		if (ddf->signature == cpu_to_be32(DDF_MAGIC) ||
		    ddf->signature == cpu_to_le32(DDF_MAGIC))
			break;
		ddf = NULL;
	}

	if (!ddf)
		return 1;

	lba = ddf->signature == cpu_to_be32(DDF_MAGIC) ?
			be64_to_cpu(ddf->primary_lba) :
			le64_to_cpu(ddf->primary_lba);

	if (lba > 0) {
		/* check primary header */
		unsigned char *buf;

		buf = blkid_probe_get_buffer(pr,
					lba << 9, sizeof(ddf->signature));
		if (!buf)
			return errno ? -errno : 1;

		if (memcmp(buf, &ddf->signature, 4) != 0)
			return 1;
	}

	blkid_probe_strncpy_uuid(pr, ddf->guid, sizeof(ddf->guid));

	memcpy(version, ddf->ddf_rev, sizeof(ddf->ddf_rev));
	*(version + sizeof(ddf->ddf_rev)) = '\0';

	blkid_probe_set_version(pr, version);
	if (blkid_probe_set_magic(pr, off,
			sizeof(ddf->signature),
			(unsigned char *) &ddf->signature))
		return 1;
	return 0;
}

static const struct blkid_idinfo ddfraid_idinfo = {
	.name           = "ddf_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_ddf,
	.magics         = BLKID_NONE_MAGIC
};


#define LUKS_CIPHERNAME_L               32
#define LUKS_CIPHERMODE_L               32
#define LUKS_HASHSPEC_L                 32
#define LUKS_DIGESTSIZE                 20
#define LUKS_SALTSIZE                   32
#define LUKS_MAGIC_L                    6
#define UUID_STRING_L                   40
#define LUKS2_LABEL_L                   48
#define LUKS2_SALT_L                    64
#define LUKS2_CHECKSUM_ALG_L            32
#define LUKS2_CHECKSUM_L                64

#define LUKS_MAGIC      "LUKS\xba\xbe"
#define LUKS_MAGIC_2    "SKUL\xba\xbe"

/* Offsets for secondary header (for scan if primary header is corrupted). */
#define LUKS2_HDR2_OFFSETS { 0x04000, 0x008000, 0x010000, 0x020000, \
			     0x40000, 0x080000, 0x100000, 0x200000, 0x400000 }

static const uint64_t secondary_offsets[] = LUKS2_HDR2_OFFSETS;

struct luks_phdr {
	uint8_t         magic[LUKS_MAGIC_L];
	uint16_t        version;
	uint8_t         cipherName[LUKS_CIPHERNAME_L];
	uint8_t         cipherMode[LUKS_CIPHERMODE_L];
	uint8_t         hashSpec[LUKS_HASHSPEC_L];
	uint32_t        payloadOffset;
	uint32_t        keyBytes;
	uint8_t         mkDigest[LUKS_DIGESTSIZE];
	uint8_t         mkDigestSalt[LUKS_SALTSIZE];
	uint32_t        mkDigestIterations;
	uint8_t         uuid[UUID_STRING_L];
} __attribute__((packed));

struct luks2_phdr {
	char            magic[LUKS_MAGIC_L];
	uint16_t        version;
	uint64_t        hdr_size;       /* in bytes, including JSON area */
	uint64_t        seqid;          /* increased on every update */
	char            label[LUKS2_LABEL_L];
	char            checksum_alg[LUKS2_CHECKSUM_ALG_L];
	uint8_t         salt[LUKS2_SALT_L]; /* unique for every header/offset */
	char            uuid[UUID_STRING_L];
	char            subsystem[LUKS2_LABEL_L]; /* owner subsystem label */
	uint64_t        hdr_offset;     /* offset from device start in bytes */
	char            _padding[184];
	uint8_t         csum[LUKS2_CHECKSUM_L];
	/* Padding to 4k, then JSON area */
} __attribute__ ((packed));

static int luks_attributes(blkid_probe pr, struct luks2_phdr *header, uint64_t offset)
{
	int version;
	struct luks_phdr *header_v1;

	if (blkid_probe_set_magic(pr, offset, LUKS_MAGIC_L, (unsigned char *) &header->magic))
		return BLKID_PROBE_NONE;

	version = be16_to_cpu(header->version);
	blkid_probe_sprintf_version(pr, "%u", version);

	if (version == 1) {
		header_v1 = (struct luks_phdr *)header;
		blkid_probe_strncpy_uuid(pr,
			(unsigned char *) header_v1->uuid, UUID_STRING_L);
	} else if (version == 2) {
		blkid_probe_strncpy_uuid(pr, (unsigned char *) header->uuid, UUID_STRING_L);
		blkid_probe_set_label(pr, (unsigned char *) header->label, LUKS2_LABEL_L);
		blkid_probe_set_id_label(pr, "SUBSYSTEM", (unsigned char *) header->subsystem, LUKS2_LABEL_L);
	}

	return BLKID_PROBE_OK;
}

static int probe_luks(blkid_probe pr, const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct luks2_phdr *header;
	size_t i;

	header = (struct luks2_phdr *) blkid_probe_get_buffer(pr, 0, sizeof(struct luks2_phdr));
	if (!header)
		return errno ? -errno : BLKID_PROBE_NONE;

	if (!memcmp(header->magic, LUKS_MAGIC, LUKS_MAGIC_L)) {
		/* LUKS primary header was found. */
		return luks_attributes(pr, header, 0);
	} else {
		/* No primary header, scan for known offsets of LUKS2 secondary header. */
		for (i = 0; i < ARRAY_SIZE(secondary_offsets); i++) {
			header = (struct luks2_phdr *) blkid_probe_get_buffer(pr,
				  secondary_offsets[i], sizeof(struct luks2_phdr));

			if (!header)
				return errno ? -errno : BLKID_PROBE_NONE;

			if (!memcmp(header->magic, LUKS_MAGIC_2, LUKS_MAGIC_L))
				return luks_attributes(pr, header, secondary_offsets[i]);
		}
	}

	return BLKID_PROBE_NONE;
}

static const struct blkid_idinfo luks_idinfo =
{
	.name           = "crypto_LUKS",
	.usage          = BLKID_USAGE_CRYPTO,
	.probefunc      = probe_luks,
	.magics         = BLKID_NONE_MAGIC
};

/* Specification for on disk format
 * https://stratis-storage.github.io/StratisSoftwareDesign.pdf */

struct stratis_sb {
	uint32_t crc32;
	uint8_t magic[16];
	uint64_t sectors;
	uint8_t reserved[4];
	uint8_t pool_uuid[32];
	uint8_t dev_uuid[32];
	uint64_t mda_size;
	uint64_t reserved_size;
	uint64_t flags;
	uint64_t initialization_time;
} __attribute__ ((__packed__));

#define BS_OFFSETS 512
#define FIRST_COPY_OFFSET BS_OFFSETS
#define SECOND_COPY_OFFSET (BS_OFFSETS * 9)
#define SB_AREA_SIZE (BS_OFFSETS * 16)

static const char STRATIS_MAGIC[] = "!Stra0tis\x86\xff\x02^\x41rh";
#define MAGIC_LEN (sizeof(STRATIS_MAGIC) - 1)

#define _MAGIC_OFFSET (offsetof(const struct stratis_sb, magic))
#define MAGIC_OFFSET_COPY_1 (FIRST_COPY_OFFSET + _MAGIC_OFFSET)
#define MAGIC_OFFSET_COPY_2 (SECOND_COPY_OFFSET + _MAGIC_OFFSET)

static int stratis_valid_sb(uint8_t *p)
{
	const struct stratis_sb *stratis = (const struct stratis_sb *)p;
	uint32_t crc = 0;

	/* generate CRC from byte position 4 for length 508 == 512 byte sector */
	crc = crc32c(~0L, p + sizeof(stratis->crc32),
			BS_OFFSETS - sizeof(stratis->crc32));
	crc ^= ~0L;

	return crc == le32_to_cpu(stratis->crc32);
}

static int probe_stratis(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	const struct stratis_sb *stratis = NULL;
	uint8_t *buf = blkid_probe_get_buffer(pr, 0, SB_AREA_SIZE);

	if (!buf)
		return errno ? -errno : 1;

	if (stratis_valid_sb(buf + FIRST_COPY_OFFSET)) {
		stratis = (const struct stratis_sb *)(buf + FIRST_COPY_OFFSET);
	} else {
		if (!stratis_valid_sb(buf + SECOND_COPY_OFFSET))
			return 1;

		stratis = (const struct stratis_sb *)
				(buf + SECOND_COPY_OFFSET);
	}

	blkid_probe_strncpy_uuid(pr, stratis->dev_uuid,
					sizeof(stratis->dev_uuid));
	blkid_probe_set_value(pr, "POOL_UUID", stratis->pool_uuid, sizeof(stratis->pool_uuid));

	blkid_probe_sprintf_value(pr, "BLOCKDEV_SECTORS", "%" PRIu64,
				le64_to_cpu(stratis->sectors));
	blkid_probe_sprintf_value(pr, "BLOCKDEV_INITTIME", "%" PRIu64,
				le64_to_cpu(stratis->initialization_time));

	return 0;
}

static const struct blkid_idinfo stratis_idinfo = {
	.name           = "stratis",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_stratis,
	.minsz          = SB_AREA_SIZE,
	.magics         = {
		{ .magic = STRATIS_MAGIC, .len = MAGIC_LEN,
			.sboff = MAGIC_OFFSET_COPY_1},
		{ .magic = STRATIS_MAGIC, .len = MAGIC_LEN,
			.sboff = MAGIC_OFFSET_COPY_2},
		{ NULL }
	}
};

struct vmfs_fs_info {
	uint32_t magic;
	uint32_t volume_version;
	uint8_t version;
	uint8_t uuid[16];
	uint32_t mode;
	char label[128];
} __attribute__ ((__packed__));

struct vmfs_volume_info {
	uint32_t magic;
	uint32_t ver;
	uint8_t irrelevant[122];
	uint8_t uuid[16];
} __attribute__ ((__packed__));

static int probe_vmfs_fs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct vmfs_fs_info *header;

	header = blkid_probe_get_sb(pr, mag, struct vmfs_fs_info);
	if (header == NULL)
		return errno ? -errno : 1;

	blkid_probe_sprintf_uuid(pr, (unsigned char *) header->uuid, 16,
		"%02x%02x%02x%02x-%02x%02x%02x%02x-"
		"%02x%02x-%02x%02x%02x%02x%02x%02x",
		header->uuid[3], header->uuid[2], header->uuid[1],
		header->uuid[0], header->uuid[7], header->uuid[6],
		header->uuid[5], header->uuid[4], header->uuid[9],
		header->uuid[8], header->uuid[10], header->uuid[11],
		header->uuid[12], header->uuid[13], header->uuid[14],
		header->uuid[15]);

	blkid_probe_set_label(pr, (unsigned char *) header->label, sizeof(header->label));
	blkid_probe_sprintf_version(pr, "%u", header->version);
	return 0;
}

static int probe_vmfs_volume(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct vmfs_volume_info *header;
	unsigned char *lvm_uuid;

	header = blkid_probe_get_sb(pr, mag, struct vmfs_volume_info);
	if (header == NULL)
		return errno ? -errno : 1;

	blkid_probe_sprintf_value(pr, "UUID_SUB",
		"%02x%02x%02x%02x-%02x%02x%02x%02x-"
		"%02x%02x-%02x%02x%02x%02x%02x%02x",
		header->uuid[3], header->uuid[2], header->uuid[1],
		header->uuid[0], header->uuid[7], header->uuid[6],
		header->uuid[5], header->uuid[4], header->uuid[9],
		header->uuid[8], header->uuid[10], header->uuid[11],
		header->uuid[12], header->uuid[13], header->uuid[14],
		header->uuid[15]);
	blkid_probe_sprintf_version(pr, "%u", le32_to_cpu(header->ver));

	lvm_uuid = blkid_probe_get_buffer(pr,
				1024 * 1024 /* Start of the volume info */
				+ 512 /* Offset to lvm info */
				+ 20 /* Offset in lvm info */, 35);
	if (lvm_uuid)
		blkid_probe_strncpy_uuid(pr, lvm_uuid, 35);

	return 0;
}

static const struct blkid_idinfo vmfs_fs_idinfo =
{
	.name           = "VMFS",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_vmfs_fs,
	.magics         =
	{
		{ .magic = "\x5e\xf1\xab\x2f", .len = 4, .kboff = 2048 },
		{ NULL }
	}
};

static const struct blkid_idinfo vmfs_volume_idinfo =
{
	.name           = "VMFS_volume_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_vmfs_volume,
	.magics         =
	{
		{ .magic = "\x0d\xd0\x01\xc0", .len = 4, .kboff = 1024 },
		{ NULL }
	}
};

static int blkid_probe_set_utf8_id_label(blkid_probe pr, const char *name,
			     const unsigned char *data, size_t len, int enc)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	struct blkid_prval *v;

	if (!(chn->flags & BLKID_SUBLKS_LABEL))
		return 0;

	v = blkid_probe_assign_value(pr, name);
	v->data = blkid_encode_alloc(len, &v->len);
	blkid_encode_to_utf8(enc, v->data, v->len, data, len);
	v->len = rtrim_whitespace(v->data) + 1;
	if (v->len > 1)
		v->len = blkid_ltrim_whitespace(v->data) + 1;
	if (v->len > 1)
		return 0;

	blkid_probe_free_value(v);
	return 0;
}

#define udf_cid_to_enc(cid) ((cid) == 8 ? BLKID_ENC_LATIN1 : (cid) == 16 ? BLKID_ENC_UTF16BE : -1)

struct dstring128 {
	uint8_t cid;
	uint8_t c[126];
	uint8_t clen;
} __attribute__((packed));

struct dstring32 {
	uint8_t cid;
	uint8_t c[30];
	uint8_t clen;
} __attribute__((packed));

struct volume_descriptor {
	struct descriptor_tag {
		uint16_t        id;
		uint16_t        version;
		uint8_t         checksum;
		uint8_t         reserved;
		uint16_t        serial;
		uint16_t        crc;
		uint16_t        crc_len;
		uint32_t        location;
	} __attribute__((packed)) tag;

	union {
		struct anchor_descriptor {
			uint32_t        length;
			uint32_t        location;
		} __attribute__((packed)) anchor;

		struct primary_descriptor {
			uint32_t        seq_num;
			uint32_t        desc_num;
			struct dstring32 ident;
			uint16_t        vds_num;
			uint16_t        max_vol_seq;
			uint16_t        ichg_lvl;
			uint16_t        max_ichg_lvl;
			uint32_t        charset_list;
			uint32_t        max_charset_list;
			struct dstring128 volset_id;
		} __attribute__((packed)) primary;

		struct logical_descriptor {
			uint32_t        seq_num;
			uint8_t         desc_charset[64];
			struct dstring128 logvol_id;
			uint32_t        logical_blocksize;
			uint8_t         domain_id_flags;
			char            domain_id[23];
			uint16_t        udf_rev;
			uint8_t         domain_suffix_flags;
			uint8_t         reserved[5];
			uint8_t         logical_contents_use[16];
			uint32_t        map_table_length;
			uint32_t        num_partition_maps;
			uint8_t         imp_id[32];
			uint8_t         imp_use[128];
			uint32_t        lvid_length;
			uint32_t        lvid_location;
		} __attribute__((packed)) logical;

		struct logical_vol_integ_descriptor {
			uint8_t         recording_date[12];
			uint32_t        type;
			uint32_t        next_lvid_length;
			uint32_t        next_lvid_location;
			uint8_t         logical_contents_use[32];
			uint32_t        num_partitions;
			uint32_t        imp_use_length;
		} __attribute__((packed)) logical_vol_integ;
	} __attribute__((packed)) type;

} __attribute__((packed));

#define TAG_ID_PVD  1
#define TAG_ID_AVDP 2
#define TAG_ID_LVD  6
#define TAG_ID_TD   8
#define TAG_ID_LVID 9

struct volume_structure_descriptor {
	uint8_t         type;
	uint8_t         id[5];
	uint8_t         version;
} __attribute__((packed));

#define UDF_VSD_OFFSET                  0x8000LL

struct logical_vol_integ_descriptor_imp_use
{
	uint8_t         imp_id[32];
	uint32_t        num_files;
	uint32_t        num_dirs;
	uint16_t        min_udf_read_rev;
	uint16_t        min_udf_write_rev;
	uint16_t        max_udf_write_rev;
} __attribute__ ((packed));

#define UDF_LVIDIU_OFFSET(vd) (sizeof((vd).tag) + sizeof((vd).type.logical_vol_integ) + 2 * 4 * le32_to_cpu((vd).type.logical_vol_integ.num_partitions))
#define UDF_LVIDIU_LENGTH(vd) (le32_to_cpu((vd).type.logical_vol_integ.imp_use_length))

static int gen_uuid_from_volset_id(unsigned char uuid[17], struct dstring128 *volset_id)
{
	int enc;
	size_t i;
	size_t len;
	size_t clen;
	size_t nonhexpos;
	unsigned char buf[17];

	memset(buf, 0, sizeof(buf));

	clen = volset_id->clen;
	if (clen > 0)
		--clen;
	if (clen > sizeof(volset_id->c))
		clen = sizeof(volset_id->c);

	enc = udf_cid_to_enc(volset_id->cid);
	if (enc == -1)
		return -1;

	len = blkid_encode_to_utf8(enc, buf, sizeof(buf), volset_id->c, clen);
	if (len < 8)
		return -1;

	nonhexpos = 16;
	for (i = 0; i < 16; ++i) {
		if (!isxdigit(buf[i])) {
			nonhexpos = i;
			break;
		}
	}

	if (nonhexpos < 8) {
		snprintf((char *) uuid, 17, "%02x%02x%02x%02x%02x%02x%02x%02x",
			buf[0], buf[1], buf[2], buf[3],
			buf[4], buf[5], buf[6], buf[7]);
	} else if (nonhexpos < 16) {
		for (i = 0; i < 8; ++i)
			uuid[i] = tolower(buf[i]);
		snprintf((char *) uuid + 8, 9, "%02x%02x%02x%02x",
			buf[8], buf[9], buf[10], buf[11]);
	} else {
		for (i = 0; i < 16; ++i)
			uuid[i] = tolower(buf[i]);
		uuid[16] = 0;
	}

	return 0;
}

static int probe_udf(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct volume_descriptor *vd;
	struct volume_structure_descriptor *vsd;
	struct logical_vol_integ_descriptor_imp_use *lvidiu;
	uint32_t lvid_len = 0;
	uint32_t lvid_loc = 0;
	uint32_t bs;
	uint32_t b;
	uint16_t type;
	uint32_t count;
	uint32_t loc;
	size_t i;
	uint32_t vsd_len;
	uint16_t udf_rev = 0;
	int vsd_2048_valid = -1;
	int have_label = 0;
	int have_uuid = 0;
	int have_logvolid = 0;
	int have_volid = 0;
	int have_volsetid = 0;

	/* The block size of a UDF filesystem is that of the underlying
	 * storage; we check later on for the special case of image files,
	 * which may have any block size valid for UDF filesystem */
	uint32_t pbs[] = { 0, 512, 1024, 2048, 4096 };
	pbs[0] = blkid_probe_get_sectorsize(pr);

	for (i = 0; i < ARRAY_SIZE(pbs); i++) {
		/* Do not try with block size same as sector size two times */
		if (i != 0 && pbs[0] == pbs[i])
			continue;

		/* ECMA-167 2/8.4, 2/9.1: Each VSD is either 2048 bytes long or
		 * its size is same as blocksize (for blocksize > 2048 bytes)
		 * plus padded with zeros */
		vsd_len = pbs[i] > 2048 ? pbs[i] : 2048;

		/* Process 2048 bytes long VSD only once */
		if (vsd_len == 2048) {
			if (vsd_2048_valid == 0)
				continue;
			else if (vsd_2048_valid == 1)
				goto anchor;
		}

		/* Check for a Volume Structure Descriptor (VSD) */
		for (b = 0; b < 64; b++) {
			vsd = (struct volume_structure_descriptor *)
				blkid_probe_get_buffer(pr,
						UDF_VSD_OFFSET + b * vsd_len,
						sizeof(*vsd));
			if (!vsd)
				return errno ? -errno : 1;
			if (vsd->id[0] == '\0')
				break;
			if (memcmp(vsd->id, "NSR02", 5) == 0 ||
			    memcmp(vsd->id, "NSR03", 5) == 0)
				goto anchor;
			else if (memcmp(vsd->id, "BEA01", 5) != 0 &&
				 memcmp(vsd->id, "BOOT2", 5) != 0 &&
				 memcmp(vsd->id, "CD001", 5) != 0 &&
				 memcmp(vsd->id, "CDW02", 5) != 0 &&
				 memcmp(vsd->id, "TEA01", 5) != 0)
				/* ECMA-167 2/8.3.1: The volume recognition sequence is
				 * terminated by the first sector which is not a valid
				 * descriptor.
				 * UDF-2.60 2.1.7: UDF 2.00 and lower revisions do not
				 * have requirement that NSR descritor is in Extended Area
				 * (between BEA01 and TEA01) and that there is only one
				 * Extended Area. So do not stop scanning after TEA01. */
				break;
		}

		if (vsd_len == 2048)
			vsd_2048_valid = 0;

		/* NSR was not found, try with next block size */
		continue;

anchor:
		if (vsd_len == 2048)
			vsd_2048_valid = 1;

		/* Read Anchor Volume Descriptor (AVDP), detect block size */
		vd = (struct volume_descriptor *)
			blkid_probe_get_buffer(pr, 256 * pbs[i], sizeof(*vd));
		if (!vd)
			return errno ? -errno : 1;

		/* Check that we read correct sector and detected correct block size */
		if (le32_to_cpu(vd->tag.location) != 256)
			continue;

		type = le16_to_cpu(vd->tag.id);
		if (type == TAG_ID_AVDP)
			goto real_blksz;

	}
	return 1;

real_blksz:
	/* Use the actual block size from here on out */
	bs = pbs[i];

	/* get descriptor list address and block count */
	count = le32_to_cpu(vd->type.anchor.length) / bs;
	loc = le32_to_cpu(vd->type.anchor.location);

	/* pick the primary descriptor from the list and read UDF identifiers */
	for (b = 0; b < count; b++) {
		vd = (struct volume_descriptor *)
			blkid_probe_get_buffer(pr,
					(uint64_t) (loc + b) * bs,
					sizeof(*vd));
		if (!vd)
			return errno ? -errno : 1;
		type = le16_to_cpu(vd->tag.id);
		if (type == 0)
			break;
		if (le32_to_cpu(vd->tag.location) != loc + b)
			break;
		if (type == TAG_ID_TD)
			break;
		if (type == TAG_ID_PVD) {
			if (!have_volid) {
				int enc = udf_cid_to_enc(vd->type.primary.ident.cid);
				uint8_t clen = vd->type.primary.ident.clen;
				if (clen > 0)
					--clen;
				if (clen > sizeof(vd->type.primary.ident.c))
					clen = sizeof(vd->type.primary.ident.c);
				if (enc != -1)
					have_volid = !blkid_probe_set_utf8_id_label(pr, "VOLUME_ID",
							vd->type.primary.ident.c, clen, enc);
			}
			if (!have_uuid) {
				/* VolumeSetIdentifier in UDF 2.01 specification:
				 * =================================================================================
				 * 2.2.2.5 dstring VolumeSetIdentifier
				 *
				 * Interpreted as specifying the identifier for the volume set.
				 *
				 * The first 16 characters of this field should be set to a unique value. The
				 * remainder of the field may be set to any allowed value. Specifically, software
				 * generating volumes conforming to this specification shall not set this field to a
				 * fixed or trivial value. Duplicate disks which are intended to be identical may
				 * contain the same value in this field.
				 *
				 * NOTE: The intended purpose of this is to guarantee Volume Sets with unique
				 * identifiers. The first 8 characters of the unique part should come from a CS0
				 * hexadecimal representation of a 32-bit time value. The remaining 8 characters
				 * are free for implementation use.
				 *
				 * Implementation in libblkid:
				 * The first 16 (Unicode) characters of VolumeSetIdentifier are encoded to UTF-8
				 * and then first 16 UTF-8 bytes are used to generate UUID. If all 16 bytes are
				 * hexadecimal digits then their lowercase variants are used as UUID. If one of
				 * the first 8 bytes (time value) is not hexadecimal digit then first 8 bytes are
				 * encoded to their hexadecimal representations, resulting in 16 characters and
				 * set as UUID. If all first 8 bytes (time value) are hexadecimal digits but some
				 * remaining not then lowercase variant of the first 8 bytes are used as first
				 * part of UUID and next 4 bytes encoded in hexadecimal representations (resulting
				 * in 8 characters) are used as second part of UUID string. */
				unsigned char uuid[17];
				if (gen_uuid_from_volset_id(uuid, &vd->type.primary.volset_id) == 0)
					have_uuid = !blkid_probe_strncpy_uuid(pr, uuid, sizeof(uuid));
			}
			if (!have_volsetid) {
				int enc = udf_cid_to_enc(vd->type.primary.volset_id.cid);
				uint8_t clen = vd->type.primary.volset_id.clen;
				if (clen > 0)
					--clen;
				if (clen > sizeof(vd->type.primary.volset_id.c))
					clen = sizeof(vd->type.primary.volset_id.c);
				if (enc != -1)
					have_volsetid = !blkid_probe_set_utf8_id_label(pr, "VOLUME_SET_ID",
							vd->type.primary.volset_id.c, clen, enc);
			}
		} else if (type == TAG_ID_LVD) {
			if (!lvid_len || !lvid_loc) {
				uint32_t num_partition_maps = le32_to_cpu(vd->type.logical.num_partition_maps);
				/* ECMA-167 3/10.6.12: If num_partition_maps is 0, then no LVID is specified */
				if (num_partition_maps) {
					lvid_len = le32_to_cpu(vd->type.logical.lvid_length);
					lvid_loc = le32_to_cpu(vd->type.logical.lvid_location);
				}
			}
			if (!udf_rev) {
				/* UDF-2.60: 2.1.5.3: UDF revision field shall indicate revision of UDF document
				 * We use this field as fallback value for ID_FS_VERSION when LVIDIU is missing */
				if (strncmp(vd->type.logical.domain_id, "*OSTA UDF Compliant", sizeof(vd->type.logical.domain_id)) == 0)
					udf_rev = le16_to_cpu(vd->type.logical.udf_rev);
			}
			if (!have_logvolid || !have_label) {
				/* LogicalVolumeIdentifier in UDF 2.01 specification:
				 * ===============================================================
				 * 2. Basic Restrictions & Requirements
				 *
				 * Logical Volume Descriptor
				 *
				 * There shall be exactly one prevailing Logical Volume
				 * Descriptor recorded per Volume Set.
				 *
				 * The LogicalVolumeIdentifier field shall not be null and
				 * should contain an identifier that aids in the identification of
				 * the logical volume. Specifically, software generating
				 * volumes conforming to this specification shall not set this
				 * field to a fixed or trivial value. Duplicate disks, which are
				 * intended to be identical, may contain the same value in this
				 * field. This field is extremely important in logical volume
				 * identification when multiple media are present within a
				 * jukebox. This name is typically what is displayed to the user.
				 *
				 * Implementation in libblkid:
				 * The LogicalVolumeIdentifier field is used for LABEL. MS Windows
				 * read Volume Label also from LogicalVolumeIdentifier. Grub2 read
				 * LABEL also from this field. Program newfs_udf (from UDFclient)
				 * when formatting disk set this field from user option Disc Name. */
				int enc = udf_cid_to_enc(vd->type.logical.logvol_id.cid);
				uint8_t clen = vd->type.logical.logvol_id.clen;
				if (clen > 0)
					--clen;
				if (clen > sizeof(vd->type.logical.logvol_id.c))
					clen = sizeof(vd->type.logical.logvol_id.c);
				if (enc != -1) {
					if (!have_label) {
						have_label = 1;
						blkid_probe_set_utf8label(pr,
								vd->type.logical.logvol_id.c, clen, enc);
					}
					if (!have_logvolid)
						have_logvolid = !blkid_probe_set_utf8_id_label(pr, "LOGICAL_VOLUME_ID",
								vd->type.logical.logvol_id.c, clen, enc);
				}
			}
		}
		if (have_volid && have_uuid && have_volsetid && have_logvolid && have_label && lvid_len && lvid_loc)
			break;
	}

	/* Pick the first logical volume integrity descriptor and read UDF revision */
	if (lvid_loc && lvid_len >= sizeof(*vd)) {
		vd = (struct volume_descriptor *)
			blkid_probe_get_buffer(pr,
					(uint64_t) lvid_loc * bs,
					sizeof(*vd));
		if (!vd)
			return errno ? -errno : 1;
		type = le16_to_cpu(vd->tag.id);
		if (type == TAG_ID_LVID &&
		    le32_to_cpu(vd->tag.location) == lvid_loc &&
		    UDF_LVIDIU_LENGTH(*vd) >= sizeof(*lvidiu)) {
			/* ECMA-167 3/8.8.2: There is stored sequence of LVIDs and valid is just last
			 * one. So correctly we should jump to next_lvid_location and read next LVID
			 * until we find last one. This could be time consuming process and could
			 * lead to scanning lot of disk blocks. Because we use LVID only for UDF
			 * version, in the worst case we would report only wrong ID_FS_VERSION. */
			uint16_t lvidiu_udf_rev;
			lvidiu = (struct logical_vol_integ_descriptor_imp_use *)
				blkid_probe_get_buffer(pr,
						(uint64_t) lvid_loc * bs + UDF_LVIDIU_OFFSET(*vd),
						sizeof(*lvidiu));
			if (!lvidiu)
				return errno ? -errno : 1;
			/* Use Minimum UDF Read Revision as ID_FS_VERSION */
			lvidiu_udf_rev = le16_to_cpu(lvidiu->min_udf_read_rev);
			if (lvidiu_udf_rev)
				udf_rev = lvidiu_udf_rev;
			/* UDF-2.60: 2. Basic Restrictions & Requirements:
			 * The Minimum UDF Read Revision value shall be at most #0250
			 * for all media with a UDF 2.60 file system.
			 * So in this case use Minimum UDF Write Revision as ID_FS_VERSION
			 * to distinguish between UDF 2.50 and UDF 2.60 discs. */
			if (lvidiu_udf_rev == 0x250) {
				lvidiu_udf_rev = le16_to_cpu(lvidiu->min_udf_write_rev);
				if (lvidiu_udf_rev > 0x250)
					udf_rev = lvidiu_udf_rev;
			}
		}
	}

	if (udf_rev)
		/* UDF revision is stored as decimal number in hexadecimal format.
		 * E.g. number 0x0150 is revision 1.50, number 0x0201 is revision 2.01. */
		blkid_probe_sprintf_version(pr, "%x.%02x", (unsigned int)(udf_rev >> 8), (unsigned int)(udf_rev & 0xFF));

	return 0;
}


static const struct blkid_idinfo udf_idinfo =
{
	.name           = "udf",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_udf,
	.flags          = BLKID_IDINFO_TOLERANT,
	.magics         =
	{
		{ .magic = "BEA01", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "BOOT2", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "CD001", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "CDW02", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "NSR02", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "NSR03", .len = 5, .kboff = 32, .sboff = 1 },
		{ .magic = "TEA01", .len = 5, .kboff = 32, .sboff = 1 },
		{ NULL }
	}
};

struct btrfs_super_block {
	uint8_t csum[32];
	uint8_t fsid[16];
	uint64_t bytenr;
	uint64_t flags;
	uint8_t magic[8];
	uint64_t generation;
	uint64_t root;
	uint64_t chunk_root;
	uint64_t log_root;
	uint64_t log_root_transid;
	uint64_t total_bytes;
	uint64_t bytes_used;
	uint64_t root_dir_objectid;
	uint64_t num_devices;
	uint32_t sectorsize;
	uint32_t nodesize;
	uint32_t leafsize;
	uint32_t stripesize;
	uint32_t sys_chunk_array_size;
	uint64_t chunk_root_generation;
	uint64_t compat_flags;
	uint64_t compat_ro_flags;
	uint64_t incompat_flags;
	uint16_t csum_type;
	uint8_t root_level;
	uint8_t chunk_root_level;
	uint8_t log_root_level;
	struct btrfs_dev_item {
		uint64_t devid;
		uint64_t total_bytes;
		uint64_t bytes_used;
		uint32_t io_align;
		uint32_t io_width;
		uint32_t sector_size;
		uint64_t type;
		uint64_t generation;
		uint64_t start_offset;
		uint32_t dev_group;
		uint8_t seek_speed;
		uint8_t bandwidth;
		uint8_t uuid[16];
		uint8_t fsid[16];
	} __attribute__ ((__packed__)) dev_item;
	uint8_t label[256];
} __attribute__ ((__packed__));

static int probe_btrfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct btrfs_super_block *bfs;

	bfs = blkid_probe_get_sb(pr, mag, struct btrfs_super_block);
	if (!bfs)
		return errno ? -errno : 1;

	if (*bfs->label)
		blkid_probe_set_label(pr, (unsigned char *) bfs->label, sizeof(bfs->label));

	blkid_probe_set_uuid(pr, bfs->fsid);
	blkid_probe_set_uuid_as(pr, bfs->dev_item.uuid, "UUID_SUB");

	return 0;
}

static const struct blkid_idinfo btrfs_idinfo =
{
	.name           = "btrfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_btrfs,
	.minsz          = 1024 * 1024,
	.magics         =
	{
	  { .magic = "_BHRfS_M", .len = 8, .sboff = 0x40, .kboff = 64 },
	  { NULL }
	}
};


struct xfs_super_block {
	uint32_t        sb_magicnum;    /* magic number == XFS_SB_MAGIC */
	uint32_t        sb_blocksize;   /* logical block size, bytes */
	uint64_t        sb_dblocks;     /* number of data blocks */
	uint64_t        sb_rblocks;     /* number of realtime blocks */
	uint64_t        sb_rextents;    /* number of realtime extents */
	unsigned char   sb_uuid[16];    /* file system unique id */
	uint64_t        sb_logstart;    /* starting block of log if internal */
	uint64_t        sb_rootino;     /* root inode number */
	uint64_t        sb_rbmino;      /* bitmap inode for realtime extents */
	uint64_t        sb_rsumino;     /* summary inode for rt bitmap */
	uint32_t        sb_rextsize;    /* realtime extent size, blocks */
	uint32_t        sb_agblocks;    /* size of an allocation group */
	uint32_t        sb_agcount;     /* number of allocation groups */
	uint32_t        sb_rbmblocks;   /* number of rt bitmap blocks */
	uint32_t        sb_logblocks;   /* number of log blocks */

	uint16_t        sb_versionnum;  /* header version == XFS_SB_VERSION */
	uint16_t        sb_sectsize;    /* volume sector size, bytes */
	uint16_t        sb_inodesize;   /* inode size, bytes */
	uint16_t        sb_inopblock;   /* inodes per block */
	char            sb_fname[12];   /* file system name */
	uint8_t         sb_blocklog;    /* log2 of sb_blocksize */
	uint8_t         sb_sectlog;     /* log2 of sb_sectsize */
	uint8_t         sb_inodelog;    /* log2 of sb_inodesize */
	uint8_t         sb_inopblog;    /* log2 of sb_inopblock */
	uint8_t         sb_agblklog;    /* log2 of sb_agblocks (rounded up) */
	uint8_t         sb_rextslog;    /* log2 of sb_rextents */
	uint8_t         sb_inprogress;  /* mkfs is in progress, don't mount */
	uint8_t         sb_imax_pct;    /* max % of fs for inode space */
					/* statistics */
	uint64_t        sb_icount;      /* allocated inodes */
	uint64_t        sb_ifree;       /* free inodes */
	uint64_t        sb_fdblocks;    /* free data blocks */
	uint64_t        sb_frextents;   /* free realtime extents */

	/* this is not all... but enough for libblkid */

} __attribute__((packed));

#define XFS_MIN_BLOCKSIZE_LOG   9       /* i.e. 512 bytes */
#define XFS_MAX_BLOCKSIZE_LOG   16      /* i.e. 65536 bytes */
#define XFS_MIN_BLOCKSIZE       (1 << XFS_MIN_BLOCKSIZE_LOG)
#define XFS_MAX_BLOCKSIZE       (1 << XFS_MAX_BLOCKSIZE_LOG)
#define XFS_MIN_SECTORSIZE_LOG  9       /* i.e. 512 bytes */
#define XFS_MAX_SECTORSIZE_LOG  15      /* i.e. 32768 bytes */
#define XFS_MIN_SECTORSIZE      (1 << XFS_MIN_SECTORSIZE_LOG)
#define XFS_MAX_SECTORSIZE      (1 << XFS_MAX_SECTORSIZE_LOG)

#define XFS_DINODE_MIN_LOG      8
#define XFS_DINODE_MAX_LOG      11
#define XFS_DINODE_MIN_SIZE     (1 << XFS_DINODE_MIN_LOG)
#define XFS_DINODE_MAX_SIZE     (1 << XFS_DINODE_MAX_LOG)

#define XFS_MAX_RTEXTSIZE       (1024 * 1024 * 1024)    /* 1GB */
#define XFS_DFL_RTEXTSIZE       (64 * 1024)             /* 64kB */
#define XFS_MIN_RTEXTSIZE       (4 * 1024)              /* 4kB */

#define XFS_MIN_AG_BLOCKS       64
#define XFS_MAX_DBLOCKS(s) ((uint64_t)(s)->sb_agcount * (s)->sb_agblocks)
#define XFS_MIN_DBLOCKS(s) ((uint64_t)((s)->sb_agcount - 1) *   \
			 (s)->sb_agblocks + XFS_MIN_AG_BLOCKS)


static void xfs_sb_from_disk(struct xfs_super_block *from,
			 struct xfs_super_block *to)
{

	to->sb_magicnum = be32_to_cpu(from->sb_magicnum);
	to->sb_blocksize = be32_to_cpu(from->sb_blocksize);
	to->sb_dblocks = be64_to_cpu(from->sb_dblocks);
	to->sb_rblocks = be64_to_cpu(from->sb_rblocks);
	to->sb_rextents = be64_to_cpu(from->sb_rextents);
	to->sb_logstart = be64_to_cpu(from->sb_logstart);
	to->sb_rootino = be64_to_cpu(from->sb_rootino);
	to->sb_rbmino = be64_to_cpu(from->sb_rbmino);
	to->sb_rsumino = be64_to_cpu(from->sb_rsumino);
	to->sb_rextsize = be32_to_cpu(from->sb_rextsize);
	to->sb_agblocks = be32_to_cpu(from->sb_agblocks);
	to->sb_agcount = be32_to_cpu(from->sb_agcount);
	to->sb_rbmblocks = be32_to_cpu(from->sb_rbmblocks);
	to->sb_logblocks = be32_to_cpu(from->sb_logblocks);
	to->sb_versionnum = be16_to_cpu(from->sb_versionnum);
	to->sb_sectsize = be16_to_cpu(from->sb_sectsize);
	to->sb_inodesize = be16_to_cpu(from->sb_inodesize);
	to->sb_inopblock = be16_to_cpu(from->sb_inopblock);
	to->sb_blocklog = from->sb_blocklog;
	to->sb_sectlog = from->sb_sectlog;
	to->sb_inodelog = from->sb_inodelog;
	to->sb_inopblog = from->sb_inopblog;
	to->sb_agblklog = from->sb_agblklog;
	to->sb_rextslog = from->sb_rextslog;
	to->sb_inprogress = from->sb_inprogress;
	to->sb_imax_pct = from->sb_imax_pct;
	to->sb_icount = be64_to_cpu(from->sb_icount);
	to->sb_ifree = be64_to_cpu(from->sb_ifree);
	to->sb_fdblocks = be64_to_cpu(from->sb_fdblocks);
	to->sb_frextents = be64_to_cpu(from->sb_frextents);
}

static int xfs_verify_sb(struct xfs_super_block *ondisk)
{
	struct xfs_super_block sb, *sbp = &sb;

	/* beXX_to_cpu(), but don't convert UUID and fsname! */
	xfs_sb_from_disk(ondisk, sbp);

	/* sanity checks, we don't want to rely on magic string only */
	if (sbp->sb_agcount <= 0                                        ||
	    sbp->sb_sectsize < XFS_MIN_SECTORSIZE                       ||
	    sbp->sb_sectsize > XFS_MAX_SECTORSIZE                       ||
	    sbp->sb_sectlog < XFS_MIN_SECTORSIZE_LOG                    ||
	    sbp->sb_sectlog > XFS_MAX_SECTORSIZE_LOG                    ||
	    sbp->sb_sectsize != (1 << sbp->sb_sectlog)                  ||
	    sbp->sb_blocksize < XFS_MIN_BLOCKSIZE                       ||
	    sbp->sb_blocksize > XFS_MAX_BLOCKSIZE                       ||
	    sbp->sb_blocklog < XFS_MIN_BLOCKSIZE_LOG                    ||
	    sbp->sb_blocklog > XFS_MAX_BLOCKSIZE_LOG                    ||
	    sbp->sb_blocksize != (1ULL << sbp->sb_blocklog)             ||
	    sbp->sb_inodesize < XFS_DINODE_MIN_SIZE                     ||
	    sbp->sb_inodesize > XFS_DINODE_MAX_SIZE                     ||
	    sbp->sb_inodelog < XFS_DINODE_MIN_LOG                       ||
	    sbp->sb_inodelog > XFS_DINODE_MAX_LOG                       ||
	    sbp->sb_inodesize != (1 << sbp->sb_inodelog)                ||
	    (sbp->sb_blocklog - sbp->sb_inodelog != sbp->sb_inopblog)   ||
	    (sbp->sb_rextsize * sbp->sb_blocksize > XFS_MAX_RTEXTSIZE)  ||
	    (sbp->sb_rextsize * sbp->sb_blocksize < XFS_MIN_RTEXTSIZE)  ||
	    (sbp->sb_imax_pct > 100 /* zero sb_imax_pct is valid */)    ||
	    sbp->sb_dblocks == 0                                        ||
	    sbp->sb_dblocks > XFS_MAX_DBLOCKS(sbp)                      ||
	    sbp->sb_dblocks < XFS_MIN_DBLOCKS(sbp))
		return 0;

	/* TODO: version 5 has also checksum CRC32, maybe we can check it too */

	return 1;
}

static int probe_xfs(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct xfs_super_block *xs;

	xs = blkid_probe_get_sb(pr, mag, struct xfs_super_block);
	if (!xs)
		return errno ? -errno : 1;

	if (!xfs_verify_sb(xs))
		return 1;

	if (*xs->sb_fname != '\0')
		blkid_probe_set_label(pr, (unsigned char *) xs->sb_fname, sizeof(xs->sb_fname));
	blkid_probe_set_uuid(pr, xs->sb_uuid);
	return 0;
}

static const struct blkid_idinfo xfs_idinfo =
{
	.name           = "xfs",
	.usage          = BLKID_USAGE_FILESYSTEM,
	.probefunc      = probe_xfs,
	.magics         =
	{
		{ .magic = "XFSB", .len = 4 },
		{ NULL }
	}
};

struct xlog_rec_header {
	uint32_t        h_magicno;
	uint32_t        h_dummy1[1];
	uint32_t        h_version;
	uint32_t        h_len;
	uint32_t        h_dummy2[71];
	uint32_t        h_fmt;
	unsigned char   h_uuid[16];
} __attribute__((packed));

#define XLOG_HEADER_MAGIC_NUM 0xFEEDbabe

/* For very small filesystems, the minimum log size
 * can be smaller, but that seems vanishingly unlikely
 * when used with an external log (which is used for
 * performance reasons; tiny conflicts with that goal). */
#define XFS_MIN_LOG_BYTES       (10 * 1024 * 1024)

#define XLOG_FMT_LINUX_LE       1
#define XLOG_FMT_LINUX_BE       2
#define XLOG_FMT_IRIX_BE        3

#define XLOG_VERSION_1          1
#define XLOG_VERSION_2          2       /* Large IClogs, Log sunit */
#define XLOG_VERSION_OKBITS     (XLOG_VERSION_1 | XLOG_VERSION_2)

static int xlog_valid_rec_header(struct xlog_rec_header *rhead)
{
	uint32_t hlen;

	if (rhead->h_magicno != cpu_to_be32(XLOG_HEADER_MAGIC_NUM))
		return 0;

	if (!rhead->h_version ||
	    (be32_to_cpu(rhead->h_version) & (~XLOG_VERSION_OKBITS)))
		return 0;

	/* LR body must have data or it wouldn't have been written */
	hlen = be32_to_cpu(rhead->h_len);
	if (hlen <= 0 || hlen > INT_MAX)
		return 0;

	if (rhead->h_fmt != cpu_to_be32(XLOG_FMT_LINUX_LE) &&
	    rhead->h_fmt != cpu_to_be32(XLOG_FMT_LINUX_BE) &&
	    rhead->h_fmt != cpu_to_be32(XLOG_FMT_IRIX_BE))
		return 0;

	return 1;
}

/* xlog record header will be in some sector in the first 256k */
static int probe_xfs_log(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int i;
	struct xlog_rec_header *rhead;
	unsigned char *buf;

	buf = blkid_probe_get_buffer(pr, 0, 256*1024);
	if (!buf)
		return errno ? -errno : 1;

	if (memcmp(buf, "XFSB", 4) == 0)
		return 1;                       /* this is regular XFS, ignore */

	/* check the first 512 512-byte sectors */
	for (i = 0; i < 512; i++) {
		rhead = (struct xlog_rec_header *)&buf[i*512];

		if (xlog_valid_rec_header(rhead)) {
			blkid_probe_set_uuid_as(pr, rhead->h_uuid, "LOGUUID");

			if (blkid_probe_set_magic(pr, i * 512,
						sizeof(rhead->h_magicno),
						(unsigned char *) &rhead->h_magicno))
				return 1;

			return 0;
		}
	}

	return 1;
}

static const struct blkid_idinfo xfs_log_idinfo =
{
	.name           = "xfs_external_log",
	.usage          = BLKID_USAGE_OTHER,
	.probefunc      = probe_xfs_log,
	.magics         = BLKID_NONE_MAGIC,
	.minsz          = XFS_MIN_LOG_BYTES,
};

/* This is a binary interface for partitions. See also blkid_partlist_*
 * functions.
 *
 * This function is independent on blkid_do_[safe,full]probe() and
 * blkid_probe_enable_partitions() calls.
 *
 * WARNING: the returned object will be overwritten by the next
 *          blkid_probe_get_partitions() call for the same @pr. If you want to
 *          use more blkid_partlist objects in the same time you have to create
 *          more blkid_probe handlers (see blkid_new_probe()).
 *
 * Returns: list of partitions, or NULL in case of error. */
static blkid_partlist blkid_probe_get_partitions(blkid_probe pr)
{
	return (blkid_partlist) blkid_probe_get_binary_data(pr,
			&pr->chains[BLKID_CHAIN_PARTS]);
}

/* Returns: number of partitions in the list or -1 in case of error. */
static inline int blkid_partlist_numof_partitions(blkid_partlist ls)
{
	return ls->nparts;
}

/* Returns: a pointer to the newly allocated probe struct or NULL in case of error. */
static blkid_probe blkid_new_probe(void)
{
	int i;
	blkid_probe pr = zmalloc(sizeof(struct blkid_struct_probe));

	/* initialize chains */
	for (i = 0; i < BLKID_NCHAINS; i++) {
		pr->chains[i].driver = chains_drvs[i];
		pr->chains[i].flags = chains_drvs[i]->dflt_flags;
		pr->chains[i].enabled = chains_drvs[i]->dflt_enabled;
	}
	INIT_LIST_HEAD(&pr->buffers);
	INIT_LIST_HEAD(&pr->values);
	return pr;
}

/* Clone @parent, the new clone shares all, but except:
 *      - probing result
 *      - buffers if another device (or offset) is set to the prober */
static blkid_probe blkid_clone_probe(blkid_probe parent)
{
	blkid_probe pr;

	pr = blkid_new_probe();
	pr->fd = parent->fd;
	pr->off = parent->off;
	pr->size = parent->size;
	pr->devno = parent->devno;
	pr->disk_devno = parent->disk_devno;
	pr->blkssz = parent->blkssz;
	pr->flags = parent->flags;
	pr->parent = parent;

	pr->flags &= ~BLKID_FL_PRIVATE_FD;

	return pr;
}

/* Returns 1 if the device is whole-disk and the area specified by @offset and
 * @size is covered by any partition. */
static int blkid_probe_is_covered_by_pt(blkid_probe pr,
				 uint64_t offset, uint64_t size)
{
	blkid_probe prc = NULL;
	blkid_partlist ls = NULL;
	uint64_t start, end;
	int nparts, i, rc = 0;

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		goto done;

	prc = blkid_clone_probe(pr);
	ls = blkid_probe_get_partitions(prc);
	if (!ls)
		goto done;

	nparts = blkid_partlist_numof_partitions(ls);
	if (!nparts)
		goto done;

	end = (offset + size) >> 9;
	start = offset >> 9;

	/* check if the partition table fits into the device */
	for (i = 0; i < nparts; i++) {
		blkid_partition par = &ls->parts[i];

		if (par->start + par->size > (pr->size >> 9))
			goto done;
	}

	/* check if the requested area is covered by PT */
	for (i = 0; i < nparts; i++) {
		blkid_partition par = &ls->parts[i];

		if (start >= par->start && end <= par->start + par->size) {
			rc = 1;
			break;
		}
	}
done:
	blkid_free_probe(prc);

	return rc;
}

struct mdp0_super_block {
	uint32_t        md_magic;
	uint32_t        major_version;
	uint32_t        minor_version;
	uint32_t        patch_version;
	uint32_t        gvalid_words;
	uint32_t        set_uuid0;
	uint32_t        ctime;
	uint32_t        level;
	uint32_t        size;
	uint32_t        nr_disks;
	uint32_t        raid_disks;
	uint32_t        md_minor;
	uint32_t        not_persistent;
	uint32_t        set_uuid1;
	uint32_t        set_uuid2;
	uint32_t        set_uuid3;
};

/* Version-1, little-endian. */
struct mdp1_super_block {
	/* constant array information - 128 bytes */
	uint32_t        magic;          /* MD_SB_MAGIC: 0xa92b4efc - little endian */
	uint32_t        major_version;  /* 1 */
	uint32_t        feature_map;    /* 0 for now */
	uint32_t        pad0;           /* always set to 0 when writing */

	uint8_t         set_uuid[16];   /* user-space generated. */
	unsigned char   set_name[32];   /* set and interpreted by user-space */

	uint64_t        ctime;          /* lo 40 bits are seconds, top 24 are microseconds or 0 */
	uint32_t        level;          /* -4 (multipath), -1 (linear), 0,1,4,5 */
	uint32_t        layout;         /* only for raid5 currently */
	uint64_t        size;           /* used size of component devices, in 512byte sectors */

	uint32_t        chunksize;      /* in 512byte sectors */
	uint32_t        raid_disks;
	uint32_t        bitmap_offset;  /* sectors after start of superblock that bitmap starts
					 * NOTE: signed, so bitmap can be before superblock
					 * only meaningful of feature_map[0] is set. */

	/* These are only valid with feature bit '4' */
	uint32_t        new_level;      /* new level we are reshaping to                */
	uint64_t        reshape_position;       /* next address in array-space for reshape */
	uint32_t        delta_disks;    /* change in number of raid_disks               */
	uint32_t        new_layout;     /* new layout                                   */
	uint32_t        new_chunk;      /* new chunk size (bytes)                       */
	uint8_t         pad1[128-124];  /* set to 0 when written */

	/* constant this-device information - 64 bytes */
	uint64_t        data_offset;    /* sector start of data, often 0 */
	uint64_t        data_size;      /* sectors in this device that can be used for data */
	uint64_t        super_offset;   /* sector start of this superblock */
	uint64_t        recovery_offset;/* sectors before this offset (from data_offset) have been recovered */
	uint32_t        dev_number;     /* permanent identifier of this  device - not role in raid */
	uint32_t        cnt_corrected_read; /* number of read errors that were corrected by re-writing */
	uint8_t         device_uuid[16]; /* user-space setable, ignored by kernel */
	uint8_t         devflags;        /* per-device flags.  Only one defined... */
	uint8_t         pad2[64-57];    /* set to 0 when writing */

	/* array state information - 64 bytes */
	uint64_t        utime;          /* 40 bits second, 24 bits microseconds */
	uint64_t        events;         /* incremented when superblock updated */
	uint64_t        resync_offset;  /* data before this offset (from data_offset) known to be in sync */
	uint32_t        sb_csum;        /* checksum up to dev_roles[max_dev] */
	uint32_t        max_dev;        /* size of dev_roles[] array to consider */
	uint8_t         pad3[64-32];    /* set to 0 when writing */

	/* device state information. Indexed by dev_number.
	 * 2 bytes per device
	 * Note there are no per-device state flags. State information is rolled
	 * into the 'roles' value.  If a device is spare or faulty, then it doesn't
	 * have a meaningful role. */
	uint16_t        dev_roles[0];   /* role in array, or 0xffff for a spare, or 0xfffe for faulty */
};


#define MD_RESERVED_BYTES               0x10000
#define MD_SB_MAGIC                     0xa92b4efc

static int probe_raid0(blkid_probe pr, uint64_t off)
{
	struct mdp0_super_block *mdp0;
	union {
		uint32_t ints[4];
		uint8_t bytes[16];
	} uuid;
	uint32_t ma, mi, pa;
	uint64_t size;

	if (pr->size < MD_RESERVED_BYTES)
		return 1;
	mdp0 = (struct mdp0_super_block *)
			blkid_probe_get_buffer(pr,
				off,
				sizeof(struct mdp0_super_block));
	if (!mdp0)
		return errno ? -errno : 1;

	memset(uuid.ints, 0, sizeof(uuid.ints));

	if (le32_to_cpu(mdp0->md_magic) == MD_SB_MAGIC) {
		uuid.ints[0] = swab32(mdp0->set_uuid0);
		if (le32_to_cpu(mdp0->minor_version) >= 90) {
			uuid.ints[1] = swab32(mdp0->set_uuid1);
			uuid.ints[2] = swab32(mdp0->set_uuid2);
			uuid.ints[3] = swab32(mdp0->set_uuid3);
		}
		ma = le32_to_cpu(mdp0->major_version);
		mi = le32_to_cpu(mdp0->minor_version);
		pa = le32_to_cpu(mdp0->patch_version);
		size = le32_to_cpu(mdp0->size);

	} else if (be32_to_cpu(mdp0->md_magic) == MD_SB_MAGIC) {
		uuid.ints[0] = mdp0->set_uuid0;
		if (be32_to_cpu(mdp0->minor_version) >= 90) {
			uuid.ints[1] = mdp0->set_uuid1;
			uuid.ints[2] = mdp0->set_uuid2;
			uuid.ints[3] = mdp0->set_uuid3;
		}
		ma = be32_to_cpu(mdp0->major_version);
		mi = be32_to_cpu(mdp0->minor_version);
		pa = be32_to_cpu(mdp0->patch_version);
		size = be32_to_cpu(mdp0->size);
	} else
		return 1;

	size <<= 10;    /* convert KiB to bytes */

	if (pr->size < size + MD_RESERVED_BYTES)
		/* device is too small */
		return 1;

	if (off < size)
		/* no space before superblock */
		return 1;

	/* Check for collisions between RAID and partition table
	 *
	 * For example the superblock is at the end of the last partition, it's
	 * the same position as at the end of the disk... */
	if ((S_ISREG(pr->mode) || blkid_probe_is_wholedisk(pr)) &&
	    blkid_probe_is_covered_by_pt(pr,
			off - size,                             /* min. start  */
			size + MD_RESERVED_BYTES)) {            /* min. length */

		/* ignore this superblock, it's within any partition and
		 * we are working with whole-disk now */
		return 1;
	}

	blkid_probe_sprintf_version(pr, "%u.%u.%u", ma, mi, pa);
	if (blkid_probe_set_uuid(pr, (unsigned char *) uuid.bytes) != 0)
		return 1;
	if (blkid_probe_set_magic(pr, off, sizeof(mdp0->md_magic),
				(unsigned char *) &mdp0->md_magic))
		return 1;
	return 0;
}

static int probe_raid1(blkid_probe pr, off_t off)
{
	struct mdp1_super_block *mdp1;

	mdp1 = (struct mdp1_super_block *)
			blkid_probe_get_buffer(pr,
				off,
				sizeof(struct mdp1_super_block));
	if (!mdp1)
		return errno ? -errno : 1;
	if (le32_to_cpu(mdp1->magic) != MD_SB_MAGIC)
		return 1;
	if (le32_to_cpu(mdp1->major_version) != 1U)
		return 1;
	if (le64_to_cpu(mdp1->super_offset) != (uint64_t) off >> 9)
		return 1;
	if (blkid_probe_set_uuid(pr, (unsigned char *) mdp1->set_uuid) != 0)
		return 1;
	if (blkid_probe_set_uuid_as(pr,
			(unsigned char *) mdp1->device_uuid, "UUID_SUB") != 0)
		return 1;
	blkid_probe_set_label(pr, mdp1->set_name, sizeof(mdp1->set_name));
	if (blkid_probe_set_magic(pr, off, sizeof(mdp1->magic),
				(unsigned char *) &mdp1->magic))
		return 1;
	return 0;
}

static int probe_raid(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	const char *ver = NULL;
	int ret = BLKID_PROBE_NONE;

	if (pr->size > MD_RESERVED_BYTES) {
		/* version 0 at the end of the device */
		uint64_t sboff = (pr->size & ~(MD_RESERVED_BYTES - 1))
			- MD_RESERVED_BYTES;
		ret = probe_raid0(pr, sboff);
		if (ret < 1)
			return ret;     /* error */

		/* version 1.0 at the end of the device */
		sboff = (pr->size & ~(0x1000 - 1)) - 0x2000;
		ret = probe_raid1(pr, sboff);
		if (ret < 0)
			return ret;     /* error */
		if (ret == 0)
			ver = "1.0";
	}

	if (!ver) {
		/* version 1.1 at the start of the device */
		ret = probe_raid1(pr, 0);
		if (ret == 0)
			ver = "1.1";

		/* version 1.2 at 4k offset from the start */
		else if (ret == BLKID_PROBE_NONE) {
			ret = probe_raid1(pr, 0x1000);
			if (ret == 0)
				ver = "1.2";
		}
	}

	if (ver) {
		blkid_probe_set_version(pr, ver);
		return BLKID_PROBE_OK;
	}
	return ret;
}


static const struct blkid_idinfo linuxraid_idinfo = {
	.name           = "linux_raid_member",
	.usage          = BLKID_USAGE_RAID,
	.probefunc      = probe_raid,
	.magics         = BLKID_NONE_MAGIC
};

/* The library API has been originally designed for superblocks probing only.
 * This is reason why some *deprecated* superblock specific functions don't use
 * '_superblocks_' namespace in the function name. Please, don't use these
 * functions in new code.
 *
 * The 'superblocks' probers support NAME=value (tags) interface only. The
 * superblocks probing is enabled by default (and controlled by
 * blkid_probe_enable_superblocks()). */

/* Superblocks chains probing functions */
static const struct blkid_idinfo * const idinfos_sb[] =
{
	/* RAIDs */
	&linuxraid_idinfo,
	&ddfraid_idinfo,
	&iswraid_idinfo,
	&lsiraid_idinfo,
	&viaraid_idinfo,
	&silraid_idinfo,
	&nvraid_idinfo,
	&pdcraid_idinfo,
	&highpoint45x_idinfo,
	&highpoint37x_idinfo,
	&adraid_idinfo,
	&jmraid_idinfo,

	&bcache_idinfo,
	&drbd_idinfo,
	&drbdmanage_idinfo,
	&drbdproxy_datalog_idinfo,
	&lvm2_idinfo,
	&lvm1_idinfo,
	&snapcow_idinfo,
	&verity_hash_idinfo,
	&integrity_idinfo,
	&luks_idinfo,
	&vmfs_volume_idinfo,
	&ubi_idinfo,
	&vdo_idinfo,
	&stratis_idinfo,
	&bitlocker_idinfo,

	/* Filesystems */
	&vfat_idinfo,
	&swsuspend_idinfo,
	&swap_idinfo,
	&xfs_idinfo,
	&xfs_log_idinfo,
	&exfs_idinfo,
	&ext4dev_idinfo,
	&ext4_idinfo,
	&ext3_idinfo,
	&ext2_idinfo,
	&jbd_idinfo,
	&reiser_idinfo,
	&reiser4_idinfo,
	&jfs_idinfo,
	&udf_idinfo,
	&iso9660_idinfo,
	&zfs_idinfo,
	&hfsplus_idinfo,
	&hfs_idinfo,
	&ufs_idinfo,
	&hpfs_idinfo,
	&sysv_idinfo,
	&xenix_idinfo,
	&ntfs_idinfo,
	&refs_idinfo,
	&cramfs_idinfo,
	&romfs_idinfo,
	&minix_idinfo,
	&gfs_idinfo,
	&gfs2_idinfo,
	&ocfs_idinfo,
	&ocfs2_idinfo,
	&oracleasm_idinfo,
	&vxfs_idinfo,
	&squashfs_idinfo,
	&squashfs3_idinfo,
	&netware_idinfo,
	&btrfs_idinfo,
	&ubifs_idinfo,
	&bfs_idinfo,
	&vmfs_fs_idinfo,
	&befs_idinfo,
	&nilfs2_idinfo,
	&exfat_idinfo,
	&f2fs_idinfo,
	&mpool_idinfo,
	&apfs_idinfo
};

/* Enables/disables the superblocks probing for non-binary interface. */
static inline void blkid_probe_enable_superblocks(blkid_probe pr, int enable)
{
	pr->chains[BLKID_CHAIN_SUBLKS].enabled = enable;
}

/* Sets probing flags to the superblocks prober. This function is optional, the
 * default are BLKID_SUBLKS_DEFAULTS flags. */
static inline void blkid_probe_set_superblocks_flags(blkid_probe pr, int flags)
{
	pr->chains[BLKID_CHAIN_SUBLKS].flags = flags;
}

static void blkid_probe_set_usage(blkid_probe pr, int usage)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);
	char *u = NULL;

	if (!(chn->flags & BLKID_SUBLKS_USAGE))
		return;

	if (usage & BLKID_USAGE_FILESYSTEM)
		u = "filesystem";
	else if (usage & BLKID_USAGE_RAID)
		u = "raid";
	else if (usage & BLKID_USAGE_CRYPTO)
		u = "crypto";
	else if (usage & BLKID_USAGE_OTHER)
		u = "other";
	else
		u = "unknown";

	blkid_probe_set_value(pr, "USAGE", (unsigned char *) u, strlen(u) + 1);
}

/* The blkid_do_probe() backend. */
static int superblocks_probe(blkid_probe pr, struct blkid_chain *chn)
{
	size_t i;
	int rc = BLKID_PROBE_NONE;

	if (chn->idx < -1)
		return -EINVAL;

	blkid_probe_chain_reset_values(pr, chn);

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return BLKID_PROBE_NONE;

	if (pr->size <= 0 || (pr->size <= 1024 && !S_ISCHR(pr->mode))) {
		/* Ignore very very small block devices or regular files (e.g.
		 * extended partitions). Note that size of the UBI char devices
		 * is 1 byte */
		return BLKID_PROBE_NONE;
	}

	i = chn->idx < 0 ? 0 : chn->idx + 1U;

	for ( ; i < ARRAY_SIZE(idinfos_sb); i++) {
		const struct blkid_idinfo *id;
		const struct blkid_idmag *mag = NULL;
		uint64_t off = 0;

		chn->idx = i;
		id = idinfos_sb[i];

		if (chn->fltr && blkid_bmp_get_item(chn->fltr, i)) {
			rc = BLKID_PROBE_NONE;
			continue;
		}

		if (id->minsz && (unsigned)id->minsz > pr->size) {
			rc = BLKID_PROBE_NONE;
			continue;       /* the device is too small */
		}

		/* don't probe for RAIDs, swap or journal on CD/DVDs */
		if ((id->usage & (BLKID_USAGE_RAID | BLKID_USAGE_OTHER)) &&
		    blkid_probe_is_cdrom(pr)) {
			rc = BLKID_PROBE_NONE;
			continue;
		}

		/* don't probe for RAIDs on floppies */
		if ((id->usage & BLKID_USAGE_RAID) && blkid_probe_is_tiny(pr)) {
			rc = BLKID_PROBE_NONE;
			continue;
		}

		rc = blkid_probe_get_idmag(pr, id, &off, &mag);
		if (rc < 0)
			break;
		if (rc != BLKID_PROBE_OK)
			continue;

		/* final check by probing function */
		if (id->probefunc) {
			rc = id->probefunc(pr, mag);
			if (rc != BLKID_PROBE_OK) {
				blkid_probe_chain_reset_values(pr, chn);
				if (rc < 0)
					break;
				continue;
			}
		}

		/* all checks passed */
		if (chn->flags & BLKID_SUBLKS_TYPE)
			blkid_probe_set_value(pr, "TYPE", (const unsigned char *) id->name, strlen(id->name) + 1);

		if (!rc)
			blkid_probe_set_usage(pr, id->usage);

		if (!rc && mag)
			rc = blkid_probe_set_magic(pr, off, mag->len,
					(const unsigned char *) mag->magic);
		if (rc) {
			blkid_probe_chain_reset_values(pr, chn);
			continue;
		}

		return BLKID_PROBE_OK;
	}

	return rc;
}

/* This is the same function as blkid_do_probe(), but returns only one result
 * (cannot be used in while()) and checks for ambivalent results (more
 * filesystems on the device) -- in such case returns -2.
 *
 * The function does not check for filesystems when a RAID or crypto signature
 * is detected.  The function also does not check for collision between RAIDs
 * and crypto devices. The first detected RAID or crypto device is returned.
 *
 * The function does not probe for ambivalent results on very small devices
 * (e.g. floppies), on small devices the first detected filesystem is returned. */
static int superblocks_safeprobe(blkid_probe pr, struct blkid_chain *chn)
{
	struct list_head vals;
	int idx = -1;
	int count = 0;
	int intol = 0;
	int rc;

	INIT_LIST_HEAD(&vals);

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return BLKID_PROBE_NONE;

	while ((rc = superblocks_probe(pr, chn)) == 0) {

		if (blkid_probe_is_tiny(pr) && !count)
			return BLKID_PROBE_OK;  /* floppy or so -- returns the first result. */

		count++;

		if (chn->idx >= 0 &&
		    idinfos_sb[chn->idx]->usage & (BLKID_USAGE_RAID | BLKID_USAGE_CRYPTO))
			break;

		if (chn->idx >= 0 &&
		    !(idinfos_sb[chn->idx]->flags & BLKID_IDINFO_TOLERANT))
			intol++;

		if (count == 1) {
			/* save the first result */
			blkid_probe_chain_save_values(pr, chn, &vals);
			idx = chn->idx;
		}
	}

	if (rc < 0)
		goto done;              /* error */

	if (count > 1 && intol) {
		rc = -2;                /* error, ambivalent result (more FS) */
		goto done;
	}
	if (!count) {
		rc = BLKID_PROBE_NONE;
		goto done;
	}

	if (idx != -1) {
		/* restore the first result */
		blkid_probe_chain_reset_values(pr, chn);
		blkid_probe_append_values_list(pr, &vals);
		chn->idx = idx;
	}

	/* The RAID device could be partitioned. The problem are RAID1 devices
	 * where the partition table is visible from underlying devices. We
	 * have to ignore such partition tables. */
	if (chn->idx >= 0 && idinfos_sb[chn->idx]->usage & BLKID_USAGE_RAID)
		pr->prob_flags |= BLKID_PROBE_FL_IGNORE_PT;

	rc = BLKID_PROBE_OK;
done:
	blkid_probe_free_values_list(&vals);
	return rc;
}

#endif /* CONFIG_FEATURE_LIBBLKID */

/* Alignment according to physical device topology (usually minimal i/o size) */
static int lba_is_phy_aligned(struct fdisk_context *cxt, fdisk_sector_t lba)
{
	unsigned long granularity = max(cxt->phy_sector_size, cxt->min_io_size);
	uintmax_t offset = (lba * cxt->sector_size) % granularity;

	return !((granularity + cxt->alignment_offset - offset) % granularity);
}

/* Check if the @lba is aligned to physical sector boundary.
 *
 * Returns: 1 if aligned. */
static int fdisk_lba_is_phy_aligned(struct fdisk_context *cxt, fdisk_sector_t lba)
{
	return lba_is_phy_aligned(cxt, lba);
}

/* Returns: 1 if is regular file rather than a block device. */
static inline int fdisk_is_regfile(struct fdisk_context *cxt)
{
	return S_ISREG(cxt->dev_st.st_mode);
}

static unsigned long get_sector_size(struct fdisk_context *cxt)
{
	int sect_sz;

	if (!fdisk_is_regfile(cxt) &&
	    !blkdev_get_sector_size(cxt->dev_fd, &sect_sz))
		return (unsigned long) sect_sz;

	return DEFAULT_SECTOR_SIZE;
}

static void recount_geometry(struct fdisk_context *cxt)
{
	if (!cxt->geom.heads)
		cxt->geom.heads = 255;
	if (!cxt->geom.sectors)
		cxt->geom.sectors = 63;

	cxt->geom.cylinders = cxt->total_sectors /
		(cxt->geom.heads * cxt->geom.sectors);
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* This is a binary interface for topology values. See also blkid_topology_*
 * functions.
 *
 * This function is independent on blkid_do_[safe,full]probe()
 *
 * WARNING: the returned object will be overwritten by the next
 *          blkid_probe_get_topology() call for the same @pr. If you want to
 *          use more blkid_topology objects in the same time you have to create
 *          more blkid_probe handlers (see blkid_new_probe()).
 *
 * Returns: blkid_topology, or NULL in case of error. */
static blkid_topology blkid_probe_get_topology(blkid_probe pr)
{
	return (blkid_topology) blkid_probe_get_binary_data(pr,
			&pr->chains[BLKID_CHAIN_TOPLGY]);
}

/* Returns: minimum io size in bytes or 0. */
static inline unsigned long blkid_topology_get_minimum_io_size(blkid_topology tp)
{
	return tp->minimum_io_size;
}

/* Returns: optimal io size in bytes or 0. */
static inline unsigned long blkid_topology_get_optimal_io_size(blkid_topology tp)
{
	return tp->optimal_io_size;
}

/* Returns: logical sector size (BLKSSZGET ioctl) in bytes or 0. */
static inline unsigned long blkid_topology_get_physical_sector_size(blkid_topology tp)
{
	return tp->physical_sector_size;
}

/* Returns: alignment offset in bytes or 0. */
static inline unsigned long blkid_topology_get_alignment_offset(blkid_topology tp)
{
	return tp->alignment_offset;
}

#endif

static int fdisk_discover_topology(struct fdisk_context *cxt)
{
#ifdef CONFIG_FEATURE_LIBBLKID
	blkid_probe pr;
	pr = blkid_new_probe();
	if (blkid_probe_set_device(pr, cxt->dev_fd, 0, 0) == 0) {
		blkid_topology tp = blkid_probe_get_topology(pr);

		if (tp) {
			cxt->min_io_size = blkid_topology_get_minimum_io_size(tp);
			cxt->optimal_io_size = blkid_topology_get_optimal_io_size(tp);
			cxt->phy_sector_size = blkid_topology_get_physical_sector_size(tp);
			cxt->alignment_offset = blkid_topology_get_alignment_offset(tp);

			/* I/O size used by fdisk */
			cxt->io_size = cxt->optimal_io_size;
			if (!cxt->io_size)
				/* optimal I/O is optional, default to minimum IO */
				cxt->io_size = cxt->min_io_size;

			/* ignore optimal I/O if not aligned to phy.sector size */
			if (cxt->io_size
			    && cxt->phy_sector_size
			    && (cxt->io_size % cxt->phy_sector_size) != 0) {
				cxt->io_size = cxt->phy_sector_size;
			}

		}
	}
	blkid_free_probe(pr);
#endif

	cxt->sector_size = get_sector_size(cxt);
	if (!cxt->phy_sector_size) /* could not discover physical size */
		cxt->phy_sector_size = cxt->sector_size;

	/* no blkid or error, use default values */
	if (!cxt->min_io_size)
		cxt->min_io_size = cxt->sector_size;
	if (!cxt->io_size)
		cxt->io_size = cxt->sector_size;

	return 0;
}

static unsigned long topology_get_grain(struct fdisk_context *cxt)
{
	unsigned long res;

	if (!cxt)
		return 0;

	if (!cxt->io_size)
		fdisk_discover_topology(cxt);

	res = cxt->io_size;

	/* use 1MiB grain always when possible */
	if (res < 2048 * 512)
		res = 2048 * 512;

	/* don't use huge grain on small devices */
	if (cxt->total_sectors <= (res * 4 / cxt->sector_size))
		res = cxt->phy_sector_size;

	return res;
}

static int has_topology(struct fdisk_context *cxt)
{
	/* Assume that the device provides topology info if
	 * optimal_io_size is set or alignment_offset is set or
	 * minimum_io_size is not power of 2. */
	if (cxt &&
	    (cxt->optimal_io_size ||
	     cxt->alignment_offset ||
	     !is_power_of_2(cxt->min_io_size)))
		return 1;
	return 0;
}

/* The LBA of the first partition is based on the device geometry and topology.
 * This offset is generic (and recommended) for all labels.
 *
 * Returns: 0 on error or number of logical sectors. */
static fdisk_sector_t topology_get_first_lba(struct fdisk_context *cxt)
{
	fdisk_sector_t x = 0, res;

	if (!cxt)
		return 0;

	if (!cxt->io_size)
		fdisk_discover_topology(cxt);

	/* Align the begin of partitions to:
	 *
	 * a) topology
	 *  a2) alignment offset
	 *  a1) or physical sector (minimal_io_size, aka "grain")
	 *
	 * b) or default to 1MiB (2048 sectors, Windows Vista default)
	 *
	 * c) or for very small devices use 1 phy.sector */
	if (has_topology(cxt)) {
		if (cxt->alignment_offset)
			x = cxt->alignment_offset;
		else if (cxt->io_size > 2048 * 512)
			x = cxt->io_size;
	}
	/* default to 1MiB */
	if (!x)
		x = 2048 * 512;

	res = x / cxt->sector_size;

	/* don't use huge offset on small devices */
	if (cxt->total_sectors <= res * 4)
		res = cxt->phy_sector_size / cxt->sector_size;

	return res;
}

/* apply label alignment setting to the context -- if not sure use
 * fdisk_reset_alignment() */
static int fdisk_apply_label_device_properties(struct fdisk_context *cxt)
{
	int rc = 0;

	if (cxt->label && cxt->label->op->reset_alignment) {
		rc = cxt->label->op->reset_alignment(cxt);
	}
	return rc;
}

/* Resets alignment setting to the default and label specific values. This
 * function does not change device properties (I/O limits, geometry etc.).
 *
 * Returns: 0 on success, < 0 in case of error. */
static int fdisk_reset_alignment(struct fdisk_context *cxt)
{
	int rc = 0;

	if (!cxt)
		return -EINVAL;

	/* default */
	cxt->grain = topology_get_grain(cxt);
	cxt->first_lba = topology_get_first_lba(cxt);
	cxt->last_lba = cxt->total_sectors - 1;

	/* overwrite default by label stuff */
	rc = fdisk_apply_label_device_properties(cxt);

	return rc;
}

/* Overrides auto-discovery. The function fdisk_reset_device_properties()
 * restores the original setting.
 *
 * The difference between fdisk_override_geometry() and fdisk_save_user_geometry()
 * is that saved user geometry is persistent setting and it's applied always
 * when device is assigned to the context or device properties are reset.
 *
 * Returns: 0 on success, < 0 on error. */
static int fdisk_override_geometry(struct fdisk_context *cxt,
			    unsigned int cylinders,
			    unsigned int heads,
			    unsigned int sectors)
{
	if (!cxt)
		return -EINVAL;
	if (heads)
		cxt->geom.heads = heads;
	if (sectors)
		cxt->geom.sectors = sectors;

	if (cylinders)
		cxt->geom.cylinders = cylinders;
	else
		recount_geometry(cxt);

	fdisk_reset_alignment(cxt);

	return 0;
}

/* Save user defined geometry to use it for partitioning.
 * The user properties are applied by fdisk_assign_device() or
 * fdisk_reset_device_properties().
 * Returns: <0 on error, 0 on success. */
static int fdisk_save_user_geometry(struct fdisk_context *cxt,
			    unsigned int cylinders,
			    unsigned int heads,
			    unsigned int sectors)
{
	if (!cxt)
		return -EINVAL;

	if (heads)
		cxt->user_geom.heads = heads > 256 ? 0 : heads;
	if (sectors)
		cxt->user_geom.sectors = sectors >= 64 ? 0 : sectors;
	if (cylinders)
		cxt->user_geom.cylinders = cylinders;

	return 0;
}

/* Save user defined sector sizes to use it for partitioning.
 *
 * The user properties are applied by fdisk_assign_device() or
 * fdisk_reset_device_properties().
 *
 * Returns: <0 on error, 0 on success. */
static int fdisk_save_user_sector_size(struct fdisk_context *cxt,
				unsigned int phy,
				unsigned int log)
{
	if (!cxt)
		return -EINVAL;

	cxt->user_pyh_sector = phy;
	cxt->user_log_sector = log;

	return 0;
}

/* Save user define grain size. The size is used to align partitions.
 *
 * The default is 1MiB (or optimal I/O size if greater than 1MiB). It's strongly
 * recommended to use the default.
 *
 * The smallest possible granularity for partitioning is physical sector size
 * (or minimal I/O size; the bigger number win). If the user's @grain size is
 * too small than the smallest possible granularity is used. It means
 * fdisk_save_user_grain(cxt, 512) forces libfdisk to use grain as small as
 * possible.
 *
 * The setting is applied by fdisk_assign_device() or
 * fdisk_reset_device_properties().
 *
 * Returns: <0 on error, 0 on success. */
static int fdisk_save_user_grain(struct fdisk_context *cxt, unsigned long grain)
{
	if (!cxt || grain % 512)
		return -EINVAL;

	cxt->user_grain = grain;
	return 0;
}

static int fdisk_apply_user_device_properties(struct fdisk_context *cxt)
{
	if (!cxt)
		return -EINVAL;

	if (cxt->user_pyh_sector)
		cxt->phy_sector_size = cxt->user_pyh_sector;
	if (cxt->user_log_sector) {
		uint64_t old_total = cxt->total_sectors;
		uint64_t old_secsz = cxt->sector_size;

		cxt->sector_size = cxt->min_io_size =
			cxt->io_size = cxt->user_log_sector;

		if (cxt->sector_size != old_secsz) {
			cxt->total_sectors = (old_total * (old_secsz/512)) / (cxt->sector_size >> 9);
		}
	}

	if (cxt->user_geom.heads)
		cxt->geom.heads = cxt->user_geom.heads;
	if (cxt->user_geom.sectors)
		cxt->geom.sectors = cxt->user_geom.sectors;

	if (cxt->user_geom.cylinders)
		cxt->geom.cylinders = cxt->user_geom.cylinders;
	else if (cxt->user_geom.heads || cxt->user_geom.sectors)
		recount_geometry(cxt);

	fdisk_reset_alignment(cxt);

	if (cxt->user_grain) {
		unsigned long granularity = max(cxt->phy_sector_size, cxt->min_io_size);

		cxt->grain = cxt->user_grain < granularity ? granularity : cxt->user_grain;
	}

	if (cxt->firstsector_bufsz != cxt->sector_size)
		fdisk_read_firstsector(cxt);

	return 0;
}


/* Generic (label independent) geometry */
static int fdisk_discover_geometry(struct fdisk_context *cxt)
{
	fdisk_sector_t nsects = 0;
	unsigned int h = 0, s = 0;

	if (fdisk_is_regfile(cxt))
		cxt->total_sectors = cxt->dev_st.st_size / cxt->sector_size;
	else {
		/* get number of 512-byte sectors, and convert it the real sectors */
		if (!blkdev_get_sectors(cxt->dev_fd, (unsigned long long *) &nsects))
			cxt->total_sectors = (nsects / (cxt->sector_size >> 9));

		/* what the kernel/bios thinks the geometry is */
		blkdev_get_geometry(cxt->dev_fd, &h, &s);
	}

	cxt->geom.cylinders = 0;
	cxt->geom.heads = h;
	cxt->geom.sectors = s;

	/* obtained heads and sectors */
	recount_geometry(cxt);

	return 0;
}



/* Returns: 1 if user wants to display in cylinders. */
static int fdisk_use_cylinders(struct fdisk_context *cxt)
{
	return cxt->display_in_cyl_units == 1;
}

/* This is necessary only for brain dead situations when we use "cylinders";
 * Returns: number of "units" per sector, default is 1 if display unit is sector. */
static unsigned int fdisk_get_units_per_sector(struct fdisk_context *cxt)
{
	if (fdisk_use_cylinders(cxt))
		return cxt->geom.heads * cxt->geom.sectors;
	return 1;
}

#if defined(CONFIG_FEATURE_SUN_LABEL) || defined(CONFIG_FEATURE_SGI_LABEL)
static fdisk_sector_t fdisk_scround(struct fdisk_context *cxt, fdisk_sector_t num)
{
	fdisk_sector_t un = fdisk_get_units_per_sector(cxt);
	return (num + un - 1) / un;
}
#endif


static fdisk_sector_t fdisk_cround(struct fdisk_context *cxt, fdisk_sector_t num)
{
	return fdisk_use_cylinders(cxt) ?
			(num / fdisk_get_units_per_sector(cxt)) + 1 : num;
}

#include <linux/blkpg.h>

#ifndef BLKPG_ADD_PARTITION
# define BLKPG_ADD_PARTITION    1
#endif

#ifndef BLKPG_DEL_PARTITION
# define BLKPG_DEL_PARTITION    2
#endif

#ifndef BLKPG_RESIZE_PARTITION
# define BLKPG_RESIZE_PARTITION 3               /* since Linux 3.6 */
#endif


#define INIT_BLKPG_PARTITION(_partno, _start, _size) {  \
		.pno    = (_partno),                    \
		.start  = (_start) << 9,                \
		.length = (_size) << 9,                 \
		.devname[0] = 0,                        \
		.volname[0] = 0                         \
}

#define INIT_BLKPG_ARG(_action, _part) {                \
		.op      = (_action),                   \
		.flags   = 0,                           \
		.datalen = sizeof(*(_part)),            \
		.data = (_part)                         \
}


static inline int partx_del_partition(int fd, unsigned int partno)
{
	struct blkpg_partition p = INIT_BLKPG_PARTITION(partno, 0, 0);
	struct blkpg_ioctl_arg a = INIT_BLKPG_ARG(BLKPG_DEL_PARTITION, &p);

	return ioctl(fd, BLKPG, &a);
}

static inline int partx_add_partition(int fd, int partno,
			uint64_t start, uint64_t size)
{
	struct blkpg_partition p = INIT_BLKPG_PARTITION(partno, start, size);
	struct blkpg_ioctl_arg a = INIT_BLKPG_ARG(BLKPG_ADD_PARTITION, &p);

	return ioctl(fd, BLKPG, &a);
}

static inline int partx_resize_partition(int fd, int partno,
			uint64_t start, uint64_t size)
{
	struct blkpg_partition p = INIT_BLKPG_PARTITION(partno, start, size);
	struct blkpg_ioctl_arg a = INIT_BLKPG_ARG(BLKPG_RESIZE_PARTITION, &p);

	return ioctl(fd, BLKPG, &a);
}


static void init_nested_from_parent(struct fdisk_context *cxt, int isnew)
{
	struct fdisk_context *parent;

	parent = cxt->parent;

	cxt->alignment_offset = parent->alignment_offset;
	cxt->ask_cb =           parent->ask_cb;
	cxt->ask_data =         parent->ask_data;
	cxt->dev_fd =           parent->dev_fd;
	cxt->first_lba =        parent->first_lba;
	cxt->firstsector_bufsz = parent->firstsector_bufsz;
	cxt->firstsector =      parent->firstsector;
	cxt->geom =             parent->geom;
	cxt->grain =            parent->grain;
	cxt->io_size =          parent->io_size;
	cxt->last_lba =         parent->last_lba;
	cxt->min_io_size =      parent->min_io_size;
	cxt->optimal_io_size =  parent->optimal_io_size;
	cxt->phy_sector_size =  parent->phy_sector_size;
	cxt->readonly =         parent->readonly;
	cxt->script =           parent->script;
	fdisk_ref_script(cxt->script);
	cxt->sector_size =      parent->sector_size;
	cxt->total_sectors =    parent->total_sectors;
	cxt->user_geom =        parent->user_geom;
	cxt->user_log_sector =  parent->user_log_sector;
	cxt->user_pyh_sector =  parent->user_pyh_sector;

	/* parent <--> nested independent setting, initialize for new nested
	 * contexts only */
	if (isnew) {
		cxt->listonly = parent->listonly;
		cxt->display_details =  parent->display_details;
		cxt->display_in_cyl_units = parent->display_in_cyl_units;
		cxt->protect_bootbits = parent->protect_bootbits;
	}

	free(cxt->dev_model);
	cxt->dev_model = NULL;
	cxt->dev_model_probed = 0;

	free(cxt->dev_path);
	cxt->dev_path = NULL;

	if (parent->dev_path)
		cxt->dev_path = xstrdup(parent->dev_path);

	INIT_LIST_HEAD(&cxt->wipes);
}

static int __fdisk_switch_label(struct fdisk_context *cxt, struct fdisk_label *lb)
{
	if (!lb || !cxt)
		return -EINVAL;
	if (lb->disabled)
		return -EINVAL;
	cxt->label = lb;

	fdisk_apply_label_device_properties(cxt);
	return 0;
}

#if defined(CONFIG_FEATURE_BSD_LABEL) || defined(CONFIG_FEATURE_GPT_LABEL)
/* Create a new nested fdisk context for nested disk labels (e.g. BSD or PMBR).
 * The function also probes for the nested label on the device if device is
 * already assigned to parent.
 *
 * The new context is initialized according to @parent and both context shares
 * some settings and file descriptor to the device. The child propagate some
 * changes (like fdisk_assign_device()) to parent, but it does not work
 * vice-versa. The behavior is undefined if you assign another device to
 * parent.
 *
 * Returns: new context for nested partition table. */
static struct fdisk_context *fdisk_new_nested_context(struct fdisk_context *parent,
				const char *name)
{
	struct fdisk_context *cxt;
	struct fdisk_label *lb = NULL;

	cxt = zmalloc(sizeof(*cxt));
	cxt->refcount = 1;

	fdisk_ref_context(parent);
	cxt->parent = parent;

	init_nested_from_parent(cxt, 1);

	if (name) {
#ifdef CONFIG_FEATURE_BSD_LABEL
		if (strcasecmp(name, "bsd") == 0)
			lb = cxt->labels[ cxt->nlabels++ ] = fdisk_new_bsd_label(cxt);
		else
#endif
		     if (strcasecmp(name, "dos") == 0 || strcasecmp(name, "mbr") == 0)
			lb = cxt->labels[ cxt->nlabels++ ] = fdisk_new_dos_label(cxt);
	}

	if (lb && parent->dev_fd >= 0) {
		cxt->label = lb;

		if (lb->op->probe(cxt) == 1)
			__fdisk_switch_label(cxt, lb);
		else {
			if (lb->op->deinit)
				lb->op->deinit(lb);
			cxt->label = NULL;
		}
	}

	return cxt;
}
#endif /* CONFIG_FEATURE_BSD_LABEL || CONFIG_FEATURE_GPT_LABEL */


/* Returns: <0 in case of error, 0 on success, 1 at the end. */
static int fdisk_next_label(struct fdisk_context *cxt, struct fdisk_label **lb)
{
	size_t i;
	struct fdisk_label *res = NULL;

	if (!lb || !cxt)
		return -EINVAL;

	if (!*lb)
		res = cxt->labels[0];
	else {
		for (i = 1; i < cxt->nlabels; i++) {
			if (*lb == cxt->labels[i - 1]) {
				res = cxt->labels[i];
				break;
			}
		}
	}

	*lb = res;
	return res ? 0 : 1;
}

/* Returns: return 1 if there is label on the device. */
static inline int fdisk_has_label(struct fdisk_context *cxt)
{
	return cxt && cxt->label;
}

/* Returns: return 1 if boot bits protection enabled. */
static int fdisk_has_protected_bootbits(struct fdisk_context *cxt)
{
	return cxt && cxt->protect_bootbits;
}

/* The library zeroizes all the first sector when create a new disk label by
 * default.  This function allows to control this behavior. For now it's
 * supported for MBR and GPT.
 * Returns: 0 on success, < 0 on error. */
static int fdisk_enable_bootbits_protection(struct fdisk_context *cxt, int enable)
{
	if (!cxt)
		return -EINVAL;
	cxt->protect_bootbits = enable ? 1 : 0;
	return 0;
}


/* The library removes all PT/filesystem/RAID signatures before it writes
 * partition table. The probing area where it looks for signatures is from
 * the begin of the disk. The device is wiped by libblkid.
 * See also fdisk_wipe_partition().
 * Returns: 0 on success, < 0 on error. */
static int fdisk_enable_wipe(struct fdisk_context *cxt, int enable)
{
	if (!cxt)
		return -EINVAL;

	fdisk_set_wipe_area(cxt, 0, cxt->total_sectors, enable);
	return 0;
}

/* Returns: name of the filesystem or RAID detected on the device or NULL. */
static inline const char *fdisk_get_collision(struct fdisk_context *cxt)
{
	return cxt->collision;
}

/* The collision detected by libblkid (usually another partition table). Note
 * that libfdisk does not support all partitions tables, so fdisk_has_label()
 * may return false, but fdisk_is_ptcollision() may return true.
 * Returns: 0 or 1 */
static inline int fdisk_is_ptcollision(struct fdisk_context *cxt)
{
	return cxt->pt_collision;
}


/* Returns: pointer to parental context, or NULL */
static struct fdisk_context *fdisk_get_parent(struct fdisk_context *cxt)
{
	return cxt->parent;
}

/* Just list partition only, don't care about another details, mistakes, ...
 * Returns: 0 on success, < 0 on error. */
static int fdisk_enable_listonly(struct fdisk_context *cxt, int enable)
{
	cxt->listonly = enable ? 1 : 0;
	return 0;
}


/* Close device and call fsync(). If the @cxt is nested context than the
 * request is redirected to the parent.
 * Returns: 0 on success, < 0 on error. */
static int fdisk_deassign_device(struct fdisk_context *cxt, int nosync)
{
	if (cxt->parent) {
		int rc = fdisk_deassign_device(cxt->parent, nosync);

		if (!rc)
			init_nested_from_parent(cxt, 0);
		return rc;
	}

	if (cxt->readonly)
		close(cxt->dev_fd);
	else {
		int rc = fsync_close(cxt->dev_fd);
		if (rc) {
			fdisk_warn(cxt, "%s: close device failed", cxt->dev_path);
			return rc;
		}

		if (!nosync) {
			fdisk_info(cxt, "Syncing disks.");
			sync();
		}
	}

	free(cxt->dev_path);
	cxt->dev_path = NULL;

	cxt->dev_fd = -1;

	return 0;
}

/* Force *kernel* to re-read partition table on block devices.
 *
 * Returns: 0 on success, < 0 in case of error. */
static int fdisk_reread_partition_table(struct fdisk_context *cxt)
{
	int i = 0;

	if (!S_ISBLK(cxt->dev_st.st_mode))
		return 0;
	else {
		sync();
#ifdef BLKRRPART
		fdisk_info(cxt, "Calling ioctl() to re-read partition table.");
		i = ioctl(cxt->dev_fd, BLKRRPART);
#else
		errno = ENOSYS;
		i = 1;
#endif
	}

	if (i) {
		fdisk_warn(cxt, "Re-reading the partition table failed.");
		fdisk_info(cxt, "The kernel still uses the old table. The "
			"new table will be used at the next reboot "
			"or after you run partprobe(8) or kpartx(8).");
		return -errno;
	}

	return 0;
}

/* Like fdisk_reread_partition_table() but don't forces kernel re-read all
 * partition table. The BLKPG_* ioctls are used for individual partitions. The
 * advantage is that unmodified partitions maybe mounted.
 *
 * The function behavies like fdisk_reread_partition_table() on systems where
 * are no available BLKPG_* ioctls.
 *
 * Returns: <0 on error, or 0. */
#ifdef __linux__

static int add_to_partitions_array(struct fdisk_partition ***ary,
			struct fdisk_partition *pa,
			size_t *n, size_t nmax)
{
	if (!*ary)
		*ary = zmalloc(nmax * sizeof(struct fdisk_partition *));
	(*ary)[*n] = pa;
	(*n)++;
	return 0;
}

static int fdisk_reread_changes(struct fdisk_context *cxt, struct fdisk_table *org)
{
	struct fdisk_table *tb = NULL;
	struct fdisk_iter itr;
	struct fdisk_partition *pa;
	struct fdisk_partition **rem = NULL, **add = NULL, **upd = NULL;
	int change, rc = 0, err = 0;
	size_t nparts, i, nadds = 0, nupds = 0, nrems = 0;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);

	/* the current layout */
	fdisk_get_partitions(cxt, &tb);
	/* maximal number of partitions */
	nparts = max(fdisk_table_get_nents(tb), fdisk_table_get_nents(org));

	while (fdisk_diff_tables(org, tb, &itr, &pa, &change) == 0) {
		if (change == FDISK_DIFF_UNCHANGED)
			continue;
		switch (change) {
		case FDISK_DIFF_REMOVED:
			rc = add_to_partitions_array(&rem, pa, &nrems, nparts);
			break;
		case FDISK_DIFF_ADDED:
			rc = add_to_partitions_array(&add, pa, &nadds, nparts);
			break;
		case FDISK_DIFF_RESIZED:
			rc = add_to_partitions_array(&upd, pa, &nupds, nparts);
			break;
		case FDISK_DIFF_MOVED:
			rc = add_to_partitions_array(&rem, pa, &nrems, nparts);
			rc = add_to_partitions_array(&add, pa, &nadds, nparts);
			break;
		}
		if (rc != 0)
			goto done;
	}

	for (i = 0; i < nrems; i++) {
		pa = rem[i];
		if (partx_del_partition(cxt->dev_fd, pa->partno + 1) != 0) {
			fdisk_warn(cxt, "Failed to remove partition %zu from system", pa->partno + 1);
			err++;
		}
	}
	for (i = 0; i < nupds; i++) {
		pa = upd[i];
		if (partx_resize_partition(cxt->dev_fd, pa->partno + 1, pa->start, pa->size) != 0) {
			fdisk_warn(cxt, "Failed to update system information about partition %zu", pa->partno + 1);
			err++;
		}
	}
	for (i = 0; i < nadds; i++) {
		pa = add[i];
		if (partx_add_partition(cxt->dev_fd, pa->partno + 1, pa->start, pa->size) != 0) {
			fdisk_warn(cxt, "Failed to add partition %zu to system", pa->partno + 1);
			err++;
		}
	}
	if (err)
		fdisk_info(cxt, "The kernel still uses the old partitions. The new "
			"table will be used at the next reboot. ");
done:
	free(rem);
	free(add);
	free(upd);
	fdisk_unref_table(tb);
	return rc;
}
#else
int fdisk_reread_changes(struct fdisk_context *cxt,
			 struct fdisk_table *org __attribute__((__unused__))) {
	return fdisk_reread_partition_table(cxt);
}
#endif

/* On systems where is no BLKRRPART ioctl the function returns zero and
 * sets errno to ENOSYS.
 * Returns: 1 if the device assigned to the context is used by system, or 0. */
static int fdisk_device_is_used(struct fdisk_context *cxt)
{
	int rc = 0;

#ifdef BLKRRPART
#define LOOPDEV_MAJOR           7       /* loop major number */

	errno = 0;
	/* it seems kernel always return EINVAL for BLKRRPART on loopdevices */
	if (S_ISBLK(cxt->dev_st.st_mode)
	    && major(cxt->dev_st.st_rdev) != LOOPDEV_MAJOR) {
		rc = ioctl(cxt->dev_fd, BLKRRPART) != 0;
	}
#else
	errno = ENOSYS;
#endif
	return rc;
}

/* Returns: 1 if device open readonly */
static inline int fdisk_is_readonly(struct fdisk_context *cxt)
{
	return cxt->readonly;
}


/* Enables or disables "details" display mode. This function has effect to
 * fdisk_partition_to_string() function.
 * Returns: 0 on success, < 0 on error. */
static int fdisk_enable_details(struct fdisk_context *cxt, int enable)
{
	cxt->display_details = enable ? 1 : 0;
	return 0;
}

/* Returns: 1 if details are enabled */
static int fdisk_is_details(struct fdisk_context *cxt)
{
	return cxt->display_details == 1;
}

/* This is pure shit, unfortunately for example Sun addresses begin of the
 * partition by cylinders...
 * Returns: 0 on success, <0 on error. */
static int fdisk_set_unit(struct fdisk_context *cxt, const char *str)
{
	cxt->display_in_cyl_units = 0;

	if (!str)
		return 0;

	if (strcmp(str, "cylinder") == 0 || strcmp(str, "cylinders") == 0)
		cxt->display_in_cyl_units = 1;

	else if (strcmp(str, "sector") == 0 || strcmp(str, "sectors") == 0)
		cxt->display_in_cyl_units = 0;

	return 0;
}

/* @n: FDISK_PLURAL or FDISK_SINGULAR. Returns: unit name. */
static const char *fdisk_get_unit(struct fdisk_context *cxt, int n)
{
	if (fdisk_use_cylinders(cxt))
		return P_("cylinder", "cylinders", n);
	return P_("sector", "sectors", n);
}

/* The optimal I/O is optional and does not have to be provided by device,
 * anyway libfdisk never returns zero. If the optimal I/O size is not provided
 * then libfdisk returns minimal I/O size or sector size.
 * Returns: optimal I/O size in bytes. */
static unsigned long fdisk_get_optimal_iosize(struct fdisk_context *cxt)
{
	return cxt->optimal_io_size ? cxt->optimal_io_size : cxt->io_size;
}

/* Returns: minimal I/O size in bytes */
static unsigned long fdisk_get_minimal_iosize(struct fdisk_context *cxt)
{
	return cxt->min_io_size;
}

/* Returns: physical sector size in bytes */
static unsigned long fdisk_get_physector_size(struct fdisk_context *cxt)
{
	return cxt->phy_sector_size;
}

/* Returns: logical sector size in bytes */
static unsigned long fdisk_get_sector_size(struct fdisk_context *cxt)
{
	return cxt->sector_size;
}

/* The alignment offset is offset between logical and physical sectors. For
 * backward compatibility the first logical sector on 4K disks does no have to
 * start on the same place like physical sectors.
 * Returns: alignment offset in bytes */
static unsigned long fdisk_get_alignment_offset(struct fdisk_context *cxt)
{
	return cxt->alignment_offset;
}


/* It's strongly recommended to use the default library setting. The first LBA
 * is always reset by fdisk_assign_device(), fdisk_override_geometry()
 * and fdisk_reset_alignment(). This is very low level function and library
 * does not check if your setting makes any sense.
 *
 * This function is necessary only when you want to work with very unusual
 * partition tables like GPT protective MBR or hybrid partition tables on
 * bootable media where the first partition may start on very crazy offsets.
 * Returns: 0 on success, <0 on error. */
static fdisk_sector_t fdisk_set_first_lba(struct fdisk_context *cxt, fdisk_sector_t lba)
{
	cxt->first_lba = lba;
	return 0;
}

/* Sets unit for SIZE output field (see fdisk_partition_to_string()).
 * Returns: 0 on success, <0 on error. */
static int fdisk_set_size_unit(struct fdisk_context *cxt, int unit)
{
	cxt->sizeunit = unit;
	return 0;
}

/* Returns: size of the device in logical sectors. */
static fdisk_sector_t fdisk_get_nsectors(struct fdisk_context *cxt)
{
	return cxt->total_sectors;
}

/* Returns: device name. */
static const char *fdisk_get_devname(struct fdisk_context *cxt)
{
	return cxt->dev_path;
}

/* fdisk_get_devmodel: * Returns: device model string or NULL. */
#if defined(__linux__) && defined(CONFIG_FEATURE_LIBBLKID)
/* fdisk_get_devno: Returns: device number or zero for non-block devices */
static dev_t fdisk_get_devno(struct fdisk_context *cxt)
{
	return S_ISBLK(cxt->dev_st.st_mode) ? cxt->dev_st.st_rdev : 0;
}


static const char *fdisk_get_devmodel(struct fdisk_context *cxt)
{
	if (cxt->dev_model_probed)
		return cxt->dev_model;

	if (fdisk_get_devno(cxt)) {
		struct path_cxt *pc = ul_new_sysfs_path(fdisk_get_devno(cxt), NULL, NULL);

		if (pc) {
			ul_path_read_string(pc, &cxt->dev_model, "device/model");
			ul_unref_path(pc);
		}
	}
	cxt->dev_model_probed = 1;
	return cxt->dev_model;
}
#else
static const char *fdisk_get_devmodel(struct fdisk_context *cxt __attribute__((__unused__)))
{
	return NULL;
}
#endif


/* Returns: number of geometry heads. */
static unsigned int fdisk_get_geom_heads(struct fdisk_context *cxt)
{
	return cxt->geom.heads;
}

/* Returns: number of geometry sectors. */
static fdisk_sector_t fdisk_get_geom_sectors(struct fdisk_context *cxt)
{
	return cxt->geom.sectors;

}

/* Returns: number of geometry cylinders */
static fdisk_sector_t fdisk_get_geom_cylinders(struct fdisk_context *cxt)
{
	return cxt->geom.cylinders;
}




#ifdef CONFIG_FEATURE_GPT_LABEL
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
static struct fdisk_partition *__copy_partition(struct fdisk_partition *o)
{
	struct fdisk_partition *n = fdisk_new_partition();

	memcpy(n, o, sizeof(*n));
	if (n->type)
		fdisk_ref_parttype(n->type);
	if (o->name)
		n->name = xstrdup(o->name);
	if (o->uuid)
		n->uuid = xstrdup(o->uuid);
	if (o->attrs)
		n->attrs = xstrdup(o->attrs);
	if (o->fstype)
		n->fstype = xstrdup(o->fstype);
	if (o->fsuuid)
		n->fsuuid = xstrdup(o->fsuuid);
	if (o->fslabel)
		n->fslabel = xstrdup(o->fslabel);

	return n;
}
#endif
#endif


/*  Returns: 1 if the partition follows default */
static int fdisk_partition_start_is_default(struct fdisk_partition *pa)
{
	return pa->start_follow_default;
}

static int fdisk_partition_has_size(struct fdisk_partition *pa)
{
	return pa && !FDISK_IS_UNDEF(pa->size);
}

/* The zero is also valid partition number. The function may return random
 * value when partno is undefined (for example after fdisk_partition_unset_partno()).
 * Always use fdisk_partition_has_partno() to be sure that you work with valid
 * numbers.
 *
 * Returns: partition number (0 is the first partition) */
static inline size_t fdisk_partition_get_partno(struct fdisk_partition *pa)
{
	return pa->partno;
}

/* Sets partition type.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_partition_set_type(struct fdisk_partition *pa, struct fdisk_parttype *type)
{
	if (!pa)
		return -EINVAL;

	fdisk_ref_parttype(type);
	fdisk_unref_parttype(pa->type);
	pa->type = type;

	return 0;
}

/* Returns: pointer to partition type. */
static struct fdisk_parttype *fdisk_partition_get_type(struct fdisk_partition *pa)
{
	return pa ? pa->type : NULL;
}

/* Returns: 1 if the partition has enabled boot flag */
static int fdisk_partition_is_bootable(struct fdisk_partition *pa)
{
	return pa && pa->boot == 1;
}


/* High-level API to ask for used or unused partition number.
 *
 * Returns: 0 on success, < 0 on error, 1 if no free/used partition */
static int fdisk_ask_partnum(struct fdisk_context *cxt, size_t *partnum, int wantnew)
{
	int rc = 0, inchar = 0;
	char range[BUFSIZ], *ptr = range;
	size_t i, len = sizeof(range), begin = 0, run = 0;
	struct fdisk_ask *ask = NULL;
	__typeof__(ask->data.num) *num;

	if (cxt->label && cxt->label->flags & FDISK_LABEL_FL_INCHARS_PARTNO)
		inchar = 1;

	ask = fdisk_new_ask();
	fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);
	num = &ask->data.num;

	ask->data.num.inchars = inchar ? 1 : 0;

	for (i = 0; i < cxt->label->nparts_max; i++) {
		int used = fdisk_is_partition_used(cxt, i);

		if (wantnew && !used) {
			ptr = mk_string_list(ptr, &len, &begin, &run, i, inchar);
			if (!ptr) {
				rc = -EINVAL;
				break;
			}
			if (!num->low)
				num->dfl = num->low = i + 1;
			num->hig = i + 1;
		} else if (!wantnew && used) {
			ptr = mk_string_list(ptr, &len, &begin, &run, i, inchar);
			if (!num->low)
				num->low = i + 1;
			num->dfl = num->hig = i + 1;
		}
	}

	if (!rc && !wantnew && num->low == num->hig) {
		if (num->low > 0) {
			/* only one existing partition, don't ask, return the number */
			fdisk_ask_number_set_result(ask, num->low);
			fdisk_info(cxt, "Selected partition %ju", num->low);

		} else if (num->low == 0) {
			fdisk_warnx(cxt, "No partition is defined yet!");
			rc = 1;
		}
		goto dont_ask;
	}
	if (!rc && wantnew && num->low == num->hig) {
		if (num->low > 0) {
			/* only one free partition, don't ask, return the number */
			fdisk_ask_number_set_result(ask, num->low);
			fdisk_info(cxt, "Selected partition %ju", num->low);
		}
		if (num->low == 0) {
			fdisk_warnx(cxt, "No free partition available!");
			rc = 1;
		}
		goto dont_ask;
	}
	if (!rc) {
		mk_string_list(ptr, &len, &begin, &run, -1, inchar);    /* terminate the list */
		fdisk_ask_number_set_range(ask, range);
		rc = fdisk_ask_set_query(ask, "Partition number");
	}
	if (!rc)
		rc = fdisk_do_ask(cxt, ask);

dont_ask:
	if (!rc) {
		*partnum = fdisk_ask_number_get_result(ask);
		if (*partnum)
			*partnum -= 1;
	}
	fdisk_unref_ask(ask);
	return rc;
}

/* If @pa specified and partno-follow-default (see fdisk_partition_partno_follow_default())
 * enabled then returns next expected partno or -ERANGE on error.
 *
 * If @pa is NULL, or @pa does not specify any semantic for the next partno
 * then use Ask API to ask user for the next partno. In this case returns 1 if
 * no free partition available. If fdisk dialogs are disabled then returns -EINVAL.
 *
 * Returns: 0 on success, <0 on error, or 1 for non-free partno by Ask API. */
static int fdisk_partition_next_partno(
		struct fdisk_partition *pa,
		struct fdisk_context *cxt,
		size_t *n)
{
	if (!cxt || !n)
		return -EINVAL;

	if (pa && pa->partno_follow_default) {
		size_t i;

		for (i = 0; i < cxt->label->nparts_max; i++) {
			if (!fdisk_is_partition_used(cxt, i)) {
				*n = i;
				return 0;
			}
		}
		return -ERANGE;

	} else if (pa && fdisk_partition_has_partno(pa)) {

		if (pa->partno >= cxt->label->nparts_max ||
		    fdisk_is_partition_used(cxt, pa->partno))
			return -ERANGE;
		*n = pa->partno;
		return 0;

	} else if (fdisk_has_dialogs(cxt))
		return fdisk_ask_partnum(cxt, n, 1);

	return -EINVAL;
}

static int probe_partition_content(struct fdisk_context *cxt, struct fdisk_partition *pa)
{
	int rc = 1;     /* nothing */

	/* zeroize the current setting */
	strdup_to_struct_member(pa, fstype, NULL);
	strdup_to_struct_member(pa, fsuuid, NULL);
	strdup_to_struct_member(pa, fslabel, NULL);

	if (!fdisk_partition_has_start(pa) ||
	    !fdisk_partition_has_size(pa))
		goto done;

#ifdef CONFIG_FEATURE_LIBBLKID
	else {
		uintmax_t start, size;

		blkid_probe pr = blkid_new_probe();
		start = fdisk_partition_get_start(pa) * fdisk_get_sector_size(cxt);
		size = fdisk_partition_get_size(pa) * fdisk_get_sector_size(cxt);

		if (blkid_probe_set_device(pr, cxt->dev_fd, start, size) == 0
		    && blkid_do_fullprobe(pr) == 0) {

			const char *data;
			rc = 0;

			if (!blkid_probe_lookup_value(pr, "TYPE",  &data, NULL))
				rc = strdup_to_struct_member(pa, fstype, data);

			if (!rc && !blkid_probe_lookup_value(pr, "LABEL", &data, NULL))
				rc = strdup_to_struct_member(pa, fslabel, data);

			if (!rc && !blkid_probe_lookup_value(pr, "UUID",  &data, NULL))
				rc = strdup_to_struct_member(pa, fsuuid, data);
		}

		blkid_free_probe(pr);
		pa->fs_probed = 1;
	}
#endif /* CONFIG_FEATURE_LIBBLKID */

done:
	return rc;
}

/* Returns info about partition converted to printable string.
 *
 * returns UUID for the first partition. */
static int fdisk_partition_to_string(struct fdisk_partition *pa,
			      struct fdisk_context *cxt,
			      int id,
			      char **data)
{
	char *p = NULL;
	int rc = 0;
	uint64_t x;

	if (!pa || !cxt || !data)
		return -EINVAL;

	switch (id) {
	case FDISK_FIELD_DEVICE:
		if (pa->freespace)
			p = xstrdup("Free space");
		else if (fdisk_partition_has_partno(pa) && cxt->dev_path) {
			if (cxt->label->flags & FDISK_LABEL_FL_INCHARS_PARTNO)
				p = xasprintf("%c", (int) pa->partno + 'a');
			else
				p = fdisk_partname(cxt->dev_path, pa->partno + 1);
		}
		break;
	case FDISK_FIELD_BOOT:
		p = fdisk_partition_is_bootable(pa) ? xstrdup("*") : NULL;
		break;
	case FDISK_FIELD_START:
		if (fdisk_partition_has_start(pa)) {
			x = fdisk_cround(cxt, pa->start);
			p = pa->start_post ?
				xasprintf("%"PRIu64"%c", x, pa->start_post) :
				xasprintf("%"PRIu64, x);
		}
		break;
	case FDISK_FIELD_END:
		if (fdisk_partition_has_end(pa)) {
			x = fdisk_cround(cxt, fdisk_partition_get_end(pa));
			p = pa->end_post ?
					xasprintf("%"PRIu64"%c", x, pa->end_post) :
					xasprintf("%"PRIu64, x);
		}
		break;
	case FDISK_FIELD_SIZE:
		if (fdisk_partition_has_size(pa)) {
			uint64_t sz = pa->size * cxt->sector_size;

			switch (cxt->sizeunit) {
			case FDISK_SIZEUNIT_BYTES:
				p = xasprintf("%"PRIu64"", sz);
				break;
			case FDISK_SIZEUNIT_HUMAN:
				if (fdisk_is_details(cxt))
					p = pa->size_post ?
							xasprintf("%"PRIu64"%c", sz, pa->size_post) :
							xasprintf("%"PRIu64, sz);
				else {
					char sths_buf[SIZE_TO_HUMAN_STRING_BUFSIZ];
					size_to_human_string(SIZE_SUFFIX_1LETTER, sz, sths_buf);
					p = xstrdup(sths_buf);
				}
				break;
			}
		}
		break;
	case FDISK_FIELD_CYLINDERS:
	{
		uintmax_t sz = fdisk_partition_has_size(pa) ? pa->size : 0;
		if (sz)
			/* Why we need to cast that to uintmax_t? */
			p = xasprintf("%ju", (uintmax_t)(sz / (cxt->geom.heads * cxt->geom.sectors)) + 1);
		break;
	}
	case FDISK_FIELD_SECTORS:
		p = xasprintf("%ju", fdisk_partition_has_size(pa) ? (uintmax_t) pa->size : 0);
		break;
	case FDISK_FIELD_BSIZE:
		p = xasprintf("%"PRIu64, pa->bsize);
		break;
	case FDISK_FIELD_FSIZE:
		p = xasprintf("%"PRIu64, pa->fsize);
		break;
	case FDISK_FIELD_CPG:
		p = xasprintf("%"PRIu64, pa->cpg);
		break;
	case FDISK_FIELD_TYPE:
		p = pa->type && pa->type->name ? xstrdup(pa->type->name) : NULL;
		break;
	case FDISK_FIELD_TYPEID:
		if (pa->type && fdisk_parttype_get_string(pa->type))
			p = xasprintf("%s", fdisk_parttype_get_string(pa->type));
		else if (pa->type)
			p = xasprintf("%x", fdisk_parttype_get_code(pa->type));
		break;
	case FDISK_FIELD_UUID:
		p = pa->uuid && *pa->uuid? xstrdup(pa->uuid) : NULL;
		break;
	case FDISK_FIELD_NAME:
		p = pa->name && *pa->name ? xstrdup(pa->name) : NULL;
		break;
	case FDISK_FIELD_ATTR:
		p = pa->attrs && *pa->attrs ? xstrdup(pa->attrs) : NULL;
		break;
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	case FDISK_FIELD_SADDR:
		p = pa->start_chs && *pa->start_chs ? xstrdup(pa->start_chs) : NULL;
		break;
	case FDISK_FIELD_EADDR:
		p = pa->end_chs && *pa->end_chs? xstrdup(pa->end_chs) : NULL;
		break;
#endif
	case FDISK_FIELD_FSUUID:
		if (pa->fs_probed || probe_partition_content(cxt, pa) == 0)
			p = pa->fsuuid && *pa->fsuuid ? xstrdup(pa->fsuuid) : NULL;
		break;
	case FDISK_FIELD_FSLABEL:
		if (pa->fs_probed || probe_partition_content(cxt, pa) == 0)
			p = pa->fslabel && *pa->fslabel ? xstrdup(pa->fslabel) : NULL;
		break;
	case FDISK_FIELD_FSTYPE:
		if (pa->fs_probed || probe_partition_content(cxt, pa) == 0)
			p = pa->fstype && *pa->fstype ? xstrdup(pa->fstype) : NULL;
		break;
	default:
		return -EINVAL;
	}

	if (rc < 0) {
		rc = -ENOMEM;
		free(p);
		p = NULL;

	} else if (rc > 0)
		rc = 0;

	*data = p;

	return rc;
}



#if defined(CONFIG_FEATURE_GPT_LABEL) && defined(CONFIG_FEATURE_FDISK_ADVANCED)
static struct fdisk_partition *resize_get_by_offset(
			struct fdisk_table *tb, fdisk_sector_t off)
{
	struct fdisk_partition *pa = NULL;
	struct fdisk_iter itr;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);

	while (fdisk_table_next_partition(tb, &itr, &pa) == 0) {
		if (!fdisk_partition_has_start(pa) || !fdisk_partition_has_size(pa))
			continue;
		if (off >= pa->start && off < pa->start + pa->size)
			return pa;
	}

	return NULL;
}

static inline int fdisk_partition_is_freespace(struct fdisk_partition *pa)
{
	return pa && pa->freespace;
}

/* Verify that area addressed by @start is freespace or the @cur[rent]
 * partition and continue to the next table entries until it's freespace, and
 * counts size of all this space.
 *
 * This is core of the partition start offset move operation. We can move the
 * start within the current partition of to the another free space. It's
 * forbidden to move start of the partition to another already defined
 * partition. */
static int resize_get_last_possible(
			struct fdisk_table *tb,
			struct fdisk_partition *cur,
			fdisk_sector_t start,
			fdisk_sector_t *maxsz)
{
	struct fdisk_partition *pa = NULL, *last = NULL;
	struct fdisk_iter itr;

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);

	*maxsz = 0;

	while (fdisk_table_next_partition(tb, &itr, &pa) == 0) {

		if (!fdisk_partition_has_start(pa) ||
		    !fdisk_partition_has_size(pa) ||
		    (fdisk_partition_is_container(pa) && pa != cur))
			continue;

		if (fdisk_partition_is_nested(pa)
		    && fdisk_partition_is_container(cur)
		    && pa->parent_partno == cur->partno)
			continue;

		/* The current is nested, free space has to be nested within the same parent */
		if (fdisk_partition_is_nested(cur)
		    && pa->parent_partno != cur->parent_partno)
			continue;

		if (!last) {
			if (start >= pa->start &&  start < pa->start + pa->size) {
				if (fdisk_partition_is_freespace(pa) || pa == cur) {
					last = pa;
				} else {
					break;
				}


				*maxsz = pa->size - (start - pa->start);
			}
		} else if (!fdisk_partition_is_freespace(pa) && pa != cur) {
			break;
		} else {
			last = pa;
			*maxsz = pa->size - (start - pa->start);
		}
	}

	return last ? 0 : -1;
}

/* Uses template @tpl to recount start and size change of the partition @res. The
 * @tpl->size and @tpl->start are interpreted as relative to the current setting. */
static int recount_resize(struct fdisk_context *cxt, size_t partno,
			struct fdisk_partition *res, struct fdisk_partition *tpl)
{
	fdisk_sector_t start, size, xsize;
	struct fdisk_partition *cur = NULL;
	struct fdisk_table *tb = NULL;
	int rc;

	FDISK_INIT_UNDEF(start);
	FDISK_INIT_UNDEF(size);

	rc = fdisk_get_partitions(cxt, &tb);
	if (!rc)
		rc = fdisk_get_freespaces(cxt, &tb);
	if (rc)
		return rc;

	fdisk_table_sort_partitions(tb, fdisk_partition_cmp_start);

	cur = fdisk_table_get_partition_by_partno(tb, partno);
	if (!cur) {
		fdisk_unref_table(tb);
		return -EINVAL;
	}

	/* 1a) set new start - change relative to the current on-disk setting */
	if (tpl->movestart && fdisk_partition_has_start(tpl)) {
		start = fdisk_partition_get_start(cur);
		if (tpl->movestart == FDISK_MOVE_DOWN) {
			if (fdisk_partition_get_start(tpl) > start)
				goto erange;
			start -= fdisk_partition_get_start(tpl);
		} else
			start += fdisk_partition_get_start(tpl);

	/* 1b) set new start - absolute number */
	} else if (fdisk_partition_has_start(tpl)) {
		start = fdisk_partition_get_start(tpl);
	}

	/* 2) verify that start is within the current partition or any freespace area */
	if (!FDISK_IS_UNDEF(start)) {
		struct fdisk_partition *area = resize_get_by_offset(tb, start);
		if (area == cur)
			;
		else if (area && fdisk_partition_is_freespace(area))
			;
		else if (!area && start >= cxt->first_lba && start < cxt->first_lba + (cxt->grain / cxt->sector_size))
			;
		else
			goto erange;
	} else {
		/* no change, start points to the current partition */
		start = fdisk_partition_get_start(cur);
	}

	/* 3a) set new size -- reduce */
	if (tpl->resize == FDISK_RESIZE_REDUCE && fdisk_partition_has_size(tpl)) {
		size = fdisk_partition_get_size(cur);
		if (fdisk_partition_get_size(tpl) > size)
			goto erange;
		size -= fdisk_partition_get_size(tpl);

	/* 3b) set new size -- enlarge */
	} else if (tpl->resize == FDISK_RESIZE_ENLARGE && fdisk_partition_has_size(tpl)) {
		size = fdisk_partition_get_size(cur);
		size += fdisk_partition_get_size(tpl);

	/* 3c) set new size -- no size specified, enlarge to all freespace */
	} else if (tpl->resize == FDISK_RESIZE_ENLARGE) {
		if (resize_get_last_possible(tb, cur, start, &size))
			goto erange;

	/* 3d) set new size -- absolute number */
	} else if (fdisk_partition_has_size(tpl)) {
		size = fdisk_partition_get_size(tpl);
	}

	/* 4) verify that size is within the current partition or next free space */
	xsize = !FDISK_IS_UNDEF(size) ? size : fdisk_partition_get_size(cur);

	if (fdisk_partition_has_size(cur)) {
		fdisk_sector_t maxsz;

		if (resize_get_last_possible(tb, cur, start, &maxsz))
			goto erange;
		if (xsize > maxsz)
			goto erange;
	}

	res->start = start;
	res->size = size;
	fdisk_unref_table(tb);
	return 0;
erange:
	fdisk_warnx(cxt, "Failed to resize partition #%zu.", partno + 1);
	fdisk_unref_table(tb);
	return -ERANGE;

}
#endif /* defined(CONFIG_FEATURE_GPT_LABEL) && defined(CONFIG_FEATURE_FDISK_ADVANCED) */

/* Enable/disable filesystems/RAIDs wiping in area defined by partition start and size.
 *
 * Returns: <0 in case of error, 0 on success */
static int fdisk_wipe_partition(struct fdisk_context *cxt, size_t partno, int enable)
{
	struct fdisk_partition *pa = NULL;
	int rc;

	rc = fdisk_get_partition(cxt, partno, &pa);
	if (rc)
		return rc;

	rc = fdisk_set_wipe_area(cxt, fdisk_partition_get_start(pa),
				      fdisk_partition_get_size(pa), enable);
	fdisk_unref_partition(pa);
	return rc < 0 ? rc : 0;
}

/* Returns: 1 if the area specified by @pa will be wiped by write command, or 0. */
static int fdisk_partition_has_wipe(struct fdisk_context *cxt, struct fdisk_partition *pa)
{
	return fdisk_has_wipe_area(cxt, fdisk_partition_get_start(pa),
					fdisk_partition_get_size(pa));
}

/* Deletes a @partno partition from disklabel. */
static int fdisk_delete_partition(struct fdisk_context *cxt, size_t partno)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->del_part)
		return -ENOSYS;

	fdisk_wipe_partition(cxt, partno, 0);

	return cxt->label->op->del_part(cxt, partno);
}

/* The fdisk_new_context() initializes all label drivers, and allocate
 * per-label specific data struct. This concept allows to store label specific
 * settings to the label driver independently on the currently active label
 * driver. Note that label struct cannot be deallocated, so there is no
 * reference counting for fdisk_label objects. All is destroyed by
 * fdisk_unref_context() only.
 *
 * Anyway, all label drives share in-memory first sector. The function
 * fdisk_create_disklabel() overwrites this in-memory sector. But it's possible that
 * label driver also uses another buffers, for example GPT reads more sectors
 * from the device.
 *
 * All label operations are in-memory only, except fdisk_write_disklabel().
 *
 * All functions that use "struct fdisk_context" rather than "struct
 * fdisk_label" use the currently active label driver. */

static int fdisk_probe_labels(struct fdisk_context *cxt)
{
	size_t i;

	cxt->label = NULL;

	for (i = 0; i < cxt->nlabels; i++) {
		struct fdisk_label *lb = cxt->labels[i];
		struct fdisk_label *org = fdisk_get_label(cxt, NULL);
		int rc;

		if (!lb->op->probe)
			continue;
		if (lb->disabled)
			continue;

		cxt->label = lb;
		rc = lb->op->probe(cxt);
		cxt->label = org;

		if (rc != 1) {
			if (lb->op->deinit)
				lb->op->deinit(lb);     /* for sure */
			continue;
		}

		__fdisk_switch_label(cxt, lb);
		return 0;
	}

	return 1; /* not found */
}

/* This function returns the default fields for the label.
 *
 * Note that the set of the default fields depends on fdisk_enable_details()
 * function. If the details are enabled then this function usually returns more
 * fields.
 *
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_label_get_fields_ids(const struct fdisk_label *lb,
		struct fdisk_context *cxt,
		int **ids, size_t *nids)
{
	size_t i, n;
	int *c;

	if (!cxt || (!lb && !cxt->label))
		return -EINVAL;

	lb = cxt->label;
	if (!lb->fields || !lb->nfields)
		return -ENOSYS;
	c = zmalloc(lb->nfields * sizeof(int));
	for (n = 0, i = 0; i < lb->nfields; i++) {
		int id = lb->fields[i].id;

		if ((fdisk_is_details(cxt) &&
				(lb->fields[i].flags & FDISK_FIELDFL_EYECANDY))
		     || (!fdisk_is_details(cxt) &&
				(lb->fields[i].flags & FDISK_FIELDFL_DETAIL))
		     || (id == FDISK_FIELD_SECTORS &&
				 fdisk_use_cylinders(cxt))
		     || (id == FDISK_FIELD_CYLINDERS &&
				 !fdisk_use_cylinders(cxt)))
			continue;

		c[n++] = id;
	}
	if (ids)
		*ids = c;
	else
		free(c);
	if (nids)
		*nids = n;
	return 0;
}

/* This function returns all fields for the label.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_label_get_fields_ids_all(
		const struct fdisk_label *lb,
		struct fdisk_context *cxt,
		int **ids, size_t *nids)
{
	size_t i, n;
	int *c;

	if (!cxt || (!lb && !cxt->label))
		return -EINVAL;

	lb = cxt->label;
	if (!lb->fields || !lb->nfields)
		return -ENOSYS;
	c = zmalloc(lb->nfields * sizeof(int));
	for (n = 0, i = 0; i < lb->nfields; i++)
		c[n++] = lb->fields[i].id;
	if (ids)
		*ids = c;
	else
		free(c);
	if (nids)
		*nids = n;
	return 0;
}

/* The field struct describes data stored in struct fdisk_partition. The info
 * about data is usable for example to generate human readable output (e.g.
 * fdisk 'p'rint command). See fdisk_partition_to_string() and fdisk code.
 *
 * Returns: pointer to static instance of the field. */
static const struct fdisk_field *fdisk_label_get_field(const struct fdisk_label *lb, int id)
{
	size_t i;

	for (i = 0; i < lb->nfields; i++) {
		if (lb->fields[i].id == id)
			return &lb->fields[i];
	}

	return NULL;
}

/* Returns: pointer to static instance of the field. */
static const struct fdisk_field *fdisk_label_get_field_by_name(
				const struct fdisk_label *lb,
				const char *name)
{
	size_t i;

	for (i = 0; i < lb->nfields; i++) {
		if (lb->fields[i].name && strcasecmp(lb->fields[i].name, name) == 0)
			return &lb->fields[i];
	}

	return NULL;
}


/* Verifies the partition table.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_verify_disklabel(struct fdisk_context *cxt)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->verify)
		return -ENOSYS;
	if (fdisk_missing_geometry(cxt))
		return -EINVAL;

	return cxt->label->op->verify(cxt);
}

/* Note that @id is always in range 0..N. It's fine to use the function in loop
 * until it returns error or 2, the result in @item should be ignored when
 * function returns 1. Don't forget to use fdisk_reset_labelitem().
 *
 * Returns: 0 on success, < 0 on error, 1 on unsupported item, 2 id out of range */
static int fdisk_get_disklabel_item(struct fdisk_context *cxt, int id, struct fdisk_labelitem *item)
{
	if (!cxt || !cxt->label || !item)
		return -EINVAL;

	fdisk_reset_labelitem(item);
	item->id = id;

	if (!cxt->label->op->get_item)
		return -ENOSYS;

	return cxt->label->op->get_item(cxt, item);
}

/* Lists details about disklabel, but no partitions.
 *
 * This function is based on fdisk_get_disklabel_item() and prints all label
 * specific information by ASK interface (FDISK_ASKTYPE_INFO, aka fdisk_info()).
 * The function requires enabled "details" by fdisk_enable_details().
 *
 * It's recommended to use fdisk_get_disklabel_item() if you need better
 * control on output and formatting.
 *
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_list_disklabel(struct fdisk_context *cxt)
{
	int id = 0, rc = 0;
	struct fdisk_labelitem item = { .id = id };

	if (!cxt || !cxt->label)
		return -EINVAL;

	if (!cxt->display_details)
		return 0;

	/* List all label items */
	do {
		/* rc: < 0 error, 0 success, 1 unknown item, 2 out of range */
		rc = fdisk_get_disklabel_item(cxt, id++, &item);
		if (rc != 0)
			continue;
		switch (item.type) {
		case 'j':
			fdisk_info(cxt, "%s: %ju", item.name, item.data.num64);
			break;
		case 's':
			if (item.data.str && item.name)
				fdisk_info(cxt, "%s: %s", item.name, item.data.str);
			break;
		}
		fdisk_reset_labelitem(&item);
	} while (rc == 0 || rc == 1);

	return rc < 0 ? rc : 0;
}

/* Resets and discovery topology (I/O limits), geometry, re-read the first
 * rector on the device if necessary and apply user device setting (geometry
 * and sector size), then initialize alignment according to label driver (see
 * fdisk_reset_alignment()).
 *
 * You don't have to use this function by default, fdisk_assign_device() is
 * smart enough to initialize all necessary setting.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_reset_device_properties(struct fdisk_context *cxt)
{
	int rc;

	if (!cxt)
		return -EINVAL;

	fdisk_zeroize_device_properties(cxt);
	fdisk_discover_topology(cxt);
	fdisk_discover_geometry(cxt);

	rc = fdisk_read_firstsector(cxt);
	if (rc)
		return rc;

	fdisk_apply_user_device_properties(cxt);
	return 0;
}

/* Please don't call this function if there is already a PT.
 *
 * Returns: 0 if nothing found, < 0 on error, 1 if found a signature */
#ifndef CONFIG_FEATURE_LIBBLKID
static inline int fdisk_check_collisions(struct fdisk_context *cxt __attribute__((__unused__)))
{
	return 0;
}
#else
/* Enables/disables the partitions probing for non-binary interface.
 *
 * Returns: 0 on success, or -1 in case of error. */
static int blkid_probe_enable_partitions(blkid_probe pr, int enable)
{
	pr->chains[BLKID_CHAIN_PARTS].enabled = enable;
	return 0;
}

static int fdisk_check_collisions(struct fdisk_context *cxt)
{
	int rc = 0;
	blkid_probe pr;

	pr = blkid_new_probe();
	rc = blkid_probe_set_device(pr, cxt->dev_fd, 0, 0);
	if (rc)
		return rc;

	cxt->pt_collision = 0;
	free(cxt->collision);
	cxt->collision = NULL;

	blkid_probe_enable_superblocks(pr, 1);
	blkid_probe_set_superblocks_flags(pr, BLKID_SUBLKS_TYPE);
	blkid_probe_enable_partitions(pr, 1);

	/* we care about the first found FS/raid, so don't call blkid_do_probe()
	 * in loop or don't use blkid_do_fullprobe() ... */
	rc = blkid_do_probe(pr);
	if (rc == 0) {
		const char *name = NULL;

		if (blkid_probe_lookup_value(pr, "TYPE", &name, 0) == 0)
			cxt->collision = xstrdup(name);
		else if (blkid_probe_lookup_value(pr, "PTTYPE", &name, 0) == 0) {
			cxt->collision = xstrdup(name);
			cxt->pt_collision = 1;
		}

		if (name && !cxt->collision)
			rc = -ENOMEM;
	}

	blkid_free_probe(pr);
	return rc;
}
#endif

/* Creates a new disk label of type @name. If @name is NULL, then it will
 * create a default system label type, either SUN or DOS. The function
 * automatically switches the current label driver to @name. The function
 * fdisk_get_label() returns the current label driver.
 *
 * The function modifies in-memory data only.
 *
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_create_disklabel(struct fdisk_context *cxt, const char *name)
{
	int haslabel = 0;
	struct fdisk_label *lb;

	if (!cxt)
		return -EINVAL;

	if (!name) { /* use default label creation */
#ifdef __sparc__
		name = "sun";
#else
		name = "dos";
#endif
	}

	if (cxt->label) {
		fdisk_deinit_label(cxt->label);
		haslabel = 1;
	}

	lb = fdisk_get_label(cxt, name);
	if (!lb || lb->disabled)
		return -EINVAL;

	if (!haslabel || (lb && cxt->label != lb))
		fdisk_check_collisions(cxt);

	if (!lb->op->create)
		return -ENOSYS;

	__fdisk_switch_label(cxt, lb);

	if (haslabel && !cxt->parent)
		fdisk_reset_device_properties(cxt);

	return lb->op->create(cxt);
}

#ifdef CONFIG_FEATURE_FDISK_ADVANCED
/* Locate disklabel and returns info about @n item of the label. For example
 * GPT is composed from two items, PMBR and GPT, n=0 return offset to PMBR and n=1
 * return offset to GPT. For more details see 'D' expert fdisk command.
 *
 * Returns: 0 on success, <0 on error, 1 no more items. */
static int fdisk_locate_disklabel(struct fdisk_context *cxt, int n, const char **name,
			   uint64_t *offset, size_t *size)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->locate)
		return -ENOSYS;

	return cxt->label->op->locate(cxt, n, name, offset, size);
}
#endif

static int fdisk_get_disklabel_id(struct fdisk_context *cxt, char **id)
{
	struct fdisk_labelitem item = FDISK_LABELITEM_INIT;
	int rc;

	if (!cxt || !cxt->label || !id)
		return -EINVAL;

	rc = fdisk_get_disklabel_item(cxt, FDISK_LABELITEM_ID, &item);
	if (rc == 0) {
		*id = item.data.str;
		item.data.str = NULL;
	}
	fdisk_reset_labelitem(&item);
	if (rc > 0)
		rc = 0;
	return rc;
}


/* Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_set_disklabel_id(struct fdisk_context *cxt)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->set_id)
		return -ENOSYS;

	return cxt->label->op->set_id(cxt);
}

static int fdisk_set_partition_type(struct fdisk_context *cxt,
			     size_t partnum,
			     struct fdisk_parttype *t)
{
	if (!cxt || !cxt->label || !t)
		return -EINVAL;


	if (cxt->label->op->set_part) {
		struct fdisk_partition *pa = fdisk_new_partition();
		int rc;

		fdisk_partition_set_type(pa, t);

		rc = cxt->label->op->set_part(cxt, partnum, pa);
		fdisk_unref_partition(pa);
		return rc;
	}

	return -ENOSYS;
}

static int fdisk_toggle_partition_flag(struct fdisk_context *cxt,
			       size_t partnum,
			       unsigned long flag)
{
	int rc;

	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->part_toggle_flag)
		return -ENOSYS;

	rc = cxt->label->op->part_toggle_flag(cxt, partnum, flag);

	return rc;
}

#ifdef CONFIG_FEATURE_FDISK_ADVANCED
/* Sort partitions according to the partition start sector.
 * Returns: 0 on success, 1 reorder unnecessary, otherwise a corresponding error. */
static int fdisk_reorder_partitions(struct fdisk_context *cxt)
{
	if (!cxt || !cxt->label)
		return -EINVAL;
	if (!cxt->label->op->reorder)
		return -ENOSYS;

	return cxt->label->op->reorder(cxt);
}
#endif


/* Marks in-memory data as changed, to force fdisk_write_disklabel() to write
 * to device. This should be unnecessary by default, the library keeps track
 * about changes. */
static inline void fdisk_label_set_changed1(struct fdisk_label *lb)
{
	lb->changed = 1;
}

/* Returns: 1 if in-memory data has been changed. */
static inline int fdisk_label_is_changed(const struct fdisk_label *lb)
{
	return lb ? lb->changed : 0;
}

/* Mark label as disabled, then libfdisk is going to ignore the label when
 * probe device for labels. */
static inline void fdisk_label_set_disabled(struct fdisk_label *lb, int disabled)
{
	lb->disabled = disabled ? 1 : 0;
}

/* The function provides minimal and maximal geometry supported for the label,
 * if no range defined by library than returns -ENOSYS.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_label_get_geomrange_sectors(const struct fdisk_label *lb,
					fdisk_sector_t *mi, fdisk_sector_t *ma)
{
	if (!lb || lb->geom_min.sectors == 0)
		return -ENOSYS;
	if (mi)
		*mi = lb->geom_min.sectors;
	if (ma)
		*ma = lb->geom_max.sectors;
	return 0;
}

/* The function provides minimal and maximal geometry supported for the label,
 * if no range defined by library than returns -ENOSYS.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_label_get_geomrange_heads(const struct fdisk_label *lb,
					unsigned int *mi, unsigned int *ma)
{
	if (!lb || lb->geom_min.heads == 0)
		return -ENOSYS;
	if (mi)
		*mi = lb->geom_min.heads;
	if (ma)
		*ma = lb->geom_max.heads;
	return 0;
}

/* The function provides minimal and maximal geometry supported for the label,
 * if no range defined by library than returns -ENOSYS.
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_label_get_geomrange_cylinders(const struct fdisk_label *lb,
					fdisk_sector_t *mi, fdisk_sector_t *ma)
{
	if (!lb || lb->geom_min.cylinders == 0)
		return -ENOSYS;
	if (mi)
		*mi = lb->geom_min.cylinders;
	if (ma)
		*ma = lb->geom_max.cylinders;
	return 0;
}

static inline int wipemode_from_string(const char *str)
{
	size_t i;
	static const char * const modes[] = {
		[WIPEMODE_AUTO]   = "auto",
		[WIPEMODE_NEVER]  = "never",
		[WIPEMODE_ALWAYS] = "always"
	};

	if (!str || !*str)
		return -EINVAL;

	for (i = 0; i < ARRAY_SIZE(modes); i++) {
		if (strcasecmp(str, modes[i]) == 0)
			return i;
	}

	return -EINVAL;
}

#ifdef CONFIG_FEATURE_LIBBLKID
static int is_ide_cdrom_or_tape(char *device)
{
	int fd, ret;

	if ((fd = open(device, O_RDONLY)) < 0)
		return 0;
	ret = blkdev_is_cdrom(fd);

	close(fd);
	return ret;
}
#endif

static void list_disk_identifier(struct fdisk_context *cxt)
{
	struct fdisk_label *lb = fdisk_get_label(cxt, NULL);
	char *id = NULL;

	if (fdisk_has_label(cxt))
		fdisk_info(cxt, "Disklabel type: %s", fdisk_label_get_name(lb));

	if (!fdisk_is_details(cxt) && fdisk_get_disklabel_id(cxt, &id) == 0 && id) {
		fdisk_info(cxt, "Disk identifier: %s", id);
		free(id);
	}
}

static void list_disk_geometry(struct fdisk_context *cxt)
{
	struct fdisk_label *lb = fdisk_get_label(cxt, NULL);
	uint64_t bytes = fdisk_get_nsectors(cxt) * fdisk_get_sector_size(cxt);
	char sths_buf[SIZE_TO_HUMAN_STRING_BUFSIZ];

	size_to_human_string(SIZE_SUFFIX_SPACE | SIZE_SUFFIX_3LETTER, bytes, sths_buf);

	color_scheme_enable("header", UL_COLOR_BOLD);
	fdisk_info(cxt, "Disk %s: %s, %ju bytes, %ju sectors",
			fdisk_get_devname(cxt), sths_buf,
			bytes, (uintmax_t) fdisk_get_nsectors(cxt));
	color_disable();

	if (fdisk_get_devmodel(cxt))
		fdisk_info(cxt, "Disk model: %s", fdisk_get_devmodel(cxt));

	if (lb && (fdisk_label_require_geometry(lb) || fdisk_use_cylinders(cxt)))
		fdisk_info(cxt, "Geometry: %d heads, %llu sectors/track, %llu cylinders",
			       fdisk_get_geom_heads(cxt),
			       fdisk_get_geom_sectors(cxt),
			       fdisk_get_geom_cylinders(cxt));

	fdisk_info(cxt, "Units: %s of %d * %ld = %ld bytes",
	       fdisk_get_unit(cxt, FDISK_PLURAL),
	       fdisk_get_units_per_sector(cxt),
	       fdisk_get_sector_size(cxt),
	       fdisk_get_units_per_sector(cxt) * fdisk_get_sector_size(cxt));

	fdisk_info(cxt, "Sector size (logical/physical): %lu bytes / %lu bytes",
				fdisk_get_sector_size(cxt),
				fdisk_get_physector_size(cxt));
	fdisk_info(cxt, "I/O size (minimum/optimal): %lu bytes / %lu bytes",
				fdisk_get_minimal_iosize(cxt),
				fdisk_get_optimal_iosize(cxt));
	if (fdisk_get_alignment_offset(cxt))
		fdisk_info(cxt, "Alignment offset: %lu bytes",
				fdisk_get_alignment_offset(cxt));

	list_disk_identifier(cxt);
}

static int fieldname_to_id(const char *name, size_t namesz)
{
	const struct fdisk_field *fl;
	char buf[namesz + 1];

	memcpy(buf, name, namesz);
	buf[namesz] = '\0';

	fl = fdisk_label_get_field_by_name(fields_label, buf);
	if (!fl) {
		bb_error_msg("%s unknown column: %s", fdisk_label_get_name(fields_label), buf);
		return -1;
	}
	return fdisk_field_get_id(fl);
}

/* Initialize array with output columns (fields_ids[]) according to
 * comma delimited list of columns (@str). If the list string is not
 * defined then use library defaults. This function is "-o <list>"
 * backend.
 *
 * If the columns are already initialized then returns already existing columns. */
static int *init_fields(struct fdisk_context *cxt, const char *str, size_t *n)
{
	int *dflt_ids = NULL;
	struct fdisk_label *lb;

	if (!fields_string)
		fields_string = str;
	if (!cxt)
	       goto done;

	lb = fdisk_get_label(cxt, NULL);

	if (!lb || fields_label != lb) {        /* label changed: reset */
		free(fields_ids);
		fields_ids = NULL;
		fields_label = lb;
		fields_nids = 0;
	}

	if (!fields_label)      /*  no label */
		goto done;
	if (fields_nids)
		goto done;      /* already initialized */

	/* library default */
	if (fdisk_label_get_fields_ids(NULL, cxt, &dflt_ids, &fields_nids))
		goto done;

	fields_ids = zmalloc(FDISK_NFIELDS * sizeof(int) * 2);

	/* copy defaults to the list with wanted fields */
	memcpy(fields_ids, dflt_ids, fields_nids * sizeof(int));
	free(dflt_ids);

	/* extend or replace fields_nids[] according to fields_string */
	if (fields_string &&
	    string_add_to_idarray(fields_string, fields_ids, FDISK_NFIELDS * 2,
				  &fields_nids, fieldname_to_id) < 0)
		exit(EXIT_FAILURE);
done:
	fields_label = NULL;
	if (n)
		*n = fields_nids;
	return fields_ids;
}

static void list_disklabel(struct fdisk_context *cxt)
{
	struct fdisk_table *tb = NULL;
	struct fdisk_partition *pa = NULL;
	struct fdisk_iter *itr = NULL;
	struct fdisk_label *lb;
	struct libscols_table *out = NULL;
	const char *bold = NULL;
	int *ids = NULL;                /* IDs of fdisk_fields */
	size_t  nids = 0, i;
	int post = 0;

	/* print label specific stuff by libfdisk FDISK_ASK_INFO API */
	fdisk_list_disklabel(cxt);

	/* get partitions and generate output */
	if (fdisk_get_partitions(cxt, &tb) || fdisk_table_get_nents(tb) <= 0)
		goto done;

	ids = init_fields(cxt, NULL, &nids);
	if (!ids)
		goto done;

	itr = fdisk_new_iter(FDISK_ITER_FORWARD);
	if (!itr) {
		fdisk_warn(cxt, "failed to allocate iterator");
		goto done;
	}

	out = scols_new_table();
	if (colors_wanted()) {
		scols_table_enable_colors(out, 1);
		bold = color_scheme_get_sequence("header", UL_COLOR_BOLD);
	}

	lb = fdisk_get_label(cxt, NULL);

	/* define output table columns */
	for (i = 0; i < nids; i++) {
		int fl = 0;
		struct libscols_column *co;
		const struct fdisk_field *field =
				fdisk_label_get_field(lb, ids[i]);
		if (!field)
			continue;
		if (fdisk_field_is_number(field))
			fl |= SCOLS_FL_RIGHT;
		if (fdisk_field_get_id(field) == FDISK_FIELD_TYPE)
			fl |= SCOLS_FL_TRUNC;

		co = scols_table_new_column(out,
				fdisk_field_get_name(field),
				fdisk_field_get_width(field), fl);
		if (!co)
			goto done;

		/* set column header color */
		if (bold)
			scols_cell_set_color(scols_column_get_header(co), bold);
	}

	/* fill-in output table */
	while (fdisk_table_next_partition(tb, itr, &pa) == 0) {
		struct libscols_line *ln = scols_table_new_line(out, NULL);

		if (!ln) {
			fdisk_warn(cxt, "failed to allocate output line");
			goto done;
		}

		for (i = 0; i < nids; i++) {
			char *data = NULL;

			if (fdisk_partition_to_string(pa, cxt, ids[i], &data))
				continue;
			if (scols_line_refer_data(ln, i, data)) {
				fdisk_warn(cxt, "failed to add output data");
				goto done;
			}
		}
	}

	/* print */
	if (!scols_table_is_empty(out)) {
		fdisk_info(cxt, "");    /* just line break */
		scols_print_table(out);
	}

	/* print warnings */
	fdisk_reset_iter(itr, FDISK_ITER_FORWARD);
	while (itr && fdisk_table_next_partition(tb, itr, &pa) == 0) {
		if (!fdisk_partition_has_start(pa))
			continue;
		if (!fdisk_lba_is_phy_aligned(cxt, fdisk_partition_get_start(pa))) {
			if (!post)
				fdisk_info(cxt, ""); /* line break */
			fdisk_warnx(cxt, "Partition %zu does not start on physical sector boundary.",
					  fdisk_partition_get_partno(pa) + 1);
			post++;
		}
		if (fdisk_partition_has_wipe(cxt, pa)) {
			if (!post)
				fdisk_info(cxt, ""); /* line break */
			 fdisk_info(cxt, "Filesystem/RAID signature on partition %zu will be wiped.",
					 fdisk_partition_get_partno(pa) + 1);
			 post++;
		}
	}

	if (fdisk_table_wrong_order(tb)) {
		if (!post)
			fdisk_info(cxt, ""); /* line break */
		fdisk_info(cxt, "Partition table entries are not in disk order.");
	}
done:
	scols_unref_table(out);
	fdisk_unref_table(tb);
	fdisk_free_iter(itr);
}

static void list_freespace(struct fdisk_context *cxt)
{
	struct fdisk_table *tb = NULL;
	struct fdisk_partition *pa = NULL;
	struct fdisk_iter *itr = NULL;
	struct libscols_table *out = NULL;
	const char *bold = NULL;
	size_t i;
	uintmax_t sumsize = 0, bytes = 0;
	char sths_buf[SIZE_TO_HUMAN_STRING_BUFSIZ];

	static const char * const colnames[] = { "Start", "End", "Sectors", "Size" };
	static const int colids[] = { FDISK_FIELD_START, FDISK_FIELD_END, FDISK_FIELD_SECTORS, FDISK_FIELD_SIZE };

	if (fdisk_get_freespaces(cxt, &tb))
		goto done;

	itr = fdisk_new_iter(FDISK_ITER_FORWARD);
	if (!itr) {
		fdisk_warn(cxt, "failed to allocate iterator");
		goto done;
	}

	out = scols_new_table();
	if (colors_wanted()) {
		scols_table_enable_colors(out, 1);
		bold = color_scheme_get_sequence("header", UL_COLOR_BOLD);
	}

	for (i = 0; i < ARRAY_SIZE(colnames); i++) {
		struct libscols_column *co = scols_table_new_column(out, colnames[i], 5, SCOLS_FL_RIGHT);

		if (!co)
			goto done;
		if (bold)
			scols_cell_set_color(scols_column_get_header(co), bold);
	}

	/* fill-in output table */
	while (fdisk_table_next_partition(tb, itr, &pa) == 0) {
		struct libscols_line *ln = scols_table_new_line(out, NULL);
		char *data;

		if (!ln) {
			fdisk_warn(cxt, "failed to allocate output line");
			goto done;
		}
		for (i = 0; i < ARRAY_SIZE(colids); i++) {
			if (fdisk_partition_to_string(pa, cxt, colids[i], &data))
				continue;
			if (scols_line_refer_data(ln, i, data)) {
				fdisk_warn(cxt, "failed to add output data");
				goto done;
			}
		}

		if (fdisk_partition_has_size(pa))
			sumsize += fdisk_partition_get_size(pa);
	}

	bytes = sumsize * fdisk_get_sector_size(cxt);
	size_to_human_string(SIZE_SUFFIX_SPACE | SIZE_SUFFIX_3LETTER, bytes, sths_buf);

	color_scheme_enable("header", UL_COLOR_BOLD);
	fdisk_info(cxt, "Unpartitioned space %s: %s, %ju bytes, %ju sectors",
			fdisk_get_devname(cxt), sths_buf,
			bytes, sumsize);
	color_disable();

	fdisk_info(cxt, "Units: %s of %d * %ld = %ld bytes",
	       fdisk_get_unit(cxt, FDISK_PLURAL),
	       fdisk_get_units_per_sector(cxt),
	       fdisk_get_sector_size(cxt),
	       fdisk_get_units_per_sector(cxt) * fdisk_get_sector_size(cxt));

	fdisk_info(cxt, "Sector size (logical/physical): %lu bytes / %lu bytes",
				fdisk_get_sector_size(cxt),
				fdisk_get_physector_size(cxt));

	/* print */
	if (!scols_table_is_empty(out)) {
		fdisk_info(cxt, "");    /* line break */
		scols_print_table(out);
	}
done:
	scols_unref_table(out);
	fdisk_unref_table(tb);
	fdisk_free_iter(itr);
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* Return 0 or 1, or < 0 in case of error */
static int sysfs_devno_is_wholedisk(dev_t devno)
{
	dev_t disk;

	if (sysfs_devno_to_wholedisk(devno, NULL, 0, &disk) != 0)
		return -1;

	return devno == disk;
}

static char *next_proc_partition(FILE **f)
{
	char line[128 + 1];

	if (!*f) {
		*f = fopen(_PATH_PROC_PARTITIONS, "r");
		if (!*f) {
			bb_perror_msg("cannot open %s", _PATH_PROC_PARTITIONS);
			return NULL;
		}
	}

	while (fgets(line, sizeof(line), *f)) {
		char buf[PATH_MAX], *cn;
		dev_t devno;

		if (sscanf(line, " %*d %*d %*d %128[^\n ]", buf) != 1)
			continue;

		devno = sysfs_devname_to_devno(buf);
		if (devno <= 0)
			continue;

		if (sysfs_devno_is_dm_private(devno, NULL) ||
		    sysfs_devno_is_wholedisk(devno) <= 0)
			continue;

		if (!sysfs_devno_to_devpath(devno, buf, sizeof(buf)))
			continue;

		cn = canonicalize_path(buf);
		if (!cn)
			continue;

		if (!is_ide_cdrom_or_tape(cn))
			return cn;
	}
	fclose(*f);
	*f = NULL;

	return NULL;
}
#endif

/* Open the device, discovery topology, geometry, detect disklabel and switch
 * the current label driver to reflect the probing result.
 *
 * Note that this function resets all generic setting in context. If the @cxt
 * is nested context then the device is assigned to the parental context and
 * necessary properties are copied to the @cxt. The change is propagated in
 * child->parent direction only. It's impossible to use a different device for
 * primary and nested contexts.
 *
 * Returns: 0 on success, < 0 on error. */
static int fdisk_assign_device(struct fdisk_context *cxt,
			const char *fname, int readonly)
{
	int fd;

	/* redirect request to parent */
	if (cxt->parent) {
		int rc, org = fdisk_is_listonly(cxt->parent);

		/* assign_device() is sensitive to "listonly" mode, so let's
		 * follow the current context setting for the parent to avoid
		 * unwanted extra warnings. */
		fdisk_enable_listonly(cxt->parent, fdisk_is_listonly(cxt));

		rc = fdisk_assign_device(cxt->parent, fname, readonly);
		fdisk_enable_listonly(cxt->parent, org);

		if (!rc) {
			init_nested_from_parent(cxt, 0);
			fdisk_probe_labels(cxt);
		}
		return rc;
	}

	reset_context(cxt);

	fd = open(fname, (readonly ? O_RDONLY : O_RDWR ) | O_CLOEXEC);
	if (fd < 0)
		goto fail;

	if (fstat(fd, &cxt->dev_st) != 0)
		goto fail;

	cxt->readonly = readonly;
	cxt->dev_fd = fd;
	cxt->dev_path = xstrdup(fname);
	fdisk_discover_topology(cxt);
	fdisk_discover_geometry(cxt);

	fdisk_apply_user_device_properties(cxt);

	if (fdisk_read_firstsector(cxt) < 0)
		goto fail;

	fdisk_probe_labels(cxt);

	fdisk_apply_label_device_properties(cxt);

	/* warn about obsolete stuff on the device if we aren't in
	 * list-only mode and there is not PT yet */
	if (!fdisk_is_listonly(cxt) && !fdisk_has_label(cxt)
	    && fdisk_check_collisions(cxt) < 0)
		goto fail;

	return 0;
fail:
	{
		int rc = -errno;
		if (fd >= 0)
			close(fd);
		return rc;
	}
}

static int print_device_pt(struct fdisk_context *cxt, char *device, int warnme, int verify)
{
	if (fdisk_assign_device(cxt, device, 1) != 0) { /* read-only */
		if (warnme || errno == EACCES)
			bb_perror_msg("cannot open %s", device);
		return -1;
	}

	list_disk_geometry(cxt);

	if (fdisk_has_label(cxt)) {
		list_disklabel(cxt);
		if (verify)
			fdisk_verify_disklabel(cxt);
	}
	fdisk_deassign_device(cxt, 1);
	return 0;
}

static void print_all_devices_pt(struct fdisk_context *cxt, int verify)
{
#ifdef CONFIG_FEATURE_LIBBLKID
	FILE *f = NULL;
	int ct = 0;
	char *dev;

	while ((dev = next_proc_partition(&f))) {
		if (ct)
			fputs("\n\n", stdout);
		if (print_device_pt(cxt, dev, 0, verify) == 0)
			ct++;
		free(dev);
	}
#else
	bb_error_msg_and_die("This version is small and unsupport list all devices");
#endif
}


#ifdef CONFIG_FEATURE_GPT_LABEL

/* GUID Partition Table (GPT) support. Based on UEFI Specs 2.3.1
 * Chapter 5: GUID Partition Table (GPT) Disk Layout (Jun 27th, 2012).
 * Some ideas and inspiration from GNU parted and gptfdisk. */

#define GPT_HEADER_REVISION_V1_02 0x00010200
#define GPT_HEADER_REVISION_V1_00 0x00010000
#define GPT_HEADER_REVISION_V0_99 0x00009900
#define GPT_HEADER_MINSZ          92 /* bytes */

#define GPT_PMBR_LBA        0
#define GPT_MBR_PROTECTIVE  1
#define GPT_MBR_HYBRID      2

#define GPT_PRIMARY_PARTITION_TABLE_LBA 0x00000001ULL

#define EFI_PMBR_OSTYPE     0xEE
#define MSDOS_MBR_SIGNATURE 0xAA55
#define GPT_PART_NAME_LEN   (72 / sizeof(uint16_t))
#define GPT_NPARTITIONS     FDISK_GPT_NPARTITIONS_DEFAULT

/* Globally unique identifier */
struct gpt_guid {
	uint32_t   time_low;
	uint16_t   time_mid;
	uint16_t   time_hi_and_version;
	uint8_t    clock_seq_hi;
	uint8_t    clock_seq_low;
	uint8_t    node[6];
};

/* Linux native partition type */
#define GPT_DEFAULT_ENTRY_TYPE "0FC63DAF-8483-4772-8E79-3D69D8477DE4"

/* Attribute bits */
enum {
	/* UEFI specific */
	GPT_ATTRBIT_REQ      = 0,
	GPT_ATTRBIT_NOBLOCK  = 1,
	GPT_ATTRBIT_LEGACY   = 2,

	/* GUID specific (range 48..64) */
	GPT_ATTRBIT_GUID_FIRST  = 48,
	GPT_ATTRBIT_GUID_COUNT  = 16
};

#define GPT_ATTRSTR_REQ         "RequiredPartition"
#define GPT_ATTRSTR_REQ_TYPO    "RequiredPartiton"
#define GPT_ATTRSTR_NOBLOCK     "NoBlockIOProtocol"
#define GPT_ATTRSTR_LEGACY      "LegacyBIOSBootable"

/* The GPT Partition entry array contains an array of GPT entries. */
struct gpt_entry {
	struct gpt_guid     type; /* purpose and type of the partition */
	struct gpt_guid     partition_guid;
	uint64_t            lba_start;
	uint64_t            lba_end;
	uint64_t            attrs;
	uint16_t            name[GPT_PART_NAME_LEN];
}  __attribute__ ((packed));

/* GPT header */
struct gpt_header {
	uint64_t            signature; /* header identification */
	uint32_t            revision; /* header version */
	uint32_t            size; /* in bytes */
	uint32_t            crc32; /* header CRC checksum */
	uint32_t            reserved1; /* must be 0 */
	uint64_t            my_lba; /* LBA of block that contains this struct (LBA 1) */
	uint64_t            alternative_lba; /* backup GPT header */
	uint64_t            first_usable_lba; /* first usable logical block for partitions */
	uint64_t            last_usable_lba; /* last usable logical block for partitions */
	struct gpt_guid     disk_guid; /* unique disk identifier */
	uint64_t            partition_entry_lba; /* LBA of start of partition entries array */
	uint32_t            npartition_entries; /* total partition entries - normally 128 */
	uint32_t            sizeof_partition_entry; /* bytes for each GUID pt */
	uint32_t            partition_entry_array_crc32; /* partition CRC checksum */
	uint8_t             reserved2[512 - 92]; /* must all be 0 */
} __attribute__ ((packed));

struct gpt_record {
	uint8_t             boot_indicator; /* unused by EFI, set to 0x80 for bootable */
	uint8_t             start_head; /* unused by EFI, pt start in CHS */
	uint8_t             start_sector; /* unused by EFI, pt start in CHS */
	uint8_t             start_track;
	uint8_t             os_type; /* EFI and legacy non-EFI OS types */
	uint8_t             end_head; /* unused by EFI, pt end in CHS */
	uint8_t             end_sector; /* unused by EFI, pt end in CHS */
	uint8_t             end_track; /* unused by EFI, pt end in CHS */
	uint32_t            starting_lba; /* used by EFI - start addr of the on disk pt */
	uint32_t            size_in_lba; /* used by EFI - size of pt in LBA */
} __attribute__ ((packed));

/* Protected MBR and legacy MBR share same structure */
struct gpt_legacy_mbr {
	uint8_t             boot_code[440];
	uint32_t            unique_mbr_signature;
	uint16_t            unknown;
	struct gpt_record   partition_record[4];
	uint16_t            signature;
} __attribute__ ((packed));

/* Here be dragons!
 * See: http://en.wikipedia.org/wiki/GUID_Partition_Table#Partition_type_GUIDs */
#define DEF_GUID(_u, _n) \
	{ \
		.typestr = (_u), \
		.name = (_n),    \
	}

/* Probably the most complete list of the GUIDs are at:
 *       https://wikipedia.org/wiki/GUID_Partition_Table */
static const struct fdisk_parttype gpt_parttypes[] =
{
	/* Generic OS */
	DEF_GUID("C12A7328-F81F-11D2-BA4B-00A0C93EC93B", "EFI System"),

	DEF_GUID("024DEE41-33E7-11D3-9D69-0008C781F39F", "MBR partition scheme"),
	DEF_GUID("D3BFE2DE-3DAF-11DF-BA40-E3A556D89593", "Intel Fast Flash"),

	/* Hah!IdontneedEFI */
	DEF_GUID("21686148-6449-6E6F-744E-656564454649", "BIOS boot"),

	/* NIH syndrome */
	DEF_GUID("F4019732-066E-4E12-8273-346C5641494F", "Sony boot partition"),
	DEF_GUID("BFBFAFE7-A34F-448A-9A5B-6213EB736C22", "Lenovo boot partition"),

	/* PowerPC reference platform boot partition */
	DEF_GUID("9E1A2D38-C612-4316-AA26-8B49521E5A8B", "PowerPC PReP boot"),

	/* Open Network Install Environment */
	DEF_GUID("7412F7D5-A156-4B13-81DC-867174929325", "ONIE boot"),
	DEF_GUID("D4E6E2CD-4469-46F3-B5CB-1BFF57AFC149", "ONIE config"),

	/* Windows */
	DEF_GUID("E3C9E316-0B5C-4DB8-817D-F92DF00215AE", "Microsoft reserved"),
	DEF_GUID("EBD0A0A2-B9E5-4433-87C0-68B6B72699C7", "Microsoft basic data"),
	DEF_GUID("5808C8AA-7E8F-42E0-85D2-E1E90434CFB3", "Microsoft LDM metadata"),
	DEF_GUID("AF9B60A0-1431-4F62-BC68-3311714A69AD", "Microsoft LDM data"),
	DEF_GUID("DE94BBA4-06D1-4D40-A16A-BFD50179D6AC", "Windows recovery environment"),
	DEF_GUID("37AFFC90-EF7D-4E96-91C3-2D7AE055B174", "IBM General Parallel Fs"),
	DEF_GUID("E75CAF8F-F680-4CEE-AFA3-B001E56EFC2D", "Microsoft Storage Spaces"),

	/* HP-UX */
	DEF_GUID("75894C1E-3AEB-11D3-B7C1-7B03A0000000", "HP-UX data"),
	DEF_GUID("E2A1E728-32E3-11D6-A682-7B03A0000000", "HP-UX service"),

	/* Linux (http://www.freedesktop.org/wiki/Specifications/DiscoverablePartitionsSpec) */
	DEF_GUID("0657FD6D-A4AB-43C4-84E5-0933C84B4F4F", "Linux swap"),
	DEF_GUID("0FC63DAF-8483-4772-8E79-3D69D8477DE4", "Linux filesystem"),
	DEF_GUID("3B8F8425-20E0-4F3B-907F-1A25A76F98E8", "Linux server data"),
	DEF_GUID("44479540-F297-41B2-9AF7-D131D5F0458A", "Linux root (x86)"),
	DEF_GUID("69DAD710-2CE4-4E3C-B16C-21A1D49ABED3", "Linux root (ARM)"),
	DEF_GUID("4F68BCE3-E8CD-4DB1-96E7-FBCAF984B709", "Linux root (x86-64)"),
	DEF_GUID("B921B045-1DF0-41C3-AF44-4C6F280D3FAE", "Linux root (ARM-64)"),
	DEF_GUID("993D8D3D-F80E-4225-855A-9DAF8ED7EA97", "Linux root (IA-64)"),
	DEF_GUID("8DA63339-0007-60C0-C436-083AC8230908", "Linux reserved"),
	DEF_GUID("933AC7E1-2EB4-4F13-B844-0E14E2AEF915", "Linux home"),
	DEF_GUID("A19D880F-05FC-4D3B-A006-743F0F84911E", "Linux RAID"),
	DEF_GUID("BC13C2FF-59E6-4262-A352-B275FD6F7172", "Linux extended boot"),
	DEF_GUID("E6D6D379-F507-44C2-A23C-238F2A3DF928", "Linux LVM"),
	/* ... too crazy, ignore for now:
	DEF_GUID("7FFEC5C9-2D00-49B7-8941-3EA10A5586B7", "Linux plain dm-crypt"),
	DEF_GUID("CA7D7CCB-63ED-4C53-861C-1742536059CC", "Linux LUKS"), */

	/* FreeBSD */
	DEF_GUID("516E7CB4-6ECF-11D6-8FF8-00022D09712B", "FreeBSD data"),
	DEF_GUID("83BD6B9D-7F41-11DC-BE0B-001560B84F0F", "FreeBSD boot"),
	DEF_GUID("516E7CB5-6ECF-11D6-8FF8-00022D09712B", "FreeBSD swap"),
	DEF_GUID("516E7CB6-6ECF-11D6-8FF8-00022D09712B", "FreeBSD UFS"),
	DEF_GUID("516E7CBA-6ECF-11D6-8FF8-00022D09712B", "FreeBSD ZFS"),
	DEF_GUID("516E7CB8-6ECF-11D6-8FF8-00022D09712B", "FreeBSD Vinum"),

	/* Apple OSX */
	DEF_GUID("48465300-0000-11AA-AA11-00306543ECAC", "Apple HFS/HFS+"),
	DEF_GUID("55465300-0000-11AA-AA11-00306543ECAC", "Apple UFS"),
	DEF_GUID("52414944-0000-11AA-AA11-00306543ECAC", "Apple RAID"),
	DEF_GUID("52414944-5F4F-11AA-AA11-00306543ECAC", "Apple RAID offline"),
	DEF_GUID("426F6F74-0000-11AA-AA11-00306543ECAC", "Apple boot"),
	DEF_GUID("4C616265-6C00-11AA-AA11-00306543ECAC", "Apple label"),
	DEF_GUID("5265636F-7665-11AA-AA11-00306543ECAC", "Apple TV recovery"),
	DEF_GUID("53746F72-6167-11AA-AA11-00306543ECAC", "Apple Core storage"),

	/* Solaris */
	DEF_GUID("6A82CB45-1DD2-11B2-99A6-080020736631", "Solaris boot"),
	DEF_GUID("6A85CF4D-1DD2-11B2-99A6-080020736631", "Solaris root"),
	/* same as Apple ZFS */
	DEF_GUID("6A898CC3-1DD2-11B2-99A6-080020736631", "Solaris /usr & Apple ZFS"),
	DEF_GUID("6A87C46F-1DD2-11B2-99A6-080020736631", "Solaris swap"),
	DEF_GUID("6A8B642B-1DD2-11B2-99A6-080020736631", "Solaris backup"),
	DEF_GUID("6A8EF2E9-1DD2-11B2-99A6-080020736631", "Solaris /var"),
	DEF_GUID("6A90BA39-1DD2-11B2-99A6-080020736631", "Solaris /home"),
	DEF_GUID("6A9283A5-1DD2-11B2-99A6-080020736631", "Solaris alternate sector"),
	DEF_GUID("6A945A3B-1DD2-11B2-99A6-080020736631", "Solaris reserved 1"),
	DEF_GUID("6A9630D1-1DD2-11B2-99A6-080020736631", "Solaris reserved 2"),
	DEF_GUID("6A980767-1DD2-11B2-99A6-080020736631", "Solaris reserved 3"),
	DEF_GUID("6A96237F-1DD2-11B2-99A6-080020736631", "Solaris reserved 4"),
	DEF_GUID("6A8D2AC7-1DD2-11B2-99A6-080020736631", "Solaris reserved 5"),

	/* NetBSD */
	DEF_GUID("49F48D32-B10E-11DC-B99B-0019D1879648", "NetBSD swap"),
	DEF_GUID("49F48D5A-B10E-11DC-B99B-0019D1879648", "NetBSD FFS"),
	DEF_GUID("49F48D82-B10E-11DC-B99B-0019D1879648", "NetBSD LFS"),
	DEF_GUID("2DB519C4-B10E-11DC-B99B-0019D1879648", "NetBSD concatenated"),
	DEF_GUID("2DB519EC-B10E-11DC-B99B-0019D1879648", "NetBSD encrypted"),
	DEF_GUID("49F48DAA-B10E-11DC-B99B-0019D1879648", "NetBSD RAID"),

	/* ChromeOS */
	DEF_GUID("FE3A2A5D-4F32-41A7-B725-ACCC3285A309", "ChromeOS kernel"),
	DEF_GUID("3CB8E202-3B7E-47DD-8A3C-7FF2A13CFCEC", "ChromeOS root fs"),
	DEF_GUID("2E0A753D-9E48-43B0-8337-B15192CB1B5E", "ChromeOS reserved"),

	/* MidnightBSD */
	DEF_GUID("85D5E45A-237C-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD data"),
	DEF_GUID("85D5E45E-237C-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD boot"),
	DEF_GUID("85D5E45B-237C-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD swap"),
	DEF_GUID("0394EF8B-237E-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD UFS"),
	DEF_GUID("85D5E45D-237C-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD ZFS"),
	DEF_GUID("85D5E45C-237C-11E1-B4B3-E89A8F7FC3A7", "MidnightBSD Vinum"),

	/* Ceph */
	DEF_GUID("45B0969E-9B03-4F30-B4C6-B4B80CEFF106", "Ceph Journal"),
	DEF_GUID("45B0969E-9B03-4F30-B4C6-5EC00CEFF106", "Ceph Encrypted Journal"),
	DEF_GUID("4FBD7E29-9D25-41B8-AFD0-062C0CEFF05D", "Ceph OSD"),
	DEF_GUID("4FBD7E29-9D25-41B8-AFD0-5EC00CEFF05D", "Ceph crypt OSD"),
	DEF_GUID("89C57F98-2FE5-4DC0-89C1-F3AD0CEFF2BE", "Ceph disk in creation"),
	DEF_GUID("89C57F98-2FE5-4DC0-89C1-5EC00CEFF2BE", "Ceph crypt disk in creation"),

	/* VMware */
	DEF_GUID("AA31E02A-400F-11DB-9590-000C2911D1B8", "VMware VMFS"),
	DEF_GUID("9D275380-40AD-11DB-BF97-000C2911D1B8", "VMware Diagnostic"),
	DEF_GUID("381CFCCC-7288-11E0-92EE-000C2911D0B2", "VMware Virtual SAN"),
	DEF_GUID("77719A0C-A4A0-11E3-A47E-000C29745A24", "VMware Virsto"),
	DEF_GUID("9198EFFC-31C0-11DB-8F78-000C2911D1B8", "VMware Reserved"),

	/* OpenBSD */
	DEF_GUID("824CC7A0-36A8-11E3-890A-952519AD3F61", "OpenBSD data"),

	/* QNX */
	DEF_GUID("CEF5A9AD-73BC-4601-89F3-CDEEEEE321A1", "QNX6 file system"),

	/* Plan 9 */
	DEF_GUID("C91818F9-8025-47AF-89D2-F030D7000C2C", "Plan 9 partition")
};

#define alignment_required(_x)  ((_x)->grain != (_x)->sector_size)

/* gpt_entry macros */
#define gpt_partition_start(_e)         le64_to_cpu((_e)->lba_start)
#define gpt_partition_end(_e)           le64_to_cpu((_e)->lba_end)

/* in-memory fdisk GPT stuff */
struct fdisk_gpt_label {
	struct fdisk_label      head;           /* generic part */

	/* gpt specific part */
	struct gpt_header       *pheader;       /* primary header */
	struct gpt_header       *bheader;       /* backup header */

	unsigned char *ents;                    /* entries (partitions) */
};

static inline struct fdisk_gpt_label *self_label(struct fdisk_context *cxt)
{
	return (struct fdisk_gpt_label *) cxt->label;
}

/* Returns the partition length, or 0 if end is before beginning. */
static uint64_t gpt_partition_size(const struct gpt_entry *e)
{
	uint64_t start = gpt_partition_start(e);
	uint64_t end = gpt_partition_end(e);

	return start > end ? 0 : end - start + 1ULL;
}

/* UUID is traditionally 16 byte big-endian array, except Intel EFI
 * specification where the UUID is a structure of little-endian fields. */
static void swap_efi_guid_gpt(struct gpt_guid *uid)
{
	uid->time_low = swab32(uid->time_low);
	uid->time_mid = swab16(uid->time_mid);
	uid->time_hi_and_version = swab16(uid->time_hi_and_version);
}

static int string_to_guid(const char *in, struct gpt_guid *guid)
{
	if (uuid_parse(in, (unsigned char *) guid)) {   /* BE */
		return -EINVAL;
	}
	swap_efi_guid_gpt(guid);        /* LE */
	return 0;
}

static char *guid_to_string(const struct gpt_guid *guid, char *out)
{
	struct gpt_guid u = *guid;      /* LE */
	static const char fmt_upper[] = "%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X";

	swap_efi_guid_gpt(&u);  /* BE */
	uuid_unparse_x((unsigned char *) &u, out, fmt_upper);
	return out;
}

static struct fdisk_parttype *gpt_partition_parttype(
		struct fdisk_context *cxt,
		const struct gpt_entry *e)
{
	struct fdisk_parttype *t;
	char str[UUID_STR_LEN];
	struct gpt_guid guid = e->type;

	guid_to_string(&guid, str);
	t = fdisk_label_get_parttype_from_string(cxt->label, str);
	return t ? : fdisk_new_unknown_parttype(0, str);
}

static void gpt_entry_set_type(struct gpt_entry *e, struct gpt_guid *uuid)
{
	e->type = *uuid;
}

static int gpt_entry_set_name(struct gpt_entry *e, char *str)
{
	uint16_t name[GPT_PART_NAME_LEN] = { 0 };
	size_t i, mblen = 0;
	uint8_t *in = (uint8_t *) str;

	for (i = 0; *in && i < GPT_PART_NAME_LEN; in++) {
		if (!mblen) {
			if (!(*in & 0x80)) {
				name[i++] = *in;
			} else if ((*in & 0xE0) == 0xC0) {
				mblen = 1;
				name[i] = (uint16_t)(*in & 0x1F) << (mblen *6);
			} else if ((*in & 0xF0) == 0xE0) {
				mblen = 2;
				name[i] = (uint16_t)(*in & 0x0F) << (mblen *6);
			} else {
				/* broken UTF-8 or code point greater than U+FFFF */
				return -EILSEQ;
			}
		} else {
			/* incomplete UTF-8 sequence */
			if ((*in & 0xC0) != 0x80)
				return -EILSEQ;

			name[i] |= (uint16_t)(*in & 0x3F) << (--mblen *6);
			if (!mblen) {
				/* check for code points reserved for surrogate pairs */
				if ((name[i] & 0xF800) == 0xD800)
					return -EILSEQ;
				i++;
			}
		}
	}

	for (i = 0; i < GPT_PART_NAME_LEN; i++)
		e->name[i] = cpu_to_le16(name[i]);

	return (int)((char *) in - str);
}

static int gpt_entry_set_uuid(struct gpt_entry *e, char *str)
{
	struct gpt_guid uuid;
	int rc;

	rc = string_to_guid(str, &uuid);
	if (rc)
		return rc;

	e->partition_guid = uuid;
	return 0;
}

static inline int gpt_entry_is_used(const struct gpt_entry *e)
{
	/* only checking that the GUID is 0 is enough to verify an empty partition. */
	return memcmp(&e->type, &GPT_UNUSED_ENTRY_GUID,
			sizeof(struct gpt_guid)) != 0;
}


static const char *gpt_get_header_revstr(struct gpt_header *header)
{
	if (!header)
		goto unknown;

	switch (le32_to_cpu(header->revision)) {
	case GPT_HEADER_REVISION_V1_02:
		return "1.2";
	case GPT_HEADER_REVISION_V1_00:
		return "1.0";
	case GPT_HEADER_REVISION_V0_99:
		return "0.99";
	default:
		goto unknown;
	}

unknown:
	return "unknown";
}

static inline unsigned char *gpt_get_entry_ptr(struct fdisk_gpt_label *gpt, size_t i)
{
	return gpt->ents + le32_to_cpu(gpt->pheader->sizeof_partition_entry) * i;
}

static inline struct gpt_entry *gpt_get_entry(struct fdisk_gpt_label *gpt, size_t i)
{
	return (struct gpt_entry *) gpt_get_entry_ptr(gpt, i);
}

static inline struct gpt_entry *gpt_zeroize_entry(struct fdisk_gpt_label *gpt, size_t i)
{
	return (struct gpt_entry *) memset(gpt_get_entry_ptr(gpt, i),
			0, le32_to_cpu(gpt->pheader->sizeof_partition_entry));
}

/* Use to access array of entries, for() loops, etc. But don't use when
 * you directly do something with GPT header, then use uint32_t. */
static inline size_t gpt_get_nentries(struct fdisk_gpt_label *gpt)
{
	return (size_t) le32_to_cpu(gpt->pheader->npartition_entries);
}

static inline int gpt_calculate_sizeof_ents(struct gpt_header *hdr, uint32_t nents, size_t *sz)
{
	uint32_t esz = le32_to_cpu(hdr->sizeof_partition_entry);

	if (nents == 0 || esz == 0 || SIZE_MAX/esz < nents)
		return -ERANGE;

	*sz = nents * esz;
	return 0;
}

static inline int gpt_sizeof_ents(struct gpt_header *hdr, size_t *sz)
{
	return gpt_calculate_sizeof_ents(hdr, le32_to_cpu(hdr->npartition_entries), sz);
}

static char *gpt_get_header_id(struct gpt_header *header)
{
	char str[UUID_STR_LEN];
	struct gpt_guid guid = header->disk_guid;

	guid_to_string(&guid, str);

	return xstrdup(str);
}

/* Builds a clean new valid protective MBR - will wipe out any existing data.
 * Returns 0 on success, otherwise < 0 on error. */
static int gpt_mknew_pmbr(struct fdisk_context *cxt)
{
	struct gpt_legacy_mbr *pmbr = NULL;
	int rc;

	if (!cxt || !cxt->firstsector)
		return -ENOSYS;

	if (fdisk_has_protected_bootbits(cxt))
		rc = fdisk_init_firstsector_buffer(cxt, 0, MBR_PT_BOOTBITS_SIZE);
	else
		rc = fdisk_init_firstsector_buffer(cxt, 0, 0);
	if (rc)
		return rc;

	pmbr = (struct gpt_legacy_mbr *) cxt->firstsector;
	memset(pmbr->partition_record, 0, sizeof(pmbr->partition_record));

	pmbr->signature = cpu_to_le16(MSDOS_MBR_SIGNATURE);
	pmbr->partition_record[0].os_type      = EFI_PMBR_OSTYPE;
	pmbr->partition_record[0].start_sector = 2;
	pmbr->partition_record[0].end_head     = 0xFF;
	pmbr->partition_record[0].end_sector   = 0xFF;
	pmbr->partition_record[0].end_track    = 0xFF;
	pmbr->partition_record[0].starting_lba = cpu_to_le32(1);
	pmbr->partition_record[0].size_in_lba  =
		cpu_to_le32((uint32_t) min( cxt->total_sectors - 1ULL, 0xFFFFFFFFULL) );

	return 0;
}

/* Move backup header to the end of the device */
static void gpt_fix_alternative_lba(struct fdisk_context *cxt, struct fdisk_gpt_label *gpt)
{
	struct gpt_header *p, *b;
	uint64_t esz, esects, last;

	if (!cxt)
		return;

	p = gpt->pheader;       /* primary */
	b = gpt->bheader;       /* backup */

	/* count size of partitions array */
	esz = (uint64_t) le32_to_cpu(p->npartition_entries) * sizeof(struct gpt_entry);
	esects = (esz + cxt->sector_size - 1) / cxt->sector_size;

	/* reference from primary to backup */
	p->alternative_lba = cpu_to_le64(cxt->total_sectors - 1ULL);

	/* reference from backup to primary */
	b->alternative_lba = p->my_lba;
	b->my_lba = p->alternative_lba;

	/* fix backup partitions array address */
	b->partition_entry_lba = cpu_to_le64(cxt->total_sectors - 1ULL - esects);

	/* update last usable LBA */
	last = cxt->total_sectors - 2ULL - esects;
	p->last_usable_lba  = cpu_to_le64(last);
	b->last_usable_lba  = cpu_to_le64(last);
}

/* some universal differences between the headers */
static void gpt_mknew_header_common(struct fdisk_context *cxt,
				    struct gpt_header *header, uint64_t lba)
{
	if (!cxt || !header)
		return;

	header->my_lba = cpu_to_le64(lba);

	if (lba == GPT_PRIMARY_PARTITION_TABLE_LBA) { /* primary */
		header->alternative_lba = cpu_to_le64(cxt->total_sectors - 1ULL);
		header->partition_entry_lba = cpu_to_le64(2ULL);
	} else { /* backup */
		uint64_t esz = (uint64_t) le32_to_cpu(header->npartition_entries)
							* sizeof(struct gpt_entry);
		uint64_t esects = (esz + cxt->sector_size - 1) / cxt->sector_size;

		header->alternative_lba = cpu_to_le64(GPT_PRIMARY_PARTITION_TABLE_LBA);
		header->partition_entry_lba = cpu_to_le64(cxt->total_sectors - 1ULL - esects);
	}
}

/* Builds a new GPT header (at sector lba) from a backup header2.
 * If building a primary header, then backup is the secondary, and vice versa.
 *
 * Always pass a new (zeroized) header to build upon as we don't
 * explicitly zero-set some values such as CRCs and reserved.
 *
 * Returns 0 on success, otherwise < 0 on error. */
static int gpt_mknew_header_from_bkp(struct fdisk_context *cxt,
				     struct gpt_header *header,
				     uint64_t lba,
				     struct gpt_header *header2)
{
	if (!cxt || !header || !header2)
		return -ENOSYS;

	header->signature              = header2->signature;
	header->revision               = header2->revision;
	header->size                   = header2->size;
	header->npartition_entries     = header2->npartition_entries;
	header->sizeof_partition_entry = header2->sizeof_partition_entry;
	header->first_usable_lba       = header2->first_usable_lba;
	header->last_usable_lba        = header2->last_usable_lba;

	memcpy(&header->disk_guid,
	       &header2->disk_guid, sizeof(header2->disk_guid));
	gpt_mknew_header_common(cxt, header, lba);

	return 0;
}

static struct gpt_header *gpt_copy_header(struct fdisk_context *cxt,
			   struct gpt_header *src)
{
	struct gpt_header *res;

	if (!cxt || !src)
		return NULL;

	res = zmalloc(cxt->sector_size);
	res->my_lba                 = src->alternative_lba;
	res->alternative_lba        = src->my_lba;
	res->signature              = src->signature;
	res->revision               = src->revision;
	res->size                   = src->size;
	res->npartition_entries     = src->npartition_entries;
	res->sizeof_partition_entry = src->sizeof_partition_entry;
	res->first_usable_lba       = src->first_usable_lba;
	res->last_usable_lba        = src->last_usable_lba;

	memcpy(&res->disk_guid, &src->disk_guid, sizeof(src->disk_guid));

	if (res->my_lba == GPT_PRIMARY_PARTITION_TABLE_LBA)
		res->partition_entry_lba = cpu_to_le64(2ULL);
	else {
		uint64_t esz = (uint64_t) le32_to_cpu(src->npartition_entries) * sizeof(struct gpt_entry);
		uint64_t esects = (esz + cxt->sector_size - 1) / cxt->sector_size;

		res->partition_entry_lba = cpu_to_le64(cxt->total_sectors - 1ULL - esects);
	}

	return res;
}

static int get_script_u64(struct fdisk_context *cxt, uint64_t *num, const char *name)
{
	const char *str;
	int pwr = 0, rc = 0;

	*num = 0;

	if (!cxt->script)
		return 1;

	str = fdisk_script_get_header(cxt->script, name);
	if (!str)
		return 1;

	rc = parse_size(str, (uintmax_t *) num, &pwr);
	if (rc < 0)
		return rc;
	if (pwr)
		*num /= cxt->sector_size;
	return 0;
}

static int count_first_last_lba(struct fdisk_context *cxt,
				 uint64_t *first, uint64_t *last)
{
	int rc = 0;
	uint64_t flba, llba;

	uint64_t esz = 0;

	*first = *last = 0;

	/* UEFI default */
	esz = sizeof(struct gpt_entry) * GPT_NPARTITIONS / cxt->sector_size;
	llba = cxt->total_sectors - 2ULL - esz;
	flba = esz + 2ULL;

	/* script default */
	if (cxt->script) {
		rc = get_script_u64(cxt, first, "first-lba");
		if (rc < 0)
			return rc;

		if (rc == 0 && (*first < flba || *first > llba)) {
			fdisk_warnx(cxt, "First LBA specified by script is out of range.");
			return -ERANGE;
		}

		rc = get_script_u64(cxt, last, "last-lba");
		if (rc < 0)
			return rc;

		if (rc == 0 && (*last > llba || *last < flba)) {
			fdisk_warnx(cxt, "Last LBA specified by script is out of range.");
			return -ERANGE;
		}
	}

	if (!*last)
		*last = llba;

	/* default by topology */
	if (!*first)
		*first = flba < cxt->first_lba &&
			 cxt->first_lba < *last ? cxt->first_lba : flba;
	return 0;
}

/* Builds a clean new GPT header (currently under revision 1.0).
 *
 * Always pass a new (zeroized) header to build upon as we don't
 * explicitly zero-set some values such as CRCs and reserved.
 *
 * Returns 0 on success, otherwise < 0 on error. */
static int gpt_mknew_header(struct fdisk_context *cxt,
			    struct gpt_header *header, uint64_t lba)
{
	uint64_t first, last;
	int has_id = 0, rc;

	if (!cxt || !header)
		return -ENOSYS;

	header->signature = cpu_to_le64(GPT_HEADER_SIGNATURE);
	header->revision  = cpu_to_le32(GPT_HEADER_REVISION_V1_00);

	/* According to EFI standard it's valid to count all the first
	 * sector into header size, but some tools may have a problem
	 * to accept it, so use the header without the zeroed area.
	 * This does not have any impact to CRC, etc.   --kzak Jan-2015 */
	header->size = cpu_to_le32(sizeof(struct gpt_header)
				- sizeof(header->reserved2));

	/* 128 partitions are the default. It can go beyond that, but
	 * we're creating a de facto header here, so no funny business. */
	header->npartition_entries     = cpu_to_le32(GPT_NPARTITIONS);
	header->sizeof_partition_entry = cpu_to_le32(sizeof(struct gpt_entry));

	rc = count_first_last_lba(cxt, &first, &last);
	if (rc)
		return rc;

	header->first_usable_lba = cpu_to_le64(first);
	header->last_usable_lba  = cpu_to_le64(last);

	gpt_mknew_header_common(cxt, header, lba);

	if (cxt->script) {
		const char *id = fdisk_script_get_header(cxt->script, "label-id");
		struct gpt_guid guid = header->disk_guid;
		if (id && string_to_guid(id, &guid) == 0)
			has_id = 1;
		header->disk_guid = guid;
	}

	if (!has_id) {
		struct gpt_guid guid;

		uuid_generate((unsigned char *) &header->disk_guid);
		guid = header->disk_guid;
		swap_efi_guid_gpt(&guid);
	}
	return 0;
}

/* Checks if there is a valid protective MBR partition table.
 * Returns 0 if it is invalid or failure. Otherwise, return
 * GPT_MBR_PROTECTIVE or GPT_MBR_HYBRID, depending on the detection. */
static int valid_pmbr(struct fdisk_context *cxt)
{
	int i, part = 0, ret = 0; /* invalid by default */
	struct gpt_legacy_mbr *pmbr = NULL;

	if (!cxt->firstsector)
		goto done;

	pmbr = (struct gpt_legacy_mbr *) cxt->firstsector;

	if (le16_to_cpu(pmbr->signature) != MSDOS_MBR_SIGNATURE)
		goto done;

	/* seems like a valid MBR was found, check DOS primary partitions */
	for (i = 0; i < 4; i++) {
		if (pmbr->partition_record[i].os_type == EFI_PMBR_OSTYPE) {
			/* Ok, we at least know that there's a protective MBR,
			 * now check if there are other partition types for
			 * hybrid MBR. */
			part = i;
			ret = GPT_MBR_PROTECTIVE;
			break;
		}
	}

	if (ret != GPT_MBR_PROTECTIVE)
		goto done;

	/* LBA of the GPT partition header */
	if (pmbr->partition_record[part].starting_lba !=
	    cpu_to_le32(GPT_PRIMARY_PARTITION_TABLE_LBA))
		goto done;

	for (i = 0 ; i < 4; i++) {
		if ((pmbr->partition_record[i].os_type != EFI_PMBR_OSTYPE) &&
		    (pmbr->partition_record[i].os_type != 0x00))
			ret = GPT_MBR_HYBRID;
	}

	/* Protective MBRs take up the lesser of the whole disk
	 * or 2 TiB (32bit LBA), ignoring the rest of the disk.
	 * Some partitioning programs, nonetheless, choose to set
	 * the size to the maximum 32-bit limitation, disregarding
	 * the disk size.
	 *
	 * Hybrid MBRs do not necessarily comply with this.
	 *
	 * Consider a bad value here to be a warning to support dd-ing
	 * an image from a smaller disk to a bigger disk. */
	if (ret == GPT_MBR_PROTECTIVE) {
		uint64_t sz_lba = (uint64_t) le32_to_cpu(pmbr->partition_record[part].size_in_lba);
		if (sz_lba != cxt->total_sectors - 1ULL && sz_lba != 0xFFFFFFFFULL) {

			fdisk_warnx(cxt, "GPT PMBR size mismatch (%"PRIu64" != %"PRIu64") "
					   "will be corrected by write.",
					sz_lba, cxt->total_sectors - 1ULL);

			/* Note that gpt_write_pmbr() overwrites PMBR, but we want to keep it valid already
			 * in memory too to disable warnings when valid_pmbr() called next time */
			pmbr->partition_record[part].size_in_lba  =
				cpu_to_le32((uint32_t) min( cxt->total_sectors - 1ULL, 0xFFFFFFFFULL) );
			fdisk_label_set_changed1(cxt->label);
		}
	}
done:
	return ret;
}

static uint64_t gpt_last_lba(struct fdisk_context *cxt)
{
	struct stat s;
	uint64_t sectors = 0;

	memset(&s, 0, sizeof(s));
	if (fstat(cxt->dev_fd, &s) == -1) {
		fdisk_warn(cxt, "gpt: stat() failed");
		return 0;
	}

	if (S_ISBLK(s.st_mode))
		sectors = cxt->total_sectors - 1ULL;
	else if (S_ISREG(s.st_mode))
		sectors = ((uint64_t) s.st_size /
			   (uint64_t) cxt->sector_size) - 1ULL;
	else
		fdisk_warnx(cxt, "gpt: cannot handle files with mode %o", s.st_mode);

	return sectors;
}

static ssize_t read_lba(struct fdisk_context *cxt, uint64_t lba,
			void *buffer, const size_t bytes)
{
	off_t offset = lba * cxt->sector_size;

	if (lseek(cxt->dev_fd, offset, SEEK_SET) == (off_t) -1)
		return -1;
	return (size_t)read(cxt->dev_fd, buffer, bytes) != bytes;
}


/* Returns the GPT entry array */
static unsigned char *gpt_read_entries(struct fdisk_context *cxt,
					 struct gpt_header *header)
{
	size_t sz = 0;
	ssize_t ssz;

	unsigned char *ret = NULL;
	off_t offset;

	if (gpt_sizeof_ents(header, &sz))
		return NULL;

	if (sz > (size_t) SSIZE_MAX)
		return NULL;

	ret = zmalloc(sz);
	offset = (off_t) le64_to_cpu(header->partition_entry_lba) *
		       cxt->sector_size;

	if (offset != lseek(cxt->dev_fd, offset, SEEK_SET))
		goto fail;

	ssz = read(cxt->dev_fd, ret, sz);
	if (ssz < 0 || (size_t) ssz != sz)
		goto fail;

	return ret;

fail:
	free(ret);
	return NULL;
}

static inline uint32_t gpt_header_count_crc32(struct gpt_header *header)
{
	return count_crc32((unsigned char *) header,            /* buffer */
			le32_to_cpu(header->size),              /* size of buffer */
			offsetof(struct gpt_header, crc32),     /* exclude */
			sizeof(header->crc32));                 /* size of excluded area */
}

static inline uint32_t gpt_entryarr_count_crc32(struct gpt_header *header, unsigned char *ents)
{
	size_t arysz = 0;

	if (gpt_sizeof_ents(header, &arysz))
		return 0;

	return count_crc32(ents, arysz, 0, 0);
}

/* Recompute header and partition array 32bit CRC checksums.
 * This function does not fail - if there's corruption, then it
 * will be reported when checksumming it again (ie: probing or verify). */
static void gpt_recompute_crc(struct gpt_header *header, unsigned char *ents)
{
	if (!header)
		return;

	header->partition_entry_array_crc32 =
			cpu_to_le32( gpt_entryarr_count_crc32(header, ents) );

	header->crc32 = cpu_to_le32( gpt_header_count_crc32(header) );
}

/* Compute the 32bit CRC checksum of the partition table header.
 * Returns 1 if it is valid, otherwise 0. */
static int gpt_check_header_crc(struct gpt_header *header, unsigned char *ents)
{
	uint32_t orgcrc = le32_to_cpu(header->crc32),
		 crc = gpt_header_count_crc32(header);

	if (crc == orgcrc)
		return 1;

	/* If we have checksum mismatch it may be due to stale data, like a
	 * partition being added or deleted. Recompute the CRC again and make
	 * sure this is not the case. */
	if (ents) {
		gpt_recompute_crc(header, ents);
		return gpt_header_count_crc32(header) == orgcrc;
	}

	return 0;
}

/* It initializes the partition entry array.
 * Returns 1 if the checksum is valid, otherwise 0. */
static int gpt_check_entryarr_crc(struct gpt_header *header, unsigned char *ents)
{
	if (!header || !ents)
		return 0;

	return gpt_entryarr_count_crc32(header, ents) ==
			le32_to_cpu(header->partition_entry_array_crc32);
}

static int gpt_check_lba_sanity(struct fdisk_context *cxt, struct gpt_header *header)
{
	int ret = 0;
	uint64_t lu, fu, lastlba = gpt_last_lba(cxt);

	fu = le64_to_cpu(header->first_usable_lba);
	lu = le64_to_cpu(header->last_usable_lba);

	/* check if first and last usable LBA make sense */
	if (lu < fu)
		goto done;

	/* check if first and last usable LBAs with the disk's last LBA */
	if (fu > lastlba || lu > lastlba)
		goto done;

	/* the header has to be outside usable range */
	if (fu < GPT_PRIMARY_PARTITION_TABLE_LBA && GPT_PRIMARY_PARTITION_TABLE_LBA < lu)
		goto done;

	ret = 1; /* sane */
done:
	return ret;
}

/* Check if there is a valid header signature */
static int gpt_check_signature(struct gpt_header *header)
{
	return header->signature == cpu_to_le64(GPT_HEADER_SIGNATURE);
}

/* Return the specified GPT Header, or NULL upon failure/invalid.
 * Note that all tests must pass to ensure a valid header,
 * we do not rely on only testing the signature for a valid probe. */
static struct gpt_header *gpt_read_header(struct fdisk_context *cxt,
					  uint64_t lba,
					  unsigned char **_ents)
{
	struct gpt_header *header = NULL;
	unsigned char *ents = NULL;
	uint32_t hsz;

	if (!cxt)
		return NULL;

	/* always allocate all sector, the area after GPT header
	 * has to be fill by zeros */
	header = zmalloc(cxt->sector_size);

	/* read and verify header */
	if (read_lba(cxt, lba, header, cxt->sector_size) != 0)
		goto invalid;

	if (!gpt_check_signature(header))
		goto invalid;

	/* make sure header size is between 92 and sector size bytes */
	hsz = le32_to_cpu(header->size);
	if (hsz < GPT_HEADER_MINSZ || hsz > cxt->sector_size)
		goto invalid;

	if (!gpt_check_header_crc(header, NULL))
		goto invalid;

	/* read and verify entries */
	ents = gpt_read_entries(cxt, header);
	if (!ents)
		goto invalid;

	if (!gpt_check_entryarr_crc(header, ents))
		goto invalid;

	if (!gpt_check_lba_sanity(cxt, header))
		goto invalid;

	/* valid header must be at MyLBA */
	if (le64_to_cpu(header->my_lba) != lba)
		goto invalid;

	if (_ents)
		*_ents = ents;
	else
		free(ents);

	return header;
invalid:
	free(header);
	free(ents);

	return NULL;
}


static int gpt_locate_disklabel(struct fdisk_context *cxt, int n,
		const char **name, uint64_t *offset, size_t *size)
{
	struct fdisk_gpt_label *gpt;

	*name = NULL;
	*offset = 0;
	*size = 0;

	switch (n) {
	case 0:
		*name = "PMBR";
		*offset = 0;
		*size = 512;
		break;
	case 1:
		*name = "GPT Header";
		*offset = (uint64_t) GPT_PRIMARY_PARTITION_TABLE_LBA * cxt->sector_size;
		*size = sizeof(struct gpt_header);
		break;
	case 2:
		*name = "GPT Entries";
		gpt = self_label(cxt);
		*offset = (uint64_t) le64_to_cpu(gpt->pheader->partition_entry_lba) *
				     cxt->sector_size;
		return gpt_sizeof_ents(gpt->pheader, size);
	default:
		return 1;                       /* no more chunks */
	}

	return 0;
}

static int gpt_get_disklabel_item(struct fdisk_context *cxt, struct fdisk_labelitem *item)
{
	struct gpt_header *h;
	int rc = 0;

	h = self_label(cxt)->pheader;

	switch (item->id) {
	case GPT_LABELITEM_ID:
		item->name = "Disk identifier";
		item->type = 's';
		item->data.str = gpt_get_header_id(h);
		break;
	case GPT_LABELITEM_FIRSTLBA:
		item->name = "First LBA";
		item->type = 'j';
		item->data.num64 = le64_to_cpu(h->first_usable_lba);
		break;
	case GPT_LABELITEM_LASTLBA:
		item->name = "Last LBA";
		item->type = 'j';
		item->data.num64 = le64_to_cpu(h->last_usable_lba);
		break;
	case GPT_LABELITEM_ALTLBA:
		/* TRANSLATORS: The LBA (Logical Block Address) of the backup GPT header. */
		item->name = "Alternative LBA";
		item->type = 'j';
		item->data.num64 = le64_to_cpu(h->alternative_lba);
		break;
	case GPT_LABELITEM_ENTRIESLBA:
		/* TRANSLATORS: The start of the array of partition entries. */
		item->name = "Partition entries LBA";
		item->type = 'j';
		item->data.num64 = le64_to_cpu(h->partition_entry_lba);
		break;
	case GPT_LABELITEM_ENTRIESALLOC:
		item->name = "Allocated partition entries";
		item->type = 'j';
		item->data.num64 = le32_to_cpu(h->npartition_entries);
		break;
	default:
		if (item->id < __FDISK_NLABELITEMS)
			rc = 1; /* unsupported generic item */
		else
			rc = 2; /* out of range */
		break;
	}

	return rc;
}

/* Returns the number of partitions that are in use. */
static size_t partitions_in_use(struct fdisk_gpt_label *gpt)
{
	size_t i, used = 0;

	for (i = 0; i < gpt_get_nentries(gpt); i++) {
		struct gpt_entry *e = gpt_get_entry(gpt, i);

		if (gpt_entry_is_used(e))
			used++;
	}
	return used;
}

/* Check if a partition is too big for the disk (sectors).
 * Returns the faulting partition number, otherwise 0. */
static uint32_t check_too_big_partitions(struct fdisk_gpt_label *gpt, uint64_t sectors)
{
	size_t i;

	for (i = 0; i < gpt_get_nentries(gpt); i++) {
		struct gpt_entry *e = gpt_get_entry(gpt, i);

		if (!gpt_entry_is_used(e))
			continue;
		if (gpt_partition_end(e) >= sectors)
			return i + 1;
	}

	return 0;
}

/* Check if a partition ends before it begins
 * Returns the faulting partition number, otherwise 0. */
static uint32_t check_start_after_end_partitions(struct fdisk_gpt_label *gpt)
{
	size_t i;

	for (i = 0; i < gpt_get_nentries(gpt); i++) {
		struct gpt_entry *e = gpt_get_entry(gpt, i);

		if (!gpt_entry_is_used(e))
			continue;
		if (gpt_partition_start(e) > gpt_partition_end(e))
			return i + 1;
	}

	return 0;
}

/* Check if partition e1 overlaps with partition e2. */
static inline int partition_overlap(struct gpt_entry *e1, struct gpt_entry *e2)
{
	uint64_t start1 = gpt_partition_start(e1);
	uint64_t end1   = gpt_partition_end(e1);
	uint64_t start2 = gpt_partition_start(e2);
	uint64_t end2   = gpt_partition_end(e2);

	return (start1 && start2 && (start1 <= end2) != (end1 < start2));
}

/* Find any partitions that overlap. */
static uint32_t check_overlap_partitions(struct fdisk_gpt_label *gpt)
{
	size_t i, j;

	for (i = 0; i < gpt_get_nentries(gpt); i++)
		for (j = 0; j < i; j++) {
			struct gpt_entry *ei = gpt_get_entry(gpt, i);
			struct gpt_entry *ej = gpt_get_entry(gpt, j);

			if (!gpt_entry_is_used(ei) || !gpt_entry_is_used(ej))
				continue;
			if (partition_overlap(ei, ej))
				return i + 1;
		}

	return 0;
}

/* Find the first available block after the starting point; returns 0 if
 * there are no available blocks left, or error. From gdisk. */
static uint64_t find_first_available(struct fdisk_gpt_label *gpt, uint64_t start)
{
	int first_moved = 0;
	uint64_t first;
	uint64_t fu, lu;

	fu = le64_to_cpu(gpt->pheader->first_usable_lba);
	lu = le64_to_cpu(gpt->pheader->last_usable_lba);

	/* Begin from the specified starting point or from the first usable
	 * LBA, whichever is greater... */
	first = start < fu ? fu : start;

	/* Now search through all partitions; if first is within an
	 * existing partition, move it to the next sector after that
	 * partition and repeat. If first was moved, set firstMoved
	 * flag; repeat until firstMoved is not set, so as to catch
	 * cases where partitions are out of sequential order.... */
	do {
		size_t i;

		first_moved = 0;
		for (i = 0; i < gpt_get_nentries(gpt); i++) {
			struct gpt_entry *e = gpt_get_entry(gpt, i);

			if (!gpt_entry_is_used(e))
				continue;
			if (first < gpt_partition_start(e))
				continue;
			if (first <= gpt_partition_end(e)) {
				first = gpt_partition_end(e) + 1;
				first_moved = 1;
			}
		}
	} while (first_moved == 1);

	if (first > lu)
		first = 0;

	return first;
}


/* Returns last available sector in the free space pointed to by start. From gdisk. */
static uint64_t find_last_free(struct fdisk_gpt_label *gpt, uint64_t start)
{
	size_t i;
	uint64_t nearest_start;

	nearest_start = le64_to_cpu(gpt->pheader->last_usable_lba);

	for (i = 0; i < gpt_get_nentries(gpt); i++) {
		struct gpt_entry *e = gpt_get_entry(gpt, i);
		uint64_t ps = gpt_partition_start(e);

		if (nearest_start > ps && ps > start)
			nearest_start = ps - 1ULL;
	}

	return nearest_start;
}

/* Returns the last free sector on the disk. From gdisk. */
static uint64_t find_last_free_sector(struct fdisk_gpt_label *gpt)
{
	int last_moved;
	uint64_t last = 0;

	/* start by assuming the last usable LBA is available */
	last = le64_to_cpu(gpt->pheader->last_usable_lba);
	do {
		size_t i;

		last_moved = 0;
		for (i = 0; i < gpt_get_nentries(gpt); i++) {
			struct gpt_entry *e = gpt_get_entry(gpt, i);

			if (last >= gpt_partition_start(e) &&
			    last <= gpt_partition_end(e)) {
				last = gpt_partition_start(e) - 1ULL;
				last_moved = 1;
			}
		}
	} while (last_moved == 1);

	return last;
}

/* Finds the first available sector in the largest block of unallocated
 * space on the disk. Returns 0 if there are no available blocks left.
 * From gdisk. */
static uint64_t find_first_in_largest(struct fdisk_gpt_label *gpt)
{
	uint64_t start = 0, first_sect, last_sect;
	uint64_t segment_size, selected_size = 0, selected_segment = 0;

	do {
		first_sect = find_first_available(gpt, start);
		if (first_sect != 0) {
			last_sect = find_last_free(gpt, first_sect);
			segment_size = last_sect - first_sect + 1ULL;

			if (segment_size > selected_size) {
				selected_size = segment_size;
				selected_segment = first_sect;
			}
			start = last_sect + 1ULL;
		}
	} while (first_sect != 0);

	return selected_segment;
}

/* Find the total number of free sectors, the number of segments in which
 * they reside, and the size of the largest of those segments. From gdisk. */
static uint64_t get_free_sectors(struct fdisk_context *cxt,
				 struct fdisk_gpt_label *gpt,
				 uint32_t *nsegments,
				 uint64_t *largest_segment)
{
	uint32_t num = 0;
	uint64_t first_sect, last_sect;
	uint64_t largest_seg = 0, segment_sz;
	uint64_t totfound = 0, start = 0; /* starting point for each search */

	if (!cxt->total_sectors)
		goto done;

	do {
		first_sect = find_first_available(gpt, start);
		if (first_sect) {
			last_sect = find_last_free(gpt, first_sect);
			segment_sz = last_sect - first_sect + 1;

			if (segment_sz > largest_seg)
				largest_seg = segment_sz;
			totfound += segment_sz;
			num++;
			start = last_sect + 1ULL;
		}
	} while (first_sect);

done:
	if (nsegments)
		*nsegments = num;
	if (largest_segment)
		*largest_segment = largest_seg;

	return totfound;
}

/* Deinitialize fdisk-specific variables */
static void gpt_deinit(struct fdisk_label *lb)
{
	struct fdisk_gpt_label *gpt = (struct fdisk_gpt_label *) lb;

	if (!gpt)
		return;

	free(gpt->ents);
	free(gpt->pheader);
	free(gpt->bheader);

	gpt->ents = NULL;
	gpt->pheader = NULL;
	gpt->bheader = NULL;
}

static int gpt_probe_label(struct fdisk_context *cxt)
{
	int mbr_type;
	struct fdisk_gpt_label *gpt;

	gpt = self_label(cxt);

	/* TODO: it would be nice to support scenario when GPT headers are OK,
	 *       but PMBR is corrupt */
	mbr_type = valid_pmbr(cxt);
	if (!mbr_type)
		goto failed;

	/* primary header */
	gpt->pheader = gpt_read_header(cxt, GPT_PRIMARY_PARTITION_TABLE_LBA,
				       &gpt->ents);

	if (gpt->pheader)
		/* primary OK, try backup from alternative LBA */
		gpt->bheader = gpt_read_header(cxt,
					le64_to_cpu(gpt->pheader->alternative_lba),
					NULL);
	else
		/* primary corrupted -- try last LBA */
		gpt->bheader = gpt_read_header(cxt, gpt_last_lba(cxt), &gpt->ents);

	if (!gpt->pheader && !gpt->bheader)
		goto failed;

	/* primary OK, backup corrupted -- recovery */
	if (gpt->pheader && !gpt->bheader) {
		fdisk_warnx(cxt, "The backup GPT table is corrupt, but the "
				  "primary appears OK, so that will be used.");
		gpt->bheader = gpt_copy_header(cxt, gpt->pheader);
		if (!gpt->bheader)
			goto failed;
		gpt_recompute_crc(gpt->bheader, gpt->ents);
		fdisk_label_set_changed1(cxt->label);

	/* primary corrupted, backup OK -- recovery */
	} else if (!gpt->pheader && gpt->bheader) {
		fdisk_warnx(cxt, "The primary GPT table is corrupt, but the "
				  "backup appears OK, so that will be used.");
		gpt->pheader = gpt_copy_header(cxt, gpt->bheader);
		if (!gpt->pheader)
			goto failed;
		gpt_recompute_crc(gpt->pheader, gpt->ents);
		fdisk_label_set_changed1(cxt->label);
	}

	/* The headers make be correct, but Backup do not have to be on the end
	 * of the device (due to device resize, etc.). Let's fix this issue. */
	if (le64_to_cpu(gpt->pheader->alternative_lba) > cxt->total_sectors ||
	    le64_to_cpu(gpt->pheader->alternative_lba) < cxt->total_sectors - 1ULL) {
		fdisk_warnx(cxt, "The backup GPT table is not on the end of the device. "
				   "This problem will be corrected by write.");

		gpt_fix_alternative_lba(cxt, gpt);
		gpt_recompute_crc(gpt->bheader, gpt->ents);
		gpt_recompute_crc(gpt->pheader, gpt->ents);
		fdisk_label_set_changed1(cxt->label);
	}

	cxt->label->nparts_max = gpt_get_nentries(gpt);
	cxt->label->nparts_cur = partitions_in_use(gpt);
	return 1;
failed:
	gpt_deinit(cxt->label);
	return 0;
}

/* Stolen from libblkid - can be removed once partition semantics
 * are added to the fdisk API. */
static char *encode_to_utf8(unsigned char *src, size_t count)
{
	uint16_t c;
	char *dest;
	size_t i, j;
	size_t len = count * 3 / 2;

	dest = zmalloc(len + 1);
	for (j = i = 0; i + 2 <= count; i += 2) {
		/* always little endian */
		c = (src[i+1] << 8) | src[i];
		if (c == 0) {
			break;
		} else if (c < 0x80) {
			if (j+1 > len)
				break;
			dest[j++] = (uint8_t) c;
		} else if (c < 0x800) {
			if (j+2 > len)
				break;
			dest[j++] = (uint8_t) (0xc0 | (c >> 6));
			dest[j++] = (uint8_t) (0x80 | (c & 0x3f));
		} else {
			if (j+3 > len)
				break;
			dest[j++] = (uint8_t) (0xe0 | (c >> 12));
			dest[j++] = (uint8_t) (0x80 | ((c >> 6) & 0x3f));
			dest[j++] = (uint8_t) (0x80 | (c & 0x3f));
		}
	}

	return dest;
}

static int gpt_entry_attrs_to_string(struct gpt_entry *e, char **res)
{
	unsigned int n, count = 0;
	size_t l;
	char *bits, *p;
	uint64_t attrs;

	*res = NULL;
	attrs = e->attrs;
	if (!attrs)
		return 0;       /* no attributes at all */

	bits = (char *) &attrs;

	/* Note that sizeof() is correct here, we need separators between
	 * the strings so also count \0 is correct */
	*res = zmalloc(sizeof(GPT_ATTRSTR_NOBLOCK) +
			 sizeof(GPT_ATTRSTR_REQ) +
			 sizeof(GPT_ATTRSTR_LEGACY) +
			 sizeof("GUID:") + (GPT_ATTRBIT_GUID_COUNT * 3));
	p = *res;
	if (isset(bits, GPT_ATTRBIT_REQ)) {
		memcpy(p, GPT_ATTRSTR_REQ, (l = sizeof(GPT_ATTRSTR_REQ)));
		p += l - 1;
	}
	if (isset(bits, GPT_ATTRBIT_NOBLOCK)) {
		if (p > *res)
			*p++ = ' ';
		memcpy(p, GPT_ATTRSTR_NOBLOCK, (l = sizeof(GPT_ATTRSTR_NOBLOCK)));
		p += l - 1;
	}
	if (isset(bits, GPT_ATTRBIT_LEGACY)) {
		if (p > *res)
			*p++ = ' ';
		memcpy(p, GPT_ATTRSTR_LEGACY, (l = sizeof(GPT_ATTRSTR_LEGACY)));
		p += l - 1;
	}

	for (n = GPT_ATTRBIT_GUID_FIRST;
	     n < GPT_ATTRBIT_GUID_FIRST + GPT_ATTRBIT_GUID_COUNT; n++) {

		if (!isset(bits, n))
			continue;
		if (!count) {
			if (p > *res)
				*p++ = ' ';
			p += sprintf(p, "GUID:%u", n);
		} else
			p += sprintf(p, ",%u", n);
		count++;
	}

	return 0;
}

static int gpt_entry_attrs_from_string(
			struct fdisk_context *cxt,
			struct gpt_entry *e,
			const char *str)
{
	const char *p = str;
	uint64_t attrs = 0;
	char *bits;

	bits = (char *) &attrs;

	while (p && *p) {
		int bit = -1;

		while (isblank(*p)) p++;
		if (!*p)
			break;

		if (strncmp(p, GPT_ATTRSTR_REQ,
					sizeof(GPT_ATTRSTR_REQ) - 1) == 0) {
			bit = GPT_ATTRBIT_REQ;
			p += sizeof(GPT_ATTRSTR_REQ) - 1;
		} else if (strncmp(p, GPT_ATTRSTR_REQ_TYPO,
					sizeof(GPT_ATTRSTR_REQ_TYPO) - 1) == 0) {
			bit = GPT_ATTRBIT_REQ;
			p += sizeof(GPT_ATTRSTR_REQ_TYPO) - 1;
		} else if (strncmp(p, GPT_ATTRSTR_LEGACY,
					sizeof(GPT_ATTRSTR_LEGACY) - 1) == 0) {
			bit = GPT_ATTRBIT_LEGACY;
			p += sizeof(GPT_ATTRSTR_LEGACY) - 1;
		} else if (strncmp(p, GPT_ATTRSTR_NOBLOCK,
					sizeof(GPT_ATTRSTR_NOBLOCK) - 1) == 0) {
			bit = GPT_ATTRBIT_NOBLOCK;
			p += sizeof(GPT_ATTRSTR_NOBLOCK) - 1;

		/* GUID:<bit> as well as <bit> */
		} else if (isdigit((unsigned char) *p)
			   || (strncmp(p, "GUID:", 5) == 0
			       && isdigit((unsigned char) *(p + 5)))) {
			char *end = NULL;

			if (*p == 'G')
				p += 5;

			bit = bb_xparse_ui_number(BB_PN_SILENT_RE |
					BB_PN_SET_LOWER | BB_PN_SET_UPPER | BB_PN_END_PTR,
					p, GPT_ATTRBIT_GUID_FIRST,
					GPT_ATTRBIT_GUID_FIRST + GPT_ATTRBIT_GUID_COUNT - 1,
					&end);
			if (bit > 0)
				p = end;
		}

		if (bit < 0) {
			fdisk_warnx(cxt, "unsupported GPT attribute bit '%s'", p);
			return -EINVAL;
		}

		if (*p && *p != ',' && !isblank(*p)) {
			fdisk_warnx(cxt, "failed to parse GPT attribute string '%s'", str);
			return -EINVAL;
		}

		setbit(bits, bit);

		while (isblank(*p)) p++;
		if (*p == ',')
			p++;
	}

	e->attrs = attrs;
	return 0;
}

static int gpt_get_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_entry *e;
	char u_str[UUID_STR_LEN];
	int rc = 0;
	struct gpt_guid guid;

	gpt = self_label(cxt);

	if (n >= gpt_get_nentries(gpt))
		return -EINVAL;

	gpt = self_label(cxt);
	e = gpt_get_entry(gpt, n);

	pa->used = gpt_entry_is_used(e) || gpt_partition_start(e);
	if (!pa->used)
		return 0;

	pa->start = gpt_partition_start(e);
	pa->size = gpt_partition_size(e);
	pa->type = gpt_partition_parttype(cxt, e);

	guid = e->partition_guid;
	if (guid_to_string(&guid, u_str)) {
		pa->uuid = xstrdup(u_str);
	} else
		pa->uuid = NULL;

	rc = gpt_entry_attrs_to_string(e, &pa->attrs);
	if (rc)
		goto done;

	pa->name = encode_to_utf8((unsigned char *)e->name, sizeof(e->name));
	return 0;
done:
	fdisk_reset_partition(pa);
	return rc;
}


static int gpt_set_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_entry *e;
	int rc = 0;
	uint64_t start, end;

	gpt = self_label(cxt);

	if (n >= gpt_get_nentries(gpt))
		return -EINVAL;

	FDISK_INIT_UNDEF(start);
	FDISK_INIT_UNDEF(end);

	gpt = self_label(cxt);
	e = gpt_get_entry(gpt, n);

	if (pa->uuid) {
		char new_u[UUID_STR_LEN], old_u[UUID_STR_LEN];
		struct gpt_guid guid;

		guid = e->partition_guid;
		guid_to_string(&guid, old_u);
		rc = gpt_entry_set_uuid(e, pa->uuid);
		if (rc)
			return rc;
		guid = e->partition_guid;
		guid_to_string(&guid, new_u);
		fdisk_info(cxt, "Partition UUID changed from %s to %s.",
			old_u, new_u);
	}

	if (pa->name) {
		int len;
		char *old = encode_to_utf8((unsigned char *)e->name, sizeof(e->name));
		len = gpt_entry_set_name(e, pa->name);
		if (len < 0)
			fdisk_warn(cxt, "Failed to translate partition name, name not changed.");
		else
			fdisk_info(cxt, "Partition name changed from '%s' to '%.*s'.",
				old, len, pa->name);
		free(old);
	}

	if (pa->type && pa->type->typestr) {
		struct gpt_guid typeid;

		rc = string_to_guid(pa->type->typestr, &typeid);
		if (rc)
			return rc;
		gpt_entry_set_type(e, &typeid);
	}
	if (pa->attrs) {
		rc = gpt_entry_attrs_from_string(cxt, e, pa->attrs);
		if (rc)
			return rc;
	}

	if (fdisk_partition_has_start(pa))
		start = pa->start;
	if (fdisk_partition_has_size(pa) || fdisk_partition_has_start(pa)) {
		uint64_t xstart = fdisk_partition_has_start(pa) ? pa->start : gpt_partition_start(e);
		uint64_t xsize  = fdisk_partition_has_size(pa)  ? pa->size  : gpt_partition_size(e);
		end = xstart + xsize - 1ULL;
	}

	if (!FDISK_IS_UNDEF(start)) {
		if (start < le64_to_cpu(gpt->pheader->first_usable_lba)) {
			fdisk_warnx(cxt, "The start of the partition understeps FirstUsableLBA.");
			return -EINVAL;
		}
		e->lba_start = cpu_to_le64(start);
	}
	if (!FDISK_IS_UNDEF(end)) {
		if (end > le64_to_cpu(gpt->pheader->last_usable_lba)) {
			fdisk_warnx(cxt, "The end of the partition oversteps LastUsableLBA.");
			return -EINVAL;
		}
		e->lba_end = cpu_to_le64(end);
	}
	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	fdisk_label_set_changed1(cxt->label);
	return rc;
}

/* Write partitions.
 * Returns 0 on success, or corresponding error otherwise. */
static int gpt_write_partitions(struct fdisk_context *cxt,
				struct gpt_header *header, unsigned char *ents)
{
	off_t offset = (off_t) le64_to_cpu(header->partition_entry_lba) * cxt->sector_size;
	size_t towrite = 0;
	ssize_t ssz;
	int rc;

	rc = gpt_sizeof_ents(header, &towrite);
	if (rc)
		return rc;

	if (offset != lseek(cxt->dev_fd, offset, SEEK_SET))
		return -errno;

	ssz = write(cxt->dev_fd, ents, towrite);
	if (ssz < 0 || (ssize_t) towrite != ssz)
		return -errno;

	return 0;
}

/* Write a GPT header to a specified LBA.
 *
 * We read all sector, so we have to write all sector back
 * to the device -- never ever rely on sizeof(struct gpt_header)!
 *
 * Returns 0 on success, or corresponding error otherwise. */
static int gpt_write_header(struct fdisk_context *cxt,
			    struct gpt_header *header, uint64_t lba)
{
	off_t offset = lba * cxt->sector_size;

	if (offset != lseek(cxt->dev_fd, offset, SEEK_SET))
		goto fail;
	if (cxt->sector_size ==
	    (size_t) write(cxt->dev_fd, header, cxt->sector_size))
		return 0;
fail:
	return -errno;
}

/* Write the protective MBR.
 *  Returns 0 on success, or corresponding error otherwise. */
static int gpt_write_pmbr(struct fdisk_context *cxt)
{
	off_t offset;
	struct gpt_legacy_mbr *pmbr;

	pmbr = (struct gpt_legacy_mbr *) cxt->firstsector;

	/* zero out the legacy partitions */
	memset(pmbr->partition_record, 0, sizeof(pmbr->partition_record));

	pmbr->signature = cpu_to_le16(MSDOS_MBR_SIGNATURE);
	pmbr->partition_record[0].os_type      = EFI_PMBR_OSTYPE;
	pmbr->partition_record[0].start_sector = 2;
	pmbr->partition_record[0].end_head     = 0xFF;
	pmbr->partition_record[0].end_sector   = 0xFF;
	pmbr->partition_record[0].end_track    = 0xFF;
	pmbr->partition_record[0].starting_lba = cpu_to_le32(1);

	/* Set size_in_lba to the size of the disk minus one. If the size of the disk
	 * is too large to be represented by a 32bit LBA (2Tb), set it to 0xFFFFFFFF. */
	if (cxt->total_sectors - 1ULL > 0xFFFFFFFFULL)
		pmbr->partition_record[0].size_in_lba = cpu_to_le32(0xFFFFFFFF);
	else
		pmbr->partition_record[0].size_in_lba =
			cpu_to_le32((uint32_t) (cxt->total_sectors - 1ULL));

	offset = GPT_PMBR_LBA * cxt->sector_size;
	if (offset != lseek(cxt->dev_fd, offset, SEEK_SET))
		goto fail;

	/* pMBR covers the first sector (LBA) of the disk */
	if (write_all(cxt->dev_fd, pmbr, cxt->sector_size))
		goto fail;
	return 0;
fail:
	return -errno;
}

/* Writes in-memory GPT and pMBR data to disk.
 * Returns 0 if successful write, otherwise, a corresponding error.
 * Any indication of error will abort the operation. */
static int gpt_write_disklabel(struct fdisk_context *cxt)
{
	struct fdisk_gpt_label *gpt;
	int mbr_type;

	gpt = self_label(cxt);
	mbr_type = valid_pmbr(cxt);

	/* check that disk is big enough to handle the backup header */
	if (le64_to_cpu(gpt->pheader->alternative_lba) > cxt->total_sectors)
		goto err0;

	/* check that the backup header is properly placed */
	if (le64_to_cpu(gpt->pheader->alternative_lba) < cxt->total_sectors - 1ULL)
		goto err0;

	if (check_overlap_partitions(gpt))
		goto err0;

	/* recompute CRCs for both headers */
	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	/* UEFI requires writing in this specific order:
	 *   1) backup partition tables
	 *   2) backup GPT header
	 *   3) primary partition tables
	 *   4) primary GPT header
	 *   5) protective MBR
	 *
	 * If any write fails, we abort the rest. */
	if (gpt_write_partitions(cxt, gpt->bheader, gpt->ents) != 0)
		goto err1;
	if (gpt_write_header(cxt, gpt->bheader,
			     le64_to_cpu(gpt->pheader->alternative_lba)) != 0)
		goto err1;
	if (gpt_write_partitions(cxt, gpt->pheader, gpt->ents) != 0)
		goto err1;
	if (gpt_write_header(cxt, gpt->pheader, GPT_PRIMARY_PARTITION_TABLE_LBA) != 0)
		goto err1;

	if (mbr_type == GPT_MBR_HYBRID)
		fdisk_warnx(cxt, "The device contains hybrid MBR -- writing GPT only. "
				   "You have to sync the MBR manually.");
	else if (gpt_write_pmbr(cxt) != 0)
		goto err1;

	return 0;
err0:
	errno = EINVAL;
	return -EINVAL;
err1:
	return -errno;
}

/* Verify data integrity and report any found problems for:
 *   - primary and backup header validations
 *   - partition validations */
static int gpt_verify_disklabel(struct fdisk_context *cxt)
{
	int nerror = 0;
	unsigned int ptnum;
	struct fdisk_gpt_label *gpt;

	gpt = self_label(cxt);
	if (!gpt)
		return -EINVAL;

	if (!gpt->bheader) {
		nerror++;
		fdisk_warnx(cxt, "Disk does not contain a valid backup header.");
	}

	if (!gpt_check_header_crc(gpt->pheader, gpt->ents)) {
		nerror++;
		fdisk_warnx(cxt, "Invalid primary header CRC checksum.");
	}
	if (gpt->bheader && !gpt_check_header_crc(gpt->bheader, gpt->ents)) {
		nerror++;
		fdisk_warnx(cxt, "Invalid backup header CRC checksum.");
	}

	if (!gpt_check_entryarr_crc(gpt->pheader, gpt->ents)) {
		nerror++;
		fdisk_warnx(cxt, "Invalid partition entry checksum.");
	}

	if (!gpt_check_lba_sanity(cxt, gpt->pheader)) {
		nerror++;
		fdisk_warnx(cxt, "Invalid primary header LBA sanity checks.");
	}
	if (gpt->bheader && !gpt_check_lba_sanity(cxt, gpt->bheader)) {
		nerror++;
		fdisk_warnx(cxt, "Invalid backup header LBA sanity checks.");
	}

	if (le64_to_cpu(gpt->pheader->my_lba) != GPT_PRIMARY_PARTITION_TABLE_LBA) {
		nerror++;
		fdisk_warnx(cxt, "MyLBA mismatch with real position at primary header.");
	}
	if (gpt->bheader && le64_to_cpu(gpt->bheader->my_lba) != gpt_last_lba(cxt)) {
		nerror++;
		fdisk_warnx(cxt, "MyLBA mismatch with real position at backup header.");

	}
	if (le64_to_cpu(gpt->pheader->alternative_lba) >= cxt->total_sectors) {
		nerror++;
		fdisk_warnx(cxt, "Disk is too small to hold all data.");
	}

	/* if the GPT is the primary table, check the alternateLBA
	 * to see if it is a valid GPT */
	if (gpt->bheader && (le64_to_cpu(gpt->pheader->my_lba) !=
			     le64_to_cpu(gpt->bheader->alternative_lba))) {
		nerror++;
		fdisk_warnx(cxt, "Primary and backup header mismatch.");
	}

	ptnum = check_overlap_partitions(gpt);
	if (ptnum) {
		nerror++;
		fdisk_warnx(cxt, "Partition %u overlaps with partition %u.",
				ptnum, ptnum+1);
	}

	ptnum = check_too_big_partitions(gpt, cxt->total_sectors);
	if (ptnum) {
		nerror++;
		fdisk_warnx(cxt, "Partition %u is too big for the disk.",
				ptnum);
	}

	ptnum = check_start_after_end_partitions(gpt);
	if (ptnum) {
		nerror++;
		fdisk_warnx(cxt, "Partition %u ends before it starts.",
				ptnum);
	}

	if (!nerror) { /* yay :-) */
		uint32_t nsegments = 0;
		uint64_t free_sectors = 0, largest_segment = 0;
		char sths_buf[SIZE_TO_HUMAN_STRING_BUFSIZ];

		fdisk_info(cxt, "No errors detected.");
		fdisk_info(cxt, "Header version: %s", gpt_get_header_revstr(gpt->pheader));
		fdisk_info(cxt, "Using %zu out of %zu partitions.",
		       partitions_in_use(gpt),
		       gpt_get_nentries(gpt));

		free_sectors = get_free_sectors(cxt, gpt, &nsegments, &largest_segment);
		if (largest_segment) {
			size_to_human_string(SIZE_SUFFIX_SPACE | SIZE_SUFFIX_3LETTER,
					largest_segment * cxt->sector_size, sths_buf);
		} else {
			strcpy(sths_buf, "0");
		}

		fdisk_info(cxt,
			   P_("A total of %ju free sectors is available in %u segment.",
			      "A total of %ju free sectors is available in %u segments "
			      "(the largest is %s).", nsegments),
			   free_sectors, nsegments, sths_buf);
	} else
		fdisk_warnx(cxt,
			P_("%d error detected.", "%d errors detected.", nerror),
			nerror);

	return 0;
}

/* Delete a single GPT partition, specified by partnum. */
static int gpt_delete_partition(struct fdisk_context *cxt,
				size_t partnum)
{
	struct fdisk_gpt_label *gpt;

	gpt = self_label(cxt);

	if (partnum >= cxt->label->nparts_max)
		return -EINVAL;

	if (!gpt_entry_is_used(gpt_get_entry(gpt, partnum)))
		return -EINVAL;

	/* hasta la vista, baby! */
	gpt_zeroize_entry(gpt, partnum);

	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);
	cxt->label->nparts_cur--;
	fdisk_label_set_changed1(cxt->label);

	return 0;
}


/* Performs logical checks to add a new partition entry */
static int gpt_add_partition(
		struct fdisk_context *cxt,
		struct fdisk_partition *pa,
		size_t *partno)
{
	uint64_t user_f, user_l;        /* user input ranges for first and last sectors */
	uint64_t disk_f, disk_l;        /* first and last available sector ranges on device */
	uint64_t dflt_f, dflt_l;        /* largest segment (default) */
	struct gpt_guid typeid;
	struct fdisk_gpt_label *gpt;
	struct gpt_header *pheader;
	struct gpt_entry *e;
	struct fdisk_ask *ask = NULL;
	size_t partnum;
	int rc;

	gpt = self_label(cxt);

	pheader = gpt->pheader;

	rc = fdisk_partition_next_partno(pa, cxt, &partnum);
	if (rc)
		return rc;

	if (gpt_entry_is_used(gpt_get_entry(gpt, partnum))) {
		fdisk_warnx(cxt, "Partition %zu is already defined.  "
				   "Delete it before re-adding it.", partnum +1);
		return -ERANGE;
	}
	if (gpt_get_nentries(gpt) == partitions_in_use(gpt)) {
		fdisk_warnx(cxt, "All partitions are already in use.");
		return -ENOSPC;
	}
	if (!get_free_sectors(cxt, gpt, NULL, NULL)) {
		fdisk_warnx(cxt, "No free sectors available.");
		return -ENOSPC;
	}

	rc = string_to_guid(pa && pa->type && pa->type->typestr ?
				pa->type->typestr:
				GPT_DEFAULT_ENTRY_TYPE, &typeid);
	if (rc)
		return rc;

	disk_f = find_first_available(gpt, le64_to_cpu(pheader->first_usable_lba));
	e = gpt_get_entry(gpt, 0);

	/* if first sector no explicitly defined then ignore small gaps before
	 * the first partition */
	if ((!pa || !fdisk_partition_has_start(pa))
	    && gpt_entry_is_used(e)
	    && disk_f < gpt_partition_start(e)) {

		do {
			uint64_t x;
			disk_f = find_first_available(gpt, disk_f);
			if (!disk_f)
				break;
			x = find_last_free(gpt, disk_f);
			if (x - disk_f >= cxt->grain / cxt->sector_size)
				break;
			disk_f = x + 1ULL;
		} while(1);

		if (disk_f == 0)
			disk_f = find_first_available(gpt, le64_to_cpu(pheader->first_usable_lba));
	}

	e = NULL;
	disk_l = find_last_free_sector(gpt);

	/* the default is the largest free space */
	dflt_f = find_first_in_largest(gpt);
	dflt_l = find_last_free(gpt, dflt_f);

	/* align the default in range <dflt_f,dflt_l> */
	dflt_f = fdisk_align_lba_in_range(cxt, dflt_f, dflt_f, dflt_l);

	/* first sector */
	if (pa && pa->start_follow_default) {
		user_f = dflt_f;

	} else if (pa && fdisk_partition_has_start(pa)) {
		if (pa->start != find_first_available(gpt, pa->start)) {
			fdisk_warnx(cxt, "Sector %ju already used.",  (uintmax_t)pa->start);
			return -ERANGE;
		}
		user_f = pa->start;
	} else {
		/*  ask by dialog */
		for (;;) {
			if (!ask)
				ask = fdisk_new_ask();
			else
				fdisk_reset_ask(ask);
			/* First sector */
			fdisk_ask_set_query(ask, "First sector");
			fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);
			fdisk_ask_number_set_low(ask,     disk_f);      /* minimal */
			fdisk_ask_number_set_default(ask, dflt_f);      /* default */
			fdisk_ask_number_set_high(ask,    disk_l);      /* maximal */

			rc = fdisk_do_ask(cxt, ask);
			if (rc)
				goto done;

			user_f = fdisk_ask_number_get_result(ask);
			if (user_f != find_first_available(gpt, user_f)) {
				fdisk_warnx(cxt, "Sector %ju already used.", user_f);
				continue;
			}
			break;
		}
	}


	/* Last sector */
	dflt_l = find_last_free(gpt, user_f);

	if (pa && pa->end_follow_default) {
		user_l = dflt_l;

	} else if (pa && fdisk_partition_has_size(pa)) {
		user_l = user_f + pa->size - 1;

		if (user_l != dflt_l
		    && !pa->size_explicit
		    && alignment_required(cxt)
		    && user_l - user_f > (cxt->grain / fdisk_get_sector_size(cxt))) {

			user_l = fdisk_align_lba_in_range(cxt, user_l, user_f, dflt_l);
			if (user_l > user_f)
				user_l -= 1ULL;
		}
	} else {
		for (;;) {
			if (!ask)
				ask = fdisk_new_ask();
			else
				fdisk_reset_ask(ask);
			fdisk_ask_set_query(ask, "Last sector, +/-sectors or +/-size{K,M,G,T,P}");
			fdisk_ask_set_type(ask, FDISK_ASKTYPE_OFFSET);
			fdisk_ask_number_set_low(ask,     user_f);      /* minimal */
			fdisk_ask_number_set_default(ask, dflt_l);      /* default */
			fdisk_ask_number_set_high(ask,    dflt_l);      /* maximal */
			fdisk_ask_number_set_base(ask,    user_f);      /* base for relative input */
			fdisk_ask_number_set_unit(ask,    cxt->sector_size);
			fdisk_ask_number_set_wrap_negative1(ask);     /* wrap negative around high */

			rc = fdisk_do_ask(cxt, ask);
			if (rc)
				goto done;

			user_l = fdisk_ask_number_get_result(ask);
			if (fdisk_ask_number_is_relative(ask)) {
				user_l = fdisk_align_lba_in_range(cxt, user_l, user_f, dflt_l);
				if (user_l > user_f)
					user_l -= 1ULL;
			}

			if (user_l >= user_f && user_l <= disk_l)
				break;

			fdisk_warnx(cxt, "Value out of range.");
		}
	}


	if (user_f > user_l || partnum >= cxt->label->nparts_max) {
		fdisk_warnx(cxt, "Could not create partition %zu", partnum + 1);
		rc = -EINVAL;
		goto done;
	}

	/* Be paranoid and check against on-disk setting rather than against libfdisk cxt */
	if (user_l > le64_to_cpu(pheader->last_usable_lba)) {
		fdisk_warnx(cxt, "The last usable GPT sector is %ju, but %ju is requested.",
				le64_to_cpu(pheader->last_usable_lba), user_l);
		rc = -EINVAL;
		goto done;
	}

	if (user_f < le64_to_cpu(pheader->first_usable_lba)) {
		fdisk_warnx(cxt, "The first usable GPT sector is %ju, but %ju is requested.",
				le64_to_cpu(pheader->first_usable_lba), user_f);
		rc = -EINVAL;
		goto done;
	}

	e = gpt_get_entry(gpt, partnum);
	e->lba_end = cpu_to_le64(user_l);
	e->lba_start = cpu_to_le64(user_f);

	gpt_entry_set_type(e, &typeid);

	if (pa && pa->uuid) {
		/* Sometimes it's necessary to create a copy of the PT and
		 * reuse already defined UUID */
		rc = gpt_entry_set_uuid(e, pa->uuid);
		if (rc)
			goto done;
	} else {
		/* Any time a new partition entry is created a new GUID must be
		 * generated for that partition, and every partition is guaranteed
		 * to have a unique GUID. */
		struct gpt_guid guid;

		uuid_generate((unsigned char *) &e->partition_guid);
		guid = e->partition_guid;
		swap_efi_guid_gpt(&guid);
	}

	if (pa && pa->name && *pa->name)
		gpt_entry_set_name(e, pa->name);
	if (pa && pa->attrs)
		gpt_entry_attrs_from_string(cxt, e, pa->attrs);

	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	/* report result */
	{
		struct fdisk_parttype *t;

		cxt->label->nparts_cur++;
		fdisk_label_set_changed1(cxt->label);

		t = gpt_partition_parttype(cxt, e);
		fdisk_info_new_partition(cxt, partnum + 1, user_f, user_l, t);
		fdisk_unref_parttype(t);
	}

	rc = 0;
	if (partno)
		*partno = partnum;
done:
	fdisk_unref_ask(ask);
	return rc;
}

/* Create a new GPT disklabel - destroys any previous data. */
static int gpt_create_disklabel(struct fdisk_context *cxt)
{
	int rc = 0;
	size_t esz = 0;
	char str[UUID_STR_LEN];
	struct fdisk_gpt_label *gpt;
	struct gpt_guid guid;

	gpt = self_label(cxt);

	/* When no header, entries or pmbr is set, we're probably
	 * dealing with a new, empty disk - so always allocate memory
	 * to deal with the data structures whatever the case is. */
	rc = gpt_mknew_pmbr(cxt);
	if (rc < 0)
		goto done;

	/* primary */
	gpt->pheader = zmalloc(cxt->sector_size);
	rc = gpt_mknew_header(cxt, gpt->pheader, GPT_PRIMARY_PARTITION_TABLE_LBA);
	if (rc < 0)
		goto done;

	/* backup ("copy" primary) */
	gpt->bheader = zmalloc(cxt->sector_size);
	rc = gpt_mknew_header_from_bkp(cxt, gpt->bheader,
			gpt_last_lba(cxt), gpt->pheader);
	if (rc < 0)
		goto done;

	rc = gpt_sizeof_ents(gpt->pheader, &esz);
	if (rc)
		goto done;
	gpt->ents = zmalloc(esz);
	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	cxt->label->nparts_max = gpt_get_nentries(gpt);
	cxt->label->nparts_cur = 0;

	guid = gpt->pheader->disk_guid;
	guid_to_string(&guid, str);
	fdisk_label_set_changed1(cxt->label);
	fdisk_info(cxt, "Created a new GPT disklabel (GUID: %s).", str);
done:
	return rc;
}

static int gpt_set_disklabel_id(struct fdisk_context *cxt)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_guid uuid;
	char *str, *old, *new;
	int rc;

	gpt = self_label(cxt);
	if (fdisk_ask_string(cxt, "Enter new disk UUID (in 8-4-4-4-12 format)", &str))
		return -EINVAL;

	rc = string_to_guid(str, &uuid);
	free(str);

	if (rc) {
		fdisk_warnx(cxt, "Failed to parse your UUID.");
		return rc;
	}

	old = gpt_get_header_id(gpt->pheader);

	gpt->pheader->disk_guid = uuid;
	gpt->bheader->disk_guid = uuid;

	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	new = gpt_get_header_id(gpt->pheader);

	fdisk_info(cxt, "Disk identifier changed from %s to %s.", old, new);

	free(old);
	free(new);
	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int gpt_check_table_overlap(struct fdisk_context *cxt,
				   uint64_t first_usable,
				   uint64_t last_usable)
{
	struct fdisk_gpt_label *gpt = self_label(cxt);
	size_t i;
	int rc = 0;

	/* First check if there's enough room for the table. last_lba may have wrapped */
	if (first_usable > cxt->total_sectors || /* far too little space */
	    last_usable > cxt->total_sectors || /* wrapped */
	    first_usable > last_usable) { /* too little space */
		fdisk_warnx(cxt, "Not enough space for new partition table!");
		return -ENOSPC;
	}

	/* check that all partitions fit in the remaining space */
	for (i = 0; i < gpt_get_nentries(gpt); i++) {
		struct gpt_entry *e = gpt_get_entry(gpt, i);

		if (!gpt_entry_is_used(e))
			continue;
		if (gpt_partition_start(e) < first_usable) {
			fdisk_warnx(cxt, "Partition #%zu out of range (minimal start is %"PRIu64" sectors)",
				    i + 1, first_usable);
			rc = -EINVAL;
		}
		if (gpt_partition_end(e) > last_usable) {
			fdisk_warnx(cxt, "Partition #%zu out of range (maximal end is %"PRIu64" sectors)",
				    i + 1, last_usable - 1ULL);
			rc = -EINVAL;
		}
	}
	return rc;
}

/**
 * fdisk_set_last_lba:
 * @cxt: fdisk context
 * @lba: last possible logical sector
 *
 * It's strongly recommended to use the default library setting. The last LBA
 * is always reset by fdisk_assign_device(), fdisk_override_geometry() and
 * fdisk_reset_alignment().
 *
 * The default is number of sectors on the device, but maybe modified by the
 * current disklabel driver (for example GPT uses the end of disk for backup
 * header, so last_lba is smaller than total number of sectors).
 *
 * Returns: 0 on success, <0 on error. */
static fdisk_sector_t fdisk_set_last_lba(struct fdisk_context *cxt, fdisk_sector_t lba)
{
	if (lba > cxt->total_sectors - 1 || lba < 1)
		return -ERANGE;
	cxt->last_lba = lba;
	return 0;
}

/* Elarge GPT entries array if possible. The function check if an existing
 * partition does not overlap the entries array area. If yes, then it report
 * warning and returns -EINVAL.
 *
 * Returns: 0 on success, < 0 on error. */
static int fdisk_gpt_set_npartitions(struct fdisk_context *cxt, uint32_t entries)
{
	struct fdisk_gpt_label *gpt;
	size_t old_size, new_size;
	uint32_t old;
	uint64_t first_usable, last_usable;
	int rc;

	if (!fdisk_is_label(cxt, GPT))
		return -EINVAL;

	gpt = self_label(cxt);

	old = le32_to_cpu(gpt->pheader->npartition_entries);
	if (old == entries)
		return 0;       /* do nothing, say nothing */

	/* calculate the size (bytes) of the entries array */
	rc = gpt_calculate_sizeof_ents(gpt->pheader, entries, &new_size);
	if (rc) {
		fdisk_warnx(cxt, "The number of the partition has to be smaller than %zu.",
				UINT32_MAX / le32_to_cpu(gpt->pheader->sizeof_partition_entry));
		return rc;
	}

	rc = gpt_calculate_sizeof_ents(gpt->pheader, old, &old_size);
	if (rc)
		return rc;

	/* calculate new range of usable LBAs */
	first_usable = (uint64_t) (new_size / cxt->sector_size) + 2ULL;
	last_usable = cxt->total_sectors - 2ULL - (uint64_t) (new_size / cxt->sector_size);

	/* if expanding the table, first check that everything fits,
	 * then allocate more memory and zero. */
	if (entries > old) {
		unsigned char *ents;

		rc = gpt_check_table_overlap(cxt, first_usable, last_usable);
		if (rc)
			return rc;
		ents = xrealloc(gpt->ents, new_size);
		memset(ents + old_size, 0, new_size - old_size);
		gpt->ents = ents;
	}

	/* everything's ok, apply the new size */
	gpt->pheader->npartition_entries = cpu_to_le32(entries);
	gpt->bheader->npartition_entries = cpu_to_le32(entries);

	/* usable LBA addresses will have changed */
	fdisk_set_first_lba(cxt, first_usable);
	fdisk_set_last_lba(cxt, last_usable);
	gpt->pheader->first_usable_lba = cpu_to_le64(first_usable);
	gpt->bheader->first_usable_lba = cpu_to_le64(first_usable);
	gpt->pheader->last_usable_lba = cpu_to_le64(last_usable);
	gpt->bheader->last_usable_lba = cpu_to_le64(last_usable);


	/* The backup header must be recalculated */
	gpt_mknew_header_common(cxt, gpt->bheader, le64_to_cpu(gpt->pheader->alternative_lba));

	/* CRCs will have changed */
	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);

	/* update library info */
	cxt->label->nparts_max = gpt_get_nentries(gpt);

	fdisk_info(cxt, "Partition table length changed from %"PRIu32" to %"PRIu64".", old, entries);

	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int gpt_part_is_used(struct fdisk_context *cxt, size_t i)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_entry *e;

	gpt = self_label(cxt);

	if (i >= gpt_get_nentries(gpt))
		return 0;

	e = gpt_get_entry(gpt, i);

	return gpt_entry_is_used(e) || gpt_partition_start(e);
}


static int gpt_toggle_partition_flag(
		struct fdisk_context *cxt,
		size_t i,
		unsigned long flag)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_entry *e;
	uint64_t attrs;
	uintmax_t tmp;
	char *bits;
	const char *name = NULL;
	int bit = -1, rc;

	gpt = self_label(cxt);

	if (i >= gpt_get_nentries(gpt))
		return -EINVAL;

	e = gpt_get_entry(gpt, i);
	attrs = e->attrs;
	bits = (char *) &attrs;

	switch (flag) {
	case GPT_FLAG_REQUIRED:
		bit = GPT_ATTRBIT_REQ;
		name = GPT_ATTRSTR_REQ;
		break;
	case GPT_FLAG_NOBLOCK:
		bit = GPT_ATTRBIT_NOBLOCK;
		name = GPT_ATTRSTR_NOBLOCK;
		break;
	case GPT_FLAG_LEGACYBOOT:
		bit = GPT_ATTRBIT_LEGACY;
		name = GPT_ATTRSTR_LEGACY;
		break;
	case GPT_FLAG_GUIDSPECIFIC:
		rc = fdisk_ask_number(cxt, 48, 48, 63, "Enter GUID specific bit", &tmp);
		if (rc)
			return rc;
		bit = tmp;
		break;
	default:
		/* already specified PT_FLAG_GUIDSPECIFIC bit */
		if (flag >= 48 && flag <= 63) {
			bit = flag;
			flag = GPT_FLAG_GUIDSPECIFIC;
		}
		break;
	}

	if (bit < 0) {
		fdisk_warnx(cxt, "failed to toggle unsupported bit %lu", flag);
		return -EINVAL;
	}

	if (!isset(bits, bit))
		setbit(bits, bit);
	else
		clrbit(bits, bit);

	e->attrs = attrs;

	if (flag == GPT_FLAG_GUIDSPECIFIC)
		fdisk_info(cxt, isset(bits, bit) ?
			"The GUID specific bit %d on partition %zu is enabled now." :
			"The GUID specific bit %d on partition %zu is disabled now.",
			bit, i + 1);
	else
		fdisk_info(cxt, isset(bits, bit) ?
			"The %s flag on partition %zu is enabled now." :
			"The %s flag on partition %zu is disabled now.",
			name, i + 1);

	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);
	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int gpt_entry_cmp_start(const void *a, const void *b)
{
	const struct gpt_entry  *ae = (const struct gpt_entry *) a,
				*be = (const struct gpt_entry *) b;
	int au = gpt_entry_is_used(ae),
	    bu = gpt_entry_is_used(be);

	if (!au && !bu)
		return 0;
	if (!au)
		return 1;
	if (!bu)
		return -1;

	return cmp_numbers(gpt_partition_start(ae), gpt_partition_start(be));
}

/* sort partition by start sector */
static int gpt_reorder(struct fdisk_context *cxt)
{
	struct fdisk_gpt_label *gpt;
	size_t i, nparts, mess;

	gpt = self_label(cxt);
	nparts = gpt_get_nentries(gpt);

	for (i = 0, mess = 0; mess == 0 && i + 1 < nparts; i++)
		mess = gpt_entry_cmp_start(
				(const void *) gpt_get_entry(gpt, i),
				(const void *) gpt_get_entry(gpt, i + 1)) > 0;

	if (!mess) {
		fdisk_info(cxt, "Nothing to do. Ordering is correct already.");
		return 1;
	}

	qsort(gpt->ents, nparts, sizeof(struct gpt_entry),
			gpt_entry_cmp_start);

	gpt_recompute_crc(gpt->pheader, gpt->ents);
	gpt_recompute_crc(gpt->bheader, gpt->ents);
	fdisk_label_set_changed1(cxt->label);

	return 0;
}

static int gpt_reset_alignment(struct fdisk_context *cxt)
{
	struct fdisk_gpt_label *gpt;
	struct gpt_header *h;

	gpt = self_label(cxt);
	h = gpt ? gpt->pheader : NULL;

	if (h) {
		/* always follow existing table */
		cxt->first_lba = le64_to_cpu(h->first_usable_lba);
		cxt->last_lba  = le64_to_cpu(h->last_usable_lba);
	} else {
		/* estimate ranges for GPT */
		uint64_t first, last;

		count_first_last_lba(cxt, &first, &last);

		if (cxt->first_lba < first)
			cxt->first_lba = first;
		if (cxt->last_lba > last)
			cxt->last_lba = last;
	}

	return 0;
}

static const struct fdisk_label_operations gpt_operations =
{
	.probe          = gpt_probe_label,
	.write          = gpt_write_disklabel,
	.verify         = gpt_verify_disklabel,
	.create         = gpt_create_disklabel,
	.locate         = gpt_locate_disklabel,
	.get_item       = gpt_get_disklabel_item,
	.set_id         = gpt_set_disklabel_id,

	.get_part       = gpt_get_partition,
	.set_part       = gpt_set_partition,
	.add_part       = gpt_add_partition,
	.del_part       = gpt_delete_partition,
	.reorder        = gpt_reorder,

	.part_is_used   = gpt_part_is_used,
	.part_toggle_flag = gpt_toggle_partition_flag,

	.deinit         = gpt_deinit,

	.reset_alignment = gpt_reset_alignment
};

static const struct fdisk_field gpt_fields[] =
{
	/* basic */
	{ FDISK_FIELD_DEVICE,   "Device",    10,    0 },
	{ FDISK_FIELD_START,    "Start",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_END,      "End",        5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SECTORS,  "Sectors",    5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SIZE,     "Size",       5,    FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_EYECANDY },
	{ FDISK_FIELD_TYPE,     "Type",     0.1,    FDISK_FIELDFL_EYECANDY }
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	,
	/* expert */
	{ FDISK_FIELD_TYPEID,   "Type-UUID", 36,    FDISK_FIELDFL_DETAIL },
	{ FDISK_FIELD_UUID,     "UUID",      36,    FDISK_FIELDFL_DETAIL },
	{ FDISK_FIELD_NAME,     "Name",     0.2,    FDISK_FIELDFL_DETAIL },
	{ FDISK_FIELD_ATTR,     "Attrs",      0,    FDISK_FIELDFL_DETAIL }
#endif
};

/* allocates GPT in-memory stuff */
static struct fdisk_label *fdisk_new_gpt_label(struct fdisk_context *cxt __attribute__ ((__unused__)))
{
	struct fdisk_label *lb;
	struct fdisk_gpt_label *gpt;

	gpt = zmalloc(sizeof(*gpt));
	/* initialize generic part of the driver */
	lb = (struct fdisk_label *) gpt;
	lb->name = "gpt";
	lb->id = FDISK_DISKLABEL_GPT;
	lb->op = &gpt_operations;
	lb->parttypes = (struct fdisk_parttype *)gpt_parttypes;
	lb->nparttypes = ARRAY_SIZE(gpt_parttypes);

	lb->fields = gpt_fields;
	lb->nfields = ARRAY_SIZE(gpt_fields);

	return lb;
}
#endif /* CONFIG_FEATURE_GPT_LABEL */

#ifdef CONFIG_FEATURE_SUN_LABEL
/* SUN specific label items. */
enum fdisk_labelitem_sun {
	SUN_LABELITEM_LABELID = __FDISK_NLABELITEMS,
	SUN_LABELITEM_VTOCID,
	SUN_LABELITEM_RPM,
	SUN_LABELITEM_ACYL,
	SUN_LABELITEM_PCYL,
	SUN_LABELITEM_APC,
	SUN_LABELITEM_INTRLV
};

/* Based on original code from fdisk:
 *   Jakub Jelinek (jj@sunsite.mff.cuni.cz), July 1996
 *   Merged with fdisk for other architectures, aeb, June 1998.
 *   Arnaldo Carvalho de Melo <acme@conectiva.com.br> Mar 1999, Internationalization */

#define SUN_LABEL_MAGIC         0xDABE

/* Supported VTOC setting */
#define SUN_VTOC_SANITY         0x600DDEEE      /* magic number */
#define SUN_VTOC_VERSION        1
#define SUN_MAXPARTITIONS       8

struct sun_disklabel {
	unsigned char label_id[128];   /* Informative text string */

	struct sun_vtoc {
		uint32_t version;     /* version */
		char     volume_id[8];/* volume name */
		uint16_t nparts;      /* num of partitions */

		struct sun_info {        /* partition information */
			uint16_t id;     /* SUN_TAG_*  */
			uint16_t flags;  /* SUN_FLAG_* */
		} __attribute__ ((packed)) infos[8];

		uint16_t padding;      /* padding */
		uint32_t bootinfo[3];  /* info needed by mboot */
		uint32_t sanity;       /* magic number */
		uint32_t reserved[10]; /* padding */
		uint32_t timestamp[8]; /* partition timestamp */
	} __attribute__ ((packed)) vtoc;

	uint32_t write_reinstruct;     /* sectors to skip, writes */
	uint32_t read_reinstruct;      /* sectors to skip, reads */
	unsigned char spare[148];      /* padding */
	uint16_t rpm;                  /* disk rotational speed */
	uint16_t pcyl;                 /* physical cylinder count */
	uint16_t apc;                  /* extra sects per cylinder */
	uint16_t obs1;
	uint16_t obs2;
	uint16_t intrlv;               /* interleave factor */
	uint16_t ncyl;                 /* data cylinder count */
	uint16_t acyl;                 /* alt. cylinder count */
	uint16_t nhead;                /* tracks per cylinder   <---- */
	uint16_t nsect;                /* sectors per track     <---- */
	uint16_t obs3;
	uint16_t obs4;

	struct sun_partition {         /* partitions */
		uint32_t start_cylinder;
		uint32_t num_sectors;
	} __attribute__ ((packed)) partitions[8];

	uint16_t magic;                /* magic number */
	uint16_t csum;                 /* label xor'd checksum */
} __attribute__ ((packed));


#define SUN_TAG_UNASSIGNED      0x00    /* Unassigned partition */
#define SUN_TAG_BOOT            0x01    /* Boot partition       */
#define SUN_TAG_ROOT            0x02    /* Root filesystem      */
#define SUN_TAG_SWAP            0x03    /* Swap partition       */
#define SUN_TAG_USR             0x04    /* /usr filesystem      */
#define SUN_TAG_WHOLEDISK       0x05    /* Full-disk slice      */
#define SUN_TAG_STAND           0x06    /* Stand partition      */
#define SUN_TAG_VAR             0x07    /* /var filesystem      */
#define SUN_TAG_HOME            0x08    /* /home filesystem     */
#define SUN_TAG_ALTSCTR         0x09    /* Alt sector partition */
#define SUN_TAG_CACHE           0x0a    /* Cachefs partition    */
#define SUN_TAG_RESERVED        0x0b    /* SMI reserved data    */
#define SUN_TAG_LINUX_SWAP      0x82    /* Linux SWAP           */
#define SUN_TAG_LINUX_NATIVE    0x83    /* Linux filesystem     */
#define SUN_TAG_LINUX_LVM       0x8e    /* Linux LVM            */
#define SUN_TAG_LINUX_RAID      0xfd    /* LInux RAID           */

#define SUN_FLAG_UNMNT          0x01    /* Unmountable partition */
#define SUN_FLAG_RONLY          0x10    /* Read only            */

static inline uint16_t sun_pt_checksum(const struct sun_disklabel *label)
{
	const uint16_t *ptr = ((const uint16_t *) (label + 1)) - 1;
	uint16_t sum;

	for (sum = 0; ptr >= ((const uint16_t *) label);)
		sum ^= *ptr--;

	return sum;
}


/* in-memory fdisk SUN stuff */
struct fdisk_sun_label {
	struct fdisk_label      head;           /* generic part */
	struct sun_disklabel   *header;         /* on-disk data (pointer to cxt->firstsector) */
};

static const struct fdisk_parttype sun_parttypes[] = {
	{SUN_TAG_UNASSIGNED, "Unassigned"},
	{SUN_TAG_BOOT, "Boot"},
	{SUN_TAG_ROOT, "SunOS root"},
	{SUN_TAG_SWAP, "SunOS swap"},
	{SUN_TAG_USR, "SunOS usr"},
	{SUN_TAG_WHOLEDISK, "Whole disk"},
	{SUN_TAG_STAND, "SunOS stand"},
	{SUN_TAG_VAR, "SunOS var"},
	{SUN_TAG_HOME, "SunOS home"},
	{SUN_TAG_ALTSCTR, "SunOS alt sectors"},
	{SUN_TAG_CACHE, "SunOS cachefs"},
	{SUN_TAG_RESERVED, "SunOS reserved"},
	{SUN_TAG_LINUX_SWAP, "Linux swap"},
	{SUN_TAG_LINUX_NATIVE, "Linux native"},
	{SUN_TAG_LINUX_LVM, "Linux LVM"},
	{SUN_TAG_LINUX_RAID, "Linux raid autodetect"},
	{ 0, NULL }
};

/* return pointer buffer with on-disk data */
static inline struct sun_disklabel *self_disklabel(struct fdisk_context *cxt)
{
	return ((struct fdisk_sun_label *) cxt->label)->header;
}

/* return in-memory sun fdisk data */
static inline struct fdisk_sun_label *self_label_sun(struct fdisk_context *cxt)
{
	return (struct fdisk_sun_label *) cxt->label;
}

static void set_partition_sun(struct fdisk_context *cxt, size_t i,
		uint32_t start,uint32_t stop, uint16_t sysid)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	struct fdisk_parttype *t =
			fdisk_label_get_parttype_from_code(cxt->label, sysid);

	sunlabel->vtoc.infos[i].id = cpu_to_be16(sysid);
	sunlabel->vtoc.infos[i].flags = cpu_to_be16(0);
	sunlabel->partitions[i].start_cylinder =
		cpu_to_be32(start / (cxt->geom.heads * cxt->geom.sectors));
	sunlabel->partitions[i].num_sectors = cpu_to_be32(stop - start);
	fdisk_label_set_changed1(cxt->label);

	fdisk_info_new_partition(cxt, i + 1, start, stop, t);
}

static size_t count_used_partitions_sun(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	size_t ct = 0, i;

	for (i = 0; i < cxt->label->nparts_max; i++) {
		if (sunlabel->partitions[i].num_sectors)
			ct++;
	}
	return ct;
}

static int sun_probe_label(struct fdisk_context *cxt)
{
	struct fdisk_sun_label *sun;
	struct sun_disklabel *sunlabel;
	int need_fixing = 0;

	/* map first sector to header */
	sun = self_label_sun(cxt);
	sun->header = (struct sun_disklabel *) cxt->firstsector;
	sunlabel = sun->header;

	if (be16_to_cpu(sunlabel->magic) != SUN_LABEL_MAGIC) {
		sun->header = NULL;
		return 0;               /* failed */
	}

	if (sun_pt_checksum(sunlabel)) {
		fdisk_warnx(cxt, "Detected sun disklabel with wrong checksum. "
			      "Probably you'll have to set all the values, "
			      "e.g. heads, sectors, cylinders and partitions "
			      "or force a fresh label (s command in main menu)");
		return 1;
	}

	cxt->label->nparts_max = SUN_MAXPARTITIONS;
	cxt->geom.heads = be16_to_cpu(sunlabel->nhead);
	cxt->geom.cylinders = be16_to_cpu(sunlabel->ncyl);
	cxt->geom.sectors = be16_to_cpu(sunlabel->nsect);

	/* we have on label geom, but user has to win */
	if (fdisk_has_user_device_geometry(cxt))
		fdisk_apply_user_device_properties(cxt);

	if (be32_to_cpu(sunlabel->vtoc.version) != SUN_VTOC_VERSION) {
		fdisk_warnx(cxt, "Detected sun disklabel with wrong version [%d].",
			be32_to_cpu(sunlabel->vtoc.version));
		need_fixing = 1;
	}
	if (be32_to_cpu(sunlabel->vtoc.sanity) != SUN_VTOC_SANITY) {
		fdisk_warnx(cxt, "Detected sun disklabel with wrong vtoc.sanity [0x%08x].",
			be32_to_cpu(sunlabel->vtoc.sanity));
		need_fixing = 1;
	}
	if (be16_to_cpu(sunlabel->vtoc.nparts) != SUN_MAXPARTITIONS) {
		fdisk_warnx(cxt, "Detected sun disklabel with wrong vtoc.nparts [%u].",
			be16_to_cpu(sunlabel->vtoc.nparts));
		need_fixing = 1;
	}
	if (need_fixing) {
		fdisk_warnx(cxt, "Warning: Wrong values need to be fixed up and "
				   "will be corrected by w(rite)");

		sunlabel->vtoc.version = cpu_to_be32(SUN_VTOC_VERSION);
		sunlabel->vtoc.sanity = cpu_to_be32(SUN_VTOC_SANITY);
		sunlabel->vtoc.nparts = cpu_to_be16(SUN_MAXPARTITIONS);
		sunlabel->csum = 0;
		sunlabel->csum = sun_pt_checksum(sunlabel);

		fdisk_label_set_changed1(cxt->label);
	}

	cxt->label->nparts_cur = count_used_partitions_sun(cxt);

	return 1;
}

static void ask_geom(struct fdisk_context *cxt)
{
	uintmax_t res;

	if (fdisk_ask_number(cxt, cxt->label->geom_min.heads, 1,
				  cxt->label->geom_max.heads,
				  "Heads", &res) == 0)
		cxt->geom.heads = res;

	if (fdisk_ask_number(cxt, cxt->label->geom_min.sectors, 1,
				  cxt->label->geom_max.sectors,
				  "Sectors/track", &res) == 0)
		cxt->geom.sectors = res;

	if (fdisk_ask_number(cxt, cxt->label->geom_min.cylinders, 1,
				  cxt->label->geom_max.cylinders,
				  "Cylinders", &res) == 0)
		cxt->geom.cylinders = res;
}

static int sun_create_disklabel(struct fdisk_context *cxt)
{
	unsigned int ndiv;
	struct fdisk_sun_label *sun;            /* libfdisk sun handler */
	struct sun_disklabel *sunlabel; /* on disk data */
	int rc = 0;

	/* map first sector to header */
	rc = fdisk_init_firstsector_buffer(cxt, 0, 0);
	if (rc)
		return rc;

	sun = self_label_sun(cxt);
	sun->header = (struct sun_disklabel *) cxt->firstsector;

	sunlabel = sun->header;

	cxt->label->nparts_max = SUN_MAXPARTITIONS;

	sunlabel->magic = cpu_to_be16(SUN_LABEL_MAGIC);
	sunlabel->vtoc.version = cpu_to_be32(SUN_VTOC_VERSION);
	sunlabel->vtoc.sanity = cpu_to_be32(SUN_VTOC_SANITY);
	sunlabel->vtoc.nparts = cpu_to_be16(SUN_MAXPARTITIONS);

	if (cxt->geom.heads && cxt->geom.sectors) {
		fdisk_sector_t llsectors;

		if (blkdev_get_sectors(cxt->dev_fd, (unsigned long long *) &llsectors) == 0) {
			int sec_fac = cxt->sector_size / 512;
			fdisk_sector_t llcyls;

			llcyls = llsectors / (cxt->geom.heads * cxt->geom.sectors * sec_fac);
			cxt->geom.cylinders = llcyls;
			if (cxt->geom.cylinders != llcyls)
				cxt->geom.cylinders = ~0;
		} else {
			fdisk_warnx(cxt,
				"BLKGETSIZE ioctl failed on %s. "
				  "Using geometry cylinder value of %llu. "
				  "This value may be truncated for devices "
				  "> 33.8 GB.",
				cxt->dev_path, cxt->geom.cylinders);
		}
	} else
		ask_geom(cxt);

	sunlabel->acyl   = cpu_to_be16(0);
	sunlabel->pcyl   = cpu_to_be16(cxt->geom.cylinders);
	sunlabel->rpm    = cpu_to_be16(5400);
	sunlabel->intrlv = cpu_to_be16(1);
	sunlabel->apc    = cpu_to_be16(0);

	sunlabel->nhead  = cpu_to_be16(cxt->geom.heads);
	sunlabel->nsect  = cpu_to_be16(cxt->geom.sectors);
	sunlabel->ncyl   = cpu_to_be16(cxt->geom.cylinders);

	snprintf((char *) sunlabel->label_id, sizeof(sunlabel->label_id),
		 "Linux cyl %ju alt %u hd %u sec %ju",
		 (uintmax_t) cxt->geom.cylinders,
		 be16_to_cpu(sunlabel->acyl),
		 cxt->geom.heads,
		 (uintmax_t) cxt->geom.sectors);

	if (cxt->geom.cylinders * cxt->geom.heads * cxt->geom.sectors >= 150 * 2048) {
		ndiv = cxt->geom.cylinders - (50 * 2048 / (cxt->geom.heads * cxt->geom.sectors)); /* 50M swap */
	} else
		ndiv = cxt->geom.cylinders * 2 / 3;

	/* create the default layout only if no-script defined */
	if (!cxt->script) {
		set_partition_sun(cxt, 0, 0, ndiv * cxt->geom.heads * cxt->geom.sectors,
			  SUN_TAG_LINUX_NATIVE);
		set_partition_sun(cxt, 1, ndiv * cxt->geom.heads * cxt->geom.sectors,
			  cxt->geom.cylinders * cxt->geom.heads * cxt->geom.sectors,
			  SUN_TAG_LINUX_SWAP);
		sunlabel->vtoc.infos[1].flags |= cpu_to_be16(SUN_FLAG_UNMNT);

		set_partition_sun(cxt, 2, 0,
			  cxt->geom.cylinders * cxt->geom.heads * cxt->geom.sectors,
			  SUN_TAG_WHOLEDISK);
	}

	sunlabel->csum = 0;
	sunlabel->csum = sun_pt_checksum(sunlabel);

	fdisk_label_set_changed1(cxt->label);
	cxt->label->nparts_cur = count_used_partitions_sun(cxt);

	fdisk_info(cxt, "Created a new Sun disklabel.");
	return 0;
}

static int sun_toggle_partition_flag(struct fdisk_context *cxt, size_t i, unsigned long flag)
{
	struct sun_disklabel *sunlabel;
	struct sun_info *p;

	if (i >= cxt->label->nparts_max)
		return -EINVAL;

	sunlabel = self_disklabel(cxt);
	p = &sunlabel->vtoc.infos[i];

	switch (flag) {
	case SUN_FLAG_UNMNT:
		p->flags ^= cpu_to_be16(SUN_FLAG_UNMNT);
		fdisk_label_set_changed1(cxt->label);
		break;
	case SUN_FLAG_RONLY:
		p->flags ^= cpu_to_be16(SUN_FLAG_RONLY);
		fdisk_label_set_changed1(cxt->label);
		break;
	default:
		return 1;
	}

	return 0;
}

static void fetch_sun(struct fdisk_context *cxt,
		      uint32_t *starts,
		      uint32_t *lens,
		      uint32_t *start,
		      uint32_t *stop)
{
	struct sun_disklabel *sunlabel;
	int continuous = 1;
	size_t i;
	int sectors_per_cylinder = cxt->geom.heads * cxt->geom.sectors;

	sunlabel = self_disklabel(cxt);

	*start = 0;
	*stop = cxt->geom.cylinders * sectors_per_cylinder;

	for (i = 0; i < cxt->label->nparts_max; i++) {
		struct sun_partition *part = &sunlabel->partitions[i];
		struct sun_info *info = &sunlabel->vtoc.infos[i];

		if (part->num_sectors &&
		    be16_to_cpu(info->id) != SUN_TAG_UNASSIGNED &&
		    be16_to_cpu(info->id) != SUN_TAG_WHOLEDISK) {
			starts[i] = be32_to_cpu(part->start_cylinder) *
				     sectors_per_cylinder;
			lens[i] = be32_to_cpu(part->num_sectors);
			if (continuous) {
				if (starts[i] == *start) {
					*start += lens[i];
					int remained_sectors = *start % sectors_per_cylinder;
					if (remained_sectors) {
						*start += sectors_per_cylinder - remained_sectors;
					}
				} else if (starts[i] + lens[i] >= *stop)
					*stop = starts[i];
				else
					continuous = 0;
					/* There will be probably more gaps
					  than one, so lets check afterwards */
			}
		} else {
			starts[i] = 0;
			lens[i] = 0;
		}
	}
}

static int verify_sun_cmp(int *a, int *b)
{
    if (*a == -1)
	    return 1;
    if (*b == -1)
	    return -1;
    if (verify_sun_starts[*a] > verify_sun_starts[*b])
	    return 1;
    return -1;
}

static int sun_verify_disklabel(struct fdisk_context *cxt)
{
    uint32_t starts[SUN_MAXPARTITIONS], lens[SUN_MAXPARTITIONS], start, stop;
    uint32_t i,j,k,starto,endo;
    int array[SUN_MAXPARTITIONS];

    fetch_sun(cxt, starts, lens, &start, &stop);

    for (k = 0; k < 7; k++) {
	for (i = 0; i < SUN_MAXPARTITIONS; i++) {
	    if (k && (lens[i] % (cxt->geom.heads * cxt->geom.sectors)))
		fdisk_warnx(cxt, "Partition %u doesn't end on cylinder boundary.", i+1);
	    if (lens[i]) {
		for (j = 0; j < i; j++)
		    if (lens[j]) {
			if (starts[j] == starts[i]+lens[i]) {
			    starts[j] = starts[i]; lens[j] += lens[i];
			    lens[i] = 0;
			} else if (starts[i] == starts[j]+lens[j]){
			    lens[j] += lens[i];
			    lens[i] = 0;
			} else if (!k) {
			    if (starts[i] < starts[j]+lens[j] &&
				starts[j] < starts[i]+lens[i]) {
				starto = starts[i];
				if (starts[j] > starto)
					starto = starts[j];
				endo = starts[i]+lens[i];
				if (starts[j]+lens[j] < endo)
					endo = starts[j]+lens[j];
				fdisk_warnx(cxt, "Partition %u overlaps with others in "
				       "sectors %u-%u.", i+1, starto, endo);
			    }
			}
		    }
	    }
	}
    }

    for (i = 0; i < SUN_MAXPARTITIONS; i++) {
	if (lens[i])
	    array[i] = i;
	else
	    array[i] = -1;
    }
    verify_sun_starts = starts;

    qsort(array,ARRAY_SIZE(array),sizeof(array[0]),
	  (int (*)(const void *,const void *)) verify_sun_cmp);

    if (array[0] == -1) {
	fdisk_info(cxt, "No partitions defined.");
	return 0;
    }
    stop = cxt->geom.cylinders * cxt->geom.heads * cxt->geom.sectors;
    if (starts[array[0]])
	fdisk_warnx(cxt, "Unused gap - sectors 0-%u.", starts[array[0]]);
    for (i = 0; i < 7 && array[i+1] != -1; i++) {
	fdisk_warnx(cxt, "Unused gap - sectors %u-%u.",
	       (starts[array[i]] + lens[array[i]]),
	       starts[array[i+1]]);
    }
    start = (starts[array[i]] + lens[array[i]]);
    if (start < stop)
	fdisk_warnx(cxt, "Unused gap - sectors %u-%u.", start, stop);
    return 0;
}


static int is_free_sector(struct fdisk_context *cxt,
		fdisk_sector_t s, uint32_t starts[], uint32_t lens[])
{
	size_t i;

	for (i = 0; i < cxt->label->nparts_max; i++) {
		if (lens[i] && starts[i] <= s
		    && starts[i] + lens[i] > s)
			return 0;
	}
	return 1;
}

static int sun_add_partition(
		struct fdisk_context *cxt,
		struct fdisk_partition *pa,
		size_t *partno)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uint32_t starts[SUN_MAXPARTITIONS], lens[SUN_MAXPARTITIONS];
	struct sun_partition *part;
	struct sun_info *info;
	uint32_t start, stop, stop2;
	int whole_disk = 0;
	int sys = pa && pa->type ? pa->type->code : SUN_TAG_LINUX_NATIVE;
	int rc;
	size_t n;

	char mesg[256];
	size_t i;
	unsigned int first, last;

	rc = fdisk_partition_next_partno(pa, cxt, &n);
	if (rc)
		return rc;

	part = &sunlabel->partitions[n];
	info = &sunlabel->vtoc.infos[n];

	if (part->num_sectors && be16_to_cpu(info->id) != SUN_TAG_UNASSIGNED) {
		fdisk_info(cxt, "Partition %zu is already defined.  Delete "
			"it before re-adding it.", n + 1);
		return -EINVAL;
	}

	fetch_sun(cxt, starts, lens, &start, &stop);

	if (pa && pa->type && pa->type->code == SUN_TAG_WHOLEDISK)
		whole_disk = 1;

	if (stop <= start) {
		if (n == 2)
			whole_disk = 1;
		else {
			fdisk_info(cxt, "Other partitions already cover the "
				"whole disk. Delete some/shrink them before retry.");
			return -EINVAL;
		}
	}

	if (pa && pa->start_follow_default)
		first = start;
	else if (pa && fdisk_partition_has_start(pa)) {
		first = pa->start;

		if (!whole_disk && !is_free_sector(cxt, first, starts, lens))
			return -ERANGE;
	} else {
		struct fdisk_ask *ask;

		if (n == 2)
			fdisk_info(cxt, "It is highly recommended that the "
					   "third partition covers the whole disk "
					   "and is of type `Whole disk'");

		snprintf(mesg, sizeof(mesg), "First %s",
				fdisk_get_unit(cxt, FDISK_SINGULAR));
		for (;;) {
			ask = fdisk_new_ask();
			fdisk_ask_set_query(ask, mesg);
			fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);

			if (whole_disk) {
				fdisk_ask_number_set_low(ask,     0);   /* minimal */
				fdisk_ask_number_set_default(ask, 0);   /* default */
				fdisk_ask_number_set_high(ask,    0);   /* maximal */
			} else if (n == 2) {
				fdisk_ask_number_set_low(ask,     0);                           /* minimal */
				fdisk_ask_number_set_default(ask, 0);                           /* default */
				fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, stop));    /* maximal */
			} else {
				fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, start));   /* minimal */
				fdisk_ask_number_set_default(ask, fdisk_scround(cxt, start));   /* default */
				fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, stop));    /* maximal */
			}
			rc = fdisk_do_ask(cxt, ask);
			first = fdisk_ask_number_get_result(ask);
			fdisk_unref_ask(ask);
			if (rc)
				return rc;

			if (fdisk_use_cylinders(cxt))
				first *= fdisk_get_units_per_sector(cxt);

			if (!fdisk_use_cylinders(cxt)) {
				/* Starting sector has to be properly aligned */
				int cs = cxt->geom.heads * cxt->geom.sectors;
				int x = first % cs;

				if (x) {
					fdisk_info(cxt, "Aligning the first sector from %u to %u "
							  "to be on cylinder boundary.",
							first, first + cs - x);
					first += cs - x;
				}
			}

			/* ewt asks to add: "don't start a partition at cyl 0"
			   However, edmundo@rano.demon.co.uk writes:
			   "In addition to having a Sun partition table, to be able to
			   boot from the disc, the first partition, /dev/sdX1, must
			   start at cylinder 0. This means that /dev/sdX1 contains
			   the partition table and the boot block, as these are the
			   first two sectors of the disc. Therefore you must be
			   careful what you use /dev/sdX1 for. In particular, you must
			   not use a partition starting at cylinder 0 for Linux swap,
			   as that would overwrite the partition table and the boot
			   block. You may, however, use such a partition for a UFS
			   or EXT2 file system, as these file systems leave the first
			   1024 bytes undisturbed. */
			/* On the other hand, one should not use partitions
			   starting at block 0 in an md, or the label will
			   be trashed. */
			if (!is_free_sector(cxt, first, starts,  lens) && !whole_disk) {
				if (n == 2 && !first) {
				    whole_disk = 1;
				    break;
				}
				fdisk_warnx(cxt, "Sector %d is already allocated", first);
			} else
				break;
		}
	}

	stop = cxt->geom.cylinders * cxt->geom.heads * cxt->geom.sectors;       /* ancient */
	stop2 = stop;
	for (i = 0; i < cxt->label->nparts_max; i++) {
		if (starts[i] > first && starts[i] < stop)
			stop = starts[i];
	}

	/* last */
	if (pa && pa->end_follow_default)
		last = whole_disk || (n == 2 && !first) ? stop2 : stop;

	else if (pa && fdisk_partition_has_size(pa)) {
		last = first + pa->size;

		if (!whole_disk && last > stop)
			return -ERANGE;
	} else {
		struct fdisk_ask *ask = fdisk_new_ask();

		snprintf(mesg, sizeof(mesg),
			 "Last %s or +/-%s or +/-size{K,M,G,T,P}",
			 fdisk_get_unit(cxt, FDISK_SINGULAR),
			 fdisk_get_unit(cxt, FDISK_PLURAL));
		fdisk_ask_set_query(ask, mesg);
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_OFFSET);

		if (whole_disk) {
			fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, stop2));   /* minimal */
			fdisk_ask_number_set_default(ask, fdisk_scround(cxt, stop2));   /* default */
			fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, stop2));   /* maximal */
			fdisk_ask_number_set_base(ask,    0);
		} else if (n == 2 && !first) {
			fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, first));   /* minimal */
			fdisk_ask_number_set_default(ask, fdisk_scround(cxt, stop2));   /* default */
			fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, stop2));   /* maximal */
			fdisk_ask_number_set_base(ask,    fdisk_scround(cxt, first));
		} else {
			fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, first));   /* minimal */
			fdisk_ask_number_set_default(ask, fdisk_scround(cxt, stop));    /* default */
			fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, stop));    /* maximal */
			fdisk_ask_number_set_base(ask,    fdisk_scround(cxt, first));
		}

		fdisk_ask_number_set_wrap_negative1(ask); /* wrap negative around high */

		if (fdisk_use_cylinders(cxt))
			fdisk_ask_number_set_unit(ask, cxt->sector_size *
				     fdisk_get_units_per_sector(cxt));
		else
			fdisk_ask_number_set_unit(ask,  cxt->sector_size);

		rc = fdisk_do_ask(cxt, ask);
		last = fdisk_ask_number_get_result(ask);

		fdisk_unref_ask(ask);
		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt))
			last *= fdisk_get_units_per_sector(cxt);
	}

	if (n == 2 && !first) {
		if (last >= stop2) {
		    whole_disk = 1;
		    last = stop2;
		} else if (last > stop) {
		    fdisk_warnx(cxt,
   "You haven't covered the whole disk with the 3rd partition, but your value\n"
     "%lu %s covers some other partition. Your entry has been changed\n"
     "to %lu %s",
			(unsigned long) fdisk_scround(cxt, last), fdisk_get_unit(cxt, FDISK_SINGULAR),
			(unsigned long) fdisk_scround(cxt, stop), fdisk_get_unit(cxt, FDISK_SINGULAR));
		    last = stop;
		}
	} else if (!whole_disk && last > stop)
		last = stop;

	if (whole_disk)
		sys = SUN_TAG_WHOLEDISK;

	set_partition_sun(cxt, n, first, last, sys);
	cxt->label->nparts_cur = count_used_partitions_sun(cxt);
	if (partno)
		*partno = n;
	return 0;
}

static int sun_delete_partition(struct fdisk_context *cxt,
		size_t partnum)
{
	struct sun_disklabel *sunlabel;
	struct sun_partition *part;
	struct sun_info *info;
	unsigned int nsec;

	sunlabel = self_disklabel(cxt);
	part = &sunlabel->partitions[partnum];
	info = &sunlabel->vtoc.infos[partnum];

	if (partnum == 2 &&
	    be16_to_cpu(info->id) == SUN_TAG_WHOLEDISK &&
	    !part->start_cylinder &&
	    (nsec = be32_to_cpu(part->num_sectors))
	    == cxt->geom.heads * cxt->geom.sectors * cxt->geom.cylinders)
		fdisk_info(cxt, "If you want to maintain SunOS/Solaris compatibility, "
			 "consider leaving this "
			 "partition as Whole disk (5), starting at 0, with %u "
			 "sectors", nsec);
	info->id = cpu_to_be16(SUN_TAG_UNASSIGNED);
	part->num_sectors = 0;
	cxt->label->nparts_cur = count_used_partitions_sun(cxt);
	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int sun_get_disklabel_item(struct fdisk_context *cxt, struct fdisk_labelitem *item)
{
	struct sun_disklabel *sunlabel;
	int rc = 0;

	sunlabel = self_disklabel(cxt);

	switch (item->id) {
	case SUN_LABELITEM_LABELID:
		item->name ="Label ID";
		item->type = 's';
		item->data.str = *sunlabel->label_id ? xstrndup((char *)sunlabel->label_id, sizeof(sunlabel->label_id)) : NULL;
		break;
	case SUN_LABELITEM_VTOCID:
		item->name ="Volume ID";
		item->type = 's';
		item->data.str = *sunlabel->vtoc.volume_id ? xstrndup((char *)sunlabel->vtoc.volume_id, sizeof(sunlabel->vtoc.volume_id)) : NULL;
		break;
	case SUN_LABELITEM_RPM:
		item->name ="Rpm";
		item->type = 'j';
		item->data.num64 = be16_to_cpu(sunlabel->rpm);
		break;
	case SUN_LABELITEM_ACYL:
		item->name ="Alternate cylinders";
		item->type = 'j';
		item->data.num64 = be16_to_cpu(sunlabel->acyl);
		break;
	case SUN_LABELITEM_PCYL:
		item->name ="Physical cylinders";
		item->type = 'j';
		item->data.num64 = be16_to_cpu(sunlabel->pcyl);
		break;
	case SUN_LABELITEM_APC:
		item->name ="Extra sects/cyl";
		item->type = 'j';
		item->data.num64 = be16_to_cpu(sunlabel->apc);
		break;
	case SUN_LABELITEM_INTRLV:
		item->name ="Interleave";
		item->type = 'j';
		item->data.num64 = be16_to_cpu(sunlabel->intrlv);
		break;
	default:
		if (item->id < __FDISK_NLABELITEMS)
			rc = 1; /* unsupported generic item */
		else
			rc = 2; /* out of range */
		break;
	}

	return rc;
}

static struct fdisk_parttype *sun_get_parttype(
		struct fdisk_context *cxt,
		size_t n)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	struct fdisk_parttype *t;

	if (n >= cxt->label->nparts_max)
		return NULL;

	t = fdisk_label_get_parttype_from_code(cxt->label,
			be16_to_cpu(sunlabel->vtoc.infos[n].id));
	return t ? : fdisk_new_unknown_parttype(be16_to_cpu(sunlabel->vtoc.infos[n].id), NULL);
}


static int sun_get_partition(struct fdisk_context *cxt, size_t n,
			      struct fdisk_partition *pa)
{
	struct sun_disklabel *sunlabel;
	struct sun_partition *part;
	uint16_t flags;
	uint32_t start, len;

	if (n >= cxt->label->nparts_max)
		return -EINVAL;

	sunlabel = self_disklabel(cxt);
	part = &sunlabel->partitions[n];

	pa->used = part->num_sectors ? 1 : 0;
	if (!pa->used)
		return 0;

	flags = be16_to_cpu(sunlabel->vtoc.infos[n].flags);
	start = be32_to_cpu(part->start_cylinder)
			* cxt->geom.heads * cxt->geom.sectors;
	len = be32_to_cpu(part->num_sectors);

	pa->type = sun_get_parttype(cxt, n);
	if (pa->type && pa->type->code == SUN_TAG_WHOLEDISK)
		pa->wholedisk = 1;

	if (flags & SUN_FLAG_UNMNT || flags & SUN_FLAG_RONLY) {
		pa->attrs = xasprintf("%c%c",
				flags & SUN_FLAG_UNMNT ? 'u' : ' ',
				flags & SUN_FLAG_RONLY ? 'r' : ' ');
	}

	pa->start = start;
	pa->size = len;

	return 0;
}

/* Sets number of alternative cylinders. This function uses libfdisk Ask API
 * for dialog with user.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_sun_set_alt_cyl(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uintmax_t res;
	int rc = fdisk_ask_number(cxt, 0,                       /* low */
			be16_to_cpu(sunlabel->acyl),            /* default */
			65535,                                  /* high */
			"Number of alternate cylinders",        /* query */
			&res);                                  /* result */
	if (rc)
		return rc;

	sunlabel->acyl = cpu_to_be16(res);
	return 0;
}

/* Sets number of extra sectors per cylinder. This function uses libfdisk Ask API
 * for dialog with user.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_sun_set_xcyl(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uintmax_t res;
	int rc = fdisk_ask_number(cxt, 0,                       /* low */
			be16_to_cpu(sunlabel->apc),             /* default */
			cxt->geom.sectors,                      /* high */
			"Extra sectors per cylinder",           /* query */
			&res);                                  /* result */
	if (rc)
		return rc;
	sunlabel->apc = cpu_to_be16(res);
	return 0;
}

/* Sets interleave factor. This function uses libfdisk Ask API for dialog with
 * user.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_sun_set_ilfact(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uintmax_t res;
	int rc = fdisk_ask_number(cxt, 1,                       /* low */
			be16_to_cpu(sunlabel->intrlv),          /* default */
			32,                                     /* high */
			"Interleave factor",                    /* query */
			&res);                                  /* result */
	if (rc)
		return rc;
	sunlabel->intrlv = cpu_to_be16(res);
	return 0;
}

/* Sets rotation speed. This function uses libfdisk Ask API for dialog with
 * user.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_sun_set_rspeed(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uintmax_t res;
	int rc = fdisk_ask_number(cxt, 1,                       /* low */
			be16_to_cpu(sunlabel->rpm),             /* default */
			USHRT_MAX,                              /* high */
			"Rotation speed (rpm)",                 /* query */
			&res);                                  /* result */
	if (rc)
		return rc;
	sunlabel->rpm = cpu_to_be16(res);
	return 0;
}

/* Sets number of physical cylinders. This function uses libfdisk Ask API for
 * dialog with user.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_sun_set_pcylcount(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel = self_disklabel(cxt);
	uintmax_t res;
	int rc = fdisk_ask_number(cxt, 0,                       /* low */
			be16_to_cpu(sunlabel->pcyl),            /* default */
			USHRT_MAX,                              /* high */
			"Number of physical cylinders",         /* query */
			&res);                                  /* result */
	if (!rc)
		return rc;
	sunlabel->pcyl = cpu_to_be16(res);
	return 0;
}

static int sun_write_disklabel(struct fdisk_context *cxt)
{
	struct sun_disklabel *sunlabel;
	const size_t sz = sizeof(struct sun_disklabel);

	sunlabel = self_disklabel(cxt);

	/* Maybe geometry has been modified */
	sunlabel->nhead = cpu_to_be16(cxt->geom.heads);
	sunlabel->nsect = cpu_to_be16(cxt->geom.sectors);

	if (cxt->geom.cylinders != be16_to_cpu(sunlabel->ncyl)) {
		int a = cpu_to_be16(cxt->geom.cylinders);
		int b = be16_to_cpu(sunlabel->acyl);
		sunlabel->ncyl = a - b;
	}

	sunlabel->csum = 0;
	sunlabel->csum = sun_pt_checksum(sunlabel);

	if (lseek(cxt->dev_fd, 0, SEEK_SET) < 0)
		return -errno;
	if (write_all(cxt->dev_fd, sunlabel, sz) != 0)
		return -errno;

	return 0;
}

static int sun_set_partition(
		struct fdisk_context *cxt,
		size_t i,
		struct fdisk_partition *pa)
{
	struct sun_disklabel *sunlabel;
	struct sun_partition *part;
	struct sun_info *info;

	sunlabel = self_disklabel(cxt);

	if (i >= cxt->label->nparts_max)
		return -EINVAL;

	if (pa->type) {
		struct fdisk_parttype *t = pa->type;

		if (t->code > UINT16_MAX)
			return -EINVAL;

		if (i == 2 && t->code != SUN_TAG_WHOLEDISK)
			fdisk_info(cxt, "Consider leaving partition 3 as Whole disk (5),\n"
				 "as SunOS/Solaris expects it and even Linux likes it.\n");

		part = &sunlabel->partitions[i];
		info = &sunlabel->vtoc.infos[i];

		if (cxt->script == NULL &&
		    t->code == SUN_TAG_LINUX_SWAP && !part->start_cylinder) {
			int yes, rc;

			rc = fdisk_ask_yesno(cxt,
			      "It is highly recommended that the partition at offset 0\n"
			      "is UFS, EXT2FS filesystem or SunOS swap. Putting Linux swap\n"
			      "there may destroy your partition table and bootblock.\n"
			      "Are you sure you want to tag the partition as Linux swap?", &yes);
			if (rc)
				return rc;
			if (!yes)
				return 1;
		}

		switch (t->code) {
		case SUN_TAG_SWAP:
		case SUN_TAG_LINUX_SWAP:
			/* swaps are not mountable by default */
			info->flags |= cpu_to_be16(SUN_FLAG_UNMNT);
			break;
		default:
			/* assume other types are mountable;
			   user can change it anyway */
			info->flags &= ~cpu_to_be16(SUN_FLAG_UNMNT);
			break;
		}
		info->id = cpu_to_be16(t->code);
	}

	if (fdisk_partition_has_start(pa))
		sunlabel->partitions[i].start_cylinder =
			cpu_to_be32(pa->start / (cxt->geom.heads * cxt->geom.sectors));
	if (fdisk_partition_has_size(pa))
		sunlabel->partitions[i].num_sectors = cpu_to_be32(pa->size);

	fdisk_label_set_changed1(cxt->label);
	return 0;
}


static int sun_reset_alignment(struct fdisk_context *cxt __attribute__((__unused__)))
{
	fdisk_set_first_lba(cxt, 0);
	return 0;
}


static int sun_partition_is_used(
		struct fdisk_context *cxt,
		size_t i)
{
	struct sun_disklabel *sunlabel;

	if (i >= cxt->label->nparts_max)
		return 0;

	sunlabel = self_disklabel(cxt);
	return sunlabel->partitions[i].num_sectors ? 1 : 0;
}

static const struct fdisk_field sun_fields[] =
{
	{ FDISK_FIELD_DEVICE,   "Device",    10,    0 },
	{ FDISK_FIELD_START,    "Start",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_END,      "End",        5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SECTORS,  "Sectors",    5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_CYLINDERS,"Cylinders",  5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SIZE,     "Size",       5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_TYPEID,   "Id",         2,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_TYPE,     "Type",     0.1,    0 },
	{ FDISK_FIELD_ATTR,     "Flags",      0,    FDISK_FIELDFL_NUMBER }
};

static const struct fdisk_label_operations sun_operations =
{
	.probe          = sun_probe_label,
	.write          = sun_write_disklabel,
	.verify         = sun_verify_disklabel,
	.create         = sun_create_disklabel,
	.get_item       = sun_get_disklabel_item,

	.get_part       = sun_get_partition,
	.set_part       = sun_set_partition,
	.add_part       = sun_add_partition,
	.del_part       = sun_delete_partition,

	.part_is_used   = sun_partition_is_used,
	.part_toggle_flag = sun_toggle_partition_flag,

	.reset_alignment = sun_reset_alignment,
};

/* allocates SUN label driver */
static struct fdisk_label *fdisk_new_sun_label(struct fdisk_context *cxt __attribute__ ((__unused__)))
{
	struct fdisk_label *lb;
	struct fdisk_sun_label *sun;

	sun = zmalloc(sizeof(*sun));
	/* initialize generic part of the driver */
	lb = (struct fdisk_label *) sun;
	lb->name = "sun";
	lb->id = FDISK_DISKLABEL_SUN;
	lb->op = &sun_operations;
	lb->parttypes = (struct fdisk_parttype *)sun_parttypes;
	lb->nparttypes = ARRAY_SIZE(sun_parttypes) - 1;
	lb->fields = sun_fields;
	lb->nfields = ARRAY_SIZE(sun_fields);
	lb->flags |= FDISK_LABEL_FL_REQUIRE_GEOMETRY;

	lb->geom_min.sectors = 1;
	lb->geom_min.heads = 1;
	lb->geom_min.cylinders = 1;

	lb->geom_max.sectors = 1024;
	lb->geom_max.heads = 1024;
	lb->geom_max.cylinders = USHRT_MAX;
	return lb;
}
#endif /* CONFIG_FEATURE_SUN_LABEL */

#ifdef CONFIG_FEATURE_SGI_LABEL
/* sgi.h */
#define SGI_FLAG_BOOT   1
#define SGI_FLAG_SWAP   2

enum fdisk_labelitem_sgi {
	SGI_LABELITEM_PCYLCOUNT = __FDISK_NLABELITEMS,
	SGI_LABELITEM_SPARECYL,
	SGI_LABELITEM_ILFACT,
	SGI_LABELITEM_BOOTFILE
};

/* This is a re-written version for libfdisk, the original was fdisksgilabel.c
 * from util-linux fdisk, by:
 *
 *               Andreas Neuper, Sep 1998,
 *               Arnaldo Carvalho de Melo <acme@conectiva.com.br>, Mar 1999,
 *               Phillip Kesling <pkesling@sgi.com>, Mar 2003. */

#define SGI_LABEL_MAGIC         0x0be5a941

#define SGI_MAXPARTITIONS       16
#define SGI_MAXVOLUMES          15

/* partition types */
enum {
	SGI_TYPE_VOLHDR         = 0x00,
	SGI_TYPE_TRKREPL        = 0x01,
	SGI_TYPE_SECREPL        = 0x02,
	SGI_TYPE_SWAP           = 0x03,
	SGI_TYPE_BSD            = 0x04,
	SGI_TYPE_SYSV           = 0x05,
	SGI_TYPE_ENTIRE_DISK    = 0x06,
	SGI_TYPE_EFS            = 0x07,
	SGI_TYPE_LVOL           = 0x08,
	SGI_TYPE_RLVOL          = 0x09,
	SGI_TYPE_XFS            = 0x0a,
	SGI_TYPE_XFSLOG         = 0x0b,
	SGI_TYPE_XLV            = 0x0c,
	SGI_TYPE_XVM            = 0x0d
};

struct sgi_device_parameter {
	unsigned char skew;
	unsigned char gap1;
	unsigned char gap2;
	unsigned char sparecyl;

	uint16_t pcylcount;
	uint16_t head_vol0;
	uint16_t ntrks;         /* tracks in cyl 0 or vol 0 */

	unsigned char cmd_tag_queue_depth;
	unsigned char unused0;

	uint16_t unused1;
	uint16_t nsect;         /* sectors/tracks in cyl 0 or vol 0 */
	uint16_t bytes;
	uint16_t ilfact;
	uint32_t flags;         /* SGI_DEVPARAM_* controller flags */
	uint32_t datarate;
	uint32_t retries_on_error;
	uint32_t ms_per_word;
	uint16_t xylogics_gap1;
	uint16_t xylogics_syncdelay;
	uint16_t xylogics_readdelay;
	uint16_t xylogics_gap2;
	uint16_t xylogics_readgate;
	uint16_t xylogics_writecont;
} __attribute__((packed));

enum {
	SGI_DEVPARAM_SECTOR_SLIP        = 0x01,
	SGI_DEVPARAM_SECTOR_FWD         = 0x02,
	SGI_DEVPARAM_TRACK_FWD          = 0x04,
	SGI_DEVPARAM_TRACK_MULTIVOL     = 0x08,
	SGI_DEVPARAM_IGNORE_ERRORS      = 0x10,
	SGI_DEVPARAM_RESEEK             = 0x20,
	SGI_DEVPARAM_CMDTAGQ_ENABLE     = 0x40
};


struct sgi_disklabel {
	uint32_t magic;                 /* magic number */
	uint16_t root_part_num;         /* # root partition */
	uint16_t swap_part_num;         /* # swap partition */
	unsigned char boot_file[16];    /* name of boot file */

	struct sgi_device_parameter     devparam;       /* not used now */

	struct sgi_volume {
		unsigned char name[8];  /* name of volume */
		uint32_t block_num;     /* logical block number */
		uint32_t num_bytes;     /* how big, in bytes */
	} __attribute__((packed)) volume[SGI_MAXVOLUMES];

	struct sgi_partition {
		uint32_t num_blocks;    /* size in logical blocks */
		uint32_t first_block;   /* first logical block */
		uint32_t type;          /* type of this partition */
	} __attribute__((packed)) partitions[SGI_MAXPARTITIONS];

	/* checksum is the 32bit 2's complement sum of the disklabel */
	uint32_t csum;                  /* disk label checksum */
	uint32_t padding;               /* padding */
} __attribute__((packed));

static inline uint32_t sgi_pt_checksum(struct sgi_disklabel *label)
{
	int i;
	uint32_t *ptr = (uint32_t *) label;
	uint32_t sum = 0;

	i = sizeof(*label) / sizeof(*ptr);

	while (i) {
		i--;
		sum -= be32_to_cpu(ptr[i]);
	}

	return sum;
}

/* in-memory fdisk SGI stuff */
struct fdisk_sgi_label {
	struct fdisk_label      head;           /* generic fdisk part */
	struct sgi_disklabel    *header;        /* on-disk data (pointer to cxt->firstsector) */

	struct sgi_freeblocks {
		unsigned int first;
		unsigned int last;
	} freelist[SGI_MAXPARTITIONS + 1];
};

static const struct fdisk_parttype sgi_parttypes[] =
{
	{SGI_TYPE_VOLHDR,       "SGI volhdr"},
	{SGI_TYPE_TRKREPL,      "SGI trkrepl"},
	{SGI_TYPE_SECREPL,      "SGI secrepl"},
	{SGI_TYPE_SWAP,         "SGI raw"},
	{SGI_TYPE_BSD,          "SGI bsd"},
	{SGI_TYPE_SYSV,         "SGI sysv"},
	{SGI_TYPE_ENTIRE_DISK,  "SGI volume"},
	{SGI_TYPE_EFS,          "SGI efs"},
	{SGI_TYPE_LVOL,         "SGI lvol"},
	{SGI_TYPE_RLVOL,        "SGI rlvol"},
	{SGI_TYPE_XFS,          "SGI xfs"},
	{SGI_TYPE_XFSLOG,       "SGI xfslog"},
	{SGI_TYPE_XLV,          "SGI xlv"},
	{SGI_TYPE_XVM,          "SGI xvm"},
	{MBR_LINUX_SWAP_PARTITION, "Linux swap"},
	{MBR_LINUX_DATA_PARTITION, "Linux native"},
	{MBR_LINUX_LVM_PARTITION, "Linux LVM"},
	{MBR_LINUX_RAID_PARTITION, "Linux RAID"},
	{0, NULL }
};

static unsigned int sgi_get_start_sector(struct fdisk_context *cxt, int i );
static unsigned int sgi_get_num_sectors(struct fdisk_context *cxt, int i );
static int sgi_get_bootpartition(struct fdisk_context *cxt);
static int sgi_get_swappartition(struct fdisk_context *cxt);

/* Returns a pointer buffer with on-disk data. */
static inline struct sgi_disklabel *self_disklabel_sgi(struct fdisk_context *cxt)
{
	return ((struct fdisk_sgi_label *) cxt->label)->header;
}

/* Returns in-memory fdisk data. */
static inline struct fdisk_sgi_label *self_label_sgi(struct fdisk_context *cxt)
{
	return (struct fdisk_sgi_label *) cxt->label;
}

/* Information within second on-disk block */
#define SGI_INFO_MAGIC          0x00072959

struct sgi_info {
	unsigned int   magic;           /* looks like a magic number */
	unsigned int   a2;
	unsigned int   a3;
	unsigned int   a4;
	unsigned int   b1;
	unsigned short b2;
	unsigned short b3;
	unsigned int   c[16];
	unsigned short d[3];
	unsigned char  scsi_string[50];
	unsigned char  serial[137];
	unsigned short check1816;
	unsigned char  installer[225];
};

static struct sgi_info *sgi_new_info(void)
{
	struct sgi_info *info = zmalloc(sizeof(struct sgi_info));

	info->magic = cpu_to_be32(SGI_INFO_MAGIC);
	info->b1 = cpu_to_be32(-1);
	info->b2 = cpu_to_be16(-1);
	info->b3 = cpu_to_be16(1);

	/* You may want to replace this string !!!!!!! */
	strcpy((char *) info->scsi_string, "IBM OEM 0662S12         3 30");
	strcpy((char *) info->serial, "0000");
	info->check1816 = cpu_to_be16(18 * 256 + 16);
	strcpy((char *) info->installer, "Sfx version 5.3, Oct 18, 1994");

	return info;
}

static void sgi_free_info(struct sgi_info *info)
{
	free(info);
}

/* This function add hint about SGI label (e.g. set "sgilabel" as volume name)
 * to the first SGI volume. This is probably old SGI convention without any
 * effect to the device partitioning.
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_sgi_create_info(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);

	/* I keep SGI's habit to write the sgilabel to the second block */
	sgilabel->volume[0].block_num = cpu_to_be32(2);
	sgilabel->volume[0].num_bytes = cpu_to_be32(sizeof(struct sgi_info));
	memcpy((char *) sgilabel->volume[0].name, "sgilabel", 8);

	fdisk_info(cxt, "SGI info created on second sector.");
	return 0;
}

/* only dealing with free blocks here */
static void set_freelist(struct fdisk_context *cxt,
		size_t i, unsigned int f, unsigned int l)
{
	struct fdisk_sgi_label *sgi = self_label_sgi(cxt);

	if (i < ARRAY_SIZE(sgi->freelist)) {
		sgi->freelist[i].first = f;
		sgi->freelist[i].last = l;
	}
}

static void add_to_freelist(struct fdisk_context *cxt,
		unsigned int f, unsigned int l)
{
	struct fdisk_sgi_label *sgi = self_label_sgi(cxt);
	size_t i;

	for (i = 0; i < ARRAY_SIZE(sgi->freelist); i++) {
		if (sgi->freelist[i].last == 0)
			break;
	}
	set_freelist(cxt, i, f, l);
}

static void clear_freelist(struct fdisk_context *cxt)
{
	struct fdisk_sgi_label *sgi = self_label_sgi(cxt);

	memset(sgi->freelist, 0, sizeof(sgi->freelist));
}

static unsigned int is_in_freelist(struct fdisk_context *cxt, unsigned int b)
{
	struct fdisk_sgi_label *sgi = self_label_sgi(cxt);
	size_t i;

	for (i = 0; i < ARRAY_SIZE(sgi->freelist); i++) {
		if (sgi->freelist[i].first <= b
		    && sgi->freelist[i].last >= b)
			return sgi->freelist[i].last;
	}

	return 0;
}


static int sgi_get_nsect(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be16_to_cpu(sgilabel->devparam.nsect);
}

static int sgi_get_ntrks(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be16_to_cpu(sgilabel->devparam.ntrks);
}

static size_t count_used_partitions_sgi(struct fdisk_context *cxt)
{
	size_t i, ct = 0;

	for (i = 0; i < cxt->label->nparts_max; i++)
		ct += sgi_get_num_sectors(cxt, i) > 0;

	return ct;
}

static int sgi_probe_label(struct fdisk_context *cxt)
{
	struct fdisk_sgi_label *sgi;
	struct sgi_disklabel *sgilabel;

	/* map first sector to header */
	sgi = (struct fdisk_sgi_label *) cxt->label;
	sgi->header = (struct sgi_disklabel *) cxt->firstsector;
	sgilabel = sgi->header;

	if (be32_to_cpu(sgilabel->magic) != SGI_LABEL_MAGIC) {
		sgi->header = NULL;
		return 0;
	}

	/* test for correct checksum */
	if (sgi_pt_checksum(sgilabel) != 0)
		fdisk_warnx(cxt, "Detected an SGI disklabel with wrong checksum.");

	clear_freelist(cxt);
	cxt->label->nparts_max = SGI_MAXPARTITIONS;
	cxt->label->nparts_cur = count_used_partitions_sgi(cxt);
	return 1;
}

static int sgi_get_disklabel_item(struct fdisk_context *cxt, struct fdisk_labelitem *item)
{
	struct sgi_disklabel *sgilabel;
	struct sgi_device_parameter *sgiparam;
	int rc = 0;

	sgilabel = self_disklabel_sgi(cxt);
	sgiparam = &sgilabel->devparam;

	switch (item->id) {
	case SGI_LABELITEM_PCYLCOUNT:
		item->name = "Physical cylinders";
		item->type = 'j';
		item->data.num64 = (uint64_t) be16_to_cpu(sgiparam->pcylcount);
		break;
	case SGI_LABELITEM_SPARECYL:
		item->name = "Extra sects/cyl";
		item->type = 'j';
		item->data.num64 = (uint64_t) sgiparam->sparecyl;
		break;
	case SGI_LABELITEM_ILFACT:
		item->name = "Interleave";
		item->type = 'j';
		item->data.num64 = (uint64_t) be16_to_cpu(sgiparam->ilfact);
		break;
	case SGI_LABELITEM_BOOTFILE:
		item->name = "Bootfile";
		item->type = 's';
		item->data.str = *sgilabel->boot_file ? xstrdup((char *) sgilabel->boot_file) : NULL;
		break;
	default:
		if (item->id < __FDISK_NLABELITEMS)
			rc = 1; /* unsupported generic item */
		else
			rc = 2; /* out of range */
		break;
	}

	return rc;
}

static unsigned int sgi_get_start_sector(struct fdisk_context *cxt, int i)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be32_to_cpu(sgilabel->partitions[i].first_block);
}

static unsigned int sgi_get_num_sectors(struct fdisk_context *cxt, int i)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be32_to_cpu(sgilabel->partitions[i].num_blocks);
}

static int sgi_get_sysid(struct fdisk_context *cxt, int i)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be32_to_cpu(sgilabel->partitions[i].type);
}

static int sgi_get_bootpartition(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be16_to_cpu(sgilabel->root_part_num);
}

static int sgi_get_swappartition(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);
	return be16_to_cpu(sgilabel->swap_part_num);
}

static unsigned int sgi_get_lastblock(struct fdisk_context *cxt)
{
	return cxt->geom.heads * cxt->geom.sectors * cxt->geom.cylinders;
}

static struct fdisk_parttype *sgi_get_parttype(struct fdisk_context *cxt, size_t n)
{
	struct fdisk_parttype *t;

	if (n >= cxt->label->nparts_max)
		return NULL;

	t = fdisk_label_get_parttype_from_code(cxt->label, sgi_get_sysid(cxt, n));
	return t ? : fdisk_new_unknown_parttype(sgi_get_sysid(cxt, n), NULL);
}

/* fdisk_get_partition() backend */
static int sgi_get_partition(struct fdisk_context *cxt, size_t n, struct fdisk_partition *pa)
{
	fdisk_sector_t start, len;

	pa->used = sgi_get_num_sectors(cxt, n) > 0;
	if (!pa->used)
		return 0;

	start = sgi_get_start_sector(cxt, n);
	len = sgi_get_num_sectors(cxt, n);

	pa->type = sgi_get_parttype(cxt, n);
	pa->size = len;
	pa->start = start;

	if (pa->type && pa->type->code == SGI_TYPE_ENTIRE_DISK)
		pa->wholedisk = 1;

	pa->attrs = sgi_get_swappartition(cxt) == (int) n ? "swap" :
		    sgi_get_bootpartition(cxt) == (int) n ? "boot" : NULL;
	if (pa->attrs)
		pa->attrs = xstrdup(pa->attrs);

	return 0;
}


static int sgi_check_bootfile(struct fdisk_context *cxt, const char *name)
{
	size_t sz;
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);

	sz = strlen(name);

	if (sz < 3) {
		/* "/a\n" is minimum */
		fdisk_warnx(cxt, "Invalid bootfile!  The bootfile must "
				   "be an absolute non-zero pathname, "
				   "e.g. \"/unix\" or \"/unix.save\".");
		return -EINVAL;

	} else if (sz > sizeof(sgilabel->boot_file)) {
		fdisk_warnx(cxt, "Name of bootfile is too long: %zu bytes maximum.",
			    sizeof(sgilabel->boot_file));
		return -EINVAL;

	} else if (*name != '/') {
		fdisk_warnx(cxt, "Bootfile must have a fully qualified pathname.");
		return -EINVAL;
	}

	if (strncmp(name, (char *) sgilabel->boot_file,
				sizeof(sgilabel->boot_file))) {
		fdisk_warnx(cxt, "Be aware that the bootfile is not checked "
				   "for existence.  SGI's default is \"/unix\", "
				   "and for backup \"/unix.save\".");
		return 0;       /* filename is correct and did change */
	}

	return 1;       /* filename did not change */
}

/* Allows to set SGI boot file. The function uses Ask API for dialog with
 * user.
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_sgi_set_bootfile(struct fdisk_context *cxt)
{
	int rc = 0;
	size_t sz;
	char *name = NULL;
	struct sgi_disklabel *sgilabel = self_disklabel_sgi(cxt);

	fdisk_info(cxt, "The current boot file is: %s", sgilabel->boot_file);

	rc = fdisk_ask_string(cxt, "Enter of the new boot file", &name);
	if (rc == 0)
		rc = sgi_check_bootfile(cxt, name);
	if (rc) {
		if (rc == 1)
			fdisk_info(cxt, "Boot file is unchanged.");
		goto done;
	}

	memset(sgilabel->boot_file, 0, sizeof(sgilabel->boot_file));
	sz = strlen(name);

	memcpy(sgilabel->boot_file, name, sz);

	fdisk_info(cxt, "Bootfile has been changed to \"%s\".", name);
done:
	free(name);
	return rc;
}

static int sgi_write_disklabel(struct fdisk_context *cxt)
{
	struct sgi_disklabel *sgilabel;
	struct sgi_info *info = NULL;

	sgilabel = self_disklabel_sgi(cxt);
	sgilabel->csum = 0;
	sgilabel->csum = cpu_to_be32(sgi_pt_checksum(sgilabel));

	if (lseek(cxt->dev_fd, 0, SEEK_SET) < 0)
		goto err;
	if (write_all(cxt->dev_fd, sgilabel, DEFAULT_SECTOR_SIZE))
		goto err;
	if (!strncmp((char *) sgilabel->volume[0].name, "sgilabel", 8)) {
		/* Keep this habit of first writing the "sgilabel".
		 * I never tested whether it works without. (AN 1998-10-02) */
		int infostartblock
			= be32_to_cpu(sgilabel->volume[0].block_num);

		if (lseek(cxt->dev_fd, (off_t) infostartblock *
					DEFAULT_SECTOR_SIZE, SEEK_SET) < 0)
			goto err;
		info = sgi_new_info();
		if (!info)
			goto err;
		if (write_all(cxt->dev_fd, info, sizeof(*info)))
			goto err;
	}

	sgi_free_info(info);
	return 0;
err:
	sgi_free_info(info);
	return -errno;
}

static int compare_start(struct fdisk_context *cxt,
			 const void *x, const void *y)
{
	/* Sort according to start sectors and prefer the largest partition:
	 * entry zero is the entire-disk entry. */
	const unsigned int i = *(const int *) x;
	const unsigned int j = *(const int *) y;
	unsigned int a = sgi_get_start_sector(cxt, i);
	unsigned int b = sgi_get_start_sector(cxt, j);
	unsigned int c = sgi_get_num_sectors(cxt, i);
	unsigned int d = sgi_get_num_sectors(cxt, j);

	if (a == b)
		return (d > c) ? 1 : (d == c) ? 0 : -1;
	return (a > b) ? 1 : -1;
}

static void generic_swap(void *a0, void *b0, int size)
{
	char *a = a0, *b = b0;

	for (; size > 0; --size, a++, b++) {
		char t = *a;
		*a = *b;
		*b = t;
	}
}


/* heap sort, based on Matt Mackall's linux kernel version */
static void sort(void *base0, size_t num, size_t size, struct fdisk_context *cxt,
		 int (*cmp_func)(struct fdisk_context *, const void *, const void *))
{
	/* pre-scale counters for performance */
	int i = (num/2 - 1) * size;
	size_t n = num * size, c, r;
	char *base = base0;

	/* heapify */
	for ( ; i >= 0; i -= size) {
		for (r = i; r * 2 + size < n; r  = c) {
			c = r * 2 + size;
			if (c < n - size &&
			    cmp_func(cxt, base + c, base + c + size) < 0)
				c += size;
			if (cmp_func(cxt, base + r, base + c) >= 0)
				break;
			generic_swap(base + r, base + c, size);
		}
	}

	/* sort */
	for (i = n - size; i > 0; i -= size) {
		generic_swap(base, base + i, size);
		for (r = 0; r * 2 + size < (size_t) i; r = c) {
			c = r * 2 + size;
			if (c < i - size &&
			    cmp_func(cxt, base + c, base + c + size) < 0)
				c += size;
			if (cmp_func(cxt, base + r, base + c) >= 0)
				break;
			generic_swap(base + r, base + c, size);
		}
	}
}

static int verify_disklabel(struct fdisk_context *cxt, int verbose)
{
	int Index[SGI_MAXPARTITIONS];   /* list of valid partitions */
	int sortcount = 0;              /* number of used partitions, i.e. non-zero lengths */
	int entire = 0, i = 0;
	unsigned int start = 0;
	long long gap = 0;      /* count unused blocks */
	unsigned int lastblock = sgi_get_lastblock(cxt);

	clear_freelist(cxt);
	memset(Index, 0, sizeof(Index));

	for (i=0; i < SGI_MAXPARTITIONS; i++) {
		if (sgi_get_num_sectors(cxt, i) != 0) {
			Index[sortcount++] = i;
			if (sgi_get_sysid(cxt, i) == SGI_TYPE_ENTIRE_DISK
			    && entire++ == 1 && verbose) {
				fdisk_info(cxt, "More than one entire "
						"disk entry present.");
			}
		}
	}
	if (sortcount == 0) {
		if (verbose)
			fdisk_info(cxt, "No partitions defined.");
		if (lastblock)
			add_to_freelist(cxt, 0, lastblock);
		return (lastblock > 0) ? 1 : (lastblock == 0) ? 0 : -1;
	}

	sort(Index, sortcount, sizeof(Index[0]), cxt, compare_start);

	if (sgi_get_sysid(cxt, Index[0]) == SGI_TYPE_ENTIRE_DISK) {
		if (verbose && Index[0] != 10)
			fdisk_info(cxt, "IRIX likes it when partition 11 "
					  "covers the entire disk.");

		if (verbose && sgi_get_start_sector(cxt, Index[0]) != 0)
			fdisk_info(cxt, "The entire disk partition should "
					  "start at block 0, not at block %d.",
				   sgi_get_start_sector(cxt, Index[0]));

		lastblock = sgi_get_num_sectors(cxt, Index[0]);
	} else if (verbose) {
		fdisk_info(cxt, "Partition 11 should cover the entire disk.");
	}
	for (i=1, start=0; i<sortcount; i++) {
		int cylsize = sgi_get_nsect(cxt) * sgi_get_ntrks(cxt);

		if (verbose && cylsize
		    && (sgi_get_start_sector(cxt, Index[i]) % cylsize) != 0)

		if (verbose && cylsize
		    && sgi_get_num_sectors(cxt, Index[i]) % cylsize != 0)

		/* We cannot handle several "entire disk" entries. */
		if (sgi_get_sysid(cxt, Index[i]) == SGI_TYPE_ENTIRE_DISK)
			continue;

		if (start > sgi_get_start_sector(cxt, Index[i])) {
			if (verbose)
				fdisk_info(cxt,
					   P_("Partitions %d and %d overlap by %d sector.",
					      "Partitions %d and %d overlap by %d sectors.",
					      start - sgi_get_start_sector(cxt, Index[i])),
					   Index[i-1]+1, Index[i]+1,
					   start - sgi_get_start_sector(cxt, Index[i]));
			if (gap >  0) gap = -gap;
			if (gap == 0) gap = -1;
		}
		if (start < sgi_get_start_sector(cxt, Index[i])) {
			if (verbose)
				fdisk_info(cxt,
					   P_("Unused gap of %8u sector: sector %8u",
					      "Unused gap of %8u sectors: sectors %8u-%u",
					      sgi_get_start_sector(cxt, Index[i]) - start),
					   sgi_get_start_sector(cxt, Index[i]) - start,
					   start, sgi_get_start_sector(cxt, Index[i])-1);
			gap += sgi_get_start_sector(cxt, Index[i]) - start;
			add_to_freelist(cxt, start,
					sgi_get_start_sector(cxt, Index[i]));
		}
		start = sgi_get_start_sector(cxt, Index[i])
			+ sgi_get_num_sectors(cxt, Index[i]);
		/* Align free space on cylinder boundary. */
		if (cylsize && start % cylsize)
			start += cylsize - (start % cylsize);

	}
	if (start < lastblock) {
		if (verbose)
			fdisk_info(cxt, P_("Unused gap of %8u sector: sector %8u",
					   "Unused gap of %8u sectors: sectors %8u-%u",
					   lastblock - start),
				   lastblock - start, start, lastblock-1);
		gap += lastblock - start;
		add_to_freelist(cxt, start, lastblock);
	}
	/* Done with arithmetics. Go for details now. */
	if (verbose) {
		if (sgi_get_bootpartition(cxt) < 0
		    || !sgi_get_num_sectors(cxt, sgi_get_bootpartition(cxt)))
			fdisk_info(cxt, "The boot partition does not exist.");

		if (sgi_get_swappartition(cxt) < 0
		    || !sgi_get_num_sectors(cxt, sgi_get_swappartition(cxt)))
			fdisk_info(cxt, "The swap partition does not exist.");

		else if (sgi_get_sysid(cxt, sgi_get_swappartition(cxt)) != SGI_TYPE_SWAP
		    && sgi_get_sysid(cxt, sgi_get_swappartition(cxt)) != MBR_LINUX_SWAP_PARTITION)
			fdisk_info(cxt, "The swap partition has no swap type.");

		if (sgi_check_bootfile(cxt, "/unix"))
			fdisk_info(cxt, "You have chosen an unusual bootfile name.");
	}

	return (gap > 0) ? 1 : (gap == 0) ? 0 : -1;
}

static int sgi_verify_disklabel(struct fdisk_context *cxt)
{
	return verify_disklabel(cxt, 1);
}

static int sgi_gaps(struct fdisk_context *cxt)
{
	/* returned value is:
	 *  = 0 : disk is properly filled to the rim
	 *  < 0 : there is an overlap
	 *  > 0 : there is still some vacant space */
	return verify_disklabel(cxt, 0);
}

/* Returns partition index of first entry marked as entire disk. */
static int sgi_entire(struct fdisk_context *cxt)
{
	size_t i;

	for (i = 0; i < SGI_MAXPARTITIONS; i++)
		if (sgi_get_sysid(cxt, i) == SGI_TYPE_ENTIRE_DISK)
			return i;
	return -1;
}

static int set_partition_sgi(struct fdisk_context *cxt, size_t i,
			     unsigned int start, unsigned int length, int sys)
{
	struct sgi_disklabel *sgilabel;

	sgilabel = self_disklabel_sgi(cxt);
	sgilabel->partitions[i].type = cpu_to_be32(sys);
	sgilabel->partitions[i].num_blocks = cpu_to_be32(length);
	sgilabel->partitions[i].first_block = cpu_to_be32(start);

	fdisk_label_set_changed1(cxt->label);

	if (sgi_gaps(cxt) < 0)  /* rebuild freelist */
		fdisk_warnx(cxt, "Partition overlap on the disk.");
	if (length) {
		struct fdisk_parttype *t =
				fdisk_label_get_parttype_from_code(cxt->label, sys);
		fdisk_info_new_partition(cxt, i + 1, start, start + length, t);
	}

	return 0;
}

static void sgi_set_entire(struct fdisk_context *cxt)
{
	size_t n;

	for (n = 10; n < cxt->label->nparts_max; n++) {
		if (!sgi_get_num_sectors(cxt, n)) {
			set_partition_sgi(cxt, n, 0, sgi_get_lastblock(cxt), SGI_TYPE_ENTIRE_DISK);
			break;
		}
	}
}

static void sgi_set_volhdr(struct fdisk_context *cxt)
{
	size_t n;

	for (n = 8; n < cxt->label->nparts_max; n++) {
		if (!sgi_get_num_sectors(cxt, n)) {
			/* Choose same default volume header size as IRIX fx uses. */
			if (4096 < sgi_get_lastblock(cxt))
				set_partition_sgi(cxt, n, 0, 4096, SGI_TYPE_VOLHDR);
			break;
		}
	}
}

static int sgi_delete_partition(struct fdisk_context *cxt, size_t partnum)
{
	int rc;

	if (partnum > cxt->label->nparts_max)
		return -EINVAL;

	rc = set_partition_sgi(cxt, partnum, 0, 0, 0);

	cxt->label->nparts_cur = count_used_partitions_sgi(cxt);

	return rc;
}

static int sgi_add_partition(struct fdisk_context *cxt,
			     struct fdisk_partition *pa,
			     size_t *partno)
{
	struct fdisk_sgi_label *sgi;
	char mesg[256];
	unsigned int first = 0, last = 0;
	struct fdisk_ask *ask;
	int sys = pa && pa->type ? pa->type->code : SGI_TYPE_XFS;
	int rc;
	size_t n;

	rc = fdisk_partition_next_partno(pa, cxt, &n);
	if (rc)
		return rc;
	if (n == 10)
		sys = SGI_TYPE_ENTIRE_DISK;
	else if (n == 8)
		sys = 0;

	sgi = self_label_sgi(cxt);

	if (sgi_get_num_sectors(cxt, n)) {
		fdisk_warnx(cxt, "Partition %zu is already defined.  "
				   "Delete it before re-adding it.", n + 1);
		return -EINVAL;
	}
	if (!cxt->script && sgi_entire(cxt) == -1 &&  sys != SGI_TYPE_ENTIRE_DISK) {
		fdisk_info(cxt, "Attempting to generate entire disk entry automatically.");
		sgi_set_entire(cxt);
		sgi_set_volhdr(cxt);
	}
	if (sgi_gaps(cxt) == 0 && sys != SGI_TYPE_ENTIRE_DISK) {
		fdisk_warnx(cxt, "The entire disk is already covered with partitions.");
		return -EINVAL;
	}
	if (sgi_gaps(cxt) < 0) {
		fdisk_warnx(cxt, "You got a partition overlap on the disk. Fix it first!");
		return -EINVAL;
	}

	if (sys == SGI_TYPE_ENTIRE_DISK) {
		first = 0;
		last = sgi_get_lastblock(cxt);
	} else {
		first = sgi->freelist[0].first;
		last  = sgi->freelist[0].last;
	}

	/* first sector */
	if (pa && pa->start_follow_default)
		;
	else if (pa && fdisk_partition_has_start(pa)) {
		first = pa->start;
		last = is_in_freelist(cxt, first);

		if (sys != SGI_TYPE_ENTIRE_DISK && !last)
			return -ERANGE;
	} else {
		snprintf(mesg, sizeof(mesg), "First %s",
				fdisk_get_unit(cxt, FDISK_SINGULAR));
		ask = fdisk_new_ask();
		fdisk_ask_set_query(ask, mesg);
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);

		fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, first));   /* minimal */
		fdisk_ask_number_set_default(ask, fdisk_scround(cxt, first));   /* default */
		fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, last) - 1); /* maximal */

		rc = fdisk_do_ask(cxt, ask);
		first = fdisk_ask_number_get_result(ask);
		fdisk_unref_ask(ask);

		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt))
			first *= fdisk_get_units_per_sector(cxt);
	}

	if (first && sys == SGI_TYPE_ENTIRE_DISK)
		fdisk_info(cxt, "It is highly recommended that the "
				  "eleventh partition covers the entire "
				  "disk and is of type 'SGI volume'.");
	if (!last)
		last = is_in_freelist(cxt, first);

	/* last sector */
	if (pa && pa->end_follow_default)
		last -= 1ULL;
	else if (pa && fdisk_partition_has_size(pa)) {
		if (first + pa->size - 1ULL > last)
			return -ERANGE;
		last = first + pa->size - 1ULL;
	} else {
		snprintf(mesg, sizeof(mesg),
			 "Last %s or +%s or +size{K,M,G,T,P}",
			 fdisk_get_unit(cxt, FDISK_SINGULAR),
			 fdisk_get_unit(cxt, FDISK_PLURAL));

		ask = fdisk_new_ask();
		fdisk_ask_set_query(ask, mesg);
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_OFFSET);

		fdisk_ask_number_set_low(ask,     fdisk_scround(cxt, first));   /* minimal */
		fdisk_ask_number_set_default(ask, fdisk_scround(cxt, last) - 1);/* default */
		fdisk_ask_number_set_high(ask,    fdisk_scround(cxt, last) - 1);/* maximal */
		fdisk_ask_number_set_base(ask,    fdisk_scround(cxt, first));
		fdisk_ask_number_set_wrap_negative1(ask); /* wrap negative around high */

		if (fdisk_use_cylinders(cxt))
			fdisk_ask_number_set_unit(ask, cxt->sector_size *
				     fdisk_get_units_per_sector(cxt));
		else
			fdisk_ask_number_set_unit(ask,cxt->sector_size);

		rc = fdisk_do_ask(cxt, ask);
		last = fdisk_ask_number_get_result(ask) + 1;

		fdisk_unref_ask(ask);
		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt))
			last *= fdisk_get_units_per_sector(cxt);
	}

	if (sys == SGI_TYPE_ENTIRE_DISK
	    && (first != 0 || last != sgi_get_lastblock(cxt)))
		fdisk_info(cxt, "It is highly recommended that the "
				  "eleventh partition covers the entire "
				  "disk and is of type 'SGI volume'.");

	set_partition_sgi(cxt, n, first, last - first, sys);
	cxt->label->nparts_cur = count_used_partitions_sgi(cxt);
	if (partno)
		*partno = n;
	return 0;
}

static int sgi_create_disklabel(struct fdisk_context *cxt)
{
	struct fdisk_sgi_label *sgi;
	struct sgi_disklabel *sgilabel;
	int rc;

	if (cxt->geom.heads && cxt->geom.sectors) {
		fdisk_sector_t llsectors;

		if (blkdev_get_sectors(cxt->dev_fd, (unsigned long long *) &llsectors) == 0) {
			/* the get device size ioctl was successful */
			fdisk_sector_t llcyls;
			int sec_fac = cxt->sector_size / 512;

			llcyls = llsectors / (cxt->geom.heads * cxt->geom.sectors * sec_fac);
			cxt->geom.cylinders = llcyls;
			if (cxt->geom.cylinders != llcyls)      /* truncated? */
				cxt->geom.cylinders = ~0;
		} else {
			/* otherwise print error and use truncated version */
			fdisk_warnx(cxt,
				"BLKGETSIZE ioctl failed on %s. "
				  "Using geometry cylinder value of %llu. "
				  "This value may be truncated for devices "
				  "> 33.8 GB.", cxt->dev_path, cxt->geom.cylinders);
		}
	}

	rc = fdisk_init_firstsector_buffer(cxt, 0, 0);
	if (rc)
		return rc;

	sgi = (struct fdisk_sgi_label *) cxt->label;
	sgi->header = (struct sgi_disklabel *) cxt->firstsector;

	sgilabel = sgi->header;

	sgilabel->magic = cpu_to_be32(SGI_LABEL_MAGIC);
	sgilabel->root_part_num = cpu_to_be16(0);
	sgilabel->swap_part_num = cpu_to_be16(1);

	/* sizeof(sgilabel->boot_file) = 16 > 6 */
	memset(sgilabel->boot_file, 0, 16);
	strcpy((char *) sgilabel->boot_file, "/unix");

	sgilabel->devparam.skew                 = (0);
	sgilabel->devparam.gap1                 = (0);
	sgilabel->devparam.gap2                 = (0);
	sgilabel->devparam.sparecyl                     = (0);
	sgilabel->devparam.pcylcount    = cpu_to_be16(cxt->geom.cylinders);
	sgilabel->devparam.head_vol0    = cpu_to_be16(0);
	sgilabel->devparam.ntrks        = cpu_to_be16(cxt->geom.heads);
	/* tracks/cylinder (heads) */
	sgilabel->devparam.cmd_tag_queue_depth  = (0);
	sgilabel->devparam.unused0                      = (0);
	sgilabel->devparam.unused1      = cpu_to_be16(0);
	sgilabel->devparam.nsect        = cpu_to_be16(cxt->geom.sectors);
	/* sectors/track */
	sgilabel->devparam.bytes        = cpu_to_be16(cxt->sector_size);
	sgilabel->devparam.ilfact       = cpu_to_be16(1);
	sgilabel->devparam.flags        = cpu_to_be32(
			SGI_DEVPARAM_TRACK_FWD
			| SGI_DEVPARAM_IGNORE_ERRORS
			| SGI_DEVPARAM_RESEEK);
	sgilabel->devparam.datarate     = cpu_to_be32(0);
	sgilabel->devparam.retries_on_error     = cpu_to_be32(1);
	sgilabel->devparam.ms_per_word          = cpu_to_be32(0);
	sgilabel->devparam.xylogics_gap1        = cpu_to_be16(0);
	sgilabel->devparam.xylogics_syncdelay   = cpu_to_be16(0);
	sgilabel->devparam.xylogics_readdelay   = cpu_to_be16(0);
	sgilabel->devparam.xylogics_gap2        = cpu_to_be16(0);
	sgilabel->devparam.xylogics_readgate    = cpu_to_be16(0);
	sgilabel->devparam.xylogics_writecont   = cpu_to_be16(0);

	memset(&(sgilabel->volume), 0,
			sizeof(struct sgi_volume) * SGI_MAXVOLUMES);
	memset(&(sgilabel->partitions), 0,
			sizeof(struct sgi_partition) * SGI_MAXPARTITIONS);
	cxt->label->nparts_max = SGI_MAXPARTITIONS;

	/* don't create default layout when a script defined */
	if (!cxt->script) {
		sgi_set_entire(cxt);
		sgi_set_volhdr(cxt);
	}
	cxt->label->nparts_cur = count_used_partitions_sgi(cxt);

	fdisk_info(cxt, "Created a new SGI disklabel.");
	return 0;
}

static int sgi_set_partition(struct fdisk_context *cxt,
		size_t i,
		struct fdisk_partition *pa)
{
	struct sgi_disklabel *sgilabel;

	if (i >= cxt->label->nparts_max)
		return -EINVAL;

	sgilabel = self_disklabel_sgi(cxt);

	if (pa->type) {
		struct fdisk_parttype *t = pa->type;

		if (sgi_get_num_sectors(cxt, i) == 0)   /* caught already before, ... */ {
			fdisk_warnx(cxt, "Sorry, only for non-empty partitions you can change the tag.");
			return -EINVAL;
		}

		if ((i == 10 && t->code != SGI_TYPE_ENTIRE_DISK)
		    || (i == 8 && t->code != 0))
			fdisk_info(cxt, "Consider leaving partition 9 as volume header (0), "
					  "and partition 11 as entire volume (6), "
					  "as IRIX expects it.");

		if (cxt->script == NULL
		    && ((t->code != SGI_TYPE_ENTIRE_DISK) && (t->code != SGI_TYPE_VOLHDR))
		    && (sgi_get_start_sector(cxt, i) < 1)) {
			int yes = 0;
			fdisk_ask_yesno(cxt,
				"It is highly recommended that the partition at offset 0 "
				  "is of type \"SGI volhdr\", the IRIX system will rely on it to "
				  "retrieve from its directory standalone tools like sash and fx. "
				  "Only the \"SGI volume\" entire disk section may violate this. "
				  "Are you sure about tagging this partition differently?", &yes);
			if (!yes)
				return 1;
		}

		sgilabel->partitions[i].type = cpu_to_be32(t->code);
	}

	if (fdisk_partition_has_start(pa))
		sgilabel->partitions[i].first_block = cpu_to_be32(pa->start);
	if (fdisk_partition_has_size(pa))
		sgilabel->partitions[i].num_blocks = cpu_to_be32(pa->size);

	fdisk_label_set_changed1(cxt->label);
	return 0;
}


static int sgi_partition_is_used(
		struct fdisk_context *cxt,
		size_t i)
{
	if (i >= cxt->label->nparts_max)
		return 0;
	return sgi_get_num_sectors(cxt, i) ? 1 : 0;
}

static int sgi_toggle_partition_flag(struct fdisk_context *cxt, size_t i, unsigned long flag)
{
	struct sgi_disklabel *sgilabel;

	if (i >= cxt->label->nparts_max)
		return -EINVAL;

	sgilabel = self_disklabel_sgi(cxt);

	switch (flag) {
	case SGI_FLAG_BOOT:
		sgilabel->root_part_num =
			be16_to_cpu(sgilabel->root_part_num) == i ?
			0 : cpu_to_be16(i);
		fdisk_label_set_changed1(cxt->label);
		break;
	case SGI_FLAG_SWAP:
		sgilabel->swap_part_num =
			be16_to_cpu(sgilabel->swap_part_num) == i ?
			0 : cpu_to_be16(i);
		fdisk_label_set_changed1(cxt->label);
		break;
	default:
		return 1;
	}

	return 0;
}

static const struct fdisk_field sgi_fields[] =
{
	{ FDISK_FIELD_DEVICE,   "Device",    10,    0 },
	{ FDISK_FIELD_START,    "Start",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_END,      "End",        5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SECTORS,  "Sectors",    5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_CYLINDERS,"Cylinders",  5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SIZE,     "Size",       5,    FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_EYECANDY },
	{ FDISK_FIELD_TYPEID,   "Id",         2,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_TYPE,     "Type",     0.1,    FDISK_FIELDFL_EYECANDY },
	{ FDISK_FIELD_ATTR,     "Attrs",      0,    FDISK_FIELDFL_NUMBER }
};

static const struct fdisk_label_operations sgi_operations =
{
	.probe          = sgi_probe_label,
	.write          = sgi_write_disklabel,
	.verify         = sgi_verify_disklabel,
	.get_item       = sgi_get_disklabel_item,
	.create         = sgi_create_disklabel,

	.get_part       = sgi_get_partition,
	.set_part       = sgi_set_partition,
	.add_part       = sgi_add_partition,
	.del_part       = sgi_delete_partition,

	.part_is_used   = sgi_partition_is_used,
	.part_toggle_flag = sgi_toggle_partition_flag
};

/* Allocates an SGI label driver. */
static struct fdisk_label *fdisk_new_sgi_label(struct fdisk_context *cxt __attribute__ ((__unused__)))
{
	struct fdisk_label *lb;
	struct fdisk_sgi_label *sgi;

	sgi = zmalloc(sizeof(*sgi));
	/* initialize generic part of the driver */
	lb = (struct fdisk_label *) sgi;
	lb->name = "sgi";
	lb->id = FDISK_DISKLABEL_SGI;
	lb->op = &sgi_operations;
	lb->parttypes = (struct fdisk_parttype *)sgi_parttypes;
	lb->nparttypes = ARRAY_SIZE(sgi_parttypes) - 1;
	lb->fields = sgi_fields;
	lb->nfields = ARRAY_SIZE(sgi_fields);

	lb->flags |= FDISK_LABEL_FL_REQUIRE_GEOMETRY;

	return lb;
}
#endif /* CONFIG_FEATURE_SGI_LABEL */

/* This is re-written version for libfdisk, the original was fdiskdoslabel.c
 * from util-linux fdisk. */
#define MAXIMUM_PARTS   60
#define ACTIVE_FLAG     0x80

#define IS_EXTENDED(i) \
	((i) == MBR_DOS_EXTENDED_PARTITION \
	 || (i) == MBR_W95_EXTENDED_PARTITION \
	 || (i) == MBR_LINUX_EXTENDED_PARTITION)

/* per partition table entry data
 *
 * The four primary partitions have the same sectorbuffer
 * and have NULL ex_entry.
 *
 * Each logical partition table entry has two pointers, one for the
 * partition and one link to the next one. */
struct pte {
	struct dos_partition *pt_entry; /* on-disk MBR entry */
	struct dos_partition *ex_entry; /* on-disk EBR entry */
	fdisk_sector_t offset;          /* disk sector number */
	unsigned char *sectorbuffer;    /* disk sector contents */

	unsigned int changed : 1,
		     private_sectorbuffer : 1;
};

/* in-memory fdisk GPT stuff */
struct fdisk_dos_label {
	struct fdisk_label      head;           /* generic part */

	struct pte      ptes[MAXIMUM_PARTS];    /* partition */
	fdisk_sector_t  ext_offset;             /* start of the ext.partition */
	size_t          ext_index;              /* ext.partition index (if ext_offset is set) */
	unsigned int    compatible : 1,         /* is DOS compatible? */
			non_pt_changed : 1;     /* MBR, but no PT changed */
};

/* Partition types */
static const struct fdisk_parttype dos_parttypes[] = {
	{0x00, "Empty"},
	{0x01, "FAT12"},
	{0x02, "XENIX root"},
	{0x03, "XENIX usr"},
	{0x04, "FAT16 <32M"},
	{0x05, "Extended"},         /* DOS 3.3+ extended partition */
	{0x06, "FAT16"},            /* DOS 16-bit >=32M */
	{0x07, "HPFS/NTFS/exFAT"},  /* OS/2 IFS, eg, HPFS or NTFS or QNX or exFAT */
	{0x08, "AIX"},              /* AIX boot (AIX -- PS/2 port) or SplitDrive */
	{0x09, "AIX bootable"},     /* AIX data or Coherent */
	{0x0a, "OS/2 Boot Manager"},/* OS/2 Boot Manager */
	{0x0b, "W95 FAT32"},
	{0x0c, "W95 FAT32 (LBA)"},/* LBA really is `Extended Int 13h' */
	{0x0e, "W95 FAT16 (LBA)"},
	{0x0f, "W95 Ext'd (LBA)"},
	{0x10, "OPUS"},
	{0x11, "Hidden FAT12"},
	{0x12, "Compaq diagnostics"},
	{0x14, "Hidden FAT16 <32M"},
	{0x16, "Hidden FAT16"},
	{0x17, "Hidden HPFS/NTFS"},
	{0x18, "AST SmartSleep"},
	{0x1b, "Hidden W95 FAT32"},
	{0x1c, "Hidden W95 FAT32 (LBA)"},
	{0x1e, "Hidden W95 FAT16 (LBA)"},
	{0x24, "NEC DOS"},
	{0x27, "Hidden NTFS WinRE"},
	{0x39, "Plan 9"},
	{0x3c, "PartitionMagic recovery"},
	{0x40, "Venix 80286"},
	{0x41, "PPC PReP Boot"},
	{0x42, "SFS"},
	{0x4d, "QNX4.x"},
	{0x4e, "QNX4.x 2nd part"},
	{0x4f, "QNX4.x 3rd part"},
	{0x50, "OnTrack DM"},
	{0x51, "OnTrack DM6 Aux1"}, /* (or Novell) */
	{0x52, "CP/M"},             /* CP/M or Microport SysV/AT */
	{0x53, "OnTrack DM6 Aux3"},
	{0x54, "OnTrackDM6"},
	{0x55, "EZ-Drive"},
	{0x56, "Golden Bow"},
	{0x5c, "Priam Edisk"},
	{0x61, "SpeedStor"},
	{0x63, "GNU HURD or SysV"}, /* GNU HURD or Mach or Sys V/386 (such as ISC UNIX) */
	{0x64, "Novell Netware 286"},
	{0x65, "Novell Netware 386"},
	{0x70, "DiskSecure Multi-Boot"},
	{0x75, "PC/IX"},
	{0x80, "Old Minix"},        /* Minix 1.4a and earlier */
	{0x81, "Minix / old Linux"},/* Minix 1.4b and later */
	{0x82, "Linux swap / Solaris"},
	{0x83, "Linux"},
	{0x84, "OS/2 hidden or Intel hibernation"},/* OS/2 hidden C: drive,
					   hibernation type Microsoft APM
					   or hibernation Intel Rapid Start */
	{0x85, "Linux extended"},
	{0x86, "NTFS volume set"},
	{0x87, "NTFS volume set"},
	{0x88, "Linux plaintext"},
	{0x8e, "Linux LVM"},
	{0x93, "Amoeba"},
	{0x94, "Amoeba BBT"},       /* (bad block table) */
	{0x9f, "BSD/OS"},           /* BSDI */
	{0xa0, "IBM Thinkpad hibernation"},
	{0xa5, "FreeBSD"},          /* various BSD flavours */
	{0xa6, "OpenBSD"},
	{0xa7, "NeXTSTEP"},
	{0xa8, "Darwin UFS"},
	{0xa9, "NetBSD"},
	{0xab, "Darwin boot"},
	{0xaf, "HFS / HFS+"},
	{0xb7, "BSDI fs"},
	{0xb8, "BSDI swap"},
	{0xbb, "Boot Wizard hidden"},
	{0xbc, "Acronis FAT32 LBA"},/* hidden (+0xb0) Acronis Secure Zone (backup software) */
	{0xbe, "Solaris boot"},
	{0xbf, "Solaris"},
	{0xc1, "DRDOS/sec (FAT-12)"},
	{0xc4, "DRDOS/sec (FAT-16 < 32M)"},
	{0xc6, "DRDOS/sec (FAT-16)"},
	{0xc7, "Syrinx"},
	{0xda, "Non-FS data"},
	{0xdb, "CP/M / CTOS / ..."},/* CP/M or Concurrent CP/M or
					   Concurrent DOS or CTOS */
	{0xde, "Dell Utility"},     /* Dell PowerEdge Server utilities */
	{0xdf, "BootIt"},           /* BootIt EMBRM */
	{0xe1, "DOS access"},       /* DOS access or SpeedStor 12-bit FAT
					   extended partition */
	{0xe3, "DOS R/O"},          /* DOS R/O or SpeedStor */
	{0xe4, "SpeedStor"},        /* SpeedStor 16-bit FAT extended
					   partition < 1024 cyl. */
	{0xea, "Rufus alignment"},  /* Rufus extra partition for alignment */
	{0xeb, "BeOS fs"},
	{0xee, "GPT"},              /* Intel EFI GUID Partition Table */
	{0xef, "EFI (FAT-12/16/32)"},/* Intel EFI System Partition */
	{0xf0, "Linux/PA-RISC boot"},/* Linux/PA-RISC boot loader */
	{0xf1, "SpeedStor"},
	{0xf4, "SpeedStor"},        /* SpeedStor large partition */
	{0xf2, "DOS secondary"},    /* DOS 3.3+ secondary */
	{0xfb, "VMware VMFS"},
	{0xfc, "VMware VMKCORE"},   /* VMware kernel dump partition */
	{0xfd, "Linux raid autodetect"},/* Linux raid partition with
					       autodetect using persistent
					       superblock */
	{0xfe, "LANstep"},          /* SpeedStor >1024 cyl. or LANstep */
	{0xff, "BBT"},              /* Xenix Bad Block Table */

	{ 0, NULL }
};

#define set_hsc(h,s,c,sector) { \
		s = sector % cxt->geom.sectors + 1;                     \
		sector /= cxt->geom.sectors;                            \
		h = sector % cxt->geom.heads;                           \
		sector /= cxt->geom.heads;                              \
		c = sector & 0xff;                                      \
		s |= (sector >> 2) & 0xc0;                              \
	}


#define sector(s)       ((s) & 0x3f)
#define cylinder(s, c)  ((c) | (((s) & 0xc0) << 2))

#define alignment_required(_x)  ((_x)->grain != (_x)->sector_size)


#define cround(c, n)    fdisk_cround(c, n)


static inline struct fdisk_dos_label *self_label_dos(struct fdisk_context *cxt)
{
	return (struct fdisk_dos_label *) cxt->label;
}

static inline struct pte *self_pte(struct fdisk_context *cxt, size_t i)
{
	struct fdisk_dos_label *l = self_label_dos(cxt);

	if (i >= ARRAY_SIZE(l->ptes))
		return NULL;

	return &l->ptes[i];
}

static inline struct dos_partition *self_partition(struct fdisk_context *cxt,
				size_t i)
{
	struct pte *pe = self_pte(cxt, i);
	return pe ? pe->pt_entry : NULL;
}


static struct fdisk_parttype *dos_partition_parttype(
		struct fdisk_context *cxt,
		struct dos_partition *p)
{
	struct fdisk_parttype *t
		= fdisk_label_get_parttype_from_code(cxt->label, p->sys_ind);
	return t ? : fdisk_new_unknown_parttype(p->sys_ind, NULL);
}

/* Linux kernel cares about partition size only. Things like
 * partition type or so are completely irrelevant -- kzak Nov-2013 */
static int is_used_partition(struct dos_partition *p)
{
	return p && dos_partition_get_size(p) != 0;
}

static void partition_set_changed(
				struct fdisk_context *cxt,
				size_t i,
				int changed)
{
	struct pte *pe = self_pte(cxt, i);

	if (!pe)
		return;

	pe->changed = changed ? 1 : 0;
	if (changed)
		fdisk_label_set_changed1(cxt->label);
}

static fdisk_sector_t get_abs_partition_start(struct pte *pe)
{
	return pe->offset + dos_partition_get_start(pe->pt_entry);
}

static fdisk_sector_t get_abs_partition_end(struct pte *pe)
{
	fdisk_sector_t size;

	size = dos_partition_get_size(pe->pt_entry);
	return get_abs_partition_start(pe) + size - (size ? 1 : 0);
}

static int is_cleared_partition(struct dos_partition *p)
{
	return !(!p || p->boot_ind || p->bh || p->bs || p->bc ||
		 p->sys_ind || p->eh || p->es || p->ec ||
		 dos_partition_get_start(p) || dos_partition_get_size(p));
}

static int get_partition_unused_primary(struct fdisk_context *cxt,
					struct fdisk_partition *pa,
					size_t *partno)
{
	size_t org, n;
	int rc;

	org = cxt->label->nparts_max;

	cxt->label->nparts_max = 4;
	rc = fdisk_partition_next_partno(pa, cxt, &n);
	cxt->label->nparts_max = org;

	if (rc == 1) {
		fdisk_info(cxt, "All primary partitions have been defined already.");
		rc = -1;
	} else if (rc == -ERANGE) {
		fdisk_warnx(cxt, "Primary partition not available.");
	} else if (rc == 0)
		*partno = n;

	return rc;
}

static int seek_sector(struct fdisk_context *cxt, fdisk_sector_t secno)
{
	off_t offset = (off_t) secno * cxt->sector_size;

	return lseek(cxt->dev_fd, offset, SEEK_SET) == (off_t) -1 ? -errno : 0;
}

static int read_sector(struct fdisk_context *cxt, fdisk_sector_t secno,
			unsigned char *buf)
{
	int rc = seek_sector(cxt, secno);
	ssize_t r;

	if (rc < 0)
		return rc;

	r = read(cxt->dev_fd, buf, cxt->sector_size);
	if (r == (ssize_t) cxt->sector_size)
		return 0;
	if (r < 0)
		return -errno;
	return -1;
}

/* Allocate a buffer and read a partition table sector */
static int read_pte(struct fdisk_context *cxt, size_t pno, fdisk_sector_t offset)
{
	int rc;
	unsigned char *buf;
	struct pte *pe = self_pte(cxt, pno);

	if (!pe)
		return -EINVAL;

	buf = zmalloc(cxt->sector_size);
	pe->offset = offset;
	pe->sectorbuffer = buf;
	pe->private_sectorbuffer = 1;

	rc = read_sector(cxt, offset, pe->sectorbuffer);
	if (rc) {
		fdisk_warn(cxt, "Failed to read extended partition table "
				"(offset=%ju)", (uintmax_t) offset);
		return rc;
	}

	pe->changed = 0;
	pe->pt_entry = pe->ex_entry = NULL;
	return 0;
}


static void clear_partition(struct dos_partition *p)
{
	if (!p)
		return;
	p->boot_ind = 0;
	p->bh = 0;
	p->bs = 0;
	p->bc = 0;
	p->sys_ind = 0;
	p->eh = 0;
	p->es = 0;
	p->ec = 0;
	dos_partition_set_start(p,0);
	dos_partition_set_size(p,0);
}

/* Returns: 0 if DOS compatibility disabled, 1 if enabled */
static inline int fdisk_dos_is_compatible(struct fdisk_label *lb)
{
	return ((struct fdisk_dos_label *) lb)->compatible;
}

#define is_dos_compatible(_x) \
		   (fdisk_is_label(_x, DOS) && \
		    fdisk_dos_is_compatible(fdisk_get_label(_x, NULL)))

static void dos_init(struct fdisk_context *cxt)
{
	struct fdisk_dos_label *l = self_label_dos(cxt);
	size_t i;

	cxt->label->nparts_max = 4;     /* default, unlimited number of logical */

	l->ext_index = 0;
	l->ext_offset = 0;
	l->non_pt_changed = 0;

	memset(l->ptes, 0, sizeof(l->ptes));

	for (i = 0; i < 4; i++) {
		struct pte *pe = self_pte(cxt, i);

		pe->pt_entry = mbr_get_partition(cxt->firstsector, i);
		pe->ex_entry = NULL;
		pe->offset = 0;
		pe->sectorbuffer = cxt->firstsector;
		pe->private_sectorbuffer = 0;
		pe->changed = 0;
	}

	if (fdisk_is_listonly(cxt))
		return;
	/* Various warnings... */
	if (fdisk_missing_geometry(cxt))
		fdisk_warnx(cxt, "You can set geometry from the extra functions menu.");

	if (is_dos_compatible(cxt)) {
		fdisk_warnx(cxt, "DOS-compatible mode is deprecated.");

		if (cxt->sector_size != cxt->phy_sector_size)
			fdisk_info(cxt,
		"The device presents a logical sector size that is smaller than "
		"the physical sector size. Aligning to a physical sector (or optimal "
		"I/O) size boundary is recommended, or performance may be impacted.");
	}

	if (fdisk_use_cylinders(cxt))
		fdisk_warnx(cxt, "Cylinders as display units are deprecated.");

	if (cxt->total_sectors > UINT_MAX) {
		uint64_t bytes = cxt->total_sectors * cxt->sector_size;
		char sths_buf[SIZE_TO_HUMAN_STRING_BUFSIZ];

		size_to_human_string(SIZE_SUFFIX_SPACE | SIZE_SUFFIX_3LETTER, bytes, sths_buf);
		fdisk_warnx(cxt,
		"The size of this disk is %s (%ju bytes). DOS "
		  "partition table format cannot be used on drives for "
		  "volumes larger than %lu bytes for %lu-byte "
		  "sectors. Use GUID partition table format (GPT).",
			sths_buf, bytes,
			UINT_MAX * cxt->sector_size,
			cxt->sector_size);
	}
}

/* callback called by libfdisk */
static void dos_deinit(struct fdisk_label *lb)
{
	size_t i;
	struct fdisk_dos_label *l = (struct fdisk_dos_label *) lb;

	for (i = 0; i < ARRAY_SIZE(l->ptes); i++) {
		struct pte *pe = &l->ptes[i];

		if (pe->private_sectorbuffer && pe->sectorbuffer)
			free(pe->sectorbuffer);
		pe->sectorbuffer = NULL;
		pe->private_sectorbuffer = 0;
	}

	memset(l->ptes, 0, sizeof(l->ptes));
}

static void reset_pte(struct pte *pe)
{
	if (pe->private_sectorbuffer)
		free(pe->sectorbuffer);
	memset(pe, 0, sizeof(struct pte));
}

static int delete_partition(struct fdisk_context *cxt, size_t partnum)
{
	struct fdisk_dos_label *l;
	struct pte *pe;
	struct dos_partition *p;
	struct dos_partition *q;

	pe = self_pte(cxt, partnum);
	if (!pe)
		return -EINVAL;

	l = self_label_dos(cxt);
	p = pe->pt_entry;
	q = pe->ex_entry;

	/* Note that for the fifth partition (partnum == 4) we don't actually
	   decrement partitions. */
	if (partnum < 4) {
		if (IS_EXTENDED(p->sys_ind) && partnum == l->ext_index) {
			size_t i;
			for (i = 4; i < cxt->label->nparts_max; i++) {
				reset_pte(&l->ptes[i]);
			}
			cxt->label->nparts_max = 4;
			l->ptes[l->ext_index].ex_entry = NULL;
			l->ext_offset = 0;
			l->ext_index = 0;
		}
		partition_set_changed(cxt, partnum, 1);
		clear_partition(p);
	} else if (!q->sys_ind && partnum > 4) {
		reset_pte(&l->ptes[partnum]);
		--cxt->label->nparts_max;
		--partnum;
		/* clear link to deleted partition */
		clear_partition(l->ptes[partnum].ex_entry);
		partition_set_changed(cxt, partnum, 1);
	} else {
		if (partnum > 4) {
			p = l->ptes[partnum - 1].ex_entry;
			*p = *q;
			dos_partition_set_start(p, dos_partition_get_start(q));
			dos_partition_set_size(p, dos_partition_get_size(q));
			partition_set_changed(cxt, partnum - 1, 1);

		} else if (cxt->label->nparts_max > 5) {
			pe = &l->ptes[5];       /* second logical */

			if (pe->pt_entry)       /* prevent SEGFAULT */
				dos_partition_set_start(pe->pt_entry,
					       get_abs_partition_start(pe) -
					       l->ext_offset);
			pe->offset = l->ext_offset;
			partition_set_changed(cxt, 5, 1);
		}

		if (cxt->label->nparts_max > 5) {
			cxt->label->nparts_max--;
			reset_pte(&l->ptes[partnum]);
			while (partnum < cxt->label->nparts_max) {
				l->ptes[partnum] = l->ptes[partnum + 1];
				partnum++;
			}
			memset(&l->ptes[partnum], 0, sizeof(struct pte));
		} else {
			clear_partition(l->ptes[partnum].pt_entry);
			cxt->label->nparts_max--;

			if (partnum == 4) {
				reset_pte(&l->ptes[partnum]);
				partition_set_changed(cxt, l->ext_index, 1);
			}
		}
	}

	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int dos_delete_partition(struct fdisk_context *cxt, size_t partnum)
{
	struct pte *pe;

	pe = self_pte(cxt, partnum);
	if (!pe || !is_used_partition(pe->pt_entry))
		return -EINVAL;

	return delete_partition(cxt, partnum);
}

static void read_extended(struct fdisk_context *cxt, size_t ext)
{
	size_t i;
	struct pte *pex, *pe;
	struct dos_partition *p, *q;
	struct fdisk_dos_label *l = self_label_dos(cxt);

	l->ext_index = ext;
	pex = self_pte(cxt, ext);
	if (!pex)
		return;
	pex->ex_entry = pex->pt_entry;

	p = pex->pt_entry;
	if (!dos_partition_get_start(p)) {
		fdisk_warnx(cxt, "Bad offset in primary extended partition.");
		return;
	}

	while (IS_EXTENDED (p->sys_ind)) {
		if (cxt->label->nparts_max >= MAXIMUM_PARTS) {
			/* This is not a Linux restriction, but
			   this program uses arrays of size MAXIMUM_PARTS.
			   Do not try to `improve' this test. */
			struct pte *pre = self_pte(cxt,
						cxt->label->nparts_max - 1);
			fdisk_warnx(cxt,
			"Omitting partitions after #%zu. They will be deleted "
			  "if you save this partition table.",
				cxt->label->nparts_max);

			if (pre) {
				clear_partition(pre->ex_entry);
				partition_set_changed(cxt,
						cxt->label->nparts_max - 1, 1);
			}
			return;
		}

		pe = self_pte(cxt, cxt->label->nparts_max);
		if (!pe)
			return;

		if (read_pte(cxt, cxt->label->nparts_max, l->ext_offset +
						dos_partition_get_start(p)))
			return;

		if (!l->ext_offset)
			l->ext_offset = dos_partition_get_start(p);

		q = p = mbr_get_partition(pe->sectorbuffer, 0);

		for (i = 0; i < 4; i++, p++) {
			if (!dos_partition_get_size(p))
				continue;

			if (IS_EXTENDED (p->sys_ind)) {
				if (pe->ex_entry)
					fdisk_warnx(cxt, "Extra link pointer in partition "
					"table %zu.",
						cxt->label->nparts_max + 1);
				else
					pe->ex_entry = p;
			} else if (p->sys_ind) {
				if (pe->pt_entry)
					fdisk_warnx(cxt, "Ignoring extra data in partition "
					"table %zu.",
						cxt->label->nparts_max + 1);
				else
					pe->pt_entry = p;
			}
		}

		/* very strange code here... */
		if (!pe->pt_entry) {
			if (q != pe->ex_entry)
				pe->pt_entry = q;
			else
				pe->pt_entry = q + 1;
		}
		if (!pe->ex_entry) {
			if (q != pe->pt_entry)
				pe->ex_entry = q;
			else
				pe->ex_entry = q + 1;
		}

		p = pe->ex_entry;
		cxt->label->nparts_cur = ++cxt->label->nparts_max;
	}

	/* remove last empty EBR */
	pe = self_pte(cxt, cxt->label->nparts_max - 1);
	if (pe &&
	    is_cleared_partition(pe->ex_entry) &&
	    is_cleared_partition(pe->pt_entry)) {
		reset_pte(pe);
		cxt->label->nparts_max--;
		cxt->label->nparts_cur--;
	}

	/* remove empty links */
 remove:
	q = self_partition(cxt, 4);
	for (i = 4; i < cxt->label->nparts_max; i++) {
		p = self_partition(cxt, i);

		if (p && !dos_partition_get_size(p) &&
		    (cxt->label->nparts_max > 5 || (q && q->sys_ind))) {
			fdisk_info(cxt, "omitting empty partition (%zu)", i+1);
			delete_partition(cxt, i);
			goto remove;    /* numbering changed */
		}
	}
}

static int dos_create_disklabel(struct fdisk_context *cxt)
{
	unsigned int id = 0;
	int rc, has_id = 0;
	struct fdisk_dos_label *l;

	if (cxt->script) {
		char *end = NULL;
		const char *s = fdisk_script_get_header(cxt->script, "label-id");

		if (s) {
			errno = 0;
			id = strtol(s, &end, 16);
			if (!errno && end && s < end)
				has_id = 1;
		}
	}

	/* random disk signature */
	if (!has_id)
		random_get_bytes(&id, sizeof(id));

	if (fdisk_has_protected_bootbits(cxt))
		rc = fdisk_init_firstsector_buffer(cxt, 0, MBR_PT_BOOTBITS_SIZE);
	else
		rc = fdisk_init_firstsector_buffer(cxt, 0, 0);
	if (rc)
		return rc;
	dos_init(cxt);

	l = self_label_dos(cxt);

	/* Generate an MBR ID for this disk */
	mbr_set_id(cxt->firstsector, id);
	l->non_pt_changed = 1;
	fdisk_label_set_changed1(cxt->label);

	/* Put MBR signature */
	mbr_set_magic(cxt->firstsector);

	fdisk_info(cxt, "Created a new DOS disklabel with disk "
			 "identifier 0x%08x.", id);
	return 0;
}

static int dos_set_disklabel_id(struct fdisk_context *cxt)
{
	char *end = NULL, *str = NULL;
	unsigned int id, old;
	struct fdisk_dos_label *l;
	int rc;

	l = self_label_dos(cxt);
	old = mbr_get_id(cxt->firstsector);
	rc = fdisk_ask_string(cxt, "Enter the new disk identifier", &str);
	if (rc)
		return rc;

	errno = 0;
	id = strtoul(str, &end, 0);
	if (errno || str == end || (end && *end)) {
		fdisk_warnx(cxt, "Incorrect value.");
		return -EINVAL;
	}

	mbr_set_id(cxt->firstsector, id);
	l->non_pt_changed = 1;
	fdisk_label_set_changed1(cxt->label);

	fdisk_info(cxt, "Disk identifier changed from 0x%08x to 0x%08x.",
			old, id);
	return 0;
}

static void get_partition_table_geometry(struct fdisk_context *cxt,
			unsigned int *ph, unsigned int *ps)
{
	unsigned char *bufp = cxt->firstsector;
	struct dos_partition *p;
	int i, h, s, hh, ss;
	int first = 1;
	int bad = 0;

	hh = ss = 0;
	for (i = 0; i < 4; i++) {
		p = mbr_get_partition(bufp, i);
		if (p->sys_ind != 0) {
			h = p->eh + 1;
			s = (p->es & 077);
			if (first) {
				hh = h;
				ss = s;
				first = 0;
			} else if (hh != h || ss != s)
				bad = 1;
		}
	}

	if (!first && !bad) {
		*ph = hh;
		*ps = ss;
	}
}

static int dos_reset_alignment(struct fdisk_context *cxt)
{
	/* overwrite necessary stuff by DOS deprecated stuff */
	if (is_dos_compatible(cxt)) {
		if (cxt->geom.sectors)
			cxt->first_lba = cxt->geom.sectors;     /* usually 63 */

		cxt->grain = cxt->sector_size;                  /* usually 512 */
	}

	return 0;
}

/* TODO: move to include/pt-dos.h and share with libblkid */
#define AIX_MAGIC_STRING        "\xC9\xC2\xD4\xC1"
#define AIX_MAGIC_STRLEN        (sizeof(AIX_MAGIC_STRING) - 1)

static int dos_probe_label(struct fdisk_context *cxt)
{
	size_t i;
	unsigned int h = 0, s = 0;

	/* ignore disks with AIX magic number */
	if (memcmp(cxt->firstsector, AIX_MAGIC_STRING, AIX_MAGIC_STRLEN) == 0)
		return 0;

	if (!mbr_is_valid_magic(cxt->firstsector))
		return 0;

	dos_init(cxt);

	get_partition_table_geometry(cxt, &h, &s);
	if (h && s) {
		cxt->geom.heads = h;
		cxt->geom.sectors = s;

		if (fdisk_has_user_device_geometry(cxt))
			fdisk_apply_user_device_properties(cxt);
	}

	for (i = 0; i < 4; i++) {
		struct pte *pe = self_pte(cxt, i);

		if (is_used_partition(pe->pt_entry))
			cxt->label->nparts_cur++;

		if (IS_EXTENDED (pe->pt_entry->sys_ind)) {
			if (cxt->label->nparts_max != 4)
				fdisk_warnx(cxt, "Ignoring extra extended partition %zu",
					i + 1);
			else
				read_extended(cxt, i);
		}
	}

	for (i = 3; i < cxt->label->nparts_max; i++) {
		struct pte *pe = self_pte(cxt, i);
		struct fdisk_dos_label *l = self_label_dos(cxt);

		if (!mbr_is_valid_magic(pe->sectorbuffer)) {
			fdisk_info(cxt,
			"Invalid flag 0x%02x%02x of EBR (for partition %zu) will "
			"be corrected by w(rite).",
				pe->sectorbuffer[510],
				pe->sectorbuffer[511],
				i + 1);
			partition_set_changed(cxt, i, 1);

			/* mark also extended as changed to update the first EBR
			 * in situation that there is no logical partitions at all */
			partition_set_changed(cxt, l->ext_index, 1);
		}
	}

	return 1;
}

static void set_partition_dos(struct fdisk_context *cxt,
			  int i, int doext, fdisk_sector_t start,
			  fdisk_sector_t stop, int sysid, int boot)
{
	struct pte *pe = self_pte(cxt, i);
	struct dos_partition *p;
	fdisk_sector_t offset;

	if (doext) {
		struct fdisk_dos_label *l = self_label_dos(cxt);
		p = pe->ex_entry;
		offset = l->ext_offset;
	} else {
		p = pe->pt_entry;
		offset = pe->offset;
	}

	p->boot_ind = boot ? ACTIVE_FLAG : 0;
	p->sys_ind = sysid;
	dos_partition_set_start(p, start - offset);
	dos_partition_set_size(p, stop - start + 1);

	if (is_dos_compatible(cxt) && (start/(cxt->geom.sectors*cxt->geom.heads) > 1023))
		start = cxt->geom.heads*cxt->geom.sectors*1024 - 1;
	set_hsc(p->bh, p->bs, p->bc, start);
	if (is_dos_compatible(cxt) && (stop/(cxt->geom.sectors*cxt->geom.heads) > 1023))
		stop = cxt->geom.heads*cxt->geom.sectors*1024 - 1;
	set_hsc(p->eh, p->es, p->ec, stop);
	partition_set_changed(cxt, i, 1);
}

static fdisk_sector_t get_unused_start(struct fdisk_context *cxt,
				 int part_n, fdisk_sector_t start,
				 fdisk_sector_t first[], fdisk_sector_t last[])
{
	size_t i;

	for (i = 0; i < cxt->label->nparts_max; i++) {
		fdisk_sector_t lastplusoff;
		struct pte *pe = self_pte(cxt, i);

		if (start == pe->offset)
			start += cxt->first_lba;
		lastplusoff = last[i] + ((part_n < 4) ? 0 : cxt->first_lba);
		if (start >= first[i] && start <= lastplusoff)
			start = lastplusoff + 1;
	}

	return start;
}

static void fill_bounds(struct fdisk_context *cxt,
			fdisk_sector_t *first, fdisk_sector_t *last)
{
	size_t i;
	struct pte *pe = self_pte(cxt, 0);
	struct dos_partition *p;

	for (i = 0; i < cxt->label->nparts_max; pe++,i++) {
		p = pe->pt_entry;
		if (is_cleared_partition(p) || IS_EXTENDED (p->sys_ind)) {
			first[i] = 0xffffffff;
			last[i] = 0;
		} else {
			first[i] = get_abs_partition_start(pe);
			last[i]  = get_abs_partition_end(pe);
		}
	}
}

static int get_start_from_user( struct fdisk_context *cxt,
				fdisk_sector_t *start,
				fdisk_sector_t low,
				fdisk_sector_t dflt,
				fdisk_sector_t limit,
				struct fdisk_partition *pa)
{
	/* try to use template from 'pa' */
	if (pa && pa->start_follow_default)
		*start = dflt;

	else if (pa && fdisk_partition_has_start(pa)) {
		*start = pa->start;
		if (*start < low || *start > limit) {
			fdisk_warnx(cxt, "Start sector %ju out of range.",
					(uintmax_t) *start);
			return -ERANGE;
		}
	} else {
		/* ask user by dialog */
		struct fdisk_ask *ask = fdisk_new_ask();
		int rc;

		fdisk_ask_set_query(ask, fdisk_use_cylinders(cxt) ? "First cylinder" : "First sector");
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);
		fdisk_ask_number_set_low(ask, fdisk_cround(cxt, low));
		fdisk_ask_number_set_default(ask, fdisk_cround(cxt, dflt));
		fdisk_ask_number_set_high(ask, fdisk_cround(cxt, limit));

		rc = fdisk_do_ask(cxt, ask);
		*start = fdisk_ask_number_get_result(ask);
		fdisk_unref_ask(ask);
		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt)) {
			*start = (*start - 1)
				* fdisk_get_units_per_sector(cxt);
			if (*start < low)
				*start = low;
		}
	}
	return 0;
}

static fdisk_sector_t get_possible_last(struct fdisk_context *cxt, size_t n)
{
	fdisk_sector_t limit;

	if (n >= 4) {
		/* logical partitions */
		struct fdisk_dos_label *l = self_label_dos(cxt);
		struct pte *ext_pe = l->ext_offset ? self_pte(cxt, l->ext_index) : NULL;

		if (!ext_pe)
			return 0;
		limit = get_abs_partition_end(ext_pe);
	} else {
		/* primary partitions */
		if (fdisk_use_cylinders(cxt) || !cxt->total_sectors)
			limit = cxt->geom.heads * cxt->geom.sectors * cxt->geom.cylinders - 1;
		else
			limit = cxt->total_sectors - 1;

		if (limit > UINT_MAX)
			limit = UINT_MAX;
	}
	return limit;
}

/* returns last free sector for area addressed by @start, the first[] and
 * last[] are fill_bounds() results */
static fdisk_sector_t get_unused_last(struct fdisk_context *cxt, size_t n,
				fdisk_sector_t start,
				fdisk_sector_t first[])
{
	size_t i;
	fdisk_sector_t limit = get_possible_last(cxt, n);

	for (i = 0; i < cxt->label->nparts_max; i++) {
		struct pte *pe = self_pte(cxt, i);

		if (start < pe->offset && limit >= pe->offset)
			limit = pe->offset - 1;
		if (start < first[i] && limit >= first[i])
			limit = first[i] - 1;
	}
	return limit;
}

static int add_partition(struct fdisk_context *cxt, size_t n,
			 struct fdisk_partition *pa)
{
	int sys, read = 0, rc, isrel = 0;
	size_t i;
	struct fdisk_dos_label *l = self_label_dos(cxt);
	struct dos_partition *p = self_partition(cxt, n);
	struct pte *ext_pe = l->ext_offset ? self_pte(cxt, l->ext_index) : NULL;
	struct fdisk_ask *ask = NULL;

	fdisk_sector_t start, stop = 0, limit, temp,
		first[cxt->label->nparts_max],
		last[cxt->label->nparts_max];

	sys = pa && pa->type ? pa->type->code : MBR_LINUX_DATA_PARTITION;

	if (p && is_used_partition(p)) {
		fdisk_warnx(cxt, "Partition %zu is already defined.  "
				   "Delete it before re-adding it.",
				n + 1);
		return -EINVAL;
	}
	fill_bounds(cxt, first, last);
	limit = get_possible_last(cxt, n);

	if (n < 4) {
		if (cxt->parent && fdisk_is_label(cxt->parent, GPT))
			start = 1;              /* Bad boy modifies hybrid MBR */
		else {
			if (cxt->script && pa && fdisk_partition_has_start(pa)
			    && pa->start < cxt->first_lba
			    && pa->start >= 1)
				fdisk_set_first_lba(cxt, 1);

			start = cxt->first_lba;
		}

		if (l->ext_offset) {
			first[l->ext_index] = l->ext_offset;
			last[l->ext_index] = get_abs_partition_end(ext_pe);
		}
	} else {
		if (cxt->script && pa && fdisk_partition_has_start(pa)
		    && pa->start >= l->ext_offset
		    && pa->start < l->ext_offset + cxt->first_lba)
			fdisk_set_first_lba(cxt, 1);

		start = l->ext_offset + cxt->first_lba;
	}

	if (fdisk_use_cylinders(cxt))
		for (i = 0; i < cxt->label->nparts_max; i++) {
			first[i] = (fdisk_cround(cxt, first[i]) - 1)
				* fdisk_get_units_per_sector(cxt);
		}

	/* Ask for first sector */
	do {
		fdisk_sector_t dflt, aligned;

		temp = start;
		dflt = start = get_unused_start(cxt, n, start, first, last);

		if (n >= 4 && pa && fdisk_partition_has_start(pa) && cxt->script
		    && cxt->first_lba > 1
		    && temp == start - cxt->first_lba) {
			fdisk_set_first_lba(cxt, 1);
			start = pa->start;
		}

		/* the default sector should be aligned and unused */
		do {
			aligned = fdisk_align_lba_in_range(cxt, dflt, dflt, limit);
			dflt = get_unused_start(cxt, n, aligned, first, last);
		} while (dflt != aligned && dflt > aligned && dflt < limit);

		if (dflt >= limit)
			dflt = start;
		if (start > limit)
			break;
		if (start >= temp + fdisk_get_units_per_sector(cxt)
		    && read) {
			fdisk_info(cxt, "Sector %llu is already allocated.", temp);
			temp = start;
			read = 0;
			if (pa && (fdisk_partition_has_start(pa) ||
				   pa->start_follow_default))
				break;
		}

		if (!read && start == temp) {
			rc = get_start_from_user(cxt, &start, temp, dflt, limit, pa);
			if (rc)
				return rc;
			read = 1;
		}
	} while (start != temp || !read);

	if (n == 4) {
		/* The first EBR is stored at begin of the extended partition */
		struct pte *pe = self_pte(cxt, n);

		pe->offset = l->ext_offset;
	} else if (n > 4) {
		/* The second (and another) EBR */
		struct pte *pe = self_pte(cxt, n);

		pe->offset = start - cxt->first_lba;
		if (pe->offset == l->ext_offset) { /* must be corrected */
			pe->offset++;
			if (cxt->first_lba == 1)
				start++;
		}
	}

	limit = get_unused_last(cxt, n, start, first);

	if (start > limit) {
		fdisk_warnx(cxt, "No free sectors available.");
		return -ENOSPC;
	}

	/* Ask for last sector */
	if (fdisk_cround(cxt, start) == fdisk_cround(cxt, limit))
		stop = limit;
	else if (pa && pa->end_follow_default)
		stop = limit;
	else if (pa && fdisk_partition_has_size(pa)) {
		stop = start + pa->size;
		isrel = pa->size_explicit ? 0 : 1;
		if ((!isrel || !alignment_required(cxt)) && stop > start)
			stop -= 1;
	} else {
		/* ask user by dialog */
		for (;;) {
			if (!ask)
				ask = fdisk_new_ask();
			else
				fdisk_reset_ask(ask);
			fdisk_ask_set_type(ask, FDISK_ASKTYPE_OFFSET);

			if (fdisk_use_cylinders(cxt)) {
				fdisk_ask_set_query(ask, "Last cylinder, +/-cylinders or +/-size{K,M,G,T,P}");
				fdisk_ask_number_set_unit(ask, cxt->sector_size *
					     fdisk_get_units_per_sector(cxt));
			} else {
				fdisk_ask_set_query(ask, "Last sector, +/-sectors or +/-size{K,M,G,T,P}");
				fdisk_ask_number_set_unit(ask,cxt->sector_size);
			}

			fdisk_ask_number_set_low(ask, fdisk_cround(cxt, start));
			fdisk_ask_number_set_default(ask, fdisk_cround(cxt, limit));
			fdisk_ask_number_set_high(ask, fdisk_cround(cxt, limit));
			fdisk_ask_number_set_base(ask, fdisk_cround(cxt, start));       /* base for relative input */
			fdisk_ask_number_set_wrap_negative1(ask); /* wrap negative around high */

			rc = fdisk_do_ask(cxt, ask);
			if (rc)
				goto done;

			stop = fdisk_ask_number_get_result(ask);
			isrel = fdisk_ask_number_is_relative(ask);
			if (fdisk_use_cylinders(cxt)) {
				stop = stop * fdisk_get_units_per_sector(cxt) - 1;
				if (stop >limit)
					stop = limit;
			}

			if (stop >= start && stop <= limit)
				break;
			fdisk_warnx(cxt, "Value out of range.");
		}
	}

	if (stop > limit)
		stop = limit;

	if (isrel && stop - start < (cxt->grain / fdisk_get_sector_size(cxt))) {
		/* Don't try to be smart on very small partitions and don't align so small sizes */
		isrel = 0;
		if (stop > start)
			stop -= 1;
	}

	if (stop < limit && isrel && alignment_required(cxt)) {
		/* the last sector has not been exactly requested (but
		 * defined by +size{K,M,G} convention), so be smart and
		 * align the end of the partition. The next partition
		 * will start at phy.block boundary. */
		stop = fdisk_align_lba_in_range(cxt, stop, start, limit);
		if (stop > start)
			stop -= 1;
		if (stop > limit)
			stop = limit;
	}

	set_partition_dos(cxt, n, 0, start, stop, sys, fdisk_partition_is_bootable(pa));
	if (n > 4) {
		struct pte *pe = self_pte(cxt, n);

		set_partition_dos(cxt, n - 1, 1, pe->offset, stop,
					MBR_DOS_EXTENDED_PARTITION, 0);
	}

	/* report */
	{
		struct fdisk_parttype *t =
			fdisk_label_get_parttype_from_code(cxt->label, sys);
		fdisk_info_new_partition(cxt, n + 1, start, stop, t);
		fdisk_unref_parttype(t);
	}


	if (IS_EXTENDED(sys)) {
		struct pte *pen = self_pte(cxt, n);

		l->ext_index = n;
		l->ext_offset = start;
		pen->ex_entry = p;
	}

	fdisk_label_set_changed1(cxt->label);
	rc = 0;
done:
	fdisk_unref_ask(ask);
	return rc;
}

static int add_logical(struct fdisk_context *cxt,
		       struct fdisk_partition *pa,
		       size_t *partno)
{
	struct pte *pe;
	int rc;

	pe = self_pte(cxt, cxt->label->nparts_max);

	if (!pe->sectorbuffer) {
		pe->sectorbuffer = zmalloc(cxt->sector_size);
		pe->private_sectorbuffer = 1;
	}
	pe->pt_entry = mbr_get_partition(pe->sectorbuffer, 0);
	pe->ex_entry = pe->pt_entry + 1;
	pe->offset = 0;
	partition_set_changed(cxt, cxt->label->nparts_max, 1);

	cxt->label->nparts_max++;

	/* this message makes sense only when we use extended/primary/logical
	 * dialog. The dialog is disable for scripts, see dos_add_partition() */
	if (!cxt->script)
		fdisk_info(cxt, "Adding logical partition %zu", cxt->label->nparts_max);
	*partno = cxt->label->nparts_max - 1;
	rc = add_partition(cxt, *partno, pa);

	if (rc) {
		/* reset on error */
		cxt->label->nparts_max--;
		pe->pt_entry = NULL;
		pe->ex_entry = NULL;
		pe->offset = 0;
		pe->changed = 0;
	}

	return rc;
}

static void check(struct fdisk_context *cxt, size_t n,
	   unsigned int h, unsigned int s, unsigned int c,
	   unsigned int start)
{
	unsigned int total, real_s, real_c;

	if (!is_dos_compatible(cxt))
		return;

	real_s = sector(s) - 1;
	real_c = cylinder(s, c);
	total = (real_c * cxt->geom.heads + h) * cxt->geom.sectors + real_s;

	if (!total)
		fdisk_warnx(cxt, "Partition %zu: contains sector 0", n);
	if (h >= cxt->geom.heads)
		fdisk_warnx(cxt, "Partition %zu: head %d greater than "
				   "maximum %d", n, h + 1, cxt->geom.heads);
	if (real_s >= cxt->geom.sectors)
		fdisk_warnx(cxt, "Partition %zu: sector %d greater than "
				   "maximum %llu", n, s, cxt->geom.sectors);
	if (real_c >= cxt->geom.cylinders)
		fdisk_warnx(cxt, "Partition %zu: cylinder %d greater than "
				   "maximum %llu",
				n, real_c + 1,
				cxt->geom.cylinders);

	if (cxt->geom.cylinders <= 1024 && start != total)
		fdisk_warnx(cxt, "Partition %zu: previous sectors %u "
				   "disagrees with total %u", n, start, total);
}

/* check_consistency() and long2chs() added Sat Mar 6 12:28:16 1993,
 * faith@cs.unc.edu, based on code fragments from pfdisk by Gordon W. Ross,
 * Jan.  1990 (version 1.2.1 by Gordon W. Ross Aug. 1990; Modified by S.
 * Lubkin Oct.  1991). */

static void
long2chs(struct fdisk_context *cxt, unsigned long ls,
	 unsigned int *c, unsigned int *h, unsigned int *s) {
	int spc = cxt->geom.heads * cxt->geom.sectors;

	*c = ls / spc;
	ls = ls % spc;
	*h = ls / cxt->geom.sectors;
	*s = ls % cxt->geom.sectors + 1;        /* sectors count from 1 */
}

static void check_consistency(struct fdisk_context *cxt, struct dos_partition *p,
			      size_t partition)
{
	unsigned int pbc, pbh, pbs;     /* physical beginning c, h, s */
	unsigned int pec, peh, pes;     /* physical ending c, h, s */
	unsigned int lbc, lbh, lbs;     /* logical beginning c, h, s */
	unsigned int lec, leh, les;     /* logical ending c, h, s */

	if (!is_dos_compatible(cxt))
		return;

	if (!cxt->geom.heads || !cxt->geom.sectors || (partition >= 4))
		return;         /* do not check extended partitions */

	/* physical beginning c, h, s */
	pbc = (p->bc & 0xff) | ((p->bs << 2) & 0x300);
	pbh = p->bh;
	pbs = p->bs & 0x3f;

	/* physical ending c, h, s */
	pec = (p->ec & 0xff) | ((p->es << 2) & 0x300);
	peh = p->eh;
	pes = p->es & 0x3f;

	/* compute logical beginning (c, h, s) */
	long2chs(cxt, dos_partition_get_start(p), &lbc, &lbh, &lbs);

	/* compute logical ending (c, h, s) */
	long2chs(cxt, dos_partition_get_start(p) + dos_partition_get_size(p) - 1, &lec, &leh, &les);

	/* Same physical / logical beginning? */
	if (cxt->geom.cylinders <= 1024
	    && (pbc != lbc || pbh != lbh || pbs != lbs)) {
		fdisk_warnx(cxt, "Partition %zu: different physical/logical "
			"beginnings (non-Linux?): "
			"phys=(%d, %d, %d), logical=(%d, %d, %d)",
			partition + 1,
			pbc, pbh, pbs,
			lbc, lbh, lbs);
	}

	/* Same physical / logical ending? */
	if (cxt->geom.cylinders <= 1024
	    && (pec != lec || peh != leh || pes != les)) {
		fdisk_warnx(cxt, "Partition %zu: different physical/logical "
			"endings: phys=(%d, %d, %d), logical=(%d, %d, %d)",
			partition + 1,
			pec, peh, pes,
			lec, leh, les);
	}

	/* Ending on cylinder boundary? */
	if (peh != (cxt->geom.heads - 1) || pes != cxt->geom.sectors) {
		fdisk_warnx(cxt, "Partition %zu: does not end on "
				   "cylinder boundary.",
			partition + 1);
	}
}

static int dos_verify_disklabel(struct fdisk_context *cxt)
{
	size_t i, j;
	fdisk_sector_t total = 1, n_sectors = cxt->total_sectors;
	fdisk_sector_t first[cxt->label->nparts_max],
		       last[cxt->label->nparts_max];
	struct dos_partition *p;
	struct fdisk_dos_label *l = self_label_dos(cxt);

	fill_bounds(cxt, first, last);
	for (i = 0; i < cxt->label->nparts_max; i++) {
		struct pte *pe = self_pte(cxt, i);

		p = self_partition(cxt, i);
		if (p && is_used_partition(p) && !IS_EXTENDED(p->sys_ind)) {
			check_consistency(cxt, p, i);
			if (get_abs_partition_start(pe) < first[i])
				fdisk_warnx(cxt, "Partition %zu: bad start-of-data.", i + 1);

			check(cxt, i + 1, p->eh, p->es, p->ec, last[i]);
			total += last[i] + 1 - first[i];

			if (i == 0)
				total += get_abs_partition_start(pe) - 1;

			for (j = 0; j < i; j++) {
				if ((first[i] >= first[j] && first[i] <= last[j])
				    || ((last[i] <= last[j] && last[i] >= first[j]))) {

					fdisk_warnx(cxt, "Partition %zu: overlaps partition %zu.",
						j + 1, i + 1);

					total += first[i] >= first[j] ?
						first[i] : first[j];
					total -= last[i] <= last[j] ?
						last[i] : last[j];
				}
			}
		}
	}

	if (l->ext_offset) {
		fdisk_sector_t e_last;
		struct pte *ext_pe = self_pte(cxt, l->ext_index);

		e_last = get_abs_partition_end(ext_pe);

		for (i = 4; i < cxt->label->nparts_max; i++) {
			total++;
			p = self_partition(cxt, i);

			if (!p->sys_ind) {
				if (i != 4 || i + 1 < cxt->label->nparts_max)
					fdisk_warnx(cxt, "Partition %zu: empty.", i + 1);
			} else if (first[i] < l->ext_offset
				   || last[i] > e_last) {

				fdisk_warnx(cxt, "Logical partition %zu: "
					"not entirely in partition %zu.",
					i + 1, l->ext_index + 1);
			}
		}
	}

	if (total > n_sectors)
		fdisk_warnx(cxt, "Total allocated sectors %llu greater "
			"than the maximum %llu.", total, n_sectors);
	else if (total < n_sectors)
		fdisk_warnx(cxt, "Remaining %lld unallocated %ld-byte "
			"sectors.", n_sectors - total, cxt->sector_size);

	return 0;
}

/* Ask the user for new partition type information (logical, extended).
 * This function calls the actual partition adding logic - add_partition.
 *
 * API callback. */
static int dos_add_partition(struct fdisk_context *cxt,
			     struct fdisk_partition *pa,
			     size_t *partno)
{
	size_t i, free_primary = 0, free_sectors = 0;
	fdisk_sector_t last = 0, grain;
	int rc = 0;
	struct fdisk_dos_label *l;
	struct pte *ext_pe;
	size_t res = 0;         /* partno */

	l = self_label_dos(cxt);
	ext_pe = l->ext_offset ? self_pte(cxt, l->ext_index) : NULL;

	/* partition template (@pa) based partitioning */

	/* A) template specifies start within extended partition; add logical */
	if (pa && fdisk_partition_has_start(pa) && ext_pe
	    && pa->start >= l->ext_offset
	    && pa->start <= get_abs_partition_end(ext_pe)) {
		if (fdisk_partition_has_partno(pa) && fdisk_partition_get_partno(pa) < 4)
			return -EINVAL;
		rc = add_logical(cxt, pa, &res);
		goto done;

	/* B) template specifies start out of extended partition; add primary */
	} else if (pa && fdisk_partition_has_start(pa) && ext_pe) {
		if (fdisk_partition_has_partno(pa) && fdisk_partition_get_partno(pa) >= 4)
			return -EINVAL;
		if (ext_pe && pa->type && IS_EXTENDED(pa->type->code)) {
			fdisk_warnx(cxt, "Extended partition already exists.");
			return -EINVAL;
		}
		rc = get_partition_unused_primary(cxt, pa, &res);
		if (rc == 0)
			rc = add_partition(cxt, res, pa);
		goto done;

	/* C) template specifies start (or default), partno < 4; add primary */
	} else if (pa && (fdisk_partition_start_is_default(pa) || fdisk_partition_has_start(pa))
		   && fdisk_partition_has_partno(pa)
		   && pa->partno < 4) {

		if (ext_pe && pa->type && IS_EXTENDED(pa->type->code)) {
			fdisk_warnx(cxt, "Extended partition already exists.");
			return -EINVAL;
		}
		rc = get_partition_unused_primary(cxt, pa, &res);
		if (rc == 0)
			rc = add_partition(cxt, res, pa);
		goto done;

	/* D) template specifies start (or default), partno >= 4; add logical */
	} else if (pa && (fdisk_partition_start_is_default(pa) || fdisk_partition_has_start(pa))
		   && fdisk_partition_has_partno(pa)
		   && pa->partno >= 4) {

		if (!ext_pe) {
			fdisk_warnx(cxt, "Extended partition does not exists. Failed to add logical partition.");
			return -EINVAL;
		} else if (fdisk_partition_has_start(pa)
			   && pa->start < l->ext_offset
			   && pa->start > get_abs_partition_end(ext_pe)) {
			return -EINVAL;
		}

		rc = add_logical(cxt, pa, &res);
		goto done;
	}

	/* Note @pa may be still used for things like partition type, etc */

	/* check if there is space for primary partition */
	grain = cxt->grain > cxt->sector_size ? cxt->grain / cxt->sector_size : 1;
	last = cxt->first_lba;

	for (i = 0; i < 4; i++) {
		struct dos_partition *p = self_partition(cxt, i);

		if (is_used_partition(p)) {
			fdisk_sector_t start = dos_partition_get_start(p);
			if (last + grain <= start)
				free_sectors = 1;
			last = start + dos_partition_get_size(p);
		} else
			free_primary++;
	}
	if (last + grain < cxt->total_sectors - 1)
		free_sectors = 1;

	if (!free_primary && cxt->label->nparts_max >= MAXIMUM_PARTS) {
		fdisk_info(cxt, "The maximum number of partitions has been created.");
		return -EINVAL;
	}
	rc = 1;

	if (!free_primary || !free_sectors) {
		if (l->ext_offset) {
			if (!pa || fdisk_partition_has_start(pa)) {
				/* See above case A); here we have start, but
				 * out of extended partition */
				const char *msg;
				if (!free_primary)
					msg = "All primary partitions are in use.";
				else
					msg =  "All space for primary partitions is in use.";

				if (pa && fdisk_partition_has_start(pa)) {
					fdisk_warnx(cxt, msg);
					return -EINVAL;
				} else
					fdisk_info(cxt, msg);
			}
			rc = add_logical(cxt, pa, &res);
		} else {
			if (free_primary)
				fdisk_info(cxt, "All space for primary partitions is in use.");
			else
			/* TRANSLATORS: Try to keep this within 80 characters. */
				fdisk_info(cxt, "To create more partitions, first replace "
					  "a primary with an extended partition.");
			return -EINVAL;
		}
	} else if (cxt->label->nparts_max >= MAXIMUM_PARTS) {
		fdisk_info(cxt, "All logical partitions are in use. "
				  "Adding a primary partition.");
		rc = get_partition_unused_primary(cxt, pa, &res);
		if (rc == 0)
			rc = add_partition(cxt, res, pa);
	} else {
		char hint[BUFSIZ];
		struct fdisk_ask *ask;
		int c;

		/* the default layout for scripts is to create primary partitions */
		if (cxt->script || !fdisk_has_dialogs(cxt)) {
			rc = get_partition_unused_primary(cxt, pa, &res);
			if (rc == 0)
				rc = add_partition(cxt, res, pa);
			goto done;
		}

		ask = fdisk_new_ask();
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_MENU);
		fdisk_ask_set_query(ask, "Partition type");
		fdisk_ask_menu_set_default(ask, free_primary == 1
						&& !l->ext_offset ? 'e' : 'p');
		snprintf(hint, sizeof(hint), "%zu primary, %d extended, %zu free",
				4 - (l->ext_offset ? 1 : 0) - free_primary,
				l->ext_offset ? 1 : 0,
				free_primary);

		fdisk_ask_menu_add_item(ask, 'p', "primary", hint);
		if (!l->ext_offset)
			fdisk_ask_menu_add_item(ask, 'e', "extended", "container for logical partitions");
		else
			fdisk_ask_menu_add_item(ask, 'l', "logical", "numbered from 5");

		rc = fdisk_do_ask(cxt, ask);
		if (!rc)
			fdisk_ask_menu_get_result(ask, &c);
		fdisk_unref_ask(ask);
		if (rc)
			return rc;

		if (c == 'p') {
			rc = get_partition_unused_primary(cxt, pa, &res);
			if (rc == 0)
				rc = add_partition(cxt, res, pa);
			goto done;
		} else if (c == 'l' && l->ext_offset) {
			rc = add_logical(cxt, pa, &res);
			goto done;
		} else if (c == 'e' && !l->ext_offset) {
			rc = get_partition_unused_primary(cxt, pa, &res);
			if (rc == 0) {
				struct fdisk_partition *xpa = NULL;
				struct fdisk_parttype *t;

				t = fdisk_label_get_parttype_from_code(cxt->label,
						MBR_DOS_EXTENDED_PARTITION);
				if (!pa) {
					pa = xpa = fdisk_new_partition();
				}
				fdisk_partition_set_type(pa, t);
				rc = add_partition(cxt, res, pa);
				if (xpa) {
					fdisk_unref_partition(xpa);
					pa = NULL;
				}
			}
			goto done;
		} else
			fdisk_warnx(cxt, "Invalid partition type `%c'.", c);
	}
done:
	if (rc == 0) {
		cxt->label->nparts_cur++;
		if (partno)
			*partno = res;
	}
	return rc;
}

static int write_sector(struct fdisk_context *cxt, fdisk_sector_t secno,
			       unsigned char *buf)
{
	int rc;

	rc = seek_sector(cxt, secno);
	if (rc != 0) {
		fdisk_warn(cxt, "Cannot write sector %jd: seek failed", (uintmax_t) secno);
		return rc;
	}

	if (write(cxt->dev_fd, buf, cxt->sector_size) != (ssize_t) cxt->sector_size)
		return -errno;
	return 0;
}

static int dos_write_disklabel(struct fdisk_context *cxt)
{
	struct fdisk_dos_label *l = self_label_dos(cxt);
	size_t i;
	int rc = 0, mbr_changed = 0;

	mbr_changed = l->non_pt_changed;

	/* MBR (primary partitions) */
	if (!mbr_changed) {
		for (i = 0; i < 4; i++) {
			struct pte *pe = self_pte(cxt, i);

			if (pe->changed)
				mbr_changed = 1;
		}
	}
	if (mbr_changed) {
		mbr_set_magic(cxt->firstsector);
		rc = write_sector(cxt, 0, cxt->firstsector);
		if (rc)
			goto done;
	}

	if (cxt->label->nparts_max <= 4 && l->ext_offset) {
		/* we have empty extended partition, check if the partition has
		 * been modified and then cleanup possible remaining EBR  */
		struct pte *pe = self_pte(cxt, l->ext_index);
		unsigned char empty[512] = { 0 };
		fdisk_sector_t off = pe ? get_abs_partition_start(pe) : 0;

		if (off && pe->changed) {
			mbr_set_magic(empty);
			write_sector(cxt, off, empty);
		}
	}

	/* EBR (logical partitions) */
	for (i = 4; i < cxt->label->nparts_max; i++) {
		struct pte *pe = self_pte(cxt, i);

		if (!pe->changed || !pe->offset || !pe->sectorbuffer)
			continue;

		mbr_set_magic(pe->sectorbuffer);
		rc = write_sector(cxt, pe->offset, pe->sectorbuffer);
		if (rc)
			goto done;
	}

done:
	return rc;
}

static int dos_locate_disklabel(struct fdisk_context *cxt, int n,
		const char **name, uint64_t *offset, size_t *size)
{
	*name = NULL;
	*offset = 0;
	*size = 0;

	switch (n) {
	case 0:
		*name = "MBR";
		*offset = 0;
		*size = 512;
		break;
	default:
		/* extended partitions */
		if ((size_t)n - 1 + 4 < cxt->label->nparts_max) {
			struct pte *pe = self_pte(cxt, n - 1 + 4);

			*name = "EBR";
			*offset = (uint64_t) pe->offset * cxt->sector_size;
			*size = 512;
		} else
			return 1;
		break;
	}

	return 0;
}

/* Check whether partition entries are ordered by their starting positions.
 * Return 0 if OK. Return i if partition i should have been earlier.
 * Two separate checks: primary and logical partitions. */
static int wrong_p_order(struct fdisk_context *cxt, size_t *prev)
{
	size_t last_p_start_pos = 0, p_start_pos;
	size_t i, last_i = 0;

	for (i = 0 ; i < cxt->label->nparts_max; i++) {

		struct pte *pe = self_pte(cxt, i);
		struct dos_partition *p;

		p = pe->pt_entry;

		if (i == 4) {
			last_i = 4;
			last_p_start_pos = 0;
		}
		if (is_used_partition(p)) {
			p_start_pos = get_abs_partition_start(pe);

			if (last_p_start_pos > p_start_pos) {
				if (prev)
					*prev = last_i;
				return i;
			}

			last_p_start_pos = p_start_pos;
			last_i = i;
		}
	}
	return 0;
}

static int dos_get_disklabel_item(struct fdisk_context *cxt, struct fdisk_labelitem *item)
{
	int rc = 0;

	switch (item->id) {
	case FDISK_LABELITEM_ID:
	{
		unsigned int num = mbr_get_id(cxt->firstsector);
		item->name = "Disk identifier";
		item->type = 's';
		item->data.str = xasprintf("0x%08x", num);
		break;
	}
	default:
		if (item->id < __FDISK_NLABELITEMS)
			rc = 1; /* unsupported generic item */
		else
			rc = 2; /* out of range */
		break;
	}

	return rc;

}

static int dos_get_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct dos_partition *p;
	struct pte *pe;
	struct fdisk_dos_label *lb;

	lb = self_label_dos(cxt);

	pe = self_pte(cxt, n);

	p = pe->pt_entry;
	pa->used = !is_cleared_partition(p);
	if (!pa->used)
		return 0;

	pa->type = dos_partition_parttype(cxt, p);
	pa->boot = p->boot_ind == ACTIVE_FLAG ? 1 : 0;
	pa->start = get_abs_partition_start(pe);
	pa->size = dos_partition_get_size(p);
	pa->container = lb->ext_offset && n == lb->ext_index;

	if (n >= 4)
		pa->parent_partno = lb->ext_index;

	if (p->boot_ind)
		pa->attrs = xasprintf("%02x", p->boot_ind);

	/* start C/H/S */
	pa->start_chs = xasprintf("%d/%d/%d",
				cylinder(p->bs, p->bc),
				p->bh, sector(p->bs));
	/* end C/H/S */
	pa->end_chs = xasprintf("%d/%d/%d",
				cylinder(p->es, p->ec),
				p->eh, sector(p->es));
	return 0;
}

static int has_logical(struct fdisk_context *cxt)
{
	size_t i;
	struct fdisk_dos_label *l = self_label_dos(cxt);

	for (i = 4; i < cxt->label->nparts_max; i++) {
		if (l->ptes[i].pt_entry)
			return 1;
	}
	return 0;
}

static int dos_set_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct fdisk_dos_label *l;
	struct dos_partition *p;
	struct pte *pe;
	int orgtype;
	fdisk_sector_t start, size;

	if (n >= cxt->label->nparts_max)
		return -EINVAL;

	l = self_label_dos(cxt);
	p = self_partition(cxt, n);

	pe = self_pte(cxt, n);
	if (!pe)
		return -EINVAL;

	orgtype = p->sys_ind;

	if (pa->type) {
		if (IS_EXTENDED(pa->type->code) && l->ext_offset && l->ext_index != n) {
			fdisk_warnx(cxt, "Extended partition already exists.");
			return -EINVAL;
		}

		if (!pa->type->code)
			fdisk_warnx(cxt, "Type 0 means free space to many systems. "
				   "Having partitions of type 0 is probably unwise.");

		if (IS_EXTENDED(p->sys_ind) && !IS_EXTENDED(pa->type->code) && has_logical(cxt)) {
			fdisk_warnx(cxt, "Cannot change type of the extended partition which is "
				"already used by logical partitions. Delete logical "
				"partitions first.");
			return -EINVAL;
		}
	}

	FDISK_INIT_UNDEF(start);
	FDISK_INIT_UNDEF(size);

	if (fdisk_partition_has_start(pa))
		start = pa->start;
	if (fdisk_partition_has_size(pa))
		size = pa->size;

	if (!FDISK_IS_UNDEF(start) || !FDISK_IS_UNDEF(size)) {
		if (FDISK_IS_UNDEF(start))
			start = get_abs_partition_start(pe);
		if (FDISK_IS_UNDEF(size))
			size = dos_partition_get_size(p);

		set_partition_dos(cxt, n, 0, start, start + size - 1,
				pa->type  ? pa->type->code : p->sys_ind,
				FDISK_IS_UNDEF(pa->boot) ?
					p->boot_ind == ACTIVE_FLAG :
					fdisk_partition_is_bootable(pa));
	} else {
		if (pa->type)
			p->sys_ind = pa->type->code;
		if (!FDISK_IS_UNDEF(pa->boot))
			p->boot_ind = fdisk_partition_is_bootable(pa) ? ACTIVE_FLAG : 0;
	}

	if (pa->type) {
		if (IS_EXTENDED(pa->type->code) && !IS_EXTENDED(orgtype)) {
			/* new extended partition - create a reference  */
			l->ext_index = n;
			l->ext_offset = dos_partition_get_start(p);
			pe->ex_entry = p;
		 } else if (IS_EXTENDED(orgtype)) {
			/* remove extended partition */
			cxt->label->nparts_max = 4;
			l->ptes[l->ext_index].ex_entry = NULL;
			l->ext_offset = 0;
			l->ext_index = 0;
		 }
	}

	partition_set_changed(cxt, n, 1);
	return 0;
}

static int cmp_ebr_offsets(const void *a, const void *b)
{
	const struct pte *ae = (const struct pte *) a,
			 *be = (const struct pte *) b;

	if (ae->offset == 0 && be->offset == 0)
		return 0;
	if (ae->offset == 0)
		return 1;
	if (be->offset == 0)
		return -1;

	return cmp_numbers(ae->offset, be->offset);
}

/* Fix the chain of logicals.
 *
 * The function does not modify data partitions within EBR tables
 * (pte->pt_entry). It sorts the chain by EBR offsets and then update links
 * (pte->ex_entry) between EBR tables. */
static void fix_chain_of_logicals(struct fdisk_context *cxt)
{
	struct fdisk_dos_label *l = self_label_dos(cxt);
	struct pte *last;
	size_t i;

	/* Sort chain by EBR offsets */
	qsort(&l->ptes[4], cxt->label->nparts_max - 4, sizeof(struct pte),
			cmp_ebr_offsets);

again:
	/* Sort data partitions by start */
	for (i = 4; i < cxt->label->nparts_max - 1; i++) {
		struct pte *cur = self_pte(cxt, i),
			   *nxt = self_pte(cxt, i + 1);

		if (get_abs_partition_start(cur) >
		    get_abs_partition_start(nxt)) {

			struct dos_partition tmp = *cur->pt_entry;
			fdisk_sector_t cur_start = get_abs_partition_start(cur),
				 nxt_start = get_abs_partition_start(nxt);

			/* swap data partitions */
			*cur->pt_entry = *nxt->pt_entry;
			*nxt->pt_entry = tmp;

			/* Recount starts according to EBR offsets, the absolute
			 * address still has to be the same! */
			dos_partition_set_start(cur->pt_entry, nxt_start - cur->offset);
			dos_partition_set_start(nxt->pt_entry, cur_start - nxt->offset);

			partition_set_changed(cxt, i, 1);
			partition_set_changed(cxt, i + 1, 1);
			goto again;
		}
	}

	/* Update EBR links */
	for (i = 4; i < cxt->label->nparts_max - 1; i++) {
		struct pte *cur = self_pte(cxt, i),
			   *nxt = self_pte(cxt, i + 1);

		fdisk_sector_t noff = nxt->offset - l->ext_offset,
		 ooff = dos_partition_get_start(cur->ex_entry);

		if (noff == ooff)
			continue;

		set_partition_dos(cxt, i, 1, nxt->offset,
				get_abs_partition_end(nxt),
				MBR_DOS_EXTENDED_PARTITION, 0);
	}

	/* always terminate the chain ! */
	last = self_pte(cxt, cxt->label->nparts_max - 1);
	if (last) {
		clear_partition(last->ex_entry);
		partition_set_changed(cxt, cxt->label->nparts_max - 1, 1);
	}
}

static int dos_reorder(struct fdisk_context *cxt)
{
	struct pte *pei, *pek;
	size_t i,k;

	if (!wrong_p_order(cxt, NULL)) {
		fdisk_info(cxt, "Nothing to do. Ordering is correct already.");
		return 1;
	}

	while ((i = wrong_p_order(cxt, &k)) != 0 && i < 4) {
		/* partition i should have come earlier, move it */
		/* We have to move data in the MBR */
		struct dos_partition *pi, *pk, *pe, pbuf;
		pei = self_pte(cxt, i);
		pek = self_pte(cxt, k);

		pe = pei->ex_entry;
		pei->ex_entry = pek->ex_entry;
		pek->ex_entry = pe;

		pi = pei->pt_entry;
		pk = pek->pt_entry;

		memmove(&pbuf, pi, sizeof(struct dos_partition));
		memmove(pi, pk, sizeof(struct dos_partition));
		memmove(pk, &pbuf, sizeof(struct dos_partition));

		partition_set_changed(cxt, i, 1);
		partition_set_changed(cxt, k, 1);
	}

	if (i)
		fix_chain_of_logicals(cxt);

	return 0;
}

/* TODO: use fdisk_set_partition() API */
static int fdisk_dos_move_begin(struct fdisk_context *cxt, size_t i)
{
	struct pte *pe;
	struct dos_partition *p;
	unsigned int new, free_start, curr_start, last;
	uintmax_t res = 0;
	size_t x;
	int rc;

	pe = self_pte(cxt, i);
	if (!pe)
		return -EINVAL;

	p = pe->pt_entry;

	if (!is_used_partition(p) || IS_EXTENDED (p->sys_ind)) {
		fdisk_warnx(cxt, "Partition %zu: no data area.", i + 1);
		return 0;
	}

	/* the default start is at the second sector of the disk or at the
	 * second sector of the extended partition */
	free_start = pe->offset ? pe->offset + 1 : 1;

	curr_start = get_abs_partition_start(pe);

	/* look for a free space before the current start of the partition */
	for (x = 0; x < cxt->label->nparts_max; x++) {
		unsigned int end;
		struct pte *prev_pe = self_pte(cxt, x);
		struct dos_partition *prev_p;

		prev_p = prev_pe->pt_entry;
		if (!prev_p)
			continue;
		end = get_abs_partition_start(prev_pe)
		      + dos_partition_get_size(prev_p);

		if (is_used_partition(prev_p) &&
		    end > free_start && end <= curr_start)
			free_start = end;
	}

	last = get_abs_partition_end(pe);

	rc = fdisk_ask_number(cxt, free_start, curr_start, last, "New beginning of data", &res);
	if (rc)
		return rc;

	new = res - pe->offset;

	if (new != dos_partition_get_size(p)) {
		unsigned int sects = dos_partition_get_size(p)
				+ dos_partition_get_start(p) - new;

		dos_partition_set_size(p, sects);
		dos_partition_set_start(p, new);

		partition_set_changed(cxt, i, 1);
	}

	return rc;
}

static int dos_partition_is_used(struct fdisk_context *cxt, size_t i)
{
	struct dos_partition *p;

	if (i >= cxt->label->nparts_max)
		return 0;

	p = self_partition(cxt, i);

	return p && !is_cleared_partition(p);
}

static int dos_toggle_partition_flag(struct fdisk_context *cxt, size_t i, unsigned long flag)
{
	struct dos_partition *p;

	if (i >= cxt->label->nparts_max)
		return -EINVAL;

	p = self_partition(cxt, i);

	switch (flag) {
	case DOS_FLAG_ACTIVE:
		if (IS_EXTENDED(p->sys_ind) && !p->boot_ind)
			fdisk_warnx(cxt, "Partition %zu: is an extended partition.", i + 1);

		p->boot_ind = (p->boot_ind ? 0 : ACTIVE_FLAG);
		partition_set_changed(cxt, i, 1);
		fdisk_info(cxt, p->boot_ind ?
			"The bootable flag on partition %zu is enabled now." :
			"The bootable flag on partition %zu is disabled now.",
			i + 1);
		break;
	default:
		return 1;
	}

	return 0;
}

static const struct fdisk_field dos_fields[] =
{
	/* basic */
	{ FDISK_FIELD_DEVICE,   "Device",    10,    0 },
	{ FDISK_FIELD_BOOT,     "Boot",       1,    0 },
	{ FDISK_FIELD_START,    "Start",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_END,      "End",        5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SECTORS,  "Sectors",    5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_CYLINDERS,"Cylinders",  5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SIZE,     "Size",       5,    FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_EYECANDY },
	{ FDISK_FIELD_TYPEID,   "Id",         2,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_TYPE,     "Type",     0.1,    0 }
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	,
	/* expert mode */
	{ FDISK_FIELD_SADDR,    "Start-C/H/S", 1,   FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_DETAIL },
	{ FDISK_FIELD_EADDR,    "End-C/H/S",   1,   FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_DETAIL },
	{ FDISK_FIELD_ATTR,     "Attrs",       2,   FDISK_FIELDFL_NUMBER | FDISK_FIELDFL_DETAIL }
#endif
};

static const struct fdisk_label_operations dos_operations =
{
	.probe          = dos_probe_label,
	.write          = dos_write_disklabel,
	.verify         = dos_verify_disklabel,
	.create         = dos_create_disklabel,
	.locate         = dos_locate_disklabel,
	.get_item       = dos_get_disklabel_item,
	.set_id         = dos_set_disklabel_id,

	.get_part       = dos_get_partition,
	.set_part       = dos_set_partition,
	.add_part       = dos_add_partition,
	.del_part       = dos_delete_partition,
	.reorder        = dos_reorder,

	.part_toggle_flag = dos_toggle_partition_flag,
	.part_is_used   = dos_partition_is_used,

	.reset_alignment = dos_reset_alignment,

	.deinit         = dos_deinit,
};

/* allocates DOS in-memory stuff */
static struct fdisk_label *fdisk_new_dos_label(struct fdisk_context *cxt __attribute__ ((__unused__)))
{
	struct fdisk_label *lb;
	struct fdisk_dos_label *dos;

	dos = zmalloc(sizeof(*dos));
	/* initialize generic part of the driver */
	lb = (struct fdisk_label *) dos;
	lb->name = "dos";
	lb->id = FDISK_DISKLABEL_DOS;
	lb->op = &dos_operations;
	lb->parttypes = (struct fdisk_parttype *)dos_parttypes;
	lb->nparttypes = ARRAY_SIZE(dos_parttypes) - 1;
	lb->fields = dos_fields;
	lb->nfields = ARRAY_SIZE(dos_fields);

	lb->geom_min.sectors = 1;
	lb->geom_min.heads = 1;
	lb->geom_min.cylinders = 1;

	lb->geom_max.sectors = 63;
	lb->geom_max.heads = 255;
	lb->geom_max.cylinders = 1048576;

	return lb;
}

/* Enables deprecated DOS compatible mode, in this mode library checks for
 * cylinders boundary, cases about CHS addressing and another obscure things.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_dos_enable_compatible(struct fdisk_label *lb, int enable)
{
	struct fdisk_dos_label *dos = (struct fdisk_dos_label *) lb;

	if (!lb)
		return -EINVAL;

	dos->compatible = enable;
	if (enable)
		lb->flags |= FDISK_LABEL_FL_REQUIRE_GEOMETRY;
	return 0;
}

#ifdef CONFIG_FEATURE_BSD_LABEL
/* BSD specific label items. */
enum fdisk_labelitem_bsd {
	/* specific */
	BSD_LABELITEM_TYPE = __FDISK_NLABELITEMS,
	BSD_LABELITEM_DISK,
	BSD_LABELITEM_PACKNAME,
	BSD_LABELITEM_FLAGS,
	BSD_LABELITEM_SECSIZE,
	BSD_LABELITEM_NTRACKS,
	BSD_LABELITEM_SECPERCYL,
	BSD_LABELITEM_CYLINDERS,
	BSD_LABELITEM_RPM,
	BSD_LABELITEM_INTERLEAVE,
	BSD_LABELITEM_TRACKSKEW,
	BSD_LABELITEM_CYLINDERSKEW,
	BSD_LABELITEM_HEADSWITCH,
	BSD_LABELITEM_TRKSEEK
};


/* Based on the original code from fdisk
 *    written by Bernhard Fastenrath (fasten@informatik.uni-bonn.de)
 *    with code from the NetBSD disklabel command.
 *
 *    Arnaldo Carvalho de Melo <acme@conectiva.com.br>, March 1999
 *    David Huggins-Daines <dhuggins@linuxcare.com>, January 2000 */
#define BSD_MAXPARTITIONS       16
#define BSD_FS_UNUSED           0

#ifndef BSD_DISKMAGIC
# define BSD_DISKMAGIC     ((uint32_t) 0x82564557)
#endif

#define BSD_LINUX_BOOTDIR "/usr/ucb/mdec"

#if defined (__alpha__) || defined (__powerpc__) || \
    defined (__ia64__) || defined (__hppa__)
# define BSD_LABELSECTOR   0
# define BSD_LABELOFFSET   64
#else
# define BSD_LABELSECTOR   1
# define BSD_LABELOFFSET   0
#endif

#define BSD_BBSIZE        8192          /* size of boot area, with label */
#define BSD_SBSIZE        8192          /* max size of fs superblock */

struct bsd_disklabel {
	uint32_t        d_magic;                /* the magic number */
	int16_t         d_type;                 /* drive type */
	int16_t         d_subtype;              /* controller/d_type specific */
	char            d_typename[16];         /* type name, e.g. "eagle" */
	char            d_packname[16];         /* pack identifier */

			/* disk geometry: */
	uint32_t        d_secsize;              /* # of bytes per sector */
	uint32_t        d_nsectors;             /* # of data sectors per track */
	uint32_t        d_ntracks;              /* # of tracks per cylinder */
	uint32_t        d_ncylinders;           /* # of data cylinders per unit */
	uint32_t        d_secpercyl;            /* # of data sectors per cylinder */
	uint32_t        d_secperunit;           /* # of data sectors per unit */

	/* Spares (bad sector replacements) below
	 * are not counted in d_nsectors or d_secpercyl.
	 * Spare sectors are assumed to be physical sectors
	 * which occupy space at the end of each track and/or cylinder. */
	uint16_t        d_sparespertrack;       /* # of spare sectors per track */
	uint16_t        d_sparespercyl;         /* # of spare sectors per cylinder */

	/* Alternate cylinders include maintenance, replacement,
	 * configuration description areas, etc. */
	uint32_t        d_acylinders;           /* # of alt. cylinders per unit */

			/* hardware characteristics: */
	/* d_interleave, d_trackskew and d_cylskew describe perturbations
	 * in the media format used to compensate for a slow controller.
	 * Interleave is physical sector interleave, set up by the formatter
	 * or controller when formatting.  When interleaving is in use,
	 * logically adjacent sectors are not physically contiguous,
	 * but instead are separated by some number of sectors.
	 * It is specified as the ratio of physical sectors traversed
	 * per logical sector.  Thus an interleave of 1:1 implies contiguous
	 * layout, while 2:1 implies that logical sector 0 is separated
	 * by one sector from logical sector 1.
	 * d_trackskew is the offset of sector 0 on track N
	 * relative to sector 0 on track N-1 on the same cylinder.
	 * Finally, d_cylskew is the offset of sector 0 on cylinder N
	 * relative to sector 0 on cylinder N-1. */
	uint16_t        d_rpm;                  /* rotational speed */
	uint16_t        d_interleave;           /* hardware sector interleave */
	uint16_t        d_trackskew;            /* sector 0 skew, per track */
	uint16_t        d_cylskew;              /* sector 0 skew, per cylinder */
	uint32_t        d_headswitch;           /* head switch time, usec */
	uint32_t        d_trkseek;              /* track-to-track seek, usec */
	uint32_t        d_flags;                /* generic flags */
	uint32_t        d_drivedata[5];         /* drive-type specific information */
	uint32_t        d_spare[5];             /* reserved for future use */
	uint32_t        d_magic2;               /* the magic number (again) */
	uint16_t        d_checksum;             /* xor of data incl. partitions */

			/* filesystem and partition information: */
	uint16_t        d_npartitions;          /* number of partitions in following */
	uint32_t        d_bbsize;               /* size of boot area at sn0, bytes */
	uint32_t        d_sbsize;               /* max size of fs superblock, bytes */

	struct bsd_partition     {              /* the partition table */
		uint32_t        p_size;         /* number of sectors in partition */
		uint32_t        p_offset;       /* starting sector */
		uint32_t        p_fsize;        /* filesystem basic fragment size */
		uint8_t         p_fstype;       /* filesystem type, see below */
		uint8_t         p_frag;         /* filesystem fragments per block */
		uint16_t        p_cpg;          /* filesystem cylinders per group */
	} __attribute__((packed)) d_partitions[BSD_MAXPARTITIONS];      /* actually may be more */
} __attribute__((packed));


/* d_type values: */
#define BSD_DTYPE_SMD           1               /* SMD, XSMD; VAX hp/up */
#define BSD_DTYPE_MSCP          2               /* MSCP */
#define BSD_DTYPE_DEC           3               /* other DEC (rk, rl) */
#define BSD_DTYPE_SCSI          4               /* SCSI */
#define BSD_DTYPE_ESDI          5               /* ESDI interface */
#define BSD_DTYPE_ST506         6               /* ST506 etc. */
#define BSD_DTYPE_HPIB          7               /* CS/80 on HP-IB */
#define BSD_DTYPE_HPFL          8               /* HP Fiber-link */
#define BSD_DTYPE_FLOPPY        10              /* floppy */

/* d_subtype values: */
#define BSD_DSTYPE_INDOSPART    0x8             /* is inside dos partition */
#define BSD_DSTYPE_DOSPART(s)   ((s) & 3)       /* dos partition number */
#define BSD_DSTYPE_GEOMETRY     0x10            /* drive params in label */

/* Filesystem type and version.
 * Used to interpret other filesystem-specific per-partition information. */
#define BSD_FS_UNUSED   0               /* unused */
#define BSD_FS_SWAP     1               /* swap */
#define BSD_FS_V6       2               /* Sixth Edition */
#define BSD_FS_V7       3               /* Seventh Edition */
#define BSD_FS_SYSV     4               /* System V */
#define BSD_FS_V71K     5               /* V7 with 1K blocks (4.1, 2.9) */
#define BSD_FS_V8       6               /* Eighth Edition, 4K blocks */
#define BSD_FS_BSDFFS   7               /* 4.2BSD fast file system */
#define BSD_FS_BSDLFS   9               /* 4.4BSD log-structured file system */
#define BSD_FS_OTHER    10              /* in use, but unknown/unsupported */
#define BSD_FS_HPFS     11              /* OS/2 high-performance file system */
#define BSD_FS_ISO9660  12              /* ISO-9660 filesystem (cdrom) */
#define BSD_FS_ISOFS    BSD_FS_ISO9660
#define BSD_FS_BOOT     13              /* partition contains bootstrap */
#define BSD_FS_ADOS     14              /* AmigaDOS fast file system */
#define BSD_FS_HFS      15              /* Macintosh HFS */
#define BSD_FS_ADVFS    16              /* Digital Unix AdvFS */

/* this is annoying, but it's also the way it is :-( */
#ifdef __alpha__
#define BSD_FS_EXT2     8               /* ext2 file system */
#else
#define BSD_FS_MSDOS    8               /* MS-DOS file system */
#endif

/* flags shared by various drives: */
#define BSD_D_REMOVABLE 0x01            /* removable media */
#define BSD_D_ECC       0x02            /* supports ECC */
#define BSD_D_BADSECT   0x04            /* supports bad sector forw. */
#define BSD_D_RAMDISK   0x08            /* disk emulator */
#define BSD_D_CHAIN     0x10            /* can do back-back transfers */
#define BSD_D_DOSPART   0x20            /* within MSDOS partition */

static const char * const bsd_dktypenames[] = {
	"unknown",
	"SMD",
	"MSCP",
	"old DEC",
	"SCSI",
	"ESDI",
	"ST506",
	"HP-IB",
	"HP-FL",
	"type 9",
	"floppy",
	NULL
};
#define BSD_DKMAXTYPES  (ARRAY_SIZE(bsd_dktypenames) - 1)

static const struct fdisk_parttype bsd_fstypes[] = {
	{BSD_FS_UNUSED, "unused"},
	{BSD_FS_SWAP,   "swap"},
	{BSD_FS_V6,     "Version 6"},
	{BSD_FS_V7,     "Version 7"},
	{BSD_FS_SYSV,   "System V"},
	{BSD_FS_V71K,   "4.1BSD"},
	{BSD_FS_V8,     "Eighth Edition"},
	{BSD_FS_BSDFFS, "4.2BSD"},
#ifdef __alpha__
	{BSD_FS_EXT2,   "ext2"},
#else
	{BSD_FS_MSDOS,  "MS-DOS"},
#endif
	{BSD_FS_BSDLFS, "4.4LFS"},
	{BSD_FS_OTHER,  "unknown"},
	{BSD_FS_HPFS,   "HPFS"},
	{BSD_FS_ISO9660,"ISO-9660"},
	{BSD_FS_BOOT,   "boot"},
	{BSD_FS_ADOS,   "ADOS"},
	{BSD_FS_HFS,    "HFS"},
	{BSD_FS_ADVFS,  "AdvFS"},
	{ 0, NULL }
};
#define BSD_FSMAXTYPES (ARRAY_SIZE(bsd_fstypes)-1)

/* in-memory fdisk BSD stuff */
struct fdisk_bsd_label {
	struct fdisk_label      head;           /* generic part */

	struct dos_partition *dos_part;         /* parent */
	struct bsd_disklabel bsd;               /* on disk label */
#if defined (__alpha__)
	/* We access this through a u_int64_t * when checksumming */
	char bsdbuffer[BSD_BBSIZE] __attribute__((aligned(8)));
#else
	char bsdbuffer[BSD_BBSIZE];
#endif
};

static int bsd_initlabel(struct fdisk_context *cxt);
static int bsd_readlabel(struct fdisk_context *cxt);

static inline struct fdisk_bsd_label *self_label_bsd(struct fdisk_context *cxt)
{
	return (struct fdisk_bsd_label *) cxt->label;
}

static inline struct bsd_disklabel *self_disklabel_bsd(struct fdisk_context *cxt)
{
	return &((struct fdisk_bsd_label *) cxt->label)->bsd;
}

static struct fdisk_parttype *bsd_partition_parttype(
		struct fdisk_context *cxt,
		struct bsd_partition *p)
{
	struct fdisk_parttype *t
		= fdisk_label_get_parttype_from_code(cxt->label, p->p_fstype);
	return t ? : fdisk_new_unknown_parttype(p->p_fstype, NULL);
}


#if defined (__alpha__)
static void alpha_bootblock_checksum (char *boot)
{
	uint64_t *dp = (uint64_t *) boot, sum = 0;
	int i;

	for (i = 0; i < 63; i++)
		sum += dp[i];
	dp[63] = sum;
}
#endif /* __alpha__ */

#define HIDDEN_MASK     0x10

static int is_bsd_partition_type(int type)
{
	return (type == MBR_FREEBSD_PARTITION ||
		type == (MBR_FREEBSD_PARTITION ^ HIDDEN_MASK) ||
		type == MBR_NETBSD_PARTITION ||
		type == (MBR_NETBSD_PARTITION ^ HIDDEN_MASK) ||
		type == MBR_OPENBSD_PARTITION ||
		type == (MBR_OPENBSD_PARTITION ^ HIDDEN_MASK));
}

static struct dos_partition *fdisk_dos_get_partition(
				struct fdisk_context *cxt,
				size_t i)
{
	return self_partition(cxt, i);
}

/* look for DOS partition usable for nested BSD partition table */
static int bsd_assign_dos_partition(struct fdisk_context *cxt)
{
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	size_t i;

	for (i = 0; i < 4; i++) {
		fdisk_sector_t ss;

		l->dos_part = fdisk_dos_get_partition(cxt->parent, i);

		if (!l->dos_part || !is_bsd_partition_type(l->dos_part->sys_ind))
			continue;

		ss = dos_partition_get_start(l->dos_part);
		if (!ss) {
			fdisk_warnx(cxt, "Partition %zd: has invalid starting "
					   "sector 0.", i + 1);
			return -1;
		}

		if (cxt->parent->dev_path) {
			free(cxt->dev_path);
			cxt->dev_path = fdisk_partname(cxt->parent->dev_path, i + 1);
		}
		return 0;
	}

	fdisk_warnx(cxt, "There is no *BSD partition on %s.", cxt->parent->dev_path);
	free(cxt->dev_path);
	cxt->dev_path = NULL;
	l->dos_part = NULL;
	return 1;
}

static int bsd_probe_label(struct fdisk_context *cxt)
{
	int rc = 0;

	if (cxt->parent)
		rc = bsd_assign_dos_partition(cxt);     /* nested BSD partition table */
	if (!rc)
		rc = bsd_readlabel(cxt);
	if (!rc)
		return 1;       /* found BSD */
	return 0;               /* not found */
}

static int set_parttype(
		struct fdisk_context *cxt,
		size_t partnum,
		struct fdisk_parttype *t)
{
	struct bsd_partition *p;
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	if (partnum >= d->d_npartitions || !t || t->code > UINT8_MAX)
		return -EINVAL;

	p = &d->d_partitions[partnum];
	if (t->code == p->p_fstype)
		return 0;

	p->p_fstype = t->code;
	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int bsd_add_partition(struct fdisk_context *cxt,
			     struct fdisk_partition *pa,
			     size_t *partno)
{
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);
	size_t i;
	unsigned int begin = 0, end;
	int rc = 0;

	rc = fdisk_partition_next_partno(pa, cxt, &i);
	if (rc)
		return rc;
	if (i >= BSD_MAXPARTITIONS)
		return -ERANGE;
	if (l->dos_part) {
		begin = dos_partition_get_start(l->dos_part);
		end = begin + dos_partition_get_size(l->dos_part) - 1;
	} else
		end = d->d_secperunit - 1;

	/* First sector */
	if (pa && pa->start_follow_default)
		;
	else if (pa && fdisk_partition_has_start(pa)) {
		if (pa->start < begin || pa->start > end)
			return -ERANGE;
		begin = pa->start;
	} else {
		struct fdisk_ask *ask = fdisk_new_ask();

		fdisk_ask_set_query(ask, fdisk_use_cylinders(cxt) ? "First cylinder" : "First sector");
		fdisk_ask_set_type(ask, FDISK_ASKTYPE_NUMBER);
		fdisk_ask_number_set_low(ask, fdisk_cround(cxt, begin));
		fdisk_ask_number_set_default(ask, fdisk_cround(cxt, begin));
		fdisk_ask_number_set_high(ask, fdisk_cround(cxt, end));

		rc = fdisk_do_ask(cxt, ask);
		begin = fdisk_ask_number_get_result(ask);
		fdisk_unref_ask(ask);
		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt))
			begin = (begin - 1) * d->d_secpercyl;
	}

	/* Last sector */
	if (pa && pa->end_follow_default)
		;
	else if (pa && fdisk_partition_has_size(pa)) {
		if (begin + pa->size > end)
			return -ERANGE;
		end = begin + pa->size - 1ULL;
	} else {
		/* ask user by dialog */
		struct fdisk_ask *ask = fdisk_new_ask();

		fdisk_ask_set_type(ask, FDISK_ASKTYPE_OFFSET);

		if (fdisk_use_cylinders(cxt)) {
			fdisk_ask_set_query(ask, "Last cylinder, +/-cylinders or +/-size{K,M,G,T,P}");
			fdisk_ask_number_set_unit(ask, cxt->sector_size *
				     fdisk_get_units_per_sector(cxt));
		} else {
			fdisk_ask_set_query(ask, "Last sector, +/-sectors or +/-size{K,M,G,T,P}");
			fdisk_ask_number_set_unit(ask,cxt->sector_size);
		}

		fdisk_ask_number_set_low(ask, fdisk_cround(cxt, begin));
		fdisk_ask_number_set_default(ask, fdisk_cround(cxt, end));
		fdisk_ask_number_set_high(ask, fdisk_cround(cxt, end));
		fdisk_ask_number_set_base(ask, fdisk_cround(cxt, begin));
		fdisk_ask_number_set_wrap_negative1(ask); /* wrap negative around high */

		rc = fdisk_do_ask(cxt, ask);
		end = fdisk_ask_number_get_result(ask);
		fdisk_unref_ask(ask);
		if (rc)
			return rc;
		if (fdisk_use_cylinders(cxt))
			end = end * d->d_secpercyl - 1;
	}

	d->d_partitions[i].p_size   = end - begin + 1;
	d->d_partitions[i].p_offset = begin;
	d->d_partitions[i].p_fstype = BSD_FS_UNUSED;

	if (i >= d->d_npartitions)
		d->d_npartitions = i + 1;
	cxt->label->nparts_cur = d->d_npartitions;

	if (pa && pa->type)
		set_parttype(cxt, i, pa->type);

	fdisk_label_set_changed1(cxt->label);
	if (partno)
		*partno = i;
	return 0;
}

static int bsd_set_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct bsd_partition *p;
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	if (n >= d->d_npartitions)
		return -EINVAL;

	p = &d->d_partitions[n];

	/* we have to stay within parental DOS partition */
	if (l->dos_part && (fdisk_partition_has_start(pa) ||
			    fdisk_partition_has_size(pa))) {

		fdisk_sector_t dosbegin = dos_partition_get_start(l->dos_part);
		fdisk_sector_t dosend = dosbegin + dos_partition_get_size(l->dos_part) - 1;
		fdisk_sector_t begin = fdisk_partition_has_start(pa) ? pa->start : p->p_offset;
		fdisk_sector_t end = begin + (fdisk_partition_has_size(pa) ? pa->size : p->p_size) - 1;

		if (begin < dosbegin || begin > dosend)
			return -ERANGE;
		if (end < dosbegin || end > dosend)
			return -ERANGE;
	}

	if (pa->type) {
		int rc = set_parttype(cxt, n, pa->type);
		if (rc)
			return rc;
	}

	if (fdisk_partition_has_start(pa))
		d->d_partitions[n].p_offset = pa->start;
	if (fdisk_partition_has_size(pa))
		d->d_partitions[n].p_size = pa->size;

	fdisk_label_set_changed1(cxt->label);
	return 0;
}


/* Returns 0 on success, < 0 on error. */
static int bsd_create_disklabel(struct fdisk_context *cxt)
{
	int rc, yes = 0;
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	fdisk_info(cxt, "The device %s does not contain BSD disklabel.", cxt->dev_path);
	rc = fdisk_ask_yesno(cxt, "Do you want to create a BSD disklabel?", &yes);
	if (rc)
		return rc;
	if (!yes)
		return 1;
	if (cxt->parent) {
		rc = bsd_assign_dos_partition(cxt);
		if (rc == 1)
			/* not found DOS partition usable for BSD label */
			rc = -EINVAL;
	}
	if (rc)
		return rc;

	rc = bsd_initlabel(cxt);
	if (!rc) {
		cxt->label->nparts_cur = d->d_npartitions;
		cxt->label->nparts_max = BSD_MAXPARTITIONS;
	}

	return rc;
}

static int bsd_delete_part(
		struct fdisk_context *cxt,
		size_t partnum)
{
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	d->d_partitions[partnum].p_size   = 0;
	d->d_partitions[partnum].p_offset = 0;
	d->d_partitions[partnum].p_fstype = BSD_FS_UNUSED;

	if (d->d_npartitions == partnum + 1)
		while (!d->d_partitions[d->d_npartitions - 1].p_size)
			d->d_npartitions--;

	cxt->label->nparts_cur = d->d_npartitions;
	fdisk_label_set_changed1(cxt->label);
	return 0;
}

static int bsd_get_disklabel_item(struct fdisk_context *cxt, struct fdisk_labelitem *item)
{
	struct bsd_disklabel *d;
	int rc = 0;

	d = self_disklabel_bsd(cxt);

	switch (item->id) {
	case BSD_LABELITEM_TYPE:
		item->name = "Type";
		item->type = 's';
		if ((unsigned) d->d_type < BSD_DKMAXTYPES)
			item->data.str = xstrdup(bsd_dktypenames[d->d_type]);
		else
			item->data.str = xasprintf("%d", d->d_type);
		break;
	case BSD_LABELITEM_DISK:
		item->name = "Disk";
		item->type = 's';
		item->data.str = xstrndup(d->d_typename, sizeof(d->d_typename));
		break;
	case BSD_LABELITEM_PACKNAME:
		item->name = "Packname";
		item->type = 's';
		item->data.str = xstrndup(d->d_packname, sizeof(d->d_packname));
		break;
	case BSD_LABELITEM_FLAGS:
		item->name = "Flags";
		item->type = 's';
		item->data.str = xstrdup(
			d->d_flags & BSD_D_REMOVABLE ? " removable" :
			d->d_flags & BSD_D_ECC ? " ecc" :
			d->d_flags & BSD_D_BADSECT ? " badsect" : "");
		break;

	/* On various machines the fields of *lp are short/int/long */
	/* In order to avoid problems, we cast them all uint64. */
	case BSD_LABELITEM_SECSIZE:
		item->name = "Bytes/Sector";
		item->type = 'j';
		item->data.num64 = (uint64_t) d->d_secsize;
		break;
	case BSD_LABELITEM_NTRACKS:
		item->name = "Tracks/Cylinder";
		item->type = 'j';
		item->data.num64 = (uint64_t) d->d_ntracks;
		break;
	case BSD_LABELITEM_SECPERCYL:
		item->name = "Sectors/Cylinder";
		item->data.num64 = (uint64_t) d->d_secpercyl;
		item->type = 'j';
		break;
	case BSD_LABELITEM_CYLINDERS:
		item->name = "Cylinders";
		item->data.num64 = (uint64_t) d->d_ncylinders;
		item->type = 'j';
		break;
	case BSD_LABELITEM_RPM:
		item->name = "Rpm";
		item->data.num64 = (uint64_t) d->d_rpm;
		item->type = 'j';
		break;
	case BSD_LABELITEM_INTERLEAVE:
		item->name = "Interleave";
		item->data.num64 = (uint64_t) d->d_interleave;
		item->type = 'j';
		break;
	case BSD_LABELITEM_TRACKSKEW:
		item->name = "Trackskew";
		item->data.num64 = (uint64_t) d->d_trackskew;
		item->type = 'j';
		break;
	case BSD_LABELITEM_CYLINDERSKEW:
		item->name = "Cylinderskew";
		item->data.num64 = (uint64_t) d->d_cylskew;
		item->type = 'j';
		break;
	case BSD_LABELITEM_HEADSWITCH:
		item->name = "Headswitch";
		item->data.num64 = (uint64_t) d->d_headswitch;
		item->type = 'j';
		break;
	case BSD_LABELITEM_TRKSEEK:
		item->name = "Track-to-track seek";
		item->data.num64 = (uint64_t) d->d_trkseek;
		item->type = 'j';
		break;
	default:
		if (item->id < __FDISK_NLABELITEMS)
			rc = 1; /* unsupported generic item */
		else
			rc = 2; /* out of range */
		break;
	}

	return rc;
}

static int bsd_get_partition(struct fdisk_context *cxt, size_t n,
			     struct fdisk_partition *pa)
{
	struct bsd_partition *p;
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	if (n >= d->d_npartitions)
		return -EINVAL;

	p = &d->d_partitions[n];

	pa->used = p->p_size ? 1 : 0;
	if (!pa->used)
		return 0;

	if (fdisk_use_cylinders(cxt) && d->d_secpercyl) {
		pa->start_post = p->p_offset % d->d_secpercyl ? '*' : ' ';
		pa->end_post = (p->p_offset + p->p_size) % d->d_secpercyl ? '*' : ' ';
	}

	pa->start = p->p_offset;
	pa->size = p->p_size;
	pa->type = bsd_partition_parttype(cxt, p);

	if (p->p_fstype == BSD_FS_UNUSED || p->p_fstype == BSD_FS_BSDFFS) {
		pa->fsize = p->p_fsize;
		pa->bsize = p->p_fsize * p->p_frag;
	}
	if (p->p_fstype == BSD_FS_BSDFFS)
		pa->cpg = p->p_cpg;

	return 0;
}

static uint32_t ask_uint32(struct fdisk_context *cxt,
		uint32_t dflt, char *mesg)
{
	uintmax_t res;

	if (fdisk_ask_number(cxt, min(dflt, (uint32_t) 1), dflt,
				UINT32_MAX, mesg, &res) == 0)
		return res;
	return dflt;
}

static uint16_t ask_uint16(struct fdisk_context *cxt,
		uint16_t dflt, char *mesg)
{
	uintmax_t res;

	if (fdisk_ask_number(cxt, min(dflt, (uint16_t) 1),
				dflt, UINT16_MAX, mesg, &res) == 0)
		return res;
	return dflt;
}

/* Edits fields in BSD disk label.
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_bsd_edit_disklabel(struct fdisk_context *cxt)
{
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);
	uintmax_t res;

#if defined (__alpha__) || defined (__ia64__)
	if (fdisk_ask_number(cxt, DEFAULT_SECTOR_SIZE, d->d_secsize,
			     UINT32_MAX, "bytes/sector", &res) == 0)
		d->d_secsize = res;

	d->d_nsectors = ask_uint32(cxt, d->d_nsectors, "sectors/track");
	d->d_ntracks = ask_uint32(cxt, d->d_ntracks, "tracks/cylinder");
	d->d_ncylinders = ask_uint32(cxt, d->d_ncylinders  ,"cylinders");
#endif
	if (fdisk_ask_number(cxt, 1, d->d_nsectors * d->d_ntracks,
			     d->d_nsectors * d->d_ntracks,
			     "sectors/cylinder", &res) == 0)
		d->d_secpercyl = res;

	d->d_rpm = ask_uint16(cxt, d->d_rpm, "rpm");
	d->d_interleave = ask_uint16(cxt, d->d_interleave, "interleave");
	d->d_trackskew = ask_uint16(cxt, d->d_trackskew, "trackskew");
	d->d_cylskew = ask_uint16(cxt, d->d_cylskew, "cylinderskew");

	d->d_headswitch = ask_uint32(cxt, d->d_headswitch, "headswitch");
	d->d_trkseek = ask_uint32(cxt, d->d_trkseek, "track-to-track seek");

	d->d_secperunit = d->d_secpercyl * d->d_ncylinders;
	return 0;
}

static int bsd_get_bootstrap(struct fdisk_context *cxt,
			char *path, void *ptr, int size)
{
	int fd;

	if ((fd = open(path, O_RDONLY)) < 0) {
		fdisk_warn(cxt, "cannot open %s", path);
		return -errno;
	}

	if (read_all(fd, ptr, size) != size) {
		fdisk_warn(cxt, "cannot read %s", path);
		close(fd);
		return -errno;
	}

	fdisk_info(cxt, "The bootstrap file %s successfully loaded.", path);
	close (fd);
	return 0;
}

static void sync_disks(struct fdisk_context *cxt)
{
	fdisk_info(cxt, "Syncing disks.");
	sync();
}

/* Install bootstrap file to the BSD device */
static int fdisk_bsd_write_bootstrap(struct fdisk_context *cxt)
{
	struct bsd_disklabel dl, *d = self_disklabel_bsd(cxt);
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	char *name = d->d_type == BSD_DTYPE_SCSI ? "sd" : "wd";
	char buf[BUFSIZ];
	char *res, *dp, *p;
	int rc;
	fdisk_sector_t sector;

	snprintf(buf, sizeof(buf), "Bootstrap: %1$sboot -> boot%1$s (default %1$s)", name);
	rc = fdisk_ask_string(cxt, buf, &res);
	if (rc)
		goto done;
	if (res && *res)
		name = res;

	snprintf(buf, sizeof(buf), "%s/%sboot", BSD_LINUX_BOOTDIR, name);
	rc = bsd_get_bootstrap(cxt, buf, l->bsdbuffer,  (int) d->d_secsize);
	if (rc)
		goto done;

	/* We need a backup of the disklabel (might have changed). */
	dp = &l->bsdbuffer[BSD_LABELSECTOR * DEFAULT_SECTOR_SIZE];
	memmove(&dl, dp, sizeof(struct bsd_disklabel));

	/* The disklabel will be overwritten by 0's from bootxx anyway */
	memset(dp, 0, sizeof(struct bsd_disklabel));

	snprintf(buf, sizeof(buf), "%s/boot%s", BSD_LINUX_BOOTDIR, name);
	rc = bsd_get_bootstrap(cxt, buf,
			&l->bsdbuffer[d->d_secsize],
			(int) d->d_bbsize - d->d_secsize);
	if (rc)
		goto done;

	/* check end of the bootstrap */
	for (p = dp; p < dp + sizeof(struct bsd_disklabel); p++) {
		if (!*p)
			continue;
		fdisk_warnx(cxt, "Bootstrap overlaps with disklabel!");
		return -EINVAL;
	}

	/* move disklabel back */
	memmove(dp, &dl, sizeof(struct bsd_disklabel));

	sector = 0;
	if (l->dos_part)
		sector = dos_partition_get_start(l->dos_part);
#if defined (__alpha__)
	alpha_bootblock_checksum(l->bsdbuffer);
#endif
	if (lseek(cxt->dev_fd, (off_t) sector * DEFAULT_SECTOR_SIZE, SEEK_SET) == -1) {
		fdisk_warn(cxt, "seek on %s failed", cxt->dev_path);
		rc = -errno;
		goto done;
	}
	if (write_all(cxt->dev_fd, l->bsdbuffer, BSD_BBSIZE)) {
		fdisk_warn(cxt, "cannot write %s", cxt->dev_path);
		rc = -errno;
		goto done;
	}

	fdisk_info(cxt, "Bootstrap installed on %s.", cxt->dev_path);
	sync_disks(cxt);

	rc = 0;
done:
	free(res);
	return rc;
}

static unsigned short bsd_dkcksum (struct bsd_disklabel *lp)
{
	unsigned short *start, *end;
	unsigned short sum = 0;

	start = (unsigned short *) lp;
	end = (unsigned short *) &lp->d_partitions[lp->d_npartitions];
	while (start < end)
		sum ^= *start++;
	return sum;
}

static int bsd_initlabel (struct fdisk_context *cxt)
{
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);
	struct bsd_partition *pp;

	memset (d, 0, sizeof (struct bsd_disklabel));

	d -> d_magic = BSD_DISKMAGIC;

	if (strncmp (cxt->dev_path, "/dev/sd", 7) == 0)
		d -> d_type = BSD_DTYPE_SCSI;
	else
		d -> d_type = BSD_DTYPE_ST506;

#if !defined (__alpha__)
	d -> d_flags = BSD_D_DOSPART;
#else
	d -> d_flags = 0;
#endif
	d -> d_secsize = DEFAULT_SECTOR_SIZE;           /* bytes/sector  */
	d -> d_nsectors = cxt->geom.sectors;            /* sectors/track */
	d -> d_ntracks = cxt->geom.heads;               /* tracks/cylinder (heads) */
	d -> d_ncylinders = cxt->geom.cylinders;
	d -> d_secpercyl  = cxt->geom.sectors * cxt->geom.heads;/* sectors/cylinder */
	if (d -> d_secpercyl == 0)
		d -> d_secpercyl = 1;           /* avoid segfaults */
	d -> d_secperunit = d -> d_secpercyl * d -> d_ncylinders;

	d -> d_rpm = 3600;
	d -> d_interleave = 1;
	d -> d_trackskew = 0;
	d -> d_cylskew = 0;
	d -> d_headswitch = 0;
	d -> d_trkseek = 0;

	d -> d_magic2 = BSD_DISKMAGIC;
	d -> d_bbsize = BSD_BBSIZE;
	d -> d_sbsize = BSD_SBSIZE;

	if (l->dos_part) {
		d->d_npartitions = 4;

		pp = &d->d_partitions[2];       /* Partition C should be the NetBSD partition */
		pp->p_offset = dos_partition_get_start(l->dos_part);
		pp->p_size   = dos_partition_get_size(l->dos_part);
		pp->p_fstype = BSD_FS_UNUSED;

		pp = &d -> d_partitions[3];     /* Partition D should be the whole disk */
		pp->p_offset = 0;
		pp->p_size   = d->d_secperunit;
		pp->p_fstype = BSD_FS_UNUSED;
	} else {
		d->d_npartitions = 3;

		pp = &d->d_partitions[2];       /* Partition C should be the whole disk */
		pp->p_offset = 0;
		pp->p_size   = d->d_secperunit;
		pp->p_fstype = BSD_FS_UNUSED;
	}

	return 0;
}

/* Read a bsd_disklabel from sector 0 or from the starting sector of p.
 * If it has the right magic, return 0. */
static int bsd_readlabel(struct fdisk_context *cxt)
{
	struct fdisk_bsd_label *l;
	struct bsd_disklabel *d;
	int t;
	off_t offset = 0;

	l = self_label_bsd(cxt);
	d = self_disklabel_bsd(cxt);

	if (l->dos_part)
		/* BSD is nested within DOS partition, get the begin of the
		 * partition. Note that DOS uses native sector size. */
		offset = dos_partition_get_start(l->dos_part) * cxt->sector_size;

	if (lseek(cxt->dev_fd, offset, SEEK_SET) == -1)
		return -1;
	if (read_all(cxt->dev_fd, l->bsdbuffer, sizeof(l->bsdbuffer)) < 0)
		return errno ? -errno : -1;

	/* The offset to begin of the disk label. Note that BSD uses
	 * 512-byte (default) sectors. */
	memmove(d, &l->bsdbuffer[BSD_LABELSECTOR * DEFAULT_SECTOR_SIZE
			      + BSD_LABELOFFSET], sizeof(*d));

	if (d->d_magic != BSD_DISKMAGIC || d->d_magic2 != BSD_DISKMAGIC)
		return -1;

	for (t = d->d_npartitions; t < BSD_MAXPARTITIONS; t++) {
		d->d_partitions[t].p_size   = 0;
		d->d_partitions[t].p_offset = 0;
		d->d_partitions[t].p_fstype = BSD_FS_UNUSED;
	}

	if (d->d_npartitions > BSD_MAXPARTITIONS)
		fdisk_warnx(cxt, ("Too many partitions (%d, maximum is %d)."),
				d->d_npartitions, BSD_MAXPARTITIONS);

	/* let's follow in-PT geometry */
	cxt->geom.sectors = d->d_nsectors;
	cxt->geom.heads = d->d_ntracks;
	cxt->geom.cylinders = d->d_ncylinders;

	if (fdisk_has_user_device_geometry(cxt))
		fdisk_apply_user_device_properties(cxt);

	cxt->label->nparts_cur = d->d_npartitions;
	cxt->label->nparts_max = BSD_MAXPARTITIONS;
	return 0;
}

static int bsd_write_disklabel(struct fdisk_context *cxt)
{
	off_t offset = 0;
	struct fdisk_bsd_label *l = self_label_bsd(cxt);
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);


	if (l->dos_part)
		offset = dos_partition_get_start(l->dos_part) * cxt->sector_size;

	d->d_checksum = 0;
	d->d_checksum = bsd_dkcksum(d);

	/* Update label within boot block. */
	memmove(&l->bsdbuffer[BSD_LABELSECTOR * DEFAULT_SECTOR_SIZE
			   + BSD_LABELOFFSET], d, sizeof(*d));

#if defined (__alpha__) && BSD_LABELSECTOR == 0
	/* Write the checksum to the end of the first sector. */
	alpha_bootblock_checksum(l->bsdbuffer);
#endif
	if (lseek(cxt->dev_fd, offset, SEEK_SET) == -1) {
		fdisk_warn(cxt, "seek on %s failed", cxt->dev_path);
		return -errno;
	}
	if (write_all(cxt->dev_fd, l->bsdbuffer, sizeof(l->bsdbuffer))) {
		fdisk_warn(cxt, "cannot write %s", cxt->dev_path);
		return -errno;
	}
	sync_disks(cxt);

	if (cxt->parent && fdisk_label_is_changed(cxt->parent->label))
		fdisk_info(cxt, "Disklabel written to %s.  (Don't forget to write the %s disklabel too.)",
				cxt->dev_path, cxt->parent->dev_path);
	else
		fdisk_info(cxt, "Disklabel written to %s.", cxt->dev_path);
	return 0;
}


static int bsd_translate_fstype (int linux_type)
{
	switch (linux_type) {
	case 0x01: /* DOS 12-bit FAT   */
	case 0x04: /* DOS 16-bit <32M  */
	case 0x06: /* DOS 16-bit >=32M */
	case 0xe1: /* DOS access       */
	case 0xe3: /* DOS R/O          */
#if !defined (__alpha__)
	case 0xf2: /* DOS secondary    */
		return BSD_FS_MSDOS;
#endif
	case 0x07: /* OS/2 HPFS        */
		return BSD_FS_HPFS;
	default:
		break;
	}

	return BSD_FS_OTHER;
}

/* Links partition from parent (DOS) to nested BSD partition table.
 *
 * Returns: 0 on success, <0 on error */
static int fdisk_bsd_link_partition(struct fdisk_context *cxt)
{
	size_t k, i;
	int rc;
	struct dos_partition *p;
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	if (!cxt->parent || !fdisk_is_label(cxt->parent, DOS)) {
		fdisk_warnx(cxt, "BSD label is not nested within a DOS partition.");
		return -EINVAL;
	}

	/* ask for DOS partition */
	rc = fdisk_ask_partnum(cxt->parent, &k, FALSE);
	if (rc)
		return rc;
	/* ask for BSD partition */
	rc = fdisk_ask_partnum(cxt, &i, TRUE);
	if (rc)
		return rc;

	if (i >= BSD_MAXPARTITIONS)
		return -EINVAL;

	p = fdisk_dos_get_partition(cxt->parent, k);

	d->d_partitions[i].p_size   = dos_partition_get_size(p);
	d->d_partitions[i].p_offset = dos_partition_get_start(p);
	d->d_partitions[i].p_fstype = bsd_translate_fstype(p->sys_ind);

	if (i >= d->d_npartitions)
		d->d_npartitions = i + 1;

	cxt->label->nparts_cur = d->d_npartitions;
	fdisk_label_set_changed1(cxt->label);

	fdisk_info(cxt, "BSD partition '%c' linked to DOS partition %zu.", 'a' + (int) i, k + 1);
	return 0;
}

static int bsd_partition_is_used(struct fdisk_context *cxt, size_t partnum)
{
	struct bsd_disklabel *d = self_disklabel_bsd(cxt);

	if (partnum >= BSD_MAXPARTITIONS)
		return 0;

	return d->d_partitions[partnum].p_size ? 1 : 0;
}


static const struct fdisk_label_operations bsd_operations =
{
	.probe          = bsd_probe_label,
	.get_item       = bsd_get_disklabel_item,
	.write          = bsd_write_disklabel,
	.create         = bsd_create_disklabel,

	.del_part       = bsd_delete_part,
	.get_part       = bsd_get_partition,
	.set_part       = bsd_set_partition,
	.add_part       = bsd_add_partition,

	.part_is_used   = bsd_partition_is_used,
};

static const struct fdisk_field bsd_fields[] =
{
	{ FDISK_FIELD_DEVICE,   "Slice",      1,    0 },
	{ FDISK_FIELD_START,    "Start",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_END,      "End",        5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SECTORS,  "Sectors",    5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_CYLINDERS,"Cylinders",  5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_SIZE,     "Size",       5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_TYPE,     "Type",       8,    0 },
	{ FDISK_FIELD_FSIZE,    "Fsize",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_BSIZE,    "Bsize",      5,    FDISK_FIELDFL_NUMBER },
	{ FDISK_FIELD_CPG,      "Cpg",        5,    FDISK_FIELDFL_NUMBER }
};

/* allocates BSD label driver */
struct fdisk_label *fdisk_new_bsd_label(struct fdisk_context *cxt __attribute__ ((__unused__)))
{
	struct fdisk_label *lb;
	struct fdisk_bsd_label *bsd;

	bsd = zmalloc(sizeof(*bsd));
	/* initialize generic part of the driver */
	lb = (struct fdisk_label *) bsd;
	lb->name = "bsd";
	lb->id = FDISK_DISKLABEL_BSD;
	lb->op = &bsd_operations;
	lb->parttypes = (struct fdisk_parttype *)bsd_fstypes;
	lb->nparttypes = ARRAY_SIZE(bsd_fstypes) - 1;

	lb->fields = bsd_fields;
	lb->nfields = ARRAY_SIZE(bsd_fields);

	lb->flags |= FDISK_LABEL_FL_INCHARS_PARTNO;
	lb->flags |= FDISK_LABEL_FL_REQUIRE_GEOMETRY;

	return lb;
}
#endif /* CONFIG_FEATURE_BSD_LABEL */


#define RPMATCH_YES      1
#define RPMATCH_NO       0
#define RPMATCH_INVALID -1

static int process_fdisk_menu(struct fdisk_context **cxt);

static void reply_sighandler(int sig __attribute__((unused)))
{
}

static int get_user_reply(const char *prompt, char *buf)
{
	struct sigaction oldact, act = {
		.sa_handler = reply_sighandler
	};
	struct pollfd fds[] = {
		{ .fd = fileno(stdin), .events = POLLIN }
	};
	size_t sz;
	int ret = 0;
	int rc;

	sigemptyset(&act.sa_mask);


	*buf = '\0';
#ifdef CONFIG_FEATURE_COMMAND_EDITING
	if (!is_interactive) {
#endif
		sigaction(SIGINT, &act, &oldact);
		fputs(prompt, stdout);
		fflush(stdout);

		rc = poll(fds, 1, -1);
		if (rc == -1 && errno == EINTR) {       /* interrupted by signal */
			ret = -ECANCELED;
			goto done;
		}
		if (rc == -1 && errno != EAGAIN) {      /* error */
			ret = -errno;
			goto done;
		}
		if (!fgets(buf, BUFSIZ, stdin))
			*buf = '\0';
#ifdef CONFIG_FEATURE_COMMAND_EDITING
	} else {
		if(cmdedit_read_input(prompt, buf)==0)
			*buf = '\0';
	}
#endif
	if (!*buf) {
		ret = -ECANCELED;
		goto done;
	}

	/* cleanup the reply */
	sz = ltrim_whitespace((unsigned char *) buf);
	if (sz && *(buf + sz - 1) == '\n')
		*(buf + sz - 1) = '\0';

done:
#ifdef CONFIG_FEATURE_COMMAND_EDITING
	if (!is_interactive)
#endif
		sigaction(SIGINT, &oldact, NULL);
	return ret;
}

static int ask_menu(struct fdisk_context *cxt, struct fdisk_ask *ask, char *buf)

{
	const char *q = fdisk_ask_get_query(ask);
	int dft = fdisk_ask_menu_get_default(ask);

	if (q) {
		fputs(q, stdout);               /* print header */
		fputc('\n', stdout);
	}

	do {
		char prompt[128];
		int key, c, rc;
		const char *name, *desc;
		size_t i = 0;

		/* print menu items */
		while (fdisk_ask_menu_get_item(ask, i++, &key, &name, &desc) == 0)
			fprintf(stdout, "   %c   %s (%s)\n", key, name, desc);

		/* ask for key */
		snprintf(prompt, sizeof(prompt), "Select (default %c): ", dft);
		rc = get_user_reply(prompt, buf);
		if (rc)
			return rc;
		if (!*buf) {
			fdisk_info(cxt, "Using default response %c.", dft);
			c = dft;
		} else
			c = tolower(buf[0]);

		/* check result */
		i = 0;
		while (fdisk_ask_menu_get_item(ask, i++, &key, NULL, NULL) == 0) {
			if (c == key) {
				fdisk_ask_menu_set_result(ask, c);
				return 0;       /* success */
			}
		}
		fdisk_warnx(cxt, "Value out of range.");
	} while (1);

	return -EINVAL;
}


#define tochar(num)     ((int) ('a' + num - 1))
static int ask_number(struct fdisk_context *cxt,
		      struct fdisk_ask *ask, char *buf)
{
	char prompt[128] = { '\0' };
	const char *q = fdisk_ask_get_query(ask);
	const char *range = fdisk_ask_number_get_range(ask);

	uint64_t dflt = fdisk_ask_number_get_default(ask),
		 low = fdisk_ask_number_get_low(ask),
		 high = fdisk_ask_number_get_high(ask);
	int inchar = fdisk_ask_number_inchars(ask);

	if (range && dflt >= low && dflt <= high) {
		if (inchar)
			snprintf(prompt, sizeof(prompt), "%s (%s, default %c): ",
					q, range, tochar(dflt));
		else
			snprintf(prompt, sizeof(prompt), "%s (%s, default %"PRIu64"): ",
					q, range, dflt);

	} else if (dflt >= low && dflt <= high) {
		if (inchar)
			snprintf(prompt, sizeof(prompt), "%s (%c-%c, default %c): ",
					q, tochar(low), tochar(high), tochar(dflt));
		else
			snprintf(prompt, sizeof(prompt),
					"%s (%"PRIu64"-%"PRIu64", default %"PRIu64"): ",
					q, low, high, dflt);
	} else if (inchar)
		snprintf(prompt, sizeof(prompt), "%s (%c-%c): ", q, tochar(low), tochar(high));
	else
		snprintf(prompt, sizeof(prompt), "%s (%"PRIu64"-%"PRIu64"): ", q, low, high);

	do {
		int rc = get_user_reply(prompt, buf);
		uint64_t num = 0;

		if (rc)
			return rc;
		if (!*buf && dflt >= low && dflt <= high) {
			fdisk_ask_number_set_result(ask, dflt);
			return 0;
		}

		if (isdigit_strend(buf)) {
			char *end;

			errno = 0;
			num = strtoumax(buf, &end, 10);
			if (errno || buf == end || (end && *end))
				continue;
		} else if (inchar && isalpha(*buf)) {
			num = tolower(*buf) - 'a' + 1;
		} else
			rc = -EINVAL;

		if (rc == 0 && num >= low && num <= high) {
			fdisk_ask_number_set_result(ask, num);
			return 0;
		}

		fdisk_warnx(cxt, "Value out of range.");
	} while (1);

	return -1;
}

static int ask_offset(struct fdisk_context *cxt,
		      struct fdisk_ask *ask, char *buf)
{
	char prompt[128] = { '\0' };
	const char *q = fdisk_ask_get_query(ask);
	const char *range = fdisk_ask_number_get_range(ask);

	uint64_t dflt = fdisk_ask_number_get_default(ask),
		 low = fdisk_ask_number_get_low(ask),
		 high = fdisk_ask_number_get_high(ask),
		 base = fdisk_ask_number_get_base(ask);

	if (range && dflt >= low && dflt <= high)
		snprintf(prompt, sizeof(prompt), "%s (%s, default %"PRIu64"): ",
			 q, range, dflt);
	else if (dflt >= low && dflt <= high)
		snprintf(prompt, sizeof(prompt),
			 "%s (%"PRIu64"-%"PRIu64", default %"PRIu64"): ",
			 q, low, high, dflt);
	else
		snprintf(prompt, sizeof(prompt), "%s (%"PRIu64"-%"PRIu64"): ",
			 q, low, high);

	do {
		uintmax_t num = 0;
		char sig = 0, *p;
		int pwr = 0;

		int rc = get_user_reply(prompt, buf);
		if (rc)
			return rc;
		if (!*buf && dflt >= low && dflt <= high) {
			fdisk_ask_number_set_result(ask, dflt);
			return 0;
		}

		p = buf;
		if (*p == '+' || *p == '-') {
			sig = *buf;
			p++;
		}

		rc = parse_size(p, &num, &pwr);
		if (rc)
			continue;
		if (sig && pwr) {
			/* +{size}{K,M,...} specified, the "num" is in bytes */
			uint64_t unit = fdisk_ask_number_get_unit(ask);
			num += unit/2;  /* round */
			num /= unit;
		}
		if (sig == '+')
			num += base;
		else if (sig == '-' && fdisk_ask_number_is_wrap_negative(ask))
			num = high - num;
		else if (sig == '-')
			num = base - num;

		if (num >= low && num <= high) {
			if (sig && pwr)
				fdisk_ask_number_set_relative1(ask);
			fdisk_ask_number_set_result(ask, (uint64_t)num);
			return 0;
		}
		fdisk_warnx(cxt, "Value out of range.");
	} while (1);

	return -1;
}

static int my_rpmatch(const char *r)
{
	while(*r == ' ' || *r == '\t')
		r++;
	return (*r == 'y' || *r == 'Y' ? 1 : *r == 'n' || *r == 'N' ? 0 : -1);
}

static void fputs_info(struct fdisk_ask *ask, FILE *out)
{
	const char *msg;

	msg = fdisk_ask_print_get_mesg(ask);
	if (!msg)
		return;
	if (info_count == 1)
		fputc('\n', out);

	fputs(msg, out);
	fputc('\n', out);
}

static int ask_callback(struct fdisk_context *cxt, struct fdisk_ask *ask,
		    void *data __attribute__((__unused__)))
{
	int rc = 0;
	char buf[BUFSIZ];

	if (fdisk_ask_get_type(ask) != FDISK_ASKTYPE_INFO)
		info_count = 0;

	switch(fdisk_ask_get_type(ask)) {
	case FDISK_ASKTYPE_MENU:
		return ask_menu(cxt, ask, buf);
	case FDISK_ASKTYPE_NUMBER:
		return ask_number(cxt, ask, buf);
	case FDISK_ASKTYPE_OFFSET:
		return ask_offset(cxt, ask, buf);
	case FDISK_ASKTYPE_INFO:
		if (!fdisk_is_listonly(cxt))
			info_count++;
		fputs_info(ask, stdout);
		break;
	case FDISK_ASKTYPE_WARNX:
		fflush(stdout);
		color_scheme_fenable("warn", UL_COLOR_RED, stderr);
		fputs(fdisk_ask_print_get_mesg(ask), stderr);
		color_fdisable(stderr);
		fputc('\n', stderr);
		break;
	case FDISK_ASKTYPE_WARN:
		fflush(stdout);
		color_scheme_fenable("warn", UL_COLOR_RED, stderr);
		fputs(fdisk_ask_print_get_mesg(ask), stderr);
		errno = fdisk_ask_print_get_errno(ask);
		fprintf(stderr, ": %m\n");
		color_fdisable(stderr);
		break;
	case FDISK_ASKTYPE_YESNO:
		fputc('\n', stdout);
		do {
			int x;
			fputs(fdisk_ask_get_query(ask), stdout);
			rc = get_user_reply(" [Y]es/[N]o: ", buf);
			if (rc)
				break;
			x = my_rpmatch(buf);
			if (x == RPMATCH_YES || x == RPMATCH_NO) {
				fdisk_ask_yesno_set_result(ask, x);
				break;
			}
		} while(1);
		break;
	case FDISK_ASKTYPE_STRING:
	{
		char prmt[BUFSIZ];
		snprintf(prmt, sizeof(prmt), "%s: ", fdisk_ask_get_query(ask));
		fputc('\n', stdout);
		rc = get_user_reply(prmt, buf);
		if (rc == 0)
			fdisk_ask_string_set_result(ask, xstrdup(buf));
		break;
	}
	default:
		bb_error_msg("internal error: unsupported dialog type %d", fdisk_ask_get_type(ask));
		return -EINVAL;
	}
	return rc;
}

static void list_partition_types(struct fdisk_context *cxt)
{
	size_t ntypes = 0;
	struct fdisk_label *lb;

	lb = fdisk_get_label(cxt, NULL);
	if (!lb)
		return;
	ntypes = fdisk_label_get_nparttypes(lb);
	if (!ntypes)
		return;

	if (fdisk_label_has_code_parttypes(lb)) {
		/* Prints in 4 columns in format <hex> <name> */
		size_t last[4], done = 0, next = 0, size;
		int i;

		size = ntypes;

		for (i = 3; i >= 0; i--)
			last[3 - i] = done += (size + i - done) / (i + 1);
		i = done = 0;

		do {
			#define NAME_WIDTH 15
			char name[NAME_WIDTH * MB_LEN_MAX];
			size_t width = NAME_WIDTH;
			const struct fdisk_parttype *t = fdisk_label_get_parttype(lb, next);
			size_t ret;

			if (fdisk_parttype_get_name(t)) {
				printf("%c%2x  ", i ? ' ' : '\n',
						fdisk_parttype_get_code(t));
				ret = mbsalign(fdisk_parttype_get_name(t),
						name, sizeof(name),
						&width, MBS_ALIGN_LEFT, 0);

				if (ret == (size_t)-1 || ret >= sizeof(name))
					printf("%-15.15s", fdisk_parttype_get_name(t));
				else
					fputs(name, stdout);
			}

			next = last[i++] + done;
			if (i > 3 || next >= last[i]) {
				i = 0;
				next = ++done;
			}
		} while (done < last[0]);

	} else {
		/* Prints 1 column in format <idx> <name> <typestr> */
		size_t i;

		pager_open();

		for (i = 0; i < ntypes; i++) {
			const struct fdisk_parttype *t = fdisk_label_get_parttype(lb, i);
			printf("%3zu %-30s %s\n", i + 1,
					fdisk_parttype_get_name(t),
					fdisk_parttype_get_string(t));
		}

		pager_close();
	}
	putchar('\n');
}

static void toggle_dos_compatibility_flag(struct fdisk_context *cxt)
{
	struct fdisk_label *lb = fdisk_get_label(cxt, "dos");
	int flag;

	if (!lb)
		return;

	flag = !fdisk_dos_is_compatible(lb);
	fdisk_info(cxt, flag ? "DOS Compatibility flag is set (DEPRECATED!)" :
			"DOS Compatibility flag is not set");

	fdisk_dos_enable_compatible(lb, flag);

	if (fdisk_is_label(cxt, DOS))
		fdisk_reset_alignment(cxt);     /* reset the current label */
}

static struct fdisk_parttype *ask_partition_type(struct fdisk_context *cxt)
{
	const char *q;
	struct fdisk_label *lb;

	lb = fdisk_get_label(cxt, NULL);

	if (!lb)
		return NULL;

	q = fdisk_label_has_code_parttypes(lb) ?
		"Hex code (type L to list all codes): " :
		"Partition type (type L to list all types): ";
	do {
		char buf[BUFSIZ];
		int rc = get_user_reply(q, buf);

		if (rc)
			break;

		if (buf[1] == '\0' && toupper(*buf) == 'L')
			list_partition_types(cxt);
		else if (*buf)
			return fdisk_label_parse_parttype(lb, buf);
	} while (1);

	return NULL;
}

static void change_partition_type(struct fdisk_context *cxt)
{
	size_t i;
	struct fdisk_parttype *t = NULL;
	struct fdisk_partition *pa = NULL;
	const char *old = NULL;

	if (fdisk_ask_partnum(cxt, &i, FALSE))
		return;

	if (fdisk_get_partition(cxt, i, &pa)) {
		fdisk_warnx(cxt, "Partition %zu does not exist yet!", i + 1);
		return;
	}

	t = (struct fdisk_parttype *) fdisk_partition_get_type(pa);
	old = t ? fdisk_parttype_get_name(t) : "Unknown";

	do {
		t = ask_partition_type(cxt);
	} while (!t);

	if (fdisk_set_partition_type(cxt, i, t) == 0)
		fdisk_info(cxt,
			"Changed type of partition '%s' to '%s'.",
			old, t ? fdisk_parttype_get_name(t) : "Unknown");
	else
		fdisk_info(cxt, "Type of partition %zu is unchanged: %s.", i + 1, old);

	fdisk_unref_partition(pa);
	fdisk_unref_parttype(t);
}

static int print_partition_info(struct fdisk_context *cxt)
{
	struct fdisk_partition *pa = NULL;
	int rc = 0;
	size_t i, nfields;
	int *fields = NULL;
	struct fdisk_label *lb = fdisk_get_label(cxt, NULL);

	if ((rc = fdisk_ask_partnum(cxt, &i, FALSE)))
		return rc;

	if ((rc = fdisk_get_partition(cxt, i, &pa))) {
		fdisk_warnx(cxt, "Partition %zu does not exist yet!", i + 1);
		return rc;
	}

	if ((rc = fdisk_label_get_fields_ids_all(lb, cxt, &fields, &nfields)))
		goto clean_data;

	for (i = 0; i < nfields; ++i) {
		int id = fields[i];
		char *data = NULL;
		const struct fdisk_field *fd = fdisk_label_get_field(lb, id);

		if (!fd)
			continue;

		rc = fdisk_partition_to_string(pa, cxt, id, &data);
		if (rc < 0)
			goto clean_data;
		if (!data || !*data)
			continue;
		fdisk_info(cxt, "%15s: %s", fdisk_field_get_name(fd), data);
		free(data);
	}

clean_data:
	fdisk_unref_partition(pa);
	free(fields);
	return rc;
}

#ifdef CONFIG_FEATURE_FDISK_ADVANCED

static size_t skip_empty(const unsigned char *buf, size_t i, size_t sz)
{
	size_t next;
	const unsigned char *p0 = buf + i;

	for (next = i + 16; next < sz; next += 16) {
		if (memcmp(p0, buf + next, 16) != 0)
			break;
	}

	return next == i + 16 ? i : next;
}


static void dump_buffer(off_t base, unsigned char *buf, size_t sz, int all)
{
	size_t i, l, next = 0;

	if (!buf)
		return;
	for (i = 0, l = 0; i < sz; i++, l++) {
		if (l == 0) {
			if (all == 0 && !next)
				next = skip_empty(buf, i, sz);
			printf("%08jx ", (intmax_t)base + i);
		}
		printf(" %02x", buf[i]);
		if (l == 7)                             /* words separator */
			fputs(" ", stdout);
		else if (l == 15) {
			fputc('\n', stdout);            /* next line */
			l = -1;
			if (next > i) {
				printf("*\n");
				i = next - 1;
			}
			next = 0;
		}
	}
	if (l > 0)
		printf("\n");
}

/* fdisk_get_devfd: Returns: device file descriptor. */
static inline int fdisk_get_devfd(struct fdisk_context *cxt)
{
	return cxt->dev_fd;
}

static void dump_blkdev(struct fdisk_context *cxt, const char *name,
			uint64_t offset, size_t size, int all)
{
	int fd = fdisk_get_devfd(cxt);

	fdisk_info(cxt, "\n%s: offset = %"PRIu64", size = %zu bytes.",
			name, offset, size);

	if (lseek(fd, (off_t) offset, SEEK_SET) == (off_t) -1)
		fdisk_warn(cxt, "cannot seek");
	else {
		unsigned char *buf = xmalloc(size);

		if (read_all(fd, (char *) buf, size) != (ssize_t) size)
			fdisk_warn(cxt, "cannot read");
		else
			dump_buffer(offset, buf, size, all);
		free(buf);
	}
}

static void dump_firstsector(struct fdisk_context *cxt)
{
	int all = !isatty(STDOUT_FILENO);

	dump_blkdev(cxt, "First sector", 0, fdisk_get_sector_size(cxt), all);
}

static void dump_disklabel(struct fdisk_context *cxt)
{
	int all = !isatty(STDOUT_FILENO);
	int i = 0;
	const char *name = NULL;
	uint64_t offset = 0;
	size_t size = 0;

	while (fdisk_locate_disklabel(cxt, i++, &name, &offset, &size) == 0 && size)
		dump_blkdev(cxt, name, offset, size, all);
}
#endif /* CONFIG_FEATURE_FDISK_ADVANCED */

#ifdef CONFIG_FEATURE_FDISK_BLKSIZE
static fdisk_sector_t get_dev_blocks(char *dev)
{
	int fd, ret;
	fdisk_sector_t size;

	if ((fd = open(dev, O_RDONLY)) < 0)
		bb_perror_msg_and_die("cannot open %s", dev);
	ret = blkdev_get_sectors(fd, (unsigned long long *) &size);
	close(fd);
	if (ret < 0)
		bb_perror_msg_and_die("BLKGETSIZE ioctl failed on %s", dev);
	return size/2;
}
#endif

static void follow_wipe_mode(struct fdisk_context *cxt)
{
	int dowipe = wipemode == WIPEMODE_ALWAYS ? 1 : 0;

	if (isatty(STDIN_FILENO) && wipemode == WIPEMODE_AUTO)
		dowipe = 1;     /* do it in interactive mode */

	if (fdisk_is_ptcollision(cxt) && wipemode != WIPEMODE_NEVER)
		dowipe = 1;     /* always remove old PT */

	fdisk_enable_wipe(cxt, dowipe);
	if (dowipe)
		fdisk_warnx(cxt, "The old %s signature will be removed by a write command.",
			fdisk_get_collision(cxt));
	else
		fdisk_warnx(cxt, "The old %s signature may remain on the device. "
			"It is recommended to wipe the device with wipefs(8) or "
			"fdisk --wipe, in order to avoid possible collisions.",
			fdisk_get_collision(cxt));
}

enum {
	ACT_FDISK = 0,  /* default */
	ACT_LIST,
	ACT_SHOWSIZE
};


struct menu_entry {
	const char      key;                    /* command key */
	const char      *title;                 /* help string */
	unsigned int    normal : 1,             /* normal mode */
			expert : 1,             /* expert mode */
			hidden : 1;             /* be sensitive for this key,
						   but don't print it in help */

	enum fdisk_labeltype    label;          /* only for this label */
	int                     exclude;    /* all labels except these */
	enum fdisk_labeltype    parent;         /* for nested PT */
};

#define IS_MENU_SEP(e)  ((e)->key == '-')
#define IS_MENU_HID(e)  ((e)->hidden)

struct menu {
	enum fdisk_labeltype    label;          /* only for this label */
	int                     exclude;    /* all labels except these */

	unsigned int            nonested : 1;   /* don't make this menu active in nested PT */

	int (*callback)(struct fdisk_context **,
			const struct menu *,
			const struct menu_entry *);

	struct menu_entry       entries[];      /* NULL terminated array */
};

struct menu_context {
	size_t          menu_idx;               /* the current menu */
	size_t          entry_idx;              /* index with in the current menu */
};

#define MENU_CXT_EMPTY  { 0, 0 }
#define DECLARE_MENU_CB(x) \
	static int x(struct fdisk_context **, \
		     const struct menu *, \
		     const struct menu_entry *)

DECLARE_MENU_CB(geo_menu_cb);
DECLARE_MENU_CB(dos_menu_cb);
DECLARE_MENU_CB(createlabel_menu_cb);
DECLARE_MENU_CB(generic_menu_cb);

/* Menu entry macros:
 *      MENU_X*    expert mode only
 *      MENU_B*    both -- expert + normal mode
 *
 *      *_E  exclude this label
 *      *_H  hidden
 *      *_L  only for this label */

/* separator */
#define MENU_SEP(t)             { .title = t, .key = '-', .normal = 1 }
#define MENU_XSEP(t)            { .title = t, .key = '-', .expert = 1 }
#define MENU_BSEP(t)            { .title = t, .key = '-', .expert = 1, .normal = 1 }

/* entry */
#define MENU_ENT(k, t)          { .title = t, .key = k, .normal = 1 }
#define MENU_ENT_E(k, t, l)     { .title = t, .key = k, .normal = 1, .exclude = l }
#define MENU_ENT_L(k, t, l)     { .title = t, .key = k, .normal = 1, .label = l }

#define MENU_XENT(k, t)         { .title = t, .key = k, .expert = 1 }
#define MENU_XENT_H(k, t)       { .title = t, .key = k, .expert = 1, .hidden = 1 }

#define MENU_BENT(k, t)         { .title = t, .key = k, .expert = 1, .normal = 1 }
#define MENU_BENT_E(k, t, l)    { .title = t, .key = k, .expert = 1, .normal = 1, .exclude = l }

#define MENU_ENT_NEST(k, t, l, p)       { .title = t, .key = k, .normal = 1, .label = l, .parent = p }
#define MENU_XENT_NEST(k, t, l, p)      { .title = t, .key = k, .expert = 1, .label = l, .parent = p }
#define MENU_BENT_NEST(k, t, l, p)      { .title = t, .key = k, .expert = 1, .normal = 1, .label = l, .parent = p }

/* Generic menu */
static const struct menu menu_generic = {
	.callback       = generic_menu_cb,
	.entries        = {
		MENU_BSEP("Generic"),
		MENU_ENT  ('d', "delete a partition"),
		MENU_ENT  ('F', "list free unpartitioned space"),
		MENU_ENT  ('l', "list known partition types"),
		MENU_ENT  ('n', "add a new partition"),
		MENU_BENT ('p', "print the partition table"),
		MENU_ENT  ('t', "change a partition type"),
		MENU_BENT_E('v', "verify the partition table", FDISK_DISKLABEL_BSD),
		MENU_ENT  ('i', "print information about a partition"),

#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT('d', "print the raw data of the first sector from the device"),
		MENU_XENT('D', "print the raw data of the disklabel from the device"),
		MENU_XENT('f', "fix partitions order"),
#endif

		MENU_SEP("Misc"),
		MENU_BENT ('m', "print this menu"),
		MENU_ENT_E('u', "change display/entry units", FDISK_DISKLABEL_GPT),
		MENU_ENT_E('x', "extra functionality (experts only)", FDISK_DISKLABEL_BSD),

		MENU_SEP("Script"),
		MENU_ENT  ('I', "load disk layout from sfdisk script file"),
		MENU_ENT  ('O', "dump disk layout to sfdisk script file"),

		MENU_BSEP("Save & Exit"),
		MENU_ENT_E('w', "write table to disk and exit", FDISK_DISKLABEL_BSD),
		MENU_ENT_L('w', "write table to disk", FDISK_DISKLABEL_BSD),
		MENU_BENT ('q', "quit without saving changes"),
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT ('r', "return to main menu"),
#endif

		MENU_ENT_NEST('r', "return from BSD to DOS", FDISK_DISKLABEL_BSD, FDISK_DISKLABEL_DOS),

		{ 0, NULL }
	}
};

static const struct menu menu_createlabel = {
	.callback = createlabel_menu_cb,
	.exclude = FDISK_DISKLABEL_BSD,
	.nonested = 1,
	.entries = {
		MENU_SEP("Create a new label"),
#if defined(CONFIG_FEATURE_GPT_LABEL)
		MENU_ENT('g', "create a new empty GPT partition table"),
#endif
#if defined(CONFIG_FEATURE_SGI_LABEL)
		MENU_ENT('G', "create a new empty SGI (IRIX) partition table"),
#endif
		MENU_ENT('o', "create a new empty DOS partition table"),
#if defined(CONFIG_FEATURE_SUN_LABEL)
		MENU_ENT('s', "create a new empty Sun partition table"),
#endif
#if defined(CONFIG_FEATURE_SGI_LABEL)
		/* backward compatibility -- be sensitive to 'g', but don't
		 * print it in the expert menu */
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT_H('g', "create an IRIX (SGI) partition table"),
#endif
#endif
		{ 0, NULL }
	}
};

static const struct menu menu_geo = {
	.callback = geo_menu_cb,
	.exclude = FDISK_DISKLABEL_GPT | FDISK_DISKLABEL_BSD,
	.entries = {
		MENU_XSEP("Geometry (for the current label)"),
		MENU_XENT('c', "change number of cylinders"),
		MENU_XENT('h', "change number of heads"),
		MENU_XENT('s', "change number of sectors/track"),
		{ 0, NULL }
	}
};

#ifdef CONFIG_FEATURE_GPT_LABEL
static int gpt_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent);

static const struct menu menu_gpt = {
	.callback = gpt_menu_cb,
	.label = FDISK_DISKLABEL_GPT,
	.entries = {
		MENU_BSEP("GPT"),
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT('i', "change disk GUID"),
		MENU_XENT('n', "change partition name"),
		MENU_XENT('u', "change partition UUID"),
		MENU_XENT('l', "change table length"),
#endif
		MENU_BENT('M', "enter protective/hybrid MBR"),
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XSEP(""),
		MENU_XENT('A', "toggle the legacy BIOS bootable flag"),
		MENU_XENT('B', "toggle the no block IO protocol flag"),
		MENU_XENT('R', "toggle the required partition flag"),
		MENU_XENT('S', "toggle the GUID specific bits"),
#endif

		{ 0, NULL }
	}
};
#endif

#ifdef CONFIG_FEATURE_SUN_LABEL
static int sun_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent);

static const struct menu menu_sun = {
	.callback = sun_menu_cb,
	.label = FDISK_DISKLABEL_SUN,
	.entries = {
		MENU_BSEP("Sun"),
		MENU_ENT('a', "toggle the read-only flag"),
		MENU_ENT('c', "toggle the mountable flag"),
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT('a', "change number of alternate cylinders"),
		MENU_XENT('e', "change number of extra sectors per cylinder"),
		MENU_XENT('i', "change interleave factor"),
		MENU_XENT('o', "change rotation speed (rpm)"),
		MENU_XENT('y', "change number of physical cylinders"),
#endif
		{ 0, NULL }
	}
};
#endif

#ifdef CONFIG_FEATURE_SGI_LABEL
static int sgi_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent);

static const struct menu menu_sgi = {
	.callback = sgi_menu_cb,
	.label = FDISK_DISKLABEL_SGI,
	.entries = {
		MENU_SEP("SGI"),
		MENU_ENT('a', "select bootable partition"),
		MENU_ENT('b', "edit bootfile entry"),
		MENU_ENT('c', "select sgi swap partition"),
		MENU_ENT('i', "create SGI info"),
		{ 0, NULL }
	}
};
#endif

static const struct menu menu_dos = {
	.callback = dos_menu_cb,
	.label = FDISK_DISKLABEL_DOS,
	.entries = {
		MENU_BSEP("DOS (MBR)"),
		MENU_ENT('a', "toggle a bootable flag"),
#ifdef CONFIG_FEATURE_BSD_LABEL
		MENU_ENT('b', "edit nested BSD disklabel"),
#endif
		MENU_ENT('c', "toggle the dos compatibility flag"),
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
		MENU_XENT('b', "move beginning of data in a partition"),
		MENU_XENT('i', "change the disk identifier"),
#endif

		MENU_BENT_NEST('M', "return from protective/hybrid MBR to GPT",
					FDISK_DISKLABEL_DOS, FDISK_DISKLABEL_GPT),
		{ 0, NULL }
	}
};

#ifdef CONFIG_FEATURE_BSD_LABEL
static int bsd_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent);

static const struct menu menu_bsd = {
	.callback = bsd_menu_cb,
	.label = FDISK_DISKLABEL_BSD,
	.entries = {
		MENU_SEP("BSD"),
		MENU_ENT('e', "edit drive data"),
		MENU_ENT('i', "install bootstrap"),
		MENU_ENT('s', "show complete disklabel"),
		MENU_ENT('x', "link BSD partition to non-BSD partition"),
		{ 0, NULL }
	}
};
#endif

static const struct menu * const menus[] = {
#ifdef CONFIG_FEATURE_GPT_LABEL
	&menu_gpt,
#endif
#ifdef CONFIG_FEATURE_SUN_LABEL
	&menu_sun,
#endif
#ifdef CONFIG_FEATURE_SGI_LABEL
	&menu_sgi,
#endif
	&menu_dos,
#ifdef CONFIG_FEATURE_BSD_LABEL
	&menu_bsd,
#endif
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	&menu_geo,
#endif
	&menu_generic,
	&menu_createlabel
};

static const struct menu_entry *next_menu_entry(
			struct fdisk_context *cxt,
			struct menu_context *mc)
{
	struct fdisk_label *lb = fdisk_get_label(cxt, NULL);
	struct fdisk_context *parent = fdisk_get_parent(cxt);
	unsigned int type = 0, pr_type = 0;

	if (lb)
		type = fdisk_label_get_type(lb);
	if (parent)
		pr_type = fdisk_label_get_type(fdisk_get_label(parent, NULL));

	while (mc->menu_idx < ARRAY_SIZE(menus)) {
		const struct menu *m = menus[mc->menu_idx];
		const struct menu_entry *e = &(m->entries[mc->entry_idx]);

		/* whole-menu filter */

		/* no more entries */
		if (e->title == NULL ||
		/* menu wanted for specified labels only */
		    (m->label && lb && !(m->label & type)) ||
		/* unwanted for nested PT */
		    (m->nonested && parent) ||
		/* menu excluded for specified labels */
		    (m->exclude && lb && (m->exclude & type))) {
			mc->menu_idx++;
			mc->entry_idx = 0;
			continue;
		}

		/* per entry filter */

		/* excluded for the current label */
		if ((e->exclude && lb && e->exclude & type) ||
		/* entry wanted for specified labels only */
		    (e->label && lb && !(e->label & type)) ||
		/* exclude non-expert entries in expect mode */
		    (e->expert == 0 && fdisk_is_details(cxt)) ||
		/* nested only */
		    (e->parent && (!parent || pr_type != e->parent)) ||
		/* exclude non-normal entries in normal mode */
		    (e->normal == 0 && !fdisk_is_details(cxt))) {
			mc->entry_idx++;
			continue;
		}
		mc->entry_idx++;
		return e;

	}
	return NULL;
}

/* returns @menu and menu entry for then @key */
static const struct menu_entry *get_fdisk_menu_entry(
		struct fdisk_context *cxt,
		int key,
		const struct menu **menu)
{
	struct menu_context mc = MENU_CXT_EMPTY;
	const struct menu_entry *e;

	while ((e = next_menu_entry(cxt, &mc))) {
		if (IS_MENU_SEP(e) || e->key != key)
			continue;

		if (menu)
			*menu = menus[mc.menu_idx];
		return e;
	}

	return NULL;
}

static int print_fdisk_menu(struct fdisk_context *cxt)
{
	struct menu_context mc = MENU_CXT_EMPTY;
	const struct menu_entry *e;

	if (fdisk_is_details(cxt))
		printf("\nHelp (expert commands):\n");
	else
		printf("\nHelp:\n");

	while ((e = next_menu_entry(cxt, &mc))) {
		if (IS_MENU_HID(e))
			continue;       /* hidden entry */
		if (IS_MENU_SEP(e) && (!e->title || !*e->title))
			printf("\n");
		else if (IS_MENU_SEP(e)) {
			color_scheme_enable("help-title", UL_COLOR_BOLD);
			printf("\n  %s\n", e->title);
			color_disable();
		} else
			printf("   %c   %s\n", e->key, e->title);
	}
	fputc('\n', stdout);

	if (fdisk_get_parent(cxt)) {
		struct fdisk_label *l = fdisk_get_label(cxt, NULL),
				   *p = fdisk_get_label(fdisk_get_parent(cxt), NULL);

		fdisk_info(cxt, "You're editing nested '%s' partition table, "
				  "primary partition table is '%s'.",
				fdisk_label_get_name(l),
				fdisk_label_get_name(p));
	}

	return 0;
}

/* Asks for command, verify the key and perform the command or
 * returns the command key if no callback for the command is
 * implemented.
 *
 * Note that this function might exchange the context pointer to
 * switch to another (nested) context.
 *
 * Returns: <0 on error
 *           0 on success (the command performed)
 *          >0 if no callback (then returns the key) */
int process_fdisk_menu(struct fdisk_context **cxt0)
{
	struct fdisk_context *cxt = *cxt0;
	const struct menu_entry *ent;
	const struct menu *menu;
	int key, rc;
	const char *prompt;
	char buf[BUFSIZ];

	if (fdisk_is_details(cxt))
		prompt = "Expert command (m for help): ";
	else
		prompt = "Command (m for help): ";

	fputc('\n',stdout);
	rc = get_user_reply(prompt, buf);

	if (rc == -ECANCELED) {
		/* Map ^C and ^D in main menu to 'q' */
		if (is_interactive
		    && fdisk_label_is_changed(fdisk_get_label(cxt, NULL))) {
			rc = get_user_reply("\nDo you really want to quit? ", buf);
			if (rc || !my_rpmatch(buf))
				return 0;
		}
		key = 'q';
	} else if (rc) {
		return rc;
	} else
		key = buf[0];

	ent = get_fdisk_menu_entry(cxt, key, &menu);
	if (!ent) {
		fdisk_warnx(cxt, "%c: unknown command", key);
		return -EINVAL;
	}

	/* menu has implemented callback, use it */
	if (menu->callback)
		rc = menu->callback(cxt0, menu, ent);
	else {
		rc = -EINVAL;
	}

	return rc;
}


/* Associate context @cxt with script @dp and creates a new empty disklabel.
 * The script may be later unreference by fdisk_set_script() with NULL as script.
 *
 * Returns: 0 on success, <0 on error. */
static int fdisk_apply_script_headers(struct fdisk_context *cxt, struct fdisk_script *dp)
{
	const char *name;
	const char *str;
	int rc;

	fdisk_set_script(cxt, dp);

	str = fdisk_script_get_header(dp, "grain");
	if (str) {
		uintmax_t sz;

		rc = parse_size(str, &sz, NULL);
		if (rc == 0)
			rc = fdisk_save_user_grain(cxt, sz);
		if (rc)
			return rc;
	}

	if (fdisk_has_user_device_properties(cxt))
		fdisk_apply_user_device_properties(cxt);

	/* create empty label */
	name = fdisk_script_get_header(dp, "label");
	if (!name)
		return -EINVAL;

	rc = fdisk_create_disklabel(cxt, name);
	if (rc)
		return rc;

	str = fdisk_script_get_header(dp, "table-length");
	if (str) {
		uintmax_t sz;

		rc = parse_size(str, &sz, NULL);
#ifdef CONFIG_FEATURE_GPT_LABEL
		if (rc == 0)
			rc = fdisk_gpt_set_npartitions(cxt, sz);
#endif
	}

	return rc;
}

/* This function creates a new disklabel and partition within context @cxt. You
 * have to call fdisk_write_disklabel() to apply changes to the device.
 *
 * Returns: 0 on error, <0 on error. */
static int fdisk_apply_script(struct fdisk_context *cxt, struct fdisk_script *dp)
{
	int rc;
	struct fdisk_script *old;

	old = fdisk_get_script(cxt);
	fdisk_ref_script(old);

	/* create empty disk label */
	rc = fdisk_apply_script_headers(cxt, dp);

	/* create partitions */
	if (!rc && dp->table)
		rc = fdisk_apply_table(cxt, dp->table);

	fdisk_set_script(cxt, old);
	fdisk_unref_script(old);

	return rc;
}


/* This function is "hard reset" of the context and it does not write anything
 * to the device. All in-memory changes associated with the context will be
 * lost. It's recommended to use this function after some fatal problem when the
 * context (and label specific driver) is in an undefined state.
 * Returns: 0 on success, < 0 on error. */
static int fdisk_reassign_device(struct fdisk_context *cxt)
{
	char *devname;
	int rdonly, rc;

	devname = xstrdup(cxt->dev_path);
	rdonly = cxt->readonly;

	fdisk_deassign_device(cxt, 1);
	rc = fdisk_assign_device(cxt, devname, rdonly);
	free(devname);

	return rc;
}

static int script_read(struct fdisk_context *cxt)
{
	struct fdisk_script *sc = NULL;
	char *filename = NULL;
	int rc;

	rc = fdisk_ask_string(cxt, "Enter script file name", &filename);
	if (rc)
		return rc;

	errno = 0;
	sc = fdisk_new_script_from_file(cxt, filename);
	if (!sc && errno)
		fdisk_warn(cxt, "Cannot open %s", filename);
	else if (!sc)
		fdisk_warnx(cxt, "Failed to parse script file %s", filename);
	else if (fdisk_apply_script(cxt, sc) != 0) {
		fdisk_warnx(cxt, "Failed to apply script %s", filename);
		fdisk_warnx(cxt, "Resetting fdisk!");
		rc = fdisk_reassign_device(cxt);
		if (rc == 0 && !fdisk_has_label(cxt)) {
			fdisk_info(cxt, "Device does not contain a recognized partition table.");
			fdisk_create_disklabel(cxt, NULL);
		}
	} else
		fdisk_info(cxt, "Script successfully applied.");

	fdisk_unref_script(sc);
	free(filename);
	return rc;
}

static int write_file_sfdisk(struct fdisk_script *dp, FILE *f)
{
	struct list_head *h;
	struct fdisk_partition *pa;
	struct fdisk_iter itr;
	const char *devname = NULL;

	/* script headers */
	list_for_each(h, &dp->headers) {
		struct fdisk_scriptheader *fi = list_entry(h, struct fdisk_scriptheader, headers);
		fprintf(f, "%s: %s\n", fi->name, fi->data);
		if (strcmp(fi->name, "device") == 0)
			devname = fi->data;
	}

	if (!dp->table)
		return 0;

	fputc('\n', f);

	fdisk_reset_iter(&itr, FDISK_ITER_FORWARD);
	while (fdisk_table_next_partition(dp->table, &itr, &pa) == 0) {
		char *p = NULL;

		if (devname)
			p = fdisk_partname(devname, pa->partno + 1);
		if (p) {
			fprintf(f, "%s :", p);
		} else
			fprintf(f, "%zu :", pa->partno + 1);

		if (fdisk_partition_has_start(pa))
			fprintf(f, " start=%12ju", (uintmax_t)pa->start);
		if (fdisk_partition_has_size(pa))
			fprintf(f, ", size=%12ju", (uintmax_t)pa->size);

		if (pa->type && fdisk_parttype_get_string(pa->type))
			fprintf(f, ", type=%s", fdisk_parttype_get_string(pa->type));
		else if (pa->type)
			fprintf(f, ", type=%x", fdisk_parttype_get_code(pa->type));

		if (pa->uuid)
			fprintf(f, ", uuid=%s", pa->uuid);
		if (pa->name && *pa->name) {
			fputs(", name=", f);
			fputs_quoted(pa->name, f);
		}

		/* for MBR attr=80 means bootable */
		if (pa->attrs) {
			struct fdisk_label *lb = script_get_label(dp);

			if (!lb || fdisk_label_get_type(lb) != FDISK_DISKLABEL_DOS)
				fprintf(f, ", attrs=\"%s\"", pa->attrs);
		}
		if (fdisk_partition_is_bootable(pa))
			fprintf(f, ", bootable");
		fputc('\n', f);
	}

	return 0;
}

/* Writes script @dp to the file @f.
 * Returns: 0 on success, <0 on error. */
static int fdisk_script_write_file(struct fdisk_script *dp, FILE *f)
{
	return write_file_sfdisk(dp, f);
}

/* Reads data from the @cxt context (on disk partition table) into the script.
 * If the context is no specified than defaults to context used for fdisk_new_script().
 *
 * Return: 0 on success, <0 on error. */
static int fdisk_script_read_context(struct fdisk_script *dp, struct fdisk_context *cxt)
{
	struct fdisk_label *lb;
	int rc;
	char *p = NULL;

	if (!dp || (!cxt && !dp->cxt))
		return -EINVAL;

	if (!cxt)
		cxt = dp->cxt;

	fdisk_reset_script(dp);

	lb = fdisk_get_label(cxt, NULL);
	if (!lb)
		return -EINVAL;

	/* allocate and fill new table */
	rc = fdisk_get_partitions(cxt, &dp->table);
	if (rc)
		return rc;

	/* generate headers */
	rc = fdisk_script_set_header(dp, "label", fdisk_label_get_name(lb));

	if (!rc && fdisk_get_disklabel_id(cxt, &p) == 0 && p) {
		rc = fdisk_script_set_header(dp, "label-id", p);
		free(p);
	}
	if (!rc && cxt->dev_path)
		rc = fdisk_script_set_header(dp, "device", cxt->dev_path);
	if (!rc)
		rc = fdisk_script_set_header(dp, "unit", "sectors");

	if (!rc && fdisk_is_label(cxt, GPT)) {
		struct fdisk_labelitem item = FDISK_LABELITEM_INIT;
		char buf[64];

		/* first-lba */
		rc = fdisk_get_disklabel_item(cxt, GPT_LABELITEM_FIRSTLBA, &item);
		if (!rc) {
			snprintf(buf, sizeof(buf), "%"PRIu64, item.data.num64);
			rc = fdisk_script_set_header(dp, "first-lba", buf);
		}

		/* last-lba */
		if (!rc)
			rc = fdisk_get_disklabel_item(cxt, GPT_LABELITEM_LASTLBA, &item);
		if (!rc) {
			snprintf(buf, sizeof(buf), "%"PRIu64, item.data.num64);
			rc = fdisk_script_set_header(dp, "last-lba", buf);
		}

		/* table-length */
		if (!rc) {
			size_t n = fdisk_get_npartitions(cxt);
			if (n != FDISK_GPT_NPARTITIONS_DEFAULT) {
				snprintf(buf, sizeof(buf), "%zu", n);
				rc = fdisk_script_set_header(dp, "table-length", buf);
			}
		}
	}

	if (!rc && fdisk_get_grain_size(cxt) != 2048 * 512) {
		char buf[64];

		snprintf(buf, sizeof(buf), "%lu", fdisk_get_grain_size(cxt));
		rc = fdisk_script_set_header(dp, "grain", buf);
	}


	return rc;
}

static int script_write(struct fdisk_context *cxt)
{
	struct fdisk_script *sc = NULL;
	char *filename = NULL;
	FILE *f = NULL;
	int rc;

	rc = fdisk_ask_string(cxt, "Enter script file name", &filename);
	if (rc)
		return rc;

	sc = fdisk_new_script(cxt);
	rc = fdisk_script_read_context(sc, NULL);
	if (rc) {
		fdisk_warnx(cxt, "Failed to transform disk layout into script");
		goto done;
	}

	f = fopen(filename, "w");
	if (!f) {
		fdisk_warn(cxt, "Cannot open %s", filename);
		goto done;
	}

	rc = fdisk_script_write_file(sc, f);
	if (rc)
		fdisk_warn(cxt, "Failed to write script %s", filename);
	else
		fdisk_info(cxt, "Script successfully saved.");
done:
	if (f)
		fclose(f);
	fdisk_unref_script(sc);
	free(filename);
	return rc;
}

static int ask_for_wipe(struct fdisk_context *cxt, size_t partno)
{
	struct fdisk_partition *tmp = NULL;
	char *fstype = NULL;
	int rc, yes = 0;

	rc = fdisk_get_partition(cxt, partno, &tmp);
	if (rc)
		goto done;

	rc = fdisk_partition_to_string(tmp, cxt, FDISK_FIELD_FSTYPE, &fstype);
	if (rc || fstype == NULL)
		goto done;

	fdisk_warnx(cxt, "Partition #%zu contains a %s signature.", partno + 1, fstype);

	if (pwipemode == WIPEMODE_AUTO && isatty(STDIN_FILENO))
		fdisk_ask_yesno(cxt, "Do you want to remove the signature?", &yes);
	else if (pwipemode == WIPEMODE_ALWAYS)
		yes = 1;

	if (yes) {
		fdisk_info(cxt, "The signature will be removed by a write command.");
		rc = fdisk_wipe_partition(cxt, partno, TRUE);
	}
done:
	fdisk_unref_partition(tmp);
	free(fstype);
	return rc;
}

#ifndef CONFIG_FEATURE_LIBBLKID
static int fdisk_do_wipe(struct fdisk_context *cxt __attribute__((__unused__)))
{
	return 0;
}
#else
/* Sets probing flags to the partitions prober. This function is optional. */
static inline void blkid_probe_set_partitions_flags(blkid_probe pr, int flags)
{
	pr->chains[BLKID_CHAIN_PARTS].flags = flags;
}

static int fdisk_do_wipe(struct fdisk_context *cxt)
{
	struct list_head *p;
	blkid_probe pr;
	int rc;

	if (list_empty(&cxt->wipes))
		return 0;

	pr = blkid_new_probe();
	list_for_each(p, &cxt->wipes) {
		struct fdisk_wipe *wp = list_entry(p, struct fdisk_wipe, wipes);
		blkid_loff_t start = (blkid_loff_t) wp->start * cxt->sector_size,
			     size = (blkid_loff_t) wp->size * cxt->sector_size;

		rc = blkid_probe_set_device(pr, cxt->dev_fd, start, size);
		if (rc)
			return rc;

		blkid_probe_enable_superblocks(pr, 1);
		blkid_probe_set_superblocks_flags(pr, BLKID_SUBLKS_MAGIC);
		blkid_probe_enable_partitions(pr, 1);
		blkid_probe_set_partitions_flags(pr, BLKID_PARTS_MAGIC);

		while (blkid_do_probe(pr) == 0)
			blkid_do_wipe(pr, FALSE);
	}

	blkid_free_probe(pr);
	return 0;
}
#endif

/* Write in-memory changes to disk. Be careful!
 * Returns: 0 on success, otherwise, a corresponding error. */
static int fdisk_write_disklabel(struct fdisk_context *cxt)
{
	if (!cxt || !cxt->label || cxt->readonly)
		return -EINVAL;
	if (!cxt->label->op->write)
		return -ENOSYS;

	fdisk_do_wipe(cxt);
	return cxt->label->op->write(cxt);
}

/* Basic fdisk actions */
static int generic_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = 0;
	size_t n;

	/* actions shared between expert and normal mode */
	switch (ent->key) {
	case 'p':
		list_disk_geometry(cxt);
		list_disklabel(cxt);
		break;
	case 'w':
		if (fdisk_is_readonly(cxt)) {
			fdisk_warnx(cxt, "Device is open in read-only mode.");
			break;
		}
		rc = fdisk_write_disklabel(cxt);
		if (rc)
			bb_perror_msg_and_die("failed to write disklabel");
		if (fdisk_get_parent(cxt))
			break; /* nested PT, don't leave */
		fdisk_info(cxt, "The partition table has been altered.");

		if (device_is_used)
			rc = fdisk_reread_changes(cxt, original_layout);
		else
			rc = fdisk_reread_partition_table(cxt);
		if (!rc)
			rc = fdisk_deassign_device(cxt, 0);
		/* fallthrough */
	case 'q':
		fdisk_unref_context(cxt);
		fputc('\n', stdout);
		exit(rc == 0 ? EXIT_SUCCESS : EXIT_FAILURE);
	case 'm':
		rc = print_fdisk_menu(cxt);
		break;
	case 'v':
		rc = fdisk_verify_disklabel(cxt);
		break;
	case 'i':
		rc = print_partition_info(cxt);
		break;
	case 'F':
		list_freespace(cxt);
		break;
	}

#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	/* expert mode */
	if (ent->expert) {
		switch (ent->key) {
		case 'd':
			dump_firstsector(cxt);
			break;
		case 'D':
			dump_disklabel(cxt);
			break;
		case 'f':
			rc = fdisk_reorder_partitions(cxt);
			if (rc)
				fdisk_warnx(cxt, "Failed to fix partitions order.");
			else
				fdisk_info(cxt, "Partitions order fixed.");
			break;
		case 'r':
			rc = fdisk_enable_details(cxt, 0);
			break;
		}
		return rc;
	}
#endif

	/* normal mode */
	switch (ent->key) {
	case 'd':
		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (rc)
			break; /* no partitions yet (or ENOMEM, ...) */

		rc = fdisk_delete_partition(cxt, n);
		if (rc)
			fdisk_warnx(cxt, "Could not delete partition %zu", n + 1);
		else
			fdisk_info(cxt, "Partition %zu has been deleted.", n + 1);
		break;
	case 'I':
		script_read(cxt);
		break;
	case 'O':
		script_write(cxt);
		break;
	case 'l':
		list_partition_types(cxt);
		break;
	case 'n':
	{
		size_t partno;
		rc = fdisk_add_partition(cxt, NULL, &partno);
		if (!rc)
			rc = ask_for_wipe(cxt, partno);
		break;
	}
	case 't':
		change_partition_type(cxt);
		break;
	case 'u':
		fdisk_set_unit(cxt,
			fdisk_use_cylinders(cxt) ? "sectors" :
							   "cylinders");
		if (fdisk_use_cylinders(cxt))
			fdisk_info(cxt, "Changing display/entry units to cylinders (DEPRECATED!).");
		else
			fdisk_info(cxt, "Changing display/entry units to sectors.");
		break;
	case 'x':
		fdisk_enable_details(cxt, 1);
		break;
	case 'r':
		/* return from nested BSD to DOS */
		if (fdisk_get_parent(cxt)) {
			*cxt0 = fdisk_get_parent(cxt);

			fdisk_info(cxt, "Leaving nested disklabel.");
			fdisk_unref_context(cxt);
		}
		break;
	}

	return rc;
}


#ifdef CONFIG_FEATURE_GPT_LABEL
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
/* Modifies disklabel according to setting with in @pa.
 * Returns: 0 on success, <0 on error. */
static int fdisk_set_partition(struct fdisk_context *cxt, size_t partno,
			struct fdisk_partition *pa)
{
	struct fdisk_partition *xpa = pa, *tmp = NULL;
	int rc, wipe = 0;

	if (!cxt || !cxt->label || !pa)
		return -EINVAL;
	if (!cxt->label->op->set_part)
		return -ENOSYS;

	pa->fs_probed = 0;

	if (!fdisk_is_partition_used(cxt, partno)) {
		pa->partno = partno;
		return fdisk_add_partition(cxt, pa, NULL);
	}

	if (pa->resize || fdisk_partition_has_start(pa) || fdisk_partition_has_size(pa)) {
		xpa = __copy_partition(pa);
		xpa->movestart = 0;
		xpa->resize = 0;
		FDISK_INIT_UNDEF(xpa->size);
		FDISK_INIT_UNDEF(xpa->start);

		rc = recount_resize(cxt, partno, xpa, pa);
		if (rc)
			goto done;
	}

	/* disable wipe for old offset/size setting */
	if (fdisk_get_partition(cxt, partno, &tmp) == 0 && tmp) {
		wipe = fdisk_set_wipe_area(cxt, fdisk_partition_get_start(tmp),
						fdisk_partition_get_size(tmp), FALSE);
		fdisk_unref_partition(tmp);
	}

	/* call label driver */
	rc = cxt->label->op->set_part(cxt, partno, xpa);

	/* enable wipe for new offset/size */
	if (!rc && wipe)
		fdisk_wipe_partition(cxt, partno, TRUE);
done:
	if (xpa != pa)
		fdisk_unref_partition(xpa);
	return rc;
}

static int fdisk_partition_set_name(struct fdisk_partition *pa, const char *name)
{
	char *p = NULL;

	if (!pa)
		return -EINVAL;
	if (name)
	       p = xstrdup(name);
	free(pa->name);
	pa->name = p;
	return 0;
}

static int fdisk_partition_set_uuid(struct fdisk_partition *pa, const char *uuid)
{
	char *p = NULL;

	if (!pa)
		return -EINVAL;
	if (uuid)
	       p = xstrdup(uuid);
	free(pa->uuid);
	pa->uuid = p;
	return 0;
}
#endif /* CONFIG_FEATURE_FDISK_ADVANCED */

/* This is fdisk frontend for GPT specific libfdisk functions that
 * are not exported by generic libfdisk API. */
static int gpt_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = 0;
	struct fdisk_context *mbr;
#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	struct fdisk_partition *pa = NULL;
	size_t n;
	uintmax_t length = 0;
#endif

#ifndef CONFIG_FEATURE_FDISK_ADVANCED
	if (ent->expert && ent->key == 'M') {
		mbr = fdisk_new_nested_context(cxt, "dos");
		*cxt0 = cxt = mbr;
		if (fdisk_is_details(cxt))
			fdisk_enable_details(cxt, 1);   /* keep us in expert mode */
		fdisk_info(cxt, "Entering protective/hybrid MBR disklabel.");
		return 0;
	}
#else
	if (ent->expert) {
		switch (ent->key) {
		case 'i':
			return fdisk_set_disklabel_id(cxt);
		case 'l':
			rc =  fdisk_ask_number(cxt, 1, fdisk_get_npartitions(cxt),
					~(uint32_t)0, "New maximum entries", &length);
			if (rc)
				return rc;
			return fdisk_gpt_set_npartitions(cxt, (uint32_t) length);
		case 'M':
			mbr = fdisk_new_nested_context(cxt, "dos");
			*cxt0 = cxt = mbr;
			if (fdisk_is_details(cxt))
				fdisk_enable_details(cxt, 1);   /* keep us in expert mode */
			fdisk_info(cxt, "Entering protective/hybrid MBR disklabel.");
			return 0;
		}

		/* actions where is necessary partnum */
		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (rc)
			return rc;

		switch(ent->key) {
		case 'u':
			pa = fdisk_new_partition();     /* new template */
			{
				char *str = NULL;
				rc = fdisk_ask_string(cxt, "New UUID (in 8-4-4-4-12 format)", &str);
				if (!rc)
					rc = fdisk_partition_set_uuid(pa, str);
				if (!rc)
					rc = fdisk_set_partition(cxt, n, pa);
				free(str);
				fdisk_unref_partition(pa);
			}
			break;
		case 'n':
			pa = fdisk_new_partition();     /* new template */
			{
				char *str = NULL;
				rc = fdisk_ask_string(cxt, "New name", &str);
				if (!rc)
					rc = fdisk_partition_set_name(pa, str);
				if (!rc)
					rc = fdisk_set_partition(cxt, n, pa);
				free(str);
				fdisk_unref_partition(pa);
			}
			break;
		case 'A':
			rc = fdisk_toggle_partition_flag(cxt, n, GPT_FLAG_LEGACYBOOT);
			break;
		case 'B':
			rc = fdisk_toggle_partition_flag(cxt, n, GPT_FLAG_NOBLOCK);
			break;
		case 'R':
			rc = fdisk_toggle_partition_flag(cxt, n, GPT_FLAG_REQUIRED);
			break;
		case 'S':
			rc = fdisk_toggle_partition_flag(cxt, n, GPT_FLAG_GUIDSPECIFIC);
			break;
		}
	}
#endif
	return rc;
}
#endif /* CONFIG_FEATURE_GPT_LABEL */

/* This is fdisk frontend for MBR specific libfdisk functions that
 * are not exported by generic libfdisk API. */
static int dos_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = 0;

	if (!ent->expert) {
		switch (ent->key) {
		case 'a':
		{
			size_t n;
			rc = fdisk_ask_partnum(cxt, &n, FALSE);
			if (!rc)
				rc = fdisk_toggle_partition_flag(cxt, n, DOS_FLAG_ACTIVE);
			break;
		}
#ifdef CONFIG_FEATURE_BSD_LABEL
		case 'b':
		{
			struct fdisk_context *bsd = fdisk_new_nested_context(cxt, "bsd");
			if (!fdisk_has_label(bsd))
				rc = fdisk_create_disklabel(bsd, "bsd");
			if (rc)
				fdisk_unref_context(bsd);
			else {
				*cxt0 = cxt = bsd;
				fdisk_info(cxt, "Entering nested BSD disklabel.");
			}
			break;
		}
#endif
		case 'c':
			toggle_dos_compatibility_flag(cxt);
			break;
		}
		return rc;
	}

	/* expert mode */
	switch (ent->key) {
	case 'b':
	{
		size_t n;
		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (!rc)
			rc = fdisk_dos_move_begin(cxt, n);
		break;
	}
	case 'i':
		rc = fdisk_set_disklabel_id(cxt);
		break;
	case 'M':
		/* return from nested MBR to GPT */
		if (fdisk_get_parent(cxt)) {
			*cxt0 = fdisk_get_parent(cxt);

			fdisk_info(cxt, "Leaving nested disklabel.");
			fdisk_unref_context(cxt);
		}
		break;
	}
	return rc;
}

#ifdef CONFIG_FEATURE_SUN_LABEL
static int sun_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = 0;

	/* normal mode */
	if (!ent->expert) {
		size_t n;

		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (rc)
			return rc;
		switch (ent->key) {
		case 'a':
			rc = fdisk_toggle_partition_flag(cxt, n, SUN_FLAG_RONLY);
			break;
		case 'c':
			rc = fdisk_toggle_partition_flag(cxt, n, SUN_FLAG_UNMNT);
			break;
		}
		return rc;
	}

	/* expert mode */
	switch (ent->key) {
	case 'a':
		rc = fdisk_sun_set_alt_cyl(cxt);
		break;
	case 'e':
		rc = fdisk_sun_set_xcyl(cxt);
		break;
	case 'i':
		rc = fdisk_sun_set_ilfact(cxt);
		break;
	case 'o':
		rc = fdisk_sun_set_rspeed(cxt);
		break;
	case 'y':
		rc = fdisk_sun_set_pcylcount(cxt);
		break;
	}
	return rc;
}
#endif

#ifdef CONFIG_FEATURE_SGI_LABEL
static int sgi_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = -EINVAL;
	size_t n = 0;

	if (ent->expert)
		return rc;

	switch (ent->key) {
	case 'a':
		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (!rc)
			rc = fdisk_toggle_partition_flag(cxt, n, SGI_FLAG_BOOT);
		break;
	case 'b':
		fdisk_sgi_set_bootfile(cxt);
		break;
	case 'c':
		rc = fdisk_ask_partnum(cxt, &n, FALSE);
		if (!rc)
			rc = fdisk_toggle_partition_flag(cxt, n, SGI_FLAG_SWAP);
		break;
	case 'i':
		rc = fdisk_sgi_create_info(cxt);
		break;
	}

	return rc;
}
#endif

#ifdef CONFIG_FEATURE_BSD_LABEL
/* This is fdisk frontend for BSD specific libfdisk functions that
 * are not exported by generic libfdisk API. */
static int bsd_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = 0, org;

	switch(ent->key) {
	case 'e':
		rc = fdisk_bsd_edit_disklabel(cxt);
		break;
	case 'i':
		rc = fdisk_bsd_write_bootstrap(cxt);
		break;
	case 's':
		org = fdisk_is_details(cxt);

		fdisk_enable_details(cxt, 1);
		list_disklabel(cxt);
		fdisk_enable_details(cxt, org);
		break;
	case 'x':
		rc = fdisk_bsd_link_partition(cxt);
		break;
	}
	return rc;
}
#endif

/* C/H/S commands
 *
 * The geometry setting from this dialog is not persistent and maybe reset by
 * fdisk_reset_device_properties() (for example when you create a new disk
 * label). Note that on command line specified -C/-H/-S setting is persistent
 * as it's based on fdisk_save_user_geometry(). */
static int geo_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	struct fdisk_label *lb = fdisk_get_label(cxt, NULL);
	int rc = -EINVAL;
	uintmax_t c = 0, h = 0, s = 0;
	fdisk_sector_t mi, ma;

	/* default */
	if (!lb)
		lb = fdisk_get_label(cxt, "dos");

	switch (ent->key) {
	case 'c':
		fdisk_label_get_geomrange_cylinders(lb, &mi, &ma);
		rc =  fdisk_ask_number(cxt, mi, fdisk_get_geom_cylinders(cxt),
				ma, "Number of cylinders", &c);
		break;
	case 'h':
	{
		unsigned int i, a;
		fdisk_label_get_geomrange_heads(lb, &i, &a);
		rc =  fdisk_ask_number(cxt, i, fdisk_get_geom_heads(cxt),
				a, "Number of heads", &h);
		break;
	}
	case 's':
		fdisk_label_get_geomrange_sectors(lb, &mi, &ma);
		rc =  fdisk_ask_number(cxt, mi, fdisk_get_geom_sectors(cxt),
				ma, "Number of sectors", &s);
		break;
	}

	if (!rc)
		fdisk_override_geometry(cxt, c, h, s);
	return rc;
}

static int createlabel_menu_cb(struct fdisk_context **cxt0,
		       const struct menu *menu __attribute__((__unused__)),
		       const struct menu_entry *ent)
{
	struct fdisk_context *cxt = *cxt0;
	int rc = -EINVAL;

#ifdef CONFIG_FEATURE_FDISK_ADVANCED
	if (ent->expert) {
		switch (ent->key) {
		case 'g':
			/* Deprecated, use 'G' in main menu, just for backward
			 * compatibility only. */
			rc = fdisk_create_disklabel(cxt, "sgi");
			break;
		}
	} else
#endif
	{
		switch (ent->key) {
			case 'g':
				rc = fdisk_create_disklabel(cxt, "gpt");
				break;
			case 'G':
				rc = fdisk_create_disklabel(cxt, "sgi");
				break;
			case 'o':
				rc = fdisk_create_disklabel(cxt, "dos");
				break;
			case 's':
				rc = fdisk_create_disklabel(cxt, "sun");
				break;
		}
	}

	if (rc == 0 && fdisk_get_collision(cxt))
		follow_wipe_mode(cxt);

	return rc;
}

#ifdef CONFIG_FEATURE_LIBBLKID
/* Be careful if you _not_ probe whole disk:
 *
 * 1) the offset is usually relative to begin of the disk -- but if you probe a
 *    fragment of the disk only -- then the offset could be still relative to
 *    the begin of the disk rather that relative to the fragment.
 *
 * 2) the offset for nested partitions could be relative to parent (e.g. Solaris)
 *    _or_ relative to the begin of the whole disk (e.g. bsd).
 *
 * You don't have to care about such details if you probe whole disk. In such
 * a case libblkid always returns the offset relative to the begin of the disk.
 *
 * Returns: start of the partition (in 512-sectors). */
static inline blkid_loff_t blkid_partition_get_start(blkid_partition par)
{
	return (blkid_loff_t)par->start;
}

/* Linux Software RAID (md) topology
 * -- this is fallback for old systems where the topology information is not
 *    exported by sysfs */

/* topology probers */
#ifndef MD_MAJOR
#define MD_MAJOR        9
#endif

#ifndef _IOT__IOTBASE_uint32_t
#define _IOT__IOTBASE_uint32_t IOT_SIMPLE(uint32_t)
#endif
#define _IOT_md_array_info _IOT (_IOTS(uint32_t), 18, 0, 0, 0, 0)
#define GET_ARRAY_INFO          _IOR (MD_MAJOR, 0x11, struct md_array_info)

struct md_array_info {
	/* Generic constant information */
	uint32_t major_version;
	uint32_t minor_version;
	uint32_t patch_version;
	uint32_t ctime;
	uint32_t level;
	uint32_t size;
	uint32_t nr_disks;
	uint32_t raid_disks;
	uint32_t md_minor;
	uint32_t not_persistent;

	/* Generic state information */
	uint32_t utime;   /*  0 Superblock update time            */
	uint32_t state;   /*  1 State bits (clean, ...)           */
	uint32_t active_disks;  /*  2 Number of currently active disks  */
	uint32_t working_disks; /*  3 Number of working disks             */
	uint32_t failed_disks;  /*  4 Number of failed disks              */
	uint32_t spare_disks;     /*  5 Number of spare disks             */

	/* Personality information */
	uint32_t layout;          /*  0 the array's physical layout       */
	uint32_t chunk_size;      /*  1 chunk size in bytes               */

};

static int is_md_device(dev_t devno)
{
	if (major(devno) == MD_MAJOR)
		return 1;
	return blkid_driver_has_major("md", major(devno));
}

static int topology_set_value(blkid_probe pr, const char *name,
				size_t structoff, unsigned long data)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (!chn)
		return -1;
	if (!data)
		return 0;       /* ignore zeros */

	if (chn->binary) {
		memcpy((char *) chn->data + structoff, &data, sizeof(data));
		return 0;
	}
	return blkid_probe_sprintf_value(pr, name, "%lu", data);
}

static int blkid_topology_set_minimum_io_size(blkid_probe pr, unsigned long val)
{
	return topology_set_value(pr,
			"MINIMUM_IO_SIZE",
			offsetof(struct blkid_struct_topology, minimum_io_size),
			val);
}

static int blkid_topology_set_optimal_io_size(blkid_probe pr, unsigned long val)
{
	return topology_set_value(pr,
			"OPTIMAL_IO_SIZE",
			offsetof(struct blkid_struct_topology, optimal_io_size),
			val);
}

static int probe_md_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int fd = -1;
	dev_t disk = 0;
	dev_t devno = blkid_probe_get_devno(pr);
	struct md_array_info md;

	if (!devno)
		goto nothing;           /* probably not a block device */

	if (!is_md_device(devno))
		goto nothing;

	if (blkid_devno_to_wholedisk(devno, NULL, 0, &disk))
		goto nothing;

	if (disk == devno)
		fd = pr->fd;
	else {
		char *diskpath = blkid_devno_to_devname(disk);

		if (!diskpath)
			goto nothing;

		fd = open(diskpath, O_RDONLY|O_CLOEXEC);
		free(diskpath);

		if (fd == -1)
			goto nothing;
	}

	memset(&md, 0, sizeof(md));

	if (ioctl(fd, GET_ARRAY_INFO, &md))
		goto nothing;

	if (fd >= 0 && fd != pr->fd) {
		close(fd);
		fd = -1;
	}

	/* Ignore levels we don't want aligned (e.g. linear)
	 * and deduct disk(s) from stripe width on RAID4/5/6 */
	switch (md.level) {
	case 6:
		md.raid_disks--;
		/* fallthrough */
	case 5:
	case 4:
		md.raid_disks--;
		/* fallthrough */
	case 1:
	case 0:
	case 10:
		break;
	default:
		goto nothing;
	}

	blkid_topology_set_minimum_io_size(pr, md.chunk_size);
	blkid_topology_set_optimal_io_size(pr, md.chunk_size * md.raid_disks);

	return 0;

nothing:
	if (fd >= 0 && fd != pr->fd)
		close(fd);
	return 1;
}

static const struct blkid_idinfo md_tp_idinfo =
{
	.name           = "md",
	.probefunc      = probe_md_tp,
	.magics         = BLKID_NONE_MAGIC
};

/* device-mapper (dm) topology
 * -- this is fallback for old systems where the topology information is not
 *   exported by sysfs */

static int is_dm_device(dev_t devno)
{
	return blkid_driver_has_major("device-mapper", major(devno));
}

static int probe_dm_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	const char *paths[] = {
		"/usr/local/sbin/dmsetup",
		"/usr/sbin/dmsetup",
		"/sbin/dmsetup"
	};
	int dmpipe[] = { -1, -1 }, stripes, stripesize;
	const char *cmd = NULL;
	FILE *stream = NULL;
	long long  offset, size;
	size_t i;
	dev_t devno = blkid_probe_get_devno(pr);

	if (!devno)
		goto nothing;           /* probably not a block device */
	if (!is_dm_device(devno))
		goto nothing;

	for (i = 0; i < ARRAY_SIZE(paths); i++) {
		struct stat sb;
		if (stat(paths[i], &sb) == 0) {
			cmd = paths[i];
			break;
		}
	}

	if (!cmd)
		goto nothing;
	if (pipe(dmpipe) < 0)
		goto nothing;

	switch (fork()) {
	case 0:
	{
		const char *dmargv[7];
		char maj[16], min[16];

		/* Plumbing */
		close(dmpipe[0]);

		if (dmpipe[1] != STDOUT_FILENO)
			dup2(dmpipe[1], STDOUT_FILENO);

		/* The libblkid library could linked with setuid programs */
		if (setgid(getgid()) < 0)
			 exit(1);
		if (setuid(getuid()) < 0)
			 exit(1);

		snprintf(maj, sizeof(maj), "%d", major(devno));
		snprintf(min, sizeof(min), "%d", minor(devno));

		dmargv[0] = cmd;
		dmargv[1] = "table";
		dmargv[2] = "-j";
		dmargv[3] = maj;
		dmargv[4] = "-m";
		dmargv[5] = min;
		dmargv[6] = NULL;

		execv(dmargv[0], (char * const *) dmargv);

		exit(1);
	}
	case -1:
		goto nothing;
	default:
		break;
	}

	stream = fdopen(dmpipe[0], "r" UL_CLOEXECSTR);
	if (!stream)
		goto nothing;

	if (fscanf(stream, "%lld %lld striped %d %d ",
			&offset, &size, &stripes, &stripesize) != 0)
		goto nothing;

	blkid_topology_set_minimum_io_size(pr, stripesize << 9);
	blkid_topology_set_optimal_io_size(pr, (stripes * stripesize) << 9);

	fclose(stream);
	close(dmpipe[1]);
	return 0;

nothing:
	if (stream)
		fclose(stream);
	else if (dmpipe[0] != -1)
		close(dmpipe[0]);
	if (dmpipe[1] != -1)
		close(dmpipe[1]);
	return 1;
}

static const struct blkid_idinfo dm_tp_idinfo =
{
	.name           = "dm",
	.probefunc      = probe_dm_tp,
	.magics         = BLKID_NONE_MAGIC
};

/* Evms topology
 * -- this is fallback for old systems where the topology information is not
 *    exported by sysfs */

#define EVMS_MAJOR              117

#ifndef _IOT__IOTBASE_u_int32_t
#define _IOT__IOTBASE_u_int32_t IOT_SIMPLE(uint32_t)
#endif
#define _IOT_evms_stripe_info _IOT (_IOTS(uint32_t), 2, 0, 0, 0, 0)
#define EVMS_GET_STRIPE_INFO    _IOR(EVMS_MAJOR, 0xF0, struct evms_stripe_info)

struct evms_stripe_info {
	uint32_t        size;           /* stripe unit 512-byte blocks */
	uint32_t        width;          /* the number of stripe members or RAID data disks */
};

static int is_evms_device(dev_t devno)
{
	if (major(devno) == EVMS_MAJOR)
		return 1;
	return blkid_driver_has_major("evms", major(devno));
}

static int probe_evms_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct evms_stripe_info evms;
	dev_t devno = blkid_probe_get_devno(pr);

	if (!devno)
		goto nothing;           /* probably not a block device */

	if (!is_evms_device(devno))
		goto nothing;

	memset(&evms, 0, sizeof(evms));

	if (ioctl(pr->fd, EVMS_GET_STRIPE_INFO, &evms))
		goto nothing;

	blkid_topology_set_minimum_io_size(pr, evms.size << 9);
	blkid_topology_set_optimal_io_size(pr, (evms.size * evms.width) << 9);

	return 0;

nothing:
	return 1;
}

static const struct blkid_idinfo evms_tp_idinfo =
{
	.name           = "evms",
	.probefunc      = probe_evms_tp,
	.magics         = BLKID_NONE_MAGIC
};

/* lvm topology
 * -- this is fallback for old systems where the topology information is not
 *    exported by sysfs */

#ifndef LVM_BLK_MAJOR
# define LVM_BLK_MAJOR     58
#endif

static int is_lvm_device(dev_t devno)
{
	if (major(devno) == LVM_BLK_MAJOR)
		return 1;
	return blkid_driver_has_major("lvm", major(devno));
}

static int probe_lvm_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	const char *paths[] = {
		"/usr/local/sbin/lvdisplay",
		"/usr/sbin/lvdisplay",
		"/sbin/lvdisplay"
	};
	int lvpipe[] = { -1, -1 }, stripes = 0, stripesize = 0;
	FILE *stream = NULL;
	char *cmd = NULL, *devname = NULL, buf[1024];
	size_t i;
	dev_t devno = blkid_probe_get_devno(pr);

	if (!devno)
		goto nothing;           /* probably not a block device */
	if (!is_lvm_device(devno))
		goto nothing;

	for (i = 0; i < ARRAY_SIZE(paths); i++) {
		struct stat sb;
		if (stat(paths[i], &sb) == 0) {
			cmd = (char *) paths[i];
			break;
		}
	}

	if (!cmd)
		goto nothing;

	devname = blkid_devno_to_devname(devno);
	if (!devname)
		goto nothing;

	if (pipe(lvpipe) < 0)
		goto nothing;

	switch (fork()) {
	case 0:
	{
		char *lvargv[3];

		/* Plumbing */
		close(lvpipe[0]);

		if (lvpipe[1] != STDOUT_FILENO)
			dup2(lvpipe[1], STDOUT_FILENO);

		/* The libblkid library could linked with setuid programs */
		if (setgid(getgid()) < 0)
			 exit(1);
		if (setuid(getuid()) < 0)
			 exit(1);

		lvargv[0] = cmd;
		lvargv[1] = devname;
		lvargv[2] = NULL;

		execv(lvargv[0], lvargv);

		exit(1);
	}
	case -1:
		goto nothing;
	default:
		break;
	}

	stream = fdopen(lvpipe[0], "r" UL_CLOEXECSTR);
	if (!stream)
		goto nothing;

	while (fgets(buf, sizeof(buf), stream) != NULL) {
		if (!strncmp(buf, "Stripes", 7))
			sscanf(buf, "Stripes %d", &stripes);

		if (!strncmp(buf, "Stripe size", 11))
			sscanf(buf, "Stripe size (KByte) %d", &stripesize);
	}

	if (!stripes)
		goto nothing;

	blkid_topology_set_minimum_io_size(pr, stripesize << 10);
	blkid_topology_set_optimal_io_size(pr, (stripes * stripesize) << 10);

	free(devname);
	fclose(stream);
	close(lvpipe[1]);
	return 0;

nothing:
	free(devname);
	if (stream)
		fclose(stream);
	else if (lvpipe[0] != -1)
		close(lvpipe[0]);
	if (lvpipe[1] != -1)
		close(lvpipe[1]);
	return 1;
}

static const struct blkid_idinfo lvm_tp_idinfo =
{
	.name           = "lvm",
	.probefunc      = probe_lvm_tp,
	.magics         = BLKID_NONE_MAGIC
};


/* The topology chain provides details about Linux block devices, for more
 * information see:
 *
 *      Linux kernel Documentation/ABI/testing/sysfs-block
 *
 * NAME=value (tags) interface and provides:
 *
 * @LOGICAL_SECTOR_SIZE: this is the smallest unit the storage device can
 *                       address. It is typically 512 bytes.
 *
 * @PHYSICAL_SECTOR_SIZE: this is the smallest unit a physical storage device
 *                        can write atomically. It is usually the same as the
 *                        logical sector size but may be bigger.
 *
 * @MINIMUM_IO_SIZE: minimum size which is the device's preferred unit of I/O.
 *                   For RAID arrays it is often the stripe chunk size.
 *
 * @OPTIMAL_IO_SIZE: usually the stripe width for RAID or zero. For RAID arrays
 *                   it is usually the stripe width or the internal track size.
 *
 * @ALIGNMENT_OFFSET: indicates how many bytes the beginning of the device is
 *                    offset from the disk's natural alignment.
 *
 * The NAME=value tags are not defined when the corresponding topology value
 * is zero. The MINIMUM_IO_SIZE should be always defined if kernel provides
 * topology information. */
static int topology_is_complete(blkid_probe pr);
static int topology_set_logical_sector_size(blkid_probe pr);


#ifdef __linux__
static int probe_ioctl_tp(blkid_probe pr, const struct blkid_idmag *mag __attribute__((__unused__)));
static int probe_sysfs_tp(blkid_probe pr, const struct blkid_idmag *mag __attribute__((__unused__)));

static const struct blkid_idinfo ioctl_tp_idinfo =
{
	.name           = "ioctl",
	.probefunc      = probe_ioctl_tp,
	.magics         = BLKID_NONE_MAGIC
};

static const struct blkid_idinfo sysfs_tp_idinfo =
{
	.name           = "sysfs",
	.probefunc      = probe_sysfs_tp,
	.magics         = BLKID_NONE_MAGIC
};
#endif

/* Topology chain probing functions */
static const struct blkid_idinfo * const idinfos_tplg[] =
{
#ifdef __linux__
	&ioctl_tp_idinfo,
	&sysfs_tp_idinfo,
	&md_tp_idinfo,
	&dm_tp_idinfo,
	&lvm_tp_idinfo,
	&evms_tp_idinfo
#endif
};

/* The blkid_do_probe() backend. */
static int topology_probe(blkid_probe pr, struct blkid_chain *chn)
{
	size_t i;

	if (chn->idx < -1)
		return -1;

	if (!S_ISBLK(pr->mode))
		return -EINVAL; /* nothing, works with block devices only */

	if (chn->binary) {
		if (chn->data)
			/* reset binary data */
			memset(chn->data, 0, sizeof(struct blkid_struct_topology));
		else {
			chn->data = zmalloc(sizeof(struct blkid_struct_topology));
		}
	}

	blkid_probe_chain_reset_values(pr, chn);

	i = chn->idx < 0 ? 0 : chn->idx + 1U;

	for ( ; i < ARRAY_SIZE(idinfos_tplg); i++) {
		const struct blkid_idinfo *id = idinfos_tplg[i];

		chn->idx = i;

		if (id->probefunc) {
			if (id->probefunc(pr, NULL) != 0)
				continue;
		}

		if (!topology_is_complete(pr))
			continue;

		/* generic for all probing drivers */
		topology_set_logical_sector_size(pr);

		return BLKID_PROBE_OK;
	}

	return BLKID_PROBE_NONE;
}

static void topology_free(blkid_probe pr __attribute__((__unused__)),
			  void *data)
{
	free(data);
}



/* the topology info is complete when we have at least "minimum_io_size" which
 * is provided by all blkid topology drivers */
static int topology_is_complete(blkid_probe pr)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (!chn)
		return FALSE;

	if (chn->binary && chn->data) {
		blkid_topology tp = (blkid_topology) chn->data;
		if (tp->minimum_io_size)
			return TRUE;
	}

	return __blkid_probe_lookup_value(pr, "MINIMUM_IO_SIZE") ? TRUE : FALSE;
}

static int blkid_topology_set_alignment_offset(blkid_probe pr, int val)
{
	unsigned long xval;

	/* Welcome to Hell. The kernel is able to return -1 as an
	 * alignment_offset if no compatible sizes and alignments
	 * exist for stacked devices.
	 *
	 * There is no way how libblkid caller can respond to the value -1, so
	 * we will hide this corner case...
	 *
	 * (TODO: maybe we can export an extra boolean value 'misaligned' rather
	 *  then complete hide this problem.) */
	xval = val < 0 ? 0 : val;

	return topology_set_value(pr,
			"ALIGNMENT_OFFSET",
			offsetof(struct blkid_struct_topology, alignment_offset),
			xval);
}

/* BLKSSZGET is provided on all systems since 2.3.3 -- so we don't have to
 * waste time with sysfs. */
static int topology_set_logical_sector_size(blkid_probe pr)
{
	unsigned long val = blkid_probe_get_sectorsize(pr);

	if (!val)
		return -1;

	return topology_set_value(pr,
			"LOGICAL_SECTOR_SIZE",
			offsetof(struct blkid_struct_topology, logical_sector_size),
			val);
}

static int blkid_topology_set_physical_sector_size(blkid_probe pr, unsigned long val)
{
	return topology_set_value(pr,
			"PHYSICAL_SECTOR_SIZE",
			offsetof(struct blkid_struct_topology, physical_sector_size),
			val);
}

/* sysfs based topology -- gathers topology information from Linux sysfs
 * For more information see Linux kernel Documentation/ABI/testing/sysfs-block. */

/* Sysfs topology values (since 2.6.31, May 2009). */
struct topology_val_sysfs {
	/* /sys/dev/block/<maj>:<min>/<ATTR> */
	const char *attr;
	/* functions to set probing result */
	int (*set_ulong)(blkid_probe, unsigned long);
	int (*set_int)(blkid_probe, int);

};
static const struct topology_val_sysfs topology_vals_sysfs[] = {
	{ "alignment_offset", NULL, blkid_topology_set_alignment_offset },
	{ "queue/minimum_io_size", blkid_topology_set_minimum_io_size },
	{ "queue/optimal_io_size", blkid_topology_set_optimal_io_size },
	{ "queue/physical_block_size", blkid_topology_set_physical_sector_size },
};

static int probe_sysfs_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	dev_t dev;
	int rc, set_parent = 1;
	struct path_cxt *pc;
	size_t i, count = 0;

	dev = blkid_probe_get_devno(pr);
	if (!dev)
		return 1;
	pc = ul_new_sysfs_path(dev, NULL, NULL);
	if (!pc)
		return 1;

	rc = 1;         /* nothing (default) */

	for (i = 0; i < ARRAY_SIZE(topology_vals_sysfs); i++) {
		const struct topology_val_sysfs *val = &topology_vals_sysfs[i];
		int ok = ul_path_access(pc, F_OK, val->attr) == 0;

		rc = 1; /* nothing */

		if (!ok && set_parent) {
			dev_t disk = blkid_probe_get_wholedisk_devno(pr);
			set_parent = 0;

			/* Read attributes from "disk" if the current device is
			 * a partition. Note that sysfs ul_path_* API is able
			 * to redirect requests to attributes if parent is set. */
			if (disk && disk != dev) {
				struct path_cxt *parent = ul_new_sysfs_path(disk, NULL, NULL);
				if (!parent)
					goto done;

				sysfs_blkdev_set_parent(pc, parent);
				ul_unref_path(parent);

				/* try it again */
				ok = ul_path_access(pc, F_OK, val->attr) == 0;
			}
		}
		if (!ok)
			continue;       /* attribute does not exist */

		if (val->set_ulong) {
			uint64_t data;

			if (ul_path_read_u64(pc, &data, val->attr) != 0)
				continue;
			rc = val->set_ulong(pr, (unsigned long) data);

		} else if (val->set_int) {
			int64_t data;

			if (ul_path_read_s64(pc, &data, val->attr) != 0)
				continue;
			rc = val->set_int(pr, (int) data);
		}

		if (rc < 0)
			goto done;      /* error */
		if (rc == 0)
			count++;
	}

done:
	ul_unref_path(pc);              /* unref pc and parent */
	if (count)
		return 0;               /* success */
	return rc;                      /* error or nothing */
}

/* ioctl topology values */
struct topology_val_ioctl {
	long  ioc;
	/* functions to set probing result */
	int (*set_ulong)(blkid_probe, unsigned long);
	int (*set_int)(blkid_probe, int);
};

static const struct topology_val_ioctl topology_vals_ioctl[] = {
	{ BLKALIGNOFF, NULL, blkid_topology_set_alignment_offset },
	{ BLKIOMIN, blkid_topology_set_minimum_io_size },
	{ BLKIOOPT, blkid_topology_set_optimal_io_size },
	{ BLKPBSZGET, blkid_topology_set_physical_sector_size }
	/* we read BLKSSZGET in topology.c */
};

static int probe_ioctl_tp(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	size_t i;

	for (i = 0; i < ARRAY_SIZE(topology_vals_ioctl); i++) {
		const struct topology_val_ioctl *val = &topology_vals_ioctl[i];
		int rc = 1;
		unsigned int data;

		if (ioctl(pr->fd, val->ioc, &data) == -1)
			goto nothing;

		if (val->set_int)
			rc = val->set_int(pr, (int) data);
		else
			rc = val->set_ulong(pr, (unsigned long) data);
		if (rc)
			goto err;
	}

	return 0;
nothing:
	return 1;
err:
	return -1;
}

static int blkid_partitions_need_typeonly(blkid_probe pr)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	return chn && chn->data && chn->binary ? FALSE : TRUE;
}

static inline void blkid_partition_set_type(blkid_partition par, int type)
{
	par->type = type;
}

static inline void blkid_partition_set_flags(blkid_partition par, unsigned long long flags)
{
	par->flags = flags;
}

/* aix partitions */
#define BLKID_AIX_MAGIC_STRING  "\xC9\xC2\xD4\xC1"
#define BLKID_AIX_MAGIC_STRLEN  (sizeof(BLKID_AIX_MAGIC_STRING) - 1)

static int probe_aix_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	blkid_partlist ls;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		return BLKID_PROBE_NONE;

	blkid_partlist_new_parttable(ls, "aix", 0);
	return BLKID_PROBE_OK;
}

/* We know nothing about AIX on-disk structures. Everything what we know is the
 * magic number at begin of the disk.
 *
 * Note, Linux kernel is tring to be smart and AIX signature is ignored when
 * there is a valid DOS partitions table. We don't support such behavior. All
 * fdisk-like programs has to properly wipe the fist sector. Everything other
 * is a bug. */
static const struct blkid_idinfo aix_pt_idinfo =
{
	.name           = "aix",
	.probefunc      = probe_aix_pt,
	.magics         =
	{
		{ .magic = BLKID_AIX_MAGIC_STRING, .len = BLKID_AIX_MAGIC_STRLEN },
		{ NULL }
	}
};

/* ultrix partition parsing code */
#define ULTRIX_MAXPARTITIONS    8

#define ULTRIX_MAGIC            0x032957
#define ULTRIX_MAGIC_STR        "\x02\x29\x57"

/* sector with partition table */
#define ULTRIX_SECTOR           ((16384 - sizeof(struct ultrix_disklabel)) >> 9)
/* position of partition table within ULTRIX_SECTOR */
#define ULTRIX_OFFSET           (512 - sizeof(struct ultrix_disklabel))

struct ultrix_disklabel {
	int32_t pt_magic;       /* magic no. indicating part. info exits */
	int32_t pt_valid;       /* set by driver if pt is current */
	struct  pt_info {
		int32_t         pi_nblocks; /* no. of sectors */
		uint32_t        pi_blkoff;  /* block offset for start */
	} pt_part[ULTRIX_MAXPARTITIONS];
} __attribute__((packed));


static int probe_ultrix_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	unsigned char *data;
	struct ultrix_disklabel *l;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	int i;

	data = blkid_probe_get_sector(pr, ULTRIX_SECTOR);
	if (!data) {
		if (errno)
			return -errno;
		goto nothing;
	}

	l = (struct ultrix_disklabel *) (data + ULTRIX_OFFSET);

	if (l->pt_magic != ULTRIX_MAGIC || l->pt_valid != 1)
		goto nothing;

	if (blkid_probe_set_magic(pr, (ULTRIX_SECTOR << 9) + ULTRIX_OFFSET,
			sizeof(ULTRIX_MAGIC_STR) - 1,
			(unsigned char *) ULTRIX_MAGIC_STR))
		goto err;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "ultrix", 0);
	for (i = 0; i < ULTRIX_MAXPARTITIONS; i++) {
		if (!l->pt_part[i].pi_nblocks)
			 blkid_partlist_increment_partno(ls);
		else {
			blkid_partlist_add_partition(ls, tab,
						l->pt_part[i].pi_blkoff,
						l->pt_part[i].pi_nblocks);
		}
	}

	return BLKID_PROBE_OK;
nothing:
	return BLKID_PROBE_NONE;
err:
	return -ENOMEM;
}

static const struct blkid_idinfo ultrix_pt_idinfo =
{
	.name           = "ultrix",
	.probefunc      = probe_ultrix_pt,
	.magics         = BLKID_NONE_MAGIC
};
#endif /* CONFIG_FEATURE_LIBBLKID */

#if defined(CONFIG_FEATURE_SUN_LABEL) && defined(CONFIG_FEATURE_LIBBLKID)
/* sun (solaris-sparc) partition parsing code */
static int probe_sun_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct sun_disklabel *l;
	struct sun_partition *p;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	uint16_t nparts;
	uint64_t spc;
	int i, use_vtoc;

	l = (struct sun_disklabel *) blkid_probe_get_sector(pr, 0);
	if (!l) {
		if (errno)
			return -errno;
		goto nothing;
	}

	if (sun_pt_checksum(l))
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "sun", 0);
	/* sectors per cylinder (partition offset is in cylinders...) */
	spc = (uint64_t) be16_to_cpu(l->nhead) * be16_to_cpu(l->nsect);

	/* Check to see if we can use the VTOC table */
	use_vtoc = ((be32_to_cpu(l->vtoc.sanity) == SUN_VTOC_SANITY) &&
		    (be32_to_cpu(l->vtoc.version) == SUN_VTOC_VERSION) &&
		    (be16_to_cpu(l->vtoc.nparts) <= SUN_MAXPARTITIONS));

	/* Use 8 partition entries if not specified in validated VTOC */
	nparts = use_vtoc ? be16_to_cpu(l->vtoc.nparts) : SUN_MAXPARTITIONS;

	/* So that old Linux-Sun partitions continue to work,
	 * allow the VTOC to be used under the additional condition ... */
	use_vtoc = use_vtoc || !(l->vtoc.sanity || l->vtoc.version || l->vtoc.nparts);

	for (i = 0, p = l->partitions; i < nparts; i++, p++) {

		uint64_t start, size;
		uint16_t type = 0, flags = 0;
		blkid_partition par;

		start = be32_to_cpu(p->start_cylinder) * spc;
		size = be32_to_cpu(p->num_sectors);
		if (use_vtoc) {
			type = be16_to_cpu(l->vtoc.infos[i].id);
			flags = be16_to_cpu(l->vtoc.infos[i].flags);
		}

		if (type == SUN_TAG_WHOLEDISK || !size) {
			blkid_partlist_increment_partno(ls);
			continue;
		}
		par = blkid_partlist_add_partition(ls, tab, start, size);
		if (type)
			blkid_partition_set_type(par, type);
		if (flags)
			blkid_partition_set_flags(par, flags);
	}
	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}


static const struct blkid_idinfo sun_pt_idinfo =
{
	.name           = "sun",
	.probefunc      = probe_sun_pt,
	.magics         =
	{
		{
		  .magic = "\xDA\xBE",          /* big-endian magic string */
		  .len = 2,
		  .sboff = offsetof(struct sun_disklabel, magic)
		},
		{ NULL }
	}
};
#endif /* defined(CONFIG_FEATURE_SUN_LABEL) && defined(CONFIG_FEATURE_LIBBLKID) */

#if defined(CONFIG_FEATURE_SGI_LABEL) && defined(CONFIG_FEATURE_LIBBLKID)
/* sgi partition parsing code */
static int probe_sgi_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct sgi_disklabel *l;
	struct sgi_partition *p;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	int i;

	l = (struct sgi_disklabel *) blkid_probe_get_sector(pr, 0);
	if (!l) {
		if (errno)
			return -errno;
		goto nothing;
	}

	if (sgi_pt_checksum(l))
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "sgi", 0);
	for(i = 0, p = &l->partitions[0]; i < SGI_MAXPARTITIONS; i++, p++) {
		uint32_t size = be32_to_cpu(p->num_blocks);
		uint32_t start = be32_to_cpu(p->first_block);
		uint32_t type = be32_to_cpu(p->type);
		blkid_partition par;

		if (!size) {
			blkid_partlist_increment_partno(ls);
			continue;
		}
		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, type);
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}

static const struct blkid_idinfo sgi_pt_idinfo =
{
	.name           = "sgi",
	.probefunc      = probe_sgi_pt,
	.magics         =
	{
		{ .magic = "\x0B\xE5\xA9\x41", .len = 4 },
		{ NULL }
	}
};
#endif /* defined(CONFIG_FEATURE_SGI_LABEL) && defined(CONFIG_FEATURE_LIBBLKID) */

#ifdef CONFIG_FEATURE_LIBBLKID
static void set_string(unsigned char *item, size_t max,
				const unsigned char *data, size_t len)
{
	if (len >= max)
		len = max - 1;

	memcpy(item, data, len);
	item[len] = '\0';

	rtrim_whitespace(item);
}

static int blkid_partition_set_name(blkid_partition par,
		const unsigned char *name, size_t len)
{
	if (!par)
		return -1;

	set_string(par->name, sizeof(par->name), name, len);
	return 0;
}

/* Sets partition 'type' for PT where the type is defined by string rather
 * than by number */
static void blkid_partition_set_type_string(blkid_partition par,
		const unsigned char *type, size_t len)
{
	set_string((unsigned char *) par->typestr,
			sizeof(par->typestr), type, len);
}

/* mac partitions parsing code */
#define MAC_PARTITION_MAGIC             0x504d
#define MAC_PARTITION_MAGIC_OLD         0x5453

/* Mac partition entry
 * http://developer.apple.com/legacy/mac/library/documentation/mac/Devices/Devices-126.html
 */
struct mac_partition {
	uint16_t        signature;      /* expected to be MAC_PARTITION_MAGIC */
	uint16_t        reserved;       /* reserved */
	uint32_t        map_count;      /* # blocks in partition map */
	uint32_t        start_block;    /* absolute starting block # of partition */
	uint32_t        block_count;    /* number of blocks in partition */
	char            name[32];       /* partition name */
	char            type[32];       /* string type description */
	uint32_t        data_start;     /* rel block # of first data block */
	uint32_t        data_count;     /* number of data blocks */
	uint32_t        status;         /* partition status bits */
	uint32_t        boot_start;     /* first logical block of boot code */
	uint32_t        boot_size;      /* size of boot code, in bytes */
	uint32_t        boot_load;      /* boot code load address */
	uint32_t        boot_load2;     /* reserved */
	uint32_t        boot_entry;     /* boot code entry point */
	uint32_t        boot_entry2;    /* reserved */
	uint32_t        boot_cksum;     /* boot code checksum */
	char            processor[16];  /* identifies ISA of boot */

	/* there is more stuff after this that we don't need */
} __attribute__((packed));

/* Driver descriptor structure, in block 0
 * http://developer.apple.com/legacy/mac/library/documentation/mac/Devices/Devices-121.html
 */
struct mac_driver_desc {
	uint16_t        signature;      /* expected to be MAC_DRIVER_MAGIC */
	uint16_t        block_size;     /* block size of the device */
	uint32_t        block_count;    /* number of blocks on the device */

	/* there is more stuff after this that we don't need */
} __attribute__((packed));

static inline unsigned char *get_mac_block(
					blkid_probe pr,
					uint16_t block_size,
					uint32_t num)
{
	return blkid_probe_get_buffer(pr, (uint64_t) num * block_size, block_size);
}

static inline int has_part_signature(struct mac_partition *p)
{
	return  be16_to_cpu(p->signature) == MAC_PARTITION_MAGIC ||
		be16_to_cpu(p->signature) == MAC_PARTITION_MAGIC_OLD;
}

static int probe_mac_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct mac_driver_desc *md;
	struct mac_partition *p;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	uint16_t block_size;
	uint16_t ssf;   /* sector size fragment */
	uint32_t nblks, i;


	/* The driver descriptor record is always located at physical block 0,
	 * the first block on the disk. */
	md = (struct mac_driver_desc *) blkid_probe_get_sector(pr, 0);
	if (!md) {
		if (errno)
			return -errno;
		goto nothing;
	}

	block_size = be16_to_cpu(md->block_size);

	/* The partition map always begins at physical block 1,
	 * the second block on the disk. */
	p = (struct mac_partition *) get_mac_block(pr, block_size, 1);
	if (!p) {
		if (errno)
			return -errno;
		goto nothing;
	}

	/* check the first partition signature */
	if (!has_part_signature(p))
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return 0;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "mac", 0);
	ssf = block_size / 512;
	nblks = be32_to_cpu(p->map_count);

	for (i = 1; i <= nblks; ++i) {
		blkid_partition par;
		uint32_t start;
		uint32_t size;

		p = (struct mac_partition *) get_mac_block(pr, block_size, i);
		if (!p) {
			if (errno)
				return -errno;
			goto nothing;
		}
		if (!has_part_signature(p))
			goto nothing;

		/* note that libparted ignores some mac partitions according to
		 * the partition name (e.g. "Apple_Free" or "Apple_Void"). We
		 * follows Linux kernel and all partitions are visible */

		start = be32_to_cpu(p->start_block) * ssf;
		size = be32_to_cpu(p->block_count) * ssf;

		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_name(par, (unsigned char *) p->name,
						sizeof(p->name));

		blkid_partition_set_type_string(par, (unsigned char *) p->type,
						sizeof(p->type));
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}

/* Mac disk always begin with "Driver Descriptor Record"
 * (struct mac_driver_desc) and magic 0x4552. */
static const struct blkid_idinfo mac_pt_idinfo =
{
	.name           = "mac",
	.probefunc      = probe_mac_pt,
	.magics         =
	{
		/* big-endian magic string */
		{ .magic = "\x45\x52", .len = 2 },
		{ NULL }
	}
};

/* atari partitions parsing code
 * Based on Linux kernel implementation and atari-fdisk */

struct atari_part_def {
	/* flags:
	 * 0 (LSB): active
	 * 1-6:     (reserved)
	 * 7 (MSB): bootable */
	unsigned char flags;
	char id[3];
	uint32_t start;
	uint32_t size;
} __attribute__((packed));

struct atari_rootsector {
	char unused0[0x156]; /* boot code */
	struct atari_part_def icd_part[8]; /* ICD partition entries */
	char unused1[0xc];
	uint32_t hd_size;
	struct atari_part_def part[4]; /* primary partition entries */
	uint32_t bsl_start; /* bad sector list start */
	uint32_t bsl_len; /* bad sector list length */
	uint16_t checksum;
} __attribute__((packed));


/* Generated using linux kernel ctype.{c,h}
 *
 * Since kernel uses isalnum() to detect whether it is Atari PT, we need same
 * definition of alnum character to be consistent with kernel. */

static const unsigned char _linux_isalnum[] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1
};

static int linux_isalnum(unsigned char c) {
	return _linux_isalnum[c];
}

#define isalnum_atari linux_isalnum

#define IS_ACTIVE(partdef) ((partdef).flags & 1)

#define IS_PARTDEF_VALID(partdef, hdsize) \
	( \
		(partdef).flags & 1 && \
		isalnum_atari((partdef).id[0]) && \
		isalnum_atari((partdef).id[1]) && \
		isalnum_atari((partdef).id[2]) && \
		be32_to_cpu((partdef).start) <= (hdsize) && \
		be32_to_cpu((partdef).start) + \
			be32_to_cpu((partdef).size) <= (hdsize) \
	)

static int is_id_common(char *id)
{
	const char * const ids[] = {"GEM", "BGM", "LNX", "SWP", "RAW", };
	unsigned i;

	for (i = 0; i < ARRAY_SIZE(ids); i++) {
		if (!memcmp(ids[i], id, 3))
			return 1;
	}
	return 0;
}

/* It's possible that the list of partitions is *empty*, but there is a valid
 * partition table on the disk. This happen when on-disk details about
 * partitions are unknown or the partition table is empty.
 *
 * Returns: partition object or NULL in case or error. */
static blkid_partition blkid_partlist_get_partition(blkid_partlist ls, int n)
{
	if (n < 0 || n >= ls->nparts)
		return NULL;

	return &ls->parts[n];
}

static blkid_partition blkid_partlist_get_partition_by_start(blkid_partlist ls, uint64_t start)
{
	int i, nparts;
	blkid_partition par;

	nparts = blkid_partlist_numof_partitions(ls);
	for (i = 0; i < nparts; i++) {
		par = blkid_partlist_get_partition(ls, i);
		if ((uint64_t) blkid_partition_get_start(par) == start)
			return par;
	}
	return NULL;
}

static int parse_partition(blkid_partlist ls, blkid_parttable tab,
	struct atari_part_def *part, uint32_t offset)
{
	blkid_partition par;
	uint32_t start;
	uint32_t size;

	start = be32_to_cpu(part->start) + offset;
	size = be32_to_cpu(part->size);

	if (blkid_partlist_get_partition_by_start(ls, start)) {
		/* Don't increment partno for extended parts */
		if (!offset)
			blkid_partlist_increment_partno(ls);
		return 0;
	}

	par = blkid_partlist_add_partition(ls, tab, start, size);
	blkid_partition_set_type_string(par, (unsigned char *) part->id,
					sizeof(part->id));
	return 1;
}

/* return 1: OK, 0: bad format or -errno */
static int parse_extended(blkid_probe pr, blkid_partlist ls,
	blkid_parttable tab, struct atari_part_def *part)
{
	uint32_t x0start, xstart;
	unsigned i = 0;
	int rc;

	x0start = xstart = be32_to_cpu(part->start);
	while (1) {
		struct atari_rootsector *xrs;
		xrs = (struct atari_rootsector *) blkid_probe_get_sector(pr, xstart);
		if (!xrs) {
			if (errno)
				return -errno;
			return 0;
		}

		/* There must be data partition followed by reference to next
		 * XGM or inactive entry. */
		for (i=0; ; i++) {
			if (i >= ARRAY_SIZE(xrs->part) - 1)
				return 0;
			if (IS_ACTIVE(xrs->part[i]))
				break;
		}

		if (!memcmp(xrs->part[i].id, "XGM", 3))
			return 0;

		rc = parse_partition(ls, tab, &xrs->part[i], xstart);
		if (rc <= 0)
			return rc;

		if (!IS_ACTIVE(xrs->part[i+1]))
			break;

		if (memcmp(xrs->part[i+1].id, "XGM", 3))
			return 0;

		xstart = x0start + be32_to_cpu(xrs->part[i+1].start);
	}

	return 1;
}

static int probe_atari_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct atari_rootsector *rs;

	blkid_parttable tab = NULL;
	blkid_partlist ls;

	unsigned i;
	int has_xgm = 0;
	int rc = 0;
	off_t hdsize;

	/* Atari partition is not defined for other sector sizes */
	if (blkid_probe_get_sectorsize(pr) != 512)
		goto nothing;

	rs = (struct atari_rootsector *) blkid_probe_get_sector(pr, 0);
	if (!rs) {
		if (errno)
			return -errno;
		goto nothing;
	}

	hdsize = blkid_probe_get_size(pr) / 512;

	/* Look for validly looking primary partition */
	for (i = 0; ; i++) {
		if (i >= ARRAY_SIZE(rs->part))
			goto nothing;

		if (IS_PARTDEF_VALID(rs->part[i], hdsize)) {
			blkid_probe_set_magic(pr,
				offsetof(struct atari_rootsector, part[i]),
				sizeof(rs->part[i].flags) + sizeof(rs->part[i].id),
				(unsigned char *) &rs->part[i]);
			break;
		}
	}

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "atari", 0);
	for (i = 0; i < ARRAY_SIZE(rs->part); i++) {
		struct atari_part_def *p = &rs->part[i];

		if (!IS_ACTIVE(*p)) {
			blkid_partlist_increment_partno(ls);
			continue;
		}

		if (!memcmp(p->id, "XGM", 3)) {
			has_xgm = 1;
			rc = parse_extended(pr, ls, tab, p);
		} else {
			rc = parse_partition(ls, tab, p, 0);
		}
		if (rc < 0)
			return rc;
	}

	/* if there are no XGM partitions, we can try ICD format */
	/* if first ICD partition ID is not valid, assume no ICD format */
	if (!has_xgm && is_id_common(rs->icd_part[0].id)) {
		for (i = 0; i < ARRAY_SIZE(rs->icd_part); i++) {
			struct atari_part_def *p = &rs->icd_part[i];

			if (!IS_ACTIVE(*p) || !is_id_common(p->id)) {
				blkid_partlist_increment_partno(ls);
				continue;
			}

			rc = parse_partition(ls, tab, p, 0);
			if (rc < 0)
				return rc;
		}
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}

static const struct blkid_idinfo atari_pt_idinfo =
{
	.name           = "atari",
	.probefunc      = probe_atari_pt,
	.magics         = BLKID_NONE_MAGIC
};

static inline blkid_partition blkid_partlist_get_parent(blkid_partlist ls)
{
	return ls->next_parent;
}

/* WARNING: be very careful when you work with MS-DOS extended partitions. The
 *          library always returns full size of the partition. If you want add
 *          the partition to the Linux system (BLKPG_ADD_PARTITION ioctl) you
 *          need to reduce the size of the partition to 1 or 2 blocks. The
 *          rest of the partition has to be inaccessible for mkfs or mkswap
 *          programs, we need a small space for boot loaders only.
 *
 *          For some unknown reason this (safe) practice is not to used for
 *          nested BSD, Solaris, ..., partition tables in Linux kernel.
 *
 * Returns: size of the partition (in 512-sectors). */
static inline blkid_loff_t blkid_partition_get_size(blkid_partition par)
{
	return (blkid_loff_t)par->size;
}

/* check if @start and @size are within @par partition */
static int blkid_is_nested_dimension(blkid_partition par,
			uint64_t start, uint64_t size)
{
	uint64_t pstart;
	uint64_t psize;

	if (!par)
		return 0;

	pstart = blkid_partition_get_start(par);
	psize = blkid_partition_get_size(par);

	if (start < pstart || start + size > pstart + psize)
		return 0;

	return 1;
}

/* unixware partition parsing code
 *
 * The interesting information about unixware PT:
 *   - Linux kernel / partx
 *   - vtoc(7) SCO UNIX command man page
 *   - evms source code (http://evms.sourceforge.net/)
 *   - vxtools source code (http://martin.hinner.info/fs/vxfs/) */

/* disklabel location */
#define UNIXWARE_SECTOR         29
#define UNIXWARE_OFFSET         (UNIXWARE_SECTOR << 9)  /* offset in bytes */
#define UNIXWARE_KBOFFSET       (UNIXWARE_OFFSET >> 10) /* offset in 1024-blocks */

/* disklabel->d_magic offset within the last 1024 block */
#define UNIXWARE_MAGICOFFSET    (UNIXWARE_OFFSET - UNIXWARE_KBOFFSET + 4)

#define UNIXWARE_VTOCMAGIC      0x600DDEEEUL
#define UNIXWARE_MAXPARTITIONS  16

/* unixware_partition->s_label flags */
#define UNIXWARE_TAG_UNUSED       0x0000  /* unused partition */
#define UNIXWARE_TAG_BOOT         0x0001  /* boot fs */
#define UNIXWARE_TAG_ROOT         0x0002  /* root fs */
#define UNIXWARE_TAG_SWAP         0x0003  /* swap fs */
#define UNIXWARE_TAG_USER         0x0004  /* user fs */
#define UNIXWARE_TAG_ENTIRE_DISK  0x0005  /* whole disk */
#define UNIXWARE_TAG_ALT_S        0x0006  /* alternate sector space */
#define UNIXWARE_TAG_OTHER        0x0007  /* non unix */
#define UNIXWARE_TAG_ALT_T        0x0008  /* alternate track space */
#define UNIXWARE_TAG_STAND        0x0009  /* stand partition */
#define UNIXWARE_TAG_VAR          0x000a  /* var partition */
#define UNIXWARE_TAG_HOME         0x000b  /* home partition */
#define UNIXWARE_TAG_DUMP         0x000c  /* dump partition */
#define UNIXWARE_TAG_ALT_ST       0x000d  /* alternate sector track */
#define UNIXWARE_TAG_VM_PUBLIC    0x000e  /* volume mgt public partition */
#define UNIXWARE_TAG_VM_PRIVATE   0x000f  /* volume mgt private partition */


/* unixware_partition->s_flags flags */
#define UNIXWARE_FLAG_VALID     0x0200

struct unixware_partition {
	uint16_t        s_label;        /* partition label (tag) */
	uint16_t        s_flags;        /* permission flags */
	uint32_t        start_sect;     /* starting sector */
	uint32_t        nr_sects;       /* number of sectors */
} __attribute__((packed));

struct unixware_disklabel {
	uint32_t        d_type;         /* drive type */
	uint32_t        d_magic;        /* the magic number */
	uint32_t        d_version;      /* version number */
	char            d_serial[12];   /* serial number of the device */
	uint32_t        d_ncylinders;   /* # of data cylinders per device */
	uint32_t        d_ntracks;      /* # of tracks per cylinder */
	uint32_t        d_nsectors;     /* # of data sectors per track */
	uint32_t        d_secsize;      /* # of bytes per sector */
	uint32_t        d_part_start;   /* # of first sector of this partition */
	uint32_t        d_unknown1[12]; /* ? */
	uint32_t        d_alt_tbl;      /* byte offset of alternate table */
	uint32_t        d_alt_len;      /* byte length of alternate table */
	uint32_t        d_phys_cyl;     /* # of physical cylinders per device */
	uint32_t        d_phys_trk;     /* # of physical tracks per cylinder */
	uint32_t        d_phys_sec;     /* # of physical sectors per track */
	uint32_t        d_phys_bytes;   /* # of physical bytes per sector */
	uint32_t        d_unknown2;     /* ? */
	uint32_t        d_unknown3;     /* ? */
	uint32_t        d_pad[8];       /* pad */

	struct unixware_vtoc {
		uint32_t        v_magic;        /* the magic number */
		uint32_t        v_version;      /* version number */
		char            v_name[8];      /* volume name */
		uint16_t        v_nslices;      /* # of partitions */
		uint16_t        v_unknown1;     /* ? */
		uint32_t        v_reserved[10]; /* reserved */

		struct unixware_partition
			v_slice[UNIXWARE_MAXPARTITIONS]; /* partition */
	} __attribute__((packed)) vtoc;
};

static int probe_unixware_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct unixware_disklabel *l;
	struct unixware_partition *p;
	blkid_parttable tab = NULL;
	blkid_partition parent;
	blkid_partlist ls;
	int i;

	l = (struct unixware_disklabel *)
			blkid_probe_get_sector(pr, UNIXWARE_SECTOR);
	if (!l) {
		if (errno)
			return -errno;
		goto nothing;
	}

	if (le32_to_cpu(l->vtoc.v_magic) != UNIXWARE_VTOCMAGIC)
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	parent = blkid_partlist_get_parent(ls);

	tab = blkid_partlist_new_parttable(ls, "unixware", UNIXWARE_OFFSET);
	/* Skip the first partition that describe whole disk */
	for (i = 1, p = &l->vtoc.v_slice[1];
			i < UNIXWARE_MAXPARTITIONS; i++, p++) {

		uint32_t start, size;
		uint16_t tag, flg;
		blkid_partition par;

		tag = le16_to_cpu(p->s_label);
		flg = le16_to_cpu(p->s_flags);

		if (tag == UNIXWARE_TAG_UNUSED ||
		    tag == UNIXWARE_TAG_ENTIRE_DISK ||
		    flg != UNIXWARE_FLAG_VALID)
			continue;

		start = le32_to_cpu(p->start_sect);
		size = le32_to_cpu(p->nr_sects);

		if (parent && !blkid_is_nested_dimension(parent, start, size))
			continue;

		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, tag);
		blkid_partition_set_flags(par, flg);
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}


/* The unixware partition table is within primary DOS partition.  The PT is
 * located on 29 sector, PT magic string is d_magic member of 'struct
 * unixware_disklabel'. */
static const struct blkid_idinfo unixware_pt_idinfo =
{
	.name           = "unixware",
	.probefunc      = probe_unixware_pt,
	.minsz          = 1024 * 1440 + 1,              /* ignore floppies */
	.magics         =
	{
		{
		  .magic = "\x0D\x60\xE5\xCA",  /* little-endian magic string */
		  .len = 4,                     /* d_magic size in bytes */
		  .kboff = UNIXWARE_KBOFFSET,
		  .sboff = UNIXWARE_MAGICOFFSET
		},
		{ NULL }
	}
};

/* Solaris x86 partition parsing code */

/* Solaris-x86 is always within primary dos partition (nested PT table).  The
 * solaris-x86 vtoc allows to split the entire partition to "slices". The
 * offset (start) of the slice is always relatively to the primary dos
 * partition.
 *
 * Note that Solaris-SPARC uses entire disk with a different partitioning
 * scheme. */

/* some other implementation than Linux kernel assume 8 partitions only */
#define SOLARIS_MAXPARTITIONS   16

/* disklabel (vtoc) location  */
#define SOLARIS_SECTOR          1                       /* in 512-sectors */
#define SOLARIS_OFFSET          (SOLARIS_SECTOR << 9)   /* in bytes */
#define SOLARIS_MAGICOFFSET     (SOLARIS_OFFSET + 12)   /* v_sanity offset in bytes */

/* slice tags */
#define SOLARIS_TAG_WHOLEDISK   5

struct solaris_slice {
	uint16_t s_tag;      /* ID tag of partition */
	uint16_t s_flag;     /* permission flags */
	uint32_t s_start;    /* start sector no of partition */
	uint32_t s_size;     /* # of blocks in partition */
} __attribute__((packed));

struct solaris_vtoc {
	unsigned int v_bootinfo[3];     /* info needed by mboot (unsupported) */

	uint32_t     v_sanity;          /* to verify vtoc sanity */
	uint32_t     v_version;         /* layout version */
	char         v_volume[8];       /* volume name */
	uint16_t     v_sectorsz;        /* sector size in bytes */
	uint16_t     v_nparts;          /* number of partitions */
	unsigned int v_reserved[10];    /* free space */

	struct solaris_slice v_slice[SOLARIS_MAXPARTITIONS]; /* slices */

	unsigned int timestamp[SOLARIS_MAXPARTITIONS]; /* timestamp (unsupported) */
	char         v_asciilabel[128]; /* for compatibility */
} __attribute__((packed));

static int probe_solaris_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct solaris_vtoc *l; /* disk label */
	struct solaris_slice *p;        /* partition */
	blkid_parttable tab = NULL;
	blkid_partition parent;
	blkid_partlist ls;
	int i;
	uint16_t nparts;

	l = (struct solaris_vtoc *) blkid_probe_get_sector(pr, SOLARIS_SECTOR);
	if (!l) {
		if (errno)
			return -errno;
		goto nothing;
	}

	if (le32_to_cpu(l->v_version) != 1)
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	parent = blkid_partlist_get_parent(ls);

	tab = blkid_partlist_new_parttable(ls, "solaris", SOLARIS_OFFSET);
	nparts = le16_to_cpu(l->v_nparts);
	if (nparts > SOLARIS_MAXPARTITIONS)
		nparts = SOLARIS_MAXPARTITIONS;

	for (i = 1, p = &l->v_slice[0]; i < nparts; i++, p++) {

		uint32_t start = le32_to_cpu(p->s_start);
		uint32_t size = le32_to_cpu(p->s_size);
		blkid_partition par;

		if (size == 0 || le16_to_cpu(p->s_tag) == SOLARIS_TAG_WHOLEDISK)
			continue;

		if (parent)
			/* Solaris slices are relative to the parent (primary
			 * DOS partition) */
			start += blkid_partition_get_start(parent);

		if (parent && !blkid_is_nested_dimension(parent, start, size))
			continue;

		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, le16_to_cpu(p->s_tag));
		blkid_partition_set_flags(par, le16_to_cpu(p->s_flag));
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}

static const struct blkid_idinfo solaris_x86_pt_idinfo =
{
	.name           = "solaris",
	.probefunc      = probe_solaris_pt,
	.magics         =
	{
		{
		  .magic = "\xEE\xDE\x0D\x60",  /* little-endian magic string */
		  .len = 4,                     /* v_sanity size in bytes */
		  .sboff = SOLARIS_MAGICOFFSET  /* offset of v_sanity */
		},
		{ NULL }
	}
};

/* Returns: partition type. */
static inline int blkid_partition_get_type(blkid_partition par)
{
	return par->type;
}



/* Minix partition parsing code */
static int probe_minix_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	struct dos_partition *p;
	blkid_parttable tab = NULL;
	blkid_partition parent;
	blkid_partlist ls;
	unsigned char *data;
	int i;

	data = blkid_probe_get_sector(pr, 0);
	if (!data) {
		if (errno)
			return -errno;
		goto nothing;
	}

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	/* Parent is required, because Minix uses the same PT as DOS and
	 * difference is only in primary partition (parent) type. */
	parent = blkid_partlist_get_parent(ls);
	if (!parent)
		goto nothing;

	if (blkid_partition_get_type(parent) != MBR_MINIX_PARTITION)
		goto nothing;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return BLKID_PROBE_OK;

	tab = blkid_partlist_new_parttable(ls, "minix", MBR_PT_OFFSET);
	for (i = 0, p = mbr_get_partition(data, 0);
			i < MINIX_MAXPARTITIONS; i++, p++) {

		uint32_t start, size;
		blkid_partition par;

		if (p->sys_ind != MBR_MINIX_PARTITION)
			continue;

		start = dos_partition_get_start(p);
		size = dos_partition_get_size(p);

		if (parent && !blkid_is_nested_dimension(parent, start, size))
			continue;

		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, p->sys_ind);
		blkid_partition_set_flags(par, p->boot_ind);
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}

/* same as DOS */
static const struct blkid_idinfo minix_pt_idinfo =
{
	.name           = "minix",
	.probefunc      = probe_minix_pt,
	.magics         =
	{
		{ .magic = "\x55\xAA", .len = 2, .sboff = 510 },
		{ NULL }
	}
};


#endif /* CONFIG_FEATURE_LIBBLKID */

#if defined(CONFIG_FEATURE_BSD_LABEL) && defined(CONFIG_FEATURE_LIBBLKID)
/* BSD/OSF partition parsing code
 *
 * Inspired by fdisk, partx, Linux kernel, libparted and openbsd header files. */

/* Returns 'blkid_idmag' in 512-sectors */
#define BLKID_MAG_SECTOR(_mag)  (((_mag)->kboff / 2)  + ((_mag)->sboff >> 9))

/* Returns 'blkid_idmag' in bytes */
#define BLKID_MAG_OFFSET(_mag)  ((_mag)->kboff << 10) + ((_mag)->sboff)

/* Returns 'blkid_idmag' offset in bytes within the last sector */
#define BLKID_MAG_LASTOFFSET(_mag) \
		 (BLKID_MAG_OFFSET(_mag) - (BLKID_MAG_SECTOR(_mag) << 9))

static int probe_bsd_pt(blkid_probe pr, const struct blkid_idmag *mag)
{
	struct bsd_disklabel *l;
	struct bsd_partition *p;
	const char *name = "bsd" ;
	blkid_parttable tab = NULL;
	blkid_partition parent;
	blkid_partlist ls;
	int i, nparts = BSD_MAXPARTITIONS;
	unsigned char *data;
	int rc = BLKID_PROBE_NONE;
	uint32_t abs_offset = 0;

	if (blkid_partitions_need_typeonly(pr))
		/* caller does not ask for details about partitions */
		return rc;

	data = blkid_probe_get_sector(pr, BLKID_MAG_SECTOR(mag));
	if (!data) {
		if (errno)
			rc = -errno;
		goto nothing;
	}

	l = (struct bsd_disklabel *) data + BLKID_MAG_LASTOFFSET(mag);

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	/* try to determine the real type of BSD system according to
	 * (parental) primary partition */
	parent = blkid_partlist_get_parent(ls);
	if (parent) {
		switch(blkid_partition_get_type(parent)) {
		case MBR_FREEBSD_PARTITION:
			name = "freebsd";
			abs_offset = blkid_partition_get_start(parent);
			break;
		case MBR_NETBSD_PARTITION:
			name = "netbsd";
			break;
		case MBR_OPENBSD_PARTITION:
			name = "openbsd";
			break;
		default:
			break;
		}
	}

	tab = blkid_partlist_new_parttable(ls, name, BLKID_MAG_OFFSET(mag));
	if (le16_to_cpu(l->d_npartitions) < BSD_MAXPARTITIONS)
		nparts = le16_to_cpu(l->d_npartitions);

	for (i = 0, p = l->d_partitions; i < nparts; i++, p++) {
		blkid_partition par;
		uint32_t start, size;

		if (p->p_fstype == BSD_FS_UNUSED)
			continue;

		start = le32_to_cpu(p->p_offset);
		size = le32_to_cpu(p->p_size);

		/* FreeBSD since version 10 uses relative offsets. We can use
		 * 3rd partition (special wholedisk partition) to detect this
		 * situation. */
		if (abs_offset && nparts >= 3
		    && le32_to_cpu(l->d_partitions[2].p_offset) == 0)
			start += abs_offset;

		if (parent && blkid_partition_get_start(parent) == start
			   && blkid_partition_get_size(parent) == size)
			continue;
		if (parent && !blkid_is_nested_dimension(parent, start, size))
			continue;

		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, p->p_fstype);
	}

	return BLKID_PROBE_OK;

nothing:
	return rc;
}


/* All BSD variants use the same magic string (little-endian),
 * and the same disklabel.
 *
 * The difference between {Free,Open,...}BSD is in the (parental)
 * primary partition type.
 *
 * See also: http://en.wikipedia.org/wiki/BSD_disklabel
 *
 * The location of BSD disk label is architecture specific and in defined by
 * LABELSECTOR and LABELOFFSET macros in the disklabel.h file. The location
 * also depends on BSD variant, FreeBSD uses only one location, NetBSD and
 * OpenBSD are more creative...
 *
 * The basic overview:
 *
 * arch                    | LABELSECTOR | LABELOFFSET
 * ------------------------+-------------+------------
 * amd64 arm hppa hppa64   |             |
 * i386, macppc, mvmeppc   |      1      |      0
 * sgi, aviion, sh, socppc |             |
 * ------------------------+-------------+------------
 * alpha luna88k mac68k    |      0      |     64
 * sparc(OpenBSD) vax      |             |
 * ------------------------+-------------+------------
 * sparc64 sparc(NetBSD)   |      0      |    128
 * ------------------------+-------------+------------
 *
 * ...and more (see http://fxr.watson.org/fxr/ident?v=NETBSD;i=LABELSECTOR) */
static const struct blkid_idinfo bsd_pt_idinfo =
{
	.name           = "bsd",
	.probefunc      = probe_bsd_pt,
	.magics         =
	{
		{ .magic = "\x57\x45\x56\x82", .len = 4, .sboff = 512 },
		{ .magic = "\x57\x45\x56\x82", .len = 4, .sboff = 64 },
		{ .magic = "\x57\x45\x56\x82", .len = 4, .sboff = 128 },
		{ NULL }
	}
};
#endif /* defined(CONFIG_FEATURE_BSD_LABEL) && defined(CONFIG_FEATURE_LIBBLKID) */

#ifdef CONFIG_FEATURE_LIBBLKID

/* Sets partition 'type' for PT where the type is defined by UUIDrather
 * than by number */
static inline void blkid_partition_set_type_uuid(blkid_partition par, const unsigned char *uuid)
{
	blkid_unparse_uuid(uuid, par->typestr, sizeof(par->typestr));
}

/* partitions - partition tables parsing */

/* Partitions probing
 *
 * This chain supports binary and NAME=value interfaces, but complete PT
 * description is provided by binary interface only. The libblkid prober is
 * compatible with kernel partition tables parser. The parser does not return
 * empty (size=0) partitions or special hidden partitions. */

/* Chain driver function */
static int partitions_probe(blkid_probe pr, struct blkid_chain *chn);
static void partitions_free_data(blkid_probe pr, void *data);

static int probe_dos_pt(blkid_probe pr, const struct blkid_idmag *mag __attribute__((__unused__)));

static const struct blkid_idinfo dos_pt_idinfo =
{
	.name           = "dos",
	.probefunc      = probe_dos_pt,
	.magics         =
	{
		/* DOS master boot sector:
		 *
		 *     0 | Code Area
		 *   440 | Optional Disk signature
		 *   446 | Partition table
		 *   510 | 0x55
		 *   511 | 0xAA */
		{ .magic = "\x55\xAA", .len = 2, .sboff = 510 },
		{ NULL }
	}
};

#ifdef CONFIG_FEATURE_GPT_LABEL
static int blkid_partition_set_utf8name(blkid_partition par, const unsigned char *name,
		size_t len, int enc)
{
	if (!par)
		return -1;

	blkid_encode_to_utf8(enc, par->name, sizeof(par->name), name, len);
	rtrim_whitespace(par->name);
	return 0;
}

static int blkid_partition_set_uuid(blkid_partition par, const unsigned char *uuid)
{
	if (!par)
		return -1;

	blkid_unparse_uuid(uuid, par->uuid, sizeof(par->uuid));
	return 0;
}

/* UUID is traditionally 16 byte big-endian array, except Intel EFI
 * specification where the UUID is a structure of little-endian fields. */
static void swap_efi_guid(efi_guid_t *uid)
{
	uid->time_low = swab32(uid->time_low);
	uid->time_mid = swab16(uid->time_mid);
	uid->time_hi_and_version = swab16(uid->time_hi_and_version);
}

static int probe_gpt_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	uint64_t lastlba = 0, lba;
	struct gpt_header_blkid hdr, *h;
	struct gpt_entry_blkid *e;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	uint64_t fu, lu;
	uint32_t ssf, i;
	efi_guid_t guid;
	int ret;

	if (last_lba(pr, &lastlba))
		goto nothing;

	ret = is_pmbr_valid(pr, NULL);
	if (ret < 0)
		return ret;
	else if (ret == 0)
		goto nothing;

	errno = 0;
	h = get_gpt_header(pr, &hdr, &e, (lba = GPT_PRIMARY_LBA), lastlba);
	if (!h && !errno)
		h = get_gpt_header(pr, &hdr, &e, (lba = lastlba), lastlba);

	if (!h) {
		if (errno)
			return -errno;
		goto nothing;
	}

	blkid_probe_use_wiper(pr, lba * blkid_probe_get_size(pr), 8);

	if (blkid_probe_set_magic(pr, blkid_probe_get_sectorsize(pr) * lba,
			      sizeof(GPT_HEADER_SIGNATURE_STR) - 1,
			      (unsigned char *) GPT_HEADER_SIGNATURE_STR))
		goto err;

	guid = h->disk_guid;
	swap_efi_guid(&guid);

	if (blkid_partitions_need_typeonly(pr)) {
		/* Non-binary interface -- caller does not ask for details
		 * about partitions, just set generic variables only. */
		blkid_partitions_set_ptuuid(pr, (unsigned char *) &guid);
		return BLKID_PROBE_OK;
	}

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	tab = blkid_partlist_new_parttable(ls, "gpt",
				blkid_probe_get_sectorsize(pr) * lba);
	blkid_parttable_set_uuid(tab, (const unsigned char *) &guid);

	ssf = blkid_probe_get_sectorsize(pr) / 512;

	fu = le64_to_cpu(h->first_usable_lba);
	lu = le64_to_cpu(h->last_usable_lba);

	for (i = 0; i < le32_to_cpu(h->num_partition_entries); i++, e++) {

		blkid_partition par;
		uint64_t start = le64_to_cpu(e->starting_lba);
		uint64_t size = le64_to_cpu(e->ending_lba) -
					le64_to_cpu(e->starting_lba) + 1ULL;

		/* 00000000-0000-0000-0000-000000000000 entry */
		if (!guidcmp(e->partition_type_guid, GPT_UNUSED_ENTRY_GUID)) {
			blkid_partlist_increment_partno(ls);
			continue;
		}
		/* the partition has to inside usable range */
		if (start < fu || start + size - 1 > lu) {
			blkid_partlist_increment_partno(ls);
			continue;
		}

		par = blkid_partlist_add_partition(ls, tab,
					start * ssf, size * ssf);
		blkid_partition_set_utf8name(par,
			(unsigned char *) e->partition_name,
			sizeof(e->partition_name), BLKID_ENC_UTF16LE);

		guid = e->unique_partition_guid;
		swap_efi_guid(&guid);
		blkid_partition_set_uuid(par, (const unsigned char *) &guid);

		guid = e->partition_type_guid;
		swap_efi_guid(&guid);
		blkid_partition_set_type_uuid(par, (const unsigned char *) &guid);

		blkid_partition_set_flags(par, le64_to_cpu(e->attributes));
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;

err:
	return -ENOMEM;
}

static const struct blkid_idinfo gpt_pt_idinfo =
{
	.name           = "gpt",
	.probefunc      = probe_gpt_pt,
	.minsz          = 1024 * 1440 + 1,      /* ignore floppies */

	/* It would be possible to check for DOS signature (0xAA55), but
	 * unfortunately almost all EFI GPT implementations allow to optionally
	 * skip the legacy MBR. We follows this behavior and MBR is optional.
	 * See is_valid_pmbr().
	 *
	 * It means we have to always call probe_gpt_pt(). */
	.magics         = BLKID_NONE_MAGIC
};
#endif /* CONFIG_FEATURE_GPT_LABEL */

/* Partitions chain probing functions */
static const struct blkid_idinfo * const idinfos_all[] =
{
	&aix_pt_idinfo,
#ifdef CONFIG_FEATURE_SGI_LABEL
	&sgi_pt_idinfo,
#endif
#ifdef CONFIG_FEATURE_SUN_LABEL
	&sun_pt_idinfo,
#endif
	&dos_pt_idinfo,
#ifdef CONFIG_FEATURE_GPT_LABEL
	&gpt_pt_idinfo,
#endif
	&pmbr_pt_idinfo,        /* always after GPT */
	&mac_pt_idinfo,
	&ultrix_pt_idinfo,
#ifdef CONFIG_FEATURE_BSD_LABEL
	&bsd_pt_idinfo,
#endif
	&unixware_pt_idinfo,
	&solaris_x86_pt_idinfo,
	&minix_pt_idinfo,
	&atari_pt_idinfo
};

/* Driver definition */
static const struct blkid_chaindrv partitions_drv = {
	.id           = BLKID_CHAIN_PARTS,
	.name         = "partitions",
	.dflt_enabled = FALSE,
	.idinfos      = idinfos_all,
	.nidinfos     = ARRAY_SIZE(idinfos_all),
	.has_fltr     = TRUE,
	.probe        = partitions_probe,
	.safeprobe    = partitions_probe,
	.free_data    = partitions_free_data
};

/* Driver definition */
static const struct blkid_chaindrv topology_drv = {
	.id           = BLKID_CHAIN_TOPLGY,
	.name         = "topology",
	.dflt_enabled = FALSE,
	.idinfos      = idinfos_tplg,
	.nidinfos     = ARRAY_SIZE(idinfos_tplg),
	.probe        = topology_probe,
	.safeprobe    = topology_probe,
	.free_data    = topology_free
};

/* Driver definition */
static const struct blkid_chaindrv superblocks_drv = {
	.id           = BLKID_CHAIN_SUBLKS,
	.name         = "superblocks",
	.dflt_enabled = TRUE,
	.dflt_flags   = BLKID_SUBLKS_DEFAULT,
	.idinfos      = idinfos_sb,
	.nidinfos     = ARRAY_SIZE(idinfos_sb),
	.has_fltr     = TRUE,
	.probe        = superblocks_probe,
	.safeprobe    = superblocks_safeprobe,
};

static const struct blkid_chaindrv * const chains_drvs[] = {
	[BLKID_CHAIN_SUBLKS] = &superblocks_drv,
	[BLKID_CHAIN_TOPLGY] = &topology_drv,
	[BLKID_CHAIN_PARTS] = &partitions_drv
};

static int blkid_partitions_probe_partition(blkid_probe pr);

static void blkid_probe_set_partlist(blkid_probe pr, blkid_partlist ls)
{
	pr->chains[BLKID_CHAIN_PARTS].data = ls;
}


static void unref_parttable(blkid_parttable tab)
{
	tab->nparts--;

	if (tab->nparts <= 0) {
		list_del(&tab->t_tabs);
		free(tab);
	}
}

/* free all allocated parttables */
static void free_parttables(blkid_partlist ls)
{
	if (!ls || !ls->l_tabs.next)
		return;

	/* remove unassigned partition tables */
	while (!list_empty(&ls->l_tabs)) {
		blkid_parttable tab = list_entry(ls->l_tabs.next,
					struct blkid_struct_parttable, t_tabs);
		unref_parttable(tab);
	}
}

static void reset_partlist(blkid_partlist ls)
{
	if (!ls)
		return;

	free_parttables(ls);

	if (ls->next_partno) {
		/* already initialized - reset */
		int tmp_nparts = ls->nparts_max;
		blkid_partition tmp_parts = ls->parts;

		memset(ls, 0, sizeof(struct blkid_struct_partlist));

		ls->nparts_max = tmp_nparts;
		ls->parts = tmp_parts;
	}

	ls->nparts = 0;
	ls->next_partno = 1;
	INIT_LIST_HEAD(&ls->l_tabs);
}

static blkid_partlist partitions_init_data(struct blkid_chain *chn)
{
	blkid_partlist ls;

	if (chn->data)
		ls = (blkid_partlist) chn->data;
	else {
		/* allocate the new list of partitions */
		ls = zmalloc(sizeof(struct blkid_struct_partlist));
		chn->data = (void *) ls;
	}

	reset_partlist(ls);

	return ls;
}

static void partitions_free_data(blkid_probe pr __attribute__((__unused__)),
				 void *data)
{
	blkid_partlist ls = (blkid_partlist) data;

	if (!ls)
		return;

	free_parttables(ls);

	/* deallocate partitions and partlist */
	free(ls->parts);
	free(ls);
}

/* allows to modify used partitions numbers (for example for logical partitions) */
static inline void blkid_partlist_set_partno(blkid_partlist ls, int partno)
{
	ls->next_partno = partno;
}

/* allows to set "parent" for the next nested partition */
static int blkid_partlist_set_parent(blkid_partlist ls, blkid_partition par)
{
	if (!ls)
		return -1;
	ls->next_parent = par;
	return 0;
}



static int idinfo_probe(blkid_probe pr, const struct blkid_idinfo *id,
			struct blkid_chain *chn)
{
	const struct blkid_idmag *mag = NULL;
	uint64_t off;
	int rc = BLKID_PROBE_NONE;              /* default is nothing */

	if (pr->size <= 0 || (id->minsz && (unsigned)id->minsz > pr->size))
		goto nothing;   /* the device is too small */
	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		goto nothing;

	rc = blkid_probe_get_idmag(pr, id, &off, &mag);
	if (rc != BLKID_PROBE_OK)
		goto nothing;

	/* final check by probing function */
	if (id->probefunc) {
		rc = id->probefunc(pr, mag);
		if (rc < 0) {
			/* reset after error */
			reset_partlist(blkid_probe_get_partlist(pr));
			if (chn && !chn->binary)
				blkid_probe_chain_reset_values(pr, chn);
		}
		if (rc == BLKID_PROBE_OK && mag && chn && !chn->binary)
			rc = blkid_probe_set_magic(pr, off, mag->len,
					(const unsigned char *) mag->magic);
	}

	return rc;

nothing:
	return BLKID_PROBE_NONE;
}

/* The blkid_do_probe() backend. */
static int partitions_probe(blkid_probe pr, struct blkid_chain *chn)
{
	int rc = BLKID_PROBE_NONE;
	size_t i;

	if (!pr || chn->idx < -1)
		return -EINVAL;

	blkid_probe_chain_reset_values(pr, chn);

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return BLKID_PROBE_NONE;

	if (chn->binary)
		partitions_init_data(chn);

	if (!pr->wipe_size && (pr->prob_flags & BLKID_PROBE_FL_IGNORE_PT))
		goto details_only;

	i = chn->idx < 0 ? 0 : chn->idx + 1U;

	for ( ; i < ARRAY_SIZE(idinfos_all); i++) {
		const char *name;

		chn->idx = i;

		/* apply filter */
		if (chn->fltr && blkid_bmp_get_item(chn->fltr, i))
			continue;

		/* apply checks from idinfo */
		rc = idinfo_probe(pr, idinfos_all[i], chn);
		if (rc < 0)
			break;
		if (rc != BLKID_PROBE_OK)
			continue;

		name = idinfos_all[i]->name;

		if (!chn->binary)
			/* Non-binary interface, set generic variables. Note
			 * that the another variables could be set in prober
			 * functions. */
			blkid_probe_set_value(pr, "PTTYPE", (const unsigned char *) name, strlen(name) + 1);

		rc = BLKID_PROBE_OK;
		break;
	}

details_only:
	/* Gather PART_ENTRY_* values if the current device is a partition. */
	if ((rc == BLKID_PROBE_OK || rc == BLKID_PROBE_NONE) && !chn->binary &&
	    (blkid_partitions_get_flags(pr) & BLKID_PARTS_ENTRY_DETAILS)) {

		int xrc = blkid_partitions_probe_partition(pr);

		/* partition entry probing is optional, and "not-found" from
		 * this sub-probing must not to overwrite previous success. */
		if (xrc < 0)
			rc = xrc;                       /* always propagate errors */
		else if (rc == BLKID_PROBE_NONE)
			rc = xrc;
	}

	return rc;
}

/* Probe for nested partition table within the parental partition */
static int blkid_partitions_do_subprobe(blkid_probe pr, blkid_partition parent,
		const struct blkid_idinfo *id)
{
	blkid_probe prc;
	int rc;
	blkid_partlist ls;
	uint64_t sz, off;

	if (!pr || !parent || !parent->size)
		return -EINVAL;
	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		return BLKID_PROBE_NONE;

	/* range defined by parent */
	sz = parent->size << 9;
	off = parent->start << 9;

	if (off < pr->off || pr->off + pr->size < off + sz)
		return -ENOSPC;

	/* create private prober */
	prc = blkid_clone_probe(pr);
	blkid_probe_set_dimension(prc, off, sz);

	/* clone is always with reset chain, fix it */
	prc->cur_chain = blkid_probe_get_chain(pr);

	/* Set 'parent' to the current list of the partitions and use the list
	 * in cloned prober (so the cloned prober will extend the current list
	 * of partitions rather than create a new). */
	ls = blkid_probe_get_partlist(pr);
	blkid_partlist_set_parent(ls, parent);

	blkid_probe_set_partlist(prc, ls);

	rc = idinfo_probe(prc, id, blkid_probe_get_chain(pr));

	blkid_probe_set_partlist(prc, NULL);
	blkid_partlist_set_parent(ls, NULL);

	blkid_free_probe(prc);  /* free cloned prober */

	return rc;
}

/* This function is same as call open(filename), blkid_new_probe() and
 * blkid_probe_set_device(pr, fd, 0, 0).
 *
 * The @filename is closed by blkid_free_probe() or by the
 * blkid_probe_set_device() call.
 *
 * Returns: a pointer to the newly allocated probe struct or NULL in case of
 * error. */
static blkid_probe blkid_new_probe_from_filename(const char *filename)
{
	int fd;
	blkid_probe pr = NULL;

	fd = open(filename, O_RDONLY|O_CLOEXEC);
	if (fd < 0)
		return NULL;

	pr = blkid_new_probe();
	if (blkid_probe_set_device(pr, fd, 0, 0))
		goto err;

	pr->flags |= BLKID_FL_PRIVATE_FD;
	return pr;
err:
	if (fd >= 0)
		close(fd);
	blkid_free_probe(pr);
	return NULL;
}

static blkid_probe blkid_probe_get_wholedisk_probe(blkid_probe pr)
{
	dev_t disk;

	if (blkid_probe_is_wholedisk(pr))
		return NULL;                    /* this is not partition */

	if (pr->parent)
		/* this is cloned blkid_probe, use parent's stuff */
		return blkid_probe_get_wholedisk_probe(pr->parent);

	disk = blkid_probe_get_wholedisk_devno(pr);

	if (pr->disk_probe && pr->disk_probe->devno != disk) {
		/* we have disk prober, but for another disk... close it */
		blkid_free_probe(pr->disk_probe);
		pr->disk_probe = NULL;
	}

	if (!pr->disk_probe) {
		/* Open a new disk prober */
		char *disk_path = blkid_devno_to_devname(disk);

		if (!disk_path)
			return NULL;

		pr->disk_probe = blkid_new_probe_from_filename(disk_path);

		free(disk_path);

		if (!pr->disk_probe)
			return NULL;    /* ENOMEM? */
	}

	return pr->disk_probe;
}

/* Returns: partition UUID string if supported by PT (e.g. GPT) or NULL. */
static inline const char *blkid_partition_get_uuid(blkid_partition par)
{
	return *par->uuid ? par->uuid : NULL;
}

/* The "parttable" describes partition table. The table is usually the same for
 * all partitions -- except nested partition tables.
 *
 * The library does not to use a separate partition table object for dos logical
 * partitions (partitions within extended partition). It's possible to
 * differentiate between logical, extended and primary partitions by
 *
 *      blkid_partition_is_{extended,primary,logical}().
 *
 * Returns: partition table object or NULL in case of error. */
static inline blkid_parttable blkid_partition_get_table(blkid_partition par)
{
	return par->tab;
}

/* Returns: partition name string if supported by PT (e.g. Mac) or NULL. */
static inline const char *blkid_partition_get_name(blkid_partition par)
{
	return *par->name ? (char *) par->name : NULL;
}

/* Returns: proposed partition number (e.g. 'N' from sda'N') or -1 in case of
 * error. Note that the number is generate by library independently on your OS. */
static inline int blkid_partition_get_partno(blkid_partition par)
{
	return par->partno;
}

/* Returns: partition flags (or attributes for gpt). */
static inline unsigned long long blkid_partition_get_flags(blkid_partition par)
{
	return par->flags;
}

/* Returns: partition table type (type name, e.g. "dos", "gpt", ...) */
static inline const char *blkid_parttable_get_type(blkid_parttable tab)
{
	return tab->type;
}

/* The type string is supported by a small subset of partition tables (e.g Mac
 * and EFI GPT).  Note that GPT uses type UUID and this function returns this
 * UUID as string.
 *
 * Returns: partition type string or NULL. */
static inline const char *blkid_partition_get_type_string(blkid_partition par)
{
	return *par->typestr ? par->typestr : NULL;
}

static int partition_get_logical_type(blkid_partition par)
{
	blkid_parttable tab;

	if (!par)
		return -1;

	tab = blkid_partition_get_table(par);
	if (!tab || !tab->type)
		return -1;

	if (tab->parent)
		return 'L';  /* report nested partitions as logical */

	if (!strcmp(tab->type, "dos")) {
		if (par->partno > 4)
			return 'L';     /* logical */

		if(par->type == MBR_DOS_EXTENDED_PARTITION ||
		   par->type == MBR_W95_EXTENDED_PARTITION ||
		   par->type == MBR_LINUX_EXTENDED_PARTITION)
			return 'E';
	}
	return 'P';
}


/* Returns: 1 if the partitions is extended (dos, windows or linux)
 * partition or 0 if not. */
static int blkid_partition_is_extended(blkid_partition par)
{
	return partition_get_logical_type(par) == 'E' ? TRUE : FALSE;
}

/* This function tries to get start and size for @devno from sysfs and
 * returns a partition from @ls which matches with the values from sysfs.
 *
 * This function is necessary when you want to make a relation between an entry
 * in the partition table (@ls) and block devices in your system.
 *
 * Returns: partition object or NULL in case or error. */
static blkid_partition blkid_partlist_devno_to_partition(blkid_partlist ls, dev_t devno)
{
	struct path_cxt *pc;
	uint64_t start, size;
	int i, rc, partno = 0;

	pc = ul_new_sysfs_path(devno, NULL, NULL);
	if (!pc)
		return NULL;
	rc = ul_path_read_u64(pc, &size, "size");
	if (!rc) {
		rc = ul_path_read_u64(pc, &start, "start");
		if (rc) {
			/* try to get partition number from DM uuid. */
			char *uuid = NULL, *tmp, *prefix;

			ul_path_read_string(pc, &uuid, "dm/uuid");
			tmp = uuid;
			prefix = uuid ? strsep(&tmp, "-") : NULL;

			if (prefix && strncasecmp(prefix, "part", 4) == 0) {
				char *end = NULL;

				partno = strtol(prefix + 4, &end, 10);
				if (prefix == end || (end && *end))
					partno = 0;
				else
					rc = 0;         /* success */
			}
			free(uuid);
		}
	}

	ul_unref_path(pc);

	if (rc)
		return NULL;

	if (partno) {
		/* Partition mapped by kpartx does not provide "start" offset
		 * in /sys, but if we know partno and size of the partition
		 * that we can probably make the relation between the device
		 * and an entry in partition table. */
		 for (i = 0; i < ls->nparts; i++) {
			 blkid_partition par = &ls->parts[i];

			 if (partno != blkid_partition_get_partno(par))
				 continue;

			 if (size == (uint64_t)blkid_partition_get_size(par) ||
			     (blkid_partition_is_extended(par) && size <= 1024ULL))
				 return par;

		 }
		 return NULL;
	}

	for (i = 0; i < ls->nparts; i++) {
		blkid_partition par = &ls->parts[i];

		if ((uint64_t)blkid_partition_get_start(par) == start &&
		    (uint64_t)blkid_partition_get_size(par) == size)
			return par;

		/* exception for extended dos partitions */
		if ((uint64_t)blkid_partition_get_start(par) == start &&
		    blkid_partition_is_extended(par) && size <= 1024ULL)
			return par;

	}

	return NULL;
}

static int blkid_partitions_probe_partition(blkid_probe pr)
{
	blkid_probe disk_pr = NULL;
	blkid_partlist ls;
	blkid_partition par;
	dev_t devno;

	if (pr->flags & BLKID_FL_NOSCAN_DEV)
		goto nothing;

	devno = blkid_probe_get_devno(pr);
	if (!devno)
		goto nothing;

	disk_pr = blkid_probe_get_wholedisk_probe(pr);
	if (!disk_pr)
		goto nothing;

	/* parse PT */
	ls = blkid_probe_get_partitions(disk_pr);
	if (!ls)
		goto nothing;

	par = blkid_partlist_devno_to_partition(ls, devno);
	if (!par)
		goto nothing;
	else {
		const char *v;
		blkid_parttable tab = blkid_partition_get_table(par);
		dev_t disk = blkid_probe_get_devno(disk_pr);

		if (tab) {
			v = blkid_parttable_get_type(tab);
			if (v)
				blkid_probe_set_value(pr, "PART_ENTRY_SCHEME", (const unsigned char *) v, strlen(v) + 1);
		}

		v = blkid_partition_get_name(par);
		if (v)
			blkid_probe_set_value(pr, "PART_ENTRY_NAME", (const unsigned char *) v, strlen(v) + 1);

		v = blkid_partition_get_uuid(par);
		if (v)
			blkid_probe_set_value(pr, "PART_ENTRY_UUID", (const unsigned char *) v, strlen(v) + 1);

		/* type */
		v = blkid_partition_get_type_string(par);
		if (v)
			blkid_probe_set_value(pr, "PART_ENTRY_TYPE", (const unsigned char *) v, strlen(v) + 1);
		else
			blkid_probe_sprintf_value(pr, "PART_ENTRY_TYPE",
				"0x%x", blkid_partition_get_type(par));

		if (blkid_partition_get_flags(par))
			blkid_probe_sprintf_value(pr, "PART_ENTRY_FLAGS",
				"0x%llx", blkid_partition_get_flags(par));

		blkid_probe_sprintf_value(pr, "PART_ENTRY_NUMBER",
				"%d", blkid_partition_get_partno(par));

		blkid_probe_sprintf_value(pr, "PART_ENTRY_OFFSET", "%jd",
				(intmax_t)blkid_partition_get_start(par));
		blkid_probe_sprintf_value(pr, "PART_ENTRY_SIZE", "%jd",
				(intmax_t)blkid_partition_get_size(par));

		blkid_probe_sprintf_value(pr, "PART_ENTRY_DISK", "%u:%u",
				major(disk), minor(disk));
	}

	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;


}

static int blkid_parttable_set_id(blkid_parttable tab, const unsigned char *id)
{
	if (!tab)
		return -1;

	safe_strncpy(tab->id, (const char *) id, sizeof(tab->id));
	return 0;
}


/* set PTUUID variable for non-binary API for tables where
 * the ID is just a string */
static void blkid_partitions_strcpy_ptuuid(blkid_probe pr, char *str)
{
	struct blkid_chain *chn = blkid_probe_get_chain(pr);

	if (chn->binary || !str || !*str)
		return;

	blkid_probe_set_value(pr, "PTUUID", (unsigned char *) str, strlen(str) + 1);
}


/* Note that this function returns TRUE for all partitions in all
 * nested partition tables (e.g. BSD labels).
 *
 * Returns: 1 if the partitions is logical partition or 0 if not. */
static int blkid_partition_is_logical(blkid_partition par)
{
	return partition_get_logical_type(par) == 'L' ? TRUE : FALSE;
}

static int blkid_partition_gen_uuid(blkid_partition par)
{
	if (!par || !par->tab || !*par->tab->id)
		return -1;

	snprintf(par->uuid, sizeof(par->uuid), "%.33s-%02x",
			par->tab->id, par->partno);
	return 0;
}



/* MS-DOS partition parsing code
 *
 * Inspired by fdisk, partx, Linux kernel and libparted. */

static const struct dos_subtypes {
	unsigned char type;
	const struct blkid_idinfo *id;
} dos_nested[] = {
#ifdef CONFIG_FEATURE_BSD_LABEL
	{ MBR_FREEBSD_PARTITION, &bsd_pt_idinfo },
	{ MBR_NETBSD_PARTITION, &bsd_pt_idinfo },
	{ MBR_OPENBSD_PARTITION, &bsd_pt_idinfo },
#endif
	{ MBR_UNIXWARE_PARTITION, &unixware_pt_idinfo },
	{ MBR_SOLARIS_X86_PARTITION, &solaris_x86_pt_idinfo },
	{ MBR_MINIX_PARTITION, &minix_pt_idinfo }
};

static inline int is_extended(struct dos_partition *p)
{
	return (p->sys_ind == MBR_DOS_EXTENDED_PARTITION ||
		p->sys_ind == MBR_W95_EXTENDED_PARTITION ||
		p->sys_ind == MBR_LINUX_EXTENDED_PARTITION);
}

static int parse_dos_extended(blkid_probe pr, blkid_parttable tab,
		uint32_t ex_start, uint32_t ex_size, int ssf)
{
	blkid_partlist ls = blkid_probe_get_partlist(pr);
	uint32_t cur_start = ex_start, cur_size = ex_size;
	unsigned char *data;
	int ct_nodata = 0;      /* count ext.partitions without data partitions */
	int i;

	if (ex_start == 0)
		return 0;

	while (1) {
		struct dos_partition *p, *p0;
		uint32_t start, size;

		if (++ct_nodata > 100)
			return BLKID_PROBE_OK;
		data = blkid_probe_get_sector(pr, cur_start);
		if (!data) {
			if (errno)
				return -errno;
			goto leave;     /* malformed partition? */
		}

		if (!mbr_is_valid_magic(data))
			goto leave;

		p0 = mbr_get_partition(data, 0);

		/* Usually, the first entry is the real data partition,
		 * the 2nd entry is the next extended partition, or empty,
		 * and the 3rd and 4th entries are unused.
		 * However, DRDOS sometimes has the extended partition as
		 * the first entry (when the data partition is empty),
		 * and OS/2 seems to use all four entries.
		 * -- Linux kernel fs/partitions/dos.c
		 *
		 * See also http://en.wikipedia.org/wiki/Extended_boot_record */

		/* Parse data partition */
		for (p = p0, i = 0; i < 4; i++, p++) {
			uint32_t abs_start;
			blkid_partition par;

			/* the start is relative to the parental ext.partition */
			start = dos_partition_get_start(p) * ssf;
			size = dos_partition_get_size(p) * ssf;
			abs_start = cur_start + start;  /* absolute start */

			if (!size || is_extended(p))
				continue;
			if (i >= 2) {
				/* extra checks to detect real data on
				 * 3rd and 4th entries */
				if (start + size > cur_size)
					continue;
				if (abs_start < ex_start)
					continue;
				if (abs_start + size > ex_start + ex_size)
					continue;
			}

			/* Avoid recursive non-empty links, see ct_nodata counter */
			if (blkid_partlist_get_partition_by_start(ls, abs_start))
				continue;

			par = blkid_partlist_add_partition(ls, tab, abs_start, size);
			blkid_partition_set_type(par, p->sys_ind);
			blkid_partition_set_flags(par, p->boot_ind);
			blkid_partition_gen_uuid(par);
			ct_nodata = 0;
		}
		/* The first nested ext.partition should be a link to the next
		 * logical partition. Everything other (recursive ext.partitions)
		 * is junk. */
		for (p = p0, i = 0; i < 4; i++, p++) {
			start = dos_partition_get_start(p) * ssf;
			size = dos_partition_get_size(p) * ssf;

			if (size && is_extended(p)) {
				if (start != 0)
					break;
			}
		}
		if (i == 4)
			goto leave;

		cur_start = ex_start + start;
		cur_size = size;
	}
leave:
	return BLKID_PROBE_OK;
}

static inline int is_lvm(blkid_probe pr)
{
	struct blkid_prval *v = __blkid_probe_lookup_value(pr, "TYPE");

	return (v && v->data && strcmp((char *) v->data, "LVM2_member") == 0);
}

static inline int is_empty_mbr(unsigned char *mbr)
{
	struct dos_partition *p = mbr_get_partition(mbr, 0);
	int i, nparts = 0;

	for (i = 0; i < 4; i++) {
		if (dos_partition_get_size(p) > 0)
			nparts++;
		p++;
	}

	return nparts == 0;
}

/* This function is used by MBR partition table parser to avoid
 * misinterpretation of FAT filesystem. */
static int blkid_probe_is_vfat(blkid_probe pr)
{
	struct vfat_super_block *vs;
	struct msdos_super_block *ms;
	const struct blkid_idmag *mag = NULL;
	int rc;

	rc = blkid_probe_get_idmag(pr, &vfat_idinfo, NULL, &mag);
	if (rc < 0)
		return rc;      /* error */
	if (rc != BLKID_PROBE_OK || !mag)
		return 0;

	ms = blkid_probe_get_sb(pr, mag, struct msdos_super_block);
	if (!ms)
		return errno ? -errno : 0;
	vs = blkid_probe_get_sb(pr, mag, struct vfat_super_block);
	if (!vs)
		return errno ? -errno : 0;

	return fat_valid_superblock(pr, mag, ms, vs, NULL, NULL);
}

static int probe_dos_pt(blkid_probe pr,
		const struct blkid_idmag *mag __attribute__((__unused__)))
{
	int i;
	int ssf;
	blkid_parttable tab = NULL;
	blkid_partlist ls;
	struct dos_partition *p0, *p;
	unsigned char *data;
	uint32_t start, size, id;
	char idstr[UUID_STR_LEN];


	data = blkid_probe_get_sector(pr, 0);
	if (!data) {
		if (errno)
			return -errno;
		goto nothing;
	}

	/* ignore disks with AIX magic number -- for more details see aix.c */
	if (memcmp(data, BLKID_AIX_MAGIC_STRING, BLKID_AIX_MAGIC_STRLEN) == 0)
		goto nothing;

	p0 = mbr_get_partition(data, 0);

	/* Reject PT where boot indicator is not 0 or 0x80. */
	for (p = p0, i = 0; i < 4; i++, p++)
		if (p->boot_ind != 0 && p->boot_ind != 0x80)
			goto nothing;

	/* GPT uses valid MBR */
	for (p = p0, i = 0; i < 4; i++, p++) {
		if (p->sys_ind == MBR_GPT_PARTITION)
			goto nothing;
	}

	/* Now that the 55aa signature is present, this is probably
	 * either the boot sector of a FAT filesystem or a DOS-type
	 * partition table. */
	if (blkid_probe_is_vfat(pr) == 1)
		goto nothing;

	/* Ugly exception, if the device contains a valid LVM physical volume
	 * and empty MBR (=no partition defined) then it's LVM and MBR should
	 * be ignored. Crazy people use it to boot from LVM devices. */
	if (is_lvm(pr) && is_empty_mbr(data))
		goto nothing;

	blkid_probe_use_wiper(pr, MBR_PT_OFFSET, 512 - MBR_PT_OFFSET);

	id = mbr_get_id(data);
	if (id)
		snprintf(idstr, sizeof(idstr), "%08x", id);

	/* Well, all checks pass, it's MS-DOS partition table */
	if (blkid_partitions_need_typeonly(pr)) {
		/* Non-binary interface -- caller does not ask for details
		 * about partitions, just set generic variables only. */
		if (id)
			blkid_partitions_strcpy_ptuuid(pr, idstr);
		return 0;
	}

	ls = blkid_probe_get_partlist(pr);
	if (!ls)
		goto nothing;

	/* sector size factor (the start and size are in the real sectors, but
	 * we need to convert all sizes to 512 logical sectors */
	ssf = blkid_probe_get_sectorsize(pr) / 512;

	/* allocate a new partition table */
	tab = blkid_partlist_new_parttable(ls, "dos", MBR_PT_OFFSET);
	if (id)
		blkid_parttable_set_id(tab, (unsigned char *) idstr);

	/* Parse primary partitions */
	for (p = p0, i = 0; i < 4; i++, p++) {
		blkid_partition par;

		start = dos_partition_get_start(p) * ssf;
		size = dos_partition_get_size(p) * ssf;

		if (!size) {
			/* Linux kernel ignores empty partitions, but partno for
			 * the empty primary partitions is not reused */
			blkid_partlist_increment_partno(ls);
			continue;
		}
		par = blkid_partlist_add_partition(ls, tab, start, size);
		blkid_partition_set_type(par, p->sys_ind);
		blkid_partition_set_flags(par, p->boot_ind);
		blkid_partition_gen_uuid(par);
	}

	/* Linux uses partition numbers greater than 4
	 * for all logical partition and all nested partition tables (bsd, ..) */
	blkid_partlist_set_partno(ls, 5);

	/* Parse logical partitions */
	for (p = p0, i = 0; i < 4; i++, p++) {
		start = dos_partition_get_start(p) * ssf;
		size = dos_partition_get_size(p) * ssf;

		if (!size)
			continue;
		if (is_extended(p) &&
		    parse_dos_extended(pr, tab, start, size, ssf) == -1)
			goto nothing;
	}

	/* Parse subtypes (nested partitions) on large disks */
	if (!blkid_probe_is_tiny(pr)) {
		int nparts = blkid_partlist_numof_partitions(ls);

		for (i = 0; i < nparts; i++) {
			size_t n;
			int type;
			blkid_partition pa = blkid_partlist_get_partition(ls, i);

			if (pa == NULL
			    || blkid_partition_get_size(pa) == 0
			    || blkid_partition_is_extended(pa)
			    || blkid_partition_is_logical(pa))
				continue;

			type = blkid_partition_get_type(pa);

			for (n = 0; n < ARRAY_SIZE(dos_nested); n++) {
				int rc;

				if (dos_nested[n].type != type)
					continue;

				rc = blkid_partitions_do_subprobe(pr, pa,
							dos_nested[n].id);
				if (rc < 0)
					return rc;
				break;
			}
		}
	}
	return BLKID_PROBE_OK;

nothing:
	return BLKID_PROBE_NONE;
}
#endif /* CONFIG_FEATURE_LIBBLKID */

/* The library distinguish between three types of partitioning objects.
 *
 * on-disk data
 *    - disk label specific
 *    - probed and read  by disklabel drivers when assign device to the context
 *      or when switch to another disk label type
 *    - only fdisk_write_disklabel() modify on-disk data
 *
 * in-memory data
 *    - generic data and disklabel specific data stored in struct fdisk_label
 *    - all partitioning operations are based on in-memory data only
 *
 * struct fdisk_partition
 *    - provides abstraction to present partitions to users
 *    - fdisk_partition is possible to gather to fdisk_table container
 *    - used as unified template for new partitions
 *    - the struct fdisk_partition is always completely independent object and
 *      any change to the object has no effect to in-memory (or on-disk) label data */

/* Returns: newly allocated libfdisk handler */
static struct fdisk_context *fdisk_new_context(void)
{
	struct fdisk_context *cxt;

	cxt = zmalloc(sizeof(*cxt));
	cxt->dev_fd = -1;
	cxt->refcount = 1;

	INIT_LIST_HEAD(&cxt->wipes);

	/* Allocate label specific structs.
	 *
	 * This is necessary (for example) to store label specific
	 * context setting. */
#ifdef CONFIG_FEATURE_GPT_LABEL
	cxt->labels[ cxt->nlabels++ ] = fdisk_new_gpt_label(cxt);
#endif
	cxt->labels[ cxt->nlabels++ ] = fdisk_new_dos_label(cxt);
#ifdef CONFIG_FEATURE_BSD_LABEL
	cxt->labels[ cxt->nlabels++ ] = fdisk_new_bsd_label(cxt);
#endif
#ifdef CONFIG_FEATURE_SGI_LABEL
	cxt->labels[ cxt->nlabels++ ] = fdisk_new_sgi_label(cxt);
#endif
#ifdef CONFIG_FEATURE_SUN_LABEL
	cxt->labels[ cxt->nlabels++ ] = fdisk_new_sun_label(cxt);
#endif

	return cxt;
}

/* The regular GPT contains PMBR (dummy protective MBR) where the protective
 * MBR does not address any partitions.
 *
 * Hybrid GPT contains regular MBR where this partition table addresses the
 * same partitions as GPT. It's recommended to not use hybrid GPT due to MBR
 * limits.
 *
 * The libfdisk does not provide functionality to sync GPT and MBR, you have to
 * directly access and modify (P)MBR (see fdisk_new_nested_context()).
 *
 * Returns: 1 if partition table detected as hybrid otherwise return 0 */
#ifdef CONFIG_FEATURE_GPT_LABEL
static inline int fdisk_gpt_is_hybrid(struct fdisk_context *cxt)
{
	return valid_pmbr(cxt) == GPT_MBR_HYBRID;
}
#endif

int fdisk_main(void)
{
	int argc = Gargc;
	char **argv = Gargv;
	int rc, c, act = ACT_FDISK;
	int colormode = UL_COLORMODE_UNDEF;
	struct fdisk_context *cxt;
	char *outarg = NULL;
	enum {
		OPT_BYTES       = CHAR_MAX + 1
	};
#if ENABLE_FEATURE_LONG_OPTIONS
	static const struct option longopts[] = {
		{ "bytes",          no_argument,       NULL, OPT_BYTES },
		{ "color",          optional_argument, NULL, 'L' },
		{ "compatibility",  optional_argument, NULL, 'c' },
		{ "cylinders",      required_argument, NULL, 'C' },
		{ "heads",          required_argument, NULL, 'H' },
		{ "sectors",        required_argument, NULL, 'S' },
#ifdef CONFIG_FEATURE_FDISK_BLKSIZE
		{ "getsz",          no_argument,       NULL, 's' },
#endif
		{ "help",           no_argument,       NULL, 'h' },
		{ "list",           no_argument,       NULL, 'l' },
		{ "sector-size",    required_argument, NULL, 'b' },
		{ "type",           required_argument, NULL, 't' },
		{ "units",          optional_argument, NULL, 'u' },
		{ "version",        no_argument,       NULL, 'V' },
		{ "output",         no_argument,       NULL, 'o' },
		{ "protect-boot",   no_argument,       NULL, 'B' },
		{ "wipe",           required_argument, NULL, 'w' },
		{ "wipe-partitions",required_argument, NULL, 'W' },
		{ NULL, 0, NULL, 0 }
	};
#endif
	pager_argv[0] = "sh";
	pager_argv[1] = "-c";
#if defined(CONFIG_FEATURE_LIBBLKID) || defined(CONFIG_FEATURE_GPT_LABEL)
	crc32_filltable(crc32_tab, 0);
#endif

	cxt = fdisk_new_context();
	if (!cxt)
		bb_perror_msg_and_die("failed to allocate libfdisk context");

	fdisk_set_ask(cxt, ask_callback, NULL);

	while ((c = USE_FEATURE_LONG_OPTIONS(getopt_long)SKIP_FEATURE_LONG_OPTIONS(getopt)
				(argc, argv, "b:Bc::C:hH:lL::o:sS:t:u::vVw:W:"
				USE_FEATURE_LONG_OPTIONS(,longopts, NULL))) != -1)
	{
		switch (c) {
		case 'b':
		{
			size_t sz = strtou32_or_err(optarg, "invalid sector size argument");
			if (sz != 512 && sz != 1024 && sz != 2048 && sz != 4096)
				bb_error_msg_and_die("invalid sector size argument");
			fdisk_save_user_sector_size(cxt, sz, sz);
			break;
		}
		case 'B':
			fdisk_enable_bootbits_protection(cxt, 1);
			break;
		case 'C':
			fdisk_save_user_geometry(cxt,
				strtou32_or_err(optarg, "invalid cylinders argument"),
				0, 0);
			break;
		case 'c':
			if (optarg) {
				/* this setting is independent on the current
				 * actively used label */
				char *p = *optarg == '=' ? optarg + 1 : optarg;
				struct fdisk_label *lb = fdisk_get_label(cxt, "dos");

				if (!lb)
					bb_perror_msg_and_die("not found DOS label driver");
				if (strcmp(p, "dos") == 0)
					fdisk_dos_enable_compatible(lb, TRUE);
				else if (strcmp(p, "nondos") == 0)
					fdisk_dos_enable_compatible(lb, FALSE);
				else
					bb_error_msg_and_die("unknown compatibility mode '%s'", p);
			}
			/* use default if no optarg specified */
			break;
		case 'H':
			fdisk_save_user_geometry(cxt, 0,
				strtou32_or_err(optarg, "invalid heads argument"),
				0);
			break;
		case 'S':
			fdisk_save_user_geometry(cxt, 0, 0,
				strtou32_or_err(optarg, "invalid sectors argument"));
			break;
		case 'l':
			act = ACT_LIST;
			break;
		case 'L':
			colormode = UL_COLORMODE_AUTO;
			if (optarg)
				colormode = colormode_or_err(optarg, "unsupported color mode");
			break;
		case 'o':
			outarg = optarg;
			break;
#ifdef CONFIG_FEATURE_FDISK_BLKSIZE
		case 's':
			act = ACT_SHOWSIZE;
			break;
#endif
		case 't':
		{
			struct fdisk_label *lb = NULL;

			while (fdisk_next_label(cxt, &lb) == 0)
				fdisk_label_set_disabled(lb, 1);

			lb = fdisk_get_label(cxt, optarg);
			if (!lb)
				bb_error_msg_and_die("unsupported disklabel: %s", optarg);
			fdisk_label_set_disabled(lb, 0);
			break;
		}
		case 'u':
			if (optarg && *optarg == '=')
				optarg++;
			if (fdisk_set_unit(cxt, optarg) != 0)
				bb_error_msg_and_die("unsupported unit");
			break;
		case 'V': /* preferred for util-linux */
		case 'v': /* for backward compatibility only */
			printf("%s from %s\n", bb_applet_name, PACKAGE_STRING);
			return EXIT_SUCCESS;
		case 'w':
			wipemode = wipemode_from_string(optarg);
			if (wipemode < 0)
				bb_error_msg_and_die("unsupported wipe mode");
			break;
		case 'W':
			pwipemode = wipemode_from_string(optarg);
			if (pwipemode < 0)
				bb_error_msg_and_die("unsupported wipe mode");
			break;
		case OPT_BYTES:
			fdisk_set_size_unit(cxt, FDISK_SIZEUNIT_BYTES);
			break;
		case 'h':
		default:
			bb_show_usage();
		}
	}

	if (argc-optind != 1 && fdisk_has_user_device_properties(cxt))
		bb_error_msg("The device properties (sector size and geometry) should"
			" be used with one specified device only.");

	colors_init(colormode, "fdisk");
	is_interactive = isatty(STDIN_FILENO);

	switch (act) {
	case ACT_LIST:
		fdisk_enable_listonly(cxt, 1);
		init_fields(cxt, outarg, NULL);

		if (argc > optind) {
			int k;
			int ct = 0;

			for (rc = 0, k = optind; k < argc; k++) {
				if (ct)
				    fputs("\n\n", stdout);

				rc += print_device_pt(cxt, argv[k], 1, 0);
				ct++;
			}
			if (rc)
				return EXIT_FAILURE;
		} else
			print_all_devices_pt(cxt, 0);
		break;

#ifdef CONFIG_FEATURE_FDISK_BLKSIZE
	case ACT_SHOWSIZE:
		/* deprecated */
		if (argc - optind <= 0)
			bb_show_usage();
		for (c = optind; c < argc; c++) {
			uintmax_t blks = get_dev_blocks(argv[c]);

			if (argc - optind == 1)
				printf("%ju\n", blks);
			else
				printf("%s: %ju\n", argv[c], blks);
		}
		break;
#endif
	case ACT_FDISK:
		if (argc-optind != 1)
			bb_show_usage();

		/* Here starts interactive mode, use fdisk_{warn,info,..} functions */
		color_scheme_enable("welcome", UL_COLOR_GREEN);
		fdisk_info(cxt, "Welcome to fdisk (%s).", PACKAGE_STRING);
		color_disable();
		fdisk_info(cxt, "Changes will remain in memory only, until you decide to write them.\n"
				  "Be careful before using the write command.\n");

		rc = fdisk_assign_device(cxt, argv[optind], 0);
		if (rc == -EACCES) {
			rc = fdisk_assign_device(cxt, argv[optind], 1);
			if (rc == 0)
				fdisk_warnx(cxt, "Device is open in read-only mode.");
		}
		if (rc)
			bb_perror_msg_and_die("cannot open %s", argv[optind]);

		fflush(stdout);

		if (fdisk_get_collision(cxt))
			follow_wipe_mode(cxt);

		if (!fdisk_has_label(cxt)) {
			fdisk_info(cxt, "Device does not contain a recognized partition table.");
			fdisk_create_disklabel(cxt, NULL);

		}
#ifdef CONFIG_FEATURE_GPT_LABEL
		  else if (fdisk_is_label(cxt, GPT) && fdisk_gpt_is_hybrid(cxt))
			fdisk_warnx(cxt, "A hybrid GPT was detected. You have to sync "
				  "the hybrid MBR manually (expert command 'M').");
#endif
		init_fields(cxt, outarg, NULL);         /* -o <columns> */

		if (!fdisk_is_readonly(cxt)) {
			fdisk_get_partitions(cxt, &original_layout);
			device_is_used = fdisk_device_is_used(cxt);
		}

		while (1)
			process_fdisk_menu(&cxt);
	}

	fdisk_unref_context(cxt);
	return EXIT_SUCCESS;
}
#endif /* APPLET_USAGE */
